#!/bin/bash

UPLOADSTORE=/recordings/upload


function add_apresapush()
{
	addgroup uploader

	# add user apresapush
	useradd -m --home /home/apresapush --shell /bin/bash apresapush
	passwd -l apresapush
	adduser apresapush uploader
}

function adjust_sshd_config()
{
	SSH_CONFIG_FILE=/etc/ssh/sshd_config

	# -F : no regexp
	# -x : full line
	# -q : quiet
	if grep -Fxq "match user apresapush" $SSH_CONFIG_FILE
	then
		:
	else
		# using sh -c to allow sudo
		sh -c 'echo "match user apresapush"         >> '$SSH_CONFIG_FILE
		sh -c 'echo "  ChrootDirectory /var/upload" >> '$SSH_CONFIG_FILE
		sh -c 'echo "  ForceCommand internal-sftp"  >> '$SSH_CONFIG_FILE
		sh -c 'echo "  AllowTcpForwarding no"       >> '$SSH_CONFIG_FILE
		sh -c 'echo "  X11Forwarding no"            >> '$SSH_CONFIG_FILE
		service ssh restart
	fi
}

function create_upload_dir()
{
	mkdir               $UPLOADSTORE
	chmod 755           $UPLOADSTORE
	chown root:root     $UPLOADSTORE
	mkdir               $UPLOADSTORE/data
	chmod 770           $UPLOADSTORE/data
	chown root:uploader $UPLOADSTORE/data
	mkdir /var/upload
}

function bind_upload_dir()
{
	if mountpoint -q /var/upload
	then
		:
	else
		mount -o bind $UPLOADSTORE /var/upload
	fi
}

function create_connector_key()
{
	CONNECTORFILE=/var/apresa/data/connector
	if ! [ -f $CONNECTORFILE ]
	then
		ssh-keygen -t rsa -P "" -f $CONNECTORFILE
		# permissions are right
	fi
}

add_apresapush
adjust_sshd_config
create_upload_dir
# done by apresa_first: bind_upload_dir
create_connector_key


