#!/bin/bash


# Get size of free space on /recordings
PT=/recordings

SZ=`df -P $PT | awk 'NR==2 {print $4}'`
# convert to GB
((SZ = $SZ / 1024 ))
((SZ = $SZ / 1024 ))

echo "SIZE of $PT: $SZ GB"

if [ -d /database ];
then
	echo "not moving, because /database directory exists"
	exit 0
fi

if [ $SZ -gt 15 ];
then
	echo "Enough avail to move"

	if [ -d /recordings/db/main ];
	then
		# already moved, do nothing
		echo "Already moved"
	else
		echo "Move database"
		mkdir /recordings/db
		# for old Ubuntu version, we also do -8.4 postfix.
		service postgresql stop
		service postgresql-8.4 stop
    # for Debian 9 it seems we have to wait on this
    # to be sure it has really stopped
    # if the postmaster pid is not deleted yet,
    # we cannot move, data remains at the old position
    counter=0
    while [ -f /var/lib/postgresql/9.6/main/postmaster.pid ];
    do
      echo "PostgreSQL is still active..."
      counter=$(( counter + 1 ))
      if [ $counter -eq 31 ];
      then
        echo "Timeout"
        break
      fi
      sleep 1
    done
		mv /var/lib/postgresql/8.4/main /recordings/db/main
		# for debian 8, we have postgresql 9.4
		mv /var/lib/postgresql/9.4/main /recordings/db/main
		# for debian 9, we have postgresql 9.6
		mv /var/lib/postgresql/9.6/main /recordings/db/main
		# set database directory to /recordings/db/main
    echo "Move finished, now set data_directory"
		sed -ibak -e "s/^data_directory =.*$/data_directory = '\/recordings\/db\/main'/" /etc/postgresql/8.4/main/postgresql.conf
		sed -ibak -e "s/^data_directory =.*$/data_directory = '\/recordings\/db\/main'/" /etc/postgresql/9.4/main/postgresql.conf
    sed -ibak -e "s/^data_directory =.*$/data_directory = '\/recordings\/db\/main'/" /etc/postgresql/9.6/main/postgresql.conf
    echo "Start PostgreSQL"
		service postgresql start
		service postgresql-8.4 start
    echo "Finished"
	fi
fi

