<?php

/* A selection menu using DTMF (key press),
   with an audio message.
   On selection, it can forward to another rule number.
*/
class ActMenu extends RuleHandlerBase
{
  var $main = null;
  var $timeout = 0;
  var $startTime = null;
  var $messagStopTime = null;

  function Init($defMain)
  {
    $this->main = $defMain;
    $this->timeout = (int) $this->main->GetThisRuleCfg('MenuTimeout');
    $this->timeoutTarget = $this->main->GetThisRuleCfg('Dial12');
  }

  function UnansweredCall()
  {
    $m = new Yate("call.answered");
    $m->params["id"] = $this->main->instanceId;
    $m->params["targetid"] = $this->main->originalData['id'];
    $m->Dispatch();
    
    $this->ActiveCall();
  }
  
  function ActiveCall()
  {
    $this->startTime = time();
    // needs to play message
    $m = new Yate("chan.attach");
    $m->params["id"] = $this->main->instanceId;
    $m->params["notify"] = $this->main->instanceId;
    $m->params["source"] = "wave/play//recordings/telsys/audio/r" . $this->main->ruleNr . ".slin";
    $m->Dispatch();    
  }
  
  function ChannelEof()
  {
    // end of playback
    dbglog("Menu end message");
    $this->messagStopTime = time();
  }

  function Dtmf( $digit )
  {
    $code = -1;
    if ($digit>='0' && $digit<='9') $code = (int) $digit;
    if ($digit=='*') $code = 10;
    if ($digit=='#') $code = 11;
    if ($digit=='d') $code = 12;
    dbglog( 'ActMenu sees ' . $digit . ' code ' . $code );
    $param = 'Dial' . $code;
    $target = $this->main->GetThisRuleCfg($param);
    $target = (int) $target;
    if ($target!=0)
    {
      $this->main->ToRule( $target );
    }
  }
  
  function OnNewSecond()
  {
    if ($this->messagStopTime==null) return;
    if ($this->timeoutTarget==0) return;
    if ( time() - $this->messagStopTime >= $this->timeout)
    {
      dbglog('Menu timeout');
      $this->timeout = 0;
      $this->Dtmf( 'd' );
    }
  }
  
};


?>