<?php

/* Play notification message inside the call
*/
class ActNotify extends RuleHandlerBase
{
  var $main; // ruler
  var $NotifDst = '';
  var $NotifyReceiver = false; // setting
  var $playingNotification = false;
  
  function Init($defMain)
  {
    $this->main = $defMain;
    $this->NotifDst = $this->main->GetThisRuleCfg("NotifDst");
    if ($this->NotifDst=='dest')
    {
      $this->NotifyReceiver = true;
    }
  }
  
  function IsAddOn()
  {
    // It is an add-on rule *if* notification is set to be played to receiver.
    // NotifDst is 'source' or 'dest'
    if ($this->NotifyReceiver) return true;
    return false;
  }
  
  function UnansweredCall()
  {
    $m = new Yate("call.answered");
    $m->params["id"] = $this->main->instanceId;
    $m->params["targetid"] = $this->main->originalData['id'];
    $m->Dispatch();
    
    $this->ActiveCall();
  }
  
  function PlayNotification($ruleNr)
  {
    $m = new Yate("chan.attach");
    $m->params["id"] = $this->main->instanceId;
    $m->params["notify"] = $this->main->instanceId;
    $m->params["source"] = "wave/play//recordings/telsys/audio/r" . $ruleNr . ".slin";
    $m->params["single"] = true;
    $m->Dispatch();    
  }
  
  function ActiveCall()
  {
    // needs to play message
    $this->PlayNotification($this->main->ruleNr);
  }
  
  function AddOnChannelEof()
  {
    if ($this->playingNotification==false) return;
    dbglog("playback of notification message ended, connect parties");
    
    $this->main->callingReceiver = false;
    
    $m = new Yate("chan.connect");
    $m->params["id"] = $this->main->originalData['id'];
    $m->params["targetid"] = $this->receiverId;
    $m->Dispatch();
    
    return true;
  }
  
  function ChannelEof()
  {
    // end of playback
    $this->main->ToRule( $this->main->ruleNr + 1 );
  }
  
  function DirectRoutingAllowed()
  {
    return false;
  }
  
  function AnswerCallBeforeRouting()
  {
    return true;
  }
  
  function CallAnswered( $ev )
  {
    dbglog("NotifyReceiver CallAnswered");
    if($ev->GetValue("lastpeerid") == $this->main->instanceId)
    {
      dbglog("Connected to other, playback notification");
      $this->receiverId = $ev->GetValue("id");
      $this->playingNotification = true;
      $this->PlayNotification( $this->main->addOnRuleNr );
      return false; // not do default handling for forward action
    }
    return true;
  }
  
  function Routed( $ev )
  {
    $this->main->callingReceiver = true;
  }
  
};


?>