#!/usr/bin/php
<?php // The first line is needed to make executable
include("libyate.php");
require_once('nbs.php');

function dbglog($t) {
    Yate::Debug(date('D M G:i:s Y') . ' CallControl: '.$t);
}

class CallControl {

	var $calls = array();
	var $nbs;
  var $referid;
  var $instanceId;
  var $noDups;

	function Init()
	{
		global $argc, $argv;
		// true puts it in polling mode
		Yate::Init(true);
		Yate::Debug(true);

		dbglog('init');

		$this->nbs = new NonBlockingSocket();
		$this->nbs->Create( '/tmp/apresa_telsys' , array($this,'TelsysCmd') );
		
		$this->referid = 0;
		
		$this->instanceId = "CallControl/".uniqid();
		// without next line, problem.
		Yate::Install("engine.timer");
		Yate::Install("chan.startup");
		Yate::Install("chan.hangup");
		//Yate::Install("call.route",80);
		//Yate::Install("call.execute",80);
		Yate::Install("call.execute",80);
		
		if (file_exists('/var/apresa/conf/telsys_refer'))
		{
			Yate::Install("sip.refer");
		}
    $this->noDups = file_exists('/var/apresa/conf/telsys_nodups');
    
	}
	
	function StopCall( $telnum )
	{
		$toret = 1;
		foreach ($this->calls as $call)
		{
			if ($call['caller']==$telnum
			|| $call['called']==$telnum)
			{
				$m = new Yate("call.drop");
				$m->params["id"] = $call['id'];
				$m->Dispatch();
				$toret = 0;
			}
		}
		return $toret;
	}
	
	function HandleTelsysCmd( $cmd )
	{
		dbglog( 'CMD: ' . $cmd );
		$parts = explode(' ',$cmd);
		if (count($parts)==0)
		{
			return 'E1 No command';
		}
		$command = $parts[0];
		if ($command=='stop')
		{
			$telnum = $parts[1];
			$errcode = $this->StopCall( $telnum );
			if ($errcode==0) return 'OK';
			else if ($errcode==1) return 'E11 No active call with phone number ('.$telnum.') found';
			else return 'E12 Error stopping call';
		} else
		{
			return 'E2 Unknown command "' . $command . '"';
		}
	}
	
	function TelsysCmd( $cmd )
	{
		$reply = $this->HandleTelsysCmd( $cmd );
		dbglog( 'Reply: ' . $reply );
		return $reply;
	}

	function YateEventHandling( & $refAny )
	{
		while (true)
		{
			$ev = Yate::GetEvent();
			if ($ev === false)
					return false; // YATE closed probably
			if ($ev === true)
					break; // no messages now
      $acked = false;
			if ($ev->name!='engine.timer')
			{
					dbglog("Event received (" . $ev->type.') ' . $ev->name );
			}
			$refAny = true;
			$this->HandleEvent($ev, $acked);
			if ($ev->name=='engine.timer')
			{
				//dbglog('another second');
				$this->periodic();
			}
			if ($ev->type=='incoming' && $acked==false)
			{
				$ev->Acknowledge();
			}
		}
		return true;
	}
	
	function Main()
	{
		$this->Init();
		
		$delay = 2; // in ms
		// main loop
		while (true)
		{
			$anyDone = false;
			if ($this->YateEventHandling($anyDone)==false)
			{
				break;
			}
			$this->nbs->Perform($anyDone);
			if ($anyDone) $delay = 2;
			else if ($delay<200) $delay *= 10;
			//dbglog('zzz');
			usleep( $delay * 1000 );
		}
	}
	
	function periodic()
	{
		/*
		foreach ($this->calls as $call)
		{
			$age = time() - $call['started'];
			dbglog( 'age: ' . $age );
			if ($age>=5)
			{
				$m = new Yate("call.drop");
				$m->params["id"] = $call['id'];
				$m->Dispatch();
			}
		}
		*/
	}
  
  function ArePartiesTalking($caller,$called)
  {
		foreach ($this->calls as $call)
		{
      if ($call['caller']===$caller
      &&  $call['called']===$called)
      {
        return true;
      }
    }
    return false;
  }
	
	function HandleEvent($ev, &$acked)
	{
		if ($ev->type=='incoming')
		{
      if ($ev->name=='chan.startup')
      {
				$call = array();
				$id = $ev->GetValue('id');
        if ($id=='') return;
        if ( isset( $this->calls[ $id ] ) ) return;
        
				$call['id'] = $id;
				$call['caller'] = $ev->GetValue('caller');
				$call['called'] = $ev->GetValue('called');
				$call['started'] = time();
        $call['isdup'] = false;
				//dbglog('caller: ' . $call['caller'] );
				
        if ($this->ArePartiesTalking($call['caller'],$call['called']))
        {
          if ($this->noDups) dbglog('it is a duplicated call');
          $call['isdup'] = true;
        }
        
				$this->calls[ $id ] = $call;
				$this->dumpCalls();
      }
			if ($ev->name=='chan.hangup')
			{
				$id = $ev->GetValue('id');
				dbglog("hangup of id: $id" . ' reason: ' . $ev->GetValue('reason'));
				unset($this->calls[ $id ]);
				$this->dumpCalls();
			}
			// http://docs.yate.ro/wiki/Call.execute
			if ($ev->name=='call.execute')
			{
				$id = $ev->GetValue('id');
        if ($id=='') return;
        if ( isset( $this->calls[ $id ] ) )
        {
          $call = $this->calls[ $id ];
        } else
        {
          $call = array();
          $call['id'] = $id;
          $call['caller'] = $ev->GetValue('caller');
          $call['called'] = $ev->GetValue('called');
          $call['started'] = time();
          if ($this->ArePartiesTalking($call['caller'],$call['called']))
          {
            if ($this->noDups) dbglog('it is a duplicated call');
            $call['isdup'] = true;
          }
          $this->calls[ $id ] = $call;
          $this->dumpCalls();
        }
        
        if ($this->noDups && $call['isdup'])
        {
          dbglog('reject duplicated call');

          $ev->params["targetid"] = $this->instanceId;
          $ev->handled = true;
          $ev->Acknowledge();
          $acked = true;
          
          $m = new Yate("call.drop");
          $m->params["id"] = $id;
          // 406 = Not acceptable here
          $m->params["reason"] = "406";
          $m->Dispatch();
          
          return;
        }
      }
			if ($ev->name=='sip.refer')
			{
				// we might want to disable this detailed logging when its working
				dbglog( 'refer to: ' . $ev->GetValue('sip_refer-to') );
				dbglog( 'contact: ' . $ev->GetValue('sip_contact') );
				dbglog( 'caller: ' . $ev->GetValue('caller') );
				dbglog( 'called: ' . $ev->GetValue('called') );
				$tojoin = $ev->GetValue('sip_target-dialog');
				dbglog( 'tojoin: ' . $tojoin );
				
				// create a new unique number
				$this->referid ++;
				if ($this->referid==10000)
				{
					$this->referid = 1;
				}
				$referid = $this->referid;
				// reset info if any previous
				$this->refers[ $referid ] = array();
				
				// this call leg is the external call
				$m = new Yate("call.execute");
				$m->SetParam("callto", 'tone/silence' );
				// we cannot add extra parameters,
				// so we add information in the phone number (the USELINE prefix),
				// which is used in regexroute
				$m->SetParam("target", 'USELINE'.$ev->GetValue('sip_contact').'' );
				$m->SetParam("tojoin",$tojoin);
				// let the param tojoin be available in regexroute
				$m->SetParam("copyparams","tojoin");
				$m->SetParam("referid",$this->referid);
				$m->SetParam("referleg", '1' );
				$m->SetParam("specialtype", "refer" );
				$m->Dispatch();

				// this call leg is the internal call
				$m = new Yate("call.execute");
				$m->SetParam("callto", 'tone/silence' );
				$m->SetParam("caller", $ev->GetValue('caller') );
				$m->SetParam("target", $ev->GetValue('called') );
				$m->SetParam("referid",$this->referid);
				$m->SetParam("referleg", '2' );
				$m->SetParam("specialtype", "refer" );
				$m->Dispatch();
				$ev->SetParam('code','202');
				$ev->handled = true;
			}
		} else if ($ev->type=='answer')
		{
			if ($ev->name=='call.execute' && $ev->GetValue('specialtype')=='refer')
			{
				$leg = $ev->GetValue('referleg');
				$referid = $ev->GetValue('referid');
				dbglog('special refer answer leg '.$leg.' referid: '.$referid);
				$this->refers[ $referid ]['id'  .$leg] = $ev->GetValue('id');
				$this->refers[ $referid ]['peer'.$leg] = $ev->GetValue('peerid');
				// dbglog('refer obj:'.var_export($this->refers[ $referid ],true));
				if (isset($this->refers[ $referid ]['id1'])
					&& isset($this->refers[ $referid ]['id2']))
				{
					dbglog('both call legs for refer done, now connect');

					$id1 = $this->refers[ $referid ]['id1'];
					$id2 = $this->refers[ $referid ]['id2'];
					$p1  = $this->refers[ $referid ]['peer1'];
					$p2  = $this->refers[ $referid ]['peer2'];
					
					// connect the two peers, that are the two SIP channels
					$m = new Yate("chan.connect");
					$m->SetParam("id",       $p1);
					$m->SetParam("targetid", $p2);
					$m->Dispatch();
					
					// adjust bookkeeping
					// we do not want tone/X entries,
					// but sip/X entries,
					// and we want only one entry not double.
					//$this->dumpCalls();
					$this->calls[ $p2 ] = $this->calls[ $id2 ];
					$this->calls[ $p2 ]['id'] = $p2;
					unset($this->calls[ $id1 ]);
					unset($this->calls[ $id2 ]);
					$this->dumpCalls();
					
				}
			}
		}
	}

	function dumpCalls()
	{
		dbglog('Active calls:' . count($this->calls) );
		$i = 0;
    $tooOld = array();
    $maxAge = 60 * 60 * 24; // one day
		foreach ($this->calls as $id=>$call)
		{
      $age = time() - $call['started'];
      if ($age > $maxAge)
      {
        $tooOld[] = $id;
      }
    }
    foreach ($tooOld as $id)
    {
      dbglog( $id . ' expired' );
      unset($this->calls[$id]);
    }
    // too verbose?
		foreach ($this->calls as $call)
		{
			$i++;
      $age = time() - $call['started'];
			// too verbose: dbglog( $i . '. ' . $call['id'] . ' ' . $call['caller'] . ' age:'. $age );
		}
	}	
	
}

$t = new CallControl();
$t->Main();
dbglog("Goodbye");

?>
