#!/usr/bin/php
<?php

include("libyate.php");

function dbglog($t) {
  Yate::Debug( date('D M G:i:s Y') . ' options_snmp: '.$t);
}

class SnmpOptionsGenerator{

  var $instanceId;

  function Init()
  {
    global $argc, $argv;
    Yate::Init();
    Yate::Debug(true);

    dbglog('init');
    
    $this->instanceId = "OptionsSnmp/".uniqid();
    // without next line, problem.
    Yate::Install("engine.timer");
    Yate::Install("sip.options");
  }

  function Main()
	{
		$this->Init();
    while (true)
		{
			$ev = Yate::GetEvent();
			if ($ev === false)
					return false; // YATE closed probably
			if ($ev === true)
					break; // no messages now
			if ($ev->name!='engine.timer')
			{
					dbglog("Event received (" . $ev->type.') ' . $ev->name );
			}
			$this->HandleEvent($ev);
		}
  }

  function SendSNMPMsg($msg)
  {
    $socket = @socket_create(AF_UNIX, SOCK_DGRAM, 0);
    if ($socket===FALSE)
    {
      dbglog("Could not contact snmp agent: socket create failed\r\n");
      return;
    } 

    if (@socket_connect($socket, "/tmp/apresa_snmp") === FALSE)
    {
      dbglog("Could not contact snmp agent: socket connect failed\r\n");
      return;
    }

    $messagestr = implode("\x1e", $msg) . "\x1e";

    if(@socket_write($socket,$messagestr,strlen($messagestr)) === FALSE)
    {
      dbglog("Could not contact snmp agent: socket write failed\r\n");
      return;
    }
  }


  function HandleEvent($ev)
  {
    if ($ev->type=="incoming")
    {
      if($ev->name=="sip.options")
      {
        $ip = $ev->GetValue("ip_host");
        $msg = [
          "act:sendtrap",
          "quantity:sip_options",
          "value:" . $ip,
          "health:okay",
          "message:SIP Options request received from " . $ip,
        ];
        
        $this->SendSNMPMsg($msg);
      }

      $ev->Acknowledge();
    }
  }
}

$t = new SnmpOptionsGenerator();
$t->Main();
dbglog("Goodbye");

?>