#!/usr/bin/php
<?php // The first line is needed to make executable
include("libyate.php");

function dbglog($t) {
    Yate::Debug('SimplyAccept: '.$t);
}

class SimplyAccept{

    function Init()
    {
			global $argc, $argv;
			Yate::Init();
			Yate::Debug(true);

			dbglog('init');
			
			$this->instanceId = "SimplyAccept/".uniqid();
			// without next line, problem.
			Yate::Install("engine.timer");
    }

	function Main()
	{
		$this->Init();

		// main loop
		while (true)
		{
				$ev = Yate::GetEvent();
				if ($ev === false)
						break;
				if ($ev === true)
						continue;
				if ($ev->name!='engine.timer')
				{
						dbglog("Event received ".$ev->type.' '.$ev->name);
				}
				$this->HandleEvent($ev);
				
				// timing
				// currently, only for debugging
				if ($ev->name=='engine.timer')
				{
						//dbglog('another second');
				}
				
				
		}
	}
	
    function HandleIncomingEvent($ev)
    {
        $acked = false;
        if ($ev->name=="call.execute")
        {
            // A new incoming call arriving
            
            $this->caller = $ev->GetValue("caller");
						$this->callername = $ev->GetValue("callername");
            $this->otherSideId = $ev->GetValue("id");
            dbglog("Caller id: ".$this->caller.' name: '.$this->callername);
            
            $ev->params["targetid"] = $this->instanceId;
            $ev->handled = true;
            $ev->Acknowledge();
            $acked = true;
            
            $this->startTime = time();
            
            /* Signal we are answering the call */
            $m = new Yate("call.answered");
            $m->params["id"] = $this->instanceId;
            $m->params["targetid"] = $this->otherSideId;
            $m->Dispatch();
        }

        // we must ACK all events of type incoming
        if (!$acked) $ev->Acknowledge();
        $acked = true;
    }
    	
    function HandleEvent($ev)
    {
        if ($ev->type=="incoming")
        {
            $this->HandleIncomingEvent($ev);
        }
    }
		
}

$t = new SimplyAccept();
$t->Main();
dbglog("Goodbye");

?>
