#!/bin/bash

# Check if these services have been disabled between the scheduling and firing of this script

if [[ $1 = "apresanet" && ! -f /var/apresa/conf/apresanet ]]; then
  exit 0
fi

if [[ $1 = "apresaoig" && ! -f /var/apresa/conf/MitelOIG ]]; then
  exit 0
fi

if [[ $1 = "apresaav32" && ! -f /var/apresa/conf/AvayaCSTA ]]; then
  exit 0
fi

if [[ $1 = "apresaavnet" && ! -f /var/apresa/conf/AvayaDMCC ]]; then
  exit 0
fi

if [[ $1 = "apresacj" && ! -f /var/apresa/conf/CJtapi ]]; then
  exit 0
fi

if [[ $1 = "yate" && ! -f /etc/telsys/srv1_enable ]]; then
  exit 0
fi

if [[ $1 = "eyate" && ! -f /etc/telsys/srv2_enable ]]; then
  exit 0
fi

if [[ $1 = "ed137" && ! -f /var/apresa/conf/ed137 ]]; then
  exit 0
fi

if ! systemctl is-active $1; then
  logger -t apresa_cmd "$1 is not active after some time, create alarm"
  DESCRIPTION=`/usr/share/apresa/get_service_description.sh $1`
  echo "$DESCRIPTION exitted" > /var/apresa/data/err_proc_$1.dat
  /usr/share/apresa/check_health.sh
fi
