#!/bin/bash

# enable or disable network trace

# $1 = 1 to start, 0 to stop
# $2 = network interface (3=all+loopback)
# $3 = if 1, then boundless (unlimited)

LOGFILE=/var/log/apresa/system.log
TRACEDIR=/recordings/log
LCTFILE=/recordings/log/trace.lct
APNETTRACECONF=/var/apresa/conf/apnettrace.cfg

if [ "1" = "$1" ]
then
	LIMITOPT="-c 512000"
	if [[ "1" -eq "$3" ]]; then
		LIMITOPT=
	fi
	echo "`date` Enable network trace" >> $LOGFILE;
	rm $TRACEDIR/trace*.pcap
	rm $LCTFILE
	interfaces=(/sys/class/net/*)
	echo "1" > $APNETTRACECONF
	service apresanet restart
	for interface in ${interfaces[@]};
	do
		ethname=${interface:15}
		if [[ "lo" != ${ethname} || "3" -eq "$2" ]]; then
			tcpdump $LIMITOPT -s 8196 -i $ethname -w /recordings/log/trace-$ethname.pcap >/dev/null 2>&1 &
		fi
	done
	
fi

if [ "0" = "$1" ]
then
	echo "`date` Disable network trace" >> $LOGFILE;
	echo "0" > $APNETTRACECONF
	service apresanet restart
	killall tcpdump
fi

