GatherProcessInfo() {
  echo "$1" >> $DIAGFILE

  THEPID=`pgrep $1`
  if [ $? -eq 0 ]; then
    echo "PID $THEPID" >> $DIAGFILE
    if command -v lsof > /dev/null; then
      lsof -p $THEPID >> $DIAGFILE
    else
      echo "Mapped files: " >> $DIAGFILE
      ls -l /proc/$THEPID/map_files | awk  '{print $11}' | sort | uniq >> $DIAGFILE
      echo "File descriptors: " >> $DIAGFILE
      ls -l /proc/$THEPID/fd | awk '{print $9 $10 $11}' | sort | uniq >> $DIAGFILE
    fi
  else
    echo "Not running" >> $DIAGFILE
  fi
}

# stop network trace
killall tcpdump
# tell web interface that stopped
psql apresa -c "UPDATE Configs SET value=0 WHERE param='NetwTrace'"
# remove previous
rm /tmp/aprlogs.tgz
rm /recordings/log/aprlogs.tgz
# create configuration dump
pg_dump apresa -t Configs > /var/log/apresa/config.dump

# Get system diagnostic information
DIAGFILE=/var/log/apresa/diag.txt
rm $DIAGFILE

echo "" >> $DIAGFILE
echo "Kernel: " `uname -a` >> $DIAGFILE
echo "Distribution: " `cat /etc/issue.net` >> $DIAGFILE

echo "" >> $DIAGFILE
echo "df:" >> $DIAGFILE
df >> $DIAGFILE

echo "" >> $DIAGFILE
echo "mdstat:" >> $DIAGFILE
cat /proc/mdstat >> $DIAGFILE

echo "" >> $DIAGFILE
echo "partitions:" >> $DIAGFILE
cat /proc/partitions >> $DIAGFILE

echo "" >> $DIAGFILE
echo "Sizes" >> $DIAGFILE
du -hx --max-depth=1 /var | sort -h >> $DIAGFILE
echo "" >> $DIAGFILE
du -hx --max-depth=1 /var/log | sort -h >> $DIAGFILE
echo "" >> $DIAGFILE
du -hx --max-depth=1 /var/log/apresa | sort -h >> $DIAGFILE

echo "" >> $DIAGFILE
echo "/var/log/apresa:" >> $DIAGFILE
ls -latr /var/log/apresa >> $DIAGFILE

echo "" >> $DIAGFILE
sha256sum /usr/local/lib/shcti/CurrentVersion/out/libshdpci.so.* >> $DIAGFILE
sha256sum /usr/local/lib/shcti/CurrentVersion/out/libshpa3.so.* >> $DIAGFILE

echo "" >> $DIAGFILE
echo "/tmp:" >> $DIAGFILE
ls -latr /tmp/trace* /tmp/*.log /tmp/*apr* >> $DIAGFILE

echo "" >> $DIAGFILE
echo "processes:" >> $DIAGFILE
GatherProcessInfo orkaudio
GatherProcessInfo apresa_crec
GatherProcessInfo apresa_handler
GatherProcessInfo apresa_fifo

# compress files

if [ "1" = "$1" ]
then
	cd /recordings/log/
	tar zcf /recordings/log/aprlogs.tgz trace*.pcap \
	trace.lct ork.prof core_* \
	/var/log/orkaudio/* \
	/var/log/messages* \
	/var/log/kern.log* \
	/var/log/syslog* \
	/var/log/dmesg* \
	/var/log/lighttpd/error.log* \
	/var/log/yate* \
  /var/log/eyate* \
  /var/log/cluster/corosync.* \
	/var/log/apresa/apresa.log* \
  /var/log/apresa/main.log* \
	/var/log/apresa/scim.log* \
	/var/log/apresa/remote.log* \
  /var/log/apresa/av32.log* \
  /var/log/apresa/avdmcc.log* \
	/var/log/apresa/avdmcc.err* \
	/var/log/apresa/miteloig.log* \
	/var/log/apresa/miteloig.err* \
  /var/log/apresa/system.log \
  /var/log/apresa/crec.log* \
  /var/log/apresa/apnetsvr.log* \
  /var/log/apresa/cj.log* \
	/var/log/apresa/sforcelink-*.log \
  /var/log/apresa/ed137/ed137.log* \
  /var/log/php7.4-fpm.log* \
  -C /var/log/apresa \
  config.dump diag.txt
else
	# smaller version:
	cd /recordings/log/
	tar zcf /recordings/log/aprlogs.tgz trace*.pcap \
	trace.lct ork.prof core_* \
	-C /var/log/orkaudio orkaudio.log messages.log tapelist.log\
	-C /var/log/apresa apresa.log main.log remote.log av32.log \
	avdmcc.log avdmcc.err \
	miteloig.log miteloig.err \
	system.log crec.log sforcelink.log scim.log \
	cj.log apnetsvr.log config.dump diag.txt \
  -C /var/log/apresa/ed137 ed137.log
fi


chown www-data:www-data /recordings/log/aprlogs.tgz
# remove network trace
rm /recordings/log/trace*.pcap
rm /recordings/log/trace.lct
rm /recordings/log/ork.prof
rm /recordings/log/core_*
# remove db-config dump
rm /var/log/apresa/config.dump

exit 0
