<?php
error_reporting(E_ALL ^ E_NOTICE);
define('CMD',1);

require_once "../conf/voip_config.php";
require_once CMD_WEB_RELPATH . "db.php";
require_once CMD_WEB_RELPATH . "signaling.php";

DBConnect();

StartUp();

function StartUp()
{
  global $dbintf;

  // Set full permission
  $dbintf->SetAdmin();

  // after reboot nothing can be busy
  @unlink('/var/apresa/data/busy');
  @unlink('/var/apresa/data/TenantAction.lock');
  $dbintf->DeleteConfigsWithPrefix('AranaImporting');
  // also reset resettable alarms
  // (see sysinfo.php)
  @unlink('/var/apresa/data/reccheck.dat');
  @unlink('/var/apresa/data/err_crec.dat');
  @unlink('/var/apresa/data/shutting_down');

  // whole server restarted
  // web server has restarted
  // do not: $dbintf->DeleteAllSessions();
  // because PHP / web server keeps sessions after restart

  // if trace was running, now it stopped
  // we do not (yet?) restart it after reboot
  // would overwrite previous file otherwise
  $dbintf->SetConfigsPart(array('NetwTrace'=>0),'s');
}

/*
If we cannot connect at once, we wait, and retry a few times.
This is needed at reboot under Debian.
*/
function DBConnect()
{
  global $dbintf;
  $retry = 0;
  while(true)
  {
        $ok = false;
        try
        {
                $dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH, 'apresa', true);
                $ok = true;
                //echo "Connected OK\n";
        } catch(Exception $e)
        {
                //echo "Failed with exception.\n";
        }
        if ($ok) break;
        else
        {
                $retry ++;
                if ($retry>10)
                {
                        //throw new Exception('Cannot connect to database.');
                        throw $e;
                        exit;
                }
                // sleep for one second
                sleep(1);
        }
  }
}


?>