<?php
/*
  To be used in enterprise setup,
		by user apresarem.
*/
define('CMD',1);

require_once "../conf/voip_config.php";
require_once CMD_WEB_RELPATH . "db.php";
require_once CMD_WEB_RELPATH . "signaling.php";
require_once CMD_WEB_RELPATH . "datafile.php";

function GetSerialNumber()
{
	return trim(file_get_contents(CMD_WEB_RELPATH . '../apresa/conf/serial'));
}

Go();

function Go()
{
	global $dbintf, $argc, $argv, $recid_map;

	define('DEBUG_LOGING',1);

	// Interface to database
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();

	// Parse options
	$after_id = null;
	$limit = 500;
	$all = false;
	$know_serial = null;
	$act = '';
	for ($i=1;$i<$argc;$i++)
	{
		if ($argv[$i]=='--list')
		{
			$act = 'list';
		}
		if ($argv[$i]=='--all')
		{
			$all = true;
		}
		if ($argv[$i]=='--limit')
		{
			if ($i+1<$argv)
			{
				$limit = (int) $argv[$i+1];
			}
		}
		if ($argv[$i]=='--id')
		{
			if ($i+1<$argv)
			{
				$after_id = (int) $argv[$i+1];
			}
		}
		if ($argv[$i]=='--sn')
		{
			if ($i+1<$argv)
			{
				$know_serial = (int) $argv[$i+1];
			}
		}
	}

	if ($act=='list')
	{
	
		$serial = GetSerialNumber();
		if ($know_serial !== null)
		{
			if ($serial != $know_serial)
			{
				echo "! ".$serial."\n";
				exit;
			}
		}
	
		$recid_map = array();
		$recorders = $dbintf->GetRecorders();
		foreach ($recorders as $recorder)
		{
			$recid_map[ $recorder['id'] ] = $recorder['recid'];
		}
	
		echo "[ ".$serial." \n";

		$sk = 'id'; $sd = 'asc';
		$listconfig = array();
		$listconfig['allrecords'] = $all;
		$listconfig['loadrange'] = $limit;
		$listconfig['checkrange'] = $listconfig['loadrange'];
		$listconfig['startfrom'] = 0;
		if ($after_id !== null)
		{
			$listconfig['afterid'] = $after_id;
		}
		$listconfig['callback'] = 'HandleCall';
		$calls = $dbintf->GetCallsForExport($listconfig);
		$cnt = $calls['cnt'];
		unset($calls['cnt']);

		echo "]\n";
	}
}

function HandleCall($row,$b)
{
	global $dbintf;
	global $recid_map;
	
	if (isset($recid_map[ $row['recorderid'] ])==false)
	{
		// unknown recorder, reject
		return;
	}
	$recid = $recid_map[ $row['recorderid'] ];
	if ($recid=='')
	{
		// unknown serial, reject
		return;
	}
	$row['recorderid'] = $recid;	
	
	// advantages of this:
	// json is fast, compact, future-proof.
	echo ','.json_encode($row)."\n";
	
}

?>