<?php
/*
	Special tasks
	Specify task on command line.
  
	it is not possible to signal_service here
	use command interface of handler for a single command:
	system('apresa_handler cmd os');
*/
error_reporting(E_ALL ^ E_NOTICE);
define('CMD',1);

require_once "../conf/voip_config.php";
require_once CMD_WEB_RELPATH . "db.php";
require_once CMD_WEB_RELPATH . "signaling.php";
require_once CMD_WEB_RELPATH . "emailing.php";
require_once CMD_WEB_RELPATH . "datafile.php";
require_once CMD_WEB_RELPATH . "encryption.php";
require_once CMD_WEB_RELPATH . "actions.php";
require_once CMD_WEB_RELPATH . "tenancy.php";
require_once CMD_WEB_RELPATH . "mitelimport.php";
require_once CMD_WEB_RELPATH . "certificates_general.php";
require_once CMD_WEB_RELPATH . "utility.php";
require_once "arana_import.php";
require_once "aste.php";

BasicConstants();

$task = $argv[1];
if ($task=='')
{
	exit;
}

if ($argc>1 && $argv[$argc-1]=='debug')
{
	// logging to console instead of apresa.log
	define('DEBUG_LOGING',1);
}

RunTask($task,str_ensure_defined($argv[2]),str_ensure_defined($argv[3]));

function RunTask($task,$param,$param2)
{
	lg('Special task: '.$task);
	if ($task=='FixIsArchived')
	{
		FixIsArchived();
	} else if ($task=='CryptPrep')
	{
		CryptPrep();
	} else if ($task=='CryptUnlock')
	{
		CryptUnlock();
	} else if ($task=='CryptUserUnlock')
	{
		CryptUserUnlock($param);
	} else if ($task=='CryptRecUnlock')
	{
		CryptRecUnlock();
	} else if ($task=='LicNotRec')
	{
		LicNotRec($param, $param2);
	} else if ($task=='SystemUpdated')
	{
		SystemUpdated();
	} else if ($task=='ActiveDone')
	{
		ActiveDone($param);
	} else if ($task=='ORestart')
	{
		ORestart();
	} else if ($task=='makecss')
	{
		MakeCss();
	} else if ($task=='SetAgents')
	{
		SetAgents();
	} else if ($task=='AssignRecs')
	{
		AssignRecs();
	} else if ($task=='UndoAssignRecs')
	{
		UndoAssignRecs();
	} else if ($task=='RedoTnStats')
	{
		RedoTnStats($param);
	} else if ($task=='RedoTnBackupStats')
	{
		RedoTnBackupStats($param);
	} else if ($task=='ExportTenant')
	{
		ExportTenant($param);
	} else if ($task=='DeleteTenant')
	{
		DeleteTenantTask($param,$param2);
	} else if ($task=='CallsBetweenTenants')
	{
		CallsBetweenTenants($param);
  } else if ($task=='MoveAdminTrail')
  {
    MoveAdminTrail();
	} else if ($task=='TestLdap')
	{
		TestLdap();
	} else if ($task=='TestingDebug')
	{
		TestingDebug();
	}
  else if($task=='CaImport')
  {
    CallsArchiveImport();
  }
  else if($task=='AranaImport')
  {
    AranaImport();
  }
  else if($task=='SysCfg')
  {
    SysCfg($param);
  }
  else if($task=='ChangeAdminPwd')
  {
    ChangeAdminPwd($param);
  }
  else if($task=='DeleteRecorderCalls')
  {
    DeleteRecorderCalls($param);
  }	else if($task=='MitelImport')
	{
		MitelImport();
  }	else if($task=='MainstreamImport')
	{
		MainstreamImport($param);
  }	else if($task=='Aste')
	{
		Aste($param);
	}
	else if($task=="AssignVTapRecorders")
	{
		AssignVTapRecorders();
  }
  else if($task=="massdel")
  {
    DoMassDel($param, $param2);
  }
  else if($task=="massrec")
  {
    DoMassRecycle($param, $param2);
  }
  else if($task=="OptimizeDB")
  {
    OptimizeDB();
  }
  else if($task=="RevertOptimizeDB")
  {
    RevertOptimizeDB();
  }
	else if($task=="ApplyCurrentTimezone")
	{
		ApplyCurrentTimezone();
	}
	else
	{
		lg('Unknown task');
	}
  lg('End of run task');
}

function LicNotRec($channeltype, $channelid)
{
	global $lng, $configs, $dbintf;
	
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	// Load configuration
	LoadBasicSettings();
	$configs = array_merge($configs,$dbintf->LoadConfigsPart('n'));

	$dat = array();
  $dat['To'] = array( ensure_defined($configs['EmAdmin'], null) , ensure_defined($configs['EmAdmin2'], null) );
  
  $subject = 'Maximum number of ';
  if($channeltype !== null) $subject .= $channeltype . ' ';
  $subject .= 'channels reached';
  if($channelid !== null) $subject .= ' for ' . $channelid;
  
  $dat['Subject'] = $subject;

	$body = '';
	$body .= $dat['Subject'] . ": Call not recorded" . "\n";
  $body .= "\n";
  $body .= "This message was sent by Call Recorder Apresa";

  $dat['Body'] = $body;

	if (SendEmailData($configs,$dat)==1)
	{
	  // OK
	  exit(0);
	} else
	{
	  exit(1);
	}
}

function CryptPrep()
{
	$pwdFn = '/dev/shm/apresa/web/tmp_pwd';
	if (file_exists($pwdFn)==false)
	{
		return;
	}
	if (file_exists('/dev/shm/apresa/play.ekey')==false)
	{
		return;
	}
	if (file_exists('/var/apresa/data/rec.ekey')==false)
	{
		return;
	}

	$pwd = file_get_contents($pwdFn);
	$pwd = decrypt($pwd);

	$play = passwordEncrypt( $pwd, 'OK'.file_get_contents( '/dev/shm/apresa/play.ekey' ) );
	$rec  = passwordEncrypt( $pwd, 'OK'.file_get_contents( '/var/apresa/data/rec.ekey' ) );
	
	// not needed to store on disk,
	// only use database.

	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();

	$newcfg = array();
	$newcfg['PlayPkey'] = bin2hex($play);
	$newcfg['RecPkey'] = bin2hex($rec);
	$dbintf->SetConfigsPart($newcfg,'s');
	
	lg('Stored using new pass phrase');
	
	$dbintf->close();
}

function CryptRecUnlock()
{
	$pwdFn = '/dev/shm/apresa/web/tmp_pwd';
	if (file_exists($pwdFn)==false)
	{
		return;
	}
	$pwd = file_get_contents($pwdFn);
	$pwd = decrypt($pwd);

	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();

	$RecPKey = $dbintf->GetConfigValue('RecPkey');
	$RecPKey = pack('H*',$RecPKey);

	$rec  = passwordDecrypt( $pwd , $RecPKey  );
	
	if (substr($rec,0,2)!='OK') return;
	$rec = substr($rec,2);
	
	file_put_contents( '/var/apresa/data/rec.ekey' , $rec );
	system('chmod 640 /var/apresa/data/rec.ekey');
	system('chown root:www-data /var/apresa/data/rec.ekey');
	// rec key must be readable by www-data because of screen recording upload
	
	lg('Unlocked rec.');
	
	$dbintf->close();	
}

function CryptUserUnlock($randomId)
{
	$playKeyFile = '/dev/shm/apresa/web/play_'.$randomId.'.ekey';
	$pwdFn = '/dev/shm/apresa/web/tmp_pwd_' . $randomId;
	if (file_exists($pwdFn)==false)
	{
		return;
	}
	$pwd = file_get_contents($pwdFn);
	$pwd = decrypt($pwd);

	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);

	$PlayPKey = $dbintf->GetConfigValue('PlayPkey');
	$PlayPKey = pack('H*',$PlayPKey);

	$play = passwordDecrypt( $pwd , $PlayPKey );
	
	if (substr($play,0,2)!='OK') return;
	$play = substr($play,2);
	
	file_put_contents( $playKeyFile , $play);
	system('chmod 640 ' . $playKeyFile);
	system('chown root:www-data ' . $playKeyFile);
	// play key must be readable by www-data because of decryption playback
	
	lg('Unlocked play for ' . $randomId);
	
	$dbintf->close();
	
}

function CryptUnlock()
{
	$pwdFn = '/dev/shm/apresa/web/tmp_pwd';
	if (file_exists($pwdFn)==false)
	{
		return;
	}
	$pwd = file_get_contents($pwdFn);
	$pwd = decrypt($pwd);

	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();

	$PlayPKey = $dbintf->GetConfigValue('PlayPkey');
	$PlayPKey = pack('H*',$PlayPKey);
	$RecPKey = $dbintf->GetConfigValue('RecPkey');
	$RecPKey = pack('H*',$RecPKey);

	$play = passwordDecrypt( $pwd , $PlayPKey );
	$rec  = passwordDecrypt( $pwd , $RecPKey  );
	
	if (substr($play,0,2)!='OK') return;
	$play = substr($play,2);
	if (substr($rec,0,2)!='OK') return;
	$rec = substr($rec,2);
	
	file_put_contents( '/dev/shm/apresa/play.ekey' , $play);
	file_put_contents( '/var/apresa/data/rec.ekey' , $rec );
	system('chmod 640 /dev/shm/apresa/play.ekey');
	system('chmod 640 /var/apresa/data/rec.ekey');
	system('chown root:www-data /dev/shm/apresa/play.ekey');
	system('chown root:www-data /var/apresa/data/rec.ekey');
	// play key must be readable by www-data because of decryption playback
	// rec key must be readable by www-data because of screen recording upload
	
	lg('Unlocked play and rec.');
	
	$dbintf->close();
	
}

function FixIsArchivedCallBack($call,& $listconfig)
{
	global $dbintf, $restore_cnt, $oldest_restored;
	$fn = AUDIO_PATH . '/' . $call['directory'] . '/' . $call['filename'];
	$a = $call['isarchived'];
	//if ($a==0 && $restore_cnt<=1)
	if ($a==0)
	{
		$e = is_file($fn) ? 1 : 0;
		if ($e==1)
		{
			$oldest_restored = $call['directory'] . '/' . $call['filename'];
			$idlist = array();
			$idlist[] = $call['id'];
			$dbintf->SetIsArchivedForIDs($idlist,1);
			lg('Restored '.$fn);
			$restore_cnt ++;
		}
	}
}

function FixIsArchived()
{
	global $dbintf, $restore_cnt, $oldest_restored;
	
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();

	$restore_cnt = 0;
	$listconfig = array();
	$listconfig['allrecords'] = true;
	$listconfig['callback'] = 'FixIsArchivedCallBack';
	$listconfig['extracols'] = ' , directory ';
	$sk = 'startdate';
	$sd = 'desc';
	$dbintf->GetCallList($sk,$sd,array(),$listconfig);

	if ($restore_cnt>0)
	{
		addToSay(MSG_INF,"Restored link to ".$restore_cnt.' recordings, oldest: ' . str_replace("/","-",substr($oldest_restored,0,10)) );
	}
}

function MoveOnFail(&$data)
{
  $in = "/dev/shm/apresa/" . $data['directory'] . '/' . $data['filename'];
  $out = GetRecordingPath($data) . $data['directory'] . '/' . $data['filename'];
  rename($in, $out);
  unlink($in);
  $data['flags'] &= ~2048;
}

function TenantEncryptCall(&$data, $key)
{
  lg('Tenant call encryption: ' . $data['remoteid']);

  $pubKey = openssl_pkey_get_public(FormatPublicKey($key['pubkey']));

  if($pubKey === false)
  {
    lg('Could not load public key ' . $data['remoteid'] . openssl_error_string());
    return false;
  }

  $in = "/dev/shm/apresa/" . $data['directory'] . '/' . $data['filename'];
  $out = GetRecordingPath($data) . $data['filename'];

  $ret = 0;
  $output = array();
          
  exec('apresa_crypt -ec -i ' . escapeshellarg($in) . ' -o ' . escapeshellarg($out), $output, $ret);

  if($ret != 0)
  {
    lg('Failed to perform call encryption ' . $data['remoteid']);
    MoveOnFail($data);
    return false;
  }

  foreach($output as $line)
  {
    if(strpos($line, "Key: ") !== false)
    {
      $callkey = substr($line, 5);
    }

    if(strpos($line, "IV: ") !== false)
    {
      $iv = substr($line, 4);
    }
  }

  if(!isset($callkey))
  {
    lg('Failed to get encryption key from apresa_crypt ' . $data['remoteid']);
    MoveOnFail($data);
    return false;
  }

  if(!isset($iv))
  {
    lg('Failed to get IV from apresa_crypt ' . $data['remoteid']);
    MoveOnFail($data);
    return false;
  }

  $callkey = hex2bin($callkey);
  $iv = hex2bin($iv);

  if(openssl_public_encrypt($callkey, $encryptedKey, $pubKey, OPENSSL_PKCS1_OAEP_PADDING) === false)
  {
    lg('Failed to encrypt the call key ' . $data['remoteid']);
    MoveOnFail($data);
    return false;
  }

  $callkeydata = [
    "callkey" => base64_encode($encryptedKey),
    "iv" => base64_encode($iv),
    "keyid" => $key['id']
  ];

  unlink($in);
  chmod($out, 0777);
  return $callkeydata;
}

function ActiveDone($recid)
{
	global $dbintf, $restore_cnt, $oldest_restored;
	
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();

  $CalcChecksum = $dbintf->GetConfigValue('CalcChecksum');
  
	$maxsleep = 5;
  for ($i=0;$i<$maxsleep;$i++)
	{
		$data = $dbintf->GetActiveCallInfoRM($recid);
		if ($data!==FALSE)
		{
      $callextra = StringToArray($data['callextra']);
      $audiofile = AUDIO_PATH.'/'.$data['directory'].'/'.$data['filename'];
      // Calculate checksum if enabled
      if ($CalcChecksum=="md5")
      {
        $callextra['chk'] = md5_file($audiofile);
        $callextra['chktype'] = 'md5';
      }
      if ($CalcChecksum=="sha1")
      {
        $callextra['chk'] = sha1_file($audiofile);
        $callextra['chktype'] = 'sha1';
      }
      if ($CalcChecksum=="sha256")
      {
        $callextra['chk'] = calcChecksum('sha256sum',$audiofile);
        $callextra['chktype'] = 'sha256';
      }
      if ($CalcChecksum=="sha512")
      {
        $callextra['chk'] = calcChecksum('sha512sum',$audiofile);
        $callextra['chktype'] = 'sha512';
      }  
      $data['callextra'] = ArrayToString($callextra);
     
			unset( $data['id'] );
			$data['processingstate'] &= ~ 4;
			$data['isactive'] = 0;
			if ($data['tenantid']!=NULL)
			{
        UpdateTnDiskUsage( $data['tenantid'], GetCallStorage($data), +1);
      }
      
      if($data['flags'] & 2048)
      {
        $group = $dbintf->GetGroupInfo( $data['tenantid'] );
        $key = $dbintf->GetCallEncryptionKey($group['accid']);
        if($key && $key['inuse'])
        {
          $callkey = TenantEncryptCall($data, $key);
        }
        else
        {
          MoveOnFail($data);
        }
      }

      $newid = $dbintf->InsertCall($data);
      if($callkey)
      {
        $callkey['callid'] = (int) $newid;
        $dbintf->AddCallKey($callkey);
      }
			$dbintf->RemoveActiveCall($recid);
			break;
		}
		sleep( 1 );
	}
}

function RestartEngineVoIP($pfring)
{
	system("service orkaudio stop");
  if ($pfring)
  {
    // unload and reload
    system("rmmod pf_ring");
    system("modprobe pf_ring");
  }
	system("service orkaudio start");
	// also restart Lync component (Apresa Net)
	system("service apresanet restart");
	//also restart avdmcc!
	system("service apresaavnet restart");
}

function RestartRemoteConnector()
{
	system("service apresaremote restart");
}

function SystemUpdated()
{
  global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  UpdateSystemInfoCfg();
  $dbintf->SetAdmin();
  EnginesSettingsCalcApply();
}

function ORestart()
{
	lg('Checking VoIP engine restart');
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();
  $pfring = ((int) $dbintf->GetConfigValue('PfRing')) != 0;
	$stepcnt = 10;
	$stepsize = 60 * 3; // in seconds
	$done = false;
	for ($i=0;$i<$stepcnt;$i++)
	{
		$cnt = $dbintf->GetActiveCallsCount();
		if ($cnt==0)
		{
			lg('No calls active; restarting VoIP engine now');
			RestartEngineVoIP($pfring);
      RestartRemoteConnector();
			$done = true;
			break;
		}
		lg('Calls active: ' . $cnt . ' , waiting');
		sleep( $stepsize );
	}
	if ($done==false)
	{
		lg('No restart done. Reason: Active calls');
	}
}

function ThemeBlackGreen()
{
	$themedir = dirname(__FILE__) . '/../themes/blackgreen';
	$pdir = dirname(__FILE__) . '/' . CMD_WEB_RELPATH . 'p';
	system("cp $themedir/general.css $pdir/");
	system("chown www-data $pdir/general.css");
	CopyTheming('blackgreen');
	if (file_exists('/var/apresa/templ/custom/genlist_add_bg.css'))
	{
		file_put_contents('/var/apresa/templ/genlist.css',file_get_contents('/var/apresa/templ/custom/genlist_add_bg.css'), FILE_APPEND );
	}
}

function CopyTheming($themesubdir)
{
	$themedir = dirname(__FILE__) . '/../themes/' . $themesubdir;
	$templdir = dirname(__FILE__) . '/../templ';
	system("cp $themedir/templ/* $templdir/");
	system("chown www-data $templdir/*");
	$skindir = dirname(__FILE__) . '/' . CMD_WEB_RELPATH . 'p/yui/assets/skins/sam';
	system("cp $themedir/sam/* $skindir/");
	system("chown www-data $skindir/*");
	$imgdir = dirname(__FILE__) . '/' . CMD_WEB_RELPATH . 'p/img';
	system("cp $themedir/img/* $imgdir/");
	system("chown www-data $imgdir/*");
}

function MakeCss()
{
	global $dbintf;
	// load from configs db.
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$themeName = $dbintf->GetConfigValue('Theme');
	if ($themeName=='') $themeName = 'default';
	$themeName = preg_replace('/[^[a-zA-Z0-9]/','',$themeName);
	lg('Theme: '.$themeName);
	
	if (file_exists('/var/apresa/templ/custom/favicon_custom.ico'))
	{
		copy('/var/apresa/templ/custom/favicon_custom.ico'
			,'/var/www/favicon.ico');
	} else
	{
		// use original
		copy('/var/www/p/favicon.ico'
			,'/var/www/favicon.ico');
	}
	
	if ($themeName=='blackgreen')
	{
		ThemeBlackGreen();
		return;
	}

  $toCopy = 'default';
  if ($themeName=='ts')
  {
    $toCopy = $themeName;
  }
	CopyTheming($toCopy);

  // Less replaced by LessLikeConvert
  // because:
  // - it is needless complicated
  // - it fails on conditional CSS
	// so not: include CMD_WEB_RELPATH . 'p/lib/less/Less.php';
	// so not: $parser = new Less_Parser();
	$maininputfn = dirname(__FILE__) . '/../templ/general.css';
	$maininput = file_get_contents( $maininputfn );
	$themefn = dirname(__FILE__) . '/../themes/theme-'.$themeName.'.css';
	if (file_exists($themefn)==false)
	{
		// do nothing because theme file does not exist
		lg("Theme file $themefn does not exist");
		return;
	}
	$theme = file_get_contents($themefn);
	// not: $parser->parse( $theme . $maininput );
	// not: $css = $parser->getCss();
  $css = LessLikeConvert( $theme . $maininput );
	$outputfn = CMD_WEB_RELPATH . 'p/general.css';
	lg('Writing CSS to ' . $outputfn . ' ' . strlen($css) . ' bytes');
	file_put_contents($outputfn,$css);
	system('chown www-data:www-data '.$outputfn);
	system('chmod 764 '.$outputfn);
}

function LessLikeConvert( $input )
{
  $t = '';
  $lines = preg_split("/\r\n|\n|\r/",$input);
  $vars = array();
  foreach ($lines as $line)
  {
    $len = strlen($line);
    $st = 0;
    $idStart = -1;
    $redo = true;
    while ($redo)
    {
      $redo = false;
      for ($i=0;$i<$len;$i++)
      {
        $ch = $line[$i];
        if ($st==0)
        {
          if ($ch=='@')
          {
            $st = 1;
            $idStart = $i;
          }
        } else if ($st==1)
        {
          // accepted characters within an identifier
          if (ctype_alnum($ch) || $ch=='_' || $ch=='-')
          {
            ;
          } else 
          {
            $st = 0;
            // found end of identifier
            $var = substr($line,$idStart,$i-$idStart);
            // lookup if we have a replacement for this ID
            if (isset($vars[$var]))
            {
              $line = substr($line,0,$idStart) . $vars[$var] . substr($line,$i);
              $redo = true;
              break;
            }
          }
        }
      }
    }
    
    if ($line[0]=='@')
    {
      // we require that var assignments are in the form of @VAR space COLON ...
      $spacePos = strpos($line,' ');
      $colonPos = strpos($line,':');
      if ($spacePos==$colonPos-1)
      {
        $var = substr($line,0,$spacePos);
        $val = trim(substr($line,$colonPos+1));
        // remove ; from $val
        if ($val[ strlen($val)-1 ] == ';')
        {
          $val = substr($val,0,-1);
        }
        // lg("var = '$var' = '$val'");
        $vars[ $var ] = $val;
        continue;
      }
    }
    
    $t .= $line . "\n";
  }
  return $t;
}


// called per call
function AssignRecsCB(&$ref_cfg,$result,$row)
{
	global $dbintf, $lng;
	$ref_cfg['cnt'] ++;
	/*
	if ($ref_cfg['cnt']>1000)
	{
		// DEBUG LIMIT
		return false;
	}
	*/
	$tenantid = CalcTenant( $row );
	if ($tenantid !== null)
	{
		// the call belongs to a tenant (!)
		//echo "Call " . $row['id'] . ' TN: ' . var_export($tenantid,true) . "\n";
		$dbintf->SetCallInfo( $row['id'] , array( 'tenantid' => $tenantid ) );
		$ref_cfg['assigned'] ++;
		UpdateTnDiskUsage( $tenantid, GetCallStorage($row), +1);
	} else
	{
		// the call/recording does not belong to a tenant
		//echo "Call " . $row['id'] . ' NONE' . "\n";
	}
	
	if ( ($ref_cfg['cnt'] % 1000) == 1 )
	{
		$msg = $lng->Get('Tenancy.AssignRecs') . ': ' . $ref_cfg['cnt'] . ' / ' . $ref_cfg['fullcnt'];
		if ($ref_cfg['fullcnt']>0)
		{
			$perc = (int) ($ref_cfg['cnt'] * 100 / $ref_cfg['fullcnt']);
			$msg .= '  (' . $perc . '%)';
		}
		lg($msg);
		WriteTenantMsg(MSG_INF,$msg);
	}
	return true;
}

function UndoAssignRecs()
{
	global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	lg("Starting UndoAssignRecs");
	WriteTenantMsg(MSG_INF,'Undoing all assignments of recordings to tenants');

	$dbintf->TransactionRetry( function()
	{
		global $dbintf;
		$dbintf->StartTransaction();
		
		// - clear tenant statistics
		TenantsStorageReset(); // tenancy.php
		// - reset tenant id for recordings
		$dbintf->UnassignAllTenantCalls();
		
		$dbintf->CommitTransaction();
	});
	
	RemoveTenantMsg();
}

function AssignRecs()
{
	global $dbintf, $lng;
	// load from configs db.
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	LoadBasicSettings();
	
	lg("Starting AssignRecs");
	
	// do not: $dbintf->StartTransaction();
	
	$cfg = array();
	$cfg['cols'] = array('id'
		,'localcontact'
		,'remotecontact'
    ,'connectedcontact'
		,'linenr'
		,'local2','remote2'
		,'directory','filename','flags'
		);
	// only those with no tenant
	$cfg['notenant'] = true;
	$cfg['cnt'] = 0;
	$cfg['assigned'] = 0;
	$cfg['fullcnt'] = $dbintf->GetNoTenantCallCount();
	
	lg("Total call count = " . $cfg['fullcnt']);
	
	$dbintf->CallWalker($cfg,'AssignRecsCB');
	
	// do not: $dbintf->CommitTransaction();
	
	$msg =  $lng->Get('Tenancy.AssignResult');
	$msg = str_replace('{0}',$cfg['cnt'],$msg);
	$msg = str_replace('{1}',$cfg['assigned'],$msg);
	addToSay(MSG_INF,$msg);
	
	unlink('/var/apresa/data/tenantmsg');
	
}

// called per call
function SetAgentsCB(&$ref_cfg,$result,$row)
{
	global $dbintf;
	$ref_cfg['cnt'] ++;
	$agent = GetAgentOfCall($row);
	if ($agent !== int_ensure_defined($row['agent']))
	{
		$dbintf->SetCallInfo( $row['id'], array('agent' => $agent) );
		$ref_cfg['assigned'] ++;
	}
	if (time() - $ref_cfg['lastreport'] >= 5)
	{
		lg('processed ' . $ref_cfg['cnt'] . ' recordings ...');
		$ref_cfg['lastreport'] = time();
	}
	return true;
}

function SetAgents()
{
	global $dbintf, $lng;
	// load from configs db.
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	LoadBasicSettings();
	
	lg("Starting SetAgents");
	
	// do not: $dbintf->StartTransaction();
	
	$cfg = array();
	$cfg['cols'] = array('id'
		,'localcontact'
		,'remotecontact'
		,'linenr'
		,'local2','remote2'
		,'directory','filename','flags'
		,'tenantid'
		);
	// only those with no user assigned to yet
	$cfg['noagent'] = true;
	$cfg['cnt'] = 0;
	$cfg['assigned'] = 0;
	$cfg['fullcnt'] = $dbintf->GetNoAgentCallCount();
	$cfg['lastreport'] = time();
	
	lg("Recordings not assigned to user = " . $cfg['fullcnt']);
	
	$dbintf->CallWalker($cfg,'SetAgentsCB');
	
	// do not: $dbintf->CommitTransaction();
	
	$msg = "Assigned {1} of {0} recordings to a user";
	$msg = str_replace('{0}',$cfg['cnt'],$msg);
	$msg = str_replace('{1}',$cfg['assigned'],$msg);
	addToSay(MSG_INF,$msg);
	
}

function RedoTnStats($param)
{
	global $dbintf;
	
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);

	TenantsCalcStorage( ($param==1) );
}

function MoveAdminTrail()
{
  global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$dbintf->SetAdmin();

  $dirOld = '/var/apresa/data/audit';
  $dirNew = '/var/apresa/data/audit/admins';
  
  // ensure both main and admin directory of audit trails exist,
  // and have the correct permissions
  
  if (file_exists($dirOld)==false)
  {
    @mkdir($dirOld,0770);
    system("chown www-data:www-data $dirOld");
  }
  system("chmod 770 $dirOld");

  if (file_exists($dirNew)==false)
  {
    @mkdir($dirNew,0770);
    system("chown www-data:www-data $dirNew");
  }
  system("chmod 770 $dirNew");

  $users = $dbintf->GetUserList();
  foreach ($users as $user)
  {
    if ($dbintf->IsUserAdminT123($user['id']))
    {
      lg('admin: ' . $user['name'] );
      $usr = $user['usr'];
      //$user['usr']
      $fn = 'log_' . MakeValidFnWithoutExt($usr) . '.txt';
      $oldFn = $dirOld . '/' . $fn;
      if (file_exists($oldFn))
      {
        $newFn = $dirNew . '/' . $fn;
        if (file_exists($newFn))
        {
          // both non-admin and admin trail file already exists
          // normally would not happen
        } else
        {
          lg('Moving audit file to admin directory');
          // move the trail file to the admins directory
          rename($oldFn,$newFn);
        }
      } // else non-admin file does not exist
    }
  }
}

function TestLdap()
{
	global $dbintf, $lng;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);

  $configs_n = $dbintf->LoadConfigsPart('n');
  $key = '';

  $usersdomain = str_ensure_defined($configs_n['LdapDomain'.$key]);
	$ldaphost = str_ensure_defined($configs_n['LdapHost'.$key]);
	$ldapuser = str_ensure_defined($configs_n['LdapUser'.$key]);
	$ldappwd = str_ensure_defined($configs_n['LdapPwd'.$key]);
	$domain_usr_prefix = str_ensure_defined($configs_n['UsersDomain'.$key]);
	if (strpos($ldapuser,'\\')===false && $domain_usr_prefix!='')
	{
		$ldapuser = $domain_usr_prefix . '\\' . $ldapuser;
	}
  
  echo "Test LDAP host: " . $ldaphost . "\n";
	
  ldap_set_option(NULL, LDAP_OPT_DEBUG_LEVEL, 7);
	$ldap = ldap_connect($ldaphost) or exit("Invalid LDAP host syntax");
	ldap_set_option($ldap, LDAP_OPT_PROTOCOL_VERSION, 3);
	ldap_set_option($ldap, LDAP_OPT_REFERRALS, 0);
	if (ldap_bind($ldap, $ldapuser, decrypt($ldappwd))==false)
  {
    echo "================= LDAP test FAILED ===========" . "\n";
    ldap_close($ldap);
    $ldap = null;
  } else
  {
    echo "================= LDAP connect and login OK ===========" . "\n";
    ldap_unbind($ldap);
    $ldap = null;
  }
}

function TestingDebug()
{
	global $dbintf, $lng;
	// load from configs db.
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	LoadBasicSettings();
	
	lg("Starting TestingDebug");
	
	/*
	$key = 'TN99_DiskUsage';
	$dbintf->AddToConfig($key,256,'tn');
	$value = $dbintf->GetConfigValue($key);
	lg("$key=$value");
	*/
	
	lg("end of TestingDebug");
}

function signal_required($msg)
{
  //echo 'Signaling ' . substr($msg,0,2) . "\n";
  $reply = 1;
	$cmd_timeout = 20;
  $err = signal_service($msg,$reply,$cmd_timeout);
  if ($err!='')
  {
    onerror('Socket error: '.$err);
  }
  $msg_firstpart = explode(' ',$msg);
  $msg_firstpart = $msg_firstpart[0];

	$where = $msg_firstpart;
	if ($where=='bm')
	{
		$where = 'mounting backup directory';
	}
	// more user friendly
  if ($reply=='OK')
  {
    // OK
  } else if ($reply[0]=='E')
  {
		onerror($where . ' failed: '.$reply);
  } else
  {
    onerror($where . ' failed, unexpected reply: '.$reply.' LEN: '.strlen($reply));
  }
}

function GetDebianCodeName($version)
{
  $codeNames = array
  (  7 => 'wheezy'
  ,  8 => 'jessie'
  ,  9 => 'stretch'
  , 10 => 'buster'
  , 11 => 'bullseye'
  , 12 => 'bookworm'
  );
  if (isset($codeNames[$version]))
  {
    return $codeNames[$version];
  }
  return '';
}

function WriteArrayToFile($data,$fn)
{
  $f = fopen($fn,"w");
  if ($f===false) return;
  foreach ($data as $line)
  {
    fwrite($f,$line);
  }
  fclose($f);
}

function aptDefaultComponents($debv)
{
  switch($debv) {
    case 12:
       return 'main non-free-firmware';
    default:
      return 'main';
  }
}

function SetAptMirrorUrl($mirrorUrl)
{
  $debv = GetDebianVersion();
  if ($debv=='') return;
  $codeName = GetDebianCodeName($debv);
  if ($codeName=='') return;
  
  $found = false;
  $sourcesFilename = '/etc/apt/sources.list';
  $sources = file($sourcesFilename);
  foreach ($sources as $key => $line)
  {
    if (strpos($line,$codeName)===false) continue;
    $parts = preg_split('/\s+/',$line);
    if (count($parts)<4) continue;
    if ($parts[0]!='deb') continue;
    if ($parts[2]!=$codeName) continue;
    $found = true;
    // is it already the same
    if ($parts[1]==$mirrorUrl) continue;
    // replace
		if (trim($mirrorUrl)=='') $sources[$key] = "";
    else { 
      $componentsParts = array_slice($parts, 3);
      if(count($componentsParts) == 0) $componentsParts[] = aptDefaultComponents($debv);
      $components = implode(' ', $componentsParts);
      $sources[$key] = "deb $mirrorUrl $codeName $components\n";
    }
  }
  if ($found==false)
  {
    // add
    $components = aptDefaultComponents($debv);
    $sources[] = "deb $mirrorUrl $codeName $components\n";
  }
  // write
  WriteArrayToFile( $sources, $sourcesFilename );
}

function getInstalledDebVersion($packname)
{
  $version = '';
  $dpkg_output = array();
  exec('dpkg-query -W -f=\'${binary:Package}\t${Version}\t${Status}\n\' ' . escapeshellarg($packname) , $dpkg_output);
  if (count($dpkg_output)==1)
  {
    $parts = explode("\t",$dpkg_output[0]);
    if (count($parts)==3 && $parts[0]==$packname && $parts[2]=='install ok installed')
    {
      $version = $parts[1];
    }
  }
  return $version;
}

function AutomaticUpdates_InstallRequisites()
{
  lg("Task: Install required Debian packages for doing unattended updates");
  $neededPackages = array( 'unattended-upgrades' , 'apt-listchanges'
    , 'bsd-mailx' // for email reports
    );
  $allPresent = true;
  foreach ($neededPackages as $packname)
  {
    $version = getInstalledDebVersion($packname);
    if ($version=='') {
      lg("Package $packname is not installed");
      $allPresent = false;
    }
    else lg("Package $packname $version is installed");
  }
  if ($allPresent)
  {
    lg("Already installed, nothing to do");
    return true;
  }

  $ref_return = 0;
  $cmd = 'apt-get update';
  lg("Running $cmd");
  system($cmd, $ref_return);
  if ($ref_return!=0)
  {
    lg("'$cmd' failed");
    addToSay(MSG_ERR,"Could not install packages ('$cmd' failed)");
    return;
  }

  foreach ($neededPackages as $packname)
  {
    $version = getInstalledDebVersion($packname);
    if ($version=='') 
    {
      $ref_return = 0;
      $cmd = "apt-get -y install $packname";
      lg("Running $cmd");
      system($cmd, $ref_return);
      if ($ref_return!=0)
      {
        lg("'$cmd' failed");
        addToSay(MSG_ERR,"Could not install package $packname ('$cmd' failed)");
        return false;
      }
      // apt-get install succeeded, but is it now there?
      $version = getInstalledDebVersion($packname);
      if ($version=='')
      {
        lg("Package $packname is still not installed");
        addToSay(MSG_ERR,"Could not install package $packname ('$cmd' failed)");
        return false;
      }
    }
  }
  return true;
}

function AutomaticUpdates_RunNow()
{
  $ref_return = 0;
  $cmd = 'apt-get update';
  lg("Running $cmd");
  system($cmd, $ref_return);
  if ($ref_return!=0)
  {
    lg("'$cmd' failed");
    addToSay(MSG_ERR,"Could not update package info ('$cmd' failed)");
    return false;
  }
	
  $ref_return = 0;
  $cmd = "unattended-upgrade";
  lg("Running $cmd");
  system($cmd, $ref_return);
  if ($ref_return!=0)
  {
    lg("'$cmd' failed");
    addToSay(MSG_ERR,"Failed to perform security update check ('$cmd' failed)");
    return false;
  } else
  {
    addToSay(MSG_INF,"Security update check was successful");
    return true;
  }
}

function AutomaticUpdates_Configure( $cfg )
{
  $AuFreq = (int) $cfg['AuFreq'];
  lg("AutomaticUpdates_Configure AuFreq:$AuFreq");
  
  $AuEnable = ($AuFreq!=0)?1:0;
  $CleanFreq = 21;
  
  // Configure period updates
  $fn = "/etc/apt/apt.conf.d/02periodic";
  if ($AuEnable)
  {
    $content = "// Generated by Apresa\n"
    . "APT::Periodic::Enable \"$AuEnable\";\n"
    . "APT::Periodic::Update-Package-Lists \"$AuFreq\";\n"
    . "APT::Periodic::Download-Upgradeable-Packages \"$AuFreq\";\n"
    . "APT::Periodic::Unattended-Upgrade \"$AuFreq\";\n"
    . "APT::Periodic::AutocleanInterval \"$CleanFreq\";\n"
    // Send report mail
    . "APT::Periodic::Verbose \"1\";\n"
    ;
  } else
  {
    $content = "// Generated by Apresa\n"
    . "APT::Periodic::Enable \"$AuEnable\";\n";
  }
  file_put_contents($fn,$content);
  // Configure email:
  $fn = "/etc/apt/apt.conf.d/50unattended-upgrades";
  $cmd = "sed -i -e 's/.*Unattended-Upgrade::Mail\\(\s.*\\);"
     . "/Unattended-Upgrade::Mail \"sysupgrade\";/' "
     . "$fn";
  system($cmd);
  // debug: lg($cmd);
}

function AutomaticUpdates()
{
	global $dbintf;

  $AuReqInstall = $dbintf->GetConfigValue('AuReqInstall');
  $AuFreq       = $dbintf->GetConfigValue('AuFreq');
  $AuRunNow     = $dbintf->GetConfigValue('AuRunNow');
  
  if ($AuReqInstall==1)
  {
    if (AutomaticUpdates_InstallRequisites())
    {
      addToSay(MSG_INF,"Required Debian packages were installed");
    } else
    {
      // something failed, stop
      return;
    }
  }
  
  AutomaticUpdates_Configure( array('AuFreq' => $AuFreq) );
  
  if ($AuRunNow==1)
  {
    AutomaticUpdates_RunNow();
  } else
  {
    addToSay(MSG_INF,"Finished configuring automatic update");
  }
}

function SysCfg($param)
{
	global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);

  if ($param=='aptmirror')
  {
    SetAptMirrorUrl( $dbintf->GetConfigValue('AptMirrorUrl') );
  }
  if ($param=='au')
  {
    AutomaticUpdates();
    // clear one-time things
    $dbintf->SetConfigsPart(
          array('AuReqInstall' => "0"
          , 'AuRunNow' => "0"
          ),'s');
  }
}

function MitelImport()
{
	global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	$configs_n = $dbintf->LoadConfigsPart('n');
	
	if(int_ensure_defined($configs_n['EnableMitel']))
	{
		$dbintf->SetAdmin();
		DoMitelImport();
	}
}

function SpecialDeleteACall($row,& $listconfig)
{
  global $dbintf;
  $listconfig['delcnt'] ++;
  $fullfn = '/recordings/' . $row['directory'] . '/' . $row['filename'];
  // too verbose: lg($listconfig['delcnt'] . ' delete a call fn: '.$fullfn);
  DeleteFn($fullfn);
  $dbintf->DeleteRecording( $row['id'] );
}

function DeleteRecorderCalls($param)
{
  global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  $dbintf->SetAdmin();

  // NOTE: this ignores tenancy
  lg('To delete all calls of recorder ' . $param);
  
  $search = array();
  $search['rec'] = $param;
  $listconfig = array();
  $listconfig['callback'] = 'SpecialDeleteACall';
  $listconfig['allrecords'] = true;
  $listconfig['extracols'] = ', directory';
  $sk = '';
  $dbintf->GetCallList($sk,'',$search,$listconfig);
  
}

function TellCaProgress($msg)
{
  global $dbintf;
  $dbintf->SetConfigsPart( array('BckCaImportProgress' => $msg) , 'b' );
}

function CaImport($dbFn,$options)
{
  global $dbintf;
  
  $baseMsg = 'Importing ' . $dbFn;
  TellCaProgress($baseMsg);
  
  lg('to import ' . $dbFn);
  if (file_exists($options['BackupDest']  . '/' . $dbFn)==false)
  {
    throw new Exception('Could not find the database file in the backup');
  }

  // similar to and copied from DeleteTenantFromMountedBackup
  
  $dbenc = GetDbEncoding();
  lg('Database encoding: ' . $dbenc);
  $ok = true;
  
  lg("Delete database apresa_restore");
  exec('psql apresa -c "DROP DATABASE apresa_restore;"');
  @mkdir('/recordings/tmp');
  
  $dbsrcfile = $options['BackupDest'] . '/' . $dbFn;
  $dbfile = AUDIO_PATH . '/tmp/' . $dbFn;
  
  if (@copy($dbsrcfile , $dbfile)==false)
  {
    onerror('Could not copy database file from ' . $dbsrcfile);
  }
  
  // extract SQL
  $sqlfile = AUDIO_PATH . '/tmp/' . 'restoring.sql';
  exec('gunzip -c ' . escapeshellarg($dbfile) . ' > ' . escapeshellarg($sqlfile));
  // correct SQL for encoding (if we know it)
  if ($dbenc!='')
  {
    $cmd = 'sed -i "s/SET client_encoding = \'.*\'/SET client_encoding = \''.$dbenc.'\'/" ' . escapeshellarg($sqlfile);
    exec($cmd);
  }
  
  lg("Create database apresa_restore");
  exec('psql apresa -c "CREATE DATABASE apresa_restore;"');

  lg("Import database");
  exec('psql apresa_restore < '.escapeshellarg($sqlfile));
  
  // we now should have the information in the database available
  $db_restore = new DBInterface(CMD_WEB_RELPATH . DATA_PATH, 'apresa_restore');
  $db_restore->SetAdmin();
  $cnt = $db_restore->CopyCallsToArchiveDb($dbintf);
  lg("Added " . $cnt . " records to CallsArchive");
  $db_restore->close();
  
  lg("Delete database apresa_restore");
  exec('psql apresa -c "DROP DATABASE apresa_restore;"');

  unlink($dbfile);
  unlink($sqlfile);
  
  return true;
}

function RedoTnBackupStats($param)
{
	global $dbintf, $configs;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  if ($dbintf->GetConfigValue('UseCallsArchive')==0)
  {
    addToSayRaw(MSG_ERR,'Tenant backup usage cannot be recalculated'
    . ' if information about calls in the backup is not retained.');
    return;
  }
  $configs_b = $dbintf->LoadConfigsPart('b');
  
  $ok = false;
  $dbFn = $configs_b['BckCaImport'];
  
  $options = InitBackupOptions($configs_b);
  if (isset($options['error']))
  {
    lg('Error initializing backup options: ' . $options['error'] );
    addToSay(MSG_ERR,'Error initializing backup options: ' . $options['error'] );
  } else
  {
  
    $unmount_required = false;
    try
    {  
      // we need access to the backup
      if ($options['Mounting'])
      {
        signal_required('bm');
        $unmount_required = true;
      }

      RecalcTnBckStats(($param==1),$options['BackupDest']);
      
    } catch(Exception $e)
    {
      //RemoveTenantMsg();
      lg('RedoTnBackupStats failed: '.$e->getMessage());
      addToSayRaw(MSG_ERR,'Recalculation of backup statistics failed: '.$e->getMessage());
    }
    
    if ($unmount_required)
    {
      try
      {  
        signal_required('bu');
      } catch(Exception $e)
      {
        lg('RedoTnBackupStats failed (disconnect): '.$e->getMessage());
        addToSayRaw(MSG_ERR,'Recalculation of backup statistics failed (disconnect): '.$e->getMessage());
      }
    }
  }
  
  if ($ok)
  {
    addToSay(MSG_INF,"<%CE.Done%>");
  }
  
  return $ok;  
}


// Load a database from backup,
// and add its calls to our list of calls in the backup
function CallsArchiveImport()
{
	global $dbintf, $configs;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  $configs_b = $dbintf->LoadConfigsPart('b');
  
  $ok = false;
  $dbFn = $configs_b['BckCaImport'];
  
  $options = InitBackupOptions($configs_b);
  if (isset($options['error']))
  {
    lg('Error initializing backup options: ' . $options['error'] );
    addToSay(MSG_ERR,'Error initializing backup options: ' . $options['error'] );
  } else
  {
  
    $unmount_required = false;
    try
    {  
      $dbintf->SetConfigsPart( array('BckCaImportProgress' => 'Connecting to backup') , 'b' );
      // we need access to the backup
      if ($options['Mounting'])
      {
        signal_required('bm');
        $unmount_required = true;
      }

      $ok = CaImport( $dbFn , $options );
      /*
      // maybe takes too long (so dont)
      // and it shouldnt be needed
      // maybe create tenant recalc option
      // for both backup and normal
      if ($ok)
      {
        RecalcTnBckStats(true,$options['BackupDest']);
      }
      */
      
    } catch(Exception $e)
    {
      //RemoveTenantMsg();
      lg('CallsArchiveImport failed: '.$e->getMessage());
      addToSayRaw(MSG_ERR,'Importing failed: '.$e->getMessage());
    }
    
    if ($unmount_required)
    {
      try
      {  
        signal_required('bu');
      } catch(Exception $e)
      {
        lg('CallsArchiveImport failed (disconnect): '.$e->getMessage());
        addToSayRaw(MSG_ERR,'Importing failed (disconnect): '.$e->getMessage());
      }
    }
  }
  
  $dbintf->SetConfigsPart( array('BckCaImporting' => '0') , 'b' );
  if ($ok)
  {
    addToSayRaw(MSG_INF,"<%Web.ImportDone%> (" . $dbFn . ")");
  }
  
  return $ok;  
  
}

function ChangeAdminPwd($newpwd)
{
	global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  $dbintf->SetAdmin();
  $userinfo = $dbintf->GetUserInfoOnUsername('admin');
  if ($userinfo===false) return;
  $dbintf->ChangePassword($userinfo['id'],$newpwd,false);
}

function AssignVTapRecorders()
{
	global $dbintf;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
	
	$calls = $dbintf->GetTunnelCallsWithRecorder();
	
	foreach($calls as $call)
	{
    $callextra = StringToArray($call['callextra']);
		$TunnelID = str_ensure_defined($callextra['TunnelID']);
		if($TunnelID === '') continue;
		if($TunnelID === $call['recid']) continue;
		echo "Assigning call " . $call['id'] . " to V-Tap " . $TunnelID . "\n";
		
		$recorderid = $dbintf->GetOrCreateRecorderId($TunnelID, "V-Tap $TunnelID", 55);
		$data['recorderid'] = $recorderid;
		$dbintf->SetCallInfo($call['id'], $data);
	}
}

function onerror($msg)
{
  throw new Exception($msg);
}

function DoMassDel($accid, $search_str)
{
  global $dbintf, $lng;
  lg('Do mass delete: user: ' . $accid . ' ' . $search_str);
  
  $dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  $userinfo = $dbintf->GetUserInfoOnAccId($accid);
  LoadBasicSettings();
  
  if($userinfo === false)
  {
    lg('Do mass delete, could not find user');
    return;
  }

  require_once CMD_WEB_RELPATH . "listinggen.php";
  $dbintf->SetCurrentUserId($userinfo['id']);
  $listingHandler = new ListingHandler();
  $listingHandler->DoMassDel($search_str);
}

function DoMassRecycle($accid, $search_str)
{
  global $dbintf, $lng;
  lg('Do mass recycle: user: ' . $accid . ' ' . $search_str);

  $dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  $userinfo = $dbintf->GetUserInfoOnAccId($accid);
  LoadBasicSettings();

  if($userinfo === false)
  {
    lg('Do mass recycle, could not find user');
    return;
  }

  require_once CMD_WEB_RELPATH . 'listinggen.php';
  $dbintf->SetCurrentUserId($userinfo['id']);
  $listingHandler = new ListingHandler();
  $listingHandler->DoMassRecycle($search_str);
}

function OptimizeDB()
{
  global $dbintf;
  $dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);

  $create_pg_trgm = false;
  $pg_trgm_exists = false;

  //echo "Optimizing database for number search queries, this may take a while";

  lg("Optimzing database for number search queries");

  $result = $dbintf->db->query("SELECT count(extname) FROM pg_extension WHERE extname='pg_trgm'");
  if(!$result)
  {
    $error = $dbintf->db->errorInfo();
    lg("Could not determine existence of pg_trgn extension: " . $error[2]);  
  }
  else
  {
    $row = $result->fetch();
    if($row && $row['count'] > 0)
    {
      lg("The pg_trgm extension has already been created");
      $pg_trgm_exists = true;
    }
    else
    {
      $create_pg_trgm = true;
    }
  }
  
  if($create_pg_trgm)
  {
    lg("Trying to create the pg_trgm extesnion");
    $result = $dbintf->db->query('CREATE EXTENSION pg_trgm');
    if(!$result)
    {
      $error = $dbintf->db->errorInfo();
      lg("Could not create the pg_trgm extesion: " . $error[2]);
    }
    else
    {
      lg("Succesfully created the pg_trgm extension");
      $pg_trgm_exists = true;
    }
  }

  lg("Creating indices on calls table");

  $result = $dbintf->db->query('CREATE INDEX calls_localcallerid_ix ON Calls(localcallerid)');
  if(!$result)
  {
    lg("Failed to create index calls_localcallerid_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('CREATE INDEX calls_remotecallerid_ix ON Calls(remotecallerid)');
  if(!$result)
  {
    lg("Failed to create index calls_remotecallerid_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('CREATE INDEX calls_connectedcallerid_ix ON Calls(connectedcallerid)');
  if(!$result)
  {
    lg("Failed to create index calls_connectedcallerid_ix: " . $dbintf->db->errorInfo()[2]);
  }


  $result = $dbintf->db->query('CREATE INDEX calls_localcontact_ix ON Calls(localcontact)');
  if(!$result)
  {
    lg("Failed to create index calls_localcontact_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('CREATE INDEX calls_remotecontact_ix ON Calls(remotecontact)');
  if(!$result)
  {
    lg("Failed to create index calls_remotecontact_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('CREATE INDEX calls_connectedcontact_ix ON Calls(connectedcontact)');
  if(!$result)
  {
    lg("Failed to create index calls_connectedcontact_ix: " . $dbintf->db->errorInfo()[2]);
  }

  lg("Updating callerids table with simplified ids");

  $result = $dbintf->db->query("SELECT id,callerid FROM callerids WHERE simplified IS NULL OR simplified=''");

  if($result)
  {
    while($row = $result->fetch())
    {
      $sql = 'UPDATE callerids SET simplified=:1 WHERE id=:2';
      $update = $dbintf->db->prepare($sql);
      $update->bindValue(1, IdSimplify($row['callerid']));
      $update->bindValue(2, $row['id']);
      $update->execute();
    }
  }
  else
  {
    lg("Could not query callerids table: " . $dbintf->db->errorInfo()[2]);
  }

  if($pg_trgm_exists)
  {
    lg("Create indices on contacts and callerids tables");

    $result = $dbintf->db->query('CREATE INDEX callerids_simplified_gist_ix ON callerids USING gist(simplified gist_trgm_ops)');
    if(!$result)
    {
      lg("Failed to create index callerids_simplified_gist_ix: " . $dbintf->db->errorInfo()[2]);
    }

    $result = $dbintf->db->query('CREATE INDEX contacts_name_gist_ix ON contacts USING gist(name gist_trgm_ops)');
    if(!$result)
    {
      lg("Failed to create index contacts_name_gist_ix: " . $dbintf->db->errorInfo()[2]);
    }
  }

  $dbintf->SetConfigsPart([ "OptimizedDb" => 1], 'web');
  lg("Optimizing database done");

  addToSay(MSG_INF, "Optimize database done");
}

function RevertOptimizeDB()
{
  global $dbintf;
  $dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);

  lg("Reverting optimizing of database, dropping the indices");

  $result = $dbintf->db->query('DROP INDEX calls_localcallerid_ix');
  if(!$result)
  {
    lg("Failed to drop index calls_localcallerid_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('DROP INDEX calls_remotecallerid_ix');
  if(!$result)
  {
    lg("Failed to drop index calls_remotecallerid_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('DROP INDEX calls_connectedcallerid_ix');
  if(!$result)
  {
    lg("Failed to drop index calls_connectedcallerid_ix: " . $dbintf->db->errorInfo()[2]);
  }


  $result = $dbintf->db->query('DROP INDEX calls_localcontact_ix');
  if(!$result)
  {
    lg("Failed to drop index calls_localcontact_ix: " . $dbintf->db->errorInfo()[2]);
  }


  $result = $dbintf->db->query('DROP INDEX calls_remotecontact_ix');
  if(!$result)
  {
    lg("Failed to drop index calls_remotecontact_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('DROP INDEX calls_connectedcontact_ix');
  if(!$result)
  {
    lg("Failed to drop index calls_connectedcontact_ix: " . $dbintf->db->errorInfo()[2]);
  }


  $result = $dbintf->db->query('DROP INDEX callerids_simplified_gist_ix');
  if(!$result)
  {
    lg("Failed to drop index callerids_simplified_gist_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $result = $dbintf->db->query('DROP INDEX contacts_name_gist_ix');
  if(!$result)
  {
    lg("Failed to drop index contacts_name_gist_ix: " . $dbintf->db->errorInfo()[2]);
  }

  $dbintf->SetConfigsPart([ "OptimizedDb" => 0], 'web');
  lg("Revering optimizing of database done");

  addToSay(MSG_INF, "Reverting optimize database done");
}

function ApplyCurrentTimezone()
{
	lg("Applying timezone");
	$curtz = trim(file_get_contents('/etc/timezone'));

	lg("Determined current timezone: $curtz");

	$zonesroot = '/usr/share/zoneinfo/'; 
	$fn = $zonesroot.$curtz;

	if(!is_file($fn))
	{
		lg("$curtz is not a valid timezone");
	}
	else
	{
		lg("Setting the php timezone to $curtz");
		system("apresa_handler cmd setphptimezone $curtz");
	}
}

function ImportMainstreamFile($file, $fullfn)
{
	global $dbintf;
	
	// expected filename format:
	// local.remote.dir.date.time.mp3
	lg('consider ' . $file);
	$parts = explode('.',$file);
	if (count($parts)!=6) return false;
	$oriext = $parts[5];
	if ($oriext!='mp3') return false;
	$local = $parts[0];
	$remote = $parts[1];
	$direction = 3; // unknown
	$dirt = $parts[2];
	if ($dirt=='in') $direction = 0;
	else if ($dirt=='out') $direction = 1;
	else return false;
	$datet = $parts[3];
	$timet = $parts[4];
	$year  = (int) substr($datet,0,4);
	$month = (int) substr($datet,4,2);
	$day   = (int) substr($datet,6,2);
	$hour  = (int) substr($timet,0,2);
	$minu  = (int) substr($timet,2,2);
	$sec   = (int) substr($timet,4,2);
	$startdate = mktime($hour,$minu,$sec,$month,$day,$year);		
	if ($startdate===false) return false;
	lg("L=$local R=$remote d=$direction dt=" . date('c',$startdate) );
	$duration = GlobGetAudioDuration($fullfn);
	if ($duration == -1)
	{
		lg('Could not determine duration');
		return false;
	}

	if (isset($dbintf)==false)
	{
		// lazy init
		$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
		// Load configuration
		LoadBasicSettings();
	}
	
	$ConfRecEnc = $dbintf->GetConfigValue('RecEnc');
	if ($ConfRecEnc=='mp3') $storageExtension = 'mp3';
	else $storageExtension = 'wav';
	
	$data = array();

	$data['localfull']  = $local;
	$data['remotefull'] = $remote;
	$data['connected'] = '';
	
	$data['local'] = $local;
	$data['remote'] = $remote;

	$data['local2'] = '';
	$data['remote2'] = '';
	
	$data['direction'] = $direction;
	$remote_is_local = ($direction==2);
	$local_is_remote = ($direction==3);

	$data['startdate'] = $startdate;
	$data['duration'] = $duration;

	$data['flags'] = 0;
	$data['isarchived'] = 1;
	
	$rec_uniqifier = $dbintf->GetRecIdsNext();
	
	$basefn = date('Ymd_His', $startdate) . '_x' . $rec_uniqifier;
	$data['filename'] = $basefn . '.' . $storageExtension;
	$data['directory'] = date('Y/m/d/H',$startdate);
	$data['remoteid'] = $basefn;
	
	// use other recorder
	$recorderId = '3CX_' . $source['id'];
	$recorderName = $source['description'];
	$data['recorderid'] = $dbintf->GetOrCreateRecorderId($recorderId,$recorderName,60);

	$data['waittime'] = -1;

	$data['source'] = 0; // unknown
	$data['encoding'] = 51; // unknown, GSM or G.711
	$data['encryption'] = 0; // no (not used for ALE)
	$data['processingstate'] = 4; // audio processing
	$data['lineid'] = 0; // not applicable

	$data['localcontact'] = 0;
	$data['remotecontact'] = 0;
	
	$localname = '';
	$remotename = '';

	$cid = $local;
	$ret = $dbintf->GetOrCreateCallerID($cid,$data['local2' ],$local_is_remote?1:0,$localname);
	$data['localcallerid'] = $ret["id"];
	$data['localcontact'] = $ret["contactid"];
	
	$cid = $remote;
	$ret = $dbintf->GetOrCreateCallerID($cid,$data['remote2'],$remote_is_local?1:0,$remotename);
	$data['remotecallerid'] = $ret["id"];
	$data['remotecontact'] = $ret["contactid"];
	
	$data['data1'] = $DisplayName;
	$data['data2'] = $callId3cx;
	
	$convert = false;
	// if ($storageExtension=='mp3' && $oriext=='mp3') $convert = false;
	
	$tenantid = CalcTenant($data);
	$data['tenantid'] = $tenantid;
	
	$ALE = (int) $dbintf->GetConfigValue('ALE');
	$AleDisk = (int) $dbintf->GetConfigValue('AleDisk');
	
	if($tenantid !== null)
	{
		$group = $dbintf->GetGroupInfo( $data['tenantid'] );
		$key = $dbintf->GetCallEncryptionKey($group['accid']);
		if($key && $key['inuse'])
		{
			$ALE = 2;
		}
	}

	if ($ALE==1)
	{ 
		$data['flags'] |= 16;
	}
	else if($ALE==2)
	{
		$data['flags'] |= 2048;
	}
	
	// To avoid handling something twice,
	// we first rename.
	// The prefix busy_ is used to detect if it is a busy file,
	// so we skip it during the next round if it is still there then.
	// tmpfn should have original extension (which is .mp3 in this case)
	$tmpfn = $directory . '/busy_' . $basefn . '.' . $oriext;
	if (copy($fullfn,$tmpfn)==false)
	{
		lg('Could not copy file');
		return false;
	}
	
	$handler_act = 'copyrec';
	if ($convert) $handler_act = 'copyconvrec';
	if (signal_service($handler_act
		.' '.$tmpfn
		.' '.$data['directory'].'/'.$data['filename']
		.' '.$data['remoteid']
		.' '.$ConfRecEnc
		.' '.$ALE
		.' '.$AleDisk
		)!='')
	{
		lg('Failed to ' . $handler_act);
		DeleteFn($tmpfn);
		return false;
	}
	
	$dbintf->InsertActiveCall($data);		
	
	return true;
}

function ImportMainstreamDir($basedir, $directory)
{
	$files = scandir($directory);
	if ($files===false) return;
	foreach ($files as $file)
	{
		// skip these directories
		if ($file=='.' || $file=='..') continue;
		if ($file=='rejected') continue;
		
		$fullfn = $directory . '/' . $file;
		if (is_dir($fullfn))
		{
			// recursive import
			ImportMainstreamDir($basedir,$fullfn);
			continue;
		}
		
		if (ImportMainstreamFile($file,$fullfn))
		{
			// ok
		} else
		{
			lg("FAILED to import $file");
		}
	}
}

function MainstreamImport($param)
{
	lg('Mainstream import starting');
	
	if ($param=='')
	{
		lg('no directory specified');
		return;
	}
	
	$directory = $param;
	$directory = rtrim($directory,'/');
	
	// recursive import
	ImportMainstreamDir($directory,$directory);
	
	
}

?>
