
-- Same structure as table Calls
CREATE TABLE CallsArchive
( id SERIAL PRIMARY KEY
, startdate INT
, startms INT
, duration INT
, durms INT
, isactive INT
, direction INT
, remotefull TEXT
, remote TEXT
, localfull TEXT
, local TEXT
, remote2 TEXT
, local2 TEXT
, isconnected INT
, linenr INT
, waittime INT
, source INT
, isarchived INT
, filename TEXT
, screenfn TEXT
, directory TEXT
, encoding INT
, encryption INT
, cardno TEXT
, flags INT
, callextra TEXT
, remoteid TEXT
, processingstate INT
, recorderid INT
, lineid INT
, localcallerid INT
, remotecallerid INT
, localcontact INT
, remotecontact INT
, notes TEXT
, notes2 TEXT
, notes3 TEXT
, notes4 TEXT
, notes5 TEXT
, connected TEXT
, category INT DEFAULT(0)
, connectedcallerid INT DEFAULT(0)
, connectedcontact INT DEFAULT(0)
, recyclebin INT
, tenantid INTEGER
);

-- Same indexes as Calls
CREATE INDEX callsarchive_date_ix ON CallsArchive(startdate DESC, startms DESC);
CREATE INDEX callsarchive_remoteid_ix ON CallsArchive(remoteid ASC);
CREATE INDEX callsarchive_tenant_ix ON CallsArchive(tenantid);
CREATE INDEX callsarchive_date_arch ON CallsArchive(startdate DESC) where isarchived=1;
