<?php

require_once 'general.php';
require_once 'utility.php';

HandleActive($dbintf);

function ParseDateTime($dt)
{
  return strtotime($dt);
}

function HandleActive($dbintf)
{
  global $rpl,$configs,$actuinfo,$msg;
	
	if(DetermineWebclientOnly()
  || (str_ensure_defined($configs['Theme'])=='ts' && ($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN) )==0)
  || (str_ensure_defined($configs['ActiveCallsAccess'])=='admins'     && ($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN) )==0)
  ){
		echo 'Permission denied';
		exit;
	}

  $act = $_POST['act'];
  if ($act!='')
  {
    // nothing so far
  }

  // Get the call listing
  $call_list = $dbintf->GetActiveCallList();
  LogAction('View active calls',array('level'=>'view'));

  $calldata = 'var calldata = [';
  $first = true;
  foreach ($call_list as $ix=>$row)
  {
    // correct duration
    $row['duration'] = (time() - $row['startdate']) / 1;

    if ($first==false) $calldata .= ',';
    $calldata .= '{startdate:"'.date($configs['datetimef'],$row['startdate']).'"'
    . ',id:'.$row['id']
    . ',remote:"'.JSQuote($row['remote']).'"'
    . ',local:"'.JSQuote($row['local']).'"'
    . ',source:'.$row['source']
    . ',remotefull:"'.JSQuote($row['remotefull']).'"'
    . ',localfull:"'.JSQuote($row['localfull']).'"'
    . ',lctid:'.int_ensure_defined($row['localcontact'])
    . ',rctid:'.int_ensure_defined($row['remotecontact'])
    . ',lname:"'.JSQuote(EmptyNull($row['lname'])).'"'
    . ',rname:"'.JSQuote(EmptyNull($row['rname'])).'"'
    . ',remote2:"'.JSQuote($row['remote2']).'"'
    . ',local2:"'.JSQuote($row['local2']).'"'
    . ',connected:"' . JSQuote(EmptyNull($row['connected'])) . '"'
    . ',cname:"' . JSQuote(EmptyNull($row['cname'])) . '"'
    . ',cctid:'.(int)$row['connectedcontact']
    . ',direction:' . $row['direction']
    . ',notes:"' . JSQuote($row['notes']).'"'
    . ',length:"' . JSQuote(formatDuration($row['duration'])) . '"'
    . ',linenr:' . (int) $row['linenr']
	  . ',filename:"' . JSQuote(GetDownloadFileName($row['filename'],$row)) . '"'
    . "}\r\n";
    $first = false;
  }

  $calldata .= '];';
	
	$callmon = (int) $dbintf->GetConfigValue('Monitoring');

  $dbintf->close();

  $template_content = file_get_contents('../apresa/templ/active.htm');

  $calldata .= 'var showcols = [';
	$colkeys = array("playlink","startdate","length","direction","notes"
	, "rname", "remote", "remote2", "lname", "local", "local2","linenr"
	, "connected", "cname"
	);
  foreach ($colkeys as $colkey)
  {
    $calldata .= int_ensure_defined(($configs['col_'.$colkey])).',';
    //$data .= "]";
  }
  $calldata .= '0];';
  $calldata .= '
  var sortkey = "startdate";
  var sortdir = YAHOO.widget.DataTable.CLASS_DESC;
  var pm_del_recording = 1;
  ';
  $calldata .= 'var embedPlayer = ' . (int_ensure_defined($configs['EmbedPlayer'])?'true':'false') . ';' . "\r\n";
	$calldata .= 'var audio5 = ' . (int_ensure_defined($configs['Audio5'])?'true':'false') . ';' . "\r\n";
	$calldata .= 'var callmon = ' . $callmon . ';' . "\r\n";

  $calldata .= GeneralJSData();


  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['search'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $calldata;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>

