<?php

require_once('general.php');
require_once 'cedb.php';

HandlePage($dbintf);

function FileEntryCompare($a, $b)
{
	if ($a['fn'] == $b['fn']) return 0;
	if ($a['dt'] < $b['dt']) return 1;
	if ($a['dt'] > $b['dt']) return -1;
	// if date/time is equal sort on filename
	return ($a['fn'] < $b['fn']) ? 1 : -1;
}

function GetDirFileList(&$arr,$dir)
{
	if ($handle = @opendir($dir))
	{
		while (false !== ($fn = readdir($handle)))
		{
			if ($fn=='.' || $fn=='..' || is_dir($dir.$fn)==1) continue;
			$info = stat($dir . $fn);
			$arr[] = array( 'fn'=>$fn
				,'sz'=>$info['size']
				,'dt'=>$info['mtime']
				,'dir'=>$dir
				 );
		}
	}
	usort($arr, "FileEntryCompare");
	return $arr;
}

function GetUsrOnAuditFilename($filename)
{
  $fn = $filename;
  // username can contain _, so find first occurence
  $pos = strpos($fn,'_');
  if ($pos===false) return FALSE;
  $usertxt = substr($fn,$pos+1);
  $pos = strrpos($usertxt,'.');
  if ($pos===false) return FALSE;
  return substr($usertxt,0,$pos);
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;
	
  if (str_ensure_defined($configs['AuditIntf'])=='database')
  {
    header('Location: '.$rooturl.'auditdb.php');
    exit;
  }
  
	$haveAccess = ($dbintf->actuinfo['permissions']&PM_CONFIG)
  || ($dbintf->actuinfo["permissions"]&PM_TENANT_ADMIN_AUDIT)
  ;
  
  $isFullAdmin = ($dbintf->actuinfo['permissions']&PM_CONFIG) != 0;

  if (!$haveAccess)
  {
    echo 'Permission denied';
    exit;
  }

  $files = array();
  $viewAdminLogs = int_ensure_defined( $_GET['admins'] );
  if ($viewAdminLogs)
  {
    if ( ($dbintf->actuinfo['permissions']&PM_CONFIG)==0 )
    {
      echo 'Permission denied';
      exit;
    }
    GetDirFileList($files, AUDIO_PATH . "/audit/admins/");
  } else
  {
    GetDirFileList($files, AUDIO_PATH . "/audit/");
  }
  
	if( ($dbintf->actuinfo["permissions"]&PM_TENANT_ADMIN_AUDIT) !=0 )
  {
    if($dbintf->actuinfo["tenantid"]==NULL)
    {
      // configuration error
      // tenant admin, but no tenantid
      // no access
      $files = array();
      // and tell user about error
      $msg[] = new Msg(MSG_ERR,'Tenant admin is not a member of a tenant');
    } else 
    {
			//echo("Tenant Admin: ".$dbintf->actuinfo["tenantid"]."<br>");
			$cedb = new CEDB($dbintf);
			$tenants = $cedb->getTenants($dbintf->actuinfo["tenantid"]);
			foreach($files as $key => $value){
        // username can contain _, so find first occurence
        $fn = $value['fn'];
				$pos = strpos($fn,'_');
        if ($pos===false) continue;
        $usertxt = substr($fn,$pos+1);
        $pos = strrpos($usertxt,'.');
        if ($pos===false) continue;
        $user = substr($usertxt,0,$pos);
				if(!in_array($user,$tenants)){
					//echo("User Not in Tenants: ".$user."<br>");
					unset($files[$key]);
				}else{
					//echo("User in Tenants: ".$user."<br>");
				}
			}
    }
	}
	

  if (isset($_GET['file']))
  {
		$fn = $_GET['file'];
		// check if in directory
		$indir = false;
		$dir = '';
  	foreach($files as $file)
  	{
			if ($file['fn']==$fn)
			{
				$indir = true;
				$dir = $file['dir'];
			}
		}
		// serve this
		if ($indir)
		{
      $usr = GetUsrOnAuditFilename($fn);
      $uinfo = $dbintf->GetUserInfoOnUsername($usr);
      
      if ($viewAdminLogs) $text = "Download admin audit trail file";
      else $text = "Download audit trail file";
      
      LogAction( $text . ": " . $fn , array('tenantid'=>$uinfo['tenantid']) );
      
			$extension = pathinfo($fn, PATHINFO_EXTENSION);
			$mime = "plain/text";
      header("Content-Type: $mime");
      header('Content-Disposition: attachment; filename='.$fn);

			// previously, we did simply: readfile($dir . $fn);
			// now, we read line by line,
			// and convert \n to \r\n

			$file = fopen($dir . $fn, 'r');
			if ($file)
			{
				while (!feof($file))
				{
					$line = fgets($file,4000);
					$linelen = strlen($line);
					if ($linelen>=2)
					{
						if ($line[$linelen-2]!="\r" && $line[$linelen-1]=="\n")
						{
							$line = substr($line,0,$linelen-1) . "\r\n";
						}
					}
					echo $line;
				}
				fclose($file);
			}
		} else
		{
			echo "File not found";
		}
		exit;
	}

  $act = $_POST['act'];
	if ($act!='')
	{
		/*if ($act=='del')
		{
			$fn = $_POST['fn'];
			// check if in directory
			$indir = false;
			$dir = '';
	  	foreach($files as $file)
	  	{
				if ($file['fn']==$fn)
				{
					$indir = true;
					$dir = $file['dir'];
				}
			}
			if ($indir)
			{
				$fn = $dir . $fn;
				if (DeleteFn($fn))
				{
          $msg[] = new Msg(MSG_INF,'<%Web.FileIsDeleted%>');
				}
			}
		}
  	*/
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'audit.php');
    exit;
	}

  if ($viewAdminLogs) LogAction( "View audit trail" , array('level'=>'view') );
  else LogAction( "View admin audit trail" , array('level'=>'view') );

	// ready with database
  $dbintf->close();

	$tab = '';

  $data = '';


  $tab = "<table class=\"filestab\">";
  $first = true;

  foreach($files as $file)
  {
		$fn = $file['fn'];
		$tab .= "<tr>";
    $link = "audit.php?file=".HtmlQuote($fn);
    if ($viewAdminLogs) $link .= '&admins=1';
		$tab .= "<td class=\"fn\"><a href=\"".$link."\">" . HtmlQuote($fn) . "</a>";
		$tab .= "<td class=\"sz\">" . round($file['sz']/1024) . " Kb";
		$tab .= "<td class=\"dt\">" . date("D, Y M d H:i:s",$file['dt']);

		// deleting??
		//$tab .= "<td class=\"btn\">" . "<a href=\"#\" onclick=\"return Del('" . JsQuote($fn) . "')\">" . $lng->Get('Main.Delete')  . "</a>";

		//$data .= "\n {name:\"" . JSQuote($fn) ."\""
		//			. ",size:" . $info['size'] . "} ";
	}
	if (count($files)==0)
	{
		$tab .= "<tr>";
		$tab .= "<td>" . $lng->Get('Web.NoRecords') . "<td><td>";
	}
	$tab .= "</table>";
	//$data .= "];\n";

  $data .= 'var canViewAdminLogs = ' . ($isFullAdmin?1:0) . ";\n";
  $data .= 'var viewAdminLogs = ' . ($viewAdminLogs?1:0) . ";\n";
  

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/audit.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['filestab'] = $tab;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
