<?php

require_once('general.php');

HandlePage($dbintf);


function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  if (isset($_FILES['restore']))
  {
    LogAction('Restore configuration from file');
    $RestoreNetw = (int_ensure_defined( $_POST['RestoreNetw'] )!=0) ;
    $restore = $_FILES['restore'];
    if ($restore['error']!=0)
    {
      // error in upload
      $msg[] = new Msg(MSG_ERR,'Error in file upload. '.GetUploadErrDescr($restore['error']));
    } else
    {
      // there is a good upload
      $ziptmp = $restore['tmp_name'].'.zip';
      move_uploaded_file($restore['tmp_name'],$ziptmp);

			$ok = true;
			
      $zip = new ZipArchive();
      if ($zip->open($ziptmp)!==TRUE)
			{
				$msg[] = new Msg(MSG_ERR,'Not a .zip file.');
				$ok = false;
			} else if ($zip->numFiles==0)
			{
				$msg[] = new Msg(MSG_ERR,'The file does not have the expected format');
				$ok = false;
			}
			if ($ok)
			{
				$dbintf->StartTransaction();
				for ($i=0;$i<$zip->numFiles;$i++)
				{
					$inf = $zip->statIndex($i);
					$fn = $inf['name'];
					//echo "<br>" . $inf['name'];
					if (substr($fn,-4)!='.tab')
					{
						$msg[] = new Msg(MSG_ERR,'The file does not have the expected format');
						$ok = false;
						break;
					}
					$tabname = substr($fn,0,-4);
					//echo $tabname;
					$stream = $zip->getStream( $fn );
					if ($dbintf->RestoreConfigTable( $tabname, $stream, $RestoreNetw )==false)
					{
						$msg[] = new Msg(MSG_ERR,'Error restoring table '. $tabname.' ('.$dbintf->lasterr.')');
						$ok = false;
					}

					fclose( $stream );
					
					// if any error, do not continue
					if ($ok==false) break;
				}
				if ($ok) $dbintf->CommitTransaction();
				else $dbintf->CancelTransaction();
			}
			
      @$zip->close();
      $zip = NULL;
      DeleteFn( $ziptmp );
			
			if ($ok)
			{
				EnginesSettingsCalcApply();
				
				// not: end_of_session();
				// Full log out is needed,
				// because userid might have changed.
				LogOutEveryone();
				msg_signal_service($msg,'ns');
				msg_signal_service($msg,'ss');
        // save with fresh orkaudio xml
        // o = recording engine, f = save fresh configuration
				msg_signal_service($msg,'of');
        msg_signal_service($msg,'or');
				msg_signal_service($msg,'telsys apply');
				msg_signal_service($msg,'spin apply');
				signal_service('addtosay 0Configuration restored');
				signal_service('addtosay 0Restart might be needed to apply all the new settings.');
        clusterBackupConfigNotify();
        clusterSystemConfigNotify();
        if ($RestoreNetw)
        {
          clusterNetworkConfigNotify();
        }
        // voip engine, restart=y, fresh=y
        clusterConfigNotify(true,true);
				header('Location: '.$rooturl);
				exit;
			}
    }

		$_SESSION['msg'] = $msg;
		header('Location: '.$rooturl.'backup-config.php');
    exit;

  }

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='save')
    {
      LogAction('Export configuration to file');

      $Conf = array();
      $Conf['BckConf'] = $_POST['BckConf'];
      $Conf['BckUsr' ] = $_POST['BckUsr' ];

      //echo $Conf['BckConf']; exit;

      $zip = new ZipArchive();
      $zipfilename = sys_get_temp_dir() . '/' .  uniqid("apresa");
      $zip->open($zipfilename,ZIPARCHIVE::CREATE);


      $tables = $dbintf->ExportConfig( $Conf );
      foreach ($tables as $tableName=>$tableContent)
      {
        $zip->addFromString( $tableName.'.tab' , $tableContent);
      }

      $zip->close();

      $download_ct = 'application/zip';
      $download = true;
      $nm = 'Backup';
      if ($Conf['BckConf']) $nm .= 'Conf';
      if ($Conf['BckUsr']) $nm .= 'Usr';
      $download_fn = $nm . '-' . date('Ymd-Hi').'.zip';

      header('Content-Type: '.$download_ct);
      header('Pragma: '); // needed for IE (HTTPS)
      if ($download)
      {
        header('Content-Disposition: attachment; filename='.$download_fn);
      }

      readfile( $zipfilename );
      DeleteFn( $zipfilename );
      exit;
    }

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'backup-config.php');
    exit;
  }

  // ready with database
  $dbintf->close();

  $data = '';

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/backup-config.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
