<?php

require_once('general.php');
require_once 'smbgen.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $configs = array_merge( $configs, $dbintf->LoadConfigsPart('b') );

  $BckAct = int_ensure_defined($configs['BckAct']);
  $BckCount = int_ensure_defined($configs['BckCount']);
  $BckFinished = int_ensure_defined($configs['BckFinished']);
  $BckProgress = int_ensure_defined($configs['BckProgress']);
  $BckCopied = int_ensure_defined($configs['BckCopied']);

  if ($BckAct==0
  // can be zero when copying only database:
  && $BckCount>=0
  && $BckCount==$BckProgress
  && $BckFinished==1)
  {
    $msg[] = new Msg(MSG_INF,$lng->Get('Backup.Completed').' ('.$BckCopied.' / '.$BckCount.' '.$lng->Get('Main.recordings').')');
    $dbintf->SetConfigsPart(array('BckCount'=>0,'BckProgress'=>0
      ,'BckCopied'=>0,'BckFinished'=>0),'b');
  }

	$cfgkeys = array('BckTargetType','BckPath','BckDisk','WinDomain','WinUsr','WinPwd','BckServer','BckShare','BckSubdir','BckFrom','BckTo','BckRepeat','BckDow','BckTime','BckDbDays','BckRecDays','BckData', 'BckCertificates','BckLogonMethod','BckScreenRecDays');

  $act = $_POST['act'];
  if ($act!='')
  {
		if ($act=='clear')
		{
      // clear settings
			LogAction('Clear backup settings');
			$configs_b = array();
      $to_clear = array('BckPath','BckDisk','WinDomain','WinUsr','WinPwd','BckServer','BckShare','BckSubdir','BckFrom','BckTo','BckData', 'BckCertificates', 'BckLogonMethod');
      foreach ($to_clear as $cfgkey)
      {
				$configs_b[$cfgkey] = '';
      }
      $configs_b['BckServerIP'] = '';
      $dbintf->SetConfigsPart($configs_b,'b');
		}
    if ($act=='stop')
    {
			LogAction('Stop backup');
      $configs_b['BckAct'] = 0;
      $dbintf->SetConfigsPart($configs_b,'b');
      msg_signal_service($msg,'bs');
    }
    if ($act=='set-start')
    {
			LogAction('Configure/start backup');
      $configs_b = array();
      foreach ($cfgkeys as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_b[$cfgkey] = $_POST[$cfgkey];
          if ($cfgkey=='WinPwd')
          {
            $configs_b[$cfgkey] = encrypt($configs_b[$cfgkey]);
          }
        }
      }
      // check disk
      if (isset($configs_b['BckDisk']))
      {
        // check if in array
        $found = false;
        $disks = FindDisks();
        foreach ($disks as $disk)
        {
          if ($disk == $configs_b['BckDisk'])
          {
            $found = true;
          }
        }
        if ($found==false)
        {
          $msg[] = new Msg(MSG_ERR,'Invalid backup disk');
          $_SESSION['msg'] = $msg;
          header('Location: '.$rooturl.'backup.php');
          exit;
        }
      }

      if (isset($configs_b['BckServer']))
      {
          $ret_lookup = LookupIpAddress($configs_b['BckServer']);
          if ($ret_lookup===false)
          {
            $configs_b['BckServerIP'] = $configs_b['BckServer'];
          } else
          {
            $configs_b['BckServerIP'] = $ret_lookup;
          }
      }
      $configs_b['BckAct'] = 1;
      $configs_b['BckNew'] = 1;
      $configs_b['BckCount'] = -1;
      $configs_b['BckProgress'] = 0;
      $dbintf->SetConfigsPart($configs_b,'b');
      if (msg_signal_service($msg,'bs'))
      {
	      $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));
        clusterBackupConfigNotify();
	    }

      if ($configs_b['BckRepeat']==0)
      {
      	if (msg_signal_service($msg,'bn'))
      	{
        	$msg[] = new Msg(MSG_INF,$lng->Get('Main.OK'));
       	}
      }
    }


    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'backup.php');
    exit;
  }

  $UseCallsArchive = (int) $dbintf->GetConfigValue('UseCallsArchive');
  LogAction('View backup settings',array('level'=>'view'));
  
  // ready with database
  $dbintf->close();

  if (!isset($configs['BckRepeat']))
  {
    // defaults
    $configs['BckRepeat'] = 2;
    $configs['BckTime'] = 3*60;
    $configs['BckDow'] = 1;
    $configs['WinPwd'] = '';
  }

  // find local disks
  $disks = FindDisks();
  
  $data = GeneralJSData();

  $data .= 'var BckTargetType =  ' . int_ensure_defined($configs['BckTargetType']) . ";\r\n";

  $data .= 'var BckPath       = "' .       JSQuote(str_ensure_defined($configs['BckPath'])) .   "\";\r\n";
  $data .= 'var BckDisk       = "' .       JSQuote(str_ensure_defined($configs['BckDisk'])) .   "\";\r\n";

  $data .= 'var WinDomain     = "' .       JSQuote(str_ensure_defined($configs['WinDomain' ])) .  "\";\r\n";
  $data .= 'var BckLogonMethod=  ' . int_ensure_defined($configs['BckLogonMethod' ])    .  ";\r\n";
  $data .= 'var WinUsr        = "' .       JSQuote(str_ensure_defined($configs['WinUsr'])) .      "\";\r\n";
  $data .= 'var HasWinPwd     =  ' . (int)(decrypt(str_ensure_defined($configs['WinPwd']))!='') .   ";\r\n";
  $data .= 'var BckServer     = "' .       JSQuote(str_ensure_defined($configs['BckServer'])) .   "\";\r\n";
  $data .= 'var BckServerIP   = "' .       JSQuote(str_ensure_defined($configs['BckServerIP'])) . "\";\r\n";
  $data .= 'var BckShare      = "' .       JSQuote(str_ensure_defined($configs['BckShare' ])) .   "\";\r\n";
  $data .= 'var BckSubdir     = "' .       JSQuote(str_ensure_defined($configs['BckSubdir'])) .   "\";\r\n";

  $data .= 'var BckFrom       = "' .       JSQuote(str_ensure_defined($configs['BckFrom'  ])) .   "\";\r\n";
  $data .= 'var BckTo         = "' .       JSQuote(str_ensure_defined($configs['BckTo'  ])) .     "\";\r\n";
  $data .= 'var BckData       = "' .       JSQuote(str_ensure_defined($configs['BckData'])) .     "\";\r\n";
  $data .= 'var BckCertificates  = ' .    int_ensure_defined($configs['BckCertificates']) . ";\r\n";
  
  $data .= 'var BckDbDays        =  ' . int_ensure_defined($configs['BckDbDays']) .        ";\r\n";
  $data .= 'var BckRecDays       =  ' . int_ensure_defined($configs['BckRecDays']) .       ";\r\n";
	$data .= 'var BckScreenRecDays =  ' . int_ensure_defined($configs['BckScreenRecDays']) . ";\r\n";
  $data .= 'var BckRepeat     =  ' . (int) $configs['BckRepeat'] .     ";\r\n";
  $data .= 'var BckDow        =  ' . (int) $configs['BckDow'   ] .     ";\r\n";
  $data .= 'var BckAct        =  ' . (int) $configs['BckAct'] .        ";\r\n";
  $data .= 'var BckPerc       =  ' . (int) int_ensure_defined($configs['BckPerc'])  .      ";\r\n";
  $data .= 'var BckBusy       =  ' . (int) int_ensure_defined($configs['BckBusy']) .       ";\r\n";
  $data .= 'var BckTime       =  ' . (int) $configs['BckTime'] .       ";\r\n";
  $data .= 'var BckCount      =  ' . (int) $configs['BckCount'] .      ";\r\n";
  $data .= 'var BckProgress   =  ' . (int) $configs['BckProgress'] .   ";\r\n";
  $data .= 'var UseCallsArchive = ' . $UseCallsArchive . ";\r\n";

  $data .= 'var Disks = ' . json_encode($disks) . ";\r\n";

	$pubkey = @file_get_contents(DATA_PATH . '/connector.pub');
	$data .= 'var pubkey = "' . JsQuote($pubkey) . '";' . "\n";
  
  $template_content = file_get_contents('../apresa/templ/backup.htm');
  
  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
