<?php

require_once('general.php');
require_once 'cedb.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_MANAGE)==false && CheckCePm(PM_CE_SUPERVISOR)==false)
  {
    echo 'Permission denied';
    exit;
	}

  $cedb = new CEDB($dbintf);

  $act = $_POST['act'];
  if ($act!='')
  {

  	if ($act=='add')
  	{
			$descr = $_POST['descr'];
      LogAction('Add AgEv answer type',array('descr'=>$descr));
    	$cedb->AddAnswerType1($descr);
      $logarr = array();
		}
		if ($act=='del')
		{
      $logarr = array();
      $answertypes = $cedb->GetAnswerTypes();
      foreach ($answertypes as $at)
      {
        if ($at['id'] == $_POST['id'])
        {
          $logarr['descr'] = $at['description'];
        }
      }
      LogAction('Delete AgEv answer type',$logarr);
			$ret = $cedb->DelAnswerType((int)$_POST['id']);
			if ($ret==1)
			{
	      $msg[] = new Msg(MSG_ERR,'Answer type is used by a question, and cannot be deleted.');
			}
		}
		if ($act=='edit')
		{
      LogAction('Edit AgEv answer type', array('descr'=>$_POST['descr']) );
			$ret = $cedb->EditAnswerType1((int)$_POST['id'],$_POST['descr']);
			if ($ret==1)
			{
	      $msg[] = new Msg(MSG_ERR,'Answer type is used by an answered question, and cannot be edited.');
			}
		}
		if ($act=='import')
  	{
			$descr = $_POST['descr'];
			$answertypes=json_decode($descr);			
			
			if(json_last_error() == JSON_ERROR_NONE){		
				foreach($answertypes as $answertype){
					$cedb->AddAnswerType1($answertype->descr);
					LogAction('Import AgEv answer type(s)',array('descr'=>$descr));
				}
				//$logarr = array();
			}else{
				$msg[] = new Msg(MSG_ERR,'Import contained invalid JSON code.');
			}
		}



    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'ceanswertypes.php');
		exit;
  }

  LogAction('View AgEv answer types',array('level'=>'view'));

	$answertypes = $cedb->GetAnswerTypes();

  $any_too_few = false;
	foreach($answertypes as &$answertyperef)
	{
		if ($answertyperef['type']==1)
		{
  		$answertyperef['obj'] = ParseAnswerDescription($answertyperef['description']);
      if (count($answertyperef['obj'])<2)
      {
        $any_too_few = true;
      }
  	}
	}
  if ($any_too_few)
  {
    $msg[] = new Msg(MSG_WRN,'Answer types should have two or more options.');
  }

	$data = 'var answertypes = [';
	$first = true;
	foreach($answertypes as $answertype)
	{
		if ($first) $first = false;
		else $data .= ',';

		$fname = GetFriendlyName($answertype);
		
		$acnt = count($answertype['obj']);

		$data .= '{ descr: "' . JSQuote($answertype['description']) . '"';
		$data .= ' , name: "' . JSQuote($fname) . '"';
		$data .= ' , acnt: ' . $acnt;
		$data .= ' , id: ' . $answertype['id'];
		$data .= ' , type: ' . $answertype['type'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";


  // ready with database
  $dbintf->close();


  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/ceanswertypes.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function GetFriendlyName($answer)
{
	if ($answer['type']==2)
	{
		return '- Header -';
		//return $lng->Get
	}
	if ($answer['type']==1)
	{
		$name = '';
		$first = true;
		foreach ($answer['obj'] as $opt)
		{
			if ($first) $first = false;
			else $name .= ' \\ ';
			$name .= $opt['text'];
		}
		return $name;
	}
}

function GetScoreBestAnswer($answer)
{
	if (count($answer['obj'])==0) return -1;
	$ret = null;
	foreach ($answer['obj'] as $opt)
	{
  	if ($ret===null)
  	{
			$ret = $opt['score'];
		} else
		{
			if ($opt['score']>$ret)
			{
				$ret = $opt['score'];
			}
		}
	}
	return $ret;
}
function GetScoreWorstAnswer($answer)
{
	if (count($answer['obj'])==0) return -1;
	$ret = null;
	foreach ($answer['obj'] as $opt)
	{
  	if ($ret===null)
  	{
			$ret = $opt['score'];
		} else
		{
			if ($opt['score']<$ret)
			{
				$ret = $opt['score'];
			}
		}
	}
	return $ret;
}

function ParseAnswerDescription($descr)
{
	// format is Good=2\Avg.=1\Poor=0
  $ret = array();
	$answers = explode('\\',$descr);
	foreach ($answers as $answer)
	{
		$parts = explode('=',$answer);
		$answerinfo = array();
		if (count($parts)==2)
		{
			$answerinfo['text'] = $parts[0];
			$answerinfo['score'] = $parts[1];
		}
		$ret[] = $answerinfo;
	}
	return $ret;
}

?>
