<?php

require_once('general.php');
require_once 'cedb.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s,$lng;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_VIEWOWNREPORTS)==false)
  {
    echo 'Permission denied';
    exit;
  }

  $cedb = new CEDB($dbintf);

  $act = $_POST['act'];
  if ($act!='')
  {
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'cerepagents.php');
		exit;
  }

	$formid = -1; // test
	if (isset($_GET['frm']))
	{
		$formid = $_GET['frm'];
	}
	$formid = (int) $formid;
	$perq = true;
	
	$actuinfo = $dbintf->GetActiveUserInfo();

	$scoremap = array();
	$answertypes = $cedb->GetAnswerTypes();
	foreach($answertypes as &$answertyperef)
	{
		if ($answertyperef['type']==1)
		{
  		$answertyperef['obj'] = ParseAnswerDescription($answertyperef['description']);
  		$best = GetScoreBestAnswer($answertyperef);
  		$worst = GetScoreWorstAnswer($answertyperef);
  		$subscoremap = array();
  		$ix = 0;
  		foreach ($answertyperef['obj'] as $opt)
  		{
				if ($best==$worst) $subscoremap[ $ix ] = 100.0;
        else $subscoremap[ $ix ] = 100.0 * ($opt['score']-$worst) / ($best-$worst);
				$ix ++;
			}
			$scoremap[ $answertyperef['id'] ] = $subscoremap;
  	}
	}
	//echo '<pre>';

	$forms = $cedb->GetForms();
	// always choose a form
	// otherwise, we cannot show answers
	if ($formid==-1)
	{
		$formid = $forms[0]['id'];
	}
 	foreach ($forms as $form)
 	{
		if ($form['id']==$formid)
		{
			$theform = $form;
		}
	}

 	$projects = $cedb->GetProjects();
 	$projectform = array();
 	$projectmap = array();
 	foreach ($projects as $project)
 	{
		$projectform[ $project['id'] ] = $project['formid'];
		$projectmap[ $project['id'] ] = $project;
	}

	$filterprjid = -1;
	if (isset($_GET['prj']))
	{
		$filterprjid = (int) $_GET['prj'];
		if ($filterprjid!=-1)
		{
			if (isset($projectmap[$filterprjid])==false)
			{
				echo 'Cannot find project';
				exit;
			}
			$formid = $projectmap[$filterprjid]['formid'];
		}
	}


	if ($formid!=-1)
	{
	  $theformdata = $cedb->GetForm($formid);
	  if ($theformdata['form']==null)
	  {
			echo 'Cannot find evaluation form';
			exit;
		}
		$theform = $theformdata['form'];
	  $questions = $theformdata['questions'];
	  $questionpos = array();
	  $qscoremap = array();
	  $hdrix = -1;
		// find out how many question belong to each section
		// and where is its header located for each question
	  for ($qix=0;$qix<count($questions);$qix++)
	  {
			if ($questions[$qix]['atypeid']==-1)
			{
				$hdrix = $qix;
			} else
			{
				$questions[$qix]['hdrix'] = $hdrix;
			}
		}
	  $ix = 0;
	  foreach ($questions as &$ref_question)
	  {
			$questionpos[ $ref_question['id'] ] = $ix;
			$qscoremap[ $ref_question['id'] ] = &$scoremap[ $ref_question['atypeid'] ];
			$ix ++;
		}
	}

  $projectfilterlist = array();
	if ($filterprjid == -1)
	{
		foreach ($projects as $project)
	 	{
			if ($project['formid']==$formid)
			{
				$projectfilterlist[] = $project['id'];
			}
		}
	} else
	{
		$projectfilterlist[] = $filterprjid;
	}


	$user_list = $dbintf->GetUserList();
	$usermap = array();
	foreach ($user_list as &$ref_user)
	{
		$ref_user['evalcnt'] = 0;
		$ref_user['scoretot'] = 0;
		$ref_user['scores'] = array();
    $ref_user['scoresw'] = array();
		$usermap[ $ref_user['accid'] ] = &$ref_user;
	}

  $scorev = 2;
  if (isset($_GET['scorev']))
  {
		$scorev = (int) $_GET['scorev'];
	}

	$filterusraccid = -1;
	if(isset($_GET['usr']) && $_GET['usr']!=-1 && !(CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false))
	{
		$filterusraccid = (int) $_GET['usr'];
		if (isset($usermap[$filterusraccid])==false)
		{
			echo 'Cannot find user';
			exit;
		}
		$filterusrobj = &$usermap[ $filterusraccid ];
	}
	
	if(CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false){
		$ref_user['evalcnt'] = 0;
		$ref_user['scoretot'] = 0;
		$ref_user['scores'] = array();
		$ref_user['accid'] = $actuinfo['accid'];
		$filterusrobj=$ref_user;
	}


  // sorting key and sort direction
  $sk = str_ensure_defined($_GET['sk']);
  $sd = str_ensure_defined($_GET['sd']);

  // Searching
  $search_accepted = array
  ( 'r1', 'l1', 'r2', 'l2' , 'rn' , 'ln' , 'nts'
  , 'fd' , 'ld' , 'id' , 'ip' , 'nm'
  , 'eid' , 'eip' , 'enm' , 'dir', 'ft', 'lt', 'own', 'usrnm' );
  $search = array();
  foreach ($search_accepted as $searchix)
  {
    if (str_ensure_defined($_POST[$searchix])!='')
    {
      $search[$searchix] = $_POST[$searchix];
    }
    // in GET when browsing pages
    if (str_ensure_defined($_GET[$searchix])!='')
    {
      $search[$searchix] = $_GET[$searchix];
    }
  }

  //echo '<pre>';
  //var_dump($search);
  //echo '</pre>';

	//$user_list = $dbintf->GetUserList();

  $search_use = $search;
  if (isset($search['ld']))
  {
    $ld = $search_use['ld'];
    // next day
    $ld = $ld + 60 * 60 * 24;
    $search_use['ld'] = $ld;
  }
  if (isset($_GET['usr']) || (CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false))
  {
		if(CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false){
			$accid = (int) $actuinfo['accid'];
		}else{
			$accid = (int) $_GET['usr'];
		}
		
		$info = $dbintf->GetUserInfoOnAccId($accid);
		if ($info!=null)
		{
			$search_use['ceusr'] = $info['accid'];
		}
	}
	
	

	$search_use['projects'] = $projectfilterlist;

	$pagenow = (int) str_ensure_defined($_GET['page']);

  $selcall = -1;
  if (isset($_GET['selcall']))
  {
		$selcall = (int) $_GET['selcall'];
	}

  $what = -1;
	if (isset($_GET['what']))
	{
		$what = $_GET['what'];
	}

	$outformat = 'table';
	$needdata = true;
	if (str_ensure_defined($_GET['view'])=='chart')
	{
		$outformat = 'chart';
		$needdata = false;
	}
	$chty = 'lc';
	if (isset($_GET['chty']))
	{
		$chty = $_GET['chty'];
	}

  $listconfig = array();
  $pagesize = 20;
  $listconfig['startfrom'] = $pagenow * $pagesize;
  $listconfig['checkrange'] = (int) 100;
  $listconfig['loadrange'] = $pagesize;
  
	if(CheckCePm(PM_CE_VIEW)==true || CheckCePm(PM_CE_VIEWOWNREPORTS)==true){
		$listconfig['ceproject'] = 4;
	}else{		// supervisor
		$listconfig['ceproject'] = 2;
	}
		
  // not: $listconfig['nousrflr'] = true;

	if (str_ensure_defined($_GET['export'])=='csv')
	{
		$listconfig['allrecords'] = true;
	}

	if ($needdata)
	{

		if ($selcall!=-1)
		{
		  for ($i=0;$i<20;$i++)
		  {
				$pagenow = $i;
	  		$listconfig['startfrom'] = $pagenow * $pagesize;
				// Get the call listing
		  	$call_list = $dbintf->GetCallList($sk,$sd,$search_use,$listconfig);
		  	$in_list = false;
		  	foreach ($call_list as $row)
		  	{
					if ($row['id']==$selcall)
					{
						$in_list = true;
					}
				}
				if ($in_list) break;
		  }
		} else {
		  // Get the call listing
		  $call_list = $dbintf->GetCallList($sk,$sd,$search_use,$listconfig);
		}
			
	  $call_count = $call_list['cnt'] +  $listconfig['startfrom']; // at least, may be more
		
	  // unset because otherwise taken into account in foreach below
	  unset($call_list['cnt']);
	
		// Calculate average score 
		$totalCombinedScore=0;
		$minScore=100000;
		$maxScore=0;
	
    $data = '';
		$data .= 'var calls = [';
		$first = true;
		foreach ($call_list as &$ref_call)
		{
			$call = $ref_call;
			/*
			// check no longer needed, because filtered on projects
			// that use this form
			if ($formid!=-1)
			{
				if ($projectform[$call['projectid']]!=$formid)
				{
					// skip this one
					continue;
				}
			}
			*/
	
			$useraccid = $call['useraccid'];
			$ref_user = & $usermap[$useraccid];
			$ref_user['evalcnt'] ++;
			$ref_user['scoretot'] += $call['score'];
			if ($filterusraccid!=-1 && $useraccid!=$filterusraccid)
			{
				// we are filtering on a user,
				// and this call is not from this user
				continue;
			}

			if ($first) $first = false;
			else $data .= ', ';
			$data .= '{ ceid: ' . $call['ceid'];
			$data .= ', startdate:"'.date($configs['datetimef'],$call['startdate']).'"';
			$data .= ', dir: ' . $call['direction'];
	    $data .= ', notes: "' . JSQuote($call['notes']).'"';
	    $data .= ', length: "' . formatDuration($call['duration']).'"';
			$data .= ', pm: ' . $call['pm'];
			$data .= ', arch: ' . $call['isarchived'];
			$data .= ', filename: "' . $call['filename'] . '"';
			$data .= ', flags: ' . $call['flags'];
			$data .= ', prj: ' . $call['projectid'];
			$data .= ', id: ' . $call['id'];
			$data .= ', usr: ' . (int) $call['useraccid'];
			$data .= ', supervisor: "' . $cedb->GetUserName($call['supervisor']).'"';
			$data .= ', datescored: "' . date("Y-m-d H:i:s", $call['datescored']).'"';
			$data .= ', score: ' . round($call['score']);
			
			$totalCombinedScore += $call['score'];
			if($minScore>$call['score']){
				$minScore = $call['score'];
			}
			if($maxScore<$call['score']){
				$maxScore = $call['score'];
			}
	
			if ($perq)
			{
				$answers = $cedb->GetEvaluationAnswers($call['ceid']);
				$subscores = array();
				for ($qix=0;$qix<count($questions);$qix++)
				{
					$subscores[$qix] = null;
				}
				$headerw = array();
				foreach ($answers as $answer)
				{
					$qix = $questionpos[ $answer['qid'] ];
					if ($answer['answer']==-2)
					{
						// N/A
						$subscores[$qix] = null;
						continue;
					}
					$subscore = $qscoremap[ $answer['qid'] ][ $answer['answer'] ];

					$subscores[$qix] = $subscore;
	        $ref_user['scores' ][ $qix ] = int_ensure_defined($ref_user['scores' ][ $qix ]) + $subscore;
					$ref_user['scoresw'][ $qix ] = int_ensure_defined($ref_user['scoresw'][ $qix ]) + 1;
					
	        // find out to which section this question belongs
	        // and add the score
	        $hdrix = $questions[$qix]['hdrix'];
	        if ($hdrix!=-1)
	        {
						$ref_user['scores'][$hdrix] += $subscore * $questions[$qix]['weight'];
						$ref_user['scoresw'][$hdrix] += $questions[$qix]['weight'];
						
						$headerw[$hdrix] += $questions[$qix]['weight'];
						$subscores[$hdrix] += $subscore * $questions[$qix]['weight'];
					}
				}
				foreach ($headerw as $hdrix=>$value)
				{
					$subscores[$hdrix] /= $value;
				}
				for ($qix=0;$qix<count($questions);$qix++)
				{
					if ($subscores[$qix]===null)
					{
						continue;
					}
					$data .= ', score'. $qix . ': ' . round($subscores[$qix]);
				}
				$ref_call['subscores'] = $subscores;
			}
			$data .= '}' . "\r\n";
	
		}
		$data .= '];' . "\r\n";
		
		if($minScore==100000){
			$minScore=0;
		}
		if($call_count > 0){
			$averageTotalScore = round($totalCombinedScore / $call_count,1);
		}else{
			$averageTotalScore = 0;
		}

		//echo '<pre>' . $data;
		//exit;
	} else
	{
		// when showing image
		// set some defaults to avoid errors
		$averageTotalScore = 0;
		$maxScore = 0;
		$minScore = 0;
		$call_count = 0;
	}

  $data .= 'var searchobj = {';
  $first = true;
  foreach ($search as $searchcol=>$searchvalue)
  {
    if ($first==false)
    {
      $data .= ',';
    }
    $first = false;
    $data .= $searchcol . ':"'.JSQuote($searchvalue).'"';
  }
  $data .= '};';

  $data .= '
  var sortkey = "'.$sk.'";
  var sortdir = '.($sd=='asc'?'YAHOO.widget.DataTable.CLASS_ASC':'YAHOO.widget.DataTable.CLASS_DESC').';
  ';

	$total = array();
	$total['evalcnt'] = 0;
	$total['scoretot'] = 0;
	$total['scores'] = array();
	// Note: Totals are calculated for CSV export
	// This is similar to cerepagents.php.
	// It is calculated per user, which is not directly needed.
	foreach ($user_list as &$ref_user)
	{
		if ($ref_user['evalcnt']>0)
		{
			$ref_user['avscore'] = safediv( $ref_user['scoretot'] , $ref_user['evalcnt']);
			$total['evalcnt'] += $ref_user['evalcnt'];
			$total['scoretot'] += $ref_user['scoretot'];
			if ($perq)
			{
				foreach ($ref_user['scores'] as $qix=>$subscore)
				{
					$total['scores'][$qix] = int_ensure_defined($total['scores'][$qix]) + $subscore;
					$total['scoresw'][$qix] = int_ensure_defined($total['scoresw'][$qix]) + $ref_user['scoresw'][$qix];
				}
			}
			if (isset($ref_user['scoresw']))
			{
				foreach ($ref_user['scoresw'] as $hdrix=>$weight)
				{
					$ref_user['scores'][$hdrix] /= $weight;
				}
			}
		}
	}

	if ($total['evalcnt']>0)
	{
		$total['avscore'] = safediv( $total['scoretot'] , $total['evalcnt'] );
	}

	if (str_ensure_defined($_GET['export'])=='csv')
	{
		header('Content-type: text/csv');
	  $csvfn = 'evaluated_calls_' . date('Ymd_His') . '.csv';
	  header('Content-Disposition: attachment; filename="'.$csvfn.'"');

		// UTF-8 BOM
		echo "\xEF\xBB\xBF";

		// columns
		$line = 'ID'
		  . ',' . CsvQuote($lng->Get('Cols.startdate'))
		  . ',' . CsvQuote($lng->Get('Cols.direction'))
		  . ',' . CsvQuote($lng->Get('Cols.direction'))
		  . ',' . CsvQuote($lng->Get('Cols.length') . ' [' . $lng->Get('DateTime.s') . ']' )
		  . ',' . CsvQuote($lng->Get('CE.Project'))
		  . ',' . CsvQuote($lng->Get('CE.Agent'))
			. ',' . CsvQuote($lng->Get('CE.Score'))
			;
		if ($perq)
		{
			$qix = 0;
			foreach ($questions as $question)
			{
				if ($question['atypeid']!=-1) $qix ++;
				if ($question['atypeid']!=-1)
				{
					$line .= ',' . CsvQuote($qix . '. ' . $question['qtext']);
				} else
				{
					$line .= ',' . CsvQuote($question['qtext']);
				}
			}
		}
		$line .=  ',' . CsvQuote($lng->Get('Cols.notes'));
		echo $line . "\r\n";

		foreach ($call_list as &$call)
		{
			$strDirection = '';
			if ($call['direction']==0) $strDirection = $lng->Get('Web.Incoming');
			if ($call['direction']==1) $strDirection = $lng->Get('Web.Outgoing');
			if ($call['direction']==2) $strDirection = $lng->Get('Web.Internal');

			$line = $call['id'];
			$line .= ',' . CsvQuote(date($configs['datetimef'],$call['startdate']));
			$line .= ',' . $call['direction'];
			$line .= ',' . CsvQuote($strDirection);
			$line .= ',' . $call['duration'];
			$line .= ',' . CsvQuote($projectmap[ $call['projectid'] ]['name']);
			$line .= ',' . CsvQuote($usermap[ $call['useraccid'] ]['name']);
			$line .= ',' . round($call['score'],2);
		  for ($qix=0;$qix<count($questions);$qix++)
		  {
				$line .= ',';
				if ($call['subscores'][$qix]===null) continue;
				$line .= round($call['subscores'][$qix],2);
			}
			$line .= ',' . CsvQuote($call['notes']);
			echo $line . "\r\n";
		}

		$line = $lng->Get('Stats.Total')
		. ',' // date&time
		. ',' // direction
		. ',' // direction (2)
		. ',' // duration
		. ',' // project
		. ',' // agent
		. ',' . round($total['avscore'],2)
		;
		if ($perq)
		{
		  for ($qix=0;$qix<count($questions);$qix++)
		  {
				$line .= ',';
				if (isset($total['scores'][$qix])==false) continue;
				$line .= round(
				safediv( $total['scores'][$qix]
					,$total['scoresw'][$qix])
					);
			}
		}
		echo $line . "\r\n";
		exit;
	}


	$data .= 'var agents = [';
	$first = true;

	foreach($user_list as $user)
	{	
		if ($user['evaluated']==0 || (CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false && $user['accid']!=$actuinfo['accid'])) continue;
		
		if ($first) $first = false;
		else $data .= ',';
		
		$data .= '{ name: "' . JSQuote($user['name']) . '"';
		$data .= ' , id: ' . $user['id'];
		$data .= ' , accid: ' . $user['accid'];
		$data .= ' , evalcnt: ' . $user['evalcnt'];
		$data .= ' , avscore: ' . round(ensure_defined($user['avscore'], 0.0),0);
		$data .= '}' . "\r\n";
		
	}
	if ($first) $first = false;
	else $data .= ',';
	$data .= '{ name: "' . JSQuote('Total') . '"';
	$data .= ' , id: null';
	$data .= ' , accid: null';
	$data .= ' , evalcnt: ' . (int) $total['evalcnt'];
	$data .= ' , avscore: ' . (double) round(ensure_defined($total['avscore'], 0.0), 0);
	if ($perq)
	{
	  for ($qix=0;$qix<count($questions);$qix++)
	  {
			$score = int_ensure_defined($total['scores'][$qix]);
			$data .= ', score' . $qix . ': ' . round(safediv($score,$total['evalcnt']));
		}
	}
	$data .= '}' . "\r\n";
	$data .= '];' . "\r\n";
	///echo '<pre>' . $data;
	//exit;

	$data .= 'var evalforms = [';
	$first = true;
	foreach($forms as $form)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($form['name']) . '"';
		$data .= ' , id: ' . $form['id'];
		$data .= ' , questions: ' . $form['qcnt'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	$data .= 'var projects = [';
	$first = true;
	foreach($projects as $project)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($project['name']) . '"';
		$data .= ' , id: ' . $project['id'];
		$data .= ' , avscore: ' . (double) round(ensure_defined($project['avscore'], 0.0),0);
		$data .= ' , callcnt: ' . int_ensure_defined($project['callcnt']);
		$data .= ' , evalcnt: ' . int_ensure_defined($project['evalcnt']);
		$data .= ' , formid: ' . $project['formid'];
		$data .= ' , formname: "' . JSQuote($project['formname']) . '"';
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	if ($formid!=-1)
	{
		$data .= 'var questions = [';
		$first = true;
		foreach($questions as $question)
		{
			if ($first) $first = false;
			else $data .= ',';
			$data .= '{ qtext: "' . JSQuote($question['qtext']) . '"';
			$data .= ' , id: ' . $question['id'];
			$data .= ' , ordering: ' . $question['ordering'];
			$data .= ' , atypeid: ' . $question['atypeid'];
			$data .= '}' . "\r\n";
		}
		$data .= '];' . "\r\n";
	}

	$data .= 'var perq = ' . ($perq?1:0) . ';' . "\r\n";
	$data .= 'var theformid = ' . $formid . ';' . "\r\n";
	
	if(CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false){
		$data .= 'var theusr = ' . $actuinfo['accid'] . ';' . "\r\n";
	}else{
		$data .= 'var theusr = ' . $filterusraccid . ';' . "\r\n";
	}
	
	$data .= 'var theprj = ' . $filterprjid . ';' . "\r\n";
	$data .= 'var scorev = ' . $scorev . ';' . "\r\n";
	$data .= 'var outformat = "' . $outformat . '";' . "\r\n";
	$data .= 'var what = "' . $what . '";' . "\r\n";
	$data .= 'var chty = "' . $chty . '";' . "\r\n";
  $data .= 'var embedPlayer = ' . ($configs['EmbedPlayer']?'true':'false') . ';' . "\r\n";

  LogAction("View AgEv list of evaluated calls"
    ,array('level'=>'view'
      ,'calllist_search'=>$search_use
      ,'calllist_config'=>$listconfig
      )
  );

	//echo '<pre>'.$data;
	//exit;

  // ready with database
  $dbintf->close();
  $data .= GeneralJSData();


  // Paging

  $frompage = $pagenow - 5;
  if ($frompage<0) $frompage = 0;
  $limitpage = (int) (($call_count + $pagesize - 1) / $pagesize);

  $nav = '';
  $nav .= '<div class="navcontainer">';
  if ($pagenow!=0)
  {
    $nav .= '<a class="nav" href="#" onclick="SetPage(0);return false;">|&lt;&lt;</a>';
  } else {
    $nav .= '<div class="navgray">|&lt;&lt;</div>';
  }
  if ($pagenow!=0)
  {
    $nav .= '<a class="nav" href="#" onclick="SetPage('.($pagenow-1).');return false;">&lt;</a>';
  } else {
    $nav .= '<div class="navgray">&lt;</div>';
  }
  for ($i=$frompage;$i<$limitpage;$i++)
  {
    $navcls = 'nav';
    if ($i==$pagenow) $navcls = 'navcur';
    $nav .= '<a class="'.$navcls.'" href="#" onclick="SetPage('.$i.');return false;">'.($i+1).'</a>';
  }
  if ($call_count == $listconfig['startfrom'] + $listconfig['checkrange'])
  {
    $nav .= '<div class="navdots">...</div>';
  }
  if ($pagenow!=$limitpage-1 && $limitpage!=0)
  {
    $nav .= '<a class="nav" href="#" onclick="SetPage('.($pagenow+1).');return false;">&gt;</a>';
  } else {
    $nav .= '<div class="navgray">&gt;</div>';
  }
  $nav .= '</div>';

  $template_content = file_get_contents('../apresa/templ/cecalls.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = $nav;
  $rpl['avScore'] = $averageTotalScore;
  $rpl['maxScore'] = round($maxScore);
  $rpl['minScore'] = round($minScore);
  $rpl['callCount'] = $call_count;
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['LegacyGraph'] = int_ensure_defined($configs['LegacyGraph']);
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
	$rpl['genlist_css'] = file_get_contents('../apresa/templ/genlist.css');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function GetScoreBestAnswer($answer)
{
	if (count($answer['obj'])==0) return -1;
	$ret = null;
	foreach ($answer['obj'] as $opt)
	{
  	if ($ret===null)
  	{
			$ret = $opt['score'];
		} else
		{
			if ($opt['score']>$ret)
			{
				$ret = $opt['score'];
			}
		}
	}
	return $ret;
}

function GetScoreWorstAnswer($answer)
{
	if (count($answer['obj'])==0) return -1;
	$ret = null;
	foreach ($answer['obj'] as $opt)
	{
  	if ($ret===null)
  	{
			$ret = $opt['score'];
		} else
		{
			if ($opt['score']<$ret)
			{
				$ret = $opt['score'];
			}
		}
	}
	return $ret;
}

function ParseAnswerDescription($descr)
{
	// format is Good=2\Avg.=1\Poor=0
	$ret = array();
	$answers = explode('\\',$descr);
	foreach ($answers as $answer){
		$parts = explode('=',$answer);
		$answerinfo = array();
		if (count($parts)==2)
		{
			$answerinfo['text'] = $parts[0];
			$answerinfo['score'] = $parts[1];
		}
		$ret[] = $answerinfo;
	}
	return $ret;
}

function safediv($a,$b)
{
	if ($b==0) return 0;
	else return $a / $b;
}

?>
