<?php
require_once('general.php');
require_once('cedb.php');

global $rpl,$configs,$msg,$rooturl,$configs_s,$lng;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
		echo 'Feature is not enabled';
		exit;
	}

	if (CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_VIEWOWNREPORTS)==false)
	{
		echo 'Permission denied';
		exit;
	}

	$cedb = new CEDB($dbintf);
	
	$actuinfo = $dbintf->GetActiveUserInfo();

	$formid = -1; // test
	if (isset($_GET['frm']))
	{
		$formid = $_GET['frm'];
	}
	$formid = (int) $formid;
	$perq = true;

	$scoremap = array();
	$answertypes = $cedb->GetAnswerTypes();
	foreach($answertypes as &$answertyperef)
	{
		if ($answertyperef['type']==1){
			$answertyperef['obj'] = ParseAnswerDescription($answertyperef['description']);
			$best = GetScoreBestAnswer($answertyperef);
			$worst = GetScoreWorstAnswer($answertyperef);
			$subscoremap = array();
			$ix = 0;
			foreach ($answertyperef['obj'] as $opt)
			{
				if ($best==$worst) $subscoremap[ $ix ] = 100.0;
				else $subscoremap[ $ix ] = 100.0 * ($opt['score']-$worst) / ($best-$worst);
				$ix ++;
			}
			$scoremap[ $answertyperef['id'] ] = $subscoremap;
		}
	}
	//echo '<pre>';

	$forms = $cedb->GetForms();
	// always choose a form
	// otherwise, we cannot show answers
	if ($formid==-1)
	{
		$formid = $forms[0]['id'];
	}
 	foreach ($forms as $form)
 	{
		if ($form['id']==$formid)
		{
			$theform = $form;
		}
	}

 	$projects = $cedb->GetProjects();
 	$projectform = array();
 	$projectmap = array();
 	foreach ($projects as $project)
 	{
		$projectform[ $project['id'] ] = $project['formid'];
		$projectmap[ $project['id'] ] = $project;
	}

	$filterprjid = -1;
	if (isset($_GET['prj']))
	{
		$filterprjid = (int) $_GET['prj'];
		if ($filterprjid!=-1)
		{
			if (isset($projectmap[$filterprjid])==false)
			{
				echo 'Cannot find project';
				exit;
			}
			$formid = $projectmap[$filterprjid]['formid'];
		}
	}


	if ($formid!=-1)
	{
		$theformdata = $cedb->GetForm($formid);
		if ($theformdata['form']==null)
		{
			echo 'Cannot find evaluation form';
			exit;
		}
		$theform = $theformdata['form'];
		$questions = $theformdata['questions'];
		$questionpos = array();
		$qscoremap = array();
		$hdrix = -1;
		// find out how many question belong to each section
		// and where is its header located for each question
		for ($qix=0;$qix<count($questions);$qix++)
		{
			if ($questions[$qix]['atypeid']==-1)
			{
				$hdrix = $qix;
			} else
			{
				$questions[$qix]['hdrix'] = $hdrix;
			}
		}
		$ix = 0;
		foreach ($questions as &$ref_question)
		{
			$questionpos[ $ref_question['id'] ] = $ix;
			$qscoremap[ $ref_question['id'] ] = &$scoremap[ $ref_question['atypeid'] ];
			$ix ++;
		}
	}

	$projectfilterlist = array();
	if ($filterprjid == -1)
	{
		foreach ($projects as $project)
	 	{
			if ($project['formid']==$formid)
			{
				$projectfilterlist[] = $project['id'];
			}
		}
	} else
	{
		$projectfilterlist[] = $filterprjid;
	}


	$user_list = $dbintf->GetUserList();
	$usermap = array();
	foreach ($user_list as &$ref_user)
	{
		$ref_user['evalcnt'] = 0;
		$ref_user['scoretot'] = 0;
		$ref_user['scores'] = array();
		$usermap[ $ref_user['accid'] ] = &$ref_user;
	}

	$scorev = 2;
	if (isset($_GET['scorev']))
	{
		$scorev = (int) $_GET['scorev'];
	}

	$filterusraccid = -1;
	if(isset($_GET['usr']) && $_GET['usr']!=-1)
	{
		if(CheckCePm(PM_CE_VIEWOWNREPORTS)&& CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_VIEWOWNREPORTS)==false){
			$filterusraccid = (int) $actuinfo['accid'];
		}else{
			$filterusraccid = (int) $_GET['usr'];
		}
		
		if (isset($usermap[$filterusraccid])==false)
		{
			echo 'Cannot find user';
			exit;
		}
		$filterusrobj = &$usermap[ $filterusraccid ];
	}


	// sorting key and sort direction
	$sk = 'startdate';
	$sd = 'asc';

	// Searching
	$search_accepted = array
	( 'r1', 'l1', 'r2', 'l2' , 'rn' , 'ln' , 'nts'
	, 'fd' , 'ld' , 'id' , 'ip' , 'nm'
	, 'eid' , 'eip' , 'enm' , 'dir', 'ft', 'lt', 'own', 'usrnm' );
	$search = array();
	foreach ($search_accepted as $searchix)
	{
		if (str_ensure_defined($_POST[$searchix])!='')
		{
			$search[$searchix] = $_POST[$searchix];
		}
		// in GET when browsing pages
		if (str_ensure_defined($_GET[$searchix])!='')
		{
			$search[$searchix] = $_GET[$searchix];
		}
	}

	//echo '<pre>';
	//var_dump($search);
	//echo '</pre>';

	//$user_list = $dbintf->GetUserList();

	$search_use = $search;
	if (isset($search['ld']))
	{
		$ld = $search_use['ld'];
		// next day
		$ld = $ld + 60 * 60 * 24;
		$search_use['ld'] = $ld;
	}
	if (isset($_GET['usr']))
	{
		if(CheckCePm(PM_CE_VIEWOWNREPORTS)&& CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_VIEWOWNREPORTS)==false){
			$accid = (int) $actuinfo['accid'];
		}else{
			$accid = (int) $_GET['usr'];
		}
		
		$info = $dbintf->GetUserInfoOnAccId($accid);
		if ($info!=null)
		{
			$search_use['usr'] = $info['accid'];
		}
	}
	
	$search_use['projects'] = $projectfilterlist;

	$pagenow = (int) str_ensure_defined($_GET['page']);

	$listconfig = array();
	$pagesize = 20;
	$listconfig['startfrom'] = $pagenow * $pagesize;
	$listconfig['checkrange'] = (int) 100;
	$listconfig['loadrange'] = $pagesize;
	if(CheckCePm(PM_CE_VIEW)==true || CheckCePm(PM_CE_VIEWOWNREPORTS)==true){
		$listconfig['ceproject'] = 4;
	}else{
		$listconfig['ceproject'] = 2;
	}
	// not: $listconfig['nousrflr'] = true;
	$listconfig['allrecords'] = true;

	// Get the call listing
	$call_list = $dbintf->GetCallList($sk,$sd,$search_use,$listconfig);

	$call_count = $call_list['cnt'] +  $listconfig['startfrom']; // at least, may be more
	// unset because otherwise taken into account in foreach below
	unset($call_list['cnt']);


	$valmax = 1;

	$dbg = '';

	// t, q3, p, a, s7
	$what = 't';
	$dbg = 'GET ' . $_GET['what'];
	if (isset($_GET['what']))
	{
		if ($_GET['what'] == -2) $what = 'p';
		else if ($_GET['what'] == -1) $what = 't';
		else if ($_GET['what'] == -3) $what = 'a';
		else
		{
			$what = 'q' . $_GET['what'];
		}
	}
	//$dbg = $what;

	$chty = 'lc';
	if (isset($_GET['chty']))
	{
		$chty = $_GET['chty'];
	}

	// t   - score of the call
	// p   - score of sections separately
	// qX  - score of question X (id.)
	// a   - score of questions separately (ugly chart)
	// sX  - score of questions in section X (id.) (also ugly chart)

	$scores = array();
	$legends = array();
	$labels = array();
	$paintlegend = true;

	$whatarr = array();

	switch ($what[0])
	{
	case 't':
		$scores[0] = array();
		$legends[0] = '';
		$paintlegend = false;
		break;
	case 'p':
		foreach ($questions as $qid=>$question)
		{
			if ($question['atypeid']==-1)
			{
				$scores[] = array();
				$legends[] = $question['qtext'];
				$whatarr[] = $qid;
			}
		}
		break;
	case 'a':
		foreach ($questions as $qid=>$question)
		{
			if ($question['atypeid']!=-1)
			{
				$scores[] = array();
				$legends[] = $question['qtext'];
				$whatarr[] = $qid;
			}
		}
		break;
	case 's':
		$whatix = (int) substr($what,1);
		foreach ($questions as $qid=>$question)
		{
			if ($question['atypeid']!=-1)
			{
				$hdrix = $question['hdrix'];
				$pos = $questionpos[ $hdrix ];
				if ($questions[$pos]['id']==$whatix)
				{
					$scores[] = array();
					$legends[] = $question['qtext'];
					$whatarr[] = $qid;
				}
			}
		}
		break;
	case 'q':
		$whatix = (int) substr($what,1);
		$scores[0] = array();
		$whatix = $questionpos[ $whatix ];
		$legends[0] = $questions[$whatix]['qtext'];
		break;
	}

	//$call_count;
	// if 20 > 10
	//
	// this is an sort of relative position
	// if it is 100 we are at the end of the labeling
	// it is used to limit the amount of labels
	// to prevent it becoming too dense
	$lblpos = 0;
	$prevlbl = -40;

	$filtered_call_count = 0;

	// calculated filtered call count:
	foreach ($call_list as &$ref_call)
	{
		$useraccid = $ref_call['useraccid'];
		if ($filterusraccid!=-1 && $useraccid!=$filterusraccid)
		{
			continue;
		}
		$filtered_call_count++;
	}

	foreach ($call_list as &$ref_call)
	{
		$useraccid = $ref_call['useraccid'];
		if ($filterusraccid!=-1 && $useraccid!=$filterusraccid)
		{
			// we are filtering on a user,
			// and this call is not from this user
			// we need to do this here, because normal searching is not sufficient,
			// because a call can be from a user even if that user
			// is not evaluated with it,
			// but we want only calls where the agent is evaluated
			continue;
		}

		$lblpos += 100.0 / $filtered_call_count;

		$call = $ref_call;
		$answers = $cedb->GetEvaluationAnswers($call['ceid']);
		$subscores = array();
		for ($qix=0;$qix<count($questions);$qix++)
		{
			$subscores[$qix] = null;
		}
		$headerw = array();
		foreach ($answers as $answer)
		{
			$qix = $questionpos[ $answer['qid'] ];
			if ($answer['answer']==-2)
			{
				// N/A
				$subscores[$qix] = null;
				continue;
			}
			$subscore = $qscoremap[ $answer['qid'] ][ $answer['answer'] ];
			$subscores[$qix] = $subscore;

		// find out to which section this question belongs
		// and add the score
		$hdrix = $questions[$qix]['hdrix'];
		if ($hdrix!=-1){
				$subscores[$hdrix] += $subscore * $questions[$qix]['weight'];
				$headerw[$hdrix] += $questions[$qix]['weight'];
			}
		}
		foreach ($headerw as $hdrix=>$value)
		{
			$subscores[$hdrix] /= $value;
		}


		switch ($what[0])
		{
		case 't':
			$scores[0][] = $call['score'];
			break;
		case 'q':
			$scores[0][] = $subscores[$whatix];
			break;
		case 'p': case 'a': case 's':
			foreach ($whatarr as $ix=>$whatix)
			{
				$scores[$ix][] = $subscores[$whatix];
			}
			break;
		}

		// how much space between labels?
		$lblspacing = 4;
		if ($lblpos>$prevlbl+$lblspacing)
		{
			$labels[] = date($configs['datef'],$call['startdate']);
			$prevlbl = $lblpos;
		} else
		{
			// skip this label position
			$labels[] = '';
		}



	}

	// calculate maximum value
	foreach ($scores as $score)
	{
		// TODO: fix this:
		// $scores is an double array, $score is an array,
		// next line compares array to int, max calc does not work probably
		// same issue is in cecallsimglegacy.php
		if ($score>$valmax)
		{
			$valmax = $score;
		}
	}	
	
	// create Labels for graph
	$listLabels="";
	foreach ($labels as $label)
	{
		if($listLabels!=""){
			$listLabels.=",";
		}
		$listLabels.="'".$label."'";
	}
	
	
	$scoresetcnt = 0;
	// add data
	$listSeries="";

	for($scorecounter=0;$scorecounter<count($scores);$scorecounter++){
		if($scorecounter!=0){
			$listSeries.=",";
		}
		$listSeries.="[";
		foreach ($scores[$scorecounter] as $score_ref)
		{
			if (strlen($score_ref)>0)
			{
				if($scoresetcnt!=0){
					$listSeries.=",";
				}
				$scoresetcnt++;
				$listSeries.=$score_ref;
				//$chart->addPoint($score_ref,'d'.$ix);
				//$chart->addSerie('d'.$ix);
				//$chart->setSerieName($legends[$ix],'d'.$ix);
			}
		}
		$listSeries.="]";
		$scoresetcnt = 0;
	}
	

	$label_max = 40;
	$legend_extra = max(count($legends)*14,0);

 	$chart_width = 700;
 	$chart_height = 420 + $legend_extra;
		

	function GetScoreBestAnswer($answer)
	{
		if (count($answer['obj'])==0) return -1;
		$ret = null;
		foreach ($answer['obj'] as $opt){
			if ($ret===null)
			{
				$ret = $opt['score'];
				
			}else{
				
				if ($opt['score']>$ret)
				{
					$ret = $opt['score'];
				}
			}
		}
	return $ret;
}

function GetScoreWorstAnswer($answer)
{
	if (count($answer['obj'])==0) return -1;
	$ret = null;
	foreach ($answer['obj'] as $opt)
	{
  	if ($ret===null)
  	{
			$ret = $opt['score'];
		} else
		{
			if ($opt['score']<$ret)
			{
				$ret = $opt['score'];
			}
		}
	}
	return $ret;
}

function ParseAnswerDescription($descr)
{
	// format is Good=2\Avg.=1\Poor=0
	$ret = array();
	$answers = explode('\\',$descr);
	foreach ($answers as $answer)
	{
		$parts = explode('=',$answer);
		$answerinfo = array();
		if (count($parts)==2)
		{
			$answerinfo['text'] = $parts[0];
			$answerinfo['score'] = $parts[1];
		}
		$ret[] = $answerinfo;
	}
	return $ret;
}

function safediv($a,$b)
{
	if ($b==0) return 0;
	else return $a / $b;
}

?>
<html>
  <head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<a id="myAnchor"></a>
    <link rel="stylesheet" href="/p/lib/Chartist/chartist.min.css">
	<link rel="stylesheet" href="/p/lib/Chartist/chartist-plugin-tooltip.css">
	<!--<link rel="stylesheet" href="/p/lib/Chartist/chartist-plugin-legend.css">-->
    <script src="/p/lib/Chartist/chartist.min.js"></script>
	<script src="/p/lib/Chartist/chartist-plugin-tooltip.js"></script>
	<script src="/p/lib/Chartist/chartist-plugin-axistitle.js"></script>
	<!--<script src="/p/lib/Chartist/chartist-plugin-legend.js"></script>-->
	
  </head>
  <div class="ct-chart ct-golden-section"></div>
  <style>
	
		.ct-axis-title{
			fill:rgba(0,0,0,1) !important;
		}
		
		.ct-label{
			fill:rgba(0,0,0,1) !important;
			color:rgba(0,0,0,1) !important;
		}
		
		.ct-horizontal.ct-label {
			min-height: 70px;
			max-height: 70px;

		}
				
		.chartist-tooltip{
			fill:rgba(192, 192, 192, 1); !important;
			color:rgba(0,0,0,1) !important;
			background:rgba(192, 192, 192, 1); !important;
			border-top-color:rgba(192, 192, 192, 1); !important;
			z-index: 999 !important;
		}
		
		.chartist-tooltip:before{
			border-top-color:rgba(192, 192, 192, 1); !important;
		}
		
		.ct-vertical.ct-label {
			padding: 5px !important;
		}
	
		.ct-chart {
			fill:rgba(0,0,0,1) !important;
			color:rgba(0,0,0,1) !important;
			position: relative;
			bottom: -25px;
			width: 90% !important;
			height: 90% !important;
		}
		
		.ct-chart-line{
			height: 100%;
		}
		
	</style>
	<script>
	
	var data = {
		labels: [<?php echo $listLabels; ?>],
		series: [<?php echo $listSeries; ?>]	
	};
	
	var responsiveOptions = [{
			seriesBarDistance: 5,
			chartPadding: 100,
			labelOffset: 100
		  }];
		  
	var options = {		
		width: '100%',
		height: '100%',
		showLine: true,
		stackBars: false,
		showLabel: true,	
		axisX: {
			offset: 70
		},
		axisY: {
			onlyInteger: true
		},
		plugins: [
			Chartist.plugins.tooltip()
			,
			Chartist.plugins.ctAxisTitle({
				axisX: {
					showLabel: false,
					//axisTitle: 'Time (mins)',
					axisClass: 'ct-axis-title',
					offset: {
						x: 0,
						y: 40
					},
					textAnchor: 'middle'
				},
				axisY: {
					axisTitle: <?php echo "' ".$lng->Get('CE.Score')." '" ?>,
					axisClass: 'ct-axis-title',
					offset: {
						x: 0,
						y: 10
					},
					textAnchor: 'middle',
					flipTitle: true
				}
			})]
	}
	
	var anchor = document.getElementById('myAnchor');
	if('writingMode' in anchor.style){
		document.write("<style type='text/css'>.ct-horizontal.ct-label {text-align: left !important;font-size: 12px !important;writing-mode: vertical-lr;font-family: 'Arial', Arial, sans-serif;}</style>");
	}else{
		document.write("<style type='text/css'>.ct-horizontal.ct-label {text-align: left !important;font-size: 12px !important;-webkit-transform:rotate(90deg);-moz-transform:rotate(90deg);-o-transform: rotate(90deg);-ms-transform:rotate(90deg);transform-origin: left top 0;font-family: 'Arial', Arial, sans-serif;}</style>");
	}

	// Create a new line chart object where as first parameter we pass in a selector
	// that is resolving to our chart container element. The Second parameter
	// is the actual data object. As a third parameter we pass in our custom options.
	<?php
	if ($chty=='lc'){
		echo "new Chartist.Line('.ct-chart', data, options,responsiveOptions);";
	}else{
		echo "new Chartist.Bar('.ct-chart', data, options,responsiveOptions);";
	}
	?>
	</script>
</html>