<?php
/*
	Database things related to call evaluation (CE)
*/

class CEDB
{
	var $db;
	var $dbintf;
  
	function __construct($dbintf)
	{
		$this->dbintf = $dbintf;
		$this->db = $dbintf->db;
	}


	function OnDbErr()
	{
		return $this->dbintf->OnDbErr();
	}



	// Forms

	function GetForms()
	{
    $result = array();
    foreach ($this->db->query('SELECT * FROM CEForms ORDER BY name') as $row)
    {
			$formid = (int) $row['id'];
			$row['qcnt'] = $this->db->query('SELECT COUNT(id) FROM CEQuestions WHERE atypeid>=1 AND formid='.$formid)->fetchColumn(0);
      $result[] = $row;
    }
    return $result;
	}

	function EditForm($id,$newname)
	{
		$sql = 'UPDATE CEForms SET name=? WHERE id=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
     	$stmt->bindValue(1,$newname);
			$stmt->bindValue(2,$id);
			$stmt->execute();
    }
    return true;
	}

	function GetForm($id)
	{
		$id = (int) $id;
		$result = array();
    $result['form'] = $this->db->query('SELECT * FROM CEForms WHERE id='.$id)->fetch(PDO::FETCH_ASSOC);
    $result['questions'] = array();
    foreach ($this->db->query('SELECT * FROM CEQuestions WHERE formid='.$id.' ORDER BY ordering') as $row){
      $result['questions'][] = $row;
		}
		return $result;
	}

	function DeleteForm($formid)
	{
		$formid = (int) $formid;
		if ($this->IsFormUsedByProject($formid))
		{
			return 1;
		}

    $this->db->query('DELETE FROM CEQuestions WHERE formid='.$formid);
    $this->db->query('DELETE FROM CEForms WHERE id='.$formid);

    return 0;
	}

	function NewForm($thename)
	{
    $this->db->query('INSERT INTO CEForms(name) VALUES (\'Form\')');
		$formid = $this->db->lastInsertId('CEForms_id_seq');
		$this->EditForm($formid,$thename);
		return $formid;
	}
	
	function CloneForm($cloneid, $newname)
	{		
    $this->db->query('INSERT INTO CEForms(name) VALUES (\'Form\')');
		$formid = $this->db->lastInsertId('CEForms_id_seq');
		
		$this->EditForm($formid,$newname);

		$questions = array();	
		
		$oldformdata = $this->GetForm($cloneid);
		
		foreach ($oldformdata['questions'] as $question)
    {
			$question['formid']=$formid;
			$this->AddQuestion($question);
		}
		

		return $formid;
	}
		
	function GetFormCallCount($formid)
	{
		$cnt = 0;
		$prjlist = $this->GetProjects();
		foreach($prjlist as $prj)
		{
    	if ($prj['formid']==$formid)
    	{
     		// - find all calls of those projects
				$cnt += $this->GetProjectCallCount($prj['id']);
			}
		}
		return $cnt;
	}


	// answer types

	function GetAnswerTypes()
	{
    $result = array();
    foreach ($this->db->query('SELECT * FROM CEAnswerTypes ORDER BY id') as $row)
    {
      $result[] = $row;
    }
    return $result;
	}

	function IsAnswerTypeInUse($id)
	{
		$id = (int) $id;
		$sql = 'SELECT COUNT(id) '
		.	' FROM CEQuestions '
		.	' WHERE atypeid=' . $id ;
    $res = $this->db->query($sql)->fetchColumn(0);
    return $res!=0;
	}

	// this one also check if question is answered
	function IsAnswerTypeInUseFull($id)
	{
		$id = (int) $id;
		$sql = 'SELECT COUNT(CEAnswers.id) '
		.	' FROM CEAnswers '
		.	' JOIN CEQuestions ON CEAnswers.qid=CEQuestions.id '
		.	' WHERE CEQuestions.atypeid=' . $id ;
    $res = $this->db->query($sql)->fetchColumn(0);
    return $res!=0;
	}

	function DelAnswerType($id)
	{
		if ($this->IsAnswerTypeInUse($id))
		{
			return 1;
		}
    $sql = 'DELETE FROM CEAnswerTypes WHERE id=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return 2;
    } else {
      $res = $stmt->execute(array($id));
    }
		return 0;
	}

	function EditAnswerType1($id,$descr)
	{
		if ($this->IsAnswerTypeInUseFull($id))
		{
			return 1;
		}
    $sql = 'UPDATE CEAnswerTypes SET description=? WHERE id=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return 2;
    } else {
      $res = $stmt->execute(array($descr,$id));
    }
		return 0;
	}

	function AddAnswerType1($descr)
	{
    $sql = 'INSERT INTO CEAnswerTypes(description,type) VALUES (?,?) ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
      $stmt->bindValue(1,$descr);
      $stmt->bindValue(2,1);
      $res = $stmt->execute();
    }
		return true;
	}






	// Questions

	function RepositionQuestionInT($formid,$qid,$newpos)
	{
		$questions = array();
		$nr = 1;
		$qidpos = null;
		if ($newpos==-1)
		{
			$newpos = 9999;
		}
		$formid = (int) $formid;
		foreach ($this->db->query('SELECT id,ordering FROM CEQuestions WHERE formid='.$formid.' ORDER BY ordering') as $row)
    {
			if ($nr==$newpos)
			{
				// insert here
				$qidpos = $nr;
				$nr ++;
			}
			if ($row['id']!=$qid)
			{
				$row['ordertoset'] = $nr;
      	$nr ++;
			} else $newpos --;
      $questions[] = $row;
		}
		if ($qidpos==null)
		{
			$qidpos = $nr;
		}

		$sql = 'UPDATE CEQuestions SET ordering=? WHERE id=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
    	$this->dbintf->CancelTransaction();
      $this->OnDbErr();
      return false;
    } else {
      foreach ($questions as $q)
      {
				if ($q['id']==$qid)
				{
					$stmt->bindValue(1,$qidpos);
				} else
				{
	      	$stmt->bindValue(1,$q['ordertoset']);
				}
				$stmt->bindValue(2,$q['id']);
      	$res = $stmt->execute();
			}
    }
	}

	function EditQuestion($q)
	{
		$this->dbintf->StartTransaction();
		$this->RepositionQuestionInT($q['formid'],$q['qid'],$q['pos']);

		$sql = 'UPDATE CEQuestions SET qtext=? , atypeid=?'
		. ', weight=?, canna=? WHERE id=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
    	$this->dbintf->CancelTransaction();
      $this->OnDbErr();
      return false;
    } else {
      $stmt->bindValue(1,$q['qtext']);
      $stmt->bindValue(2,$q['atypeid']);
      $stmt->bindValue(3,$q['weight']);
      $stmt->bindValue(4,$q['canna']);
      $stmt->bindValue(5,$q['qid']);
      $res = $stmt->execute();
    }

    $this->dbintf->CommitTransaction();
		return true;
	}

	function AddQuestion($q)
	{
		$formid = (int) $q['formid'];

		$this->dbintf->StartTransaction();

		$highpos = $this->db->query('SELECT MAX(ordering) FROM CEQuestions WHERE formid='.$formid)->fetchColumn(0);

    $sql = 'INSERT INTO CEQuestions(qtext,atypeid,formid,ordering,weight,canna) VALUES (?,?,?,?,?,?) ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
    	$this->dbintf->CancelTransaction();
      $this->OnDbErr();
      return false;
    } else {
      $stmt->bindValue(1,$q['qtext']);
      $stmt->bindValue(2,$q['atypeid']);
      $stmt->bindValue(3,$q['formid']);
      $stmt->bindValue(4,$highpos+1);
      $stmt->bindValue(5,$q['weight']);
      $stmt->bindValue(6,$q['canna']);
      $res = $stmt->execute();
      $qid = $this->db->lastInsertId('CEQuestions_id_seq');
    }

		$this->RepositionQuestionInT($formid,$qid,$q['pos']);

    $this->dbintf->CommitTransaction();

		return true;
	}

	function IsQuestionAnswered($id)
	{
		$id = (int) $id;
		$sql = 'SELECT COUNT(CEAnswers.id) '
		.	' FROM CEAnswers '
		.	' WHERE qid=' . $id ;
    $res = $this->db->query($sql)->fetchColumn(0);
    return $res[0]!=0;
	}

	function DelQuestion($formid,$qid)
	{
		if ($this->IsQuestionAnswered($qid))
		{
			return 1;
		}
    $sql = 'DELETE FROM CEQuestions WHERE id=? and formid=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return 2;
    }

    $stmt->bindValue(1,$qid);
    $stmt->bindValue(2,$formid);
    $res = $stmt->execute();
		return 0;
	}
	
	//Audit
	function getTenants($tenantID){
		$sql = 'SELECT usr FROM Users WHERE tenantid = ?';		
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
		
		$stmt->execute(array($tenantID));
		
		$result = array();
		
		while ($row = $stmt->fetch()){
			$result[]=$row[0];
		}
		return $result;
	}

	
	//Dashboard
	function getMyGroups($supervisor){
		$sql = 'SELECT grpid FROM GroupMembers WHERE accid = ?';		
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
		
		$stmt->execute(array($supervisor));
		
		$result = array();
		
		while ($row = $stmt->fetch()){
			$result[]=$row[0];
		}
		return $result;
	}
	
	function getSubGroups($grpid){
		
		$sql = 'SELECT accid FROM Groups WHERE super = ?';		
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
		
		$stmt->execute(array($grpid));
		
		$result = array();
		
		while ($row = $stmt->fetch()){
			$result[]=$row[0];			
			$result=array_merge($result, $this->getSubGroups($row[0]));
		}
		return $result;
	}
		
	function getAllUsers(){
		// creates a string containing ?,?,? 
		$stmt = $this->db->prepare('SELECT DISTINCT accid FROM Users');

		$stmt->execute();
		
		$result = array();
		
		while ($row = $stmt->fetch()){
			$result[]=$row[0];
		}
		return $result;
		
	}
	
	
	function getUsersFromGroups($ids){
		if(count($ids)<=0) return array();		
		
		// creates a string containing ?,?,? 
		$clause = implode(',', array_fill(0, count($ids), '?'));
		$stmt = $this->db->prepare('SELECT DISTINCT accid FROM GroupMembers WHERE grpid IN ('.$clause.')');

		$stmt->execute($ids);
		
		$result = array();
		
		while ($row = $stmt->fetch()){
			$result[]=$row[0];
		}
		return $result;
		
	}
	
	function getUserID($accid){
		if($accid==null)return null;
		
		$sql = 'SELECT id FROM Users WHERE accid = ?';				
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}

		$stmt->execute(array($accid));		
		$result = array();
		
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		
		return null;
		
	}
	
	function getMyProjects($accid){
		if($accid==-1){
			$sql = 'SELECT id FROM CEProjects ORDER BY name';
		}else{
			$sql = 'SELECT A.id FROM CEProjects A WHERE A.id IN (SELECT DISTINCT B.projectid FROM CECalls B WHERE B.useraccid = ?) ORDER BY name';
		}
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
		if($accid==-1){
			$stmt->execute();
		}else{
			$stmt->execute(array($accid));
		}
		$result = array();
		
		while ($row = $stmt->fetch()){			
			$result[]=$row[0];
		}
		return $result;
		
	}
	
	function getCompletedEvaluationsBetween($supervisor, $accid, $prjid, $start,$end){		
		if($accid==-1&&$prjid==-1){
			$sql = 'SELECT COUNT(A.id) FROM CECalls A WHERE A.datescored >= ? AND A.datescored < ? AND A.supervisor=? AND score IS NOT NULL';
		}else if($accid!=-1&&$prjid==-1){
			$sql = 'SELECT COUNT(A.id) FROM CECalls A WHERE A.datescored >= ? AND A.datescored < ? AND A.useraccid = ? AND A.supervisor=? AND score IS NOT NULL';
		}else if($accid!=-1&&$prjid!=-1){
			$sql = 'SELECT COUNT(A.id) FROM CECalls A WHERE A.datescored >= ? AND A.datescored < ? AND A.useraccid = ? AND A.projectid = ? AND A.supervisor=? AND score IS NOT NULL';
		}else if($accid==-1&&$prjid!=-1){
			$sql = 'SELECT COUNT(A.id) FROM CECalls A WHERE A.datescored >= ? AND A.datescored < ? AND A.projectid = ? AND A.supervisor=? AND score IS NOT NULL';
		}
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
		
		if($accid==-1&&$prjid==-1){
			$stmt->execute(array($start,$end,$supervisor));
		}else if($accid!=-1&&$prjid==-1){
			$stmt->execute(array($start,$end,$accid,$supervisor));
		}else if($accid!=-1&&$prjid!=-1){
			$stmt->execute(array($start,$end,$accid,$prjid,$supervisor));
		}else if($accid==-1&&$prjid!=-1){
			$stmt->execute(array($start,$end,$prjid,$supervisor));
		}

		$result = array();
		
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		
		return 0;
	}
	
	function GetSupervisors()
	{
    $result = array();
    foreach ($this->db->query('SELECT A.accid FROM Users A WHERE A.accid IN (SELECT B.accid FROM GroupMembers B WHERE B.grpid IN (SELECT C.accid FROM AccAcc C WHERE (C.epermissions&262144)!=0)) OR A.accid IN (SELECT C.accid FROM AccAcc C WHERE (C.epermissions&262144)!=0)') as $row)
    {
			$accid = (int) $row['accid'];
			$row['name'] = $this->GetUserName($accid);
      $result[] = $row;

    }
		$sortArray=array();
		foreach($result as $row){ 
			foreach($row as $key=>$value){ 
					if(!isset($sortArray[$key])){ 
							$sortArray[$key] = array(); 
					} 
					$sortArray[$key][] = $value; 
			} 
		} 

		array_multisort($sortArray['name'],SORT_ASC,$result);
    return $result;
	}
	
	function AddSchedule($name,$type,$day,$moving,$nextdate,$callcnt,$callperuser,$supervisor,$project,$qspec){
		$stmt = $this->db->prepare('insert into CESchedules '
		. ' (name,qspec,supervisor,project,callcnt,add_per_id,type,day,moving,nexttrigger) '
		. ' VALUES '
		. ' (:1       ,:2       ,:3      ,:4	,:5		,:6		,:7		,:8		,:9 , :10) '
		);
		$stmt->bindValue(1,$name);
		$stmt->bindValue(2,$qspec);
		$stmt->bindValue(3,$supervisor);
		$stmt->bindValue(4,$project);
		$stmt->bindValue(5,$callcnt);
		$stmt->bindValue(6,$callperuser);
		$stmt->bindValue(7,$type);
		$stmt->bindValue(8,$day);
		$stmt->bindValue(9,$moving);
		$stmt->bindValue(10,$nextdate);
		$stmt->execute();
		return $this->db->lastInsertId('Schedule_id_seq');
	}
	
	
	function EditSchedule($id, $name,$type,$day,$moving,$nextdate,$lasttrigger,$callcnt,$callperuser,$supervisor,$project,$qspec)
	{
    $sql = 'UPDATE CESchedules SET name=?, qspec=?, supervisor=?, project=?, callcnt=?, add_per_id=?, type=?, day=?, moving=?, nexttrigger=?, lasttrigger=? WHERE id=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
			$stmt->bindValue(1,$name);
			$stmt->bindValue(2,$qspec);
			$stmt->bindValue(3,$supervisor);
			$stmt->bindValue(4,$project);
			$stmt->bindValue(5,$callcnt);
			$stmt->bindValue(6,$callperuser);
			$stmt->bindValue(7,$type);
			$stmt->bindValue(8,$day);
			$stmt->bindValue(9,$moving);
			$stmt->bindValue(10,$nextdate);
			$stmt->bindValue(11,$lasttrigger);		
			$stmt->bindValue(12,$id);
			$res = $stmt->execute();
    }
    return true;
	}
	
	function DelSchedule($scheduleid)
	{  	
    $this->db->query('DELETE FROM CESchedules WHERE id='.$scheduleid);

    // verified above no calls, so no related data
		// $this->db->query('DELETE FROM CECalls WHERE projectid='.$prjid);

    return 0;
	}
	
	function GetSchedules($supervisor){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'SELECT * FROM CESchedules';
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql .= ' WHERE supervisor = ?';
			}
		}
		
		$sql.=' ORDER BY id';
		
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$stmt->execute(array($supervisor));
			}else{
				$stmt->execute();
			}
		}else{
			$stmt->execute();
		}
		
		
		$result = array();
		
		while ($row = $stmt->fetch()){
			$result[]=$row;
		}
		return $result;
	}
	
	function getAverageScoreForPeriod($accid,$prjid,$start,$end){		
		if($accid==-1&&$prjid==-1){
			$sql = 'SELECT A.score FROM CECalls A WHERE A.recordingid IN (select B.id FROM Calls B WHERE B.startdate >= ? AND B.startdate < ?) AND A.score IS NOT NULL';
		}else if($accid!=-1&&$prjid==-1){
			$sql = 'SELECT A.score FROM CECalls A WHERE A.recordingid IN (select B.id FROM Calls B WHERE B.startdate >= ? AND B.startdate < ?) AND A.score IS NOT NULL AND A.useraccid = ?';
		}else if($accid!=-1&&$prjid!=-1){
			$sql = 'SELECT A.score FROM CECalls A WHERE A.recordingid IN (select B.id FROM Calls B WHERE B.startdate >= ? AND B.startdate < ?) AND A.score IS NOT NULL AND A.useraccid = ? AND A.projectid = ?';
		}else if($accid==-1&&$prjid!=-1){
			$sql = 'SELECT A.score FROM CECalls A WHERE A.recordingid IN (select B.id FROM Calls B WHERE B.startdate >= ? AND B.startdate < ?) AND A.score IS NOT NULL AND A.projectid = ?';
		}
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
			$this->OnDbErr();
			return 0;
		}
		
		if($accid==-1&&$prjid==-1){
			$stmt->execute(array($start,$end));
		}else if($accid!=-1&&$prjid==-1){
			$stmt->execute(array($start,$end,$accid));
		}else if($accid!=-1&&$prjid!=-1){
			$stmt->execute(array($start,$end,$accid,$prjid));
		}else if($accid==-1&&$prjid!=-1){
			$stmt->execute(array($start,$end,$prjid));
		}
		
		$result = array();		
		
		$totalscores=0;
		$countscores=0;
		while ($row = $stmt->fetch()){			
			$totalscores+=$row[0];
			$countscores++;
		}
		
		if($totalscores>0&&$countscores>0){
			return $totalscores/$countscores;
		}else{
			return 0;
		}
		
		
	}
	
	
	function GetAgentCallCountPeriod($userid,$prjid,$startdate,$enddate){
		if($userid==-1&&$prjid==-1){
			$sql = 'SELECT count(A.id) FROM Calls A WHERE A.localcontact IN (select B.contactid FROM UserPhones B) AND A.startdate >= ? AND A.startdate < ?';
		}else if($userid!=-1&&$prjid==-1){
			$sql = 'SELECT count(A.id) FROM Calls A WHERE A.localcontact IN (select B.contactid FROM UserPhones B WHERE B.accid = ?) AND A.startdate >= ? AND A.startdate < ?';
		}else if($userid!=-1&&$prjid!=-1){
			$sql = 'SELECT count(A.id) FROM Calls A WHERE A.localcontact IN (select B.contactid FROM UserPhones B WHERE B.accid = ?) AND A.startdate >= ? AND A.startdate < ? AND A.id IN (select C.recordingid FROM CECalls C WHERE C.projectid = ?)';
		}else if($userid==-1&&$prjid!=-1){
			$sql = 'SELECT count(A.id) FROM Calls A WHERE A.localcontact IN (select B.contactid FROM UserPhones B) AND A.startdate >= ? AND A.startdate < ? AND A.id IN (select C.recordingid FROM CECalls C WHERE C.projectid = ?)';
		}

		$stmt = $this->db->prepare($sql);
		if (!$stmt){
			$this->OnDbErr();
			return false;
		}
				
		if($userid==-1&&$prjid==-1){
			$stmt->execute(array($startdate,$enddate));
		}else if($userid!=-1&&$prjid==-1){
			$stmt->execute(array($userid,$startdate,$enddate));
		}else if($userid!=-1&&$prjid!=-1){
			$stmt->execute(array($userid,$startdate,$enddate,$prjid));
		}else if($userid==-1&&$prjid!=-1){
			$stmt->execute(array($startdate,$enddate,$prjid));
		}
		
		
		$result = array();
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		return 0;
	
	}
	
	function GetAgentEvalCount($id,$project){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql="SELECT count(A.id) FROM CECalls A WHERE A.useraccid = ? AND A.score IS NOT NULL ";
		
		if($project!=-1){
			$sql .= 'AND A.projectid = ? ';
		}
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql .= 'AND A.supervisor=? ';
			}
		}
	
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
			$this->OnDbErr();
			return false;
		}
		
		$parameters=array($id);			
		
		if($project!=-1){
			array_push($parameters, $project);
		}		
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				array_push($parameters, $actuinfo['accid']);
			}
		}
		
		$stmt->execute($parameters);
		
		$result = array();
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		return 0;
	}
	
	function GetAgentAverageScore($supervisor,$id,$project){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'SELECT A.score FROM CECalls A WHERE A.useraccid = ? AND A.score IS NOT NULL';
		
		$parameters=array($id);
		
		if($project!=-1){
			$sql .= ' AND projectid = ? ';
			array_push($parameters, $project);
		}		
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql.=" AND supervisor=?";
				array_push($parameters, $supervisor);
			}
		}
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
			$this->OnDbErr();
			return false;
		}

		$stmt->execute($parameters);
		
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql.=" AND supervisor=?";
			}
		}
		
		$result = array();
		$total = 0;
		$count = 0;
		while($row = $stmt->fetch()){
			$count++;
			$total+=$row[0];
		}
		if($total==0||$count==0){
			return 0;
		}else{
			return($total/$count);
		}
		
	}
	
	function GetAgentCallCount($id){
		$sql = 'SELECT count(A.id) FROM Calls A WHERE A.localcontact IN (select B.contactid FROM UserPhones B WHERE B.accid = ?)';
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
			$this->OnDbErr();
			return false;
		}
		
		$stmt->execute(array($id));
		$result = array();
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		return 0;
	}
	
	function GetProjectINCompleteEvalCount($supervisor, $agent, $id){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'SELECT COUNT(id) FROM CECalls WHERE score IS NULL AND projectid=?';
		
		$parameters=array($id);
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql.=" AND supervisor=?";
				array_push($parameters, $supervisor);
			}
		}
		
		if($agent!=-1){
			$sql.=" AND useraccid=?";
			array_push($parameters, $agent);
		}else{
			$sql.=" AND useraccid IS NOT NULL";
		}
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
			
		$stmt->execute($parameters);

		$result = array();
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		return 0;
	
	}
	
	function GetProjectCompleteEvalCount($supervisor, $agent, $id){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'SELECT COUNT(id) FROM CECalls WHERE score IS NOT NULL AND projectid=?';
		
		$parameters=array($id);
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql.=" AND supervisor=?";
				array_push($parameters, $supervisor);
			}
		}
		
		if($agent!=-1){
			$sql.=" AND useraccid=?";
			array_push($parameters, $agent);
		}
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}
		
		$stmt->execute($parameters);
		
		$result = array();
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		return 0;
	
	}
	
	function GetUnscoredProjectCalls($supervisor, $agent, $id){
		//$ref_project['callcnt'] = $this->db->query('SELECT COUNT(id) FROM CECalls WHERE projectid='.$id)->fetchColumn(0);
		//$ref_project['evalcnt'] = $this->db->query('SELECT COUNT(id) FROM CECalls WHERE projectid='.$id.' AND score IS NOT NULL')->fetchColumn(0);
		$sql = 'SELECT * FROM CECalls WHERE score IS NULL';
		
		$parameters=array();
		
		if($id!=-1){
			$sql.=" AND projectid=?";
			array_push($parameters, $id);
		}
		
		
		if(CheckCePm(PM_CE_SUPERVISOR)){
			if(!CheckCePm(PM_CE_MANAGE)){
				$sql.=" AND supervisor=?";
				array_push($parameters, $supervisor);
			}
		}
		
		if($agent!=-1){
			$sql.=" AND useraccid=?";
			array_push($parameters, $agent);
		}
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}

		$stmt->execute($parameters);
		$result = array();
		while ($row = $stmt->fetch(PDO::FETCH_ASSOC)){
			$row['projectname'] = $this->db->query('SELECT name FROM CEProjects WHERE id='.$row['projectid'])->fetchColumn(0);
			if($row['useraccid']!=null){
				$row['username'] = $this->db->query('SELECT name FROM Users WHERE accid='.$row['useraccid'])->fetchColumn(0);
			}else{
				$row['username'] = "";
			}
			$row['startdate'] = $this->db->query('SELECT startdate FROM Calls WHERE id='.$row['recordingid'])->fetchColumn(0);
			$result[] = $row;
		}
		return $result;
	}
	
	function isCallInProject($supervisorid, $callid, $projectid){
		$sql = 'SELECT count(id) FROM CECalls WHERE recordingid=? AND supervisor=? AND projectid=?';
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return 0;
		}
		
		$stmt->execute(array($callid,$supervisorid,$projectid));
		$result = array();
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		return 0;		
	}
	
	function getUserName($id){
		if($id==null)return "";
		
		$sql = 'SELECT name FROM Users WHERE accid = ?';				
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}

		$stmt->execute(array($id));		
		$result = array();
		
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		
		return "";
	}
	
	function getUserLogin($id){
		if($id==null)return "";
		
		$sql = 'SELECT usr FROM Users WHERE accid = ?';				
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}

		$stmt->execute(array($id));
		$result = array();
		
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		
		return "";
	}
	
	function GetProjectName($id){
		$sql = 'SELECT name FROM CEProjects WHERE id = ?';				
		
		$stmt = $this->db->prepare($sql);
		if (!$stmt){
		  $this->OnDbErr();
		  return false;
		}

		$stmt->execute(array($id));		
		$result = array();
		
		if ($row = $stmt->fetch()){
			return $row[0];
		}
		
		return "";
	}	



	// Projects

	function GetProjects()
	{
    $result = array();
    foreach ($this->db->query('SELECT * FROM CEProjects ORDER BY name') as $row)
    {
			$formid = (int) $row['formid'];
			$row['formname'] = $this->db->query('SELECT name FROM CEForms WHERE id='.$formid)->fetchColumn(0);
      $result[] = $row;
    }
    return $result;

	}

	function GetProject($id)
	{
		$prjid = (int) $id;
    return $this->db->query('SELECT * FROM CEProjects WHERE id='.$prjid)->fetch(PDO::FETCH_ASSOC);
	}

	function IsFormUsedByProject($formid)
	{
		$formid = (int) $formid;
    $res = $this->db->query('SELECT COUNT(id) FROM CEProjects WHERE formid='.$formid)->fetch();
    return $res[0]!=0;
	}

	function EditProject($prjid,$name)
	{
    $sql = 'UPDATE CEProjects SET name=? WHERE id=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
      $stmt->bindValue(1,$name);
      $stmt->bindValue(2,$prjid);
      $res = $stmt->execute();
    }
    return true;
	}

	function DelProject($prjid)
	{
  	$prjid = (int) $prjid;

  	$calls = $this->GetProjectCalls($prjid);
  	if (count($calls)>0) return 1;
  	
    $this->db->query('DELETE FROM CEProjects WHERE id='.$prjid);

    // verified above no calls, so no related data
		// $this->db->query('DELETE FROM CECalls WHERE projectid='.$prjid);

    return 0;
	}

	function AddProject($name,$formid)
	{

    $sql = 'INSERT INTO CEProjects(name,formid) VALUES (?,?) ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    } else {
      $stmt->bindValue(1,$name);
      $stmt->bindValue(2,$formid);
      $res = $stmt->execute();
      return $this->db->lastInsertId('CEProjects_id_seq');
    }

	}

	function RemoveCeCall($ceid)
	{
    $sql = 'DELETE FROM CECalls WHERE id=? ';
    $stmtDel = $this->db->prepare($sql);
    if (!$stmtDel) $this->OnDbErr();

    $sql = 'DELETE FROM CEAnswers WHERE callid=? ';
    $stmtDel2 = $this->db->prepare($sql);
    if (!$stmtDel2) $this->OnDbErr();

    // remove it
    $stmtDel->bindValue(1,(int) $ceid);
    $res = $stmtDel->execute();

    $stmtDel2->bindValue(1,(int) $ceid);
    $res = $stmtDel2->execute();
	}
	
	function RemoveAllCallsFromProject($prjid)
	{
		//$this->dbintf->StartTransaction();

		$removed = 0;

    $sql = 'DELETE FROM CECalls WHERE id=? ';
    $stmtDel = $this->db->prepare($sql);
    if (!$stmtDel)
    {
      $this->OnDbErr();
      return null;
    }

    $sql = 'DELETE FROM CEAnswers WHERE callid=? ';
    $stmtDel2 = $this->db->prepare($sql);
    if (!$stmtDel2)
    {
      $this->OnDbErr();
      return null;
    }

    $sql = 'SELECT id FROM CECalls WHERE projectid=?';
    $stmtCheck = $this->db->prepare($sql);
    if (!$stmtCheck)
    {
      $this->OnDbErr();
      return null;
    }
    
		$stmtCheck->bindValue(1,(int) $prjid);
	  $stmtCheck->execute();
		$res=$stmtCheck->fetch();
		
	  while($res != false){			
			$ceid = $res[0];

			// remove it
			$stmtDel->bindValue(1,(int) $ceid);
			$res = $stmtDel->execute();
			$stmtDel2->bindValue(1,(int) $ceid);
			$res = $stmtDel2->execute();

			$removed ++;
			$res=$stmtCheck->fetch();

		}

		//$this->dbintf->CommitTransaction();
	}

	function AddCallsToProject($supervisor,$prjid,$recids)
	{
		$already = 0;
		$added = 0;

    $sql = 'INSERT INTO CECalls(recordingid,projectid,status,answercnt,useraccid,supervisor)'
			.	' VALUES (?,?,?,?,?,?) ';
    $stmtAdd = $this->db->prepare($sql);
    if (!$stmtAdd)
    {
      $this->OnDbErr();
      return null;
    }

    $sql = 'SELECT id FROM CECalls WHERE recordingid=? AND supervisor=? AND projectid=?';
    $stmtCheck = $this->db->prepare($sql);
    if (!$stmtCheck)
    {
      $this->OnDbErr();
      return null;
    }

		foreach ($recids as $recid)
		{

			// check if already part of a project
			$stmtCheck->bindValue(1,(int) $recid[0]);
			$stmtCheck->bindValue(2,(int) $supervisor);
			$stmtCheck->bindValue(3,(int) $prjid);
	    if ($stmtCheck->execute()==false)
      {
        $this->OnDbErr();
      }
	    if ($stmtCheck->fetch()!==FALSE){
				$already++;
				//echo($recid."/".$supervisor."/".$prjid." : "."Call Already In DB?????<br>");
				continue;
			}

			//$users = $this->dbintf->GetUsersOfCall($this->dbintf->GetCallInfo($recid),true);

			// add it
			$stmtAdd->bindValue(1,(int) $recid[0]);
			$stmtAdd->bindValue(2,(int) $prjid);
			$stmtAdd->bindValue(3,0);
			$stmtAdd->bindValue(4,0);
			$stmtAdd->bindValue(5,$recid[1]);
			$stmtAdd->bindValue(6,$supervisor);
			if ($stmtAdd->execute()==false)
			{
				$this->OnDbErr();
			}
	
			$added ++;

		}

    return array( 'added'=>$added, 'already'=>$already );
	}


	function GetEvaluatedCalls()
	{
		$actuinfo = $this->dbintf->GetActiveUserInfo();
    $sql = 'SELECT * FROM CECalls WHERE score IS NOT NULL';
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql .= ' AND supervisor=?';
			}
		}	
		
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    }
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$stmt->execute(array($actuinfo['accid']));
			}else{
				$stmt->execute();
			}
		}else{
			$stmt->execute();
		}
		
		$result = array();
		while ($row = $stmt->fetch(PDO::FETCH_ASSOC))
		{
			$result[] = $row;
		}
		return $result;
	}

	function GetProjectCallCount($id)
	{
    $sql = 'SELECT COUNT(id) FROM CECalls WHERE projectid=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    }
		$stmt->execute(array($id));
		$result = array();
		if ($row = $stmt->fetch())
		{
			return $row[0];
		}
		return 0;
	}
	
	function GetActiveCalls(){
		global $dbintf, $configs;
  
		$now = time();
		$calls = $dbintf->GetLiveCalls();
		if ($calls===false)
		{
			return;
		}
		
		$result=[];
		foreach ($calls as &$call_ref)
		{
			$call_ref['initage'] = $now - $call_ref['inittime'];
			$endwait = $now;
			$endring = $now;
			if ($call_ref['connecttime']!=null)
			{
				$endwait = $call_ref['connecttime'];
				$endring = $call_ref['connecttime'];
				$call_ref['conlen'] = $now - $call_ref['connecttime'];
			}
			$call_ref['waitlen'] = $endwait - $call_ref['inittime'];
			if ($call_ref['ringtime']!=null)
			{
				$call_ref['ringlen'] = $endring - $call_ref['ringtime'];
			}else{
				$call_ref['ringlen']="";
			}
			$call_ref['inittime'] = date($configs['datetimef'],$call_ref['inittime']);
			
			$callstore[0] = $call_ref['inittime'];
			$callstore[1] = $call_ref['waitlen'];
			$callstore[2] = $call_ref['ringlen'];
			$callstore[3] = $call_ref['conlen'];
			$callstore[4] = $call_ref['callstatus'];
			$callstore[5] = $call_ref['recreason'];
			$callstore[6] = $call_ref['protocol'];
			$callstore[7] = $call_ref['direction'];
			$callstore[8] = $call_ref['remote'];
			$callstore[9] = $call_ref['local'];
			
			$result[]=$callstore;
		}
		
		return $result;
	
	}
	

	function GetProjectCalls($id)
	{
		$actuinfo = $this->dbintf->GetActiveUserInfo();
    $sql = 'SELECT * FROM CECalls WHERE projectid=?';
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$sql.=" AND supervisor=?";
			}
		}
		
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    }
		
		if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
			if(CheckCePm(PM_CE_MANAGE)==false){
				$stmt->execute(array($id,$actuinfo['accid']));
			}else{
				$stmt->execute(array($id));
			}
		}else{
			$stmt->execute(array($id));
		}
		
		$result = array();
		while ($row = $stmt->fetch(PDO::FETCH_ASSOC))
		{
			$result[] = $row;
		}
		return $result;
	}

	// Evaluation
	function GetCeCall($id)
	{
    $sql = 'SELECT * FROM CECalls WHERE id=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt) $this->OnDbErr();
    $stmt->execute(array($id));
		return $stmt->fetch(PDO::FETCH_ASSOC);
	}
  
	function GetEvaluation($id)
	{
    $sql = 'SELECT * FROM CECalls WHERE id=?';		
		
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }	
		
		$stmt->execute(array($id));
		
		return $stmt->fetch(PDO::FETCH_ASSOC);
	}
	
	function GetEvaluationOnPrjAndCallAndSupervisor($prjid, $callid,$superid)
	{
    $sql = 'SELECT * FROM CECalls WHERE recordingid=? AND projectid=? AND supervisor=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
		$stmt->execute(array($callid,$prjid,$superid));
		return $stmt->fetch(PDO::FETCH_ASSOC);
	}

	function GetEvaluationOnPrjAndCall($prjid, $callid)
	{
    $sql = 'SELECT * FROM CECalls WHERE recordingid=? AND projectid=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
		$stmt->execute(array($callid,$prjid));
		return $stmt->fetch(PDO::FETCH_ASSOC);
	}

  function SetEvaluated($useraccid)
  {
    $sql = 'UPDATE Users SET evaluated=1 WHERE accid=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
    $stmt->execute(array($useraccid));
  }
  
	function SetEvaluatedAgent($id,$useraccid)
	{
    $sql = 'UPDATE CECalls SET useraccid=? WHERE id=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
    $stmt->execute(array($useraccid,$id));

    $sql = 'UPDATE Users SET evaluated=1 WHERE accid=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
    $stmt->execute(array($useraccid));

	}
  
  function IsCallInAgEval($recordingid)
  {
    $sql = 'select count(id) from cecalls where recordingid=?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt) $this->OnDbErr();
    $stmt->bindValue(1,$recordingid);    
    $stmt->execute();
    $row = $stmt->fetch();
    return ($row[0]!=0);
  }

	function GetEvaluationAnswers($id)
	{
    $sql = 'SELECT * FROM CEAnswers WHERE callid=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
		$stmt->execute(array($id));
		$result = array();
		while ($row = $stmt->fetch(PDO::FETCH_ASSOC))
		{
			$result[] = $row;
		}
		return $result;
	}

	function UpdateScore($id,$score)
	{
    $sql = 'UPDATE CECalls SET score=?, datescored=? WHERE id=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
    $stmt->execute(array($score,time(),$id));
	}

	function StoreAnswers($id,$answers,$notes,$score)
	{
		$id = (int) $id;
    $this->db->query('DELETE FROM CEAnswers WHERE callid='.$id);

    $sql = 'INSERT INTO CEAnswers(callid,qid,answer,notes) VALUES (?,?,?,?) ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return;
    }
		foreach ($answers as $qid=>$answer)
		{
			$note = '';
			if (isset($notes[$qid]))
			{
				$note = $notes[$qid];
			}
      $stmt->execute(array($id,$qid,$answer,$note));
		}
		// update score
    $sql = 'UPDATE CECalls SET score=?, datescored=? WHERE id=? ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return null;
    }
    $stmt->execute(array($score,time(),$id));
	}


	// Placed here for reuse, not really db

	function Recalc($formid)
	{
		// procedure
		// - find all projects that use this form
		// - find all calls of those projects
		// - for each of these calls
		//   - find all answers
		//   - calculate and set score

		//echo '<pre>';

		$this->dbintf->StartTransaction();
		// - find all projects that use this form
		$prjlist = $this->GetProjects();
		$calls = array();
		foreach($prjlist as $prj)
		{
    	if ($prj['formid']==$formid)
    	{
     		// - find all calls of those projects
				$prjcalls = $this->GetProjectCalls($prj['id']);
				$calls = array_merge($calls,$prjcalls);
			}
		}

		// we have now a list of calls

		// load information about the form
  	$evalform = $this->GetForm($formid);
		$answertypes = $this->GetAnswerTypes();
		// for a strange reason we must use a separate variable name here
		// probably because it then becomes a reference *everywhere*
		foreach($answertypes as &$answertyperef)
		{
			if ($answertyperef['type']==1)
			{
	  		$answertyperef['obj'] = $this->ParseAnswerDescription($answertyperef['description']);
	  		//echo $answertyperef['obj'][0]['text'];
	  		$answertyperef['best'] = $this->GetScoreBestAnswer($answertyperef);
	  		$answertyperef['worst'] = $this->GetScoreWorstAnswer($answertyperef);
	  	}
		}
		//echo "\r\n";
	  $answermap = array();
		foreach($answertypes as $answertype)
		{
			$answermap[$answertype['id']] = $answertype;
		}

		// - for each of these calls
		foreach ($calls as $call)
		{
    	//echo $call['id'] . "\r\n";

    	$eval = $this->GetEvaluation($call['id']);
    	//echo $eval['score'] . "\r\n";

			//   - find all answers
			$answers = $this->GetEvaluationAnswers($call['id']);
			//echo count($answers) . ' ' . $eval['score'] . "\r\n";

			$complete = true;
			$weight = 0;
			$calcscore = 0;
			//   - calculate and set score
			foreach($evalform['questions'] as $question)
			{
				if ($question['atypeid']==-1) continue;

				$answertype = $answermap[ $question['atypeid'] ];
				//var_dump($answertype);
				//echo $answertype['obj']['best'];
				//exit;

				//echo $question['id'];
				$found = false;
				foreach ($answers as $answer)
				{
					if ($answer['qid']==$question['id'])
					{
						if ($answer['answer']==-1)
						{
							// not answered yet
							continue;
						}
						//echo ' A' . $answer['answer'];
						$found = true;
						
						if ($answer['answer']==-2)
						{
							// Not applicable
							continue;
						}

						$subscore = $question['weight'] * ($answertype['obj'][ $answer['answer'] ]['score']-$answertype['worst']) / ($answertype['best']-$answertype['worst']);

						//echo ' ' . $subscore;

						$calcscore += $subscore;
						$weight += $question['weight'];

						break;
					}
				}
				if ($found==false)
				{
					//echo "NF";
					$complete = false;
				}
			}
			$score = null;
			if ($complete && $weight>0)
			{
				//echo " complete ";
				$score = 100.0 * $calcscore / $weight;
				//echo $score;
			} else
			{
				//echo " incomplete ";
				$score = null;
			}
			//echo ' W:' . $weight;
			//echo "\r\n";

  		$this->UpdateScore($call['id'],$score);

		}
    $this->dbintf->CommitTransaction();
	}

	function ParseAnswerDescription($descr)
	{
		// format is Good=2\Avg.=1\Poor=0
	  $ret = array();
		$answers = explode('\\',$descr);
		foreach ($answers as $answer)
		{
			$parts = explode('=',$answer);
			$answerinfo = array();
			if (count($parts)==2)
			{
				$answerinfo['text'] = $parts[0];
				$answerinfo['score'] = $parts[1];
			}
			$ret[] = $answerinfo;
		}
		return $ret;
	}

	function GetScoreWorstAnswer($answer)
	{
		if (count($answer['obj'])==0) return -1;
		$ret = null;
		foreach ($answer['obj'] as $opt)
		{
	  	if ($ret===null)
	  	{
				$ret = $opt['score'];
			} else
			{
				if ($opt['score']<$ret)
				{
					$ret = $opt['score'];
				}
			}
		}
		return $ret;
	}

	function GetScoreBestAnswer($answer)
	{
		if (count($answer['obj'])==0) return -1;
		$ret = null;
		foreach ($answer['obj'] as $opt)
		{
	  	if ($ret===null)
	  	{
				$ret = $opt['score'];
			} else
			{
				if ($opt['score']>$ret)
				{
					$ret = $opt['score'];
				}
			}
		}
		return $ret;
	}
	
	function clearLiveDashboardOrder(){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'DELETE FROM dashboard_order WHERE usr = ?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
			$stmt->bindValue(1,$actuinfo['accid']);
      $res = $stmt->execute();
    }
		return true;
		
	}
	
	function clearLiveDashboardSettings(){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'DELETE FROM dashboard_settings WHERE usr = ?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
			$stmt->bindValue(1,$actuinfo['accid']);
      $res = $stmt->execute();
    }
		return true;
		
	}
	
	function clearLiveDashboardWeekAverage(){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'DELETE FROM dashboard_week_average WHERE usr = ?';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
			$stmt->bindValue(1,$actuinfo['accid']);
      $res = $stmt->execute();
    }
		return true;
		
	}
	
	function setLiveDashboardWeekAverage($averageString){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'INSERT INTO dashboard_week_average (usr,date_updated,average_array) VALUES (?,?,?) ';
    $stmt = $this->db->prepare($sql);
		
    if (!$stmt){
      $this->OnDbErr();
      return false;
			
    } else {
      $stmt->bindValue(1,$actuinfo['accid']);
      $stmt->bindValue(2,time());
			$stmt->bindValue(3,$averageString);
      $stmt->execute();
			
    }
		return true;
	}
	
	function getLiveDashboardWeekAverage(){
		$result = array();
		$actuinfo = $this->dbintf->GetActiveUserInfo();

		foreach ($this->db->query('SELECT * FROM dashboard_week_average WHERE usr = '.$actuinfo["accid"]) as $row){
			return $row;
		}		
		
    return NULL;
	}
	
	function addLiveDashboardOrder($order, $tile){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'INSERT INTO dashboard_order (location,usr,tile) VALUES (?,?,?) ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
			
    } else {
      $stmt->bindValue(1,$order);
      $stmt->bindValue(2,$actuinfo['accid']);
			$stmt->bindValue(3,$tile);
      $stmt->execute();
			
    }
		return true;

	}
	
	function addLiveDashboardSetting($setting, $value){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$sql = 'INSERT INTO dashboard_settings (value,clm,usr) VALUES(?,?,?) ';
    $stmt = $this->db->prepare($sql);
    if (!$stmt)
    {
      $this->OnDbErr();
      return false;
    } else {
			
      $stmt->bindValue(1,(int) $value);
      $stmt->bindValue(2,(int) $setting);
      $stmt->bindValue(3,(int) $actuinfo['accid']);
      if($stmt->execute()==false)
			{
				$this->OnDbErr();
			}
    }
		return true;
		
	}
	
	function getLiveDashboardOrder(){
		$result = array();
		$actuinfo = $this->dbintf->GetActiveUserInfo();

		foreach ($this->db->query('SELECT * FROM dashboard_order WHERE usr = '.$actuinfo["accid"].' ORDER BY location') as $row){
			$result[] = $row;
		}
		
		
    return $result;
		
	}
	
	function getLiveDashboardSetting($setting){
		$actuinfo = $this->dbintf->GetActiveUserInfo();
		$result=$this->db->query('SELECT value FROM dashboard_settings WHERE clm = '.$setting.' AND usr = '.$actuinfo["accid"]);
		if($value=$result->fetchColumn(0)){
			return $value;
			
		}else{
			return -1;
		}		
	}
	
	function getCallsPerHourAvg(){

		$savedAverage=$this->getLiveDashboardWeekAverage();
		
		$averageCounter=array();
		if($savedAverage[1]<strtotime('today')){	
			$listconfig=array();
			$listconfig["allrecords"]=true;
			
			$search=array();
		
			$search['fd']=strtotime('-2 week');
			
			$sk="startdate";
			
			
			
			$calls = $this->dbintf->GetCallList($sk,0,$search,$listconfig);
			
			foreach ($calls as $call){			
				if($call["startdate"]>1){
					$averageCounter[date('G', $call["startdate"])]+=1;
				}
			}
			$stringVersion="";
			for($i=0; $i<24; $i++) {
				$value=$averageCounter[$i];
				if($value!=NULL){
					$averageCounter[$i]=ceil($value/14);
				}else{
					$averageCounter[$i]=0;
				}
				if($i>0){
					$stringVersion.=",";
				}
				$stringVersion.=strval($averageCounter[$i]);
			}
			
			$this->clearLiveDashboardWeekAverage();
			$this->setLiveDashboardWeekAverage($stringVersion);
		}else{
			$averageCounter=explode(",",$savedAverage[2]);
		}
		return [$averageCounter[0],$averageCounter[1],$averageCounter[2],$averageCounter[3],$averageCounter[4],$averageCounter[5],$averageCounter[6],$averageCounter[7],$averageCounter[8],$averageCounter[9],$averageCounter[10],$averageCounter[11],$averageCounter[12],$averageCounter[13],$averageCounter[14],$averageCounter[15],$averageCounter[16],$averageCounter[17],$averageCounter[18],$averageCounter[19],$averageCounter[20],$averageCounter[21],$averageCounter[22],$averageCounter[23]];
	}
	
	function getActiveCallCount(){
		return count($this->dbintf->GetActiveCallList());
	}

	function getWaitingCallCount(){
		$calls = $this->dbintf->GetActiveCallList();
		
		$counter=0;
		
		foreach ($calls as $call){
			if($call["isconnected"]==0){
				$counter += 1;
			}
		}
		
		//count($this->dbintf->GetCallList("startdate",0,$search,$listconfig));
		return $counter;
		
	}
	
	function getActiveInboundCallCount(){
		$calls = $this->dbintf->GetActiveCallList();
		
		$counter=0;
		
		foreach ($calls as $call){
			if($call["direction"]==0){
				$counter += 1;
			}
		}
		
		//count($this->dbintf->GetCallList("startdate",0,$search,$listconfig));
		return $counter;
	}
	
	function getTotalInboundCallCount(){
    $listconfig=array();
		$listconfig["allrecords"]=true;
		
		$search=array();
	
		$search["dir"]="0";
		$search['fd']=strtotime('today');
		
		$sk="startdate";
		
		$count=$this->dbintf->GetCallList($sk,0,$search,$listconfig)["cnt"];
		return $count;
	}
	
	function getActiveInboundCalls(){
		$calls = $this->dbintf->GetActiveCallList();
		
		$result=array();
		
		foreach ($calls as $call){
			if($call["direction"]==0){
				$result[]=$call;
			}
		}
		return $result;
	}
	
	function getActiveOutboundCallCount(){
		$calls = $this->dbintf->GetActiveCallList();
		
		$counter=0;
		
		foreach ($calls as $call){
			if($call["direction"]==1){
				$counter += 1;
			}
		}
		
		//count($this->dbintf->GetCallList("startdate",0,$search,$listconfig));
		return $counter;
	}
	
	function getTotalOutboundCallCount(){
		$listconfig=array();
		$listconfig["allrecords"]=true;
		
		$search=array();
		$search["dir"]="1";
		$search["fd"]=strtotime('today');
		$sk="startdate";
		
		$counter=0;
		
		$calls = $this->dbintf->GetCallList($sk,0,$search,$listconfig);
		
		foreach ($calls as $call){
			if($call["isconnected"]==1){
				$counter += 1;
			}
		}
		
		return $counter;
		
	}
	
	function getActiveOutboundCalls(){
		$calls = $this->dbintf->GetActiveCallList();
		
		$result=array();
		
		foreach ($calls as $call){
			if($call["direction"]==1){
				$result[]=$call;
			}
		}
		return $result;
		
	}
	
	function getLastMissedExtensions($amount){
		global $configs;
		$listconfig=array();
		$listconfig["allrecords"]=true;
		
		$search=array();
		$search["dir"]=0;
		$search["fd"]=strtotime('today');
		$sk="startdate";
		
		$calls = $this->dbintf->GetCallList($sk,1,$search,$listconfig);
		
		$result=array();
		if($calls["cnt"]>0){
			foreach ($calls as $call){
				if(isset($call['local']) && $call['isconnected']==0){
					$row[0]=$call['local'];
			
					$row[1]="Missed Incoming";			
			
					$row[2]=date($configs['datetimef'], $call['startdate']);
					$result[] = $row;
					
					if(count($result)>=$amount){
						return $result;		
					}
				}
			}
		}
		return $result;
	}
	
	function getMissedCallCount(){
		$listconfig=array();
		$listconfig["allrecords"]=true;
		
		$search=array();
		$search["dir"]="0";
		$search["fd"]=strtotime('today');
		$sk="startdate";
		$calls = $this->dbintf->GetCallList($sk,0,$search,$listconfig);
		
		$counter=0;
		
		foreach ($calls as $call){
			if(isset($call['local']) && $call['isconnected']==0){
				$counter += 1;
			}
		}

		return $counter;
		
	}
	
	function getAverageWaitTime(){
		$listconfig=array();
		$listconfig["allrecords"]=true;
		
		$search=array();
		$search["dir"]="0";
		$search["fd"]=strtotime('today');
		$sk="startdate";
		
		$calls = $this->dbintf->GetCallList($sk,0,$search,$listconfig);
		
		$totalwait=0;
		$counter=0;
		
		foreach ($calls as $call){
			if($call["direction"]==0 && $call["waittime"]!=-1){
				$totalwait+=$call["waittime"];
				$counter++;
			}
		}
		return round($totalwait/$counter);
		
	}
	
	function getLastExtensions($direction, $amount){
		global $configs;
		$listconfig=array();
		$listconfig["allrecords"]=true;
		
		$search=array();
		$search["dir"]=$direction;
		$search["fd"]=strtotime('today');
		$sk="startdate";
		
		$calls = $this->dbintf->GetCallList($sk,'desc',$search,$listconfig);
		
		$result=array();
		if($calls["cnt"]>0){
			foreach ($calls as $call){
				if(isset($call['local']) && $call['isconnected']!=0){														
					if($call['lname']!=""){
						$row[0]=$call['lname'];
					}else{
						$row[0]=$call['local'];
					}
					
					switch($direction){
						case 0;
							$row[1]="Incoming";
							break;
						case 1;
							$row[1]="Outgoing";
							break;
						case 2;
							$row[1]="Internal";
							break;
						case 3;
							$row[1]="External";
							break;
						case -1;
							$row[1]="Unknown";
							break;				
					}
					
					$row[2]=date($configs['datetimef'], $call['startdate']);
					$result[] = $row;
					
					if(count($result)>=$amount){
						return $result;		
					}
				}
			}
		}
		return $result;		
	}
}

class CE_Stats
{
	var $cedb;
	
	// filter
	var $prjid = -1, $formid = -1, $filterusr = -1;
	
	// output
	var $user_list;
	var $questions; 
	var $total;
	var $perq;

  var $projects;
  var $projectform;
  var $projectmap;
  var $scoremap;
  var $answertypes;
  var $usermap;
  var $questionpos;
  var $qscoremap;
	
	function __construct($cedb)
	{
		$this->cedb = $cedb;
	}
	
	function Load()
	{
		// - Load Projects
		// - Load AnswerTypes
		// - Load Form with Questions
		// - Load Users

		$this->perq = false;
		if ($this->formid!=-1)
		{
			$this->perq = true;
		}
	
		$this->projects = $this->cedb->GetProjects();
		$this->projectform = array();
		$this->projectmap = array();
		foreach ($this->projects as &$ref_project)
		{
			$this->projectform[ $ref_project['id' ] ] = $ref_project['formid'];
			$this->projectmap[ $ref_project['id' ] ] = & $ref_project;
		}
	
		$this->scoremap = array();
		$this->answertypes = $this->cedb->GetAnswerTypes();
		foreach($this->answertypes as &$answertyperef)
		{
			if ($answertyperef['type']==1)
			{
				$answertyperef['obj'] = $this->cedb->ParseAnswerDescription($answertyperef['description']);
				$best = $this->cedb->GetScoreBestAnswer($answertyperef);
				$worst = $this->cedb->GetScoreWorstAnswer($answertyperef);
				$subscoremap = array();
				$ix = 0;
				foreach ($answertyperef['obj'] as $opt)
				{
					if ($best==$worst) $subscoremap[ $ix ] = 100.0;
					else $subscoremap[ $ix ] = 100.0 * ($opt['score']-$worst) / ($best-$worst);
					$ix ++;
				}
				$this->scoremap[ $answertyperef['id'] ] = $subscoremap;
			}
		}

		if ($this->formid!=-1)
		{
			$theformdata = $this->cedb->GetForm($this->formid);
			if ($theformdata['form']==null)
			{
				// should never happen
				return false;
			}
			$theform = $theformdata['form'];
			$this->questions = $theformdata['questions'];
			$this->questionpos = array();
			$this->qscoremap = array();
			$hdrix = -1;
			// find out to which section a question belongs (if any)
			for ($qix=0;$qix<count($this->questions);$qix++)
			{
				if ($this->questions[$qix]['atypeid']==-1)
				{
					$hdrix = $qix;
				} else
				{
					$this->questions[$qix]['hdrix'] = $hdrix;
				}
			}
			// store position of question
			// store score map per question
			$ix = 0;
			foreach ($this->questions as &$ref_question)
			{
				$this->questionpos[ $ref_question['id'] ] = $ix;
				$this->qscoremap[ $ref_question['id'] ] = &$this->scoremap[ $ref_question['atypeid'] ];
				$ix ++;
			}
		}
	
		$this->user_list = $this->cedb->dbintf->GetUserList();
    
    $nouser = array();
    $nouser['accid'] = NULL;
    $nouser['name'] = '??';
    $nouser['id'] = NULL;
    $this->user_list[] = $nouser;
    
		$this->usermap = array();
		foreach ($this->user_list as &$ref_user)
		{
			$ref_user['evalcnt'] = 0;
			$ref_user['scoretot'] = 0;
			$ref_user['scores'] = array();
			$ref_user['scoresw'] = array();
			$this->usermap[ $ref_user['accid'] ] = &$ref_user;
		}
		
	}
	
	function Calculate()
	{
		// Structure:
		// - Load
		// - Walk through EvaluatedCalls
		// - Totalize and average
	
		$this->Load();
	
		$calls = $this->cedb->GetEvaluatedCalls();
		foreach ($calls as $call)
		{
			if ($this->formid!=-1)
			{
				if ($this->projectform[$call['projectid']]!=$this->formid)
				{
					// skip this one
					continue;
				}
			}
			$projectid = $call['projectid'];
			if ($this->prjid!=-1)
			{
				if ($projectid != $this->prjid)
				{
					// skip this one
					continue;
				}
			}
			$useraccid = $call['useraccid'];
			$ref_user = & $this->usermap[$useraccid];

			if ($this->filterusr!=-1)
			{
				if ($this->filterusr != $useraccid)
				{
					continue;
				}
			}
			$ref_project = & $this->projectmap[ $projectid ];


			$tohandle = array();
			$tohandle[] = & $ref_user;
			$tohandle[] = & $ref_project;

      foreach($tohandle as & $ref_handle)
      {
        $ref_handle['evalcnt'] = 0;
        $ref_handle['scoretot'] = 0;
        $ref_handle['scores'] = array();
        $ref_handle['scoresw'] = array();
      }

			foreach ($tohandle as & $ref_handle)
			{
				$ref_handle['evalcnt'] ++;
				$ref_handle['scoretot'] += $call['score'];
			}
			
			if ($this->perq)
			{
				$answers = $this->cedb->GetEvaluationAnswers($call['id']);
				foreach ($answers as $answer)
				{
					if ($answer['answer']==-2) continue;
					$qix = $this->questionpos[ $answer['qid'] ];
					$subscore = $this->qscoremap[ $answer['qid'] ][ $answer['answer'] ];
					//echo $subscore . ' for q ' . $qix . "\r\n";
					$weight = $this->questions[$qix]['weight'];

					foreach ($tohandle as & $ref_handle)
					{
						$ref_handle['scores'][ $qix ] = int_ensure_defined($ref_handle['scores'][ $qix ]) + $subscore * $weight;
						$ref_handle['scoresw'][ $qix ] = int_ensure_defined($ref_handle['scoresw'][ $qix ]) + $weight;
					}
					
					// find out to which section this question belongs
					// and add the score
					$hdrix = $this->questions[$qix]['hdrix'];
					if ($hdrix!=-1)
					{
						foreach ($tohandle as & $ref_handle)
						{
							$ref_handle['scores'][$hdrix] += $subscore * $weight;
							$ref_handle['scoresw'][$hdrix] += $weight;
						}
					}
				}
			}
		}
		
		foreach($this->projects as &$ref_project)
		{
			if ($this->formid!=-1)
			{
				if ($ref_project['formid']!=$this->formid)
				{
					$ref_project['not'] = true;
					continue;
				}
			}
			$calls = $this->cedb->GetProjectCalls($ref_project['id']);
      $ref_project['callcnt'] = count($calls);
		}
		
		$this->total = array();
		$this->total['callcnt'] = 0;
		$this->total['evalcnt'] = 0;
		$this->total['scoretot'] = 0;
		$this->total['scores'] = array();
		$this->total['scoresw'] = array();
		$this->total['avscores'] = array();
		foreach ($this->user_list as &$ref_user)
		{
			if ($ref_user['evalcnt']>0)
			{
				
				$ref_user['avscore'] = $this->safediv( $ref_user['scoretot'] , $ref_user['evalcnt']);
				$this->total['evalcnt'] += $ref_user['evalcnt'];
				$this->total['scoretot'] += $ref_user['scoretot'];
				if ($this->perq)
				{
					foreach ($ref_user['scores'] as $qix=>$subscore)
					{
						$this->total['scores'][$qix] = int_ensure_defined($this->total['scores'][$qix]) + $subscore;
						$this->total['scoresw'][$qix] = int_ensure_defined($this->total['scoresw'][$qix]) + $ref_user['scoresw'][$qix];
					}
				}
				foreach ($ref_user['scoresw'] as $ix=>$weight)
				{
					$ref_user['avscores'][$ix] = 
						$this->safediv( $ref_user['scores'][$ix] 
							, $ref_user['scoresw'][$ix] );
				}
			}
		}
		foreach ($this->projects as &$ref_project)
		{
			if (int_ensure_defined($ref_project['evalcnt'])>0)
			{
				$ref_project['avscore'] = $this->safediv( $ref_project['scoretot'] , $ref_project['evalcnt']);
				if (isset($ref_project['scoresw']))
				{
					foreach ($ref_project['scoresw'] as $ix=>$weight)
					{
						$ref_project['avscores'][$ix] = 
							$this->safediv( $ref_project['scores'][$ix] 
								, $ref_project['scoresw'][$ix] );
					}
				}
			}
			$this->total['callcnt'] += int_ensure_defined($ref_project['callcnt']);
		}
		foreach ($this->total['scoresw'] as $ix=>$weight)
		{
			$this->total['avscores'][$ix] = 
				$this->safediv( $this->total['scores'][$ix] 
					, $this->total['scoresw'][$ix] );
		}
		if ($this->total['evalcnt']>0)
		{
			$this->total['avscore'] = $this->safediv( $this->total['scoretot'] , $this->total['evalcnt'] );
		} 
		
		//echo '<pre>';
		//var_dump( $this->user_list );
	} // end of Calculate
	

	function safediv($a,$b)
	{
		if ($b==0) return 0;
		else return $a / $b;
	}
	
}



?>