<?php

require_once('general.php');
require_once('cedb.php');
require_once('annotate.php');

HandleContacts($dbintf);

function HandleContacts($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s,$lng;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

	$ro = false;
	if (isset($_GET['ro']) && $_GET['ro']==1 || (CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false) && CheckCePm(PM_CE_SELFEVALUATE)==false)
	{
		$ro = true;
	}

  // not read-only
  if (CheckCePm(PM_CE_EVALUATE)==false && CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_VIEWOWNREPORTS)==false && CheckCePm(PM_CE_SELFEVALUATE)==false)
  {
    echo 'Permission denied';
    exit;
  }
  // read-only
  if (CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_VIEWOWNREPORTS)==false && CheckCePm(PM_CE_SELFEVALUATE)==false)
  {
    echo 'Permission denied';
    exit;
  }

	$cedb = new CEDB($dbintf);
	
	$id = (int) $_GET['ceid'];
	$eval = $cedb->GetEvaluation($id);
  $prjid = $eval['projectid'];
  $callid = $eval['recordingid'];			
			
	if(CheckCePm(PM_CE_SELFEVALUATE) && $dbintf->actuinfo['accid']!=$eval['supervisor'] && !(CheckCePm(PM_CE_EVALUATE) || CheckCePm(PM_CE_SUPERVISOR) || CheckCePm(PM_CE_VIEWOWNREPORTS))){
		echo 'Permission denied';
    exit;
		
	}
	
	if(CheckCePm(PM_CE_SELFEVALUATE) && $dbintf->actuinfo['accid']!=$eval['supervisor'] && CheckCePm(PM_CE_VIEWOWNREPORTS)){
		$ro = true;
	}

  $act = $_POST['act'];
  if ($act!='' && $ro==false && (CheckCePm(PM_CE_EVALUATE) || CheckCePm(PM_CE_SUPERVISOR) || CheckCePm(PM_CE_SELFEVALUATE)) )
  {
		PerformAnnotationActions();

   	$id = (int) $_POST['id'];

  	if ($act=='answer')
  	{      
			LogAction("Save AgEv answers", array('call_id'=>$callid) );
			$newscore = (double) $_POST['score'];
			$iscomplete = (int) $_POST['complete'];
			if ($iscomplete==false)
			{
				$newscore = null;
			}

			$parts = explode(',',$_POST['answers']);
			$answers = array();
			foreach ($parts as $part)
			{
				$subparts = explode('=',$part);
				if (count($subparts)==2)
				{
					$answers[ (int) $subparts[0] ] = (int) $subparts[1];
				}
			}
			$notes = array();
			foreach ($_POST as $key=>$value)
			{
				if (strncmp($key,'notes-',6)==0)
				{
					$qid = (int) substr($key,6);
					$notes[ $qid ] = $value;
				}
			}

			$cedb->StoreAnswers($id,$answers,$notes,$newscore);

			if (isset($_POST['notes']))
			{
	      $recording_id = $_POST['edit-id'];
	      $info = $dbintf->GetCallInfo($recording_id);
	      if (($info['permissions']&PM_NOTES)==0)
	      {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
	      } else {
					LogAction("Edit notes", array('call_id'=>$callid) );
	        $dbintf->EditRecordingNotes($recording_id,$_POST['notes']);
	      }
			}

		}

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'ceevalsel.php?prjid='.$prjid.'&selcall='.$callid);
		exit;
  }

	if (isset($_GET['ceid'])==false)
	{
	  // both not defined,
	  // then go back to selection page
		$_SESSION['msg'] = $msg;
	  header('Location: '.$rooturl.'ceevalsel.php');
		exit;		

	} else
	{
		$id = (int) $_GET['ceid'];
		$eval = $cedb->GetEvaluation($id);
		$prjid = $eval['projectid'];
		$callid = $eval['recordingid'];
	}
	
	//read only yourself
	if((CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false) && $eval['useraccid'] != $dbintf->actuinfo['accid']){
		echo 'Permission denied';
    exit;
	}


  LogAction('View AgEv call evaluation'
    ,array('level'=>'view'
      , 'call_id' => $callid
      )
  );
  
	$callinfo = $dbintf->GetCallInfo($callid);
	/*
	// don't check here on permission
	if (($callinfo['permissions'] & PM_LIST)==0)
	{
    echo 'Permission denied';
    exit;
	}
	*/
	$markersdb = $dbintf->GetAnnotations( $callinfo['id'] );
	$markers = array();
	foreach ($markersdb as $markerdb)
	{
		$toload = array( 'call_id', 'label', 'timepos', 'descr', 'createdby' );
		$marker = array();
		foreach ($toload as $field)
		{
			$marker[$field] = $markerdb[$field];
		}
		$markers[$markerdb['id']] = $marker;
	}
	$callinfo['markers'] = $markers;
	

  $user_list = $dbintf->GetUserList();
	$usermap = array();
	foreach ($user_list as &$ref_userinfo)
	{
    $userphones = $dbintf->GetUserPhones($ref_userinfo['accid']);
    $ref_userinfo['phonecnt'] = count($userphones);
		$usermap[ $ref_userinfo['accid'] ] = $ref_userinfo;
	}

	// check if we must decide on the agent
	if ($eval['useraccid']==null)
	{
		$agent_choice = -1;
		if ($callinfo['agent']!=null)
		{
			$agent_choice = $callinfo['agent'];
		} else
		{
			$agents = $dbintf->GetUsersOfCall($callinfo,false);
			if (count($agents)==0)
			{
				$msg[] = new Msg(MSG_ERR,'Cannot determine agent. No user account matches the call.');
				header('Location: '.$rooturl.'ceevalsel.php?ceid='.$id);
				$_SESSION['msg'] = $msg;
				exit;
			}
			$cnt = 999999;
			foreach ($agents as $agent)
			{
				$thiscnt = $usermap[ $agent ]['phonecnt'];
				if ($thiscnt<$cnt)
				{
					$agent_choice = $agent;
					$cnt = $thiscnt;
				}
			}
		}
		$cedb->SetEvaluatedAgent($id,$agent_choice);
		$eval['useraccid'] = $agent_choice;
	} else
  {
    $cedb->SetEvaluated( $eval['useraccid'] );
  }

	$agentinfo = $dbintf->GetUserInfoOnAccId($eval['useraccid']);

	$project = $cedb->GetProject($prjid);
  $formid = $project['formid'];

	$evalform = $cedb->GetForm($formid);
	$answertypes = $cedb->GetAnswerTypes();

	if ($evalform['form']===false)
	{
		$msg[] = new Msg(MSG_ERR,'The project has no evaluation form');
		header('Location: '.$rooturl.'ceevalsel.php?prjid='.$prjid);
		$_SESSION['msg'] = $msg;
		exit;
	}
	
	// for a strange reason we must use a separate variable name here
	// probably because it then becomes a reference *everywhere*
	foreach($answertypes as &$answertyperef)
	{
		if ($answertyperef['type']==1)
		{
  		$answertyperef['obj'] = ParseAnswerDescription($answertyperef['description']);
  	}
	}

  $answermap = array();
	foreach($answertypes as $answertype)
	{
		$answermap[$answertype['id']] = $answertype;
	}

	$answers = $cedb->GetEvaluationAnswers($id);


	//echo '<pre>';
	//var_dump($eval);

	$data = 'var evaldata = ';
	$data .= '{ id : ' . $eval['id'];
	$data .= ', userid : ' . int_ensure_defined($eval['userid']);
	$data .= ', username : "' . JSQuote($agentinfo['name']) . '"';
	$data .= ', supervisor: "' .$cedb->GetUserName($eval['supervisor']) . '"';
	if($eval['datescored']!=0){
		$data .= ', datescored: "' .date("Y-m-d H:i:s", $eval['datescored']) . '"';
	}else{
		$data .= ', datescored: ""';
	}
	$data .= "};\r\n";

	//echo '<pre>';
	//var_dump($evalform);
	//exit;
	$formdata = $evalform['form'];
	$data .= 'var theform = {';
	$data .= 'name:"'.JSQuote($formdata['name']).'"';
	$data .= ',id:'.(int)$formdata['id'];
	$data .= '};' . "\r\n";

	$data .= 'var questions = [';
	$first = true;
	foreach($evalform['questions'] as $question)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ qtext: "' . JSQuote($question['qtext']) . '"';
		$data .= ' , id: ' . (int) $question['id'];
		$data .= ' , ordering: ' . (int) $question['ordering'];
		$data .= ' , atypeid: ' . (int) $question['atypeid'];
		$data .= ' , weight: ' . (double) $question['weight'];
		$data .= ' , canna: ' . (int) $question['canna'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	$data .= 'var answers = [';
	$first = true;
	foreach($answers as $answer)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ qid : ' . (int) $answer['qid'];
		$data .= ', answer: ' . (int) $answer['answer'];
		$data .= ', notes: "' . JSQuote($answer['notes']) . '"';
		$data .= "}\r\n";
	}
	$data .= "];\r\n";


	$data .= 'var answertypes = [';
	$first = true;
	foreach($answertypes as $answertype)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ description: "' . JSQuote($answertype['description']) . '"';
		$data .= ' , name: "' . JSQuote(GetFriendlyName($answertype)) . '"';
		$data .= ' , id: ' . (int) $answertype['id'];
		$data .= ' , type: ' . (int) $answertype['type'];
		$data .= ' , cnt: ' . count($answertype['obj']);
		$data .= ' , best: ' . (int) GetScoreBestAnswer($answertype);
		$data .= ' , worst: ' . (int) GetScoreWorstAnswer($answertype);
		$data .= ' , obj: [';
		$f2 = true;
		foreach ($answertype['obj'] as $answer)
		{
			if ($f2) $f2 = false;
			else $data .= ',';
			$data .= '{ text : "' . JSQuote($answer['text']) . '"';
			$data .= ', score : ' . int_ensure_defined($answer['score']);
			$data .= '}';
		}
		$data .= ' ]';
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	$row = $callinfo;
	$calldata = array(); 
	$unmodified = array('id','filename','direction','notes','markers'
	,'flags','waittime');
	foreach ($unmodified as $key)
	{
		$calldata[$key] = $row[$key];
	}
	$calldata['length'] = $row['duration'];
	$calldata['startdate'] = date($configs['datetimef'],$row['startdate']);
	$calldata['arch'] = $row['isarchived'];
	$calldata['pm'] = $row['permissions'];
	$data .= "var calldata = \n" . json_encode( $calldata, JSON_FORCE_OBJECT ) . ";\n";

	//echo '<pre>'.$data;
	//exit;
  // ready with database
  $dbintf->close();
  $dbintf = null;
  $cedb = null;

  $formhtm = '';
  $formhtm .= '<table id="ceform" class="ce" cellspacing="0">';
  $odd = true;
  $nr = 1;
  $qcnt = count($evalform['questions']);
	foreach($evalform['questions'] as $question)
	{
    $answerdb = $answermap[$question['atypeid']];

		if ($odd) $clextra = 'odd';
		else $clextra = 'even';
    $qid = 'q' . $question['id'];
		$formhtm .= "<tr class=\"qrow $clextra\" id=\"row$qid\">";

		// moving up and down:
		//$formhtm .= '<td>';
		//if ($nr!=1) $formhtm .= '/\\';
		//$formhtm .= '<td>';
		//if ($nr!=$qcnt) $formhtm .= '\\/';

		$formhtm .= '<td class="nr">';
    if ($answerdb['type']==1)
    {
			$formhtm .= $nr . '.';
		}
		$formhtm .= '<td>';
    if ($answerdb['type']==1)
    {
  		$formhtm .= HtmlQuote($question['qtext']);
  	}
    if ($question['atypeid']==-1)
    {
  		$formhtm .= '<span class="header">' . HtmlQuote($question['qtext']) . '</span>';
		}

    $formhtm .= "\r\n" . '<td class="answers">';
    if ($answerdb['type']==1)
    {
	    //$answers = ParseAnswerDescription( $answerdb['description'] );
	    $answers = $answerdb['obj'];
	    $formhtm .= '<table align="left"><tr>';
	    $choicenr = 0;
	    foreach ($answers as $answer)
	    {
				$choiceid = $qid . '_' . $choicenr;
	    	$formhtm .= "<td><label for=\"$choiceid\">".HtmlQuote($answer['text'])."</label>";
	    	$formhtm .= "<br><input type=\"radio\" id=\"$choiceid\" name=\"$qid\" >";
	    	$choicenr ++;
			}
			if ($question['canna']!=0)
			{
				$choiceid = $qid . '_-2';
				$formhtm .= "<td><label for=\"$choiceid\">".HtmlQuote($lng->Get('CE.NotApplicable'))."</label>";
				$formhtm .= "<br><input type=\"radio\" id=\"$choiceid\" name=\"$qid\" >";
			}
	    $formhtm .= '</table>';
			$nr ++;
			$elemid = $qid . '_notes';
			$formhtm .= '<td><textarea id="'.$elemid.'" class="answernote"  ></textarea>';
	  } else
		{
			$formhtm .= '<td>';
		}

    $formhtm .= "\r\n";

		$odd = ! $odd;
	}
  $formhtm .= '</table>';

	$data .= 'var ro = ' . ($ro?'1':'0') . ';' . "\r\n";
  $data .= 'var embedPlayer = ' . ($configs['EmbedPlayer']?'true':'false') . ';' . "\r\n";
	$data .= 'var audio5 = ' . ($configs['Audio5']?'true':'false') . ';' . "\r\n";

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/ceeval.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
	$rpl['genplay_outside'] = file_get_contents('../apresa/templ/genplay_outside.js');
  $rpl['genplay_htm'] = file_get_contents('../apresa/templ/genplay.htm');
	$rpl['genlist_css'] = file_get_contents('../apresa/templ/genlist.css');
  $rpl['header'] = GetHeader();
  $rpl['evalform'] = $formhtm;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function GetFriendlyName($answer)
{
	if ($answer['type']==2)
	{
		return '- Header -';
		//return $lng->Get
	}
	if ($answer['type']==1)
	{
		$name = '';
		$first = true;
		foreach ($answer['obj'] as $opt)
		{
			if ($first) $first = false;
			else $name .= ' \\ ';
			$name .= $opt['text'];
		}
		return $name;
	}
}

function GetScoreBestAnswer($answer)
{
	if (count($answer['obj'])==0) return -1;
	$ret = null;
	foreach ($answer['obj'] as $opt)
	{
  	if ($ret===null)
  	{
			$ret = $opt['score'];
		} else
		{
			if ($opt['score']>$ret)
			{
				$ret = $opt['score'];
			}
		}
	}
	return $ret;
}
function GetScoreWorstAnswer($answer)
{
	if (count($answer['obj'])==0) return -1;
	$ret = null;
	foreach ($answer['obj'] as $opt)
	{
  	if ($ret===null)
  	{
			$ret = $opt['score'];
		} else
		{
			if ($opt['score']<$ret)
			{
				$ret = $opt['score'];
			}
		}
	}
	return $ret;
}

function ParseAnswerDescription($descr)
{
	// format is Good=2\Avg.=1\Poor=0
  $ret = array();
	$answers = explode('\\',$descr);
	foreach ($answers as $answer)
	{
		$parts = explode('=',$answer);
		$answerinfo = array();
		if (count($parts)==2)
		{
			$answerinfo['text'] = $parts[0];
			$answerinfo['score'] = $parts[1];
		}
		$ret[] = $answerinfo;
	}
	return $ret;
}

?>
