<?php
require_once 'actions.php';
require_once('general.php');
require_once 'cedb.php';
require_once 'listinggen.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$configs_s,$actuinfo,$msg,$lng,$rooturl;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_EVALUATE)==false && CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_SELFEVALUATE)==false)
  {
    echo 'Permission denied';
    exit;
  }

  $handler = new ListingHandler();
  $handler->filterData = true;
  $handler->search_accepted[] = 'usrnm';
  $handler->viewAuditLogText = 'View AgEv calls to evaluate';

  $cedb = new CEDB($dbintf);
  $prjid = -1;

  $act = str_ensure_defined($_POST['act']);
  if ($act!='')
  {
		$redirect_url = substr($_SERVER['REQUEST_URI'],1);
		$handler->ListingAct($act, $redirect_url);
    // redirect to same URL (but without POST data)
    $_SESSION['msg'] = $msg;
    $newurl = $rooturl.$redirect_url;
    if (isset($_POST['prjid']))
    {
			$prjid = (int) $_POST['prjid'];
			$newurl = SetUrlParam($newurl,'prjid',$prjid);
    }
    header('Location: '.$newurl);
    exit;
  }

	$handler->ParseSearch();

	$user_list = $dbintf->GetUserList();
  if (isset($_GET['usr']))
  {
		$accid = (int) $_GET['usr'];
		$info = $dbintf->GetUserInfoOnAccId($accid);
		if ($info!=null)
		{
			$handler->search['usrnm'] = $info['name'];
			$handler->search_use['usr'] = $info['accid'];
		}
	}
  if (isset($handler->search['usrnm']))
  {
		$usrnm = $handler->search['usrnm'];
		unset($handler->search_use['usrnm']);
		foreach ($user_list as $user)
		{
			if (strtolower($user['name'])==strtolower($usrnm))
			{
				$handler->search_use['usr'] = $user['accid'];
				$handler->search['usrnm'] = $user['name'];
			}
		}
		if (isset($handler->search_use['usr'])==false)
		{
			// try also beginning
			foreach ($user_list as $user)
			{
				if (strtolower(substr($user['name'],0,strlen($usrnm)))==strtolower($usrnm))
				{
					$handler->search_use['usr'] = $user['accid'];
					$handler->search['usrnm'] = $user['name'];
				}
			}
		}
		if (isset($handler->search_use['usr'])==false)
		{
      $msg[] = new Msg(MSG_WRN,'Could not find user');
		}
	}

	$usermap = array();
	foreach ($user_list as &$ref_userinfo)
	{
    $userphones = $dbintf->GetUserPhones($ref_userinfo['accid']);
    $ref_userinfo['phonecnt'] = count($userphones);
		$usermap[ $ref_userinfo['accid'] ] = $ref_userinfo;
	}

 	$projects = $cedb->GetProjects();
 	$projectmap = array();
 	foreach ($projects as $project)
 	{
		$projectmap[$project['id']] = $project;
	}
	if (isset($_GET['prjid']))
	{
		$prjid = (int) $_GET['prjid'];
	}
	if ($prjid==-1 and count($projects)>=1)
	{
		$firstproject = $projects[0];
		$prjid = $firstproject['id'];
	}
  if ($prjid!=-1)
  {
		$handler->search_use['prjid'] = $prjid;
	}

  $selcall = -1;
  if (isset($_GET['selcall']))
  {
		$selcall = (int) $_GET['selcall'];
	}

  $handler->listconfig['ceproject'] = 1;
	$actuinfo = $dbintf->GetActiveUserInfo();
	if(($actuinfo["permissions"]&PM_CE_SUPERVISOR)!=0){
		if(CheckCePm(PM_CE_EVALUATE)==false){
			$handler->listconfig['ceproject'] = 3;
			$handler->listconfig['supervisor'] = $actuinfo['accid'];
		}
	}else if(CheckCePm(PM_CE_SELFEVALUATE) && CheckCePm(PM_CE_EVALUATE)==false){
		$handler->listconfig['ceproject'] = 5;
		
	}
  // not: $handler->listconfig['nousrflr'] = true;
	$handler->listconfig['score'] = true;
	if ($selcall!=-1)
	{
  	$handler->selcall = $selcall;
 	}
  $handler->listconfig['projects'] = $projectmap;
	$handler->listconfig['usermap'] = $usermap;
	$handler->listconfig['addcb'] = 'CeAddExtraRowData';
	
	// LogAction is done in listinggen.php
	
	$handler->PerformSearch();

	$options = array();
	$options['callback'] = 'CeAddExtraJsCols';

	$calldata = '';
	$calldata .= $handler->GetBasicJsData($options);


  $dbintf->close();

	$calldata .= 'var selcall = ' . $selcall . ';' . "\r\n";

	$data = 'var projects = [';
	$first = true;
	foreach($projects as $project)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($project['name']) . '"';
		$data .= ' , id: ' . $project['id'];
		$data .= ' , avscore: ' . (double) ensure_defined($project['avscore'], 0.0);
		$data .= ' , callcnt: ' . int_ensure_defined($project['callcnt']);
		$data .= ' , evalcnt: ' . int_ensure_defined($project['evalcnt']);
		$data .= ' , formid: ' . $project['formid'];
		$data .= ' , formname: "' . JSQuote($project['formname']) . '"';
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";
	$data .= 'var selprjid = ' . $prjid . ';' . "\r\n";

	$calldata .= $data;
  $calldata .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/ceevalsel.htm');

  // template replacements:
  $handler->SetDefReplacements();
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['data'] = $calldata;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>