<?php

require_once('general.php');
require_once('cedb.php');

HandleContacts($dbintf);

function HandleContacts($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s,$lng;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_MANAGE)==false&&CheckCePm(PM_CE_SUPERVISOR)==false)
  {
    echo 'Permission denied';
    exit;
	}

	$cedb = new CEDB($dbintf);

  $act = $_POST['act'];
  if ($act!='')
  {
		$formid = (int) $_POST['id'];
    $evalform = $cedb->GetForm($formid);
		$need_recalc = false;
		if ($act=='addquestion')
		{
    	$question = array();
    	$question['formid'] = (int) $_POST['id'];
    	$question['pos'] = $_POST['pos'];
    	$question['atypeid'] = $_POST['atypeid'];
    	$question['qtext'] = $_POST['qtext'];
    	$question['weight'] = (double) $_POST['weight'];
			$question['canna'] = (int) $_POST['canna'];
			LogAction('Add AgEv question', array('form'=>$evalform['form']['name'],'question'=>$question['qtext']) );
    	$cedb->AddQuestion($question);
			$need_recalc = true;
		}
		if ($act=='editquestion')
		{
    	$question = array();
    	$question['formid'] = (int) $_POST['id'];
    	$question['qid'] = (int) $_POST['qid'];
    	$question['pos'] = $_POST['pos'];
    	$question['atypeid'] = (int) $_POST['atypeid'];
    	$question['qtext'] = $_POST['qtext'];
    	$question['weight'] = (double) $_POST['weight'];
			$question['canna'] = (int) $_POST['canna'];
			LogAction('Edit AgEv question', array('form'=>$evalform['form']['name'],'question'=>$question['qtext']) );
    	$cedb->EditQuestion($question);
			$need_recalc = true;
		}
		if ($act=='delquestion')
		{
      $qs = $evalform['questions'];
      $logarr = array();
      $logarr['form'] = $evalform['form']['name'];
      foreach ($qs as $q)
      {
        if ($q['id']==(int)$_POST['qid'])
        {
          $logarr['question'] = $q['qtext'];
        }
      }
			LogAction('Delete AgEv question', $logarr );
    	$ret = $cedb->DelQuestion((int)$_POST['id'],(int)$_POST['qid']);
			if ($ret==1)
			{
	      $msg[] = new Msg(MSG_ERR,'Question is already answered, and it cannot be deleted.');
			}
			$need_recalc = true;
		}
		if ($act=='editform')
		{
			LogAction('AgEv edit form',array('id'=>(int)$_POST['id'],'name'=>$_POST['name']));
			$cedb->EditForm((int)$_POST['id'],$_POST['name']);
		}
		if ($need_recalc)
		{
      $db2 = new DBInterface('');
      $db2->cloneInit( $dbintf );
      $db2->setAdmin();
      $cedb2 = new CEDB($db2);
    	$cedb2->Recalc($formid);
		}
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'ceform.php?id='.$formid);
		exit;
  }

  $formid = -1;
  if (isset($_GET['id']))
  {
		$formid = (int) $_GET['id'];
	}

	$evalform = $cedb->GetForm($formid);
  if ($evalform['form']===false)
  {
    // unknown form
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'ceforms.php');
    exit;
  }
	$answertypes = $cedb->GetAnswerTypes();

	$evalform['callcnt'] = $cedb->GetFormCallCount($formid);


	// for a strange reason we must use a separate variable name here
	// probably because it then because a reference *everywhere*
	foreach($answertypes as &$answertyperef)
	{
		if ($answertyperef['type']==1)
		{
  		$answertyperef['obj'] = ParseAnswerDescription($answertyperef['description']);
  	}
	}

  $answermap = array();
	foreach($answertypes as $answertype)
	{
		$answermap[$answertype['id']] = $answertype;
	}

	//echo '<pre>';
	//var_dump($evalform);
	//exit;
	$formdata = $evalform['form'];
	$data = 'var theform = {';
	$data .= 'name:"'.JSQuote($formdata['name']).'"';
	$data .= ',id:'.$formdata['id'];
	$data .= ',callcnt: '.$evalform['callcnt'];
	$data .= '};' . "\r\n";

	$data .= 'var questions = [';
	$first = true;
	foreach($evalform['questions'] as $question)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ qtext: "' . JSQuote($question['qtext']) . '"';
		$data .= ' , id: ' . $question['id'];
		$data .= ' , ordering: ' . $question['ordering'];
		$data .= ' , atypeid: ' . $question['atypeid'];
		$data .= ' , weight: ' . (int) $question['weight'];
		$data .= ' , canna: ' . (int) $question['canna'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	$data .= 'var answertypes = [';
	$first = true;
	foreach($answertypes as $answertype)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ description: "' . JSQuote($answertype['description']) . '"';
		$data .= ' , name: "' . JSQuote(GetFriendlyName($answertype)) . '"';
		$data .= ' , id: ' . $answertype['id'];
		$data .= ' , type: ' . $answertype['type'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	LogAction("View AgEv evaluation form",array('id'=>$formid,'name'=>$evalform['form']['name'],'level'=>'view') );
  
	//echo '<pre>'.$data;
	//exit;
  // ready with database
  $dbintf->close();
  $dbintf = null;
  $cedb = null;

  $formhtm = '';
  $formhtm .= '<table id="ceform" class="ce" cellspacing="0">' . "\r\n";
  $formhtm .= '<tr class="header"><td><td>'.$lng->Get('CE.Question').'<td><%CE.Answers%><td>'.$lng->Get('CE.Weight').'';
  $odd = true;
  $nr = 1;
  $qcnt = count($evalform['questions']);
	foreach($evalform['questions'] as $question)
	{
    $answerdb = $answermap[$question['atypeid']];

		if ($odd) $clextra = 'odd';
		else $clextra = 'even';
    $qid = 'q' . $question['id'];
		$formhtm .= "<tr class=\"qrow $clextra\" id=\"row$qid\">";

		// moving up and down:
		//$formhtm .= '<td>';
		//if ($nr!=1) $formhtm .= '/\\';
		//$formhtm .= '<td>';
		//if ($nr!=$qcnt) $formhtm .= '\\/';

		$formhtm .= '<td class="nr">';
    if ($answerdb['type']==1)
    {
			$formhtm .= $nr . '.';
		}
		$formhtm .= '<td>';
    if ($answerdb['type']==1)
    {
  		$formhtm .= HtmlQuote($question['qtext']);
  	}
    if ($question['atypeid']==-1)
    {
  		$formhtm .= '<span class="header">' . HtmlQuote($question['qtext']) . '</span>';
		}

    $formhtm .= "\r\n" . '<td class="answers">';
    if ($answerdb['type']==1)
    {
	    //$answers = ParseAnswerDescription( $answerdb['description'] );
	    $answers = $answerdb['obj'];
	    $formhtm .= '<table align="left"><tr>';
	    $choicenr = 0;
	    foreach ($answers as $answer)
	    {
				$choiceid = $qid . '_' . $choicenr;
	    	$formhtm .= "<td><label for=\"$choiceid\">".HtmlQuote($answer['text'])."</label>";
	    	$formhtm .= "<br><input type=\"radio\" id=\"$choiceid\" name=\"$qid\" >";
	    	$choicenr ++;
			}
			if ($question['canna']!=0)
			{
				$choiceid = $qid . '_-2';
				$formhtm .= "<td><label for=\"$choiceid\">".HtmlQuote($lng->Get('CE.NotApplicable'))."</label>";
				$formhtm .= "<br><input type=\"radio\" id=\"$choiceid\" name=\"$qid\" >";
			}
	    $formhtm .= '</table>';
			$nr ++;
    	$formhtm .= "\r\n" . '<td class="weight">'.round($question['weight']);
	  } else
	  {
    	$formhtm .= "\r\n" . '<td class="noweight">';
		}

    $formhtm .= "\r\n";

		$odd = ! $odd;
	}
  $formhtm .= '</table>';

  $data .= GeneralJSData();
	
  $template_content = file_get_contents('../apresa/templ/ceform.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['header'] = GetHeader();
  $rpl['evalform'] = $formhtm;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function GetFriendlyName($answer)
{
	if ($answer['type']==2)
	{
		return '- Header -';
		//return $lng->Get
	}
	if ($answer['type']==1)
	{
		$name = '';
		$first = true;
		foreach ($answer['obj'] as $opt)
		{
			if ($first) $first = false;
			else $name .= ' \\ ';
			$name .= $opt['text'];
		}
		return $name;
	}
}

function ParseAnswerDescription($descr)
{
	// format is Good=2\Avg.=1\Poor=0
  $ret = array();
	$answers = explode('\\',$descr);
	foreach ($answers as $answer)
	{
		$parts = explode('=',$answer);
		$answerinfo = array();
		if (count($parts)==2)
		{
			$answerinfo['text'] = $parts[0];
			$answerinfo['score'] = $parts[1];
		}
		$ret[] = $answerinfo;
	}
	return $ret;
}

?>
