<?php

require_once('general.php');
require_once('cedb.php');

HandleContacts($dbintf);

function HandleContacts($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if ((CheckCePm(PM_CE_MANAGE)==false)&&(CheckCePm(PM_CE_SUPERVISOR)==false))
  {
    echo 'Permission denied';
    exit;
	}

	$cedb = new CEDB($dbintf);

  $act = $_POST['act'];
  if ($act!='')
  {

    if ($act=='addform')
    {
      LogAction("AgEv Create evaluation form" );
      $name = $_POST['name'];
      $formid = $cedb->NewForm($name);
      // redirect to edit
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'ceform.php?id='.$formid);
      exit;
    }
  	if ($act=='delform')
  	{
			$ret = $cedb->DeleteForm($_POST['formid']);
			if ($ret==1)
			{
    		$msg[] = new Msg(MSG_ERR,'Cannot delete this form. It is in use by a project.');
			}else{
				LogAction('Form deleted', array('form'=>$_POST['formid']));
			}
		}
		if ($act=='cloneform')
  	{
			$cedb->CloneForm($_POST['formid'],$_POST['name']);			
			LogAction('Form cloned', array('form'=>$_POST['formid'],'name'=>$_POST['name']));
			
		}					
		
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'ceforms.php');
		exit;
  }
	
	LogAction("Viewed AgEv evaluation forms", array('level'=>'view'));


	$forms = $cedb->GetForms();
	$data = 'var evalforms = [';
	$first = true;
	foreach($forms as $form)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($form['name']) . '"';
		$data .= ' , id: ' . $form['id'];
		$data .= ' , questions: ' . $form['qcnt'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";


  // ready with database
  $dbintf->close();
  $dbintf = null;
  $cedb = null;


  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/ceforms.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
