<?php

require_once('general.php');
require_once('cedb.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if ((CheckCePm(PM_CE_MANAGE)==false)&&(CheckCePm(PM_CE_SUPERVISOR)==false))
  {
    echo 'Permission denied';
    exit;
	}

  $cedb = new CEDB($dbintf);

  $act = $_POST['act'];
  if ($act!='')
  {

  	if ($act=='addProject')
  	{
			$formid = (int) $_POST['evalform'];
			$cedb->AddProject($_POST['name'],$formid);
      $form = $cedb->GetForm($formid);
			LogAction('AgEv Project added', array('name'=>$_POST['name'],'form'=>$form['form']['name']));
		}
  	if ($act=='editProject')
  	{
			$prjid = (int) $_POST['prjid'];
			$cedb->EditProject($prjid,$_POST['name']);
			LogAction('AgEv Project edited', array('name'=>$_POST['name']));
		}
  	if ($act=='delProject')
  	{
			$prjid = (int) $_POST['prjid'];
      $prjname = $cedb->GetProjectName($prjid);
			if($_POST['delcalls']==1){
				$cedb->RemoveAllCallsFromProject($prjid);
			}
			$ret = $cedb->DelProject($prjid);
			LogAction('AgEv Project deleted', array('name'=>$prjname));
			if ($ret==1)
			{
    		$msg[] = new Msg(MSG_ERR,'Cannot delete this project. It contains calls.');
			}
		}


    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'ceprojects.php');
		exit;
  }

	$forms = $cedb->GetForms();
	$data = 'var evalforms = [';
	$first = true;
	foreach($forms as $form)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($form['name']) . '"';
		$data .= ' , id: ' . $form['id'];
		$data .= ' , questions: ' . $form['qcnt'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

 	$projects = $cedb->GetProjects();
	$data .= 'var projects = [';
	$first = true;
	foreach($projects as $project)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($project['name']) . '"';
		$data .= ' , id: ' . $project['id'];
		$data .= ' , avscore: ' . (double) ensure_defined($project['avscore'], 0.0);
		$data .= ' , callcnt: ' . int_ensure_defined($project['callcnt']);
		$data .= ' , evalcnt: ' . int_ensure_defined($project['evalcnt']);
		$data .= ' , formid: ' . $project['formid'];
		$data .= ' , formname: "' . JSQuote($project['formname']) . '"';
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	LogAction("Viewed AgEv projects", array('level'=>'view'));

  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/ceprojects.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
