<?php

require_once('general.php');
require_once('cedb.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s,$lng;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false)
  {
    echo 'Permission denied';
    exit;
  }

  $cedb = new CEDB($dbintf);

	/*
  $act = $_POST['act'];
  if ($act!='')
  {


    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'cerepagents.php');
		exit;
  }
  */

	$formid = -1;
	if (isset($_GET['frm']))
	{
		$formid = (int) $_GET['frm'];
	}


 	$projects = $cedb->GetProjects();
 	$projectform = array();
 	foreach ($projects as $project)
 	{
		$projectform[ $project['id' ] ] = $project['formid'];
	}

	$prjid = -1;
	if (isset($_GET['prj']))
	{
		$prjid = (int) $_GET['prj'];
		if ($prjid!=-1)
		{
			if (isset($projectform[$prjid])==false)
			{
				echo 'Cannot find project';
				exit;
			}
			$formid = $projectform[$prjid];
		}
	}
	
	$forms = $cedb->GetForms();
	
	if ($formid!=-1)
	{
	  $theformdata = $cedb->GetForm($formid);
	  if ($theformdata['form']==null)
	  {
			echo 'Cannot find evaluation form';
			exit;
		}
	}

  $logarr = array('level'=>'view');
  if ($formid!=-1)
  {
    $logarr['form'] = $theformdata['form']['name'];
  }
  if ($prjid!=-1)
  {
    $logarr['project'] = $cedb->GetProjectName($prjid);
  }
	LogAction('Viewed AgEv agent reports', $logarr );
	
	$statsData = new CE_Stats($cedb);
	// filtering
	$statsData->formid = $formid;
	$statsData->prjid = $prjid;
	$statsData->Calculate();
	
	$perq = $statsData->perq;

	
  $export = str_ensure_defined($_GET['export']);
	if ($export =='csv' || $export =='xlsx')
	{
		//header('Content-type: text/csv');
	  $csvfn = 'agents_' . date('Ymd_His');
	  //header('Content-Disposition: attachment; filename="'.$csvfn.'"');

    //echo '<pre>';

		// UTF-8 BOM
    //echo "\xEF\xBB\xBF";
    
    if($export== 'xlsx')
    {
      $file = new XLSXFile();
    }
    else
    {
      $file = new CsvFile();
    }

    $file->Init($csvfn);

    $row = $file->CreateRow();

		// columns
		$row->add($lng->Get('Main.Name'));
		$row->add($lng->Get('CE.EvaluatedCalls'));
    $row->add($lng->Get('CE.AvScore'));
    
		if ($perq)
		{
			$qix = 0;
			foreach ($statsData->questions as $question)
			{
				if ($question['atypeid']!=-1) $qix ++;
				if ($question['atypeid']!=-1)
				{
          $row->add($qix . '. ' . $question['qtext']);
				} else
				{
          $row->add($question['qtext']);
				}
			}
		}
		$row->output();

		foreach($statsData->user_list as $user)
		{
      if ($user['evalcnt']==0) continue;
      
      $row = $file->CreateRow();
      $row->add($user['name']);
      $row->add($user['evalcnt']);
      $row->add(round($user['avscore'],2));

			if ($perq)
			{
			  for ($qix=0;$qix<count($statsData->questions);$qix++)
			  {
					if (isset( $user['avscores'][$qix] )==false)
					{
						continue;
					} else
					{
						$score = $user['avscores'][$qix];
						$row->add(round( $score ,2));
					}
				}
			}

			$row->output();
    }
    
    $row = $file->CreateRow();

		$row->add($lng->Get('Stats.Total'));
    $row->add($statsData->total['evalcnt']);
    
		if (isset($statsData->total['avscore']))
		{
			$row->add(round( $statsData->total['avscore'] , 2));
		}
		if ($perq)
		{
		  for ($qix=0;$qix<count($statsData->questions);$qix++)
		  {
				if (isset( $statsData->total['avscores'][$qix] )==false)
				{
					continue;
				} else
				{
					$score = $statsData->total['avscores'][$qix];
					$row->add(round($score,2));
				}
			}
		}
    $row->output();

    $file->Finish();
		exit;
	}


	$data = 'var agents = [';
	$first = true;
	foreach($statsData->user_list as $user)
	{
		if ($user['evalcnt']==0) continue;
		if ($first) $first = false;
		else $data .= ',';
    $name = $user['name'];
    if ($user['accid']==NULL)
    {
      $name = $lng->Get('CE.UnknownAgent');
    }
		$data .= '{ name: "' . JSQuote($name) . '"';
		$data .= ' , id: ' . (int) $user['id'];
		$data .= ' , accid: ' . (int) $user['accid'];
		$data .= ' , evalcnt: ' . $user['evalcnt'];
		$data .= ' , avscore: ' . round($user['avscore'],0);
		if ($perq)
		{
		  for ($qix=0;$qix<count($statsData->questions);$qix++)
		  {
				if (isset($user['avscores'][$qix])==false) continue;
				$score = $user['avscores'][$qix];
				$data .= ', score' . $qix . ': ' . round($score);
			}
		}
		$data .= '}' . "\r\n";
	}
	if ($first) $first = false;
	else $data .= ',';
	$data .= '{ name: "' . JSQuote($lng->Get('Stats.Total')) . '"';
	$data .= ' , id: null';
	$data .= ' , accid: null';
	$data .= ' , evalcnt: ' . (int) $statsData->total['evalcnt'];
	if (isset($statsData->total['avscore']))
	{
		$data .= ' , avscore: ' . (double) round($statsData->total['avscore'],0);
	}
	if ($perq)
	{
	  for ($qix=0;$qix<count($statsData->questions);$qix++)
	  {
			if (isset($statsData->total['scores'][$qix])==false) continue;
			$data .= ', score' . $qix . ': ' . round($statsData->total['avscores'][$qix]);
		}
	}
	$data .= '}' . "\r\n";
	$data .= '];' . "\r\n";
	///echo '<pre>' . $data;
	//exit;

	$data .= 'var evalforms = [';
	$first = true;
	foreach($forms as $form)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($form['name']) . '"';
		$data .= ' , id: ' . $form['id'];
		$data .= ' , questions: ' . $form['qcnt'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	$data .= 'var projects = [';
	$first = true;
	foreach($projects as $project)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($project['name']) . '"';
		$data .= ' , id: ' . $project['id'];
		$data .= ' , avscore: ' . (double) round(ensure_defined($project['avscore'], 0.0),0);
		$data .= ' , callcnt: ' . int_ensure_defined($project['callcnt']);
		$data .= ' , evalcnt: ' . int_ensure_defined($project['evalcnt']);
		$data .= ' , formid: ' . $project['formid'];
		$data .= ' , formname: "' . JSQuote($project['formname']) . '"';
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	if ($formid!=-1)
	{
		$data .= 'var questions = [';
		$first = true;
		foreach($statsData->questions as $question)
		{
			if ($first) $first = false;
			else $data .= ',';
			$data .= '{ qtext: "' . JSQuote($question['qtext']) . '"';
			$data .= ' , id: ' . $question['id'];
			$data .= ' , ordering: ' . $question['ordering'];
			$data .= ' , atypeid: ' . $question['atypeid'];
			$data .= '}' . "\r\n";
		}
		$data .= '];' . "\r\n";
	}

	$data .= 'var perq = ' . ($perq?1:0) . ';';
	$data .= 'var theformid = ' . $formid . ';';
	$data .= 'var theprj = ' . $prjid . ';';

  // ready with database
  $dbintf->close();


  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/cerepagents.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}


?>
