<?php

require_once('general.php');
require_once('cedb.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s,$lng;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false && CheckCePm(PM_CE_VIEWOWNREPORTS)==false)
  {
    echo 'Permission denied';
    exit;
  }

  $cedb = new CEDB($dbintf);
	
	$actuinfo = $dbintf->GetActiveUserInfo();

	$filterusr = -1;
	if (isset($_GET['usr']))
	{
		$filterusr = (int) $_GET['usr'];
	}
	
	$data="";
	
	if(CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false){
		$filterusr = $actuinfo['accid'];
		$data="var OwnOnly=true;"."\r\n";
	}

	$forms = $cedb->GetForms();
 	$projects = $cedb->GetProjects();

  $formid = -1;
  if (isset($_GET['frm']))
  {
		$formid = (int) $_GET['frm'];
	}

	$statsData = new CE_Stats($cedb);
	// filtering
	$statsData->formid = $formid;
	$statsData->prjid = -1;
	$statsData->filterusr = $filterusr;
	$statsData->Calculate();	

	$perq = $statsData->perq;

  $logarr = array('level'=>'view');
  if ($formid!=-1)
  {
    foreach ($forms as $form)
    {
      if ($form['id']==$formid)
      {
        $logarr['form'] = $form['name'];
      }
    }
  }
  if ($filterusr!=-1)
  {
    $uinfo = $dbintf->GetUserInfoOnAccId($filterusr);
    $logarr['usr'] = $uinfo['name'];
    if ($uinfo['tenantid']!=null)
    {
      $tinfo = $dbintf->GetGroupInfo($uinfo['tenantid']);
      $logarr['tenant'] = $tinfo['name'];
    }
  }
	LogAction('View AgEv projects report',$logarr);
  //'filterusr'=>$statsData->filterusr

  $output = str_ensure_defined($_GET['output']);
  if ($output =='csv' || $output == 'xlsx')
  {
    $csvfn = 'projects_' . date('Ymd_His');
    if($output == 'xlsx')
    {
      $file = new XLSXFile();
    }
    else
    {
      $file = new CsvFile();
    }

    $file->Init($csvfn);
    $NumCallsColumn = ($filterusr==-1);
    
    $row = $file->CreateRow();
		
		$row->add($lng->Get('Main.Name'));
		if ($NumCallsColumn)
		{
			$row->add($lng->Get('Stats.numcalls'));
    }
    $row->add($lng->Get('CE.EvaluatedCalls'));
    $row->add($lng->Get('CE.AvScore'));

		if ($perq)
		{
			$qix = 0;
			foreach ($statsData->questions as $question)
			{
				if ($question['atypeid']!=-1) $qix ++;
				if ($question['atypeid']!=-1)
				{
          $row->add($qix . '. ' . $question['qtext']);
				} else
				{
          $row->add($question['qtext']);
					$line .= ',' . CsvQuote($question['qtext']);
				}
			}
    }
    
    $row->output();
    
    foreach($statsData->projects as $project)
		{
      if (isset($project['not'])) continue;
      $row = $file->CreateRow();

			$row->add($project['name']);
			if ($NumCallsColumn)
			{
				$row->add(int_ensure_defined($project['callcnt']));
			}
      $row->add(int_ensure_defined($project['evalcnt']));
      
			if (isset($project['avscore']))
			{
				$row->add(round($project['avscore'],2));
			}
			if ($perq)
			{
			  for ($qix=0;$qix<count($statsData->questions);$qix++)
			  {
					if (isset($project['avscores'][$qix])==false) continue;
					$score = $project['avscores'][$qix];
					$row->add(round($score,2));
				}
			}
			$row->output();
    }
    
    $row = $file->CreateRow();
		$row->add($lng->Get('Stats.Total'));
		if ($NumCallsColumn)
		{
			$row->add($statsData->total['callcnt']);
		}
		$row->add(int_ensure_defined($statsData->total['evalcnt']));
    $row->add(round(ensure_defined($statsData->total['avscore'], 0.0),2));
    
		if ($perq)
		{
		  for ($qix=0;$qix<count($statsData->questions);$qix++)
		  {
				if (isset($statsData->total['avscores'][$qix])==false) continue;
				$score = $statsData->total['avscores'][$qix];
				$row->add(round($score,2));
			}
		}
    $row->output();
    $file->Finish();
		exit;
  }


	$user_list = $dbintf->GetUserList();
	$data .= 'var agents = [';
	$first = true;
	foreach($user_list as $user)
	{
		if ($user['evaluated']==0 || (CheckCePm(PM_CE_VIEWOWNREPORTS) && $user['accid']!=$actuinfo['accid'])){
			continue;
		}
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($user['name']) . '"';
		$data .= ' , id: ' . $user['id'];
		$data .= ' , accid: ' . $user['accid'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";
	
	if(CheckCePm(PM_CE_VIEWOWNREPORTS) && CheckCePm(PM_CE_VIEW)==false && CheckCePm(PM_CE_SUPERVISOR)==false){
		$data .= 'var theusr = ' . $actuinfo['accid'] . ';' . "\r\n";
	}else{
		$data .= 'var theusr = ' . $filterusr . ';' . "\r\n";
	}
	
	$data .= 'var theform = ' . $formid . ';' . "\r\n";

	$data .= 'var evalforms = [';
	$first = true;
	foreach($forms as $form)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($form['name']) . '"';
		$data .= ' , id: ' . $form['id'];
		$data .= ' , questions: ' . $form['qcnt'];
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";


	$data .= 'var projects = [';
	$first = true;
	foreach($statsData->projects as $project)
	{
		if (isset($project['not'])) continue;
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($project['name']) . '"';
		$data .= ' , id: ' . $project['id'];
		if (isset($project['avscore']))
		{
			$data .= ' , avscore: ' . (double) round($project['avscore'],0);
		}
		$data .= ' , callcnt: ' . (int) $project['callcnt'];
		$data .= ' , evalcnt: ' . (int) $project['evalcnt'];
		$data .= ' , formid: ' . $project['formid'];
		$data .= ' , formname: "' . JSQuote($project['formname']) . '"';
		if ($perq)
		{
		  for ($qix=0;$qix<count($statsData->questions);$qix++)
		  {
				if (isset($project['avscores'][$qix])==false) continue;
				$score = $project['avscores'][$qix];
				$data .= ', score' . $qix . ': ' . round($score);
			}
		}
		$data .= '}' . "\r\n";
	}
	if ($first) $first = false;
	else $data .= ',';
	$data .= '{ name: "' . JSQuote($lng->Get('Stats.Total')) . '"';
	$data .= ' , id: null';
	if (isset($statsData->total['avscore']))
	{
		$data .= ' , avscore: ' . (double) round($statsData->total['avscore'],0);
	}
	$data .= ' , callcnt: ' . (int) $statsData->total['callcnt'];
	$data .= ' , evalcnt: ' . (int) $statsData->total['evalcnt'];
	if ($perq)
	{
	  for ($qix=0;$qix<count($statsData->questions);$qix++)
	  {
			if (isset($statsData->total['avscores'][$qix])==false) continue;
			$score = $statsData->total['avscores'][$qix];
			$data .= ', score' . $qix . ': ' . round($score);
		}
	}
	$data .= '}' . "\r\n";
	$data .= '];' . "\r\n";

	if ($formid!=-1)
	{
		$data .= 'var questions = [';
		$first = true;
		foreach($statsData->questions as $question)
		{
			if ($first) $first = false;
			else $data .= ',';
			$data .= '{ qtext: "' . JSQuote($question['qtext']) . '"';
			$data .= ' , id: ' . $question['id'];
			$data .= ' , ordering: ' . $question['ordering'];
			$data .= ' , atypeid: ' . $question['atypeid'];
			$data .= '}' . "\r\n";
		}
		$data .= '];' . "\r\n";
	}


  // ready with database
  $dbintf->close();


  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/cerepprojects.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
