<?php

require_once('general.php');
require_once 'cedb.php';
require_once 'listinggen.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$configs_s,$actuinfo,$msg,$lng,$rooturl;

	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}

  if (CheckCePm(PM_CE_MANAGE)==false&&CheckCePm(PM_CE_SUPERVISOR)==false&&CheckCePm(PM_CE_SELFEVALUATE)==false)
  {
    echo 'Permission denied';
    exit;
	}

  $handler = new ListingHandler();
  $handler->filterData = true;
  $handler->search_accepted[] = 'usrnm';
  $handler->viewAuditLogText = 'View AgEv call selection';

  $cedb = new CEDB($dbintf);
  $prjid = -1;
	$prjfilterid = -1;

  $act = str_ensure_defined($_POST['act']);
  if ($act!='')
  {
		$redirect_url = substr($_SERVER['REQUEST_URI'],1);
		$handler->ListingAct($act, $redirect_url);
    if ($act=='removeCallsFromPrj')
    {
      $ce_ids = $_POST['ids'];
      $ce_ids = explode(',',$ce_ids);
      foreach ($ce_ids as $ce_id)
      {
        $ce_id = (int) $ce_id;
        $cecall = $cedb->GetCeCall($ce_id);
        if ($cecall===false) continue;
        if (CheckCePm(PM_CE_MANAGE)==false)
        {
          // then supervisor needs to match
          if ($cecall['supervisor'] != $dbintf->actuinfo['accid'])
          {
            $msg[] = new Msg(MSG_ERR,'Cannot remove call from other supervisor');
            continue;
          }
        }
        $project_id = $cecall['projectid'];
        $recording_id = $cecall['recordingid'];
        LogAction("Remove call from AgEv project",array('project'=>$cedb->GetProjectName($project_id),'call_id'=>$recording_id));
				$cedb->RemoveCeCall($ce_id);
      }
		}
    if ($act=='addCallsToPrj')
    {
			
			$mygroups=$cedb->getMyGroups($actuinfo["accid"]);		
			$subgroups=array();
			$subgroups=array_merge($subgroups, $mygroups);
			foreach($mygroups as $group){
				$subgroups=array_merge($subgroups, $cedb->getSubGroups($group));
			}
			
			$agents=array();
			if(CheckCePm(PM_CE_MANAGE)){
				$agents=$cedb->getAllUsers();
			}else if(CheckCePm(PM_CE_SUPERVISOR)){
				$agents=$cedb->getUsersFromGroups($subgroups);
			}
			
			if(CheckCePm(PM_CE_SELFEVALUATE)){
				array_push($agents, $actuinfo["accid"]);
			}
			
      $recording_ids = $_POST['recids'];
      $recording_ids = explode(',',$recording_ids);
			$project_id = $_POST['prjid'];
			
			$recordingsToAdd=[];
			
      foreach ($recording_ids as $recording_id)
      {			
				$callInfo = $dbintf->GetCallInfo($recording_id);

				$agentFound = -1;
				
				if ($callInfo['agent']!=null)
				{
					if(in_array($callInfo['agent'],$agents)){
						$agentFound=$callInfo['agent'];
					}					
				} else
				{
					$users = $dbintf->GetUsersOfCall($callInfo,false);	
					foreach($users as $user){
						if(in_array($user,$agents)){
							$agentFound=$user;
							continue;
						}					
					}
				}
					
				if($agentFound>-1){
					LogAction("Add call to AgEv project",array('project'=>$cedb->GetProjectName($project_id),'call_id'=>$recording_id) );
					$callCombo = array();
					$callCombo[]=$recording_id;
					$callCombo[]=$agentFound;
					$recordingsToAdd[]=$callCombo;
					
				}else{
					$msg[] = new Msg(MSG_ERR,'Cannot add call from user not assigned to you.');
					$recording_ids=array_diff($recording_ids, array($recording_id));
				}
      }
			$cedb->AddCallsToProject($actuinfo['accid'],$project_id,$recordingsToAdd);
		}
    // redirect to same URL (but without POST data)
    $_SESSION['msg'] = $msg;
    $newurl = $rooturl.$redirect_url;
    if (isset($_POST['prjid']))
    {
			$prjid = (int) $_POST['prjid'];
			$newurl = SetUrlParam($newurl,'prjid',$prjid);
    }
		if (isset($_POST['prjfilterid']))
    {
			$prjfilterid = (int) $_POST['prjfilterid'];
			$newurl = SetUrlParam($newurl,'prjid',$prjid);
    }
    header('Location: '.$newurl);
    exit;
  }

	$handler->ParseSearch();
	
	

	$user_list = $dbintf->GetUserList();
  if (isset($handler->search['usrnm']))
  {
		$usrnm = $handler->search['usrnm'];
		unset($handler->search_use['usrnm']);
		foreach ($user_list as $user)
		{
			if (strtolower($user['name'])==strtolower($usrnm))
			{
				$handler->search_use['usr'] = $user['accid'];
				$handler->search['usrnm'] = $user['name'];
			}
		}
		if (isset($handler->search_use['usr'])==false)
		{
			// try also beginning
			foreach ($user_list as $user)
			{
				if (strtolower(substr($user['name'],0,strlen($usrnm)))==strtolower($usrnm))
				{
					$handler->search_use['usr'] = $user['accid'];
					$handler->search['usrnm'] = $user['name'];
				}
			}
		}
		if (isset($handler->search_use['usr'])==false)
		{
      $msg[] = new Msg(MSG_WRN,'Could not find user');
		}
	}


	$usermap = array();
	foreach ($user_list as &$ref_userinfo)
	{
    $userphones = $dbintf->GetUserPhones($ref_userinfo['accid']);
    $ref_userinfo['phonecnt'] = count($userphones);
		$usermap[ $ref_userinfo['accid'] ] = $ref_userinfo;
	}

 	$projects = $cedb->GetProjects();
 	$projectmap = array();
 	foreach ($projects as $project)
 	{
		$projectmap[$project['id']] = $project;
	}
	
	if (isset($_GET['prjfilterid']))
	{
		$prjfilterid = (int) $_GET['prjfilterid'];
	}
	
	if ($prjfilterid!=-1)
  {
		$handler->search_use['prjid'] = $prjfilterid;
	}

  $handler->listconfig['ceproject'] = 1;
	//if(CheckCePm(PM_CE_SELFEVALUATE) && CheckCePm(PM_CE_EVALUATE)==false && CheckCePm(PM_CE_SUPERVISOR) == false){
	//	$handler->listconfig['ceproject'] = 6;	
	//	$handler->search_use['usr'] = $actuinfo['accid'];
		
	//}	
	
  $handler->listconfig['projects'] = $projectmap; // for CSV export
	$handler->listconfig['usermap'] = $usermap; // for usernames
	$handler->listconfig['addcb'] = 'CeAddExtraRowData';
	$handler->PerformSearch();

	$options = array();
	$options['callback'] = 'CeAddExtraJsCols';

	$calldata = '';
	$calldata .= $handler->GetBasicJsData($options);

  $dbintf->close();

	$data = 'var projects = [';
	$first = true;
	foreach($projects as $project)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ name: "' . JSQuote($project['name']). '"';
		$data .= ' , id: ' . $project['id'];
		$data .= ' , avscore: ' . (double) ensure_defined($project['avscore'], 0.0);
		$data .= ' , callcnt: ' . int_ensure_defined($project['callcnt']);
		$data .= ' , evalcnt: ' . int_ensure_defined($project['evalcnt']);
		$data .= ' , formid: ' . $project['formid'];
		$data .= ' , formname: "' . JSQuote($project['formname']) . '"';
		$data .= '}' . "\r\n";
	}
	$data .= '];' . "\r\n";

	if (isset($_GET['prjid']))
	{
		$prjid = (int) $_GET['prjid'];
	}
	
	$data .= 'var selprjid = ' . $prjid . ';' . "\r\n";
	$data .= 'var prjfilterid = ' . $prjfilterid . ';' . "\r\n";
	
  $calldata .= $data;
  $calldata .= GeneralJSData();


  $template_content = file_get_contents('../apresa/templ/ceselect.htm');
  // template replacements:
  $handler->SetDefReplacements();
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
  $rpl['data'] = $calldata;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>