<?php
// Agent Evaluation unit with shared code



function addNewCallsToProject($schedule,$cedb){
	global $dbintf, $msg;

	$amount=$schedule['callcnt'];
	$project=$schedule['project'];
  // because we might not load all calls,
  // we prefer new calls,
  // so we sort on startdate descending
	$sk="startdate";
	$sd="desc";
  // NOTE: the full call list can be too large to fit in memory
	$listconfig['allrecords'] = false;
  $listconfig['startfrom'] = 0;
  $listconfig['checkrange'] = $listconfig['loadrange'] = 10 * 1000;
	
	$search=StringToArray($schedule['qspec']);
	
  // move last date from beginning of the day to the end of the day
  if (isset($search['ld']))
  {
    $ld = $search['ld'];
    // next day
    $ld = $ld + 60 * 60 * 24;
    $search['ld'] = $ld;
  }
	
	$mygroups=$cedb->getMyGroups($schedule['supervisor']);	
	
	$controlledgroups=array();
	$controlledgroups=array_merge($controlledgroups, $mygroups);
	foreach($mygroups as $group){
		$controlledgroups=array_merge($controlledgroups, $cedb->getSubGroups($group));
	}
	
	$agents=$cedb->getUsersFromGroups($controlledgroups);
  
	$user_list = $dbintf->GetUserList();
	if (isset($search['usrnm'])){
    $usrnm = $search['usrnm'];
    unset($search['usrnm']);
    foreach ($user_list as $user){
      if (strtolower($user['name'])==strtolower($usrnm)&&in_array($user['accid'],$agents)){
        $search['usr'] = $user['accid'];
				break;
      }else{
				$search['usr'] = "NULL";
			}
    }
		
    if (isset($search['usr'])==false){
			// try also beginning
			foreach ($user_list as $user){
				if (strtolower(substr($user['name'],0,strlen($usrnm)))==strtolower($usrnm)&&in_array($user['accid'],$agents)){
					$search['usr'] = $user['accid'];
				}else{
					$search['usr'] = "NULL";
				}
			}
		}
		
		if (isset($search['usr'])==false){
			$msg[] = new Msg(MSG_WRN,'Could not find user '.$usrnm);
      return false;
		}
	}else{
		$first=true;
		if(count($agents)<=0){
			$search['usr']="NULL";
		}
		foreach($agents as $agent){
			if($first){
				$first=false;
			}else{
				$search['usr'].=",";
			}
			$search['usr'].=$agent;
		}
		
	}
	if($schedule['add_per_id']==1){
		$idsplit=explode(",",$search['id']);
	}else{
		$idsplit[0]=$search['id'];
	}
	
	$addedcount=0;
	foreach($idsplit as $id){
		
		$search['id']=$id;
		$callList = $dbintf->getCallList($sk,$sd,$search,$listconfig);
		// remove cnt info
		unset($callList['cnt']);
		// the others are real calls
		$maxCalls = count($callList);
		
		// we have a list of candidate calls
		// now determine which of those to add
		$callsToAdd=array();
		$toadd = $amount;
		// if we have considered randomly x times the amount of calls
		// there might be not enough to add, so then we stop
		for ($i = 0; $i < $maxCalls * 4 ; $i ++ )
		{
			// we stop if we added the number we wanted
			if ($toadd<=0) break;

			// choose one randomly
			$listix = rand(0,$maxCalls-1);
			
			// determine id of call
			$callid = $callList[ $listix ]['id'];
			$user = $callList[ $listix ]['useraccid'];
			if( !in_array(array($callid,$user),$callsToAdd) && $cedb->isCallInProject(intval($schedule['supervisor']), intval($callid), intval($project))==0 )
			{
				$callsToAdd[]=array($callid,$user);
				$toadd --;
			}
		}

		$result = $cedb->AddCallsToProject(intval($schedule['supervisor']), intval($project) ,$callsToAdd);	
		$addedcount+=$result['added'];
		
	}
	if ($result != NULL){
		$msg[] = new Msg(MSG_INF,'Added ' . $addedcount . ' calls for schedule ' . $schedule['name']);
	}
	return $result;
	
}

function triggerSchedules($userid, $cedb){
	global $dbintf, $msg;
	$schedules = $cedb->GetSchedules($userid);
	$reRun=false;
	foreach($schedules as $schedule){
		
		$curDate=time();
		$nextTrigger=$schedule['nexttrigger'];
		
		if($curDate>$nextTrigger&&$nextTrigger!=''){
			//Ready to Trigger
			
			$result=addNewCallsToProject($schedule,$cedb);
			
			$lastTrigger=$nextTrigger;
			$newTriggerDate = new DateTime();
			$newTriggerDate->setTimestamp($nextTrigger);
			
			if($result!=NULL){
				$msg[count($msg)-1] = new Msg(MSG_INF,'Added ' . $result['added'] . ' calls for schedule ' . $schedule['name'].' on ' .$newTriggerDate->format('d-m-Y'));
			}
			
			switch ($schedule['type']) {
				case 0:
					$newTriggerDate->modify("+1 days");
					break;
				case 1:				
					$newTriggerDate->modify("+1 weeks");
					break;
				case 2:						
					$newTriggerDate->modify("+1 months");
					break;
			}
			
			if($schedule['moving']=="true"){
				$search=StringToArray($schedule['qspec']);
				$fd=$search['fd'];
				$ld=$search['ld'];
				
				$newTriggerFD = new DateTime();
				$newTriggerFD->setTimestamp($fd);
				
				$newTriggerLD = new DateTime();
				$newTriggerLD->setTimestamp($ld);
				
				switch ($schedule['type']) {
				case 0:
					$newTriggerFD->modify("+1 days");
					$newTriggerLD->modify("+1 days");
					break;
				case 1:				
					$newTriggerFD->modify("+1 weeks");
					$newTriggerLD->modify("+1 weeks");
					break;
				case 2:						
					$newTriggerFD->modify("+1 months");
					$newTriggerLD->modify("+1 months");
					break;
				}
				$search['fd']=$newTriggerFD->getTimestamp();
				$search['ld']=$newTriggerLD->getTimestamp();
				$schedule['qspec']=ArrayToString($search);
			}
			$cedb->EditSchedule($schedule['id'], $schedule['name'],$schedule['type'],$schedule['day'],$schedule['moving'],$newTriggerDate->getTimestamp(),$lastTrigger,$schedule['callcnt'],$schedule['add_per_id'],$schedule['supervisor'],$schedule['project'],$schedule['qspec']);
			if($newTriggerDate->getTimestamp()<$curDate){
				$reRun=true;
			}
		}
	}
	if($reRun){
		triggerSchedules($userid, $cedb);
	}
}

?>