<?php

$CLIENT = 1;
$webclient = false;
$webinternal = false;
if( (isset($_GET['webclient']) && $_GET['webclient'] == 'true')
 || (isset($_POST['webclient']) && $_POST['webclient'] == 'true')
 ) 
{
  $webclient = true;
} else {
	if (isset($_GET['webinternal']) && $_GET['webinternal']=='1') $webinternal = true;
  else $NOSESSIONS = true;
}

if ($CLIENT
&& isset($_GET['info'])
&& $_GET['info'] == 'ActiveCalls'
&& file_exists('/var/apresa/conf/opt_clientcon')
)
{
  // use client connector to reduce load on server
  // it also does login checking
  require_once('utility.php');
  require_once('datafile.php');

	$start_time = microtime(true);
  
  $wait_for_change = int_ensure_defined($_GET['wait']);
  if ($wait_for_change>60)
  {
    // never wait longer than one minute
    $wait_for_change = 60;
  }
  
  $request = array
  ( 'pc' => str_ensure_defined($_GET['pcname'])
  , 'info' => 'ActiveCalls'
  );
  
  if ($webclient)
  {
    session_start();
    if (!isset($_SESSION['uid']))
    {
      echo "Error: NotLoggedIn";
      return;
    }    
    $request['uid'] = $_SESSION['uid'];
  } else
  {
    $request['usr'] = $_GET['username'];
    $request['pwd'] = $_GET['password'];
  }
  
  $reply = array();
  $reply['RequestedInfo'] = 'ActiveCalls';
  $reply['Tech'] = 'cc';
  
  $RequeryTime = 500;
  
  $loop_cnt = 0;
  while (true)
  {
    $loop_cnt ++;

    $ccreply = AskClientConnector( $request );
    if ($ccreply['r']!=0)
    {
      $m = $ccreply['m'];
      $Error = $ccreply['m'];
      if ($m=='login') $Error = 'NotLoggedIn';
      $reply['Error'] = $Error;
			if ($webclient) echo json_encode($reply);
			else echo ArrayToString($reply);
      // some error
      exit;
    }
    $calls = $ccreply['list'];
    $phone_list = $ccreply['ph'];

    $idstr = CallListIdsStr($calls,$phone_list);
    $reply['Know'] = $idstr;
    if($webclient)
    {
      $reply['List'] = CallListDetailsJSON_CC($calls);
    }
    else
    {
      $reply['List'] = CallListDetails_CC($calls);
    }
    
    // Check if we must wait for a change.
    // If so compare our answer with what the client already knows.
    // And check if we have waited long enough.
    if ($wait_for_change
    && $idstr==$_GET['know']
    && microtime(true)<$start_time+$wait_for_change)
    {
      // output something to detect if we still have a connection
      if(!$webclient) echo "_$loop_cnt: \r\n";
      @flush();
      @ob_flush();
      if (connection_status()!=0)
      {
        // we have lost connection, so stop
        break;
      }
      // Sleep for a some time (def. was 500 ms)
      usleep($RequeryTime*1000);
    } else
    {
      break;
    }
  } // while loop

  if ($webclient)
  {
    echo json_encode($reply);
    exit;
  }
  echo ArrayToString($reply);
  exit;
  
}

require_once('general.php');
require_once('utility.php');
require_once('callhandler.php');
try{
	echo HandleClient();
} catch(Exception $e)
{
	echo 'Error: Exception';
}
exit;

function HandleClient()
{
	global $dbintf,$uid,$configs,$configs_o,$configs_s;

	$reply = array();
	
	$webclient = false;
	if(str_ensure_defined($_GET['webclient']) == 'true')
	{
		$webclient = true;
	}
	
	// general.php handles login
	// UID is now set or not
	// uid: User ID. This is only set when logged in
	if (!isset($uid) || $uid<0)
	{
		// not logged in
    $reply['Error'] = "NotLoggedIn";
    
    if($webclient)
    {
      header('Content-Type: application/json');
      return json_encode($reply);
    }
    
		return ArrayToString($reply);
	}
	
	if ($webclient)
	{
		if ( ($dbintf->actuinfo['permissions']&PM_WEBCLIENT) == 0 )
		{
			$reply['Error'] = "NoWebclientPm";
			header('Content-Type: application/json');
			return json_encode($reply);
		}
	}

	// We are logged in.
	// Process any requests

	$start_time = microtime(true);
  
  $RequeryTime = int_ensure_defined($configs['ClientRequeryTime']);
  if ($RequeryTime==0)
  {
    $RequeryTime = 500;
  }

  $uaccid = $dbintf->actuinfo['accid'];
  $phone_list = $dbintf->GetUserPhones($uaccid);
  // debug: $reply['Phones'] = count($phone_list);

	// Test if a file is uploaded
	if (isset($_FILES['fileupl']))
	{
    $upl = $_FILES['fileupl'];
		if (file_exists('../apresa/conf/compact'))
		{
      $reply['Error'] = 'Not supported in Compact Edition.';
		} else if ($upl['error']!=0)
    {
      // error in upload
      $reply['Error'] = 'Error in file upload: '.GetUploadErrDescr($upl['error']);
    } else if (is_uploaded_file($upl['tmp_name'])==false)
    {
			$reply['Error'] = 'It is not an uploaded file';
		} else
    {
			// there is a good upload
			$id = $_POST['id']; // is remoteid
		  $info = $dbintf->GetCallInfoRM($id);
			$ainfo = $dbintf->GetActiveCallInfoRM($id);

			if (!isset($info['filename']))
			{
				if (isset($ainfo['filename']))
				{
					// This may happen if the file is not yet converted,
					// and added to the main database.
					// The client must retry.
					$reply['Error'] = 'Call not ready yet';
				} else
				{
					$reply['Error'] = 'Unknown call';
				}
			} else if ( ($dbintf->GetCallPermissions($info) & PM_PLAY)==0
			&& ($dbintf->GetCallPermissions($info) & PM_DOWNLOAD)==0 )
		  {
				$reply['Error'] = 'Permission denied';
		  } else
			{
				$screen_extension = '.' . get_filename_extension($upl['name']);
				// we have found the call in the database
				// deduce the screen recording file name
			  $filename = 'screen' . change_filename_extension($info['filename'],$screen_extension);
			  $dst = AUDIO_PATH.'/'.$info['directory'].'/'.$filename;
				
				if (int_ensure_defined($configs['ALEweb'])!=0)
				{
					// call-content encryption
					$finalDst = $dst;
					if ($dbintf->GetConfigValue('AleDisk')=='1')
					{
						// dont use dev shm here
						$dst = $dst . '.tmp';
					} else
					{
						if (IsEnoughSpaceAvailOnDevShm( $upl['size'] )==false)
						{
							$reply['Error'] = 'Not enough space in /dev/shm';
							return ArrayToString($reply);
						}
						$parts = pathinfo($dst);
						$dir = '/dev/shm/apresa/'.substr($parts['dirname'],12);
						@mkdir($dir,0777,TRUE);
						$dst = $dir . '/upl_' . $parts['basename'];
					}
				}

				// debugging: $reply['FileName'] = $dst;

				// move the file to the destination place
	      if (@move_uploaded_file($upl['tmp_name'],$dst)==false)
	      {
					$reply['Error'] = 'Could not move uploaded file';
				} else
				{
					if ($configs['ALEweb']!=0)
					{
						// encryption
						$cmdToExec = 'apresa_crypt -e -i '.$dst.' -o '.$finalDst;
						$retValue = 999;
						$dummyOutput = array();
						exec($cmdToExec,$dummyOutput,$retValue);
						// remove source unencrypted file
						if (file_exists($dst))
						{
							DeleteFn($dst);
						}
						if ($retValue!=0)
						{
							lg('Screen recording encryption error '.$retValue);
							$reply['Error'] = 'Encryption error';
							return ArrayToString($reply);
						}				
					}
				
					if ($info['tenantid']!=NULL)
					{
						require_once 'tenancy.php';
						$fullfn = AUDIO_PATH.'/'.$info['directory'].'/'.$filename;
						UpdateTnDiskUsage( $info['tenantid'], filesize($fullfn), 0);
					}
					$dbintf->SetCallInfo($info['id']
					, array( 'screenfn' => $filename )
					);
					// Finally, we must set a flag
					$dbintf->SetFlagOnForIDs(array($info['id']),2);
					// ApresaClient specifically checks on this.
	      	$reply['Result'] = 'UploadOk';
					$reply['Id'] = $id;
	   		}
	   	}
    }
  // Is info requested?
  } else if (isset($_GET['info']))
	{
		// When requesting info there is a special feature for waiting on a change.
		// This allows for faster and more efficient communication.
		
		$wait_for_change = int_ensure_defined($_GET['wait']);
		if ($wait_for_change>60)
		{
			// never wait longer than one minute
			$wait_for_change = 60;
		}

		$info = $_GET['info'];
		if ($info=='ActiveCalls')
		{
      $reply['RequestedInfo'] = $info;
			// this is done periodically by the client
			
			// check setting
			if ($dbintf->actuinfo['customlocalid']!=0)
			{
				$DstContactId = $dbintf->GetCustomLocalContactId();
				$dbintf->AddOrUpdateLocalIdMapping($phone_list, $DstContactId );
			}
			
			// Apresa Client, filter out phones on which the listing
			// permission is not available
			if(!$webclient)
			{
				$phone_listf = array();
				foreach($phone_list as $phone)
				{
          $toadd = false;
          // generic permission (everyone)
          if ( ($dbintf->actuinfo['permissions']&PM_LIST) != 0)
          {
            $toadd = true;
          }
          // specific permission
					if(array_key_exists($phone, $dbintf->ctpms))
					{
						if($dbintf->ctpms[$phone]&PM_LIST==0) continue;
            $toadd = true;
					}
          if ($toadd)
          {
						$phone_listf[] = $phone;
          }
				}
				$phone_list = $phone_listf;
			}
			
			$loop_cnt = 0;
			while (true)
			{
				$loop_cnt ++;
				// use phone list for filtering (only own phones)
				$calls = $dbintf->GetActiveCallList_CTs($phone_list);

				$idstr = CallListIdsStr($calls,$phone_list);
				$reply['Know'] = $idstr;
				if($webclient)
				{
					$reply['List'] = CallListDetailsJSON($calls,$phone_list);
				}
				else
				{
					$reply['List'] = CallListDetails($calls,$phone_list);
				}
				
				// Check if we must wait for a change.
				// If so compare our answer with what the client already knows.
				// And check if we have waited long enough.
				if ($wait_for_change
				&& $idstr==$_GET['know']
				&& microtime(true)<$start_time+$wait_for_change)
				{
					// output something to detect if we still have a connection
					if(!$webclient) echo "_$loop_cnt: \r\n";
					@flush();
					@ob_flush();
					if (connection_status()!=0)
					{
						// we have lost connection, so stop
						break;
					}
					// Sleep for a some time (def. was 500 ms)
					usleep($RequeryTime*1000);
				} else
				{
					break;
				}
			}
			
			if($webclient)
			{
				header('Content-Type: application/json');
				return json_encode($reply);
			}
			
		} else if ($info=='AllActiveCalls')
		{
      $reply['RequestedInfo'] = $info;
			// for Supervisor client
			$loop_cnt = 0;
			while (true)
			{
				$loop_cnt ++;
				// no extra filtering, only normal user filtering
				$calls = $dbintf->GetActiveCallList();

				//$reply['Count'] = count($calls);
				$idstr = CallListIdsStr($calls,$phone_list);
				$reply['Know'] = $idstr;
				$reply['List'] = SupervisorCallList($calls);
				$reply['ServerTime'] = time();

				// Check if we must wait for a change.
				// If so compare our answer with what the client already knows.
				// And check if we have waited long enough.
				if ($wait_for_change && $idstr==$_GET['know'] && microtime(true)<$start_time+$wait_for_change)
				{
					// output something to detect if we still have a connection
					echo "_$loop_cnt: \r\n";
					@flush();
					@ob_flush();
					if (connection_status()!=0)
					{
						// we have lost connection, so stop
						break;
					}
					// Sleep for a some time (in micro, not milliseconds)
					usleep($RequeryTime*1000);
				} else
				{
					break;
				}
			}
		} else if ($info=='IsReady')
    {
      $reply['RequestedInfo'] = $info;
			$id = $_GET['id']; // is remoteid
			$ainfo = $dbintf->GetActiveCallInfoRM($id);
		  $info = $dbintf->GetCallInfoRM($id);

			if (!isset($info['filename']))
			{
				if (isset($ainfo['filename']))
				{
					// This may happen if the file is not yet converted,
					// and added to the main database.
					// The client must retry.
					$reply['Result'] = 'NotReady';
				} else
				{
					$reply['Result'] = 'Unknown';
				}
			} else
			{
        $reply['Result'] = 'Ready';
      }
      
		} else if ($info=='AudioFile')
		{
      $reply['RequestedInfo'] = $info;
			$id = $_GET['id']; // is remoteid
			$ainfo = $dbintf->GetActiveCallInfoRM($id);
		  $info = $dbintf->GetCallInfoRM($id);

			if (!isset($info['filename']))
			{
				if (isset($ainfo['filename']))
				{
					// This may happen if the file is not yet converted,
					// and added to the main database.
					// The client must retry.
					$reply['Error'] = 'Call not ready yet';
				} else
				{
					$reply['Error'] = 'Unknown call';
				}
			} else
			{
				$handler = new CallHandler();
				$handler->errorEcho = false;
				$handler->ids = array( $info['id'] );
        if ( int_ensure_defined($_GET['merging']) == 1)
        {
          $handler->download = false;
          $handler->embed = true;
        }
				$handler->Perform();
				if ($handler->good==false)
				{
					$reply['Error'] = $handler->errmsg;
				} else
				{
					exit;
				}
			}
		} else if ($info=='RTCall')
		{
      $reply['RequestedInfo'] = $info;
			// real-time monitoring
			RealTimeMonitor($reply);
			exit;
		} else if ($info=='Categories')
		{
      $reply['RequestedInfo'] = $info;
			$reply['CatCnt'] = 10;
			// loaded from database
			for ($i=1;$i<=10;$i++)
			{
				$reply['CatLabel'.$i] = $dbintf->GetConfigValue('CatLabel'.$i);
			}
			// taken from css (inline) in systemopt.htm
			$defcolors = GetDefaultCategoryColors();
      for ($i=1;$i<=10;$i++)
      {
        if (!isset($configs['CatColor'.$i]))
        {
          $configs['CatColor' . $i] = $defcolors[$i-1];
        }
        $catColors[] = $configs['CatColor' . $i];
				$reply['CatColor'.$i] = $configs['CatColor' . $i];
			}
      $reply['KodDelay'] = (int) $dbintf->GetConfigValue('StoreOnDemandDelay');
		}

	} else if ($_POST['act']=='silence' || $_POST['act']=='sound'
		|| $_POST['act']=='start' || $_POST['act']=='stop'
    || $_POST['act']=='delete'
		)
	{
		$recid = str_ensure_defined($_POST['id']); // is remoteid

		// get data of this call (permission is checked)
    $data = $dbintf->GetActiveCallInfoRM($recid);
    if ($data==false)
    {
			$reply['Error'] = 'Unknown call';
		} else
		{
      // audit
      $descr = GetAuditActionDescr($_POST['act']);
      LogAction($descr,array('local'=>$data['localfull'],'remote'=>$data['remotefull']));
      // spin
      NotifySpinServer( $_POST['act'] , $data );
			// send msg
			// 1: analog, 5: digital TDM, 6: PRI
			$signal_reply = true;
			$err = '';
			if ($data['source']==1 || $data['source']==5 || $data['source']==6)
			{
				$err = signal_service('sgncrc '.$_POST['act'].' '.$recid,$signal_reply);
			} else
			{
				$err = signal_service('sgnork '.$_POST['act'].' '.$recid,$signal_reply);
			}
			if ($err!='')
			{
				$reply['Error'] = 'Signaling: ' . $err;
			}
			if ($signal_reply=='OK')
			{
        $reply['Result'] = 'ActOk';
			} else
			{
				$reply['Error'] = 'Reply: "' . $signal_reply . '"';
			}
		}
	}	else if ($_POST['act']=='notes' || $_POST['act']=='notes2'
		|| $_POST['act']=='categorize'
	)
	{
		$recid = str_ensure_defined($_POST['id']); // is remoteid
		// get data of this call
    $data = $dbintf->GetActiveCallInfoRM($recid);
    if ($data==false)
    {
    	$data = $dbintf->GetCallInfoRM($recid);
    	if ($data==false)
    	{
				$reply['Error'] = 'Unknown call';
			} else if ( ($dbintf->GetCallPermissions($data) & PM_NOTES)==0 )
		  {
				$reply['Error'] = 'Permission denied';
			} else
			{
				if ($_POST['act']=='notes')
				{
					$dbintf->EditRecordingNotes($data['id'],$_POST['notes']);
				} else if ($_POST['act']=='notes2')
				{
					$dbintf->EditRecordingNotes2($data['id'],$_POST['notes']);
				} else if ($_POST['act']=='categorize')
				{
					$dbintf->EditRecordingCategory($data['id'],$_POST['category']);
				}
				$reply['Result'] = 'ActOk';
			}
		} else if ( ($dbintf->GetCallPermissions($data) & PM_NOTES)==0 )
	  {
			$reply['Error'] = 'Permission denied';
		} else
		{
			if ($_POST['act']=='notes')
			{
				$dbintf->EditActiveRecordingNotes($data['id'],$_POST['notes']);
			} else if ($_POST['act']=='notes2')
			{
				$dbintf->EditActiveRecordingNotes2($data['id'],$_POST['notes']);
			} else if ($_POST['act']=='categorize')
			{
				$dbintf->EditActiveRecordingCategory($data['id'],$_POST['category']);
			}
	    $reply['Result'] = 'ActOk';
	  }

	}	else if ($_POST['act']=='keep')
	{
		// keep command for store on demand
		$recid = $_POST['id']; // is remoteid
		// get data of this call
    $data = $dbintf->GetActiveCallInfoRM($recid);
    if ($data==false)
    {
      $reply['Error'] = 'Unknown call';
		} else
		{
			// $StoreOnDemandDelay = (int) $dbintf->GetConfigValue('StoreOnDemandDelay');
			// audit
      $descr = GetAuditActionDescr($_POST['act']);
      LogAction($descr,array('local'=>$data['localfull'],'remote'=>$data['remotefull']));
      // spin
      NotifySpinServer( $_POST['act'] , $data );
      if ( ($data['processingstate']&128) != 0)
      {
        require_once('actions.php');
        KeepPendingStoreOnDemand($data);
      } else
      {
        // normal flow
        // unpack
        $callextra = StringToArray($data['callextra']);
        // set option
        $callextra['to-keep'] = '1';
        // pack again
        $newdata = array('callextra' => ArrayToString($callextra) );
        // store in database
        $dbintf->SetActiveCallInfoRM($recid,$newdata);
      }
      $reply['Result'] = 'ActOk';
	  }
	}else if($_POST['act'] == 'storesettings')
	{
		$settings = $_POST['settings'];
		$result = $dbintf->SetWebClientSettingsUser($uaccid, $settings);
		
		if($result)
		{
			$reply['Result'] = 'ActOk';
		}
		else
		{
			$reply['Error'] = 'Failed to store web client settings';
		}
		
	}
	else
	{
		$reply['Error'] = 'No command, act='.$_POST['act'];
	}

	return ArrayToString($reply);
}

function SupervisorCallList($calls)
{
	$ret = '[';
  $first = true;
	foreach ($calls as $call)
	{
    if (!$first) $ret .= ',';
    $first = false;
		$ret .= '{id:' . $call['id']
		. ',remoteid:"' . $call['remoteid'].'"'
		. ',startdate:'.$call['startdate']
    . ',remote:"'.$call['remote'].'"'
    . ',local:"'.$call['local'].'"'
    . ',connected:"'.$call['connected'].'"'
    . ',lname:"'.JSQuote(EmptyNull($call['lname'])).'"'
    . ',rname:"'.JSQuote(EmptyNull($call['rname'])).'"'
    . ',cname:"'.JSQuote(EmptyNull($call['cname'])).'"'
    . ',remote2:"'.$call['remote2'].'"'
    . ',local2:"'.$call['local2'].'"'
    . ',direction:' . $call['direction']
    . ',linenr:' . (int) $call['linenr']
		. '}';
	}
	$ret .= ']';
	return $ret;
}

function CallListDetails_CC($calls)
{
  $first = true;
	$ret = '[';
	foreach ($calls as $call)
	{
		$callextra = StringToArray($call['callextra']);
		
    if (!$first) $ret .= ',';
    $first = false;
		$ret .= '{id:' . $call['remoteid'];
		$isremote = ($call['side']==2);
		if ($isremote==false)
		{
			$outgoing = $call['direction']!=0;
			$ret .= ',oid:"' . JSQuote($call['remote']) . '"'
			 . ',on:"' . JSQuote($call['rname']) . '"';
		} else
		{
			$outgoing = $call['direction']==0;
			$ret .= ',oid:"' . JSQuote($call['local']) . '"'
			 . ',on:"' . JSQuote($call['lname']) . '"';
		}
		$ret .= ',out:' . (int)$outgoing;
		$ret .= ',sd:' . (int)$call['startdate'];
		$ret .= ',a:' . (int)$call['isarchived'];
		$ret .= ',sil:' . int_ensure_defined( $callextra['silencing'] );
		$ret .= '}';
	}
	$ret .= ']';
	return $ret;
}

function CallListDetails($calls,$phone_list)
{
	$ret = '[';
  $first = true;
	foreach ($calls as $call)
	{
		$callextra = StringToArray($call['callextra']);
    if (!$first) $ret .= ',';
    $first = false;
		$ret .= '{id:' . $call['remoteid'];
		$isremote = false;
		if (in_array($call['remotecontact'],$phone_list))
		{
			$isremote = true;
		}
		if ($isremote==false)
		{
			$outgoing = $call['direction']!=0;
			$ret .= ',oid:"' . JSQuote($call['remote']) . '"'
			 . ',on:"' . JSQuote($call['rname']) . '"';
		} else
		{
			$outgoing = $call['direction']==0;
			$ret .= ',oid:"' . JSQuote($call['local']) . '"'
			 . ',on:"' . JSQuote($call['lname']) . '"';
		}
		$ret .= ',out:' . (int)$outgoing;
		$ret .= ',sd:' . (int)$call['startdate'];
		$ret .= ',a:' . (int)$call['isarchived'];
		$ret .= ',sil:' . int_ensure_defined( $callextra['silencing'] );
    $ret .= ',keep:' . int_ensure_defined( $callextra["to-keep"] );
		$ret .= '}';
	}
	$ret .= ']';
	return $ret;
}

function CallListDetailsJSON($calls,$phone_list)
{
	global $dbintf, $configs;
	$configs_o = $dbintf->LoadConfigsPart('o');
	$StoreOnDemand = int_ensure_Defined($configs_o['RecOnDemand']);
	
	if($dbintf->actuinfo['rod'] == 1)
	{
		$StoreOnDemand = true;
	}
	else if($dbintf->actuinfo['rod'] == 2)
	{
		$StoreOnDemand = false;
	}
	
	$ret = array();
	foreach ($calls as $call)
	{		
		$jsonobj = array();
		$callextra = StringToArray($call['callextra']);
		
		$jsonobj['id'] = $call['remoteid'];
		$isremote = false;
		if (in_array($call['remotecontact'],$phone_list))
		{
			$isremote = true;
		}
		if ($isremote==false)
		{
			$outgoing = $call['direction']!=0;
			$jsonobj['oid'] = $call['remote'];
			$jsonobj['on'] = $call['rname'];
		} else
		{
			$outgoing = $call['direction']==0;
			$jsonobj['oid'] = $call['local'];
			$jsonobj['on'] = $call['lname'];
		}
		$jsonobj['out'] = (int)$outgoing;
		$jsonobj['sd'] = date($configs['datetimef'],$call['startdate']);
		$jsonobj['sdf'] = date($configs['datef'],$call['startdate']);
		$jsonobj['stf'] = date($configs['timef'],$call['startdate']);
		if ($call['startms']!=NULL && (int_ensure_defined($configs['timeformat'])==1) )
    {
       $jsonobj['st'] .= '.' . str_pad($call['startms'],3,'0',STR_PAD_LEFT);
    }
		$jsonobj['a'] =  (int)$call['isarchived'];
		$jsonobj['sil'] =int_ensure_defined($callextra['silencing']);
		$jsonobj['notesw'] = EmptyNull($call['notes']);
		$jsonobj['notesw2'] = EmptyNull($call['notes2']);
		$jsonobj['category'] = EmptyNull($call['category']);
		
		if($StoreOnDemand)
		{
			if(!int_ensure_defined($callextra['to-keep']))
			{
				$jsonobj['sod'] = 0; // Will not be stored
			}
			else
			{
				$jsonobj['sod'] = 1; // Will be stored
			}
		}
		else
		{
			$jsonobj['sod'] = 2; // Off, will be stored
		}
		
		$ret[] = $jsonobj;
	}
	return $ret;
}

function CallListDetailsJSON_CC($calls)
{
	$ret = array();
	foreach ($calls as $call)
	{		
		$jsonobj = array();
		$callextra = StringToArray($call['callextra']);
		
		$jsonobj['id'] = $call['remoteid'];
		$isremote = ($call['side']==2);
		if ($isremote==false)
		{
			$outgoing = $call['direction']!=0;
			$jsonobj['oid'] = $call['remote'];
			$jsonobj['on'] = $call['rname'];
		} else
		{
			$outgoing = $call['direction']==0;
			$jsonobj['oid'] = $call['local'];
			$jsonobj['on'] = $call['lname'];
		}
		$jsonobj['out'] = (int)$outgoing;
		$jsonobj['sd'] = $call['sd'];
		$jsonobj['sdf'] = $call['sdf'];
		$jsonobj['stf'] = $call['stf'];

		$jsonobj['a'] = (int)$call['isarchived'];
		$jsonobj['sil'] = int_ensure_defined( $callextra['silencing'] );
		$jsonobj['notesw'] = EmptyNull($call['notes']);
		$jsonobj['notesw2'] = EmptyNull($call['notes2']);
		$jsonobj['category'] = EmptyNull($call['category']);
    
    $jsonobj['sod'] = $call['sod'];
		
		$ret[] = $jsonobj;
	}
	return $ret;
}


function CallListIdsStr($calls,$phone_list)
{
	$arr = array();
	foreach ($calls as $call)
	{
		$callextra = StringToArray($call['callextra']);
		$t = $call['id'] . '(';
		$isremote = false;
		if (in_array($call['remotecontact'],$phone_list))
		{
			$isremote = true;
		}
		if ($isremote==false)
		{
			$t .= $call['remote'];
		} else
		{
			$t .= $call['local'];
		}
		$t .= ',' . int_ensure_defined( $callextra['silencing'] );
    $t .= ',' . int_ensure_defined( $callextra["to-keep"] );
		$t .= ')';
		$arr[] = $t;
	}
	return implode(',',$arr);
}

function CallListIdsStrOld($calls)
{
	$arr = array();
	foreach ($calls as $call)
	{
		$arr[] = $call['id'];
	}
	return implode(',',$arr);
}

function HdrEchoArray(&$reply)
{
	echo ArrayToString($reply);
	echo "\0";
}

function RealTimeMonitor(&$reply)
{
	global $dbintf;

	$remid = $_GET['remid'];
  $reply['remid'] = $remid;

  $info = $dbintf->GetActiveCallInfoRM($remid);
  if ($info==false)
  {
		$reply['Error'] = 'Unknown call';
  	HdrEchoArray($reply);
  	exit;
	}
  $pm = $dbintf->GetCallPermissions($info);
	if ( ($pm&(PM_ACTIVEPLAY))==0 )
	{
		$reply['Error'] = 'Permission denied';
  	HdrEchoArray($reply);
  	exit;
	}

	$thisOneEncrypted = ($info['flags']&16) != 0 || ($info['flags'] & 2048) != 0;
	if ($thisOneEncrypted)
	{
		if ($dbintf->GetConfigValue('AleDisk')=='1')
		{
			$AudioPath = '/recordings/rectmp';
		} else
		{
			$AudioPath = '/dev/shm/apresa';
		}
	} else
	{
		$AudioPath = AUDIO_PATH;
	}
	$filename = $AudioPath . '/' . $info['directory'] . '/' . change_filename_extension($info['filename'],'.raw');
	if (file_exists($filename)==false)
	{
		// it seems crec does this for mp3
		$filename = $AudioPath . '/' . $info['directory'] . '/' . $info['filename'] . '.raw';
	}
	if (file_exists($filename)==false)
	{
		$reply['Error'] = 'File not found';
  	HdrEchoArray($reply);
  	exit;
	}

	// first write some sort of header
	// and stop with 0 byte
	$infofn = $AudioPath . '/' . $info['directory'] . '/' . change_filename_extension($info['filename'],'.info');
	if (file_exists($infofn)==false)
	{
		// it seems crec does this for mp3
		$infofn = $AudioPath . '/' . $info['directory'] . '/' . $info['filename'] . '.info';
	}
	if (file_exists($infofn)==false)
	{
		$reply['Error'] = 'Info file not found';
  	HdrEchoArray($reply);
  	exit;
	}
	// not closing the session would cause other requests to stall
	session_write_close();

	$infoKv = array();
	$infoLines = file($infofn);
	foreach ($infoLines as $line)
	{
		$colonPos = strpos($line,':');
		if ($colonPos===false) continue;
		$key = substr($line,0,$colonPos);
		$value = substr($line,$colonPos+2);
		$infoKv[$key] = $value;
	}
	// G711 8 kHz
	$bytesPerSecond = 8000;
	$blockAlign = 1;
	if (isset($infoKv['Channels']))
	{
		$chcnt = (int) $infoKv['Channels'];
		$bytesPerSecond *= $chcnt;
		$blockAlign *= $chcnt;
	}
	
	header('Content-Type: application/octet-stream');
	
	// output content of file
	readfile($infofn);
	// and trailing zero byte
	echo "\0";

	// prepare to write audio data

	$last_datatime = time();
	$err_timeout = 10;

	$lagbytes = 0;
	$lagseconds = (int) $_GET['offset'];
	if ($lagseconds>0) $lagseconds = 0;
	$lagbytes = -$lagseconds * $bytesPerSecond;
	
	$size = filesize($filename);
	$startpos = $size - $lagbytes;
	$seekpos = $startpos;
	if ($seekpos<0) $seekpos = 0;

	$filehandle = fopen($filename,'rb');
	if (!$filehandle)
	{
		$reply['Error'] = 'File not found';
  	HdrEchoArray($reply);
  	exit;
	}
	fseek($filehandle,$seekpos);
	$pos = $seekpos;
	$bufferpos = $seekpos;
	$starttime = microtime(true);
	$buffer = '';

	while (true)
	{
		if ($err_timeout!=-1 && time()-$last_datatime>=$err_timeout)
		{
			// time-out (debug)
			break;
		}
		if (connection_aborted()) break;
	
		//if ($toread<=0) break;
		//echo $toread;
		$toread = 2*8000;
	
		$content = fread($filehandle,$toread);
		$read = strlen($content);
		//echo '<BR>Read '.$read;
		if ($read==0)
		{
			if (file_exists($filename)==false)
			{
				break;
			}
			usleep(50 * 1000); // 50 ms
			continue;
		}
	
		//echo '<BR>Read: '.$read;
		$pos += $read;
	
		// debuggiing:
		//echo '<BR>Data[0-9]: ' . substr($content,0,10);
		//echo '<BR>Pos: '.$pos.' ReadSz.: '.$read;
	
		$last_datatime = time();

		if ($lagbytes==0)
		{
			// real output
			print $content;
		} else
		{
			$buffer .= $content;
			$buflen = strlen($buffer);
			
			$elapsed = microtime(true) - $starttime;
			$sendUntil = $startpos + floor($elapsed * $bytesPerSecond);
			$sendUntil = (int) ($sendUntil / $blockAlign);
			$sendUntil *= $blockAlign;
			if ($sendUntil > $bufferpos)
			{
				$sendcnt = $sendUntil - $bufferpos;
				print substr($buffer,0,$sendcnt);
				$buffer = substr($buffer,$sendcnt);
				$bufferpos += $sendcnt;
			}
		}

		ob_flush();
		flush();
	}
	
	fclose($filehandle);
	exit;

}

function NotifySpinServer( $act , & $ref_data )
{
  // check if this call was added by spin-server
  if ( ($ref_data['flags']&1024) == 0) return;
  // tell spin-server
  $msg = array( 'act' => $act , 'id' => $ref_data['remoteid'] );
  $reply = SendJsonToDomainSocket( $msg , '/tmp/apresa_spin-server');
}

function LogSocketError()
{
  $err = socket_last_error();
  lg('Client socket error ' . $err . ': ' . socket_strerror($err) );
  $reply = array();
  $reply['r'] = 9;
  $reply['m'] = 'Socket error ' . $err . ' ' . socket_strerror($err);
  return $reply;
}

function AskClientConnector($request)
{
  $socket = socket_create(AF_UNIX, SOCK_STREAM, 0);
  $ipc_path = '/tmp/apresa_cc';
  if (socket_connect($socket,$ipc_path)===FALSE)
  {
    return LogSocketError();
  }
  socket_write($socket,json_encode($request) . "\0");
  $reply = '';
  while (true)
  {
    $r = array( $socket);
    $w = array();
    $e = array();
    $result = socket_select($r,$w,$e,NULL);
    if ($result === false)
    {
      return LogSocketError();
    }
    $buf = socket_read($socket,4*1024);
    if ($buf === false)
    {
      return LogSocketError();
    } else if ($buf === '')
    {
      //lg('end of data');
      break;
    } else
    {
      // received data from client
      $reply .= $buf;
      //lg('received data, now have ' . strlen($reply) . ' bytes');
      if (strlen($reply)>0 && $reply[ strlen($reply)-1 ]=="\0")
      {
        // remove trailing nul-byte
        $reply = substr($reply,0,strlen($reply)-1);
        break;
      }
    }
  }
  socket_shutdown($socket);
  socket_close($socket);
  //lg('string reply: ' . $reply);
  return json_decode($reply,true);
}

?>