<?php

function CheckClusterSetup()
{
	global $msg,$rpl,$dbintf,$configs_s;
	if (file_exists(dirname(__FILE__) . '/../apresa/conf/opt_clustersetup')==false)
	{
		// not applicable
		// and do not check anymore during this session (except when cleared during update)
		SetSessionVar('ClusterSetupChk',true);
		return;
	}

	// this is called from a logged-in admin context
	// but check anyway
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='setup')
    {
			LogAction('Setup cluster');
			ClearSessionVars();
			
			$fields = array
			( 'role'
			, 'vip'
			, 'ipaddr1'
			, 'ipname1'
			, 'ipaddr2'
			, 'ipname2'
			, 'ipmask'
			);
			$configs_cluster = array();
			foreach ($fields as $field)
			{
				if (isset($_POST[$field]))
				{
					$configs_cluster['cluster_' . $field] = $_POST[$field];
				}
			}
			$dbintf->SetConfigsPart($configs_cluster,'cluster');
			
			// our own network settings might have changed
			// first apply those
			$configs_netw = array();
			if ($configs_cluster['cluster_role']==1)
			{
				$configs_netw['IPaddr'] = $configs_cluster['cluster_ipaddr1'];
				$configs_netw['IPname'] = $configs_cluster['cluster_ipname1'];
			} else
			{
				$configs_netw['IPaddr'] = $configs_cluster['cluster_ipaddr2'];
				$configs_netw['IPname'] = $configs_cluster['cluster_ipname2'];
			}
			$configs_netw['IPmask'] = $configs_cluster['cluster_ipmask'];
			// create busy file
			signal_service('busy cluster');
			// save & restart (to be sure it is applied)
			$dbintf->SetConfigsPart($configs_netw,'n');
			msg_signal_service($msg,'ns');
			// don't wait
			signal_service('nr');
			
			// redirect to new IP addr.
			$newip = $configs_netw['IPaddr'];
			if ($_SERVER['REMOTE_ADDR']=='127.0.0.1')
			{
				$newip = '127.0.0.1';
			}
			
			$rooturl = (isset($_SERVER['HTTPS'])?'https':'http').'://'.$newip;
			// take too long, don't wait on it
      signal_service('cluster setup');
    }
    if ($act=='cancelsetup')
    {
			LogAction('Cancel cluster setup');
			ClearSessionVars();
      msg_signal_service($msg,'cluster cancel');
		}
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl);
    exit;
	}

	$configs_n = $dbintf->LoadConfigsPart('n');
	$data = '';
	$data .= 'var IPaddr = "' . JsQuote($configs_n['IPaddr']) . '";' . "\r\n";
	$data .= 'var IPname = "' . JsQuote($configs_n['IPname']) . '";' . "\r\n";
	$data .= 'var IPmask = "' . JsQuote($configs_n['IPmask']) . '";' . "\r\n";
	
  $template_content = file_get_contents('../apresa/templ/clustersetup.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $template_content = do_replace_tags($template_content);
  echo $template_content;
	
	// exit is needed here
	exit;
}





?>