<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $active_cnt = $dbintf->GetActiveCallsCount();
  
  $synid = '';
  if (isset($_GET['id']))
  {
		$synid = $_GET['id'];
	}
  if (isset($_POST['id']))
  {
		$synid = $_POST['id'];
	}

  // Do not overwrite datef
  $datef = $configs['datef'];
	$configs = $dbintf->LoadConfigsPart('crec');
  $configs['datef'] = $datef;


	$cardlist = $configs['CardList'];

	if ($cardlist=='')
	{
		$cardlist = array();
	} else
	{
		$cardlist = explode(',',$cardlist);
	}
	//echo "<pre>";
	//var_dump($cardlist);

	$found = false;
	foreach($cardlist as $cardid)
	{
		if ($cardid==$synid)
		{
			$found = true;
		}
	}
	if ($found==false)
	{
		echo 'Unknown card: '.$synid;
		exit;
	}

	// load card data

	$chcnt = (int)$configs[$synid . '_Channels'];
	$cardsn = $configs[$synid . '_SN'];
	$startch = $configs[$synid . '_StartCh'];


	// also specifies defaults
	$channelparams = array
	(		"Trigger"=>1
	,		"OffHookThr"=>26
	,		"AudioThr"=>12
	,		"SilenceTimeOut"=>15
	,		"AGC"=>0
	,		"Amplify"=>0
	,   "InactAlarm"=>0
	,   "InactLen"=>""
	,   'LoudVoiceDetect'=>0
	,   'LoudnessThr'=>60
	,   'LoudnessLen'=>3
	,   'LongRecordings'=>0
	,   'LongRecordingsLen'=>60
	,   'RecOnDmd'=>0
	);
	$params = array();

	foreach ($channelparams as $paramname => $def)
	{
		//$paramname
		$text = str_ensure_defined($configs[$synid . '_' . $paramname]);
		if ($text=='') $param = array();
		else $param = explode(',',$text);
		for ($ch=0;$ch<$chcnt;$ch++)
		{
			if (isset($param[$ch])==false)
			{
				$param[$ch] = $def;
			}
		}
		$params[$paramname] = $param;
	}


  $act = $_POST['act'];
  if ($act!='')
  {

		//echo '<pre>';
		//echo $_POST['channels'] . "\r\n";
		$edit_channels = explode(',',$_POST['channels']);
  	if ($act=='edit')
  	{
			LogAction('Change card setting');
			$newconfigs = array();

			// marge existing data with new data
			// for each parameter separately

			foreach ($params as $key=>$param)
			{
				$newvalue = $_POST[$key];
				//echo $key . " := " . $newvalue . "\r\n";
				foreach ($edit_channels as $chix)
				{
					$param[$chix-1] = $newvalue;
				}
				$textval = implode(',',$param);
				//echo $textval . "\r\n";
				$newconfigs[$synid . '_' . $key] = $textval;
			}

			$dbintf->SetConfigsPart($newconfigs,'crec');
      $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));

			$changed = true; // assume for now
			$restart_needed = str_ensure_defined($_POST['restartneeded'])=='1';
      $restart = str_ensure_defined($_POST['restart'])=='1';

		      if ($restart)
		      {
		        if ($active_cnt>0 && $_POST['restart_force']==false)
		        {
		          $msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceRestart'));
		          $restart = false;
		        } else
		        {
		          if (msg_signal_service($msg,'or'))
		          {
		            $t = $lng->Get('System.RestartComponentBusy');
		            $t = str_replace('%1',$lng->Get('System.TheRecComp'),$t);
		            $t = ucfirst($t);
		            $msg[] = new Msg(MSG_INF,$t);
		          } else {
		            $msg[] = new Msg(MSG_ERR,'Failed to restart recording service');
		            $restart = false;
		          }
		        }
		      }
		      if ($restart==false)
		      {
		        if ($changed && $restart_needed)
		        {
		          // not restarting, but changed
		          $msg[] = new Msg(MSG_WRN,$lng->Get('System.ChangesAfterRestart'));
		        }
		      }

		}


    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'crecanaopt.php?id='.$synid);
    exit;
  }

	LogAction("View Analog Card settings",array('level'=>'view','cardid'=>$_GET['id']));

  // ready with database
  $dbintf->close();

	$data = '';
	//echo $cardlist;

	$data .= "var channels=[\n";

	//echo '<pre>';
	//var_dump($params);
	//exit;


	$first = true;
	for ($ch=0;$ch<$chcnt;$ch++)
	{
		if (!$first) $data .= ',';
		$first = false;

		$data .= "{ch: " . ($ch+1);
		foreach ($channelparams as $paramname => $def)
		{
			$data .= ", ".$paramname.": ";
			if (is_numeric($params[$paramname][$ch]))
			{
				$data .= $params[$paramname][$ch];
			} else
			{
				$data .= '"' . JSQuote($params[$paramname][$ch]) . '"';
			}
		}
		$data .= "}\n";
	}
	$data .= "];\n";

	//echo '<pre>';
	//var_dump($data);
	//exit;
	
	$data .= 'var cardid = "' . JsQuote($synid) . '"' . ";\r\n";
	$data .= 'var cardsn = "' . JsQuote($cardsn) . '"' . ";\r\n";
	$data .= 'var startch = ' . ((int)$startch) . ";\r\n";

  $data .= GeneralJSData();
  $data .= "var active_cnt = $active_cnt; \r\n";

  $template_content = file_get_contents('../apresa/templ/crecanaopt.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>