<?php

require_once('general.php');

HandlePage($dbintf);

function LoadPbxData()
{
	$dst_pbx = fopen(DATA_PATH . '/DST_PBX.csv','r');
	if (!$dst_pbx) return null;
  $first = true;
  $pbxdata = array();
  $phonetypes = array();
  while (($linedata = fgetcsv($dst_pbx)) !== false)
  {
		if ($first)
		{
			$first = false;
			continue;
		}
		$phonetypes = '';
		if (isset($linedata[4]))
		{
			$phonetypes = $linedata[4];
		}
		$manu =& $pbxdata[ $linedata[0] ];
		$manu[] = array('name'=>$linedata[1],'firmware'=>$linedata[2],'phonetypes'=>$phonetypes);
	}
	return $pbxdata;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	// for JS output unmodified
	$showkeys = array
	( 
	// informational
	'Present', 'SN', 'StartCh', 'Channels', 'MaxChannels', 'PBXType'
	, 'Model' // type of card
	, 'PhoneType' // not settable here
	);
	$setkeys = array
	( 'PBX_Manu', 'PBX_Model'
	, 'AudioDetect', 'SilenceT'
	, 'StartCndList', 'StopCndList'
	, 'RingOnCndList', 'RingOffCndList'
	, 'AudioSens', 'TdmStart'
	, 'InboundGain', 'OutboundGain'
	, 'SwapSides', 'DetectDtmf', 'MissedCalls'
	);
	$cfgkeys = array_merge($showkeys, $setkeys);
	
	$intcast_keys = array
	( 'Present', 'StartCh', 'Channels'
	, 'MaxChannels', 'AudioDetect', 'SilenceT'
	, 'AudioSens', 'TdmStart', 'InboundGain' , 'OutboundGain'
	, 'SwapSides', 'DetectDtmf', 'MissedCalls'
	);
	$def_configs = array
	( 'SilenceT' => 15
	, 'AudioSens' => 6
	);
	
  $active_cnt = $dbintf->GetActiveCallsCount();

  $act = $_POST['act'];
  if ($act!='')
  {
		if ($act=='editcard')
		{
  		$pbxdata = LoadPbxData();

			$newconfigs = array();
			$cardid = $_POST['id'];
			LogAction('Change card setting',array('cardid'=>$cardid) );
			$ok = true;
			// change TDM PBX?
			if (isset($_POST['PBX_Manu']))
			{
				$manu  = $_POST['PBX_Manu'];
				$model = $_POST['PBX_Model'];
				//echo $manu . " " . $model;
				$changed = true;

				if (isset($pbxdata[$manu])==false)
				{
					$msg[] = new Msg(MSG_WRN,'Unknown manufacturer');
					$ok = false;
				} else
				{
					$model_list = $pbxdata[$manu];
					$found = false;
					foreach($model_list as $modeldata)
					{
						if ($modeldata['name'] == $model)
						{
							$found = true;
							$firmware = $modeldata['firmware'];
						}
					}
					if (!$found)
					{
						$msg[] = new Msg(MSG_WRN,'Unknown PBX type');
						$ok = false;
					} else
					{
						$newconfigs[$cardid . '_PBXType'     ] = $firmware;
					}
				}
			}
			if ($ok)
			{
				$restart = str_ensure_defined($_POST['restart'])=='1';
				foreach ($setkeys as $key)
				{
					if (isset($_POST[$key]))
					{
						$newconfigs[$cardid . '_' . $key ] = $_POST[$key];
					}
				}
				$dbintf->SetConfigsPart($newconfigs,'crec');
				$msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));

				if ($restart)
				{
					if ($active_cnt>0 && $_POST['restart_force']==false)
					{
						$msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceRestart'));
						$restart = false;
					} else
					{
						if (msg_signal_service($msg,'or'))
						{
							$t = $lng->Get('System.RestartComponentBusy');
							$t = str_replace('%1',$lng->Get('System.TheRecComp'),$t);
							$t = ucfirst($t);
							$msg[] = new Msg(MSG_INF,$t);
						} else {
							$msg[] = new Msg(MSG_ERR,'Failed to restart recording service');
							$restart = false;
						}
					}
				}
				if ($restart==false)
				{
					if ($changed)
					{
						// not restarting, but changed
						$msg[] = new Msg(MSG_WRN,$lng->Get('System.ChangesAfterRestart'));
					}
				}
			}

		}

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'crecopt.php');
    exit;
  }


	$configs = array_merge( $configs, $dbintf->LoadConfigsPart('crec') );
	LogAction('View card settings',array('level'=>'view'));

  // ready with database
  $dbintf->close();

	$data = '';
	$cardlist = str_ensure_defined($configs['CardList']);
	//echo $cardlist;
	if ($cardlist=='')
	{
		$cardlist = array();
	} else
	{
		$cardlist = explode(',',$cardlist);
	}
	//echo "<pre>";
	//var_dump($cardlist);

  $pbxdata = LoadPbxData();
	//echo "<pre>";
	//var_dump($pbxdata);

	$data .= "var pbxtypes=[];\n";
	foreach($pbxdata as $name=>$arr)
	{
		$data .= 'pbxtypes["' . $name . '"] = [';
		$first = true;
		foreach ($arr as $item)
		{
			if (!$first) $data .= ',';
			$first = false;
			$data .= "{name:\"" . $item['name'] . "\",phonetypes:\"".$item['phonetypes']."\"}";
		}
    $data .= '];' . "\n";
	}


	$data .= "var boardlist=[\n";
	$first = true;
	foreach($cardlist as $cardid)
	{
		if (!$first) $data .= ',';
		$first = false;

		$synmodel = $configs[$cardid . '_Model'];
		$model = -1;
		if (substr($synmodel,0,3)=='DST'
		|| substr($synmodel,0,3)=='SHR')
		{
			$model = 12;
		}
		if (substr($synmodel,0,3)=='ATP'
    || substr($synmodel,0,3)=='SHT')
		{
			$model = 3;
		}
		if (substr($synmodel,0,3)=='DTP')
		{
			$model = 7;
		}
		
		// apply defaults
		foreach ($def_configs as $key=>$value)
		{
			if (isset($configs[$cardid . '_'.$key])==false)
			{
				$configs[$cardid . '_'.$key] = $value;
			}
		}

		$dataobj = array();
		// must can be handled generally
		foreach ($cfgkeys as $key)
		{
			$value = ensure_defined($configs[$cardid . '_' . $key], null);
			if (in_array($key,$intcast_keys))
			{
				$value = (int) $value;
			}
			$dataobj[$key] = $value;
		}
		// only a few specials to set
		$dataobj['Id'] = $cardid;
		$dataobj['CtType'] = $model;
		$data .= json_encode( $dataobj , JSON_FORCE_OBJECT );
	}
	$data .= "];\n";
	//var_dump($boardlist);
	//exit;
	
  $data .= GeneralJSData();
  $data .= "var active_cnt = $active_cnt; \r\n";

  $template_content = file_get_contents('../apresa/templ/crecopt.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>