<?php

require_once('general.php');

HandlePage($dbintf);

function LoadPbxData()
{
	$dst_pbx = fopen(DATA_PATH . '/DST_PBX.csv','r');
	if (!$dst_pbx) return null;
  $first = true;
  $pbxdata = array();
  $phonetypes = array();
  while (($linedata = fgetcsv($dst_pbx)) !== false)
  {
		if ($first)
		{
			$first = false;
			continue;
		}
		$phonetypes = '';
		if (isset($linedata[4]))
		{
			$phonetypes = $linedata[4];
		}
		$manu =& $pbxdata[ $linedata[0] ];
		$manu[] = array('name'=>$linedata[1],'firmware'=>$linedata[2],'phonetypes'=>$phonetypes);
	}
	return $pbxdata;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $active_cnt = $dbintf->GetActiveCallsCount();
  
  $synid = '';
  if (isset($_GET['id']))
  {
		$synid = $_GET['id'];
	}
  if (isset($_POST['id']))
  {
		$synid = $_POST['id'];
	}
	$configs_crec = $dbintf->LoadConfigsPart('crec');

	$cardlist = $configs_crec['CardList'];

	if ($cardlist=='')
	{
		$cardlist = array();
	} else
	{
		$cardlist = explode(',',$cardlist);
	}
	//echo "<pre>";
	//var_dump($cardlist);

	$found = false;
	foreach($cardlist as $cardid)
	{
		if ($cardid==$synid)
		{
			$found = true;
		}
	}
	if ($found==false)
	{
    $msg[] = new Msg(MSG_ERR,'Unknown card: '.$synid);
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'crecopt.php');
		exit;
	}

	// load card data

	$chcnt = (int)$configs_crec[$synid . '_Channels'];
	$cardsn = $configs_crec[$synid . '_SN'];

	$cardparams = array
	(			"Channels"
	,     "StartCh"
	,    	"SN"
	,     "Model"
	,			"PBX_Manu"
	,     "PBX_Model"
	,     "AudioDetect"
	,     "SilenceT"
	,     "StartCndList"
	,     "AudioSens"
	,     "TdmStart"
	,     "InboundGain"
	,     "OutboundGain"
	);
	$copts = array();

	foreach ($cardparams as $paramname)
	{
		$copts[$paramname] = $configs_crec[$synid . '_' . $paramname];
	}

	// also specifies defaults
	$channelparams = array
	(		"InactAlarm"=>0
	,   "InactLen"=>""
	,   "PhoneType"=>0
	,   'LoudVoiceDetect'=>0
	,   'LoudnessThr'=>60
	,   'LoudnessLen'=>3
	,   'RecOnDmd'=>0
	,   'CheckLineStatus'=>0
	);
	$params = array();

	foreach ($channelparams as $paramname => $def)
	{
		//$paramname
		$text = $configs_crec[$synid . '_' . $paramname];
		if ($text=='') $param = array();
		else $param = explode(',',$text);
		for ($ch=0;$ch<$chcnt;$ch++)
		{
			if (isset($param[$ch])==false)
			{
				$param[$ch] = $def;
			}
		}
		$params[$paramname] = $param;
	}


  $act = $_POST['act'];
  if ($act!='')
  {

		//echo '<pre>';
		//echo $_POST['channels'] . "\r\n";
		$edit_channels = explode(',',$_POST['channels']);
  	if ($act=='edit')
  	{
			LogAction('Change card setting',array('cardid'=>$_POST['id']) );
			$newconfigs = array();

			// marge existing data with new data
			// for each parameter separately

			foreach ($params as $key=>$param)
			{
				$newvalue = $_POST[$key];
				//echo $key . " := " . $newvalue . "\r\n";
				foreach ($edit_channels as $chix)
				{
					$param[$chix-1] = $newvalue;
				}
				$textval = implode(',',$param);
				//echo $textval . "\r\n";
				$newconfigs[$synid . '_' . $key] = $textval;
			}

			$dbintf->SetConfigsPart($newconfigs,'crec');
      $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));

			$changed = true; // assume for now
			$restart_needed = str_ensure_defined($_POST['restartneeded'])=='1';
      $restart = str_ensure_defined($_POST['restart'])=='1';

		      if ($restart)
		      {
		        if ($active_cnt>0 && $_POST['restart_force']==false)
		        {
		          $msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceRestart'));
		          $restart = false;
		        } else
		        {
		          if (msg_signal_service($msg,'or'))
		          {
		            $t = $lng->Get('System.RestartComponentBusy');
		            $t = str_replace('%1',$lng->Get('System.TheRecComp'),$t);
		            $t = ucfirst($t);
		            $msg[] = new Msg(MSG_INF,$t);
		          } else {
		            $msg[] = new Msg(MSG_ERR,'Failed to restart recording service');
		            $restart = false;
		          }
		        }
		      }
		      if ($restart==false)
		      {
		        if ($changed && $restart_needed)
		        {
		          // not restarting, but changed
		          $msg[] = new Msg(MSG_WRN,$lng->Get('System.ChangesAfterRestart'));
		        }
		      }

		}


    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'crectdmopt.php?id='.$synid);
    exit;
  }

	LogAction("View TDM Card settings",array('level'=>'view','cardid'=>$_GET['id']));

  // ready with database
  $dbintf->close();

	$data = '';
	//echo $cardlist;

  $pbxdata = LoadPbxData();
	$data .= "var pbxtypes=[];\n";
	foreach($pbxdata as $name=>$arr)
	{
		$data .= 'pbxtypes["' . $name . '"] = [';
		$first = true;
		foreach ($arr as $item)
		{
			if (!$first) $data .= ',';
			$first = false;
			$data .= "{name:\"" . $item['name'] . "\",phonetypes:\"".$item['phonetypes']."\"}";
		}
    $data .= '];' . "\n";
	}

	$data .= "var channels=[\n";


	//echo '<pre>';
	//var_dump($params);
	//exit;


	$first = true;
	for ($ch=0;$ch<$chcnt;$ch++)
	{
		if (!$first) $data .= ',';
		$first = false;

		$data .= "{ch: " . ($ch+1);
		foreach ($channelparams as $paramname => $def)
		{
			$data .= ", ".$paramname.": ";
			if (is_numeric($params[$paramname][$ch]))
			{
				$data .= $params[$paramname][$ch];
			} else
			{
				$data .= '"' . JSQuote($params[$paramname][$ch]) . '"';
			}
		}
		$data .= "}\n";
	}
	$data .= "];\n";

	//echo '<pre>';
	//var_dump($data);
	//exit;

	$data .= 'var cardid = "' . JsQuote($synid) . '"' . "\r\n";
	$data .= 'var cardsn = "' . JsQuote($cardsn) . '"' . "\r\n";

	$data .= 'var copts = {';
	$data .= ' "sn": "' . JsQuote($cardsn) . '"' . "\r\n";
	foreach ($cardparams as $paramname)
	{
		$data .= ', "' . $paramname . '": "' . JSQuote($copts[$paramname]) . '"' . "\r\n";
	}
	$data .= '};' . "\r\n";

  $data .= GeneralJSData();
  $data .= "var active_cnt = $active_cnt; \r\n";
	
  $template_content = file_get_contents('../apresa/templ/crectdmopt.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>