<?php

require_once('general.php');

HandleContacts($dbintf);

function generateRandomString($length) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}

function HandleContacts($dbintf)
{
  global $rpl,$configs,$msg,$rooturl;

	$isAdmin = ($dbintf->actuinfo['permissions']&PM_CONFIG)!=0;
	
  if (int_ensure_defined($configs['AlePlayUnlockUser'])==0
	&& $isAdmin==false)
  {
    echo 'Permission denied';
    exit;
  }
	if (isset($_GET['rec']) && $isAdmin==false)
	{
		echo 'Permission denied';
		exit;
	}

  $act = $_POST['act'];
  if ($act!='')
  {
		if ($act=='unlock')
		{
			$rec = (int) $_POST['rec'];
			if ($rec!=0 && $isAdmin==false)
			{
				echo 'Permission denied';
				exit;
			}
			
			$UnlockSession = false;
			if ($_POST['scope']=='ses' && $rec==0)
			{
				$UnlockSession = true;
			}
			if ($UnlockSession==false && $isAdmin==false)
			{
				echo 'Permission denied';
				exit;
			}
      
      // check if already unlocked
      $AlreadyUnlocked = false;
      if ($rec!=0)
      {
        $AlreadyUnlocked = file_exists('/var/apresa/data/rec.ekey');
      } else
      {
        if ($UnlockSession)
        {
          $AlreadyUnlocked = isset($_SESSION['PlayKeyId'])
            && file_exists('/dev/shm/apresa/web/play_'.$_SESSION['PlayKeyId'].'.ekey');
        } else
        {
          $AlreadyUnlocked = file_exists('/dev/shm/apresa/play.ekey');
        }
      }
      if ($AlreadyUnlocked)
      {
				$msg[] = new Msg(MSG_INF,'Already unlocked');
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl);
				exit;
      }

			if ($rec==0) LogAction('Unlock playback/decryption key for the ' . ($UnlockSession?'session':'system') );
			else LogAction('Unlock recording/encryption key');
			
			$PlayPKey = $dbintf->GetConfigValue('PlayPkey');
			$returnUrl = $rooturl.'cryptunlock.php'.(($rec==1)?'?rec':'');
			if ($PlayPKey=='')
			{
				$msg[] = new Msg(MSG_ERR,'No key is stored.');
				$_SESSION['msg'] = $msg;
				header('Location: '.$returnUrl);
				exit;
			}
			$PlayPKey = pack('H*',$PlayPKey);

			$pwd = $_POST['pwd'];
			// test if PWD is correct
			sleep( 1 );
			$play = passwordDecrypt( $pwd , $PlayPKey );
			if (substr($play,0,2)!='OK')
			{
				$msg[] = new Msg(MSG_ERR,'Password is incorrect.');
				$_SESSION['msg'] = $msg;
				header('Location: '.$returnUrl);
				exit;
			}
			
			if ($UnlockSession)
			{
				$randomId = '';
				for ($i=0;$i<100;$i++)
				{
					$randomId = generateRandomString(20);
					$playKeyFile = '/dev/shm/apresa/web/play_'.$randomId.'.ekey';
					$pwdFile = '/dev/shm/apresa/web/tmp_pwd_'.$randomId;
					if (file_exists($pwdFile)
						|| file_exists($playKeyFile) )
					{
						$randomId = '';
					}
				}
				if ($randomId=='')
				{
					die('Failed to generate random id');
				}

				$dbTmpFile = array
				( 'filepath' => $playKeyFile
				, 'filesize' => -1 // unknown yet
				, 'added' => time()
				, 'expiry' => time() + 3600
				);
				$dbintf->AddTmpFile( $dbTmpFile );
				
				$passPhrase = encrypt($pwd);
				file_put_contents($pwdFile,$passPhrase);
				$dbTmpFile = array
				( 'filepath' => $pwdFile
				, 'filesize' => filesize($pwdFile)
				, 'added' => time()
				, 'expiry' => time() + 60
				);
				$dbintf->AddTmpFile( $dbTmpFile );
				
				msg_signal_service($msg,'crypt uunlock '.$randomId);
				
				DeleteFn($pwdFile);
				$dbintf->RemoveTmpFile( $pwdFile );
				
				$_SESSION['PlayKeyId'] = $randomId;
				
			} else
			{
			
				$passPhrase = encrypt($pwd);
				file_put_contents('/dev/shm/apresa/web/tmp_pwd',$passPhrase);
				if ($rec==0) $cmd = 'crypt unlock';
				else $cmd = 'crypt recunlock';
				msg_signal_service($msg,$cmd);
				DeleteFn('/dev/shm/apresa/web/tmp_pwd');
				
			}
		
			// redirect
			$_SESSION['msg'] = $msg;
			header('Location: '.$rooturl.'index.php');
			exit;
		}
		/* 
		$msg[] = new Msg(MSG_INF,'<%Options.ConfigSaved%>');
		*/
  }

	$data = '';
	
	$rec = isset($_GET['rec'])?1:0;
	$data .= "var rec = $rec;\n";
	
	LogAction('View Cryptunlock',array('level'=>'view'));

  // ready with database
  $dbintf->close();


  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/cryptunlock.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
