<?php
require_once('general.php');
require_once('db.php');
require_once('cedb.php');
require_once('ceshared.php');

HandleDashboard($dbintf);

function calculateNextUnix($current,$period){
	$year=intval(date("Y", $current));
	$month=intval(date("n", $current));
	$day=intval(date("j", $current));
	$hour=intval(date("G", $current));
	$minute=intval(date("i", $current));
	
	if($period=="d"){
		if($minute==0){
			if($hour==0){
				if($day==1){
					if($month==1){
						$month=12;
						$year--;
					}else{
						$month--;
					}
					$day=date("t", strtotime($year."/".$month."/1"));
				}else{
					$day--;
				}
				$hour=23;
			}else{
				$hour--;
			}
		}
		return(intval(strtotime($year."/".$month."/".$day." ".$hour.":00:00")));
		
	}elseif($period=="w"||$period=="m"){
		if($hour==1){
			if($day==1){
				if($month==1){
					$month=12;
					$year--;					
				}else{
					$month--;
				}			
				$day=date("t", strtotime($year."/".$month."/".$day." 01:00:00"));		
			}else{
				$day--;
			}
		}
		return(intval(strtotime($year."/".$month."/".$day." 01:00:00")));
	}else{
		if($month==1){
			$month=12;
			$year--;
		}else{
			$month--;
		}
		
		return(intval(strtotime($year."/".$month."/1")));
	}
}

function HandleDashboard($dbintf)
{
	global $msg, $data, $configs_s, $rpl;
	
	$cedb = new CEDB($dbintf);
	$actuinfo = $dbintf->GetActiveUserInfo();
	// filtering
	$statsData = new CE_Stats($cedb);
	$statsData->formid = -1;
	$statsData->prjid = -1;
	$statsData->Calculate();
	
	if (int_ensure_defined($configs_s['calleval'])==0)
	{
    echo 'Feature is not enabled';
    exit;
	}
	
  if ((CheckCePm(PM_CE_MANAGE)==false)&&(CheckCePm(PM_CE_SUPERVISOR)==false)){
		echo("Supervisor Permission denied.<br>");
		return;
	}
		
	$supervisor=$actuinfo["accid"];
	
	triggerSchedules($actuinfo['accid'],$cedb);
  
	$mygroups=$cedb->getMyGroups($actuinfo["accid"]);		
	$subgroups=array();
	$subgroups=array_merge($subgroups, $mygroups);
	foreach($mygroups as $group){
		$subgroups=array_merge($subgroups, $cedb->getSubGroups($group));
	}
	
	$agents=array();
	if(CheckCePm(PM_CE_MANAGE)){
		$agents=$cedb->getAllUsers();
	}else if(CheckCePm(PM_CE_SUPERVISOR)){
		$agents=$cedb->getUsersFromGroups($subgroups);
	}
	
	if(isset($_GET['accid'])&&in_array($_GET['accid'],$agents)){
		$accid=$_GET['accid'];
	}else{
		$accid=-1;
	}
	
	$myprojects = $cedb->getMyProjects($accid);
	
	if(isset($_GET['accid'])){
		$prjid=intval($_GET['prjid']);
	}else{
		$prjid=-1;
	}
	$period1=str_ensure_defined($_GET['csort']);
	$period2=str_ensure_defined($_GET['tsort']);
	$period3=str_ensure_defined($_GET['asort']);
	$data.=("var cselect='".$period1."';");
	$data.=("var tselect='".$period2."';");
	$data.=("var aselect='".$period3."';");
	$data.=("var accid='".$accid."';");
	$data.=("var prjid='".$prjid."';");
	
	$months = array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dec');
	$days = array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
	
  $logarr = array('level'=>'view');
  $logarr['periods'] = $period1.$period2.$period3;
  if ($prjid!=-1)
  {
    $logarr['project'] = $cedb->GetProjectName($prjid);
  }
  if ($accid!=-1)
  {
    $uinfo = $dbintf->GetUserInfoOnAccId($accid);
    $logarr['agent'] = $uinfo['name'];
    $logarr['tenantid'] = $uinfo['tenantid'];
  }
  
	LogAction('Viewed supervisor dashboard', $logarr );
	
	//Amount of steps in a day
	$dleft=24;

	//Amount of steps in a week	
	$wleft=7;

	//Amount of steps in a month
	$current=time();
	$year=date("Y", $current);
	$month=date("m", $current);		
	$day=date("d", $current);
	if($month==1){
		$month=12;
		$year--;
	}else{
		$month--;
	}
	$mleft=intval(($current-intval(strtotime($year."/".$month."/".$day." ".date("H", $current).":".date("i", $current).":".date("s", $current))))/86400);

	//Amount of steps in a year
	$yleft=12;
			
	//array of agents
	$myagents = $agents;
	
		
	//-Graph 1--------------------------------------------------	
	$left=0;
	if($period1=="d"){
		$left=$dleft;	
	}elseif($period1=="w"){
		$left=$wleft;
	}elseif($period1=="m"){
		$left=$mleft;
	}else{
		$left=$yleft;
	}
	$datetill = time();
		
	$chart1data = array();
	$chart1dates = array();
	
	$index=0;
	for($i = $left;$i>0;$i--){
		$datefrom = intval(calculateNextUnix($datetill,$period1));
		
		$calls=0;
		if($accid==-1){
			foreach($myagents as $agent){
				$calls += $cedb->getCompletedEvaluationsBetween($supervisor, $agent,$prjid,$datefrom,$datetill);
			}
		}else if(in_array($accid,$myagents)){
			$calls = $cedb->getCompletedEvaluationsBetween($supervisor, $accid,$prjid,$datefrom,$datetill);
		}
		
		$chart1data[$index] = $calls;
		if($period1=="d"){
			$chart1dates[$index] = date("H", $datefrom).":00";
		}elseif($period1=="w"){
			$chart1dates[$index] = $days[date("w", $datefrom)];
		}elseif($period1=="m"){
			$chart1dates[$index] = date("d/m", $datefrom);
		}else{
			$chart1dates[$index] = $months[date("n", $datetill)-1];	
		}
		
		$datetill = intval($datefrom);
		$index++;
	}
	
	$chart1labels = "labels: [";
	$chart1series = "series: [[";
	
	$first=true;
	for($i=$left-1;$i>=0;$i--){
		if($first){
			$first=false;
		}else{
			$chart1labels.=",";
			$chart1series.=",";
		}
		$chart1series.=$chart1data[$i];
		$chart1labels.="'".$chart1dates[$i]."'";
	}
	
	$chart1labels.="]";
	$chart1series.="]]";
	
	//-Graph 2---------------------------------------------------
	
	$left=0;
	if($period2=="d"){
		$left=$dleft;	
	}elseif($period2=="w"){
		$left=$wleft;
	}elseif($period2=="m"){
		$left=$mleft;
	}else{
		$left=$yleft;
	}
	$datetill = time();
	
	$chart2data=array();
	$chart2dates=array();
	
	$index=0;
	for($i = $left;$i>0;$i--){
		$datefrom=intval(calculateNextUnix($datetill,$period2));
		
		$chart2data[$index]=0;
		foreach($statsData->user_list as $user)
		{
			if ($user['evalcnt']==0||!in_array($user['accid'],$myagents)){
				continue;
			}else	if($accid==-1||$accid==$user['accid']){
				$chart2data[$index]+=$cedb->GetAgentCallCountPeriod($user['accid'],$prjid,$datefrom,$datetill);
			}
		}
		
		if($period2=="d"){
			$chart2dates[$index] = date("H", $datefrom).":00";
		}elseif($period2=="w"){
			$chart2dates[$index] = $days[date("w", $datefrom)];
		}elseif($period2=="m"){
			$chart2dates[$index] = date("d/m", $datefrom);
		}else{
			$chart2dates[$index] = $months[date("n", $datetill)-1];	
		}
		
		$datetill=$datefrom;
		$index++;
	}
	
	$chart2labels="labels: [";
	$chart2series="series: [[";
	
	$first=true;
	for($i=$left-1;$i>=0;$i--){
		if($first){
			$first=false;
		}else{
			$chart2labels.=",";
			$chart2series.=",";
		}
		$chart2series.=$chart2data[$i];
		$chart2labels.="'".$chart2dates[$i]."'";
	}
	
	$chart2labels.="]";
	$chart2series.="]]";
	
	//-Graph 3---------------------------------------------------	
	$left=0;
	if($period3=="d"){
		$left=$dleft;	
	}elseif($period3=="w"){
		$left=$wleft;
	}elseif($period3=="m"){
		$left=$mleft;
	}else{
		$left=$yleft;
	}
	$datetill=time();
		
	$chart3data=array();
	$chart3dates=array();
	
	$index=0;
	for($i = $left;$i>0;$i--){
		$datefrom=intval(calculateNextUnix($datetill,$period3));
		
		$total=0;
		$totalagents=0;
		if($accid==-1){	
			foreach($myagents as $agent){
				$avg=$cedb->getAverageScoreForPeriod($agent,$prjid,$datefrom,$datetill);
				if($avg>0){
					$totalagents++;
				}
				$total += $avg;
			}
		}else if(in_array($accid,$myagents)){
			$total = $cedb->getAverageScoreForPeriod($accid,$prjid,$datefrom,$datetill);
		}
		
		
		
		if($accid!=-1){
			$chart3data[$index]=$total;
		}else if($totalagents>0){
			$chart3data[$index]=$total/$totalagents;			
		}else{
			$chart3data[$index]=0;
		}

		
		if($period3=="d"){
			$chart3dates[$index] = date("H", $datefrom).":00";
		}elseif($period3=="w"){
			$chart3dates[$index] = $days[date("w", $datefrom)];
		}elseif($period3=="m"){
			$chart3dates[$index] = date("d/m", $datefrom);
		}else{
			$chart3dates[$index] = $months[date("n", $datetill)-1];	
		}
		
		$datetill=$datefrom;		
		$index++;
	}
	
	$chart3labels="labels: [";
	$chart3series="series: [[";
	
	$first=true;
	for($i=$left-1;$i>=0;$i--){
		if($first){
			$first=false;
		}else{
			$chart3labels.=",";
			$chart3series.=",";
		}
		
		$chart3series.=$chart3data[$i];
		$chart3labels.="'".$chart3dates[$i]."'";
	}
	
	$chart3labels.="]";
	$chart3series.="]]";
	
	//-Table A---------------------------------------------------
	
	$first=true;
	$data .= "var projects = [";
	foreach($cedb->GetProjects() as $project){
			$todoEval=$cedb->GetProjectINCompleteEvalCount($supervisor, $accid , $project["id"]);
			$doneEval=$cedb->GetProjectCompleteEvalCount($supervisor, $accid , $project["id"]);
			if(!($todoEval==0&&$doneEval==0)){
				if ($first) $first = false;
				else $data .= ',';
				$data .= '{ "id": "'.$project["id"]. '"';
				$data .= ', "form": "'.JSQuote($project["formname"]). '"';
				$data .= ', "project": "'.JSQuote($project["name"]). '"';		
				$data .= ', "to do": "'.$todoEval.'"';
				$data .= ', "done": "'.$doneEval.'"}';
			}
		
	}
	$data .= '];' . "\r\n";
	
	//-Table B---------------------------------------------------
	
	$data .= 'var agents = [';
	$first = true;
	foreach($statsData->user_list as $user)
	{
		if ($user['evalcnt']==0||!in_array($user['accid'],$myagents)){
			continue;
		}else{
			if ($first) $first = false;
			else $data .= ',';
			$data .= '{ "id": "' . $user['accid'] . '"';
			$data .= ', "agent": "' . JSQuote($user['name']) . '"';	
			$data .= ', "calls": "' . $cedb->GetAgentCallCount($user['accid']) . '"';
			$data .= ', "evaluated calls": "' . $cedb->GetAgentEvalCount($user['accid'],$prjid) . '"';
			$data .= ', "average score": "' . round($cedb->GetAgentAverageScore($supervisor,$user['accid'],$prjid),0) . '"';
			$data .= '}' ;		
		}
		
		
	}
	$data.="];\r\n";
	
	//-Table C-------------------------------------------------
	
	$first=true;
	$calls = array();
	foreach($myprojects as $project){
		foreach($cedb->GetUnscoredProjectCalls($supervisor,$accid,$project) as $call){
			$calls[]=$call;			
		}
	}	
	
	function sortByDate($a, $b) {
		return $a['startdate'] - $b['startdate'];
	}

	usort($calls, 'sortByDate');
	
	$data .= "var calls = [";
	foreach($calls as $call){
		if(($accid==-1 || $accid==$call["useraccid"]) && in_array($call['useraccid'],$myagents) && ($prjid==-1 || $call['projectid']==$prjid)){
			if ($first) $first = false;
			else $data .= ',';
			$data .= '{ "id": "'.$call["recordingid"]. '"';
			$data .= ', "ceid": "'.$call["id"]. '"';
			$data .= ', "prjid": "'.$call["projectid"]. '"';
			$data .= ', "project": "'.JSQuote($call["projectname"]). '"';
			$data .= ', "agent": "'.JSQuote($call["username"]). '"';		
			$data .= ', "date": "'.date("<b>Y-m-d</b> H:i:s", $call["startdate"]).'"}';	
		}
	}
	$data .= '];' . "\r\n";
	
	//-------------------------------------------------	
	
	$data .= "var caccid=" . $accid . ";\r\n";
	
	$data .= GeneralJSData();	

	$template_content = file_get_contents('../apresa/templ/dashboard.htm');

	// template replacements:
	$rpl['msg'] = message($msg);
	$rpl['nav'] = '';
	$rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
	$rpl['FOOTER'] = '';
	
	if($accid==-1){
		$rpl['FILTER'] = '<%Main.All%> <%CE.Agents%>';
	}else{
		$rpl['FILTER'] = '<%CE.Agent%> ' . $cedb->GetUserName($accid);
	}
	
	if($prjid==-1){
		$rpl['FILTER'] .= ", <%Main.All%> <%CE.Projects%>";
	}else{
		$rpl['FILTER'] .= ', <%CE.Project%> '.$cedb->GetProjectName($prjid);
	}
	
	$rpl['CHART1LABELS'] = $chart1labels;
	$rpl['CHART1SERIES'] = $chart1series;
	$rpl['CHART2LABELS'] = $chart2labels;
	$rpl['CHART2SERIES'] = $chart2series;
	$rpl['CHART3LABELS'] = $chart3labels;
	$rpl['CHART3SERIES'] = $chart3series;
	$rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
	$rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
	$rpl['data'] = $data;
	$rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
	$rpl['header'] = GetHeader();
	$template_content = do_replace_tags($template_content);
	echo $template_content;

}

?>
