<?php

// returns array or FALSE
function ReadDataFile($filename)
{
  $arr = array();
  $h = @fopen($filename,'r');
  if ($h==false) return false;
  while (!feof($h))
  {
    $line = fgets($h);
    //echo 'LINE: '.$line;
    $spacepos = strpos($line,' ');
    if ($spacepos===false) continue;
    $key = substr($line,0,$spacepos-1);
    //echo 'KEY<' . $key . '>';
    // also removes CR-LF
    $v = substr($line,$spacepos+1,strlen($line)-$spacepos-1);
    $vlen = strlen($v);
    if ($vlen>0)
    {
      if ($v[$vlen-1]=="\n")
      {
        $v = substr($v,0,$vlen-1);
        $vlen --;
      }
      if ($v[$vlen-1]=="\r")
      {
        $v = substr($v,0,$vlen-1);
        $vlen --;
      }
    }
    $v = str_replace("\\n","\n",$v);
    $v = str_replace("\\r","\r",$v);
    $v = str_replace("\\0","\0",$v);
    $v = str_replace("\\\\","\\",$v);
    //echo $value."\n";
    $arr[$key] = $v;
  }
  fclose($h);
  return $arr;
}

// returns filename or false
function WriteRandomDataFile($arr)
{
  $fn = tempnam(sys_get_temp_dir(), 'apresa');
  if (WriteDataFile($fn,$arr)==false) return false;
  return $fn;
}

function WriteDataFile($filename,$arr)
{
  $h = fopen($filename,'w');
  if ($h==false) return false;
  $t = ArrayToString($arr);
  fwrite($h,$t,strlen($t));
  fclose($h);
  return true;
}

function StringToArray($str)
{
  if(!is_string($str)) return array();
  
  $arr = array();
  $lines = explode("\r\n",$str);
  foreach($lines as $line)
  {
    $spacepos = strpos($line,' ');
    if ($spacepos===false) continue;
    $key = substr($line,0,$spacepos-1);
    $v = substr($line,$spacepos+1,strlen($line)-$spacepos);
    $v = str_replace("\\n","\n",$v);
    $v = str_replace("\\r","\r",$v);
    $v = str_replace("\\0","\0",$v);
    $v = str_replace("\\\\","\\",$v);
    $arr[$key] = $v;
  }
  return $arr;
}

function ArrayToString($arr)
{
  $t = '';
	foreach($arr as $key=>$value)
  {
    $v = $value;
    $v = str_replace("\\","\\\\",$v);
    $v = str_replace("\n","\\n",$v);
    $v = str_replace("\r","\\r",$v);
    $v = str_replace("\0","\\0",$v);
    $t .= $key . ': '.$v . "\r\n";
  }
  return $t;
}

?>