<?php

define('FORMAT_DURATION_SECONDS_UNDEF', -1);
define('FORMAT_DURATION_RESULT_UNDEF', "0:00:00");

function formatDuration($seconds, $resultUndef = FORMAT_DURATION_RESULT_UNDEF)
{
  if ($seconds == FORMAT_DURATION_SECONDS_UNDEF) { return $resultUndef; }
  $min = floor($seconds / 60);
  $seconds -= $min * 60;
  $hour = floor($min / 60);
  $min -= $hour * 60;
  return $hour . ':' . sprintf('%02d',$min) . ':' . sprintf('%02d',$seconds);
}

function defFormatDateNnDow($timestamp)
{
  global $lng;
  if ($timestamp==0) return '';
  // Sunday = 0
  $dow = (int) date('w',$timestamp);
  $dow ++;
  return $lng->Get('DateTime.d'.$dow) . ' ' . defFormatDate($timestamp);
}

function defFormatDateNn($timestamp)
{
  if ($timestamp==0) return '';
  return defFormatDate($timestamp);
}

function defFormatDate($timestamp)
{
  global $configs;
  return date($configs['datef'],$timestamp);
}

function SetDateTimeF($dateix,$timeix)
{
  global $configs;
  /*
0        <option>month/day/year (USA)</option>
1        <option>day/month/year (UK)</option>
2        <option>year-month-day (international)</option>
3        <option>day-month-year</option>
4        <option>day.month.year</option>
5        <option>year/month/day</option>
6        <option>year.month.day</option>
7        <option>month/day/year (USA)</option>
8        <option>month-day-year</option>
9        <option>month.day.year</option>
  */
  $f = '';
  if ($dateix==0) $f .= 'm/d/Y'; // USA
  else if ($dateix==1) $f .= 'd/m/Y'; // UK
  else if ($dateix==2) $f .= 'Y-m-d'; // standard
  else if ($dateix==3) $f .= 'd-m-Y'; // NL
  else if ($dateix==4) $f .= 'd.m.Y';
  else if ($dateix==5) $f .= 'Y/m/d';
  else if ($dateix==6) $f .= 'Y.m.d';
  else if ($dateix==7) $f .= 'm/d/Y';
  else if ($dateix==8) $f .= 'm-d-Y';
  else if ($dateix==9) $f .= 'm.d.Y';
  else $f .= 'Y-m-d';
  $configs['datef'] = $f;
  $f = '';
  if ($dateix==0) $f .= 'h:i:s A';
  else $f .= 'H:i:s';
	$configs['timef'] = $f;
  $configs['datetimef'] = $configs['datef'] . ' ' . $configs['timef'];
}

function ToJSDateTimeFormat($t)
{
  $t = str_replace('i','xx',$t);
  $t = str_replace('m','MM',$t);
  $t = str_replace('d','dd',$t);
  $t = str_replace('Y','yyyy',$t);
  return $t;
}

?>