<?php

require_once('general.php');

HandleContacts($dbintf);

function HandleContacts($dbintf)
{
  global $rpl,$configs,$msg,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	$canmp3 = file_exists('/usr/lib/sox/libsox_fmt_mp3.so')
         || file_exists('/usr/lib/x86_64-linux-gnu/sox/libsox_fmt_mp3.so');
	if (defined('DEMO')) $canmp3 = true;
	$colkeys = array("playlink","flags","startdate","length","waittime","direction","category"
  ,"notes","notes2","notes3","notes4","notes5"
	, "data1", "data2", "data3", "data4", "data5"
	, "rname", "remote", "remote2", "cname", "connected"
	, "direction2"
	, "lname", "local", "local2","linenr"
	, "agent", "tenant","checksum","rem","recorder");
	
	$dispkeys = array('lng','dateformat','timeformat','CallerReceiver'
		,'CallsPerPage','Audio5','LegacyAudio','AEDashOnLogin','ToMp3Play','EmbedPlayer','LegacyGraph','NoEmailButton','RecExportFileName'
    ,'HideAutoAnnotations'
		,'RefreshCallList','RefreshCallListInterval','ToMp3Down','Theme'
    ,'NotesLabel2'
    ,'NotesLabel3'
    ,'NotesLabel4'
    ,'NotesLabel5'
		,'DataLabel1'
		,'DataLabel2'
		,'DataLabel3'
		,'DataLabel4'
		,'DataLabel5'
		);

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='change-settings')
    {
			if ($dbintf->nodePassive)
			{
        $msg[] = new Msg(MSG_ERR,'Settings can only be changed on the primary node');
				// redirect
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'displayconfig.php');
				exit;
			}
			LogAction('Change display settings');
      //echo '<p>datef: ' . $_POST['dateformat'];

			$oriTheme = $configs['Theme'];
      // selectively copy from POST data
      $configs_new = array();
			foreach ($dispkeys as $dispkey)
      {
				if ($dispkey=='Theme')
				{
					if (isset($_POST[ $dispkey ])==false) continue;
				}
				$configs_new[ $dispkey ] = $_POST[ $dispkey ];
			}
      foreach ($colkeys as $colkey)
      {
        $colix = 'col_'.$colkey;
        $configs_new[$colix] = $_POST[$colix];
				
				if ($configs_new[$colix]==1
				&& int_ensure_defined($configs[$colix])==0)
				{
					$dbintf->EnableVisibleColumn($colkey);
				}

        //echo '<p>'.$colix.': '.$_POST[$colix];
      }
      if (defined('DEMO'))
      {
				$_SESSION['lng'] = $configs_new['lng'];
        unset($configs_new['lng']);
			}
      if ($dbintf->SetConfigsPart($configs_new,'web'))
      {
				if ($oriTheme=='') $oriTheme = 'default';
				if (isset($configs_new['Theme']) && $oriTheme != $configs_new['Theme'])
				{
					// theme changed
					msg_signal_service($msg,'makecss');
					$msg[] = new Msg(MSG_INF,'<%Web.ThemeRefreshInfo%>');
				}
				$msg[] = new Msg(MSG_INF,'<%Options.ConfigSaved%>');
				$stayonpage = false;
				if ( (int_ensure_defined($configs_new['ToMp3Play'])==1
				|| int_ensure_defined($configs_new['Audio5'])==1
				|| int_ensure_defined($configs_new['ToMp3Down'])==1)
				&& $canmp3==false)
				{
					$msg[] = new Msg(MSG_WRN,'MP3 encoding is not installed.');
					$stayonpage = true;
				}
					// redirect
				$_SESSION['msg'] = $msg;
				if ($stayonpage)
				{
					header('Location: '.$rooturl.'displayconfig.php');
				} else
				{
					header('Location: '.$rooturl.'index.php');
				}
        exit;
      } else {
        $msg[] = new Msg(MSG_ERR,GetErrDescr('db'));
      }
    }
  }

  //var_dump($configs);
  //exit;

	DefSet( $configs, 'CallsPerPage', 20 );
	DefSet( $configs, 'RefreshCallList', 0 );
	DefSet( $configs, 'RefreshCallListInterval', 10 );
  DefSet( $configs, 'timeformat', 0 );
  DefSet( $configs, 'LegacyAudio', 0 );
  DefSet( $configs, 'LegacyGraph', 0 );
  DefSet( $configs, 'AEDashOnLogin', 1 );

	$data = '';
	foreach ($dispkeys as $dispkey)
	{
		$data .= 'var '.$dispkey.' = "'
			.JSQuote(str_ensure_defined($configs[$dispkey]))
			.'";'."\r\n";
	}
	
  $data .= "var cols = []; \r\n";
  foreach ($colkeys as $colkey)
  {
    $data .= "cols[\"col_".$colkey."\"] = ".int_ensure_defined($configs['col_'.$colkey]).";\r\n";
  }

	LogAction('Viewed display settings',array('level'=>'view'));

  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/displayconfig.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function DefSet( & $ref_array, $key, $value)
{
	if (isset($ref_array[$key])==false)
	{
		$ref_array[$key] = $value;
	}
}

?>
