<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	if (defined('DEMO'))
	{
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl);
    exit;
	}


  $active_cnt = $dbintf->GetActiveCallsCount();

	$fileid = -1;
	if (isset($_GET['id']))
	{
		$fileid = $_GET['id'];
	}
	if (isset($_POST['id']))
	{
		$fileid = $_POST['id'];
	}

	if ($fileid==-1)
	{
		$msg[] = new Msg(MSG_ERR,'Invalid file ID');
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl);
		exit;
	}

	$filepath = '';
	$filename = '';
	if ($fileid==1)
	{
		$filepath = DATA_PATH . '/ShConfig.ini';
		$filename = 'ShConfig.ini';
		$dst = 'crecopt.php';
	}

	if (file_exists($filepath)==false)
	{
		$msg[] = new Msg(MSG_ERR,'File not found ('.$filepath.')');
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'crecopt.php');
    exit;
	}

	$filecontent = file_get_contents($filepath);

  $act = $_POST['act'];
  if ($act!='')
  {

  	if ($act=='edit')
  	{
			LogAction('Edit file '.$filepath);
			$newcontent = $_POST['content'];
    	$restart = str_ensure_defined($_POST['restart'])=='1';

			// convert to Linux line endings
			$newcontent = str_replace("\r\n","\n",$newcontent);
			$newcontent = str_replace("\r","\n",$newcontent);

			$changed = $newcontent != $filecontent;

			if (file_put_contents($filepath,$newcontent)===false)
			{
   			$msg[] = new Msg(MSG_ERR,'Error writing to file');
			} else
			{
	   		$msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));

	      if ($restart)
	      {
	        if ($active_cnt>0 && $_POST['restart_force']==false)
	        {
	          $msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceRestart'));
	          $restart = false;
	        } else
	        {
	          if (msg_signal_service($msg,'or'))
	          {
	            $t = $lng->Get('System.RestartComponentBusy');
	            $t = str_replace('%1',$lng->Get('System.TheRecComp'),$t);
	            $t = ucfirst($t);
	            $msg[] = new Msg(MSG_INF,$t);
	          } else {
	            $msg[] = new Msg(MSG_ERR,'Failed to restart recording service');
	            $restart = false;
	          }
	        }
	      }
	      if ($restart==false)
	      {
	        if ($changed)
	        {
	          // not restarting, but changed
	          $msg[] = new Msg(MSG_WRN,$lng->Get('System.ChangesAfterRestart'));
	        }
	      }
			} // saved ok

		} // act == 'edit'


    // redirect
    $_SESSION['msg'] = $msg;
    //header('Location: '.$rooturl.'editfile.php?id='.$fileid);
    header('Location: '.$rooturl.$dst);
    exit;
  }

	LogAction('View config file '.$filepath,array('level'=>'view'));

  // ready with database
  $dbintf->close();

	$msg[] = new Msg(MSG_INF,$lng->Get('Options.WarningEditFile1'));
	$msg[] = new Msg(MSG_WRN,$lng->Get('Options.WarningEditFile2'));

	$data = '';
	$data .= 'var filecontent = "' . JsQuote($filecontent) . '";' . "\r\n";
	$data .= 'var filename = "' . JsQuote($filename) . '";' . "\r\n";
	$data .= 'var editid = ' . $fileid . ";\r\n";
  $data .= "var active_cnt = $active_cnt; \r\n";

  $data .= GeneralJSData();
  $data .= "var active_cnt = $active_cnt; \r\n";

  $template_content = file_get_contents('../apresa/templ/editfile.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>