<?php

require_once('general.php');

HandleContacts($dbintf);

function HandleContacts($dbintf)
{
  global $rpl,$configs,$msg,$rooturl;

	if ($configs['EditProfile']==0)
	{
		echo 'Profile editing is disabled';
    exit;
	}
	if (int_ensure_defined($configs['NotEditPwdInProfile'])==1)
	{
		echo 'Editing of password is disabled';
    exit;
	}
	
	$actuinfo = $dbintf->GetActiveUserInfo();
	if ( $actuinfo['logonmethod'] != 0)
	{
			$msg[] = new Msg(MSG_ERR,'The password for this account cannot be edited');
			$_SESSION['msg'] = $msg;
			header('Location: '.$rooturl.'profile.php');
			exit;
	}
	
  $act = $_POST['act'];
  if ($act!='')
  {
		if ($act=='edit-pw')
		{
			$actuinfo = $dbintf->GetActiveUserInfo();
      if (defined('DEMO') && ($actuinfo['id']==1 || $actuinfo['id']==2) )
      {
        $msg[] = new Msg(MSG_ERR,GetErrDescr('demo-protecteduser'));
        $_SESSION['msg'] = $msg;
        header('Location: '.$rooturl.'editpwd.php');
        exit;
      }
      
			LogAction('Changing own password');
			$oldpw = $_POST['pwold'];
			$newpw = $_POST['pw1'];
			// test if old password matches
			if (DBInterface::VerifyPwd($oldpw,$actuinfo['pwd'])==false)
			{
				$msg[] = new Msg(MSG_ERR,'Old password does not match');
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'editpwd.php');
				exit;
			}
			// change it
			// don't use EditUserAccount, because requires more permission
			if ($dbintf->ChangePassword($actuinfo['id'],$newpw))
			{
				$msg[] = new Msg(MSG_INF,'<%Profile.NewPwdAccepted%>');
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'profile.php');
				exit;
			}
			else
			{
				$msg[] = new Msg(MSG_ERR,'<%Profile.NewPwdRejected%>');
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'editpwd.php');
				exit;
			}
		}
		$_SESSION['msg'] = $msg;
		header('Location: '.$rooturl.'editpwd.php');
		exit;
  }

	$data = '';
	
	LogAction('Viewed password edit page.',array('level'=>'view'));

	$actuinfo = $dbintf->GetActiveUserInfo();
	$data .= 'theuser = ' . "\r\n";
	$data .= '{ "usr": "' . JsQuote($actuinfo['usr']) . '"' . "\r\n";
	$data .= ', "name": "' . JsQuote($actuinfo['name']) . '"' . "\r\n";
	$data .= '};' . "\r\n";

  //Get the password information!
  $minpwdlength = int_ensure_defined($configs['MinPwdLength']);
  $strongpwdauth	= int_ensure_defined($configs['StrongPwdAuth']);	
  // ready with database
  $dbintf->close();

  $data .= "var minpwdlength=" . $minpwdlength . ";\r\n";
	$data .= "var strongpwdauth=" . $strongpwdauth . ";\r\n";
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/editpwd.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

?>
