<?php
  require_once dirname(__FILE__)."/../apresa/vendor/autoload.php";

  use Symfony\Component\Mailer\Mailer;
  use Symfony\Component\Mailer\Transport\SendmailTransport;
  use Symfony\Component\Mime\Email;
  use Symfony\Component\Mime\Part\DataPart;
  use Symfony\Component\Mime\MimeTypes;
  use Symfony\Component\Mime\Part\File;

  function SendEmailDataSymfony($configs, $dat)
  {
    $transport = new SendmailTransport('/usr/sbin/sendmail -t');
    $mailer = new Mailer($transport);
    $email = new Email();

    $email->subject($dat['Subject']);
    $email->from($configs['SMTPfrom']);
    $email->to(...$dat['To']);

    $toreplace = array();
    //$mimeTypes = new MimeTypes();

    for ($i=1;$i<=100;$i++)
    {
      $key = 'Embed_' . $i;
      if (isset($dat[$key])==false) break;

      $tagKey = $key . 'tag';
      //$type = $mimeTypes->guessMimeType($dat[$key]);
      $email->addPart((new DataPart(new File($dat[$key]), $key))->asInline());
      $toreplace[ $dat[$tagKey] ] = 'cid:' . $key;
    }
  
    if(isset($dat['HtmlBody']))
    {
      $htmlbody = $dat['HtmlBody'];
      foreach($toreplace as $from=>$to)
      {
        $htmlbody = str_replace($from,$to,$htmlbody);
      }
      $email->html($htmlbody);
    }

    if(isset($dat['Body']))
    {
      $email->text($dat['Body']);
    }

    for ($i=1;$i<=100;$i++)
    {
      $key = 'Attach' . '_' . $i;
      if (isset($dat[$key])==false) break;
      $email->addPart(new DataPart(new File($dat[$key])));
    }  

    return TrySendEmailSymfony($mailer, $email);
  }

function TrySendEmailSymfony(&$mailer,&$email)
{
	$retry = 0;
	while(true)
	{
    $ok = false;
    try
    {
			$mailer->send($email);
      $ret = true;
			$ok = true;
    } catch(Exception $e)
    {
			lg('Email failed with exception: '.$e);
    }
    if ($ok) break;
    else
    {
      $retry ++;
      if ($retry>5)
      {
        $ret = false;
        break;
      }
      // sleep for one second
      sleep(1);
    }
	}
  return $ret;
}
?>