<?php

define('ENCRYPTKEY','strlen_FAR_zxsaWstrcmp_FAR_fxqZa');
//define('ENCRYPTALG','tripledes');
define('ENCRYPTALG','rijndael-256');

use phpseclib\Crypt\Rijndael;
use phpseclib\Crypt\Random;

if (function_exists('mcrypt_module_open')==false)
{

require_once( __DIR__ . '/p/lib/phpseclib/Crypt/Base.php' );
require_once( __DIR__ . '/p/lib/phpseclib/Crypt/Rijndael.php' );
require_once( __DIR__ . '/p/lib/phpseclib/Crypt/Random.php' );

function encrypt($data_in)
{
  $cipher = new Rijndael( Rijndael::MODE_ECB );
  $cipher->setPreferredEngine( Rijndael::ENGINE_INTERNAL );
  // with enablePadding we get 1c1c1c etc. in the result,
  // this is not compatible with mcrypt
  // so we disable padding and use our own padding below
  $cipher->disablePadding();
  // a block length of 256 makes it incompatible with AES,
  // which always uses a block length of 128
  $cipher->setBlockLength(256);
  $cipher->setKeyLength(256);
  $cipher->setKey( substr(ENCRYPTKEY,0,32) );
  $input = make_salt(4) . $data_in;
  // padding with zero to a multiple of the block length
  $input .= str_repeat("\0", 32-(strlen($input)%32) );
  // . $data_in , 32, "\0")
  $output = $cipher->encrypt( $input );
  $ret = base64_encode($output);
  return $ret;
}

function decrypt($data_enc_64)
{
  if ($data_enc_64=='') return '';
  $data_enc = base64_decode($data_enc_64);
  $cipher = new Rijndael(Rijndael::MODE_ECB);
  $cipher->setPreferredEngine( Rijndael::ENGINE_INTERNAL );
  $cipher->disablePadding();
  $cipher->setBlockLength(256);
  $cipher->setKeyLength(256);
  $cipher->setKey( substr(ENCRYPTKEY,0,32) );
  $data_out = $cipher->decrypt( $data_enc );
  // remove salt
  $data_out = substr($data_out,4);
  // remove traiing null characters
  $data_out = rtrim($data_out,"\0");
  return $data_out;
}

function passwordEncrypt($pwd,$dataIn,$mode='ofb')
{
  $key = substr(sha1($pwd,true) . md5($pwd,true),0,32);
  $ivSize = 16;
  $iv = Random::string($ivSize);
  if ($mode == 'nofb') $cipher = new Rijndael(Rijndael::MODE_OFB);
  else if ($mode == 'ofb') $cipher = new Rijndael(Rijndael::MODE_OFB8);
  else throw new Exception('Not implemented');
  $cipher->use_inline_crypt = false;
  $cipher->setPreferredEngine( Rijndael::ENGINE_INTERNAL );
  $cipher->disablePadding();
  $cipher->setBlockLength(128);
  $cipher->setKeyLength(256);
  $cipher->setKey( $key );
  $cipher->setIV( $iv );
  $dataOut = $iv . $cipher->encrypt( $dataIn );
  return $dataOut;
}

function passwordDecrypt($pwd,$dataIn,$mode='ofb')
{
  $key = substr(sha1($pwd,true) . md5($pwd,true),0,32);
  $ivSize = 16;
	if (strlen($dataIn) <= $ivSize) return "";
	$iv = substr($dataIn, 0, $ivSize);
  if ($mode == 'nofb') $cipher = new Rijndael(Rijndael::MODE_OFB);
  else if ($mode == 'ofb') $cipher = new Rijndael(Rijndael::MODE_OFB8);
  else throw new Exception('Not implemented');
  $cipher->use_inline_crypt = false;
  $cipher->setPreferredEngine( Rijndael::ENGINE_INTERNAL );
  $cipher->disablePadding();
  $cipher->setBlockLength(128);
  $cipher->setKeyLength(256);
  $cipher->setKey( $key );
  $cipher->setIV( $iv );
  $dataOut = $cipher->decrypt( substr($dataIn,$ivSize) );
  return $dataOut;
}

} else if (function_exists('mcrypt_module_open'))
{

function encrypt($data_in)
{
	/*
		ECB (cookbook) is not secure way,
		but this is countered by our own custom salt addition.
		For a better way, see passwordEncrypt.
	*/
  $enc_mod = mcrypt_module_open(ENCRYPTALG,'','ecb','');
  $key = substr(ENCRYPTKEY,0,mcrypt_enc_get_key_size($enc_mod));
  $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($enc_mod), MCRYPT_RAND);

  mcrypt_generic_init($enc_mod,$key,$iv);
  $data_enc = mcrypt_generic($enc_mod,make_salt(4).$data_in);
  mcrypt_generic_deinit($enc_mod);

  mcrypt_module_close($enc_mod);

  // convert to base64 bits to avoid problems when storing in database
  return base64_encode($data_enc);
}

function decrypt($data_enc_64)
{
  if ($data_enc_64=='') return '';

  $data_enc = base64_decode($data_enc_64);

  $enc_mod = mcrypt_module_open(ENCRYPTALG,'','ecb','');
  $key = substr(ENCRYPTKEY,0,mcrypt_enc_get_key_size($enc_mod));
  $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($enc_mod), MCRYPT_RAND);

  mcrypt_generic_init($enc_mod,$key,$iv);
  $data_out = mdecrypt_generic($enc_mod,$data_enc);
  // remove null characters at the end
  $data_out = rtrim($data_out,"\0");
  // remove salt
  $data_out = substr($data_out,4);
  mcrypt_generic_deinit($enc_mod);

  mcrypt_module_close($enc_mod);
  return $data_out;
}

// The return value is binary
// use bin2hex, or base64_encode when storing in DB.
function passwordEncrypt($pwd,$dataIn,$mode='ofb')
{
	$enc_mod = mcrypt_module_open('rijndael-128','',$mode,'');
  $key = substr(sha1($pwd,true) . md5($pwd,true),0,mcrypt_enc_get_key_size($enc_mod));
	//lg('KEY: '.bin2hex($key) );
  $iv = mcrypt_create_iv(mcrypt_enc_get_iv_size($enc_mod), MCRYPT_RAND);
	//lg('IV: '.bin2hex($iv) );
	$blkSize = mcrypt_enc_get_block_size($enc_mod);
	
  mcrypt_generic_init($enc_mod,$key,$iv);
  $dataOut = $iv . mcrypt_generic($enc_mod,$dataIn);
  mcrypt_generic_deinit($enc_mod);
	
  mcrypt_module_close($enc_mod);

	return $dataOut;
}


// The return value is binary
// use bin2hex, or base64_encode when storing in DB.
function passwordDecrypt($pwd,$dataIn,$mode='ofb')
{
  $enc_mod = mcrypt_module_open('rijndael-128','',$mode,'');
  $key = substr(sha1($pwd,true) . md5($pwd,true),0,mcrypt_enc_get_key_size($enc_mod));
	//lg('KEY: '.bin2hex($key) );
	$ivSize = mcrypt_enc_get_iv_size($enc_mod);
  
	if (strlen($dataIn) <= $ivSize) return "";
  
	$iv = substr($dataIn, 0, $ivSize);

  mcrypt_generic_init($enc_mod,$key,$iv);
  $dataOut = mdecrypt_generic($enc_mod,substr($dataIn,$ivSize) );
  mcrypt_generic_deinit($enc_mod);

  mcrypt_module_close($enc_mod);
	return $dataOut;
}

} // end mcrypt block

function make_salt($len)
{
  $t = '';
  for ($i=0;$i<$len;$i++)
  {
    $t .= chr(0x40 + mt_rand(1,26));
  }
  return $t;
}

?>