<?php

require_once('general.php');
require_once('smbgen.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	$cfgkeys = array('ExpRecs','ExpAccFilter','ExpXml','ExpXmlDirPrefix','ApiVerifyTel','ExpCustomFN'
	,'EWinDomain','EWinUsr','EWinPwd','EBckServer','EBckShare','EBckSubdir','ExpWait','ExpWaitScreen'
  ,'ExpNotScrRec','EBckDisk','EBckPath','EBckTargetType'
	);
	
  $act = $_POST['act'];
  if ($act!='')
  {
		if ($act==='change')
		{
			LogAction('Change export recordings configuration');
      $configs_b = array();
      foreach ($cfgkeys as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_b[$cfgkey] = $_POST[$cfgkey];
          if ($cfgkey=='EWinPwd')
          {
            $configs_b[$cfgkey] = encrypt($configs_b[$cfgkey]);
          }
        }
      }
      // check disk
      if (isset($configs_b['EBckDisk']))
      {
        // check if in array
        $found = false;
        $disks = FindDisks();
        foreach ($disks as $disk)
        {
          if ($disk == $configs_b['EBckDisk'])
          {
            $found = true;
          }
        }
        if ($found==false)
        {
          $configs_b['EBckDisk'] = '';
          if ($configs_b['EBckTargetType']==3)
          {
            $msg[] = new Msg(MSG_ERR,'Invalid export disk');
            $_SESSION['msg'] = $msg;
          }
        }
      }      
      if ($configs_b['EBckServer'])
      {
          $ret_lookup = LookupIpAddress($configs_b['EBckServer']);
          if ($ret_lookup===false)
          {
            $configs_b['EBckServerIP'] = $configs_b['EBckServer'];
          } else
          {
            $configs_b['EBckServerIP'] = $ret_lookup;
          }
      }
			if (isset($_POST['ExportOffset']))
			{
				$ExportOffset = $_POST['ExportOffset'];
				// 0: where we left off => nothing to do
				if ($ExportOffset==1)
				{
					// 1: from beginning
					$configs_b['EBckIdHandled'] = 0;
				} else if ($ExportOffset==2)
				{
					// 2: only new
					$configs_b['EBckIdHandled'] = $dbintf->GetIdOfLatestCall();
					// no longer needed: $dbintf->RemoveProcessingFlagForAll( 64 ); // 64= export flag
				}
			}
      $dbintf->SetConfigsPart($configs_b,'exp');
			// Reset health status.
			// It needs to be reassessed.
			$dbintf->DeleteConfig('ExpHStatus');
			
			$configs_exp = $dbintf->LoadConfigsPart('exp');
			// 
			$destshow = '\\\\' . $configs_exp['EBckServerIP'] . '\\'
				. $configs_exp['EBckShare'] . '\\' 
				. str_replace('/','\\',$configs_exp['EBckSubdir']);
			
			$msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));
			// no longer accurate:
      // $msg[] = new Msg(MSG_INF,$lng->Get('Web.Directory').': '.$destshow);
		}
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'exprecopt.php');
    exit;
  }

  $configs_exp = $dbintf->LoadConfigsPart('exp');
	
	LogAction("Viewed Export recordings configuration page.",array('level'=>'view'));
	
  // find local disks
  $disks = FindDisks();
  
  $data = GeneralJSData();

  foreach ($cfgkeys as $cfgkey)
  {
		$isstr = true;
		$value = str_ensure_defined($configs_exp[$cfgkey]);
		if ($cfgkey=='EWinPwd')
		{
			$data .= 'var Has' . $cfgkey . ' = ' . (int)(decrypt($value)!='') . ";\r\n";
			continue;
		}
		if ($cfgkey=='ExpXml') $isstr = false;
    if ($cfgkey=='ExpNotScrRec') $isstr = false;
		if ($cfgkey=='ExpRecs') $isstr = false;
		if ($cfgkey=='ApiVerifyTel') $isstr = false;
		if ($cfgkey=='ExpWaitScreen') $isstr = false;
		if ($isstr==false)
		{		
			$data .= 'var ' . $cfgkey . ' = ' . (int)($value) . ";\r\n";
		} else
		{
			$data .= 'var ' . $cfgkey . ' = "' . JSQuote($value) .   "\";\r\n";
		}
	}

  $data .= 'var Disks = ' . json_encode($disks) . ";\r\n";
  
  $acc_list = $dbintf->GetAccessorsList(); // full list
  $data .= "var accs=[];\r\n";
  foreach ($acc_list as $acc)
  {
    if ($acc['type']!=1) continue;
    $data .= "accs[" . $acc['accid'] . "]= " .
        '{name:"' . JSQuote($acc['name']) . '"' .
        ",type:" . $acc['type'] .
        "};\r\n";
  }
	
  if (isset($configs_exp['EBckIdHandled']))
  {
    $OffsetID = int_ensure_defined( $configs_exp['EBckIdHandled'] );
  } else
  {
    $OffsetID = int_ensure_defined( $configs_exp['EBckOffset'] );
  }

  // ready with database
  $dbintf->close();
	
  $template_content = file_get_contents('../apresa/templ/exprecopt.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
	$rpl['OffsetID'] = $OffsetID;
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
