<?php

require_once('general.php');

HandlePage($dbintf);

function FileEntryCompare($a, $b)
{
	if ($a['fn'] == $b['fn']) return 0;
	if ($a['dt'] < $b['dt']) return 1;
	if ($a['dt'] > $b['dt']) return -1;
	// if date/time is equal sort on filename
	return ($a['fn'] < $b['fn']) ? 1 : -1;
}

function GetDirFileList(&$arr,$dir)
{
	if ($handle = @opendir($dir))
	{
		while (false !== ($fn = readdir($handle)))
		{
			if ($fn=='.' || $fn=='..') continue;
			$info = stat($dir . $fn);
			$arr[] = array( 'fn'=>$fn
				,'sz'=>$info['size']
				,'dt'=>$info['mtime']
				,'dir'=>$dir
				 );
		}
	}
	usort($arr, "FileEntryCompare");
	return $arr;
}

function GetFileList()
{
	$arr = array();
  GetDirFileList($arr,DATA_PATH . "/web/");
  GetDirFileList($arr,"/recordings/log/ShCtiLog/ShCtiApiLog/");
  GetDirFileList($arr,"/recordings/log/ShCtiLog/ShCtiDstLog/");
  GetDirFileList($arr,"/recordings/log/ShCtiLog/ShCtiSpyIsdnLog/");
  GetDirFileList($arr,"/recordings/log/ShCtiLog/ShCtiSystemInfoLog/");
  GetDirFileList($arr,"/recordings/log/crec/");
  GetDirFileList($arr,"/recordings/log/auto/");
  return $arr;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

	LogAction('Viewed recording card log files',array('level'=>'view'));

  $files = GetFileList();

  if (isset($_GET['file']))
  {
		$fn = $_GET['file'];
		// check if in directory
		$indir = false;
		$dir = '';
  	foreach($files as $file)
  	{
			if ($file['fn']==$fn)
			{
				$indir = true;
				$dir = $file['dir'];
			}
		}
		// serve this
		if ($indir)
		{
			LogAction('Download recording card log file '.$fn);
			$extension = pathinfo($fn, PATHINFO_EXTENSION);
			if (int_ensure_defined($_GET['compress'])==1)
			{
				$zipfn = tempnam('/recordings/log','lgapr');
				//echo $zipfn;
				$zip = new ZipArchive;
				$zip->open($zipfn,ZIPARCHIVE::CREATE);
				$zip->addFile($dir . $fn, $fn);			
				$zip->close();
				$zip = null;
				$mime = "application/zip";
				header("Content-Type: $mime");
				$zipfnout = $fn.'.zip';
				header('Content-Disposition: attachment; filename='.$zipfnout);
				readfile($zipfn);
				DeleteFn($zipfn);
				return;
			} else
			{
				$mime = "application/octet-stream";
				header("Content-Type: $mime");
				header('Content-Disposition: attachment; filename='.$fn);
				readfile($dir . $fn);
			}
		} else
		{
			echo "File not found";
		}
		exit;
	}

  $act = $_POST['act'];
	if ($act!='')
	{
		if ($act=='delall')
		{
			LogAction('Delete all recording card log files');
	  	foreach($files as $file)
	  	{
				$fpath = $file['dir'] . $file['fn'];
				DeleteFn($fpath);
			}
		}
		
		if ($act=='del')
		{
			$fn = $_POST['fn'];
			LogAction('Delete recording card log file '.$fn);
			// check if in directory
			$indir = false;
			$dir = '';
	  	foreach($files as $file)
	  	{
				if ($file['fn']==$fn)
				{
					$indir = true;
					$dir = $file['dir'];
				}
			}
			// serve this
			if ($indir)
			{
				$fn = $dir . $fn;
				if (DeleteFn($fn))
				{
          $msg[] = new Msg(MSG_INF,'<%Web.FileIsDeleted%>');
				}
			}
		}
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'files.php');
    exit;
	}

  // ready with database
  $dbintf->close();
  
	$tab = '';

  $data = '';

  //$data .= 'files = [';
  $tab = "<table class=\"filestab\">";
  $first = true;

  foreach($files as $file)
  {
		$fn = $file['fn'];
		$extension = pathinfo($fn, PATHINFO_EXTENSION);
		$tab .= "<tr>";
		$tab .= "<td class=\"fn\"><a href=\"files.php?file=".HtmlQuote($fn)."\">" . HtmlQuote($fn) . "</a>";
		$tab .= "<td class=\"compr\">";
		if ($extension!='tgz' && $extension!='zip')
		{
			$tab .= "<a href=\"files.php?compress=1&file=".HtmlQuote($fn)."\">".$lng->Get('System.Compress')."</a>";
		}
		$tab .= "<td class=\"sz\">" . round($file['sz']/1024) . " Kb";
		$tab .= "<td class=\"dt\">" . date("D, Y M d H:i:s",$file['dt']);
		$tab .= "<td class=\"btn\">" . "<a href=\"#\" onclick='return Del(\"" . JsQuote($fn) . "\")'>" . $lng->Get('Main.Delete')  . "</a>";
		//$data .= "\n {name:\"" . JSQuote($fn) ."\""
		//			. ",size:" . $info['size'] . "} ";
	}
	if (count($files)==0)
	{
		$tab .= "<tr>";
		$tab .= "<td>" . $lng->Get('Web.NoRecords') . "<td><td>";
	}
	$tab .= "</table>";
	//$data .= "];\n";

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/files.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['filestab'] = $tab;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
