<?php

require_once('general.php');

HandlePage($dbintf);

function GetSerialNumber()
{
	return trim(file_get_contents('../apresa/conf/serial'));
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {
  	$dst = '';
		if ($act=='edit')
  	{
			LogAction('Edit free-seating configuration');
			//echo "<PRE>";
			$lines = $_POST['content'];
			$lines = explode("\n",$lines);
			
			$serialnum = GetSerialNumber();
			$recorderid = -1;
			if ( ((int)$serialnum) != 0 )
			{
				$recorderid = $dbintf->GetOrCreateRecorderId($serialnum,"Apresa$serialnum");
			}
			
			$anyerr = false;
			$seats = array();
			foreach ($lines as $line)
			{
				$lenline = strlen($line);
				if ($lenline>0 && $line[$lenline-1]=="\r")
				{
					$line = substr($line,0,$lenline-1);
					$lenline--;
				}
				if ($lenline>0 && $line[$lenline-1]=="\n")
				{
					$line = substr($line,0,$lenline-1);
					$lenline--;
				}
				//echo "LINE: '".$line."'\n";
				$parts = ParseCsvLine($line);
				if (count($parts)==0) continue;
				if ($parts[0]=='') continue;
				$seat = array();
				$seat['pcname'] = strtoupper( $parts[0] );
				$ctid = -1;
				if (count($parts)>=2)
				{
					$linenr = $parts[1];
					if ($linenr!='')
					{
						// look up contact id
						$ct = $dbintf->GetLineContact($linenr,$recorderid);
						if ($ct!==NULL)
						{
							$ctid = $ct['contactid'];
						} else
						{
							$anyerr = true;
							$msg[] =  new Msg(MSG_WRN,"Line number '".$linenr."' of ".$seat['pcname'].' not found');
							continue;
						}
					}
				}
				if (count($parts)>=3)
				{
					$callerid = $parts[2];
					if ($callerid!='')
					{
						$ct = $dbintf->GetOrCreateCallerID($callerid,'',2,'');
						if ($ct!==false)
						{	
							$ctid = $ct['contactid'];
						} else
						{
							$anyerr = true;
							$msg[] =  new Msg(MSG_WRN,"Caller ID '".$callerid."' of ".$seat['pcname'].' not found');
							continue;
						}
					}
				}
				if ($ctid == -1)
				{
					$anyerr = true;
					$msg[] =  new Msg(MSG_WRN,"Nothing specified for ".$seat['pcname']);
					continue;
				}
				$seat['contactid'] = $ctid;
				$seats[] = $seat;
			}
			//var_dump($seats);
			if ($anyerr==false)
			{
				$dbintf->SetAllSeats($seats);
				$msg[] =  new Msg(MSG_INF,"Configuration saved");
			} else
			{
				$msg[] =  new Msg(MSG_WRN,"Data was not saved. Please correct the errors.");
			}
			//exit;
		}
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'freeseat.php');
    exit;
  }

	$seats = $dbintf->GetAllSeats();
	//var_dump( $seats );exit;
	
	$allt = '';
	$data = '';
	$first = true;
	foreach ($seats as $seat)
	{
		$callerid = '';
		$linenr = '';
		$ct = $dbintf->GetContactInfo($seat['contactid']);
		if ($ct!==false)
		{
			if ($ct['ctype']==0) $callerid = $ct['callerid'];
			if ($ct['ctype']==1) $linenr = $ct['linenr'];
		}
		$first = false;
		$allt .= CsvQuote($seat['pcname']) . ','. $linenr . ',' . CsvQuote($callerid) . "\n";
	}
	$data .= 'var seats_t = "' . JsQuote($allt) . '";' . "\n";
	
	LogAction("Viewed Seats configuration page.",array('level'=>'view'));
	
  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/freeseat.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function extractDigits($t)
{
	$len = strlen( $t );
	$num = '';
	for ($i=0;$i<$len;$i++)
	{
		if (ctype_digit($t[$i]))
		{
			$num .= $t[$i];
		}
	}
	return $num;
}

?>