<?php

require_once('general.php');
require_once('utility.php');

HandleGetActive($dbintf);

function ParseDateTime($dt)
{
  return strtotime($dt);
}

function HandleGetActive($dbintf)
{
  global $rpl,$configs,$actuinfo,$msg;

	if(DetermineWebclientOnly()
  || (str_ensure_defined($configs['Theme'])=='ts' && ($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN) )==0)
  || (str_ensure_defined($configs['ActiveCallsAccess'])=='admins'     && ($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN) )==0)
  ){
		echo 'Permission denied';
		exit;
	}
  
  // Get the call listing
  $call_list = $dbintf->GetActiveCallList();

  $calldata = '{"data":[';
  $first = true;
  foreach ($call_list as $ix=>$row)
  {
    // correct duration
    $row['duration'] = (time() - $row['startdate']) / 1;

    if ($first==false) $calldata .= ',';
		$jsonobj = array();
		$jsonobj['startdate'] = date($configs['datetimef'],$row['startdate']);
		$jsonobj['id'] = $row['id'];
		$jsonobj['remoteid'] = $row['remoteid'];
		$jsonobj['remote'] = EmptyNull($row['remote']);
		$jsonobj['local'] = EmptyNull($row['local']);
		$jsonobj['source'] = $row['source'];
		$jsonobj['remotefull'] = EmptyNull($row['remotefull']);
		$jsonobj['localfull'] = EmptyNull($row['localfull']);
		$jsonobj['lctid'] = int_ensure_defined($row['localcontact']);
		$jsonobj['rctid'] = int_ensure_defined($row['remotecontact']);
		$jsonobj['lname'] = EmptyNull($row['lname']);
		$jsonobj['rname'] = EmptyNull($row['rname']);
		$jsonobj['remote2'] = EmptyNull($row['remote2']);
		$jsonobj['local2'] = EmptyNull($row['local2']);
		$jsonobj['connected'] = EmptyNull($row['connected']);
		$jsonobj['cname'] = EmptyNull($row['cname']);
		$jsonobj['cctid'] = $row['connectedcontact'];
		$jsonobj['direction'] = $row['direction'];
		$jsonobj['notes'] = $row['notes'];
		$jsonobj['length'] = formatDuration($row['duration']);
		$jsonobj['linenr'] = (int) $row['linenr'];
	  $jsonobj['filename'] = GetDownloadFileName($row['filename'],$row);
	  $jsonobj['pm'] = (int) $row['pm'];
	  $jsonobj['isarchived'] = (int) $row['isarchived'];
		
    $calldata .= json_encode($jsonobj,JSON_FORCE_OBJECT) . "\r\n";
    $first = false;
  }

  $calldata .= ']}';

  $dbintf->close();

  echo $calldata;
}



?>

