<?php

if (isset($_POST['data'])==false
|| (   $_POST['data']!='audittrail'
    && $_POST['data']!='contacts'   )
)
{
  $NO_LAST_ACCESS_UPDATE = true;
}

require_once('general.php');
require_once('listinggen.php');
require_once('ldapfunc.php');

HandleGetData($dbintf);


function HandleGetData($dbintf)
{
  global $configs;

	// used on test page 'bezig_web\main_async.htm'
 	$whatdata = str_ensure_defined($_GET['data']);
	if (isset($_POST['data']))
	{
		$whatdata = $_POST['data'];
	}

	if ($whatdata=='calls')
	{
		GetCalls();
		return;
	}
  
  if ($whatdata=='livecalls')
  {
    GetLiveCalls();
    return;
  }

	// used on contacts page
  if ($whatdata=='contacts')
  {
		GetContacts();
		return;
	}

	// previously used on the user edit page
  if ($whatdata=='ct')
  {
		GetContactsAC();
		return;
	}
	
	// user on user edit page
	if ($whatdata=='cids')
	{
		GetCallerIDs();
		return;
	}

	if ($whatdata=='lines')
	{
		GetLines();
		return;
	}
	
	// used on user edit page
  if ($whatdata=='inhpm')
  {
		GetInhPm();
		return;
	}

	// used on user edit page
  if ($whatdata=='pms')
  {
		GetPms();
		return;
	}

  if ($whatdata=='audittrail')
  {
    GetAuditTrail();
    return;
  }
	
	if ($whatdata=='chat')
	{
		GetChat();
		return;
	}

 	if ($whatdata=='chatmsg')
	{
		GetChatMsg();
		return;
	}

	// used on monch.php
	if ($whatdata=='chstate')
	{
		GetChState();
		return;
	}
	
	//used on group edit page
	if ($whatdata=='ldapgroups')
	{
		GetLdapGroups();
		return;
	}
	if ($whatdata=='azgroups')
	{
		GetAzGroups();
		return;
	}
	
	//used on recopt.php
	if ($whatdata=='userphonenumbers')
	{
		GetUserPhoneNumbers();
		return;
  }
  
  if($whatdata=='callkey')
  {
    $key = $dbintf->GetCallKey($_POST['callid']);

    if($key === false)
    {
      http_response_code(404);
    }
    else
    {
      $out['PrivateKey'] = $key['privkey'];
      $out['salt'] = $key['salt'];
      $out['iv'] = $key['keyiv'];
      $out['CallKey'] = $key['callkey'];
      $out['counter'] = $key['iv'];

      header('Content-Type: application/json');
      echo json_encode($out);
    }
  }

  if($whatdata=='privkey')
  {
    $tenant = $dbintf->GetGroupInfo($dbintf->actuinfo['tenantid']);
    $key = $dbintf->GetCallEncryptionKey($tenant['accid']);

    if($key === false)
    {
      http_response_code(404);
    }
    else
    {
      $out['privKey'] = $key['privkey'];
      $out['iv'] = $key['iv'];
      $out['salt'] = $key['salt'];
      header('Content-Type: application/json');
      echo json_encode($out);
    }
  }

  return;
}

function GetChatMsg()
{
	global $dbintf,$configs;
  $fullAdmin = ($dbintf->actuinfo['permissions']&PM_CONFIG)!=0;
  if ($fullAdmin==false)
  {
		echo json_encode( array( 'data' => array(), 'errmsg' => 'Permission denied' ) );
		exit;
	}
	$chatid = (int) $_POST['chat'];
	$offset = (int) $_POST['offset'];
	$page = (int) $_POST['pagesize'];
  // we retrieve a bit more to detect how many entries we have
  // still this will not be perfect
  $limit = ($page * 5) + 1;
	$options = array();
	$options['offset'] = $offset;
	$options['limit'] = $limit;
	$msgs = $dbintf->GetChatMesssages($options,$chatid);
	$atLeast = $offset + count($msgs);
	$totalRecords = -1;
  if (count($msgs)<$limit)
  {
    $totalRecords = $offset + count($msgs);
  }
	$ret = array();
	$data = array();
	foreach ($msgs as $msg)
	{
		if ($msg['created']!=null)
		{
			$msg['created'] = date($configs['datetimef'],(int)$msg['created']);
		}
		if ($msg['modified']!=null)
		{
			$msg['modified'] = date($configs['datetimef'],(int)$msg['modified']);
		}
		if ($msg['deleted']!=null)
		{
			$msg['deleted'] = date($configs['datetimef'],(int)$msg['deleted']);
		}
		$data[] = $msg;
	}
	$ret['data'] = $data;
	$ret['atLeast'] = $atLeast;
  $ret['startIndex'] = $offset;
	if ($totalRecords!=-1)
	{
		$ret['totalRecords'] = $totalRecords;
	}
	echo json_encode( $ret );	
}

function GetChat()
{
	global $dbintf,$configs;
  $fullAdmin = ($dbintf->actuinfo['permissions']&PM_CONFIG)!=0;
  if ($fullAdmin==false)
  {
		echo json_encode( array( 'data' => array(), 'errmsg' => 'Permission denied' ) );
		exit;
	}
	$offset = (int) $_POST['offset'];
  // this page limit has to match its counterpart in chat_archive.htm
  $page = (int) $_POST['pagesize'];
  // we retrieve a bit more to detect how many entries we have
  // still this will not be perfect
  $limit = ($page * 5) + 1;
	$chats = $dbintf->GetChats($offset,$limit);
	$atLeast = $offset + count($chats);
	$totalRecords = -1;
  if (count($chats)<$limit)
  {
    $totalRecords = $offset + count($chats);
  }
  // remove additional that was retrieved only for
  // determining the number of records
  while (count($chats)>$page)
  {
    array_pop($chats);
  }
	$maxmembers = 10; // number of members to load from db
	$data = array();
	foreach ($chats as $chat)
	{
		$tocopy = array( 'id', 'type', 'topic', 'teamname', 'channelname' );
		$obj = array();
		foreach ($tocopy as $col)
		{
			$obj[$col] = $chat[$col];
		}
		$obj['members'] = $dbintf->GetChatMemberList($chat['id'],$maxmembers);
		$data[] = $obj;
	}
	$ret = array();
	$ret['data'] = $data;
	$ret['atLeast'] = $atLeast;
  $ret['startIndex'] = $offset;
	if ($totalRecords!=-1)
	{
		$ret['totalRecords'] = $totalRecords;
	}
	echo json_encode( $ret );	
}

function GetAuditTrail()
{
	global $dbintf,$configs;
  $fullAdmin = ($dbintf->actuinfo['permissions']&PM_CONFIG)!=0;
  $tenantAudit = false;
  $tenantid = NULL;
  if ($fullAdmin==false)
  {
    $tenantAudit = ($dbintf->actuinfo['permissions']&PM_TENANT_ADMIN_AUDIT)!=0;
    if ($tenantAudit==false)
    {
      echo 'Permission denied';
      exit;
    }
    if($dbintf->actuinfo["tenantid"]==NULL)
    {
      // configuration error
      // tenant admin, but no tenantid
      echo json_encode( array( 'data' => array(), 'errmsg' => 'Tenant admin is not a member of a tenant' ) );
      exit;
    }
    $tenantid = $dbintf->actuinfo["tenantid"];
  }
  
  $ret = array();
  $search = array();
  $postcopy = array('fd','ld','ft','lt','descr');
  foreach ($postcopy as $key)
  {
    if (isset($_POST[$key]))
    {
      $search[$key] = $_POST[$key];
    }
  }
  if (isset($search['ld']))
  {
    $ld = $search['ld'];
	  // next day
	  $ld = $ld + 60 * 60 * 24;
    $search['ld'] = $ld;
  }
  if (isset($_POST['user']))
  {
    $username = $_POST['user'];
    // convert to userid
    $userinfo = $dbintf->GetUserInfoOnUsername($username);
    if ($tenantid !== null)
    {
      if ($userinfo['tenantid'] != $tenantid)
      {
        $userinfo = false;
      }
    }
    if ($userinfo!==false)
    {
      $search['userid'] = $userinfo['id'];
    } else
    {
      $search['userid'] = -1;
      $ret['errmsg'] = 'User not found';
    }
  }
  if ($tenantid !== null)
  {
    $search['tenantid'] = $tenantid;
  }
  
  $sortby = array();
  $sortby['key'] = 'moment';
  $sortby['ascending'] = false;
  if (isset($_POST['sa'])==true)
  {
    $sa = (int) $_POST['sa'];
    $sortby['ascending'] = ($sa!=0);
  }

  // this page limit has to match its counterpart in auditdb.htm
  $page = 20;
  // we retrieve a bit more to detect how many entries we have
  // still this will not be perfect
  $limit = ($page * 5) + 1;
  $totalRecords = -1;
  $offset = (int) $_POST['offset'];
  $data = $dbintf->GetAuditTrailEntries($search,$limit,$offset,$sortby);
  if (count($data)==0 && $offset>0)
  {
    // retry with no offset
    $offset = 0;
    $data = $dbintf->GetAuditTrailEntries($search,$limit,$offset,$sortby);
  }
  $atLeast = $offset + count($data);
  if (count($data)<$limit)
  {
    // we only know how many entries we have,
    // if we get less than we asked for
    $totalRecords = $offset + count($data);
  }
  // remove additional that was retrieved only for
  // determining the number of records
  while (count($data)>$page)
  {
    array_pop($data);
  }
  
  $users = $dbintf->GetUserList();
  $usermap = array();
  foreach ($users as $user)
  {
    $usermap[ $user['id'] ] = $user;
  }
  $tenants = $dbintf->GetTenantList();
  foreach ($tenants as $tenant)
  {
    $tenantmap[ $tenant['id'] ] = $tenant;
  }
  
  $entries = array();
  foreach ($data as $row)
  {
    $entry = array();
    $entry['moment'] = date($configs['datetimef'],$row['moment']);
    $entry['ipaddr'] = $row['ipaddr'];
    // convert userid to username and tenant
    $username = '';
    $tenantname = '';
    $userid = (int) $row['userid'];
    if ($userid==NULL)
    {
      $username = '';
    } else if ( isset( $usermap[ $userid ] ) == false )
    {
      $username = '??'; // should not occur
    } else
    {
      $user = $usermap[ $userid ];
      $username = $user['usr'];
      $tenantid = $user['tenantid'];
      if ($tenantid!=0)
      {
        if ( isset( $tenantmap[ $tenantid ] ) == false )
        {
          $tenantname = '??'; // should not occur
        } else
        {
          $tenant = $tenantmap[$tenantid];
          $tenantname = $tenant['name'];
        }
      }
    }
    $entry['tenant'] = $tenantname;
    $entry['user'] = $username;
    $entry['descr'] = $row['descr'];
    $entries[] = $entry;
  }

  $ret['data'] = $entries;
  $ret['atLeast'] = $atLeast;
  if ($totalRecords!=-1)
  {
    $ret['totalRecords'] = $totalRecords;
  }
  $ret['startIndex'] = $offset;
  echo json_encode( $ret );
}

function GetUserPhoneNumbers()
{
	global $dbintf;
	
	if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_FILTER))==0)
  {
    echo 'Permission denied';
    exit;
  }
	
	$numbers = $dbintf->GetUserPhoneNumbers();
	$dbintf->close();
	$data = '';
	$data .= '[';
	$first = true;
	foreach($numbers as $number){
		if($first == false){ $data .= ','; }
		$data .= '"' . JSQuote($number) . '"';
		$first = false;
	}
	$data .= ']';
	
	echo $data;
}

function GetContactsAC()
{
	global $dbintf;
	header('Content-Type: application/json');

	$q = str_ensure_defined( $_POST['q'] );

	$search = array();
	$search['name'] = $q;

	WriteContacts(0,10,$search);
}

function GetContacts()
{
	global $dbintf;

  if (($dbintf->actuinfo['permissions']&(PM_VIEWPHONEBOOK|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

	header('Content-Type: application/json');

	$offset = int_ensure_defined($_POST['offset']);
	$strName = str_ensure_defined($_POST['name']);
	$pagesize = 20;

	$search = array();
	if ($strName!='') $search['name'] = $strName;

	$search['wantTotal'] = true;
  
  $logarr = array('level'=>'view');
  $logarr['offset'] = $offset;
  $logarr['search'] = $strName;
  LogAction('View contact list',$logarr);

	WriteContacts($offset,$pagesize,$search);
}

function WriteContacts($offset,$pagesize,$search)
{
	global $dbintf,$lng;

  if (($dbintf->actuinfo['permissions']
	&(PM_CONFIG|PM_SUBADMIN|PM_USERS|PM_VIEWPHONEBOOK|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

	$subadmin = false;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0
	&& ($dbintf->actuinfo['permissions']&PM_SUBADMIN)!=0
	)
	{
		$subadmin = true;
	}

  $serialnum = (int) file_get_contents('../apresa/conf/serial');
	$thisRecorder = null;
	if ($serialnum!=0)
	{
		$thisRecorder = $dbintf->GetOrCreateRecorderId($serialnum,"Apresa$serialnum");
	}
  $recorders = $dbintf->GetRecorders();
  $recorderMap = array();
  foreach ($recorders as $recorder)
  {
    $recorderMap[ $recorder['id'] ] = $recorder;
  }
  
	$data = '{';
	$strName = str_ensure_defined($search['name']);

  if ($subadmin)
  {
		$phonelist = $dbintf->GetUserPhones( $dbintf->actuinfo['accid'] );
		$unfilteredload = array();
		foreach ($phonelist as $phone)
		{
			$ctdat = $dbintf->GetContactInfo($phone);
			$ctdat['contactid'] = $ctdat['id'];
			$unfilteredload[] = $ctdat;
		}
	} else
	{
		// get all lines
	  $unfilteredload = $dbintf->GetLineList();
	  foreach ($unfilteredload as $key=>&$ref_ct)
	  {
			$ref_ct['islocal'] = 1;
			$ref_ct['ctype'] = 1;
		}
	}
  $filtered = array();
	// - filter for search
	// - filter deleted
	// - filter for offset and pagesize
	$ix = -1;
	$tot = 0;
	$before_cnt = 0;
  foreach ($unfilteredload as $key=>$contact)
  {
		if ($contact['deleted']) continue;
		if ($strName!=''
			&& stripos($contact['name'],$strName)===false
			&& ( $contact['ctype']!=1 || stripos($lng->Get('Cols.linenr') . ' ' . $contact['linenr'],$strName)===false )
			&& stripos($contact['callerid'],$strName)===false
		)
		{
			continue;
		}
		$ix ++;
		$tot ++;
		if ($ix<$offset)
		{
			$before_cnt ++;
			continue;
		}
		if ($ix>=$offset+$pagesize) continue;
		// add it
		$filtered[] = $contact;
	}

	$filter_cnt = count($filtered);

	if (isset($search['wantTotal']))
	{
		if ($subadmin==false)
		{
			$tot += $dbintf->GetCallerIDSearchCount(false,$search);
		}
		$data .= '"totalRecords": ' . $tot;
		$data .= ', ';
	}
	$data .= '"startIndex": ' . $offset;

	$callerid_list = array();
	if ($subadmin==false && ($pagesize > $filter_cnt))
	{
		// first param = also-deleted?
		$startcid = $offset - $before_cnt - $filter_cnt;
		if ($startcid<0) $startcid = 0;
  	$callerid_list = $dbintf->GetCallerIDPartialList(false,$startcid,$pagesize-$filter_cnt,$search);
	}

	$data .= ', "data":[';
  $first = true;
  foreach ($filtered as $row)
  {
    if ($row['ctype']==1)
    {
    	$t = $lng->Get('Cols.linenr') . ' ' . $row['linenr'];
    } else
    {

    	$t = $row['callerid'];
		}
		if ($row['name']!='') $t .= ' [' . $row['name'] . ']';
		
		$jsonobj = new stdClass();
		$jsonobj->ctid = $row['contactid'];
    $jsonobj->cname = $row['name'];
    $jsonobj->t = $t;
    $jsonobj->linenr = $row['linenr'];
    $jsonobj->callerid = $row['callerid'];
    $jsonobj->callerid2 = $row['callerid2'];
    $jsonobj->islocal = $row['islocal'];
    $recorderid = $row['recorderid'];
    $recorderSN = '';
    if ($recorderid == $thisRecorder) ;
    else {
      if (isset($recorderMap[ $recorderid ]))
      {
        $recorder = $recorderMap[ $recorderid ];
        $recorderSN = $recorder['recid'];
      }
    }
    $jsonobj->recorder = $recorderSN;
    $jsonobj->ctype = $row['ctype'];
    $encoded = json_encode( $jsonobj );
    if ($encoded === false)
    {
      // could be a case of malformed UTF-8 in database
      continue; 
    }
    if ($first==false) $data .= ',';
		$data .= $encoded . "\r\n";
    $first = false;
  }
	foreach ($callerid_list as $row)
	{
    $t = $row['callerid'];
		if ($row['name']!='') $t .= ' [' . $row['name'] . ']';
		$jsonobj = new stdClass();
		$jsonobj->id = $row['id'];
    $jsonobj->callerid = $row['callerid'];
    $jsonobj->callerid2 = $row['callerid2'];
    $jsonobj->ctid = $row['contactid'];
    $jsonobj->cname = $row['name'];
    $jsonobj->t = $t;
    $jsonobj->islocal = $row['islocal'];
    $jsonobj->ctype = 0;
    $encoded = json_encode( $jsonobj );
    if ($encoded === false)
    {
      // could be a case of malformed UTF-8 in database
      continue; 
    }
    if ($first==false) $data .= ',';
		$data .= $encoded . "\r\n";
  	$first = false;
	}
	$data .= ']';


  $data .= '}';
  $dbintf->close();

	echo $data;

}

function GetLiveCalls()
{
	global $dbintf, $configs;
  
  $now = time();
  $calls = $dbintf->GetLiveCalls();
  if ($calls===false)
  {
    return;
  }
  foreach ($calls as &$call_ref)
  {
    $call_ref['initage'] = $now - $call_ref['inittime'];
    $endwait = $now;
    $endring = $now;
    if ($call_ref['connecttime']!=null)
    {
      $endwait = $call_ref['connecttime'];
      $endring = $call_ref['connecttime'];
      $call_ref['conlen'] = $now - $call_ref['connecttime'];
    }
    $call_ref['waitlen'] = $endwait - $call_ref['inittime'];
    if ($call_ref['ringtime']!=null)
    {
      $call_ref['ringlen'] = $endring - $call_ref['ringtime'];
    }
    $call_ref['inittime'] = date($configs['datetimef'],$call_ref['inittime']);
  }
  $ret = array();
  $ret['data'] = $calls;
  echo json_encode($ret);
  
  
}

function GetCalls()
{
	global $dbintf, $configs;
	
  $handler = new ListingHandler();
  $handler->filterData = true;
  $handler->needJsData = false;
	$handler->ParseSearch();
	$handler->PerformSearch();
  $dbintf->close();

	echo $handler->GetJsonData();
		
}

function GetPms()
{
		global $dbintf;

		$useraccid = (int) $_POST['usr'];
    $theuser = $dbintf->GetUserInfoOnAccId($useraccid);
		if ($theuser===false)
		{
			echo "User not found";
			exit;
		}
    if ($dbintf->MayEditUserAccount($theuser['id'],$theuser['accid'])==false)
    {
      echo 'Permission denied';
    	exit;
		}

		$db2 = new DBInterface('');
		$db2->cloneInit( $dbintf );
		$db2->SetCurrentUserId( $theuser['id'] );
		
	  $data = '{"data":[';
		$ix = 0;
		$first = true;
		if ($db2->actuinfo['permissions']!=0)
		{
			$ix++;
			$data .= '{"id":'.$ix
			. ',"callaccid":0'
			. ',"pm":'.$db2->actuinfo['permissions']
			. "}\r\n";
			$first = false;
		}
	  foreach ($db2->accpms	as $accid=>$pm)
	  {
			if (isset($dbintf->allgroups[$accid]))
			{
				continue;
			}
			$ix ++;
	    if ($first==false) $data .= ',';
	    $first = false;
      $data .= '{"id":'.$ix
      . ',"callaccid":'.$accid
      . ',"pm":'.$pm
      . "}\r\n";
	  }
		

	  $data .= ']}';
	  $dbintf->close();

		echo $data;
}

function GetInhPm()
{
		global $dbintf;

		$usergroups = str_ensure_defined($_POST['groups']);
    if($usergroups == "") $usergroups = [];
		else $usergroups = explode(',',$usergroups);
		
		$allowed = false;
		$aupm = $dbintf->actuinfo['permissions'];
		if ($aupm&PM_CONFIG) $allowed = true;
		if ($aupm&PM_USERS) $allowed = true;
    if ($aupm&PM_T2_ADMIN) $allowed = true;
    if ($aupm&PM_T3_ADMIN) $allowed = true;
		if ($dbintf->anyaccpms&PM_USERS && $allowed==false)
		{
			// May not move to a group to which no
			// edit access.
			$oldGroups = array();
			if (isset($_POST['usr']))
			{
				$useraccid = $_POST['usr'];
				if ($useraccid!=0)
				{
					if (($dbintf->GetAccPm($useraccid)&PM_USERS)!=0)
					{
						$oldGroups = $dbintf->GetGroupsOfWhichMember( $useraccid );
					}
				}
			}
			$allowed = true;
			foreach ($usergroups as $grpaccid)
			{
				$isNew = true;
				foreach ($oldGroups as $oldGroup)
				{
					if ($oldGroup==$grpaccid)
					{
						$isNew = false;
					}
				}
				if ($isNew==false) continue;
				if (($dbintf->GetAccPm($grpaccid)&PM_USERS)==0)
				{
					$allowed = false;
				}
			}
		}

		if ($allowed==false)
	  {
	    echo 'Permission denied';
	    exit;
	  }
	
    $inh_accpms = $dbintf->GetAccAccPms($usergroups);
    $supergroups = $dbintf->GetSuperGroups($usergroups);
		$supergroups = array_diff($supergroups,$usergroups);
    $spr_accpms = $dbintf->GetAccAccPms($supergroups);
    foreach($spr_accpms as $accacc)
    {
      if ($accacc['applytype']!=1) continue;
      $inh_accpms[] = $accacc;
		}

	  $data = '{"data":[';
	  $first = true;
	  foreach ($inh_accpms as $ix=>$row)
	  {
	    if ($first==false) $data .= ',';
	    $first = false;
      $data .= '{"id":'.$row['id']
      . ',"accid":'.$row['accid']
      . ',"callaccid":'.$row['callaccid']
      . ',"pm":'.$row['epermissions']
      . "}\r\n";
	  }

	  $data .= ']}';
	  $dbintf->close();

		echo $data;
}

function GetAzGroups()
{
	global $dbintf;
  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_USERS))==0)
  {
    echo 'Permission denied';
    exit;
  }

	$azid = (int) $_POST['azid'];
  $simulation = false;
  $ret = new stdClass();
  // even on Windows the real thing works
  if ($simulation)
  {
		if ($azid==0) $ldapreturn = array();
		else
		{
      $grouplist = 
      [
        (object) [ "name" => 'abc' , 'id' => '123-456-000' ]
      , (object) [ "name" => 'xyz' , 'id' => '888-021-032' ]
      ];
		}
	} else
	{
    require_once('azure.php');
    $errmsg = '';
		$ret->data = GetAzureGroupList($azid,$errmsg);
    if ($errmsg != '')
    {
      $ret->errmsg = $errmsg;
    }
	}
	
	$data = json_encode($ret);
	echo $data;
}

function GetLdapGroups()
{
	global $dbintf;
  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_USERS))==0)
  {
    echo 'Permission denied';
    exit;
  }

	$ldaphost = str_ensure_defined( $_POST['ldaphost'] );
  if (COM_TYPE=='Win')
  {
		if ($ldaphost=='') $ldapreturn = array();
		else
		{
			$prefix = substr(md5($ldaphost),3,4);
			$ldapreturn = array
			( 'CN='.$prefix.' Printer users,CN=Users,DC=TestCompany,DC=local'
			, 'CN='.$prefix.' Network users,CN=Users,DC=TestCompany,DC=local'
			);
		}
	} else
	{
		$ldapreturn = get_groups($ldaphost);
	}
	
	$data = '{"data":[';
	$first = true;
	foreach ($ldapreturn as $a)
	{
		if ($first==false) $data .= ',';
		$first = false;
		$r = explode(",",$a,2);
		$g = explode("=",$r[0]);
		$jsonobj = new stdClass();
    $jsonobj->gn = $g[1];
		$jsonobj->gs = $a;
		$data .= json_encode( $jsonobj ) . "\r\n";
	}
	$data .= ']}';
	echo $data;
}

function GetChState()
{
	global $dbintf;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	//header('Content-Type: application/json');

	$ch = (int) $_GET['ch'];
	if (isset($_POST['ch']))
	{
		$ch = (int) $_POST['ch'];
	}
	$reply = true;
	signal_service('sgncrc chst '.$ch,$reply);
	$fn = DATA_PATH . '/chstate_' . $ch . '.dat';
	$arr = ReadDataFile($fn);
	if ($arr==null) $arr = array();
  $data = '{"data":[{';
	$data .= '"Channel":'.$ch;
  $first = true;
  foreach ($arr as $key=>$value)
  {
		$data .= ',';
		$data .= '"'.$key.'":"'.$value.'"';
	}
  $data .= '}]}';
  echo $data;
}

function GetCallerIDs()
{
	global $dbintf;
	header('Content-Type: application/json');

	$q = str_ensure_defined( $_POST['q'] );

	$search = array();
	$search['name'] = $q;
	$offset = 0;
	$pagesize = 10;

  if (($dbintf->actuinfo['permissions']
	&(PM_CONFIG|PM_SUBADMIN|PM_USERS|PM_VIEWPHONEBOOK|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

	$subadmin = false;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0
	&& ($dbintf->actuinfo['permissions']&PM_SUBADMIN)!=0
	)
	{
		$subadmin = true;
	}

	$data = '{';
	$strName = str_ensure_defined($search['name']);
	$unfilteredload = array();

  if ($subadmin)
  {
		$phonelist = $dbintf->GetUserPhones( $dbintf->actuinfo['accid'] );
		foreach ($phonelist as $phone)
		{
			$ctdat = $dbintf->GetContactInfo($phone);
			// only caller ID
			if ($ctdat['ctype']!=0) continue;
			$ctdat['contactid'] = $ctdat['id'];
			$unfilteredload[] = $ctdat;
		}
	}
	
  $filtered = array();
	// - filter for search
	// - filter deleted
	// - filter for offset and pagesize
	$ix = -1;
	$tot = 0;
	$before_cnt = 0;
  foreach ($unfilteredload as $key=>$contact)
  {
		if ($contact['deleted']) continue;
		if ($strName!=''
			&& stripos($contact['name'],$strName)===false
			&& ( $contact['ctype']!=1 || stripos($lng->Get('Cols.linenr') . ' ' . $contact['linenr'],$strName)===false )
			&& stripos($contact['callerid'],$strName)===false
		)
		{
			continue;
		}
		$ix ++;
		$tot ++;
		if ($ix<$offset)
		{
			$before_cnt ++;
			continue;
		}
		if ($ix>=$offset+$pagesize) continue;
		// add it
		$filtered[] = $contact;
	}

	$filter_cnt = count($filtered);

	if (isset($search['wantTotal']))
	{
		if ($subadmin==false)
		{
			$tot += $dbintf->GetCallerIDSearchCount(false,$search);
		}
		$data .= '"totalRecords": ' . $tot;
		$data .= ', ';
	}
	$data .= '"startIndex": ' . $offset;

	$callerid_list = array();
	if ($subadmin==false && ($pagesize > $filter_cnt))
	{
		// first param = also-deleted?
		$startcid = $offset - $before_cnt - $filter_cnt;
		if ($startcid<0) $startcid = 0;
  	$callerid_list = $dbintf->GetCallerIDPartialList(false,$startcid,$pagesize-$filter_cnt,$search);
	}

	$data .= ', "data":[';
  $first = true;
  foreach ($filtered as $row)
  {
    if ($first==false) $data .= ',';
    $t = $row['callerid'];
		if ($row['name']!='') $t .= ' [' . $row['name'] . ']';
		$jsonobj = new stdClass();
		$jsonobj->ctid = $row['contactid'];
    $jsonobj->cname = $row['name'];
    $jsonobj->t = $t;
    $jsonobj->linenr = $row['linenr'];
    $jsonobj->callerid = $row['callerid'];
    $jsonobj->callerid2 = $row['callerid2'];
    $jsonobj->islocal = $row['islocal'];
    $jsonobj->ctype = 0;
		$data .= json_encode( $jsonobj ) . "\r\n";
    $first = false;
  }
	foreach ($callerid_list as $row)
	{
    if ($first==false) $data .= ',';
    $t = $row['callerid'];
		if ($row['name']!='') $t .= ' [' . $row['name'] . ']';
		$jsonobj = new stdClass();
		$jsonobj->id = $row['id'];
    $jsonobj->callerid = $row['callerid'];
    $jsonobj->callerid2 = $row['callerid2'];
    $jsonobj->ctid = $row['contactid'];
    $jsonobj->cname = $row['name'];
    $jsonobj->t = $t;
    $jsonobj->islocal = $row['islocal'];
    $jsonobj->ctype = 0;
		$data .= json_encode( $jsonobj ) . "\r\n";
  	$first = false;
	}
	$data .= ']';


  $data .= '}';
  $dbintf->close();

	echo $data;
}

function GetLines()
{
	global $dbintf, $lng;
	header('Content-Type: application/json');

	$q = str_ensure_defined( $_POST['q'] );

	$search = array();
	$search['name'] = $q;
	$offset = 0;
	$pagesize = 10;

  if (($dbintf->actuinfo['permissions']
	&(PM_CONFIG|PM_SUBADMIN|PM_USERS|PM_VIEWPHONEBOOK|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

	$subadmin = false;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0
	&& ($dbintf->actuinfo['permissions']&PM_SUBADMIN)!=0
	)
	{
		$subadmin = true;
	}

	$data = '{';
	$strName = str_ensure_defined($search['name']);

  if ($subadmin)
  {
		$phonelist = $dbintf->GetUserPhones( $dbintf->actuinfo['accid'] );
		$unfilteredload = array();
		foreach ($phonelist as $phone)
		{
			$ctdat = $dbintf->GetContactInfo($phone);
			// only lines
			if ($ctdat['ctype']!=1) continue;
			$ctdat['contactid'] = $ctdat['id'];
			$unfilteredload[] = $ctdat;
		}
	} else
	{
		// get all lines
	  $unfilteredload = $dbintf->GetLineList();
	  foreach ($unfilteredload as $key=>&$ref_ct)
	  {
			$ref_ct['islocal'] = 1;
			$ref_ct['ctype'] = 1;
		}
	}
  $filtered = array();
	// - filter for search
	// - filter deleted
	// - filter for offset and pagesize
	$ix = -1;
	$tot = 0;
	$before_cnt = 0;
  foreach ($unfilteredload as $key=>$contact)
  {
		if ($contact['deleted']) continue;
		// $strName is the input of the user (q=)
		// it can be it is absent, and maybe we want a full list
		if ($strName=='') ; // empty search, everything matches
		// the user might fill in the line number directly
		// we sort on line number to avoid issues
		else if ($contact['ctype']==1 && stripos('' . $contact['linenr'],$strName)!==false); // partial match
		// since the name might contain the serial number, which contains numbers,
		// we only do an exact match
		else if ($contact['name'] == $strName); // exact match
		// and in partial match only if the search term not numeric
		// so we can at least search for line numbers alone if we want to
		// otherwise it might be crowded out
		else if (is_numeric($strName)==false && stripos($contact['name'],$strName)!==false); // partial match
		else continue;
		$ix ++;
		$tot ++;
		if ($ix<$offset)
		{
			$before_cnt ++;
			continue;
		}
		if ($ix>=$offset+$pagesize) continue;
		// add it
		$filtered[] = $contact;
	}

	$filter_cnt = count($filtered);

	$data .= '"startIndex": ' . $offset;

	$data .= ', "data":[';
  $first = true;
  foreach ($filtered as $row)
  {
    if ($first==false) $data .= ',';
    if ($row['ctype']==1)
    {
    	$t = $lng->Get('Cols.linenr') . ' ' . $row['linenr'];
    } else
    {

    	$t = $row['callerid'];
		}
		if ($row['name']!='') $t .= ' [' . $row['name'] . ']';
		$jsonobj = new stdClass();
		$jsonobj->ctid = $row['contactid'];
    $jsonobj->cname = $row['name'];
    $jsonobj->t = $t;
    $jsonobj->linenr = $row['linenr'];
    $jsonobj->callerid = $row['callerid'];
    $jsonobj->callerid2 = $row['callerid2'];
    $jsonobj->islocal = $row['islocal'];
    $jsonobj->ctype = $row['ctype'];
		$data .= json_encode( $jsonobj ) . "\r\n";
    $first = false;
  }
	$data .= ']';

  $data .= '}';
  $dbintf->close();

	echo $data;
}

?>