<?php
require_once('general.php');
require_once('smbgen.php');

$configs = array_merge( $configs, $dbintf->LoadConfigsPart('b') );
$configs = array_merge( $configs, $dbintf->LoadConfigsPart('n') );

/*
	Parameters (POST)
	svr=Server name or IP
	usr=username
	pwd=if not set, will load from settings
	
*/

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $configs;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $domain = '';
	if (isset($_POST['domain']))
	{
		$domain = $_POST['domain'];
	}
	$svr = $_POST['svr'];
  $usr = $_POST['usr'];
  $pwd = '';
  if (isset($configs['WinPwd']))
  {
    $pwd = decrypt($configs['WinPwd']);
  }
	if (isset($_POST['cfgpwd']))
	{
    $pwd = decrypt($dbintf->GetConfigValue($_POST['cfgpwd']));
	}
  if (isset($_POST['pwd']))
  {
    $pwd = $_POST['pwd'];
  }

  if (COM_TYPE=='Win')
  {
    //sleep(2);
		// '.$pwd.'
    echo '{"data":[{"name":"DataA","descr":"User data"}'
    . ',{"name":"DataB","descr":"Backup share"}'
    . ',{"name":"DataC","descr":"Printer share"}]}';
    exit;
  }

  $subnetmask = $configs['IPmask'];
  $svrip = NmbLookupIPAddr($svr,$subnetmask);
  if ($svrip!==false)
  {
    $svr = $svrip;
  }

  $ret = '{"data":[';
	/* -L list: what services are avail. 
	   -g grepable: easier parsable
	*/
	$cmdline = "smbclient ".GetSmbVersioningParam()." -L ".escapeshellarg($svr)." -g -U ".escapeshellarg("$usr%$pwd");
	if ($domain!='')
	{
		$cmdline .= " -W " . escapeshellarg($domain);
	}
  $smbret = shell_exec($cmdline);
  $smblines = explode("\n",str_ensure_defined($smbret));
  $errtext = '';
  $first = true;
  $cnt = 0;
  foreach ($smblines as $line)
  {
		$cnt ++;
    $parts = explode('|',$line);
    if (count($parts)==3 && $parts[0]=='Disk')
    {
      $name = $parts[1];
      $descr = $parts[2];
      if ($first==false) $ret .= ',';
      $obj = array ('name'=>$name,'descr'=>$descr);
      $ret .= json_encode($obj);
      $first = false;
    } else
    {
			if ($cnt==1 && strpos($line,'failed')!=0)
			{
				$errtext = $line;
			}
		}
  }
  $ret .= ']';
  $ret .= ',"errtext":"'.$errtext.'"';

  $ret .= '}';
  echo $ret;
}

?>
