<?php

require_once('general.php');
require_once('ldapfunc.php');
require_once('webclient_settings.php');

HandleGroup($dbintf);

function HandleGroup($dbintf)
{
  global $rpl,$rooturl,$msg,$configs_s,$configs;

  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN|PM_T3_ADMIN|PM_USERS))==0)
  {
    echo 'Permission denied';
    exit;
  }
  $act = $_POST['act'];
  if (isset($_GET['show_members'])) $show_members = $_GET['show_members'];
  
	$tenant_cfg_keys = array('RecMinDur'
	,'HdDaysKeep' ,'MaxDiskUsage','AlarmDiskUsage' ,'RecBckDaysKeep'
  ,'ScreenRecDaysKeep','ScreenRecBckDays','TraDaysKeep','KeepUnexported'
  , 'StoreOnDmdDef','CheckInactivity','iaWeekdays','iaStart1','iaStop1','iaStart2','iaStop2','iaMaxCallLength','iaPeriodSystem'
	,'RecOnDmdAvail','SilOnDemandAvail', 'MaxChannels', 'srWeekdays'
  , 'srSundayStart1', 'srSundayStop1', 'srSundayStart2', 'srSundayStop2'
  , 'srMondayStart1', 'srMondayStop1', 'srMondayStart2', 'srMondayStop2'
  , 'srTuesdayStart1', 'srTuesdayStop1', 'srTuesdayStart2', 'srTuesdayStop2'
  , 'srWednesdayStart1', 'srWednesdayStop1', 'srWednesdayStart2', 'srWednesdayStop2'
  , 'srThursdayStart1', 'srThursdayStop1', 'srThursdayStart2', 'srThursdayStop2'
  , 'srFridayStart1', 'srFridayStop1', 'srFridayStart2', 'srFridayStop2'
  , 'srSaturdayStart1', 'srSaturdayStop1', 'srSaturdayStart2', 'srSaturdayStop2'
	, 'filterType', 'filterNumbers'
  , 'Data1','Data2','Data3', 'AssignmentValue'
  );
	
	$tenant_origin = int_ensure_defined($_GET['tenant'])!=0;
	$OneGroupPerUser = 0;
	if(isset($configs_s['OneGroupPerUser'])) $OneGroupPerUser = $configs_s['OneGroupPerUser'];
	if($OneGroupPerUser)
	{
		$UsersWithoutGroup = $dbintf->GetAccIdsOfUsersWithoutGroup();
	}
	
  if ($act!='')
  {
    if ($act=='edit-group')
    {
      $isok = true;
      $dbintf->StartTransaction();
      $groupid = (int) $_POST['id'];
      $grpdata['name'] = $_POST['name'];
			if (isset($_POST['is_tenant']))
			{
				$grpdata['is_tenant'] = (int) $_POST['is_tenant'];
			}
      $grpdata['super'] = $_POST['super'];
      $grpdata['typegrp'] = 0;
			$grpdata['adgroup'] = $_POST['adgroup'];
			$grpdata['ldaphost'] = $_POST['ldaphost'];
			$grpdata['samwingroup'] = $_POST['samwingroup'];
      $grpdata['idp'] = $_POST['idp'];
      // next line needed, because of reference
      if ($grpdata['idp']==0) $grpdata['idp'] = null;
      $grpdata['cologons'] = $_POST['cologons'];
      $grpdata['azureapp'] = (int) $_POST['azureapp'];
      $grpdata['azuregroupid'] = $_POST['azuregroupid'];
      $grpdata['azuregroupname'] = $_POST['azuregroupname'];
      if ($grpdata['azureapp']==0)
      {
        $grpdata['azureapp'] = null;
        $grpdata['azuregroupid'] = null;
        $grpdata['azuregroupname'] = null;
      }

			$grpdata['scimenabled'] = (int) $_POST['scimenabled'];
			if(isset($_POST['scimtoken']))
			{
				$grpdata['scimtoken'] = DBInterface::CreatePwdHash($_POST['scimtoken']);
			}
      
			$configs2 = $dbintf->LoadConfigsPart('n');
      $oldtenant = -1;
      $toLogAdd = true;
      if ($groupid!=-1)
      {
        $groupinfo = $dbintf->GetGroupInfo($groupid);
				LogAction('Edit user group',array('id'=>$groupinfo['id'],'name'=>$groupinfo['name'],'tenantid'=>$groupinfo['tenantid'] ) );
        $subgroups = array();
        if ($grpdata['super']!=0)
        {
          if ($grpdata['super']==$groupinfo['accid'])
          {
            $msg[] = new Msg(MSG_ERR,'Higher level group cannot be itself.');
            $isok = false;
          }
          $dbintf->FindSubGroups($subgroups,$groupinfo['accid']);
          if (in_array($grpdata['super'],$subgroups))
          {
            $msg[] = new Msg(MSG_ERR,'Higher level group cannot be a subgroup.');
            $isok = false;
          }
        }
        if ($isok)
        {
          if(isset($groupinfo['tenantid']))
          {
            $oldtenant = $groupinfo['tenantid'];
          }
          $isok = $dbintf->EditGroup($groupid,$grpdata);
          if ($isok==false)
          {
            $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
          }
        }
        if ($isok && int_ensure_defined($_POST['RemoveLdapUsers'])==1)
        {
          $members = $dbintf->GetGroupMembers($groupinfo['accid']);
          foreach ($members as $member)
          {
            if ($dbintf->IsUserCreatedByAD($member))
            {
              $dbgroups = $dbintf->GetGroupsOfWhichMember($member);
              if (  count($dbgroups)==0
               ||  (count($dbgroups)==1 && $dbgroups[0]==$groupinfo['accid']) )
              {
                lg("Removing LDAP user from group after unlinking, accid: ".$member);
                $deluserinfo = $dbintf->GetUserInfoOnAccId($member);
                $dbintf->DeleteUserAccount($deluserinfo['id']);
              }
            }
          }
          // force recalc
          $dbintf->userphones = array();
        }        
      } else {
        // groupid is filled in by function
        $isok = $dbintf->AddGroup($groupid,$grpdata);
        if ($isok==false)
        {
          $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
        } else 
        {
          $ginfo = $dbintf->GetGroupInfo($groupid);
          LogAction('Add group',array('id'=>$ginfo['id'],'name'=>$ginfo['name'],'tenantid'=>$ginfo['tenantid']) );
        }
      }
      if ($isok)
      {
        $supert = 0; $subt = 0;
        if ($dbintf->TenantInsideTenant($supert,$subt))
        {
          $superg = $dbintf->GetGroupInfo($supert);
          $subg = $dbintf->GetGroupInfo($subt);
          $msg[] = new Msg(MSG_ERR,"A tenant (" . $subg['name'] . ") cannot be a subgroup of another tenant (".$superg['name'].').');
          $isok = false;
        }
      }
      if ($isok)
      {
        $dbintf->CommitTransaction();
      } else
      {
        $dbintf->CancelTransaction();
      }
      
      if ($isok)
      {
        // next block can happen during edit
        // when tenancy is disabled for a group
        if (isset($groupinfo)
        && isset($groupinfo['is_tenant']) && $groupinfo['is_tenant']==1
        && isset($grpdata['is_tenant']) && $grpdata['is_tenant']==0)
        {
          lg('Disabling tenancy for group '.$grpdata['name']); 
          // unassign any calls of this tenant
          // also those who are active
          $dbintf->UnassignTenantCalls($groupid);
          // remove settings and stats
          $tn_prefix = 'TN' . $groupid . '_';
          $dbintf->DeleteConfigsWithPrefix($tn_prefix);
          // recalculate user and group tenant membership
          $dbintf->CalcTenantUsers();
          $dbintf->UnassignVTapTenant($groupid);
        }
        $groupinfo = $dbintf->GetGroupInfo($groupid);
        if (isset($_POST['accpm'])) // set permissions
        {
          $accpm_list = explode(';',$_POST['accpm']);
          $accpm = array();
          foreach ($accpm_list as $accpm_item)
          {
            $obj = null;
            if ($accpm_item=='') continue;
            $splitted = explode(',',$accpm_item);
            $obj['callaccid'] = (int) $splitted[0];
            $obj['pm']        = (int) $splitted[1];
            // no longer set admin at group level
            $obj['pm'] &= (~ PM_CONFIG);
            $obj['applytype'] = (int) $splitted[2];
            $accpm[] = $obj;
          }
          $isok = $dbintf->SetAccAccPms($groupinfo['accid'],$accpm);
          if ($isok==false)
          {
            $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
          }
        }
        if (isset($_POST['members'])) //set members
        {
					$dbintf->StartTransaction();
          if ($_POST['members']=='')
          {
            $members = array();
          } else {
            $members = explode(',',$_POST['members']);
          }
					$oldmembers = $dbintf->GetGroupMembers($groupinfo['accid']);
          $dbintf->SetGroupMembers($groupinfo['accid'],$members);
					//Are there any useraccounts made by ldap and not part of any group anymore?
					$delusers = array_diff($oldmembers, $members);
					foreach ($delusers as $deluser)
					{
						if ($dbintf->IsUserCreatedByAD($deluser))
						{
							$dbgroups = $dbintf->GetGroupsOfWhichMember($deluser);
							if (count($dbgroups)==0)
							{
								//The user account was created by LDAP synchronization and is no longer member of any group => delete!
								$user = $dbintf->GetUserInfoOnAccId($deluser);
								$dbintf->DeleteUserAccount($user['id']);
							}
						}
					}
					$dbintf->CommitTransaction();
        }
				if (isset($grpdata['is_tenant']))
				{
					if ($grpdata['is_tenant']==1)
					{
						$configs_tn = $dbintf->LoadConfigsPart('tn');
						$configs_tn_new = array();
						$tn_prefix = 'TN' . $groupid . '_';
						foreach ($tenant_cfg_keys as $param)
						{
							if (isset($_POST[$param]))
							{
								$new_value = $_POST[$param];
								$old_value = '';
								$key = $tn_prefix . $param;
								if (isset($configs_tn[$key]))
								{
									$old_value = $configs_tn[$key];
								}
								if ($old_value !== $new_value)
								{
									$configs_tn_new[$key] = $new_value;
								}
							}
						}
            
						// apply settings
						$dbintf->ApplyTenantSettings( $groupid );
            
            if (count($configs_tn_new)>0)
            {
              $dbintf->SetConfigsPart($configs_tn_new, 'tn');
              $reconfig = true;
            }
          } else
					{
            $tn_prefix = 'TN' . $groupid . '_';
            $dbintf->DeleteConfigsWithPrefix($tn_prefix);
            if ($oldtenant!=-1) $reconfig = true;
          }
				}
        if(isset($_POST['webclientsettings']))
        {
          $webclientsettings = $_POST['webclientsettings'];
          WebClientUpdateSettingsGroup($webclientsettings, $groupinfo['accid']);
        }
        
        
        EnginesSettingsCalcApply(isset($reconfig) ? $reconfig : false);

				// do LDAP import at once, if specified
				// this is done as a bonus, after everything else
				// usually it is also done periodically
				if ($groupinfo['adgroup']!='' && COM_TYPE!='Win')
				{
					lg("LDAP group import at once");
					$dbintf->StartTransaction();
					$ldapImport = new LdapImport();
					$ldapImport->Init();
					$ldapImport->LdapImportGroup($groupinfo['id']);
					$ldapImport->DbFinish();
					$dbintf->CommitTransaction();
					$ldapImport->Finalize();
					lg("LDAP group import at once finished");
				}
        // the same for Azure
				if ($groupinfo['azuregroupid']!='' && $groupinfo['azuregroupid']!=null)
				{
          require_once('azure.php');
					lg("Azure group import at once");
					$dbintf->StartTransaction();
          AzureSyncGroup( $groupinfo );
					$dbintf->CommitTransaction();
					lg("Azure group import at once finished");
				}
				
				
        // use $_SESSION for messaging
        // redirect
       	$_SESSION['msg'] = $msg;
				if (int_ensure_defined($_POST['tenant_origin'])==1)
				{
					header('Location: '.$rooturl.'tenants.php');
				} else
				{
					header('Location: '.$rooturl.'groups.php');
				}
        exit;
      }
    }
  }

  $in_edit = false;
	$tn_configs = array();
  if (isset($_GET['id']))
  {
    $in_edit = true;
    $groupid = (int) $_GET['id'];
    $thegroup = $dbintf->GetGroupInfo($groupid);
    if ($thegroup===false)
    {
      $msg[] = new Msg(MSG_ERR,GetErrDescr('not-found'));
    	$_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'groups.php');
    	exit;
    }
    if ($dbintf->MayEditGroup($groupid)==false)
    {
      $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
    	$_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'groups.php');
    	exit;
		}    
    $accpms = $dbintf->GetAccAccPms(array($thegroup['accid']));
		$tenant_cfg_keys[] = 'DiskUsage';
		$tenant_cfg_keys[] = 'DiskUsageCheckTime';
		$tenant_cfg_keys[] = 'RecCnt';
    $tenant_cfg_keys[] = 'BackupDiskUsage';
    $tenant_cfg_keys[] = 'BackupRecCnt';
		foreach ($tenant_cfg_keys as $key)
		{
			$lookupkey = 'TN'.$groupid.'_'.$key;
			$value = $dbintf->GetConfigValue($lookupkey);
			if ($value!==false)
			{
				if ($key=='DiskUsageCheckTime')
				{
					// convert timestamp to readable
					$value = date($configs['datetimef'],$value);
				}
				$tn_configs[$key] = $value;
			} else
			{
				$tn_configs[$key] = '';
			}
		}
  } else {
    $thegroup['id'] = -1;
    $thegroup['accid'] = -1;
    // set defaults
    $thegroup['permissions'] = 0;
    $thegroup['enabled'] = 1;
    $thegroup['typegrp'] = 0;
    $thegroup['super'] = 0;
    if (isset($_GET['super']))
    {
      $thegroup['super'] = $_GET['super'];
    }
		if ($tenant_origin)
		{
			$thegroup['is_tenant'] = 1;
		}
  }

  $acc_list = $dbintf->GetAccessorsList(); // full list
  $member_list = $dbintf->GetSortedGroupMembers($thegroup['accid']);
  //var_dump($member_list);
	$config_n = $dbintf->LoadConfigsPart('n');

  if ($thegroup['id']!=-1) LogAction("View user group",array('level'=>'view','id'=>$thegroup['id'],'name'=>$thegroup['name'],'tenantid'=>$thegroup['tenantid']));
  
  $idps = $dbintf->GetExtIdps();
  $idpList = array();
  foreach ($idps as $idp)
  {
    $idpList[] = array
    ( 'id' => $idp['id']
    , 'name' => $idp['name']
    );
  }
  
  $AzureApps = $dbintf->GetAzureApps();
  $azureAppList = array();
  foreach ($AzureApps as $app)
  {
    $azureAppList[] = array
    ( 'id' => $app['id']
    , 'name' => $app['name']
    );
  }
  
  $webclientsettings_dialog = WebClientSettingsGroup($thegroup['accid']);

	$enableScim = int_ensure_defined($configs['EnableSCIM']);
	if($enableScim && int_ensure_defined($thegroup['scimenabled']) == -1)
	{
		$enableScim = 0;
	}
  
	// ready with database
  $dbintf->close();

	$data = 'var thegroup = '
  // this would create issues: . json_encode($thegroup,JSON_FORCE_OBJECT) . ";\r\n";
  .'{id:'.(int)$thegroup['id']
  . ',accid:'.(int)$thegroup['accid']
  . ',name:"'.JsQuote(str_ensure_defined($thegroup['name'])).'"'
  . ',typegrp:'.(int)$thegroup['typegrp']
  . ',superacc:'.(int)$thegroup['super']
	. ',adgroup:"'.JSQuote(str_ensure_defined($thegroup['adgroup'])).'"'
	. ',samwingroup:"'.JSQuote(str_ensure_defined($thegroup['samwingroup'])).'"'
  . ',is_tenant:'.int_ensure_defined($thegroup['is_tenant'])
	. ',ldaphost:"'.JSQuote(str_ensure_defined($thegroup['ldaphost'])).'"'
  . ',idp:'.int_ensure_defined($thegroup['idp'])
  . ',cologons:'.int_ensure_defined($thegroup['cologons'])
  . ',azureapp:'.json_encode(str_ensure_defined($thegroup['azureapp']))
  . ',azuregroupid:'.json_encode(int_ensure_defined($thegroup['azuregroupid']))
  . ',azuregroupname:'.json_encode(str_ensure_defined($thegroup['azuregroupname']))
	. ',scimenabled:'.int_ensure_defined($thegroup['scimenabled'])
	. ',has_scimtoken:'. (!empty($thegroup['scimtoken']) ? "1":"0")
  . "};\r\n";
	$data .= "var tn_configs = ";
	$data .= json_encode($tn_configs,JSON_FORCE_OBJECT);
	$data .= ";\r\n";
	$accid_ordering = array();
	foreach ($acc_list as $acc)
	{
		$accid_ordering[] = (int) $acc['accid'];
	}
	$data .= "var accid_ordering = ".json_encode($accid_ordering).";\r\n";
  $data .= "var accs=[];\r\n";
  foreach ($acc_list as $acc)
  {
		$obj = array();
		$obj['name'] = $acc['name'];
		$obj['type'] = $acc['type'];
		if (isset($acc['usr']))
		{
			$obj['usr'] = $acc['usr'];
		}
		if(!$OneGroupPerUser || in_array($acc['accid'], $UsersWithoutGroup) || in_array($acc['accid'], $member_list)) $obj['canbeadded'] = 1;
		else $obj['canbeadded'] = 0;
		
		$data .= "accs[" . $acc['accid'] . "]= " .
				'{name:"' . JSQuote($acc['name']) . '"' .
				",type:" . $acc['type'] .
				",canbeadded:" . $obj['canbeadded'] .
				',usr:"' . JSQuote(str_ensure_defined($acc['usr'])) . '"' .
				"};\r\n";
  }

	$data .= "var ldaphosts=[];\r\n";
	foreach($config_n as $param=>$value)
	{
		if(strpos($param,'LdapHost') !== false)
		{
			$data .= "ldaphosts[\"".$param."\"] = \"".JSQuote(str_ensure_defined($value))."\";\r\n";
		}
	}
  
  
  $data .= 'var azureApps = ' . json_encode( $azureAppList ) . ";\r\n";
  $data .= 'var idpList = ' . json_encode( $idpList ) . ";\r\n";
  
	$data .= "var SamwinInt=".int_ensure_defined($configs_s['SamwinInt']).";\r\n";
	$data .= "var EnableSCIM=".$enableScim.";\r\n";
	
  if ($in_edit)
  {
    $data .= 'var accpms=[';
    $first = true;
    foreach ($accpms as $row)
    {
      if ($first==false) $data .= ',';
      $data .= '{id:'.$row['id']
      . ',accid:'.$row['accid']
      . ',callaccid:'.$row['callaccid']
      . ',pm:'.$row['epermissions']
      . ',applytype:'.$row['applytype']
      . "}\r\n";
      $first = false;
    }
    $data .= "];\r\n";
    $data .= 'var members=[';
    $first = true;
    foreach ($member_list as $accid)
    {
			if ($accid===null) continue;
      if ($first==false) $data .= ',';
      $data .= '{accid:'.$accid. "}\r\n";
      $first = false;
    }
    $data .= "];\r\n";
  } else {
    $data .= "var accpms=[];\r\n";
    $data .= "var members=[];\r\n";
  }
	
	$data .= 'var selecteditem=-1'.";\r\n";
	$data .= 'var tenant_origin='.int_ensure_defined($_GET['tenant']).";\r\n";
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/group.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['jsusergroup'] = file_get_contents('../apresa/templ/usergroup.js');
  $rpl['fr_dialog_contact'] = file_get_contents('../apresa/templ/fr_dialog_contact.htm');
  $rpl['fr_pm_set'] = file_get_contents('../apresa/templ/fr_pm_set.htm');
  $rpl['webclient_settings_dialog'] = $webclientsettings_dialog;
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

?>
