<?php

require_once('general.php');
require_once('tenancy.php');

HandleGroup($dbintf);

function HandleGroup($dbintf)
{
  global $rpl,$rooturl,$msg,$configs_s,$lng;

	if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN|PM_T3_ADMIN|PM_USERS))==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='del-group')
    {
      $groupid = (int) $_POST['del-id'];
			$groupinfo = $dbintf->GetGroupInfo($groupid);
			if ($groupinfo === false)
			{
				// group does not exist
				$msg[] = new Msg(MSG_ERR,'Group does not exist');
			} else
			{
        LogAction('Delete user group', array('id'=>$groupinfo['id'],'name'=>$groupinfo['name'],'tenantid'=>$groupinfo['tenantid']) );
				if ($groupinfo['is_tenant']!=0)
				{
					if ( ($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN|PM_T3_ADMIN)) == 0)
					{
						echo 'Permission denied';
						exit;
					}
					if ($_POST['del-tenant-data']!='1')
					{
						exit;
					}
          $DelFromBackup = ($_POST['del-from-backup']=='1')?1:0;
          LogAction( 'Delete all tenant data', array('name'=>$groupinfo['name'],'backup'=>($DelFromBackup?'Y':'N')) );
          msg_signal_service($msg,'TnDelete '.$DelFromBackup.' '.$groupinfo['id']);
          sleep(1);
				} else
				{
          // Supergroup might be tenant
          // So phone lists may have to be updated.
          $groupinfo = $dbintf->GetGroupInfo($groupid);
          $tenantid = -1;
          if(isset($groupinfo['tenantid']))
          {
            $tenantid = $groupinfo['tenantid'];
          }
          DeleteGroup($dbintf,$groupid);
          EnginesSettingsCalcApply();
        }
      }
      // redirect
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'groups.php');
      exit;
    }
  }
	else if(str_ensure_defined($_GET['act'])=='export')
  {
    LogAction('Export user group list');
    
    if($_GET['type'] == 'xlsx')
    {
      $file = new XLSXFile();
    }
    else
    {
      $file = new CsvFile();
    }

    $file->Init("groups");
    $row = $file->CreateRow();
		
		$groups = $dbintf->GetGroupList();
		$GroupAccIdToName = array();
		foreach($groups as $grkey => $group)
		{
			$GroupAccIdToName[$group['accid']] = $group['name'];
      
      if(int_ensure_defined($group['is_tenant']) == 1)
      {
        $res = $dbintf->GetAllTenantSettings($group['id']);
        foreach( array('RecMinDur', 'HdDaysKeep', 'MaxDiskUsage', 'RecOnDmdAvail', 'SilOnDemandAvail', 'MaxChannels') as $key)
        {
          $prefix = 'TN' . $group['id'] . '_';
          $groups[$grkey][$key] = str_ensure_defined($res[$prefix . $key]) ;
        }
      }
		}
    
		$row->add('DB-ID');
	  $row->add($lng->Get('Main.Name'));
	  $row->add($lng->Get('PM.ParentGroup'));
    $row->add($lng->Get('LDAP.Group'));
	  $row->add($lng->Get('Web.Tenant'));
    $row->add($lng->Get('Options.RecMinDur'));
    $row->add($lng->Get('Tenancy.DiskUsageMax'));
    $row->add($lng->Get('Options.HdDaysKeep'));
    $row->add($lng->Get('Options.MaxChannels'));
    $row->add($lng->Get('Options.RecOnDemand'));
    $row->add($lng->Get('Options.SilenceOnDemand'));
	  $row->output();
      
		foreach($groups as $group)
		{
      $row = $file->CreateRow();
			$row->add(int_ensure_defined($group['id']));
			$row->add(str_ensure_defined($group['name']));
		  $row->add(str_ensure_defined($GroupAccIdToName[$group['super']]));
      $row->add(str_ensure_defined($group['adgroup']));
		  $row->add(str_ensure_defined($group['is_tenant']));
      $row->add(str_ensure_defined($group['RecMinDur']));
      $row->add(str_ensure_defined($group['MaxDiskUsage']));
      $row->add(str_ensure_defined($group['HdDaysKeep']));
      $row->add(str_ensure_defined($group['MaxChannels']));
      $row->add(str_ensure_defined($group['RecOnDmdAvail']));
      $row->add(str_ensure_defined($group['SilOnDemandAvail']));
			$row->output();
    }
    
    $file->Finish();
		exit;
  }
  
	LogAction('View user groups',array('level'=>'view'));

  $group_list = $dbintf->GetSortedGroupList();

  // ready with database
  $dbintf->close();

  $data = 'var groups = [';
  $first = true;
  foreach ($group_list as $row)
  {
    if ($first==false) $data .= ',';
    $data .= '{id:' . $row['id']
    . ',name:"' . JSQuote($row['name']) . '"'
    . ',accid:' . $row['accid']
    . ',superacc:' . $row['super']
		. ',is_tenant:' . (int) $row['is_tenant']
    . "}\r\n";
    $first = false;
  }
  $data .= "]\r\n";

  $data .= GeneralJSData();


  $template_content = file_get_contents('../apresa/templ/groups.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function CsvCell($t)
{
  return '"'.str_replace('"','""',$t).'"';
}

?>
