<?php

require_once('general.php');
require_once 'smbgen.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	$cfgkeys = array('BckTargetType','BckPath','BckDisk','WinDomain','WinUsr','WinPwd','BckServer','BckShare','BckSubdir');
  $cfgPrefix = 'Arana';
  
  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='clear')
    {
      LogAction("Clear Arana import configuration");
      $dbintf->DeleteConfigsWithPrefix('Arana');
    }
    if ($act=='stop')
    {
      LogAction("Stop Arana import");
      $newConfigs = array( $cfgPrefix . 'Stop' => '1' );
      $dbintf->SetConfigsPart($newConfigs,'io');
    }
    if ($act=='start')
    {
      LogAction("Start Arana import");
      $newConfigs = array();
      foreach ($cfgkeys as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $newConfigs[$cfgPrefix . $cfgkey] = $_POST[$cfgkey];
          if ($cfgkey=='WinPwd')
          {
            $newConfigs[$cfgPrefix . $cfgkey] = encrypt($newConfigs[$cfgPrefix . $cfgkey]);
          }
        }
      }
      
      if ( isset($newConfigs[$cfgPrefix.'BckDisk']) && CheckBckDisk( $newConfigs[$cfgPrefix.'BckDisk'] )==false)
      {
        $msg[] = new Msg(MSG_ERR,'Invalid disk');
        $_SESSION['msg'] = $msg;
        header('Location: '.$rooturl.'importarana.php');
        exit;
      }
      
      if ($newConfigs[$cfgPrefix.'BckServer'])
      {
          $ret_lookup = NmbLookupIPAddr($newConfigs[$cfgPrefix.'BckServer'],null);
          if ($ret_lookup===false)
          {
            $newConfigs[$cfgPrefix.'BckServerIP'] = $newConfigs[$cfgPrefix.'BckServer'];
          } else
          {
            $newConfigs[$cfgPrefix.'BckServerIP'] = $ret_lookup;
          }
      }

      $newConfigs[$cfgPrefix . 'Importing'] = '1';
      $newConfigs[$cfgPrefix . 'Stop']      = '0';
      $newConfigs[$cfgPrefix . 'Progress']  = '';
      
      $dbintf->SetConfigsPart($newConfigs,'io');
      $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));
      msg_signal_service($msg,'aranaimport start');
    }

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'importarana.php');
    exit;
  }

  $configsIO = $dbintf->LoadConfigsPart('io');
  $cfgkeys[] = 'Importing';
  $cfgkeys[] = 'Progress';
  $currentCfg = array();
  foreach ($cfgkeys as $cfgkey)
  {
    if (isset($configsIO[$cfgPrefix . $cfgkey]))
    {
      $currentCfg[$cfgkey] = $configsIO[$cfgPrefix . $cfgkey];
      if ($cfgkey=='WinPwd')
      {
        $currentCfg['Has' . $cfgkey] = (strlen( decrypt($currentCfg[$cfgkey]) )>0)?1:0;
        unset( $currentCfg[$cfgkey] );
      }
    } else
    {
      $currentCfg[$cfgkey] = '';
    }
  }
  
  LogAction("View Arana import settings",array('level'=>'view'));
  
  // ready with database
  $dbintf->close();

  // find local disks
  $disks = FindDisks();
  
  $data = GeneralJSData();

  $data .= 'var Disks = ' . json_encode($disks) . ";\r\n";
  $data .= 'var currentCfg = ' . json_encode($currentCfg) . ";\r\n";
  
  $template_content = file_get_contents('../apresa/templ/importarana.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
