<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }
  $act = $_POST['act'];
  if ($act!='')
  {
		$datafields = array( 'description' , 'ip'
			, 'enabled' , 'username', 'password', 'interval', 'restart', 'importfromdate', 'inactivitycheck'
			, 'rectype' , 'directory', 'delay'
			);
		$transfer = array();
		if ($act=='add' || $act=='edit')
		{
			foreach ($datafields as $key)
			{
				if (isset($_POST[$key]))
				{
					if($key == 'password')
						$transfer[$key] = encrypt($_POST[$key]);
					else
						$transfer[$key] = $_POST[$key];
					if ($key=='delay')
					{
						$transfer[$key] = (int) $transfer[$key];
					}
				}
			}
		}
		if ($act=='add')
		{
      LogAction("Add other recorder to import from");
			if ($dbintf->AddImportTarget($transfer)==false)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			}
		}
		if ($act=='edit')
		{
      LogAction("Edit other recorder to import from");
			$id = (int) $_POST['id'];
			if (int_ensure_defined($_POST['restart'])==1)
			{
				$transfer['lasttry'] = NULL;
				$transfer['status'] = NULL;
			}
			// do not allow changing the type
			unset($transfer['rectype']);
			if ($dbintf->EditImportTarget($id,$transfer)==false)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			}

			$transfer = $dbintf->GetImportTarget($id);
			if ($transfer['rectype']=='3CX')
			{
				$recid = '3CX_' . $id;
				$dbintf->RenameRecorder($recid,$transfer['description']);
			}
			if ($transfer['rectype']=='Wildix')
			{
				$recid = 'Wildix_' . $id;
				$dbintf->RenameRecorder($recid,$transfer['description']);
			}
		}
		
		if ($act=='del')
		{
      LogAction("Delete other recorder to import from");
			$ids = explode(',',$_POST['del-ids']);
      foreach ($ids as $id)
      {
        if ($dbintf->DelImportTarget($id)==false)
        {
          $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
        }
      }
		}

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'importrecs.php');
    exit;
  }

	$data = '';
	
	$pubkey = @file_get_contents(DATA_PATH . '/connector.pub');
	
	$data .= 'var pubkey = "' . JsQuote($pubkey) . '";' . "\n";
	
	$transferlist = $dbintf->GetImportTargets();
	$data .= 'var transferlist = [';
	$first = true;
	foreach ($transferlist as $transfer)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ id: "' . $transfer['id'] . '"';
		$data .= ', description: "' . JsQuote($transfer['description']) . '"';
		$data .= ', errmsg: "' . JsQuote($transfer['errmsg']) . '"';
		$data .= ', enabled: "' . (int)$transfer['enabled'] . '"';
		$data .= ', ip: "' . JsQuote($transfer['ip']) . '"';
		$data .= ', username: "' . JsQuote($transfer['username']) . '"';
		if(strlen($transfer['password'])>0) $data .= ', password: "1"'; else $data .= ', password: "0"';
		$data .= ', interval: "' . JsQuote($transfer['interval']) . '"';
		$data .= ', restart: "' . (int)$transfer['restart'] . '"';
		$data .= ', lasttry: "' . (int)$transfer['lasttry'] . '"';
		$data .= ', status: "' . JsQuote($transfer['status']) . '"';
		$data .= ', bckfrom: "' . JSQuote($transfer['importfromdate']) . '"';
		$data .= ', inactivitycheck: "' . (int)$transfer['inactivitycheck'] . '"';
		$data .= ', rectype: "' . JSQuote($transfer['rectype']) . '"';
		$data .= ', directory: "' . JSQuote($transfer['directory']) . '"';
		$data .= ', delay: ' . (int)$transfer['delay'];
		$data .= "}\n";
	}
	$data .= "];\n";

  LogAction("List other recorders to import from",array('level'=>'view'));

  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/importrecs.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}
?>
