<?php

require_once('general.php');
require_once 'datafile.php';
require_once 'actions.php';
require_once 'utility.php';
require_once 'listinggen.php';
require_once 'cedb.php';

HandleMain($dbintf);

function HandleMain($dbintf)
{
  global $rpl,$configs,$configs_s,$actuinfo,$msg,$lng,$rooturl,$CallerColumn;
	
	if(DetermineWebclientOnly())
	{
		echo 'Permission denied';
		exit;
	}
	
	$ceFeatures=false;
	$projects=array();
	$data='';
	
	if ((CheckCePm(PM_CE_MANAGE)==true || CheckCePm(PM_CE_EVALUATE)==true || CheckCePm(PM_CE_SUPERVISOR)==true || CheckCePm(PM_CE_SELFEVALUATE)==true) && int_ensure_defined($configs_s['calleval'])!=0){
		$ceFeatures=true;
		
		$cedb = new CEDB($dbintf);
		
		$act = str_ensure_defined($_POST['act']);
		if ($act=='addCallToPrj')
		{
			$call_id = $_POST['recid'];
			$project_id = $_POST['prjid'];
			
			$mygroups=$cedb->getMyGroups($actuinfo["accid"]);		
			$subgroups=array();
			$subgroups=array_merge($subgroups, $mygroups);
			foreach($mygroups as $group){
				$subgroups=array_merge($subgroups, $cedb->getSubGroups($group));
			}
			
			$agents=array();
			if(CheckCePm(PM_CE_MANAGE)){
				$agents=$cedb->getAllUsers();
			}else if(CheckCePm(PM_CE_SUPERVISOR)){
				$agents=$cedb->getUsersFromGroups($subgroups);
			}
			
			if(CheckCePm(PM_CE_SELFEVALUATE)){
				array_push($agents, $actuinfo["accid"]);
			}
			
			$callinfo = $dbintf->GetCallInfo($call_id);
			$users = $dbintf->GetUsersOfCall($callinfo,false);
			
			if(CheckCePm(PM_CE_SELFEVALUATE) && !in_array($actuinfo['accid'], $agents) && !CheckCePm(PM_CE_SUPERVISOR) && !CheckCePm(PM_CE_MANAGE)){
				$msg[] = new Msg(MSG_ERR,'You are only allowed to add your own calls.');
				$_SESSION['msg'] = $msg;				
				
			}else{
				$continue=true;
				
				$agentFound=-1;
				
				foreach($users as $user){
					if(in_array($user,$agents)){
						$agentFound=$user;
						continue;
						
					}					
				}	
				
				if($agentFound>-1){
					if($cedb->GetEvaluationOnPrjAndCallAndSupervisor($project_id,$call_id,$actuinfo['accid'])==null){
						if($cedb->AddCallsToProject($actuinfo['accid'],(int) $project_id,array(array($call_id,$agentFound)))==null){
							$msg[] = new Msg(MSG_ERR,'Error adding call to project.');
							$continue=false;
						}
					}
					if($continue){
						$evaluation=$cedb->GetEvaluationOnPrjAndCallAndSupervisor($project_id,$call_id,$actuinfo['accid']);
						if($evaluation==null){
							$msg[] = new Msg(MSG_ERR,'Error finding evaluation.');
						}else{				
							$ceid = $evaluation['id'];				
							if($ceid!=0){
								header('Location: '.$rooturl.'ceeval.php?ceid='.$ceid);
								exit();	
							}else{
								$msg[] = new Msg(MSG_ERR,'Error finding evaluation id.');
							}
						}
					}
				}else{
					$msg[] = new Msg(MSG_ERR,'Cannot determine agent. No agent assigned to you matches the call.');
					$_SESSION['msg'] = $msg;
				}
			}
		}
		
		$projects = $cedb->GetProjects();
		$data .= 'var ceContextMenu = true;';
		$data .= 'var projects = [';
		$first = true;
		foreach($projects as $project)
		{
			if ($first) $first = false;
			else $data .= ',';
			$data .= '{ name: "' . JSQuote($project['name']). '"';
			$data .= ' , id: ' . $project['id'];
			$data .= '}' . "\r\n";
		}
		$data .= '];' . "\r\n";
		
	}else{
		$data .= 'var ceContextMenu = false;';
	}

  $handler = new ListingHandler();
  $handler->filterData = true;

  $act = str_ensure_defined($_POST['act']);
  if ($act!='')
  {
		$redirect_url = substr($_SERVER['REQUEST_URI'],1);
		$handler->ListingAct($act, $redirect_url);
    // redirect to same URL (but without POST data)
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.$redirect_url);
    exit;
  }
	
	$AlePlayKeyPresent = file_exists('/dev/shm/apresa/play.ekey')
	|| (isset($_SESSION['PlayKeyId'])
	    && file_exists('/dev/shm/apresa/web/play_'.$_SESSION['PlayKeyId'].'.ekey') );
	
	if (int_ensure_defined($configs['ALEweb'])
	&& $AlePlayKeyPresent==false
	&& $dbintf->GetConfigValue('PlayPkey')!='')
	{
		if (($dbintf->actuinfo['permissions']&PM_CONFIG)!=0)
		{
			$msgtext = '<%Crypt.PlayLocked%>';
			$msgtext .= ' <a href="cryptunlock.php"><%Crypt.PlayUnlock%></a>';
			$msg[] = new Msg(MSG_WRN,$msgtext);
			if (file_exists('/var/apresa/data/rec.ekey')==false)
			{
				$msgtext = '<%Crypt.RecLocked%>';
				$msgtext .= ' <a href="cryptunlock.php?rec"><%Crypt.RecUnlock%></a>';
				$msg[] = new Msg(MSG_WRN,$msgtext);
			}
		} else
		{
			$msgtext = '<%Crypt.PlayLocked%>';
			if (int_ensure_defined($configs['AlePlayUnlockUser'])==1)
			{
				$msgtext .= ' <a href="cryptunlock.php"><%Crypt.PlayUnlock%></a>';
			}
			$msg[] = new Msg(MSG_WRN,$msgtext);
		}
	}

	//debug
	/*
	function tst($a)
	{
		global $configs, $dbintf;
		echo "<pre>";
		if ($a===NULL) echo 'No call';
		else
		{
			echo 'dt: ' . date($configs['datetimef'],$a['startdate']) . "\n";
			$users = $dbintf->GetUsersOfCall( $a , true );
			$t = '';
			foreach ($users as $user)
			{
				$uinf = $dbintf->GetUserInfoOnAccId( $user );
				$t .= ' '.$uinf['name'].'(' . $uinf['usr'] . ')';// . $user ;
			}
			echo 'usrs: ' . $t . "\n";
		}
		echo "</pre>";
	}
	tst( $dbintf->GetLastOwnCall(0) );
	tst( $dbintf->GetLastOwnCall(1) );
	tst( $dbintf->GetLastOwnCall(2) );
	*/
	
	$handler->ParseSearch();
	$handler->PerformSearch();

  $template_content = file_get_contents('../apresa/templ/main.htm');

  $data .= $handler->GetBasicJsData();
  $data .= GeneralJSData();

  $dbintf->close();
	
  // template replacements:
  $handler->SetDefReplacements();
  $rpl['data'] = $data;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>