<?php

require_once('general.php');

HandlePage($dbintf);

function GetSerialNumber()
{
	return file_get_contents('../apresa/conf/serial');
}

function HandlePage($dbintf)
{
  global $rpl,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	$configs = array();

  $act = $_POST['act'];
  if ($act!='')
  {
		if ($act=='delsys')
    {
			LogAction('Delete system license');
      $msg[] = new Msg(MSG_INF,'Restart the recording component to let it take effect, and relogin');
      $dbintf->ClearLicKeys();
			$dbintf->DeleteFromConfigs('calleval');
			$dbintf->DeleteFromConfigs('ServiceEnd');
			$dbintf->DeleteFromConfigs('LicStartDay');
      msg_signal_service($msg,'xlicchk');
		}
    if ($act=='delch')
    {
			LogAction('Delete license channels VoIP');
      $msg[] = new Msg(MSG_INF,'Restart the recording component to let it take effect');
      $configs['ChCnt'] = 0;
      $dbintf->DeleteProductLicKeys('31');
    	$dbintf->SetConfigsPart($configs,'o');
      msg_signal_service($msg,'os');
		}
    if ($act=='delchg729')
    {
			LogAction('Delete license channels G.729');
      $msg[] = new Msg(MSG_INF,'Restart the recording component to let it take effect');
      $configs['G729ChCnt'] = 0;
      $dbintf->DeleteProductLicKeys('33');
    	$dbintf->SetConfigsPart($configs,'o');
      msg_signal_service($msg,'os');
    }
    if ($act=='delchrta')
    {
			LogAction('Delete license channels RTA');
      $msg[] = new Msg(MSG_INF,'Restart the recording component to let it take effect');
      $configs['RtaChCnt'] = 0;
      $dbintf->DeleteProductLicKeys('47');
    	$dbintf->SetConfigsPart($configs,'o');
      msg_signal_service($msg,'os');
    }
    if ($act=='delchdst')
    {
			LogAction('Delete license channels TDM');
      $msg[] = new Msg(MSG_INF,'Restart the recording component to let it take effect');
      $configs['DstChCnt'] = 0;
      $dbintf->DeleteProductLicKeys('35');
    	$dbintf->SetConfigsPart($configs,'crec');
      msg_signal_service($msg,'os');
    }
    if ($act=='delchana')
    {
			LogAction('Delete license channels Analog');
      $msg[] = new Msg(MSG_INF,'Restart the recording component to let it take effect');
      $configs['AnalogChCnt'] = 0;
      $dbintf->DeleteProductLicKeys('39');
    	$dbintf->SetConfigsPart($configs,'crec');
      msg_signal_service($msg,'os');
    }
    if ($act=='delchpri')
    {
			LogAction('Delete license channels ISDN PRI');
      $msg[] = new Msg(MSG_INF,'Restart the recording component to let it take effect');
      $configs['PriChCnt'] = 0;
      $dbintf->DeleteProductLicKeys('43');
    	$dbintf->SetConfigsPart($configs,'crec');
      msg_signal_service($msg,'os');
    }
    if ($act=='delchmob')
    {
			LogAction('Delete external phones licenses');
      $configs['MobileChCnt'] = 0;
      $dbintf->DeleteProductLicKeys('45');
    	$dbintf->SetConfigsPart($configs,'s');
      msg_signal_service($msg,'ss');
    }
    if ($act=='deladdon')
    {
			// NOTE: we should not deleted those with feature '2',
			// because that would cause an endless extension of the update service period.
			$msg[] = new Msg(MSG_INF,'Not implemented.');
			
			//LogAction('Delete license Add-On');
      //$configs['calleval'] = 0;
      //$dbintf->DeleteProductLicKeys('37');
    	//$dbintf->SetConfigsPart($configs,'s');
    }
		msg_signal_service($msg,'xlicchk');

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'licenses.php');
    exit;
  }

	LogAction('View system licenses',array('level'=>'view'));

	$configs = $dbintf->LoadConfigs();
	$serialnum = (int) GetSerialNumber();

	$features = array();
	if (int_ensure_defined($configs['calleval'])!=0)
	{
		$features[] = 'Call Evaluation';
	}

	$syslic = 'None';
	if ($configs['LicTrial']!=0)
	{
		$syslic = 'Trial';
	}
	if ($configs['LicSystem']!=0)
	{
		$syslic = 'Yes';
	}
	
  $data = '';
  $data .= 'var serialnum = "' . $serialnum . '";';
	$data .= 'var syslic = "' . JSQuote($syslic) . '";';
  $data .= 'var chcnt = ' . int_ensure_defined($configs['ChCnt']) . ';';
  $data .= 'var g729chcnt = ' . int_ensure_defined($configs['G729ChCnt']) . ';';
  $data .= 'var rtachcnt = ' . int_ensure_defined($configs['RtaChCnt']) . ';';
  $data .= 'var dstchcnt = ' . int_ensure_defined($configs['DstChCnt']) . ';';
  $data .= 'var anachcnt = ' . int_ensure_defined($configs['AnalogChCnt']) . ';';
  $data .= 'var prichcnt = ' . int_ensure_defined($configs['PriChCnt']) . ';';
  $data .= 'var mobchcnt = ' . int_ensure_defined($configs['MobileChCnt']) . ';';
  $data .= 'var features = "' . implode(', ',$features) . '";';
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/licenses.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
