<?php
require_once 'utility.php';
require_once 'annotate.php';

// to supress warning @ because may not exist
@include 'custom/list_custom.php';

class ListingHandler
{

	var $search_accepted;
	// search key, search direction
	var $sk, $sd;
	// search ing
	var $search;
	var $search_use;
	var $listconfig;
	// result
	var $call_list;
	var $call_count;
	// other data
	var $queries;
  var $recorders;
	// settting
	var $pagesize;
	var $CallerColumn;
  var $needJsData;
	// paging:
	var $pagenow, $frompage, $limitpage;
	var $selcall;
	var $delfromrb;
  var $viewAuditLogText;
  var $filterData;
  var $multiTenancy;
  var $agentMap;
  var $tenantNameMap;

	function __construct()
	{
		$this->Init();
	}

	function Init()
	{
	  // Searching
	  $this->search_accepted = array
	  ( 'r1', 'l1', 'c1', 'r2', 'l2' , 'rn' , 'ln' , 'cn'
    , 'nts', 'ents', 'nts2', 'nts3', 'nts4', 'nts5', 'ann', 'tra'
		, 'dts1', 'dts2', 'dts3', 'dts4', 'dts5'
	  , 'fd' , 'ld' , 'id' , 'ip' , 'nm'
	  , 'eid' , 'eip' , 'enm' , 'dir', 'ft', 'lt', 'own'
	  , 'fdur', 'ldur', 'lnr', 'cat', 'rem', 'rb', 'rec'
    , 'agent', 'tenant' // tenant name
		);
	  $this->selcall = -1;
    $this->viewAuditLogText = 'View call listing';
    $this->filterData = false;
    $this->needJsData = true;
	}


	function ListingAct($act, & $redirect_url_ref)
	{
		global $msg, $dbintf, $actuinfo, $rooturl, $configs, $lng;

      if (function_exists('CustomListing_Act'))
      {
        if (CustomListing_Act()) return;
      }
    
			PerformAnnotationActions();

      if ($act=='edit-async-notes'
      || $act=='edit-async-notes2'
      || $act=='edit-async-notes3'
      || $act=='edit-async-notes4'
      || $act=='edit-async-notes5')
      {
        $retobj = array();
        $retobj['errcode'] = 'undefined';
        $key = substr($act,11);
	      $recording_id = $_POST['edit-id'];
				LogAction('Edit '.$key.' of call', array('call_id'=>$recording_id) );
	      $info = $dbintf->GetCallInfo($recording_id);
        $ok = false;
	      if (($info['permissions']&PM_NOTES)==0)
	      {
          $retobj['errcode'] = 'pm-denied';
	      } else {
	        $ok = $dbintf->SetCallInfo($recording_id,array($key=>$_POST['edit-value']));
          if ($ok) $retobj['errcode'] = 0;
          else $retobj['errcode'] = $dbintf->lasterr;
	      }
        echo json_encode( $retobj );
        exit;
	    }      
      if ($act=='edit-display')
      {
        // this is also async
        $retobj = array();
        $retobj['errcode'] = 'undefined';
	      $colcfg = $_POST['cols'];
        if (int_ensure_defined($configs['EditProfile'])==0)
        {
          $retobj['errcode'] = 'Editing personal settings is disabled';
        } else
        {
          $ok = $dbintf->EditUserAccountLC($dbintf->actuinfo['id'],array('colcfg'=>$colcfg));
          if ($ok) $retobj['errcode'] = 0;
          else $retobj['errcode'] = $dbintf->lasterr;
        }
        echo json_encode( $retobj );
        exit;
      }
      if ($act=='edit-notes'
      || $act=='edit-notes2'
      || $act=='edit-notes3'
      || $act=='edit-notes4'
      || $act=='edit-notes5')
      {
        $key = substr($act,5);
	      $recording_id = $_POST['edit-id'];
				LogAction('Edit '.$key.' of call', array('call_id'=>$recording_id) );
	      $info = $dbintf->GetCallInfo($recording_id);
	      if (($info['permissions']&PM_NOTES)==0)
	      {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
	      } else {
	        $dbintf->SetCallInfo($recording_id,array($key=>$_POST['edit-value']));
	      }
	    }
	    if ($act=='edit-category')
	    {
	      $recording_id = $_POST['edit-id'];
				LogAction('Edit category of call', array('call_id'=>$recording_id) );
	      $info = $dbintf->GetCallInfo($recording_id);
	      if (($info['permissions']&PM_NOTES)==0)
	      {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
	      } else {
	        $dbintf->EditRecordingCategory($recording_id,$_POST['edit-value']);
	      }
	    }
	    if ($act=='edit-ct')
	    {
        LogAction('Edit contact',array('name'=>$_POST['edit-name']) );
	      if ($dbintf->EditContactForCall($_POST['edit-id'],$_POST['call-id'],$_POST['edit-name'])==false)
	      {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
	      }
	    }
      if ($act=='tn-assign-recs')
      {
        if (($actuinfo['permissions']&PM_CONFIG)==0)
        {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
        } else if (int_ensure_defined($configs['TenantReassign'])==0)
        {
	        $msg[] = new Msg(MSG_ERR,'Option is disabled');
        } else
        {
          $recids = $_POST['recids'];
          $recids = explode(',',$recids);
          // sanitize ids
          $recording_ids = array();
          foreach ($recids as $recid)
          {
            $recording_ids[] = (int) $recid;
          }
          $tenantid = (int) $_POST['tenantid'];
          require_once 'tenancy.php';
          LogAction('Reassign recordings');
          $errmsg = ReassignRecs( $recording_ids , $tenantid );
          if ($errmsg!='')
          {
            $msg[] = new Msg(MSG_ERR,$errmsg);
          }
        }
      }
	    if ($act=='del-record')
	    {
	      if (defined('DEMO'))
	      {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('demo-delcall'));
				} else
				{
					$recording_ids = $_POST['del-ids'];
		      $recording_ids = explode(',',$recording_ids);
					$delresults = array();
					if ($this->delfromrb) $recyclebin = false;
					else $recyclebin = int_ensure_defined($dbintf->GetConfigValue('RecycleBin'));
		      foreach ($recording_ids as $recording_id)
		      {
		        $info = $dbintf->GetCallInfo($recording_id);
		        if ($info===false)
		        {
		          $msg[] = new Msg(MSG_ERR,'Record not found');
		        } else if (($info['permissions']&PM_DELETE)==0)
		        {
		          $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
		        } else
		        {
							if ($recyclebin)
							{
								LogAction('Delete call to RecycleBin', array('call_id'=>$recording_id) );
								$dbintf->DeleteRecordingRB($recording_id);
							}
							else
							{
								LogAction('Delete call', array('call_id'=>$recording_id) );
								if ($info['tenantid']!=NULL && $info['isarchived']!=0)
								{
									require_once 'tenancy.php';
									UpdateTnDiskUsage($info['tenantid'], -GetCallStorage($info), -1);
								}
								$filename = $info['filename'];
								$delres = TryDelete(GetRecordingPath($info),$info['filename']);
								$delresults[$delres] = int_ensure_defined($delresults[ $delres ]) + 1;
								if (HasScreenRecording($info))
								{
									$scrdelres = TryDelete(GetRecordingPath($info),GetScreenFileName($info));
									if ($scrdelres!=$delres)
									{
										$delresults[ $scrdelres ] = int_ensure_defined($delresults[ $scrdelres ]) + 1;
									}
								}
								$dbintf->DeleteRecording($recording_id);
							}
		        }
		      }
					foreach($delresults as $ix=>$cnt)
					{
						if ($ix==1)
						{
							$t = 'Failed to delete recording with filename: '.$filename;
						}
						if ($ix==0)
						{
							$t = '<%Web.FileIsDeleted%>';
						}
						if ($ix==2)
						{
							$t = 'File was already gone.';
						}
						if ($cnt>1)
						{
							$t .= ' (' . $cnt . 'x)';
						}
						if ($ix==0) $type = MSG_INF;
						else $type = MSG_ERR;
						$msg[] = new Msg($type,$t);
					} 
		    }
      }
      if ($act=='mass-del-record')
			{
				if (defined('DEMO'))
	      {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('demo-delcall'));
        }
				else if($dbintf->actuinfo['permissions'] & PM_MASS_DELETE)
        { 
          LogAction('Mass delete of calls: ' . $_SERVER['QUERY_STRING']);

          $query_str = str_ensure_defined($_SERVER['QUERY_STRING']);
          if($this->delfromrb)
          {
            if(strlen($query_str) > 0) $query_str .= '&';
            $query_str .= 'rb=1';
          }
          $cmd = "massdel " . $actuinfo['accid'] . ' ' . $query_str;
          if(msg_signal_service($msg, $cmd))
          {
            $msg[] = new Msg(MSG_INF, "Delete operation started");
          }
        }
        else 
        {
          $msg[] = new Msg(MSG_INF, "Permission denied");  
        }
      }
      if($act=='mass-rec-record')
      {
        if($dbintf->actuinfo['permissions'] & PM_MASS_DELETE)
        {
          LogAction('Mass restore of calls: ' . $_SERVER['QUERY_STRING']);
          
          $query_str = str_ensure_defined($_SERVER['QUERY_STRING']);
          $cmd = "massrec " . $actuinfo['accid'] . ' ' . $query_str;
          if(msg_signal_service($msg, $cmd))
          {
            $msg[] = new Msg(MSG_INF, "Restore operation started");
          }
        }
        else 
        {
          $msg[] = new Msg(MSG_INF, "Permission denied");
        }
      }
	    if ($act=='email')
	    {
				if (int_ensure_defined($configs['NoEmailButton'])==1)
				{
	        $msg[] = new Msg(MSG_ERR,'Emailing is disabled');
	      } else if ($actuinfo['email']=='')
	      {
	        $msg[] = new Msg(MSG_ERR,'No email is specified for the user account.');
	      } else
	      {
          // LogAction is done inside EmailRecordings
	        $recording_ids = $_POST['call-ids'];
	        $recording_ids = explode(',',$recording_ids);
	        EmailRecordings($recording_ids,$actuinfo['email']);
	      }
	    }
	    if ($act=='delquery')
	    {
			  if (($dbintf->actuinfo['permissions']&PM_NOTES)==0)
			  {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
	      } else {
          LogAction('Delete query');
	        $dbintf->DelQuery((int) $_POST['queryid']);
	      }
			}
	    if ($act=='addquery')
	    {
			  if (($dbintf->actuinfo['permissions']&PM_NOTES)==0)
			  {
	        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
	      } else {
          LogAction('Add query');
					$qspec = array();
				  foreach ($this->search_accepted as $searchix)
				  {
				    if (str_ensure_defined($_POST[$searchix])!='')
				    {
				      $qspec[$searchix] = $_POST[$searchix];
				    }
				  }
				  $qspec = ArrayToString($qspec);
	        $dbid = $dbintf->AddQuery($_POST['queryname'],$qspec);
	        $redirect_url_ref = substr($_SERVER['PHP_SELF'],1).'?savq=' . $dbid;
	      }
      }
      if($act=='callencrypt')
      {
        if(! ($dbintf->actuinfo['permissions'] & PM_TENANT_ADMIN_ENCRYPT) )
        {
          $msg[] = new MSG(MSG_ERR, GetErrDescr('pm-denied'));
          return;
        }

        $tenantid = $dbintf->actuinfo['tenantid'];
        $group = $dbintf->GetGroupInfo( $tenantid );
        $key = $dbintf->GetCallEncryptionKey($group['accid']);

        if(!$key || $key['inuse'] == 0)
        {
          $msg[] = new MSG(MSG_ERR, $lng->Get("Web.CallEncryptionNotEnabled"));
          return;
        }

        $pubKey = openssl_pkey_get_public(FormatPublicKey($key['pubkey']));

        if($pubKey === false)
        {
          $msg[] = new MSG(MSG_ERR, "Could not load public key: " . openssl_error_string());
          return;
        }
        
        $recids = $_POST['recids'];
        $recording_ids = explode(',',$recids);

        $loggedOldEncrypt = false;
        $loggedScreenRecording = false;

        foreach ($recording_ids as $recording_id)
        {
          $info = $dbintf->GetCallInfo($recording_id);
          if($info['tenantid'] !== $tenantid) continue;
          
          if($info['flags'] & 16)
          { 
            if(!$loggedOldEncrypt)
            {
              $msg[] = new MSG(MSG_ERR, $lng->Get("Web.AlreadyEncrypted"));
              $loggedOldEncrypt = true;
            }

            continue;
          }

          if($info['flags'] & 2048)
          {
            continue;
          }

          $inFile = GetRecordingPath($info) . $info['filename'];
          $outFile = $inFile . '.enc' . uniqid();

          $ret = 0;
          $output = array();

          exec('apresa_crypt -ec -i ' . escapeshellarg($inFile) . ' -o ' . escapeshellarg($outFile), $output, $ret);

          if($ret != 0)
          {
            $msg[] = new MSG(MSG_ERR, "Call encryption failed");
            continue;
          }

          foreach($output as $line)
          {
            if(strpos($line, "Key: ") !== false)
            {
              $callkey = substr($line, 5);
            }
        
            if(strpos($line, "IV: ") !== false)
            {
              $iv = substr($line, 4);
            }
          }

          if(!isset($callkey))
          {
            $msg[] = new MSG(MSG_ERR, "Call encryption failed: no key");
            continue;
          }
        
          if(!isset($iv))
          {
            $msg[] = new MSG(MSG_ERR, "Call encryption failed: no IV");
            continue;
          }

          $callkey = hex2bin($callkey);
          $iv = hex2bin($iv);

          if(openssl_public_encrypt($callkey, $encryptedKey, $pubKey, OPENSSL_PKCS1_OAEP_PADDING) === false)
          {
            $msg[] = new MSG(MSG_ERR, "Could not encrypt the call key: " . openssl_error_string());
            continue;
          }

          unlink($inFile);
          rename($outFile, $inFile);

          $dbintf->SetCallInfo($recording_id, array( "flags" => $info['flags'] | 2048 ));
          $dbintf->AddCallKey(
            [
              "callid" => $recording_id,
              "keyid" => $key['id'],
              "callkey" => base64_encode($encryptedKey),
              "iv" => base64_encode($iv)
            ]
          );
        }
      }
      if($act == "calldecrypt")
      {
        if(! ($dbintf->actuinfo['permissions'] & PM_TENANT_ADMIN_ENCRYPT) )
        {
          $msg[] = new MSG(MSG_ERR, GetErrDescr('pm-denied'));
          return;
        }
        $tenantid = $dbintf->actuinfo['tenantid'];
        $group = $dbintf->GetGroupInfo( $tenantid );
        $records = json_decode($_POST['records'], true);

        foreach($records as $record)
        {
          $info = $dbintf->GetCallInfo($record['id']);
          if(!$info)
          {
            $msg[] = new MSG(MSG_ERR, "Call not found");
          }

          if(!($info['flags'] & 2048))
          {
            continue;
          } 

          $key = $dbintf->GetCallKey($record['id']);
          if(!$key)
          {
            $msg[] = new MSG(MSG_ERR, "Key not found");
            continue;
          }

          if($key['accid'] != $group['accid'])
          {
            $msg[] = new MSG(MSG_ERR, GetErrDescr('pm-denied'));
            continue;
          }

          $callkey = bin2hex(base64_decode($record['key']));
          $calliv = bin2hex(base64_decode($key['iv']));

          $inFile = GetRecordingPath($info) . $info['filename'];
          $outFile = GetRecordingPath($info) . 'dec' . uniqid() . '_' . $info['filename'];

          $cmd = 'apresa_crypt -dc -i ' . escapeshellarg($inFile) . ' -o ' . escapeshellarg($outFile) . ' -key ' . escapeshellarg($callkey) . ' -iv ' . escapeshellarg($calliv);

          $ret = 0;
          $output = array();
        
          exec($cmd, $output, $ret);
        
          if($ret != 0)
          {
            $msg[] = new MSG(MSG_ERR, "Could not perform decryption");
            continue;
          }

          $ret = 0;
          $output = [];
          $cmd = 'soxi -t ' . escapeshellarg($outFile);
          exec($cmd, $output, $ret);

          if($ret != 0)
          {
            $msg[] = new MSG(MSG_ERR, "Could not verify result of decryption");
            unlink($outFile);
            continue;
          }

          unlink($inFile);
          rename($outFile, $inFile);

          $dbintf->SetCallInfo($record['id'], array( "flags" => $info['flags'] & ~2048 ));
          $dbintf->RemoveCallKey($key['id']);
        }
      }
      
  } // end of function
  
  function DoMassDel($search_str)
  {
    global $dbintf, $lng;

    $fp = LockMassDel();

    if(!$fp)
    {
      addToSayUser(MSG_ERR,  $lng->Get('Web.MassDelRunning'), $dbintf->actuinfo['accid']);
      return;
    }

    register_shutdown_function("UnlockMassDel");

    parse_str($search_str, $_GET);
    $this->ParseSearch();
   
    if($_GET['rb'] === '1')
      $recyclebin = false;
    else 
      $recyclebin = int_ensure_defined($dbintf->GetConfigValue('RecycleBin'));

    $results = array_fill(0,4,0);

    $this->listconfig['allrecords'] = true;
    $this->listconfig['callback'] = function ($row, $listconfig) use ($recyclebin, &$results, $dbintf)
    {
      if(!($row['pm'] & PM_DELETE))
      {
        $results[3]++;
        return;
      } 
      if ($recyclebin)
      {
        LogAction('Delete call to RecycleBin', array('call_id'=>$row['id']));
        $dbintf->DeleteRecordingRB($row['id']);
        $results[0]++;
      }
      else
      {
        LogAction('Delete call', array('call_id'=>$row['id']) );
        if ($row['tenantid']!=NULL)
        {
          require_once 'tenancy.php';
          UpdateTnDiskUsage($row['tenantid'], -GetCallStorage($row), -1);
        }
  
        $filename = $row['filename'];
        $delres = TryDelete(GetRecordingPath($row),$row['filename']);
        $results[$delres]++;
        if (HasScreenRecording($row))
        {
          $scrdelres = TryDelete(GetRecordingPath($row),GetScreenFileName($row));
          if($delres != $scrdelres)
          {
            $results[$scrdelres]++;
          }
        }
        $dbintf->DeleteRecording($row['id']);
      }
    };

    $this->PerformSearch();    
    foreach($results as $ix=>$cnt)
    {
      if($cnt == 0)
      {
        if($ix == 0)
        {
          addToSayUser(MSG_INF, $lng->Get('Web.NoFilesDeleted'), $dbintf->actuinfo['accid']);
        }
        continue;
      }

      if ($ix==0)
      {
        if($recyclebin)
        {
          $t = $lng->Get('Web.MovedToRecycleBin');
        }
        else
        {
          $t = $lng->Get('Web.FileIsDeleted');
        }
      }
      if ($ix==1)
      {
        $t = 'Failed to delete recording file';
      }
      if ($ix==2)
      {
        $t = 'File was already gone.';
      }
      if($ix==3)
      {
        $t = GetErrDescr('pm-denied');
      }

      $t .= ' (' . $cnt . 'x)';
      
      if ($ix==0) $type = MSG_INF;
      else $type = MSG_ERR;
      addToSayUser($type, $t, $dbintf->actuinfo['accid']);
    }
  }

  function DoMassRecycle($search_str)
  {
    global $dbintf, $lng;

    $fp = LockMassDel();

    if(!$fp)
    {
      addToSayUser(MSG_ERR,  $lng->Get('Web.MassDelRunning'), $dbintf->actuinfo['accid']);
      return;
    }

    register_shutdown_function("UnlockMassDel");

    parse_str($search_str, $_GET);
    
    $this->ParseSearch();
    $this->search_use['rb'] = 1;
    $this->listconfig['allrecords'] = true;

    $results = array_fill(0,4,0);
    
    $this->listconfig['callback'] = function($row, $listconfig) use (&$results, $dbintf)
    {
      if(!($row['pm'] & PM_DELETE))
      {
        $results[3]++;
        return;
      }

      $dbintf->RecoverRecordingRB($row['id']);
      $results[0]++;
    };
    
    $this->PerformSearch();
    foreach($results as $ix=>$cnt) 
    {
      if($cnt == 0)
      {
        if($ix == 0)
        {
          addToSayUser(MSG_INF, $lng->Get('Web.RestoredNoCalls'),  $dbintf->actuinfo['accid']);
        }
        continue;
      } 

      if($ix==0)
        $t = $lng->Get('Web.RestoredCall');
      if($ix==3)
        $t = GetErrDescr('pm-denied');

      $t .= ' (' . $cnt . 'x)';
      if ($ix==0) $type = MSG_INF;
      else $type = MSG_ERR;
      addToSayUser($type, $t, $dbintf->actuinfo['accid']);
    }
  }

	function ParseSearch()
	{
		global $msg, $dbintf, $actuinfo, $configs;

	  $this->pagesize = 20;
	  if (isset($configs['CallsPerPage']))
	  {
	  	$this->pagesize = (int) $configs['CallsPerPage'];
		}

		$this->CallerColumn = int_ensure_defined($configs['CallerReceiver']);

	  // sorting key and sort direction
	  $this->sk = str_ensure_defined($_GET['sk']);
	  $this->sd = str_ensure_defined($_GET['sd']);

	  $this->search = array();
	  foreach ($this->search_accepted as $searchix)
	  {
	    if (str_ensure_defined($_POST[$searchix])!='')
	    {
	      $this->search[$searchix] = $_POST[$searchix];
	    }
	    // in GET when browsing pages
	    if (str_ensure_defined($_GET[$searchix])!='')
	    {
	      $this->search[$searchix] = $_GET[$searchix];
	    }
	  }

		$this->queries = $dbintf->GetQueries();
		foreach ($this->queries as & $q_ref)
		{
			$q_ref['qspec_arr'] = StringToArray($q_ref['qspec']);
			if ($_GET['savq']==$q_ref['id']
			|| $_POST['savq']==$q_ref['id']
			)
			{
				foreach ($q_ref['qspec_arr'] as $param=>$value)
				{
					if (in_array($param,$this->search_accepted))
					{
						$this->search[$param] = $value;
					}
				}
			}
		}
    
    $this->recorders = $dbintf->GetRecorders();

	  $this->search_use = $this->search;
	  if (isset($this->search['ld']))
	  {
	    $ld = $this->search_use['ld'];
	    // next day
	    $ld = $ld + 60 * 60 * 24;
	    $this->search_use['ld'] = $ld;
	  }
    
    $this->multiTenancy = ($dbintf->GetConfigValue('MultiTenancy')!=0);
    if (isset($this->search['tenant'])
      && $dbintf->AmIAdminT123() )
    {
      $searchName = $this->search_use['tenant'];
      unset( $this->search_use['tenant'] );
      $foundTenant = -1;
      $this->BuildTenantNameMap();
      if (isset($this->tenantNameMap) && $foundTenant==-1)
      {
        foreach ($this->tenantNameMap as $id=>$name)
        {
          // exact match
          if (strtolower($name)==strtolower($searchName))
          {
            $this->search['tenant'] = $name;
            $foundTenant = $id;
            break;
          }
        }
      }
      if (isset($this->tenantNameMap) && $foundTenant==-1)
      {
        foreach ($this->tenantNameMap as $id=>$name)
        {
          // beginning match
          if (strtolower(substr($name,0,strlen($searchName)))==strtolower($searchName))
          {
            // show in GUI full and exact name
            $this->search['tenant'] = $name;
            $foundTenant = $id;
            break;
          }
        }
      }
      $this->search_use['tenantid'] = $foundTenant;
    }
		if (isset($this->search['agent']))
		{
			$searchName = $this->search_use['agent'];
			unset( $this->search_use['agent'] );
      $foundAgent = -1;
      $this->BuildAgentMap();
      if (isset($this->agentMap) && $foundAgent==-1)
      {
        foreach ($this->agentMap as $id=>$name)
        {
          // exact match
          if (strtolower($name)==strtolower($searchName))
          {
            $this->search['agent'] = $name;
            $foundAgent = $id;
            break;
          }
        }
      }
      if (isset($this->agentMap) && $foundAgent==-1)
      {
        foreach ($this->agentMap as $id=>$name)
        {
          // beginning match
          if (strtolower(substr($name,0,strlen($searchName)))==strtolower($searchName))
          {
            // show in GUI full and exact name
            $this->search['agent'] = $name;
            $foundAgent = $id;
            break;
          }
        }
      }
      if (isset($this->agentMap) && $foundAgent==-1)
      {
        foreach ($this->agentMap as $id=>$name)
        {
          // anywhere match
          if ( strpos(strtolower($name),strtolower($searchName)) !== false )
          {
            // show in GUI full and exact name
            $this->search['agent'] = $name;
            $foundAgent = $id;
            break;
          }
        }
      }
			if ($foundAgent==-1)
			{
				// agent not found
	      $msg[] = new Msg(MSG_ERR,'User not found or no access');
			} else
			{
				$this->search_use['agent'] = $foundAgent;
			}
		}

	  $this->pagenow = (int) str_ensure_defined($_GET['page']);

	  $this->listconfig = array();
	  $this->listconfig['startfrom'] = $this->pagenow * $this->pagesize;
	  $this->listconfig['checkrange'] = $this->pagesize * 5;
	  $this->listconfig['loadrange'] = $this->pagesize;

    if(int_ensure_defined($configs['col_recorder'])) $this->listconfig['recorders'] = true;

		if (str_ensure_defined($_GET['export'])=='csv' || str_ensure_defined($_GET['export'])=='xlsx')
		{
			$this->listconfig['allrecords'] = true;
			$this->listconfig['callback'] = 'Export_RowHandler';
			$this->listconfig['callbackparam'] = array();
    }

    if (function_exists('CustomListing_SearchParse'))
    {
      CustomListing_SearchParse( $this->listconfig );
    }
	}

	function PerformSearch()
	{
		global $msg, $dbintf, $actuinfo, $configs;

		$start_timer = microtime(true);
		
		if ($_GET['export']=='csv' || $_GET['export'] == 'xlsx')
		{
			Export_Prepare($_GET['export'], $this->listconfig);
    }

    if (function_exists('CustomListing_SearchPrepare'))
    {
      CustomListing_SearchPrepare($this->listconfig);
    }

		$configs['LoadDelBackup'] = $dbintf->GetConfigValue('LoadDelBackup');

		if ($this->selcall!=-1)
		{
		  for ($i=0;$i<20;$i++)
		  {
				$this->pagenow = $i;
	  		$this->listconfig['startfrom'] = $this->pagenow * $this->pagesize;
				// Get the call listing
			  $this->call_list = $dbintf->GetCallList($this->sk,$this->sd,$this->search_use,$this->listconfig);
		  	$in_list = false;
		  	foreach ($this->call_list as $key=>$row)
		  	{
          if($key == "cnt") continue;
          
					if ($row['id']==$this->selcall)
					{
						$in_list = true;
					}
				}
				if ($in_list) break;
		  }
		} else
		{
		  // Get the call listing
			$testtime1 = microtime(true);
		  $this->call_list = $dbintf->GetCallList($this->sk,$this->sd,$this->search_use,$this->listconfig);
			$testtime2 = microtime(true);
			$db_time = (int) (($testtime2-$testtime1)*1000);
			if ($db_time>500)
			{
				lg( 'GetCallList query took '.$db_time. ' ms' );
			}
		}
    
    LogAction($this->viewAuditLogText
      ,array('level'=>'view'
        ,'calllist_search'=>$this->search_use
        ,'calllist_config'=>$this->listconfig
        )
      );


		if ($_GET['export']=='csv' || $_GET['export'] == 'xlsx')
		{
      Export_Done($this->listconfig);
	  	exit;
    }

    if (function_exists('CustomListing_SearchFinalize'))
    {
      CustomListing_SearchFinalize($this->listconfig);
    }

	  $this->call_count = $this->call_list['cnt'] +  $this->listconfig['startfrom']; // at least, may be more
	  // unset because otherwise taken into account in foreach below
	  unset($this->call_list['cnt']);
	
	  // Paging

	  $this->frompage = $this->pagenow - 5;
	  if ($this->frompage<0) $this->frompage = 0;
	  $this->limitpage = (int) (($this->call_count + $this->pagesize - 1) / $this->pagesize);
		
		
		// Load extra data
		$ids = array();
		foreach ($this->call_list as $ix=>&$ref_row)
	  {
			$ids[] = $ref_row['id'];
		}
		$markersetdb = array();
    $hastranscript = array();
		if (count($ids)>0)
		{
      $hideAuto = int_ensure_defined($configs['HideAutoAnnotations'])!=0;
			$markersetdb = $dbintf->GetAnnotationSet( $ids , $hideAuto );
      $hastranscript = $dbintf->GetHasTranscriptSet( $ids );
		}
		foreach ($this->call_list as $ix=>&$ref_row)
	  {
      $ref_row['hastranscript'] = isset($hastranscript[ $ref_row['id'] ]);
    }

    $vtaps_list = array();
    if(isset($this->listconfig['recorders']))
    {
      $vtaps = $dbintf->GetVtaps();
      foreach($vtaps as $vtap)
      {
        $vtaps_list[$vtap['vtap_id']] = $vtap;
      }
    }

		foreach ($this->call_list as $ix=>&$ref_row)
	  {
      if(int_ensure_defined($ref_row['recordertype']) == 55
      && isset($vtaps_list[$ref_row['recid']])
      && str_ensure_defined($vtaps_list[$ref_row['recid']]["name"]) != "")
      {
        $vtap = $vtaps_list[$ref_row['recid']];
        $ref_row['recordername'] = "V-Tap " . $vtap["name"] . " (" . $ref_row['recid'] . ")";
      }

			$ref_row['markers'] = array();
			if (isset($markersetdb[ $ref_row['id'] ])==false) continue;
			$markersdb = $markersetdb[ $ref_row['id'] ];
			$markers = array();
			foreach ($markersdb as $markerdb)
			{
				$toload = array( 'call_id', 'label', 'timepos', 'descr', 'createdby');
				$marker = array();
				foreach ($toload as $field)
				{
					$marker[$field] = $markerdb[$field];
				}
				$markers[$markerdb['id']] = $marker;
			}
			$ref_row['markers'] = $markers;
		}
    // only build tenant map if we need it
    if ( $this->needJsData
    && int_ensure_defined($configs['col_tenant'])!=0)
    {
      $this->BuildTenantNameMap();
    }
    if ( int_ensure_defined($configs['col_agent'])!=0)
    {
      $this->BuildAgentMap();
    }
    
		// debug: echo round(1000*( microtime(true) - $start_timer )) . " ms"; exit;
	}
	
  function BuildTenantNameMap()
  {
    global $dbintf;
    if (isset($this->tenantNameMap)) return;
    if ( $dbintf->AmIAdminT123()
    && $this->multiTenancy )
    {
      $this->tenantNameMap = array();
      $tenants = $dbintf->GetTenantList();
      foreach ($tenants as $tenant)
      {
        $this->tenantNameMap[ $tenant['id'] ] = $tenant['name'];
      }
    }
  }
  
  function BuildAgentMap()
  {
    global $dbintf;
    if (isset($this->agentMap)) return;
		$this->agentMap = array();
		// GetUserList filters out users of other tenants
		$users = $dbintf->GetUserList();
		$globalpm = ($dbintf->actuinfo['permissions']&(PM_LIST))!=0;
		foreach ($users as $user)
		{
			if ($globalpm==false && $dbintf->GetAccPm( $user['accid'] )==0) continue;
			$this->agentMap[ $user['accid'] ] = $user['name'];
		}
  }	
	
	function GetJsonData($options=array())
	{
		global $configs, $dbintf, $configs;

    // Define variables once for use in JSON filtering
    // Define a mapping from json key to configs column key
    // = means the key is the same
    $dispdep = array 
    ( 'remoteid'  => 'rem'
    , 'notes'     => '='
    , 'notes2'    => '='
    , 'notes3'    => '='
    , 'notes4'    => '='
    , 'notes5'    => '='
		, 'data1'			=> '='
		, 'data2'			=> '='
		, 'data3'			=> '='
		, 'data4'			=> '='
		, 'data5'			=> '='
    , 'category'  => '='
    , 'waittime'  => '='
    , 'chk'       => 'checksum'
    , 'linenr'    => '='
    , 'tenant'    => '='
    // remote things
    , 'remote'    => '='
    , 'rctid'     => 'remote'
    , 'remotefull'=> 'remote'
    , 'rname'     => '='
    , 'remote2'   => '='
    // local things
    , 'local'     => '='
    , 'lctid'     => 'local'
    , 'localfull' => 'local'
    , 'local2'    => '='
    , 'lname'     => '='
    // connected things
    , 'connected' => '='
    , 'cctid'     => 'connected'
    , 'cname'     => '='
    , 'recorder'  => '='
		, 'agent'     => '='
    );
    // the following keys are included always
    $includeAlways = array
    ( 'id'     => true
    , 'pm'     => true
    , 'arch'   => true
    , 'flags'  => true
    , 'length' => true
    , 'lenms'  => true
    , 'markers'   => true
    , 'filename'  => true
    , 'startdate' => true
    , 'direction' => true
    );
    if (($dbintf->actuinfo['permissions']&PM_CONFIG)!=0)
    {
      $includeAlways['retention'] = true;
    }
	  $calldata = '{"calls":[' . "\r\n";
		$first = true;
		foreach ($this->call_list as $ix=>$row)
	  {
	    if ($first==false) $calldata .= ',';
	
			$callextra = StringToArray($row['callextra']);
			$chk = '';
			if (isset($callextra['chk']))
			{
				$chk = $callextra['chk'];
			}

			$extracols = array();
			if (isset($options['callback']))
			{
				$extracols = $options['callback']($row,$options);
			}

			$filename = GetDownloadFileName($row['filename'],$row);
			if (int_ensure_defined($configs['ToMp3Play'])==1 && !($row['flags'] & 2048))
			{
				$filename = change_filename_extension($filename,'.mp3');
			}

			$startdate = $row['startdate'];
      $startms = $row['startms'];
			$datestr = date($configs['datetimef'],$startdate);
      if ($startms!=NULL && (int_ensure_defined($configs['timeformat'])==1) )
      {
        $datestr .= '.' . str_pad($startms,3,'0',STR_PAD_LEFT);
      }
      
      $flags = (int) $row['flags'];
      if ($row['hastranscript'] && ($row['pm']&PM_VIEW_TRANSCRIPT)!=0 )
      {
        $flags |= 512;
      }
      
			$jsonobj = array();
			$jsonobj['id'] = $row['id'];
      $jsonobj['startdate'] = $datestr;
			$jsonobj['remoteid'] = $row['remoteid'];
			$jsonobj['filename'] = $filename;
			$this->FillColData($jsonobj,$row,1,'X');
	    $this->FillColData($jsonobj,$row,0,'X');
	    $this->FillColData($jsonobj,$row,1,'Xfull');
	    $this->FillColData($jsonobj,$row,0,'Xfull');
	    $this->FillColData($jsonobj,$row,1,'xctid','Xcontact');
	    $this->FillColData($jsonobj,$row,0,'xctid','Xcontact');
	    $this->FillColData($jsonobj,$row,1,'xname');
	    $this->FillColData($jsonobj,$row,0,'xname');
	    $this->FillColData($jsonobj,$row,1,'X2');
	    $this->FillColData($jsonobj,$row,0,'X2');
			$jsonobj["connected"] = EmptyNull($row['connected']);
	    $jsonobj["cname"] = EmptyNull($row['cname']);
	    $jsonobj["cctid"] = (int) $row['connectedcontact'];
	    $jsonobj["direction"] = (int) $row['direction'];
	    $jsonobj["notes"] = EmptyNull($row['notes']);
	    $jsonobj["notes2"] = EmptyNull($row['notes2']);
      $jsonobj["notes3"] = EmptyNull($row['notes3']);
      $jsonobj["notes4"] = EmptyNull($row['notes4']);
      $jsonobj["notes5"] = EmptyNull($row['notes5']);
			$jsonobj["data1"] = EmptyNull($row['data1']);
	    $jsonobj["data2"] = EmptyNull($row['data2']);
      $jsonobj["data3"] = EmptyNull($row['data3']);
      $jsonobj["data4"] = EmptyNull($row['data4']);
      $jsonobj["data5"] = EmptyNull($row['data5']);
			// formatting is now done in JS. So not: formatDuration($row['duration']);
	    $jsonobj["length"] = $row['duration'];
      $jsonobj["lenms"] = $row['durms'];
	    $jsonobj["pm"] = $row['pm'];
	    $jsonobj["arch"] = $row['isarchived'];
	    $jsonobj["chk"] = $chk;
	    $jsonobj["flags"] = $flags;
	    $jsonobj["linenr"] = (int) $row['linenr'];
	    $jsonobj["category"] = (int) $row['category'];
			$jsonobj["markers"] = $row['markers'];
	    $jsonobj["waittime"] = $row['waittime'];
      $jsonobj['recorder'] = EmptyNull(ensure_defined($row['recordername'], null));
      $jsonobj['retention'] = $row['retention'];
			if ($this->agentMap)
			{
				if ($row['agent']===null)
				{
					$jsonobj['agent'] = null;
				} else if (isset($this->agentMap[ $row['agent'] ]))
				{
					$jsonobj['agent'] = $this->agentMap[ $row['agent'] ];
				} else
				{
					$jsonobj['agent'] = '[' . $row['agent'] . ']';
				}
			}
	    foreach ($extracols as $col=>$val)
	    {
				if (is_int($val)) $jsonobj[$col] = $val;
				else $jsonobj[$col] = $val;
			}
      if ($this->filterData)
      {
        // Now filter json obj. This is to avoid leaking information,
        // that maybe should not be available to all users.
        $fobj = array();
        foreach ($jsonobj as $key=>$val)
        {
          $show = -1; // undefined
          if (isset($dispdep[$key]))
          {
            // the key is included if the relevant column is enabled
            // in the display settings
            $col = $dispdep[$key];
            if ($col=='=') $col = $key;
            $show = int_ensure_defined($configs['col_' . $col]) != 0;
          }
          // some keys are included always
          if (isset($includeAlways[$key])) $show = true;
          // extra keys (for Ag.Ev.) are also included always
          if (array_key_exists($key,$extracols)) $show = true;
          if ($show===true)
          {
            $fobj[$key] = $val;
          } else if ($show===-1)
          {
            // result not defined, this should not occur
            //echo '<br>todo: ' . $key;
            //exit;
          }
        }
      } else
      {
        $fobj = $jsonobj;
      }
      if (int_ensure_defined($configs['col_tenant'])!=0
      && $dbintf->AmIAdminT123()
      && $this->multiTenancy)
      {
        $fobj['tenant'] = $row['tenantid'];
      }
      $calldata .= json_encode( $fobj, JSON_FORCE_OBJECT ) . "\r\n";

	    $first = false;
	  }

	  $calldata .= ']' . "\r\n";
		
		$calldata .= ',"call_count":' . $this->call_count . "\r\n";
		$calldata .= ',"pagesize":' . $this->pagesize . "\r\n";
		$calldata .= ',"pagenow":' . $this->pagenow . "\r\n";
		$atleast = 0;
		if ($this->call_count == $this->listconfig['startfrom'] + $this->listconfig['checkrange'])
	  {
	    // at least
			$atleast = 1;
	  }
		$calldata .= ',"atleast":' . $atleast . "\r\n";
		$calldata .= '}' . "\r\n";
		
		return $calldata;
		
	}
	
	function GetBasicJsData($options=array())
	{
		global $msg, $configs, $dbintf, $actuinfo, $lng;
		
		$calldata = 'var tmpdat = ' . $this->GetJsonData($options);
	  $calldata .= 'var calldata = tmpdat.calls;'."\r\n";
	  $calldata .= 'var categoryList =' . "\r\n";
	  $calldata .= '[	{label:"'.JSQuote($lng->Get('Main.None')).'",value:"0"}' . "\r\n";
	  for ($i=1;$i<=10;$i++)
	  {
			// JSQuote($lng->Get('Cols.category')).' '.($i+1)
			$lbl = str_ensure_defined($configs['CatLabel'.$i]);
			//if ($lbl=='') $lbl = $lng->Get('Cols.category') . ' ' . $i;
			$calldata .= ', {label: "'.JSQuote($lbl).'",value:'.$i.'}';
		}

	  $calldata .= '];' . "\r\n";
	
    $calldata .= "var NotesLabels = [];\n";
    for ($i=2;$i<=5;$i++)
    {
      $key = 'NotesLabel' . $i;
      $calldata .= "NotesLabels[$i] = \"" . JSQuote( str_ensure_defined($configs[$key]) ) . "\";\n";
    }
		
		$calldata .= "var DataLabels = [];\r\n";
		for($i=1;$i<=5;$i++)
		{
			$key = 'DataLabel' . $i;
			$calldata .= "DataLabels[$i] = \"" . JSQuote( str_ensure_defined($configs[$key]) ) . "\";\n";
		}
    
    $accessAnyTranscripts = ($dbintf->anyaccpms & PM_VIEW_TRANSCRIPT)!=0
     || ($dbintf->actuinfo['permissions'] & PM_VIEW_TRANSCRIPT) != 0;
  
	  $calldata .= '
	  var sortkey = "'.$this->sk.'";
	  var sortdir = '.($this->sd=='asc'?'YAHOO.widget.DataTable.CLASS_ASC':'YAHOO.widget.DataTable.CLASS_DESC').';
    var pm_del_recording = 1;
    var pm_mass_del = ' . ($dbintf->actuinfo['permissions'] & PM_MASS_DELETE ? '1':'0') . ';
	  var CallerReceiver = '.int_ensure_defined($configs['CallerReceiver']).';
	  var TenantReassign = '.int_ensure_defined($configs['TenantReassign']).';
	  var page = '.$this->pagenow.';
	  var anypm_tra = ' . ($accessAnyTranscripts?'1':'0') . ';
		';

		$colkeys = array("playlink","flags","startdate","length","waittime","direction"
		,"category","notes","notes2","notes3","notes4","notes5"
		,"data1","data2","data3","data4","data5"
		, "rname", "remote", "remote2", "cname", "connected"
		, "direction2"
		, "lname", "local", "local2","linenr"
		, "agent", "tenant","checksum","rem","recorder");

	  $calldata .= 'var showcols = {';
	  foreach ($colkeys as $colkey)
	  {
	    $calldata .= $colkey.': ' . int_ensure_defined($configs['col_'.$colkey]).',';
	    //$data .= "]";
	  }
	  $calldata .= 'xyend:0};' . "\r\n";
    
    // column headers
    $colheaders = array();
    foreach(array("playlink","flags","startdate","length","waittime","direction"
		,"category"
    ,"notes"
    //,"notes2","notes3","notes4","notes5"
		//,"data1","data2","data3","data4","data5"
		, "rname", "remote"
    //, "remote2"
    , "cname", "connected"
		//, "direction2"
		, "lname", "local"
    //, "local2"
    ,"linenr"
		//,"tenant"
    ,"checksum"
    //,"rem"
    ) as $colkey)
    {
      $colheaders[$colkey] = $lng->Get('Cols.' . $colkey);
    }
    for ($i=2;$i<=5;$i++)
    {
      $key = 'NotesLabel' . $i;
      $t = '';
      if ($configs[$key]!='') $t = $configs[$key];
      else $t = $lng->Get('Cols.notes') . ' (' . $i . ')';
      $colheaders['notes'.$i] = $t;
    }
    for ($i=1;$i<=5;$i++)
    {
      $key = 'DataLabel' . $i;
      $t = '';
      if ($configs[$key]!='') $t = $configs[$key];
      else $t = $lng->Get('Web.Data') . ' (' . $i . ')';
      $colheaders['data'.$i] = $t;
    }
    $colheaders['direction2'] = $colheaders['direction'] . ' (2)';
    $colheaders['remote2'] = $lng->Get('Cols.remoteIP');
    $colheaders['local2'] = $lng->Get('Cols.localIP');
    $colheaders['tenant'] = $lng->Get('Web.Tenant');
    $colheaders['rem'] = $lng->Get('Web.Identifier');
    $colheaders['recorder'] = $lng->Get('Cols.recname');
		$colheaders['agent'] = $lng->Get('PM.User');
    
    $calldata .= 'colheaders = ' . json_encode($colheaders) . "\r\n";

	  $calldata .= 'savq = [';
	  $first = true;
		foreach ($this->queries as $q)
		{
			if ($first) $first = false;
			else $calldata .= ', ';
			$calldata .= '{ id: '. $q['id']
			. ', name : "' . JSQuote($q['name']) . '" '
			. ', qspec: {';
			$first2 = true;
			foreach ($q['qspec_arr'] as $param=>$value)
			{
				if ($first2) $first2 = false;
				else $calldata .= ', ';
				$calldata .= $param . ':"' . $value . '"';
			}
			$calldata .= '} }' . "\r\n";
	
		}
		$calldata .= '];' . "\r\n";

    $vtaps_list = [];
    $vtaps = $dbintf->GetVtaps();
    foreach($vtaps as $vtap)
    {
      $vtaps_list[$vtap['vtap_id']] = $vtap;
    }

	  $calldata .= 'var recorders = [';
	  $first = true;
		foreach ($this->recorders as $r)
		{
      if($r['rectype'] == 55 && 
      isset($vtaps_list[$r['recid']]) && 
      str_ensure_defined($vtaps_list[$r['recid']]['name']) != '')
      {
        $rname = "V-Tap " . $vtaps_list[$r['recid']]["name"] . " (" . $r['recid'] . ")";
      }
      else
      {
        $rname = $r['name'];
      }

			if ($first) $first = false;
			else $calldata .= ', ';
			$calldata .= '{ id: '. $r['id']
			. ', name : "' . JSQuote($rname) . '" ';
			$calldata .= '}' . "\r\n";
	
		}
		$calldata .= '];' . "\r\n";
    
    if ( $dbintf->AmIAdminT123()
    && $this->multiTenancy
    && isset($this->tenantNameMap)
    )
    {
      $calldata .= 'var tenants = {';
      $first = true;
      foreach ($this->tenantNameMap as $id=>$name)
      {
        if ($first) $first = false;
        else $calldata .= ', ';
        $calldata .= $id . ':"' . JSQuote($name) . '"' . "\r\n";
      }
      $calldata .= "};\r\n";
    }
    
		if (isset($configs['RefreshCallListInterval'])==false)
		{
			$configs['RefreshCallListInterval'] = 10;
		}
		
    $defcolors = GetDefaultCategoryColors();
    $catColors = array();
    for ($i=1;$i<=10;$i++)
    {
      if (!isset($configs['CatColor'.$i]))
      {
        $configs['CatColor' . $i] = $defcolors[$i-1];
      }
      $catColors[] = $configs['CatColor' . $i];
    }
    $calldata .= 'var catColors = ' . json_encode($catColors) . ";\r\n";
    $calldata .= 'var dbColCfg = ' . json_encode($dbintf->actuinfo['colcfg']) . ";\r\n";
    
    $calldata .= 'var embedPlayer = ' . (int_ensure_defined($configs['EmbedPlayer'])?'true':'false') . ';' . "\r\n";
		$calldata .= 'var audio5 = ' . ($configs['Audio5']?'true':'false') . ';' . "\r\n";
		$calldata .= 'var LoadDelBackup = ' . ($configs['LoadDelBackup']?'true':'false') . ';' . "\r\n";
		$calldata .= 'var RefreshCallList = ' . (int_ensure_defined($configs['RefreshCallList'])?'true':'false') . ';' . "\r\n";
		$calldata .= 'var RefreshCallListInterval = ' . $configs['RefreshCallListInterval'] . ';' . "\r\n";

	  $calldata .= 'var searchobj = {';
	  $first = true;
	  foreach ($this->search as $searchcol=>$searchvalue)
	  {
	    if ($first==false)
	    {
	      $calldata .= ',';
	    }
	    $first = false;
	    $calldata .= $searchcol . ':"'.JSQuote($searchvalue).'"';
	  }
	  $calldata .= '};';
	  $calldata .= 'var showownswitch = ' . (($dbintf->otherlistpm && $dbintf->hasphones)?'1':'0') . ';' . "\r\n";
		
		$noEmailButton = int_ensure_defined($configs['NoEmailButton']);
    if ($dbintf->actuinfo['email']=='') $noEmailButton = 1;
		$calldata .= 'var noemailbutton = ' . $noEmailButton . ';' . "\r\n";
	  return $calldata;
	}

	function GenerateCallCntInfo()
	{
		global $lng;
	
	  $callcnt = '';
		$plus = '';
	  if ($this->call_count == $this->listconfig['startfrom'] + $this->listconfig['checkrange'])
	  {
			$plus = '+';
	  }
	  $callcnt .=  $this->call_count . $plus . ' ' . $lng->Get('Main.recordings');
	  //if (count($call_list)==200) $callcnt .= ' or more';
		return '<div class="callcnt">' . $callcnt . '</div>';
	}
	
	
	function GenerateNav()
	{
	  $nav = '';
	  $nav .= '<div class="navcontainer">';
	  if ($this->pagenow!=0)
	  {
			$inner = '<img src="p/img/nav-first.png" alt="|&lt;&lt;">';
	    $nav .= '<a class="nav" href="#" onclick="SetPage(0);return false;">'.$inner.'</a>';
	  } else {
			$inner = '<img src="p/img/nav-first-dis.png" alt="|&lt;&lt;">';
	    $nav .= '<div class="navgray">'.$inner.'</div>';
	  }
	  if ($this->pagenow!=0)
	  {
			$inner = '<img src="p/img/nav-previous.png" alt="&lt;">';
	    $nav .= '<a class="nav" href="#" onclick="SetPage('.($this->pagenow-1).');return false;">'.$inner.'</a>';
	  } else {
			$inner = '<img src="p/img/nav-previous-dis.png" alt="&lt;">';
	    $nav .= '<div class="navgray">'.$inner.'</div>';
	  }
		if ($this->frompage > 0)
		{
	    $nav .= '<div class="navdots">...</div>';
		}
	  for ($i=$this->frompage;$i<$this->limitpage;$i++)
	  {
	    $navcls = 'navnum';
	    if ($i==$this->pagenow) $navcls = 'navcur';
	    $nav .= '<a class="'.$navcls.'" href="#" onclick="SetPage('.$i.');return false;">'.($i+1).'</a>';
	  }
	  if ($this->call_count == $this->listconfig['startfrom'] + $this->listconfig['checkrange'])
	  {
	    $nav .= '<div class="navdots">...</div>';
	  }
	  if ($this->pagenow!=$this->limitpage-1 && $this->limitpage!=0)
	  {
	    //$inner = '&gt;';
			$inner = '<img src="p/img/nav-next.png" alt="&gt;">';
			$nav .= '<a class="nav" href="#" onclick="SetPage('.($this->pagenow+1).');return false;">'.$inner.'</a>';
	  } else {
			$inner = '<img src="p/img/nav-next-dis.png" alt="&gt;">';
	    $nav .= '<div class="navgray">'.$inner.'</div>';
	  }
	  $nav .= '</div>';
		return $nav;
	}

	function FillColData(&$data_ref,$row,$remote,$key1,$key2=null)
	{
		if ($key2==null) $key2=$key1;
		$data_remote = $remote;
		if ($this->CallerColumn && $row['direction']==0) $data_remote = ! $data_remote;
		$data_ref[ GetLocalRemoteText($key1,$remote) ] = EmptyNull($row[GetLocalRemoteText($key2,$data_remote)]);
	}
	
	function GetColData($row,$remote,$key1,$key2=null)
	{
		if ($key2==null) $key2=$key1;
		$data_remote = $remote;
		if ($this->CallerColumn && $row['direction']==0) $data_remote = ! $data_remote;
		$t = ',"' . GetLocalRemoteText($key1,$remote) . '"'
			 . ':"' . JSQuote(EmptyNull($row[GetLocalRemoteText($key2,$data_remote)])) . '"';
		return $t;
	}

	function SetDefReplacements()
	{
		global $msg, $rpl, $configs;
	  $rpl['msg'] = message($msg);
	  $rpl['nav'] = $this->GenerateNav();
	  $rpl['calllistsum'] = $this->GenerateCallCntInfo();
	  $rpl['search_outside_js'] = file_get_contents('../apresa/templ/search_outside.js');
    $rpl['searchblk'] = file_get_contents('../apresa/templ/list_searchblk.htm');

    // Check for internet explorer
    $ua = htmlentities($_SERVER['HTTP_USER_AGENT'], ENT_QUOTES, 'UTF-8');
    if (preg_match('~MSIE|Internet Explorer~i', $ua) || (strpos($ua, 'Trident/7.0') !== false && strpos($ua, 'rv:11.0') !== false)) 
    {
      // To prevent causing a syntax error that would break the entire page
      $rpl['callencryption_js'] = "var call_encryption_available = false\r\n";
    }
    else
    {
      $rpl['callencryption_js'] = file_get_contents('../apresa/templ/callencryption.js');
    }
    
    $custom_list_css = '../apresa/templ/custom/list_custom.css';
    $list_css = file_get_contents('../apresa/templ/genlist.css');
    if ( file_exists($custom_list_css) )
    {
      $list_css .= file_get_contents($custom_list_css);
    }
	  $rpl['genlist_css'] = $list_css;
		$rpl['genplay_htm'] = file_get_contents('../apresa/templ/genplay.htm');
    $custom_list_js = '../apresa/templ/custom/list_custom.js';
    $list_js = file_get_contents('../apresa/templ/genlist_outside.js');
    if ( file_exists($custom_list_js) )
    {
      $list_js .= file_get_contents($custom_list_js);
    }
		$AleKeyPresent = file_exists('/dev/shm/apresa/play.ekey')
		|| (isset($_SESSION['PlayKeyId'])
				&& file_exists('/dev/shm/apresa/web/play_'.$_SESSION['PlayKeyId'].'.ekey') );
		$AlePlayUnlockUser = int_ensure_defined($configs['AlePlayUnlockUser'])!=0;
		$extra_js = "\n"
		. 'var AleKeyPresent = ' . ($AleKeyPresent?1:0) . ';' . "\n"
		. 'var AlePlayUnlockUser = ' . ($AlePlayUnlockUser?1:0) . ';' . "\n";
	  $rpl['genlist_outside'] = $list_js;
		$rpl['genplay_outside'] = $extra_js . file_get_contents('../apresa/templ/genplay_outside.js');
	  $rpl['genlist_onready'] = file_get_contents('../apresa/templ/genlist_onready.js');
	  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
	  $rpl['FOOTER'] = '';
	  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
	  $rpl['header'] = GetHeader();
	}

} // end of class

function GetLocalRemoteText($text,$remote)
{
	if ($remote)
	{
		$text = str_replace('X','remote',$text);
		$text = str_replace('x','r',$text);
	} else
	{
		$text = str_replace('X','local',$text);
		$text = str_replace('x','l',$text);
	}
	return $text;
}

function TryDelete($directory,$filename)
{
	global $msg;
	if ($filename=='') return 2; // no filename, no file, so already gone
	if ($directory=='') return 3; // should never happen
	$fn = $directory . $filename;
	if (file_exists($fn))
  {
  	DeleteFn($fn);
    if (file_exists($fn))
    {
			return 1;
    	/* $msg[] = new Msg(MSG_ERR,'Failed to delete recording with filename: '.$filename); */
    } else {
			return 0;
    	/* $msg[] = new Msg(MSG_INF,'<%Web.FileIsDeleted%>'); */
    }
  } else {
		return 2;
  	/* $msg[] = new Msg(MSG_ERR,'File was already gone.'); */
  }
}

function CeAddExtraJsCols($row,& $options)
{
	$data = array();
	$data['projectid'] = (int) $row['projectid'];
	$data['agentid'] = (int) $row['agentid'];
	$data['username'] = $row['username'];
	$data['score'] = $row['score'];
  $data['supervisorid'] = $row['supervisor'];
  $data['supervisor']   = str_ensure_defined($row['supervisornm']);
  $data['ceid'] = $row['ceid'];
	return $data;
}

function CeAddExtraRowData(& $row_ref, & $options)
{
  global $dbintf;
	if ($row_ref['useraccid']!='')
	{
		// agent as stored by agent evaluation
		$row_ref['agentid'] = $row_ref['useraccid'];
	} elseif ($row_ref['agent']!=null)
	{
		// agent as determined by Apresa version 13.4.3+
		$row_ref['agentid'] = $row_ref['agent'];
	} else
	{
		$row_ref['agentid'] = 0;
		$agents = $dbintf->GetUsersOfCall($row_ref,false);
		$cnt = 999999;
		foreach ($agents as $agent)
		{
			$thiscnt = $options['usermap'][ $agent ]['phonecnt'];
			if ($thiscnt<$cnt)
			{
				$row_ref['agentid'] = $agent;
				$cnt = $thiscnt;
			}
		}
	}
	$row_ref['username'] = '';
	if ($row_ref['agentid']>0)
	{
		$userref = & $options['usermap'][ $row_ref['agentid'] ];
		$row_ref['username'] = $userref['name'];
	}
  if (isset($row_ref['supervisor']))
  {
    $suser = $options['usermap'][ $row_ref['supervisor'] ];
    if (isset($suser))
    {
      $row_ref['supervisornm'] = $suser['name'];
    }
  }
}


function LockMassDel()
{
  $res = @fopen("/tmp/massdel_lock", "x");

  return $res ? true : false;
}

function UnlockMassDel()
{
  unlink("/tmp/massdel_lock");
}


?>