<?php
require_once('general.php');
require_once('db.php');
require_once('cedb.php');
require_once('ceshared.php');

HandleLiveDashboard($dbintf);


function HandleLiveDashboard($dbintf)
{
	global $msg, $data, $configs_s, $rpl;
	
	$cedb = new CEDB($dbintf);
	$actuinfo = $dbintf->GetActiveUserInfo();
	
	if ( ($dbintf->actuinfo['permissions']&PM_CE_VIEW_LIVEDASH) == 0 )
  {
    echo 'Permission denied';
    exit;
	}
	
	$act = $_POST['act'];

  if ($act=='newDashboardOrder')
  {
		$newOrder = $_POST["NewOrder"];
		$orderArray = explode(",", $newOrder);
			
		$cedb->clearLiveDashboardOrder();
		$i=1;
		foreach($orderArray as $element){
			$cedb->addLiveDashboardOrder($i,$element);
			$i++;
		}
			
		$cedb->clearLiveDashboardSettings();
			
		$cedb->addLiveDashboardSetting(0,$_POST["ChartsPerRow"]);
		$cedb->addLiveDashboardSetting(1,$_POST["BlocksPerRow"]);
		$cedb->addLiveDashboardSetting(2,$_POST["FontSize"]);
		$cedb->addLiveDashboardSetting(3,$_POST["RefreshRate"]);
    
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'livedashboard.php');
    exit;
    
	}	
	
	
	$data="var AvailableBlocks = [".
				"			 { id:  0, name: 'Spacer' , type: 'Text', edit: 'placeholder'}".
				"			,{ id:  1, name: 'Average Calls Per Hour' , type: 'Chart', edit: 'placeholder'}".
				//"			,{ id:  2, name: '(FAKE) SomeLineChart' , type: 'Chart', edit: 'placeholder'}".
				"			,{ id:  3, name: 'Active Calls Pie Chart' , type: 'Chart', edit: 'placeholder'}".
				//"			,{ id:  4, name: '(FAKE) Lines in use' , type: 'Text', edit: 'placeholder'}".
				"			,{ id:  5, name: 'Average Wait time' , type: 'Text', edit: 'placeholder'}".
				"			,{ id:  6, name: 'Table Last Incoming' , type: 'Table', edit: 'placeholder'}".
				"			,{ id:  7, name: 'Table Last Outgoing' , type: 'Table', edit: 'placeholder'}".
				"			,{ id:  8, name: 'Table Last Missed' , type: 'Table', edit: 'placeholder'}".
				//"			,{ id:  9, name: '(NON-FUNCTIONAL) Waiting Calls' , type: 'Text', edit: 'placeholder'}".
				"			,{ id: 10, name: 'Active Calls' , type: 'Text', edit: 'placeholder'}".
				"			,{ id: 11, name: 'Active Incoming Call Count' , type: 'Text', edit: 'placeholder'}".
				"			,{ id: 12, name: 'Total Incoming Call Count' , type: 'Text', edit: 'placeholder'}".
				"			,{ id: 13, name: 'Active Outgoing Call Count' , type: 'Text', edit: 'placeholder'}".
				"			,{ id: 14, name: 'Total Outgoing Call Count' , type: 'Text', edit: 'placeholder'}".
				"			,{ id: 15, name: 'Missed Call Count' , type: 'Text', edit: 'placeholder'}".
				//"			,{ id: 16, name: 'Table Active Calls' , type: 'Table', edit: 'placeholder'}".
				"			,{ id:  17, name: 'Totals Daily Pie Chart' , type: 'Chart', edit: 'placeholder'}".																																									
				"];\r\n";
	
	$data.="var ChartsPerRow = ".(($cedb->getLiveDashboardSetting(0)!=-1) ? $cedb->getLiveDashboardSetting(0) : '3').";\r\n";
	$data.="var BlocksPerRow = ".(($cedb->getLiveDashboardSetting(1)!=-1) ? $cedb->getLiveDashboardSetting(1) : '4').";\r\n";
	$data.="var FontSize = ".(($cedb->getLiveDashboardSetting(2)!=-1) ? $cedb->getLiveDashboardSetting(2) : '2').";\r\n";
	$data.="var RefreshRate = ".(($cedb->getLiveDashboardSetting(3)!=-1) ? $cedb->getLiveDashboardSetting(3) : '3').";\r\n";
	
	$data .= GeneralJSData();

	$template_content = file_get_contents('../apresa/templ/livedashboard.htm');

	// template replacements:
	$rpl['msg'] = message($msg);
	$rpl['nav'] = '';
	$rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
	$rpl['FOOTER'] = '';
	

	$rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
	$rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
	$rpl['data'] = $data;
	$rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
	$rpl['header'] = GetHeader();
	$template_content = do_replace_tags($template_content);
	echo $template_content;

}

?>
