<?php
header('Content-type: application/json');
require_once('general.php');
require_once('db.php');
require_once('cedb.php');
require_once('ceshared.php');


//-------------------------------------------------------------------------------------

$output = [];
$cedb = new CEDB($dbintf);
$blockOrder = $cedb->getLiveDashboardOrder();

$spacercount=0;
if($blockOrder){
	foreach($blockOrder as $block){
		$data=[];
		switch ($block["tile"]) {		
			case 1:
					$randArray 					=	$cedb->getCallsPerHourAvg();
					$data["name"]				=	"Average Calls Per Hour Bar Chart";
					$data["title"]			=	"Average calls per hour";
					$data["id"]					=	$block["tile"];
					$data["color"]			=	"rgba(0, 0, 0, 0)";
					$data["type"]				=	"BarChart";
					$data["border"]			=	"black";
					$data["min"]				=	min($randArray);
					$data["max"]				=	max($randArray);
					$data["palette"]		=	['#39b54a','#ef3400'];
					$data["labels"]			= ['Number of calls'];
					$data["xaxis"]			=	['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00', '07:00', '08:00', '09:00', '10:00', '11:00', '12:00','13:00', '14:00', '15:00', '16:00', '17:00', '18:00', '19:00', '20:00', '21:00', '22:00', '23:00'];
					$data["data"]				=	$randArray;
					array_push($output,$data);
					break;
					
			case 2:
					$data["name"]				=	"SomeLineChart";
					$data["title"]			=	"Some LineChart";
					$data["id"]					=	$block["tile"];
					$data["color"]			=	"rgba(0, 0, 0, 0)";
					$data["type"]				=	"LineChart";
					$data["border"]			=	"black";
					$data["Smooth"]			=	true;
					$data["xaxis"]			=	['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun'];
					$data["data"]				=	[rand( 0 , 100 ), rand ( 0 , 100 ), rand ( 0 , 100 ), rand ( 0 , 100 ), rand ( 0 , 100 ), rand ( 0 , 100 ), rand ( 0 , 100 )];
					array_push($output,$data);
					break;
					
			case 3:
					$data["name"]				=	"Active Calls Pie Chart";
					$data["title"]			=	"Active Calls";
					$data["id"]					=	$block["tile"];
					$data["color"]			=	"rgba(0, 0, 0, 0)";
					$data["palette"]		=	['#39b54a','#00afef'];
					$data["type"]				=	"PieChart";
					$data["border"]			=	"black";
					$data["data"]				=	[[$cedb->getActiveInboundCallCount(),'Inbound'],[$cedb->getActiveOutboundCallCount(),'Outbound']];
					//$data["data"]				=	[[3,'Inbound'],[2,'Outbound']];
					array_push($output,$data);
					break;
					
			case 4:
					$data["name"]				=	"LinesInUse";
					$data["title"]			=	"Lines In Use";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"(Fake) Lines in Use:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"green";
					$data["border"]			=	"black";
					$data["value"]			=	rand( 0 , 100 );
					array_push($output,$data);
					break;
					
			case 5:
					$data["name"]				=	"AverageWait";
					$data["title"]			=	"Average Wait Time";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Average Wait:";
					$data["bottomtext"]	=	"seconds";
					$data["color"]			=	"red";
					$data["border"]			=	"black";
					$data["value"]			=	round($cedb->getAverageWaitTime(), 2);
					array_push($output,$data);
					break;
					
			case 6:
					$data["name"]				=	"TableLastIncoming";
					$data["title"]			=	"Last Incoming";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Table";
					$data["toptext"]		=	"toptext";
					$data["bottomtext"]	=	"bottomtext";
					$data["color"]			=	"blue";
					$data["border"]			=	"black";
					$data["rowspan"]		=	2;
					$data["colspan"]		=	3;
					$data["columns"]		=	["Extension:", "Direction:", "Date:"];
					//$data["rows"]=[[rand( 0 , 100 ), "TestUser 1", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 2", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 3", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 4", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 5", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 6", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 7", date("h:i:s a")]];
					$data["rows"]				=	$cedb->getLastExtensions(0,6);
					array_push($output,$data);
					break;
					
			case 7:
					$data["name"]				=	"TableLastOutgoing";
					$data["title"]			=	"Last Outgoing";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Table";
					$data["toptext"]		=	"toptext";
					$data["bottomtext"]	=	"bottomtext";
					$data["color"]			=	"orange";
					$data["border"]			=	"black";
					$data["rowspan"]		=	2;
					$data["colspan"]		=	3;
					$data["columns"]		=	["Extension:", "Direction:", "Date:"];
					//$data["rows"]=[[rand( 0 , 100 ), "TestUser 1", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 2", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 3", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 4", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 5", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 6", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 7", date("h:i:s a")]];
					$data["rows"]				= $cedb->getLastExtensions(1,6);
					array_push($output,$data);
					break;
					
			case 8:
					$data["name"]				=	"TableLastMissed";
					$data["title"]			=	"Last Missed";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Table";
					$data["toptext"]		=	"toptext";
					$data["bottomtext"]	=	"bottomtext";
					$data["color"]			=	"purple";
					$data["border"]			=	"black";
					$data["rowspan"]		=	2;
					$data["colspan"]		=	3;
					$data["columns"]		=	["Extension:", "Direction:", "Date:"];
					//$data["rows"]=[[rand( 0 , 100 ), "TestUser 1", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 2", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 3", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 4", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 5", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 6", date("h:i:s a")],[rand ( 0 , 100 ), "TestUser 7", date("h:i:s a")]];
					$data["rows"]=$cedb->getLastMissedExtensions(6);
					array_push($output,$data);
					break;
					
			case 9:
					$data["name"]				=	"WaitingCountCalls";
					$data["title"]			=	"Waiting Calls Count";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Waiting Calls:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"red";
					$data["border"]			=	"black";
					$data["value"]			=	$cedb->getWaitingCallCount();
					array_push($output,$data);
					break;
			
			case 10:
					$data["name"]				=	"ActiveCallCount";
					$data["title"]			=	"Active Calls Count";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Active Calls:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"green";
					$data["border"]			=	"black";
					$data["value"]			=	$cedb->getActiveCallCount();
					array_push($output,$data);
					break;
						
			case 11:
					$data["name"]				=	"ActiveIncomingCallCount";
					$data["title"]			=	"Active Incoming Calls Count";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Active Incoming Calls:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"green";
					$data["border"]			=	"black";
					$data["value"]			=	$cedb->getActiveInboundCallCount();
					array_push($output,$data);
					break;
					
			case 12:
					$data["name"]				=	"TotalIncomingCallCount";
					$data["title"]			=	"Total Incoming Calls Count";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Total Incoming Calls:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"green";
					$data["border"]			=	"black";
					$data["value"]			=	$cedb->getTotalInboundCallCount();
					array_push($output,$data);
					break;
					
			case 13:
					$data["name"]				=	"ActiveOutgoingCallCount";
					$data["title"]			=	"Active Outgoing Calls Count";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Active Outgoing Calls:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"green";
					$data["border"]			=	"black";
					$data["value"]			=	$cedb->getActiveOutboundCallCount();
					array_push($output,$data);
					break;
					
			case 14:
					$data["name"]				=	"TotalOutgoingCallCount";
					$data["title"]			=	"Total Outgoing Calls Count";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Total Outgoing Calls:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"green";
					$data["border"]			=	"black";
					$data["value"]			=	$cedb->getTotalOutboundCallCount();
					array_push($output,$data);
					break;
	
			case 15:
					$data["name"]				=	"MissedCallCount";
					$data["title"]			=	"Missed Calls Count";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Text";
					$data["toptext"]		=	"Missed Calls:";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"red";
					$data["border"]			=	"black";
					$data["value"]			=	$cedb->getMissedCallCount();
					array_push($output,$data);
					break;
					
			case 16:
					$data["name"]				=	"TableActiveCallsLive";
					$data["title"]			=	"Active Calls Live";
					$data["id"]					=	$block["tile"];
					$data["type"]				=	"Table";
					$data["toptext"]		=	"toptext";
					$data["bottomtext"]	=	"bottomtext";
					$data["color"]			=	"purple";
					$data["border"]			=	"black";
					$data["rowspan"]		=	4;
					$data["colspan"]		=	3;
					$data["columns"]		=	["initiated", "wait time [s]", "ring time [s]", "Duration", "Call state", "Recording state", "Protocol", "In/out", "Remote id", "Local id"];
					$data["rows"]				=	$cedb->GetActiveCalls();
					array_push($output,$data);
					break;
					
			case 17:
					$data["name"]				=	"Totals Daily Pie Chart";
					$data["title"]			=	"Totals Daily";
					$data["id"]					=	$block["tile"];
					$data["color"]			=	"rgba(0, 0, 0, 0)";
					$data["palette"]		=	['#39b54a','#00afef','#ef3400'];
					$data["type"]				=	"PieChart";
					$data["border"]			=	"black";
					$data["data"]				=	[[$cedb->getTotalInboundCallCount(),'Inbound'],[$cedb->getTotalOutboundCallCount(),'Outbound'],[$cedb->getMissedCallCount(),'Missed']];
					array_push($output,$data);
					break;
					
			default: 
					$data["name"]				=	"spacer".$spacercount;
					$data["title"]			=	"";
					$data["id"]					=	0;
					$data["type"]				=	"Text";
					$data["toptext"]		=	"";
					$data["bottomtext"]	=	"";
					$data["color"]			=	"#e2e2e2";
					$data["border"]			=	"#e2e2e2";
					$data["value"]			=	"";
					array_push($output,$data);
					$spacercount++;
					break;
		}	
	}
}
echo json_encode($output);

?>
