<?php
require_once('general.php');
require_once('certificates_general.php');

HandlePage($dbintf);

function MakeCert()
{
	global $dbintf, $msg;
	
	$baseName = uniqid($dbintf->actuinfo['id'], true);
	
	$certFile = CERTDIR. $baseName . '.crt';
  $certKey = CERTDIR . $baseName . '.key';

	if(isset($_POST['CertTimeValid'])) $daysValid = intval($_POST['CertTimeValid']);
	else $daysValid = 365;

  $config = TransformWebCertConfig($_POST);
	$cert = SelfSignCertificate($config, $daysValid);
	
	ExportKeyToFile($cert["key"], $certKey);
	ExportCertToFile($cert["cert"], $certFile);
	
	$expireDate = time() + 1 * 60 * 60 * 24 * $daysValid;
				
	$toDB = array(
					'name' => $_POST['Name'],
					'subject' => $config["distinguishedName"]['commonName'],
					'valid_to' => $expireDate,
					'privatekey' => 1,
					'trusted' => 0,
					'cert_location' => $baseName . '.crt',
					'key_location' => $baseName . '.key'
				);
				
	$id = $dbintf->InsertCertificate($toDB);
	
	if($id === false)
	{
		throw new Exception("Could not insert certificate into database");
  }
  
	msg_signal_service($msg, "pkeypermissions root " . $toDB['key_location']);
	
	return $id;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {

    if ($act=='makecert')
    {	
			try 
			{
				$id = MakeCert();
				LogAction('Create self-signed certificate', array('name'=>$_POST['Name'], 'id'=>$id));
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'certificate.php?id=' . $id);
				exit;	
			} 
			catch (Exception $ex) 
			{
        $msg[] = new Msg(MSG_ERR, $ex->getMessage());
        $_SESSION['msg'] = $msg;
        header('Location: '.$rooturl.'makecert.php');
        exit;
			}		
    }
  }

	LogAction("View certificate creation page.",array('level'=>'view'));

  // ready with database
  $dbintf->close();
	
	$data = "var certreq = 0;\r\n";
	$data .= "var eckey=" . (PHP_VERSION_ID > 70100 ? 1 : 0) . ";\r\n";
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/makecert.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
	$rpl['title'] = $lng->Get('Crypt.CreateCert');
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
