<?php
require_once('general.php');
require_once('certificates_general.php');

HandlePage($dbintf);

function MakeCertRequest()
{
	global $dbintf, $msg;

	$baseName = uniqid($dbintf->actuinfo['id'], true);
			
	$certFile = CERTDIR . $baseName . '.csr';
	$certKey = CERTDIR . $baseName . '.key';
  
  $configs = TransformWebCertConfig($_POST);
	$csr = CreateCsr($configs);

	ExportCsrToFile($csr["csr"], $certFile);
	ExportKeyToFile($csr["key"], $certKey);
	
	$toDB = array(
					'name' => $_POST['Name'],
					'subject' => $configs["distinguishedName"]['commonName'],
					'request_location' => $baseName . '.csr',
					'key_location' => $baseName . '.key'
				);
	
	$id = $dbintf->InsertCertificateRequest($toDB);
	
	if($id === false)
	{
		throw new Exception("Could not store certificate in database");
	}
	
	msg_signal_service($msg, "pkeypermissions root " . $toDB['key_location']);

	return $id;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='makecert')
    {	
			try 
			{
				$id = MakeCertRequest();
				LogAction('Create a certificate signing request', array('name'=>$_POST['Name'], 'id'=>$id));
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'certificaterequest.php?id=' . $id);
				exit;
			} 
			catch(Exception $ex)
			{
        $msg[] = new Msg(MSG_ERR, $ex->getMessage());
        $_SESSION['msg'] = $msg;
        header('Location: '.$rooturl.'makecert.php');
        exit;
			}
    }
  }

	LogAction("View certificate signing request creation page.",array('level'=>'view'));

  // ready with database
  $dbintf->close();
	
	$data = "var certreq = 1;\r\n";
	$data .= "var eckey=" . (PHP_VERSION_ID > 70100 ? 1 : 0) . ";\r\n";
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/makecert.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
	$rpl['title'] = $lng->Get('Crypt.CreateSigningRequest');
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
