<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {
  	$dst = '';
		if ($act=='edit')
  	{
      LogAction('Edit external phones list');
			$dst = 'mobile_devices.php';
			
      $newCfg = array();
      $newCfg['MobileDevicesLinkGroup'] = (int) $_POST['group'];
      $newCfg['MobileDevicesLinkProp'] = $_POST['prop'];
      $dbintf->SetConfigsPart( $newCfg , 's' );
      
      if ($newCfg['MobileDevicesLinkGroup'] != -1)
      {
        $mobs = array();
        $groupid = (int) $newCfg['MobileDevicesLinkGroup'];
        $group = $dbintf->GetGroupInfo( $groupid );
        $prop = $newCfg['MobileDevicesLinkProp'];
        $phones = array();
        $OnlyEnabled = false;
        if ( $prop == 'phones')
        {
          $phones = $dbintf->GetGroupAllNumbers( $group['accid'] , $OnlyEnabled );
        }
        if ( $prop == 'name')
        {
          $phones = $dbintf->GetGroupAllProp( $group['accid'] , $OnlyEnabled , $prop );
        }
        foreach ($phones as $phone)
        {
          $obj = array();
          $obj['imei'] = '';
          $obj['phonenum'] = $phone;
          $mobs[] = $obj;
        }
      } else
      {
        $lines = $_POST['content'];
        $lines = explode("\n",$lines);
        
        $mobs = array();
        foreach ($lines as $line)
        {
          $obj = array();
          $imeiInput = '';
          $obj['imei']  = '';
          $obj['phonenum'] = '';
          $parts = explode(",", $line);
          if (count($parts)==2)
          {
            $imeiInput = $parts[1];
            $obj['phonenum'] = $parts[0];
          } else if (count($parts)==1)
          {
            $obj['phonenum'] = $parts[0];
          } else
          {
            $msg[] =  new Msg(MSG_WRN,'Skipped line '.$line);
            continue;
          }
          $obj['imei'] = trim( $imeiInput );
          if ($obj['phonenum']=='' && $obj['imei']=='')
          {
            continue;
          }
          $obj['imei'] = extractDigits( $obj['imei'] );
          $imeiLen = strlen( $obj['imei'] );
          if ($imeiLen==0 // no IMEI specified
          || $imeiLen==14 // basic
          || $imeiLen==15 // + check digit
          || $imeiLen==16) // + software rev.
          {
            // OK
          } else
          {
            $msg[] =  new Msg(MSG_WRN,'Invalid IMEI: '.$imeiInput);
            continue;
          }
          $obj['phonenum'] = trim( $obj['phonenum'] );
          $mobs[] = $obj;
        }
      }
			
			//System.MoreChanThanLics
			//echo count($mobs); 
			$moblic = int_ensure_defined( $dbintf->GetConfigValue('MobileChCnt') );
			if ( count($mobs) > $moblic )
			{
				$msg[] =  new Msg(MSG_WRN,"Only the first ".$moblic." entries will be used");
			}
			//echo "<pre>";
			//var_dump($mobs);
			
			if ($dbintf->SetMobileDevices($mobs)==false)
			{
			} else
			{
				$msg[] =  new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));
			}
		}
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.$dst);
    exit;
  }
	
	LogAction("View external phones list",array('level'=>'view'));

	$mobs = $dbintf->GetMobileDevices();
	//var_dump($mobs);
	$data = '';
	$data .= 'var mobs = [' . "\n";
	$first = true;
	foreach ($mobs as $mob)
	{
		if (!$first) $data .= ',';
		$first = false;
		$data .= '{ imei: "'.JsQuote($mob['imei']).'"';
		$data .= ', phonenum: "'.JsQuote($mob['phonenum']).'"';
		$data .= '}' . "\n";
	}
	$data .= "];\n";
  
  $group_list = $dbintf->GetGroupList();
  $data .= "var groups=[];\r\n";
  foreach ($group_list as $group)
  {
    $data .= "groups[" . $group['id'] . "]= " .
        '{name:"' . JSQuote($group['name']) . '"' .
        "};\r\n";
  }
  
  $cfgKeys = array('MobileDevicesLinkGroup','MobileDevicesLinkProp');
  foreach ($cfgKeys as $cfgKey)
  {
    $data .= 'var ' . $cfgKey . ' = ' . json_encode( $dbintf->GetConfigValue($cfgKey) ) . ';' . "\r\n";
  }
  
	//echo $data;
	//exit;
	
  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/mobile_devices.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function extractDigits($t)
{
	$len = strlen( $t );
	$num = '';
	for ($i=0;$i<$len;$i++)
	{
		if (ctype_digit($t[$i]))
		{
			$num .= $t[$i];
		}
	}
	return $num;
}

?>