<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN) )==0)
  {
    echo 'Permission denied';
    exit;
  }

  $act = $_POST['act'];
  if ($act!='')
  {
		$changed = false;
		$datafields = array( 'name' , 'pubkey'
      , 'impacalls' , 'exprecconf', 'undouble', 'compare' );
		$authobj = array();
		$ok = true;
    $spinRestart = false;
		if ($act=='add' || $act=='edit')
		{
			foreach ($datafields as $key)
			{
				if (isset($_POST[$key]))
				{
					$authobj[$key] = $_POST[$key];
				}
			}
			
			$pubkey = $authobj['pubkey'];
			if ($ok && $pubkey=='')
			{
				$msg[] = new Msg(MSG_ERR,'Public key is empty');
				$ok = false;
			}
			if ($ok && substr($pubkey,0,7)!='ssh-rsa')
			{
				$msg[] = new Msg(MSG_ERR,'Public key is invalid. It should start with ssh-rsa');
				$ok = false;
			}
		}
		if ($act=='add' && $ok)
		{
			LogAction("Add Apresa import server", array('name'=>$authobj['name']) );
			$changed = true;
			if ($dbintf->AddAuthKey($authobj)==false)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			}
		}
		if ($act=='edit' && $ok)
		{
      $authkeys = $dbintf->GetAuthKeys();
			$changed = true;
			$id = (int) $_POST['id'];
      foreach ($authkeys as $authkey)
      {
        if ($authkey['id']==$id)
        {
          LogAction("Edit Apresa import server", array('name'=>$authkey['name']) );
        }
      }
			if ($dbintf->EditAuthKey($id,$authobj)==false)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			}
		}
		if ($act=='del')
		{
      $authkeys = $dbintf->GetAuthKeys();
			LogAction("Delete apresa server to export recordings.");
			$changed = true;
      $authkeys = $dbintf->GetAuthKeys();
			$ids = explode(',',$_POST['del-ids']);
      foreach ($ids as $id)
      {
        foreach ($authkeys as $authkey)
        {
          if ($authkey['id']==$id)
          {
            LogAction("Delete Apresa import server", array('name'=>$authkey['name']) );
          }
        }
        if ($dbintf->DelAuthKey($id)==false)
        {
          $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
        }
      }
		}
    if ($act=='set')
    {
      $certid = (int) $_POST['SpinServerCert'];
      $id = $dbintf->GetCertificateFor('spin-server');
      if($id === false) $id = -1;
      if ($id != $certid) 
      {
        $spinRestart = true;
      }
      if($certid > 0)
      {
        $set = $dbintf->SetCertificateUse('spin-server', $certid);
      }
      else
      {
        $dbintf->DeleteCertificateUse('spin-server');
      }
    }
		
		if ($changed)
		{
			// signal handler writes out the keys
			msg_signal_service($msg,'allowpush');
      $spinRestart = true;
		}
    
    // Something has changed.
    // So determine of we need to run spin-server or not
    $OldSpinServer = (int) $dbintf->GetConfigValue('SpinServer');
    $SpinServer = false;
    $authkeys = $dbintf->GetAuthKeys();
    foreach ($authkeys as $authobj)
    {
      // check the spin options
      if ($authobj['impacalls']!=0) $SpinServer = true;
      if ($authobj['exprecconf']!=0) $SpinServer = true;
    }
    $SpinServer = $SpinServer?1:0;
    if ($SpinServer != $OldSpinServer)
    {
      $dbintf->SetConfigsPart( array('SpinServer'=>(''.$SpinServer) ) , 's');
      msg_signal_service($msg,'spin apply');
    } else if ( int_ensure_defined($_POST['restartSpin']) == 1)
    {
      msg_signal_service($msg,'spin stop server');
    }

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'multisub.php');
  }

	LogAction("View list Apresa import servers",array('level'=>'view'));
	
	$data = '';
	
	$authkeys = $dbintf->GetAuthKeys();
	$data .= 'var authkeys = [';
	$first = true;
	foreach ($authkeys as $authobj)
	{
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ id: "' . $authobj['id'] . '"';
		$data .= ', name: "' . JsQuote($authobj['name']) . '"';
		$data .= ', pubkey: "' . JsQuote($authobj['pubkey']) . '"';
		$data .= ', impacalls: ' . (int)$authobj['impacalls'];
    $data .= ', exprecconf: ' . (int)$authobj['exprecconf'];
    $data .= ', undouble: ' . (int)$authobj['undouble'];
    if ($authobj['compare']===null) $authobj['compare'] = 3; // default
    $data .= ', compare: ' . (int)$authobj['compare'];
		$data .= "}\n";
	}
	$data .= "];\n";	

	$certificates = $dbintf->GetCertificatesWithPrivateKey();
	
	$certdata = "var certificates = [\r\n";
	$certdata .= "{ id: -1, name: " . '"' . $lng->Get('Main.None') . '"' . "},";
	
	$ix = 1;
	foreach($certificates as $cert)
	{
		$certdata .= "\r\n{ id: " . $cert['id']  . ", name: " . '"' . JSQuote($cert['name']) . " (" .  JSQuote($cert['subject']) . ")"  . '"' . "},";
		$ix++;
	}
	
	$certdata .= "\r\n];\r\n";
  
  $data .= $certdata;
	
	$id = $dbintf->GetCertificateFor('spin-server');
	if($id === false) $id = -1;
  $data .= "var SpinServerCertId = ". (int) $id . ";\r\n"; 
  $data .= "var cfgSpinServer = ". (int) $dbintf->GetConfigValue('SpinServer') . ";\r\n"; 
  
  // ready with database
  $dbintf->close();


  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/multisub.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
