<?php

require_once('general.php');
require_once('update-gen.php');

HandlePage($dbintf);

function IsSecondNewer($v1,$v2)
{
	if ($v2==null) return false;
  if (version_compare($v1,$v2)==-1) return true;
  else return false;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	$updatePeriod = GetUpdatePeriod();
  $active_cnt = $dbintf->GetActiveCallsCount();

  $update_descr = '';
  $update_url = '';

  $act = $_POST['act'];
  if ($act!='')
  {
		if ($updatePeriod->updating==false)
		{
			echo "The update period has expired";
			exit;
		}
    if ($act=='update')
    {
			LogAction('Update using internet');
			ClearSessionVars();

      $updateurl = $_POST['url'];
      $upd_time = $_POST['UpdTime'];
      if ($active_cnt>0 && $_POST['confirmed']!='1' && $upd_time=='now')
      {
        $msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceUpdate'));
        $_SESSION['msg'] = $msg;
        header('Location: '.$rooturl.'oupdate.php');
        exit;
      }

      $downloadh = @fopen($updateurl,"rb");
      if ($downloadh===false)
      {
        $msg[] = new Msg(MSG_ERR,'Could not download from update server.');
      } else {
        $upd_dest = sys_get_temp_dir().'/'.basename($updateurl);
        $localh = @fopen($upd_dest,'w');
        if ($localh===false)
        {
          $msg[] = new Msg(MSG_ERR,'Could open local update file '.$upd_dest);
        } else
        {
          while (!feof($downloadh))
          {
            // blocks of 10 K
            fwrite($localh,fread($downloadh,1024*10));
          }
          fclose($downloadh);
          fclose($localh);

					if ( ! $dbintf->nodePassive )
					{
						// save in database
						$dbintf->SetConfigsPart(array('UpdUpl'=>$upd_dest,'UpdTime'=>$upd_time),'s');
					}
          // signal
          if (msg_signal_service($msg,'su'))
          {
            if ($upd_time=='now')
            {
              //$msg[] = new Msg(MSG_INF,$lng->Get('System.Updating'));
							sleep(1);
            } else
            {
              $msg[] = new Msg(MSG_INF,$lng->Get('Main.OK'));
            }
          }
        }
      }
    }
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'systools.php');
    exit;
  } else {

      $online_version = null;

      // checking for update
      //$msg[] = new Msg(MSG_INF,'Check for update');
      $url = 'http://www.vidicode.com/softwupd/apresa.ini';
      // test $url = 'C:\Sources\Projecten\General\Programs\vcMakeUpdate\update\crpico.ini';
      $upd_ini = @parse_ini($url);
      if ($upd_ini===false)
      {
        $msg[] = new Msg(MSG_ERR,'Could not connect to update server.');
      } else
      {
        $update_url = $upd_ini['File0']['Source'];
        $descr_cnt = $upd_ini['Section0']['DescriptionCount'];
        for ($descr_i=0;$descr_i<$descr_cnt;$descr_i++)
        {
          $update_descr .= $upd_ini['Section0']['Description'.$descr_i]."\r\n";
        }
        $online_version = $upd_ini['General']['LatestVersion'];
      }
  }

	if ($updatePeriod->updating==false)
	{
		$msg[] = new Msg(MSG_ERR,"The update period has expired");
	}
	
	LogAction("Check for software update",array('level'=>'view'));

  // ready with database
  $dbintf->close();

  // test
  //$online_version = '1.1';

  $have_update = IsSecondNewer(APRESA_VERSION,$online_version);
  if ($have_update)
  {
    $updmsg = $lng->Get('System.UpdateAvail');
    $updmsg = sprintf($updmsg,APRESA_VERSION,$online_version);
  } else
  {
    $updmsg = $lng->Get('System.NoUpdate');
  }
	

  $data = "";
  $data .= "var active_cnt = $active_cnt; \r\n";
  $data .= GeneralJSData();
  $data .= 'var update_descr = "'.JSQuote($update_descr).'";';
  $data .= 'var newv = "'.$online_version.'";';
  $data .= 'var curv = "' . APRESA_VERSION . '";';
  $data .= 'var updmsg = "' . $updmsg . '";';
  $data .= 'var haveupd = '.($have_update?1:0).';';
  $data .= 'var updateurl = "'.JSQuote($update_url).'";';
	$data .= "var mayUpdate = " . (int) ($updatePeriod->updating?1:0) . ";\r\n";
	$data .= "var updatesUntil = \"" . JSQuote($updatePeriod->updatesUntilStr) . "\";\r\n";

  $template_content = file_get_contents('../apresa/templ/oupdate.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
