/* Export and import from/to a network drive or a local drive or directory.
   Functions that implement the GUI for configuring this.
*/

// constructor
function ExpImp()
{
  this.disabled = false;
}


ExpImp.prototype.domReady = function(cfg)
{
  this.cfg = cfg;
  
  // show current config
  Dom.get('BckTargetType').selectedIndex = cfg.BckTargetType;
  Dom.get('BckPath').value = cfg.BckPath;
  var foundDisk = false;
  var diskElem = Dom.get('BckDisk');
  for (var ix in Disks)
  {
    var t = HtmlQuote( Disks[ix] );
    var opt = document.createElement('option');
    opt.innerHTML = t;
    if (Disks[ix]==cfg.BckDisk)
    {
      opt.setAttribute('selected','true');
      foundDisk = true;
    }
    diskElem.appendChild(opt);
  }
  if (foundDisk==false && ! (typeof(cfg.BckDisk)=='undefined' || cfg.BckDisk=='') )
  {
    var t = HtmlQuote( cfg.BckDisk + " ("+this.txtError+")" );
    var opt = document.createElement('option');
    opt.innerHTML = t;
    opt.setAttribute('selected','true');
    diskElem.appendChild(opt);
  }
  Dom.get('WinDomain').value = cfg.WinDomain;
  Dom.get('WinUsr').value = cfg.WinUsr;
  if (cfg.HasWinPwd)
  {
    Dom.get('WinPwd').value = 'xxxxxxxxxx';
  } else {
    Dom.get('DefPwd').checked = true;
  }
  if (cfg.HasWinPwd==0)
  {
    Dom.get('DefPwd').style.display = 'none'
    Dom.get('DefPwdLbl').style.display = 'none'
  }
  Dom.get('BckServer').value = cfg.BckServer;
  Dom.get('BckShare').value = cfg.BckShare;
  Dom.get('BckSubdir').value = cfg.BckSubdir;
  Dom.get('BckDiskSubdir').value = cfg.BckSubdir;
        
  // browse to select server and domain name
  this.oServerBrowseBtn = new YAHOO.widget.Button('ServerBrowseBtn');
  // 3rd param is the argument to the function OnServerBrowse
  // 4th param (this) is the context (the this) in the function,
  //   if not specified it would be the button
  this.oServerBrowseBtn.on('click',this.OnServerBrowse,null,this);

  // choose network share name
  this.oShareBrowseBtn = new YAHOO.widget.Button('ShareBrowseBtn');
  this.oShareBrowseBtn.on('click',this.OnShareBrowse,null,this);

  // choose subdir on network share
  this.oSubdirBrowseBtn = new YAHOO.widget.Button('SubdirBrowseBtn');
  this.oSubdirBrowseBtn.on('click',this.OnSubdirBrowse,null,this);

  // choose subdir on local disk
  this.oDiskSubdirBrowseBtn = new YAHOO.widget.Button('DiskSubdirBrowseBtn');
  this.oDiskSubdirBrowseBtn.on('click',this.OnDiskSubdirBrowse,null,this);
  
  Event.on('BckTargetType','change',this.OtherTargetType);
  this.OtherTargetType();
  
}

ExpImp.prototype.OtherTargetType = function()
{
  var listInt = Dom.getElementsByClassName('tgint',null,'settingstable');
  var listNetw = Dom.getElementsByClassName('tgnetw',null,'settingstable');
  var listDisk = Dom.getElementsByClassName('tgdisk',null,'settingstable');
  var listMountWarn = Dom.getElementsByClassName('mountwarn',null,'settingstable');
  var BckTargetType = Dom.get('BckTargetType').selectedIndex;
  if (BckTargetType==0)
  {
    Dom.addClass(listInt,'invis');
    Dom.addClass(listDisk,'invis');
    Dom.removeClass(listNetw,'invis');
  } else if (BckTargetType==3)
  {
    Dom.addClass(listInt,'invis');
    Dom.addClass(listNetw,'invis');
    Dom.removeClass(listDisk,'invis');
  } else 
  {
    Dom.addClass(listNetw,'invis');
    Dom.addClass(listDisk,'invis');
    Dom.removeClass(listInt,'invis');
  }
  if (BckTargetType==2)
  {
    Dom.removeClass(listMountWarn,'invis');
  } else
  {
    Dom.addClass(listMountWarn,'invis');
  }

}

ExpImp.prototype.ParseInput = function()
{
  var result = {};
  var data = [];
  result.data = data;
  result.err = false;
  // remove previous error masks
  var prev_errs = Dom.getElementsByClassName('err',null,'settingstable');
  Dom.removeClass(prev_errs,'err');
  // parse and check
  var BckSubdir = '';
  BckTargetType = Dom.get('BckTargetType').selectedIndex;
  if (BckTargetType==0)
  {
    WinDomain = Dom.get('WinDomain').value;
    WinUsr = Dom.get('WinUsr').value;
    var WinPwd = Dom.get('WinPwd').value;
    BckServer = Dom.get('BckServer').value;
    if (BckServer=='')
    {
      result.err = true;
      Dom.addClass('BckServer','err');
    }
    BckShare = Dom.get('BckShare').value;
    if (BckShare=='')
    {
      result.err = true;
      Dom.addClass('BckShare','err');
    }
    BckSubdir = Dom.get('BckSubdir').value;
  } else if (BckTargetType==3)
  {
    BckSubdir = Dom.get('BckDiskSubdir').value;
    BckDisk = Dom.get('BckDisk').value;
    if (BckDisk=='') {
      result.err = true;
    }
  } else
  {
    BckPath = Dom.get('BckPath').value;
    if (BckPath=='') {
      result.err = true;
      Dom.addClass('BckPath','err');
    }
  }
  // automatically replace \ by / to prevent problems
  BckSubdir = BckSubdir.replace(/\\/g,'/');

  if (result.err) return result;

  result.data['BckTargetType'] = BckTargetType;
  if (BckTargetType==0)
  {
    result.data['WinDomain'] = WinDomain;
    result.data['WinUsr'] = WinUsr;
    if (Dom.get('DefPwd').checked)
    {
      result.data['WinPwd'] = WinPwd;
    }
    result.data['BckServer'] = BckServer;
    result.data['BckShare'] = BckShare;
    result.data['BckSubdir'] = BckSubdir;
  } else if (BckTargetType==3)
  {
    result.data['BckSubdir'] = BckSubdir;
    result.data['BckDisk'] = BckDisk;
  } else
  {
    result.data['BckPath'] = BckPath;
  }
  
  return result;
}

ExpImp.prototype.EnableTextbox = function(id)
{
    Dom.get(id).removeAttribute('readOnly');
    //Dom.get(id).disabled = false;
    Dom.removeClass(id,'disabled');
}
  
ExpImp.prototype.DisableTextbox = function(id)
{
    //Dom.get(id).disabled = true;
    Dom.get(id).setAttribute('readOnly','true');
    Dom.addClass(id,'disabled');
}
  
ExpImp.prototype.EnabledCalc = function()
{
  if (this.disabled==false)
  {
    if (Dom.get('DefPwd').checked==false)
    {
      this.DisableTextbox('WinPwd');
      if (this.cfg.HasWinPwd)
      {
        Dom.get('WinPwd').value = 'xxxxxxxxxx';
      } else
      {
        Dom.get('WinPwd').value = '';
      }
    } else {
      if (Dom.get('WinPwd').readOnly)
      {
        this.EnableTextbox('WinPwd');
        Dom.get('WinPwd').value = '';
      }
    }  
  } else
  {
    Dom.get('BckTargetType').disabled = true;
    this.DisableTextbox('BckPath');
    Dom.get('BckDisk').disabled = true;
    this.DisableTextbox('BckDiskSubdir');
    this.DisableTextbox('WinDomain');
    this.DisableTextbox('WinUsr');
    this.DisableTextbox('WinPwd');
    this.DisableTextbox('BckServer');
    this.DisableTextbox('BckShare');
    this.DisableTextbox('BckSubdir');
    this.oShareBrowseBtn.set('disabled',true);
    this.oSubdirBrowseBtn.set('disabled',true);
    this.oServerBrowseBtn.set('disabled',true);  
    this.oDiskSubdirBrowseBtn.set('disabled',true);
  }
}

// Begin block server dialog

ExpImp.prototype.DialogServerOK = function()
{
  var selrows = this.ServerTable.getSelectedRows();
  if (selrows.length!=0) {
    Dom.get('BckServer').value = this.ServerTable.getRecord(selrows[0]).getData("name");
    Dom.get('WinDomain').value = this.ServerTable.getRecord(selrows[0]).getData("domain");
  }
  return true;
}

ExpImp.prototype.EnsureDialogServer = function()
{
  var expimp = this;
  if (this.dialog_server==null)
  {
      function okHandler(){
        if (expimp.DialogServerOK())
        {
          this.hide();
        }
      }
      function closeHandler(){
        this.hide();
      }
      this.dialog_server = new YAHOO.widget.Dialog("dialog_server",
              { modal: true,
                visible : false,
                constraintoviewport : true,
                context:['ServerBrowseBtn', "tl", "bl"],
                buttons : [ { text:this.txtOk, handler:okHandler, isDefault:true },
                      { text:this.txtCancel,handler:closeHandler } ]
              });
      this.dialog_server.render();

      this.ServerDataSource = new YAHOO.util.DataSource("getservers.php");
      this.ServerDataSource.connMethodPost = true;
      this.ServerDataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
      this.ServerDataSource.responseSchema = {
        resultsList: "data"
      };
  }

  function DblClick()
  {
    if (expimp.DialogServerOK())
    {
      expimp.dialog_server.hide();
    }
  }
  if (this.ServerTable==null)
  {
    var oConfigs = {
      selectionMode:"single"
      , MSG_EMPTY : this.txtNoRecs
      , height : "15em"
      , initialRequest : ''
    };

    var thecols = [
      {key:"name",label:this.txtName}
    ];
    this.ServerTable = new YAHOO.widget.ScrollingDataTable("server_list",
            thecols, this.ServerDataSource, oConfigs);
    this.ServerTable.subscribe("rowClickEvent", this.ServerTable.onEventSelectRow);
    this.ServerTable.subscribe("rowDblclickEvent", DblClick);
  }
}

ExpImp.prototype.OnServerBrowse = function()
{
  this.EnsureDialogServer();
  this.dialog_server.show();
}

// End block server dialog
// Begin block share dialog

ExpImp.prototype.DialogShareOK = function()
{
  var selrows = this.SharesTable.getSelectedRows();
  if (selrows.length!=0) {
    Dom.get('BckShare').value = this.SharesTable.getRecord(selrows[0]).getData("name");
  }
  return true;
}

ExpImp.prototype.GetSharesRequest = function()
{
  var req = 'svr=' + encodeURIComponent(Dom.get('BckServer').value)
  + '&domain=' + encodeURIComponent(Dom.get('WinDomain').value)
  + '&usr=' + encodeURIComponent(Dom.get('WinUsr').value);
  if (Dom.get('DefPwd').checked)
  {
    req = req + '&pwd=' + encodeURIComponent(Dom.get('WinPwd').value);
  } else
  {
    req += '&cfgpwd=AranaWinPwd';
  }
  req += "&SessionToken=" + encodeURIComponent(SessionToken);
  return req;
}

ExpImp.prototype.EnsureDialogShare = function()
{
  var expimp = this;
  if (this.SharesTable!=null)
  {
    this.SharesTable.destroy();
    this.SharesTable = null;
  }
  if (this.dialog_share==null)
  {
      function okHandler(){
        if (expimp.DialogShareOK())
        {
          this.hide();
        }
      }
      function closeHandler(){
        this.hide();
      }
      this.dialog_share = new YAHOO.widget.Dialog("dialog_share",
              { modal: true,
                visible : false,
                constraintoviewport : true,
                context:['ShareBrowseBtn', "tl", "bl"],
                buttons : [ { text:this.txtOk, handler:okHandler, isDefault:true },
                      { text:this.txtCancel,handler:closeHandler } ]
              });
      this.dialog_share.render();

      this.SharesDataSource = new YAHOO.util.DataSource("getshares.php");
      this.SharesDataSource.connMethodPost = true;
      this.SharesDataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
      this.SharesDataSource.responseSchema = {
        resultsList: "data"
      , metaFields : { errtext : 'errtext' }
      };
      this.SharesDataSource.subscribe('responseParseEvent',function(e)
      {
        if (typeof(e.response.meta.errtext)!='undefined'
        && e.response.meta.errtext!='')
        {
          alert(e.response.meta.errtext);
        }
      });
  }
  if (this.SharesTable==null)
  {
      function DblClick()
      {
        if (expimp.DialogShareOK())
        {
          expimp.dialog_share.hide();
        }
      }

      var oConfigs = {
        selectionMode:"single"
        , MSG_EMPTY : this.txtNoRecs
        , height : "15em"
        , initialRequest : this.GetSharesRequest()
      };

      var thecols = [
        {key:"name",label:this.txtName }
        ,{key:"descr",label:this.txtDescr }
      ];
      this.SharesTable = new YAHOO.widget.ScrollingDataTable("share_list",
              thecols, this.SharesDataSource, oConfigs);
      this.SharesTable.subscribe("rowClickEvent", this.SharesTable.onEventSelectRow);
      this.SharesTable.subscribe("rowDblclickEvent", DblClick);

  }
}

ExpImp.prototype.OnShareBrowse = function()
{
  this.EnsureDialogShare();
  this.dialog_share.show();
}

// End block share
// Begin block subdir

ExpImp.prototype.DialogSubdirOK = function()
{
  var selrows = this.SubdirTable.getSelectedRows();
  var target = 'BckSubdir';
  if (this.disk_subdir_dialog) target = 'BckDiskSubdir';
  if (selrows.length!=0) {
    Dom.get(target).value = this.SubdirTable.getRecord(selrows[0]).getData("name");
  }
  return true;
}

ExpImp.prototype.GetSubdirRequest = function()
{
  var req;
  if (this.disk_subdir_dialog)
  {
    req = 'srctype=3'
    + '&disk=' + escape(Dom.get('BckDisk').value)
    + '&type=D';
  } else
  {
    req = 'svr=' + escape(Dom.get('BckServer').value)
    + '&domain=' + escape(Dom.get('WinDomain').value)
    + '&share=' + escape(Dom.get('BckShare').value)
    + '&usr=' + escape(Dom.get('WinUsr').value)
    + '&type=D';
    if (Dom.get('DefPwd').checked)
    {
      req = req + '&pwd=' + Dom.get('WinPwd').value;
    } else
    {
      req += '&cfgpwd=AranaWinPwd';
    }
  }
  req += "&SessionToken=" + SessionToken;
  return req;
}

ExpImp.prototype.EnsureDialogSubdir = function()
{
  var expimp = this;
  if (this.SubdirTable!=null)
  {
    this.SubdirTable.destroy();
    this.SubdirTable = null;
  }
  if (this.dialog_subdir==null)
  {
      function okHandler(){
        if (expimp.DialogSubdirOK())
        {
          this.hide();
        }
      }
      function closeHandler(){
        this.hide();
      }
      var ctid = 'SubdirBrowseBtn';
      if (this.disk_subdir_dialog)
      {
        ctid = 'DiskSubdirBrowseBtn';
      }
      this.dialog_subdir = new YAHOO.widget.Dialog("dialog_subdir",
              { modal: true,
                visible : false,
                constraintoviewport : true,
                context:[ctid, "tl", "bl"],
                buttons : [ { text:this.txtOk, handler:okHandler, isDefault:true },
                      { text:this.txtCancel,handler:closeHandler } ]
              });
      this.dialog_subdir.render();

      this.SubdirDataSource = new YAHOO.util.DataSource("getdirs.php");
      this.SubdirDataSource.connMethodPost = true;
      this.SubdirDataSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
      this.SubdirDataSource.responseSchema = {
        resultsList: "data"
      , metaFields : { errtext : 'errtext' }
      };
      this.SubdirDataSource.subscribe('responseParseEvent',function(e)
      {
        if (typeof(e.response.meta.errtext)!='undefined'
        && e.response.meta.errtext!='')
        {
          alert(e.response.meta.errtext);
        }
      });
  }

  function DblClick()
  {
    if (expimp.DialogSubdirOK())
    {
      expimp.dialog_subdir.hide();
    }
  }
  if (this.SubdirTable==null)
  {
    var oConfigs = {
      selectionMode:"single"
      , MSG_EMPTY : this.txtNoRecs
      , height : "15em"
      , initialRequest : this.GetSubdirRequest()
    };

    var thecols = [
      {key:"name",label:this.txtName}
    ];
    this.SubdirTable = new YAHOO.widget.ScrollingDataTable("subdir_list",
            thecols, this.SubdirDataSource, oConfigs);
    this.SubdirTable.subscribe("rowClickEvent", this.SubdirTable.onEventSelectRow);
    this.SubdirTable.subscribe("rowDblclickEvent", DblClick);
  }
}

ExpImp.prototype.OnSubdirBrowse = function()
{
  this.disk_subdir_dialog = false;
  this.EnsureDialogSubdir();
  this.dialog_subdir.show();
}

ExpImp.prototype.OnDiskSubdirBrowse = function()
{
  this.disk_subdir_dialog = true;
  this.EnsureDialogSubdir();
  this.dialog_subdir.show();
}

// end block subdir
