<?php

require_once('general.php');
require_once('cedb.php');
require_once('annotate.php');

HandlePagePlay($dbintf);

function HandlePagePlay($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s,$lng;

	$callinfo = false;
	if (isset($_GET['id']))
	{
		$callinfo = $dbintf->GetCallInfo( $_GET['id'] );
	}
	if (isset($_GET['rem']))
	{
		$callinfo = $dbintf->GetCallInfoRM( $_GET['rem'] );
		if ($callinfo!==false)
		{
			$callinfo['permissions'] = $dbintf->GetCallPermissions($callinfo);
		}
	}
	
	if ($callinfo===false)
	{
    echo 'Call not found';
    exit;
	}

	if (($callinfo['permissions'] & PM_LIST)==0)
	{
    echo 'Permission denied';
    exit;
	}

  LogAction('View play recording'
    ,array('level'=>'view'
      , 'call_id' => $callinfo['id']
      )
  );
	
	$markersdb = $dbintf->GetAnnotations( $callinfo['id'] );
	$markers = array();
	foreach ($markersdb as $markerdb)
	{
		$toload = array( 'call_id', 'label', 'timepos', 'descr', 'createdby' );
		$marker = array();
		foreach ($toload as $field)
		{
			$marker[$field] = $markerdb[$field];
		}
		$markers[$markerdb['id']] = $marker;
	}
	$callinfo['markers'] = $markers;

	$data = '';
	
	//echo '<pre>'; var_dump( $callinfo );exit;
	$row = $callinfo;
	$calldata = array(); 
	$unmodified = array('id','filename','direction','notes','markers'
	,'remote','local'
	,'flags','waittime');
	foreach ($unmodified as $key)
	{
		$calldata[$key] = $row[$key];
	}
	$calldata['length'] = $row['duration'];
	$calldata['startdate'] = date($configs['datetimef'],$row['startdate']);
	$calldata['arch'] = $row['isarchived'];
	$calldata['pm'] = $row['permissions'];
	$data .= "var calldata = \n" . json_encode( $calldata, JSON_FORCE_OBJECT ) . ";\n";


  // ready with database
  $dbintf->close();
  $dbintf = null;

  $data .= 'var embedPlayer = ' . ($configs['EmbedPlayer']?'true':'false') . ';' . "\r\n";
	$data .= 'var audio5 = ' . ($configs['Audio5']?'true':'false') . ';' . "\r\n";

  $data .= GeneralJSData();
	
	//echo '<pre>'; echo $data; exit;

  $template_content = file_get_contents('../apresa/templ/play.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['cejsgen'] = file_get_contents('../apresa/templ/cejsgen.js');
  $rpl['ceblock'] = file_get_contents('../apresa/templ/ceblock.htm');
	$rpl['genplay_outside'] = file_get_contents('../apresa/templ/genplay_outside.js');
  $rpl['genplay_htm'] = file_get_contents('../apresa/templ/genplay.htm');
	$rpl['genlist_css'] = file_get_contents('../apresa/templ/genlist.css');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

?>
