<?php

require_once('general.php');
require_once('reportscheduling.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$configs_s, $lng;

	$haveAccess = ($dbintf->actuinfo['permissions']&PM_CONFIG) != 0;
  
  if (!$haveAccess)
  {
    echo 'Permission denied';
    exit;
  }
  
  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='add' || $act=='edit')
    {
      $fields = array( 'name', 'type', 'period', 'email', 'filter', 'output', 'directory' );
      $newdata = array();
      foreach ($fields as $field)
      {
        if (isset($_POST[$field]))
        {
          $newdata[ $field ] = $_POST[$field];
        }
      }
      if ($act=='add')
      {
        LogAction('Add a report schedule');
        $dbintf->AddReportSchedule($newdata);
      } else if ($act=='edit')
      {
        $id = (int) $_POST['id'];
        LogAction('Edit a report schedule');
        $dbintf->EditReportSchedule($id,$newdata);
      }
    }
    if ($act=='del')
    {
      $id = (int) $_POST['id'];
      LogAction('Delete a report schedule');
      $dbintf->DelReportSchedule($id);
    }
    if ($act=='run' || $act=='view')
    {
      $id = (int) $_POST['id'];
			$format = 'default';
			if (isset($_POST['format']))
			{
				$format = $_POST['format'];
			}
      LogAction('Run a report schedule');
      $reports = $dbintf->GetReportSchedules();
      foreach ($reports as $report)
      {
        if ($report['id'] == $id)
        {
          PerformReportSchedule($report,true,$act,$format);
        }
      }
    }
    
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'reportschedules.php');
		exit;
  }	
	
	LogAction('View report schedules',array('level'=>'view'));
  
  $data = '';
  $data .= GeneralJSData();
  
  $reports = $dbintf->GetReportSchedules();
  $data .= 'var reportSchedules = ' . json_encode( $reports ) . ";\r\n";

  $tninfo = array();
  $tenants = $dbintf->GetTenantList();
  foreach ($tenants as $tenant)
  {
    $tninfo[] = array('name'=>$tenant['name'],'id'=>$tenant['id']);
  }
  $data .= 'var tenants = ' . json_encode( $tninfo ) . ";\r\n";
  
  // ready with database
  $dbintf->close();

  $template_content = file_get_contents('../apresa/templ/reportschedules.htm');
  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
