<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;
	
	if ( ($dbintf->actuinfo['permissions']&PM_CONFIG)==0 )
  {
    echo 'Permission denied';
    exit;
  }
  
  $DayFields = [ 'recdays' => 'HdDaysKeep'
  , 'screenrecdays' => 'ScreenRecDaysKeep'
  , 'tradays' => 'TraDaysKeep'
  , 'bckrecdays' => 'BckRecDays'
  , 'bckscreenrecdays' => 'BckScreenRecDays'
  ];
  $ParamParts = [ 'HdDaysKeep' => 's'
  , 'ScreenRecDaysKeep' => 's'
  , 'TraDaysKeep' => 's'
  , 'BckRecDays' => 'b'
  , 'BckScreenRecDays' => 'b'
  ];
  $NoneValue = [ 'HdDaysKeep' => '-1'
  , 'ScreenRecDaysKeep' => ''
  , 'TraDaysKeep' => ''
  , 'BckRecDays' => '0'
  , 'BckScreenRecDays' => '0'
  ];

  if ($_POST['act']!='')
  {
    if ($_POST['act']=='del')
    {
      $nr = (int) $_POST['nr'];
      $dbintf->DeleteRetentionPolicy($nr);
    } else if ($_POST['act']=='add'
    || $_POST['act']=='edit')
    {
      $obj = [];
      foreach ($DayFields as $field => $dummy)
      {
        if (isset($_POST[$field]))
        {
          $days = (int) $_POST[$field];
          if ($days<=0) $days = -1;
          $obj[$field] = $days;
        }
      }
      $obj['name'] = $_POST['name'];
      $obj['nr'] = (int) $_POST['nr'];
      
      $edit_default = false;
      if ($_POST['act']=='edit')
      {
        if ($obj['nr']==0)
        {
          $edit_default = true;
        }
      }
      
      // sanity checks
      $invalid = false;
      if ($obj['nr']<1 && $edit_default==false) $invalid = true;
      if ($invalid)
      {
        $msg[] = new Msg(MSG_ERR,'Invalid data');
        $_SESSION['msg'] = $msg;
        header('Location: '.$rooturl.'retention.php');
        exit;
      }
      
      if ($_POST['act']=='add')
      {
        // add to database
        if ($dbintf->AddRetentionPolicy($obj)==false)
        {
          $msg[] = new Msg(MSG_ERR,'Failed to add');
        }
      }
      
      if ($_POST['act']=='edit')
      {
        if ($edit_default)
        {
          $newConfigs = [ 'b' => [], 's' => [] ];
          // change in Configs table
          foreach ($DayFields as $field => $param)
          {
            if (isset($obj[$field]))
            {
              $part = $ParamParts[$param];
              $value = $obj[$field];
              if ($value==-1)
              {
                $value = $NoneValue[$param];
              }
              $newConfigs[$part][ $param ] = $value;
            }
          }
          foreach ($newConfigs as $part => $newConfig)
          {
            if (count($newConfig)==0) continue;
            $dbintf->SetConfigsPart( $newConfig, $part );
          }
        } else
        {
          $dbintf->ModifyRetentionPolicy($obj);
        }
      }
      
    }

    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'retention.php');
		exit;
  }
  
  
  $data = '';
  $pols = $dbintf->GetRetentionPolicies();
  // add default policy
  $defpol = array
  ( 'nr' => 0
  , 'name' => $lng->Get('Web.Default')
  , 'recdays' => (int) $dbintf->GetConfigValue('HdDaysKeep')
  , 'screenrecdays' => (int) $dbintf->GetConfigValue('ScreenRecDaysKeep')
  , 'tradays' => (int) $dbintf->GetConfigValue('TraDaysKeep')
  , 'bckrecdays' => (int) $dbintf->GetConfigValue('BckRecDays')
  , 'bckscreenrecdays' => (int) $dbintf->GetConfigValue('BckScreenRecDays')
  );
  array_unshift($pols, $defpol);
  // use generalized way to set no value
  foreach ($pols as &$ref_pol)
  {
    foreach ($DayFields as $field => $dummy)
    {
      $value = (int) $ref_pol[$field];
      if ($value <= 0) $ref_pol[$field] = '';
    }
  }
  
  $data .= "var pols = " . json_encode($pols) . ";\n";
  $data .= "var UseCallsArchive = " . (int) $dbintf->GetConfigValue('UseCallsArchive') . ";\n";
  
  LogAction( "View retention policies" , array('level'=>'view') );

	// ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/retention.htm');

  // template replacements:
  $rpl['search_outside_js'] = file_get_contents('../apresa/templ/search_outside.js');
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}





