<?php
require_once('general.php');
require_once('statgen.php');
require_once('listinggen.php');

HandleStats($dbintf);

function HandleStats($dbintf)
{
	global $rpl,$configs,$msg,$lng;
	$data = '';
	
	if(DetermineWebclientOnly())
	{
		echo 'Permission denied';
		exit;
	}

	
	if (int_ensure_defined($configs['StatsAccess'])>0)
	{
		if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
		{
			echo 'Permission denied';
			exit;
		}
	}
	
	if(isset($_POST['act'])){
		$act = $_POST['act'];
    $redirect_url = substr($_SERVER['REQUEST_URI'],1);
		if ($act == 'empty-unrecorded'){
			if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
			{
				echo 'Permission denied';
				exit;
			}
			$dbintf->EmptyLicNotRec();
		}
    if ($act=='delquery')
    {
      if (($dbintf->actuinfo['permissions']&PM_NOTES)==0)
      {
        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
      } else {
        LogAction('Delete query');
        $dbintf->DelQuery((int) $_POST['queryid']);
      }
    }
    if ($act=='addquery')
    {
      if (($dbintf->actuinfo['permissions']&PM_NOTES)==0)
      {
        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
      } else {
        LogAction('Add query');
        $tmpHandler = new ListingHandler();
        $tmpHandler->Init();
        $qspec = array();
        foreach ($tmpHandler->search_accepted as $searchix)
        {
          if (str_ensure_defined($_POST[$searchix])!='')
          {
            $qspec[$searchix] = $_POST[$searchix];
          }
        }
        $qspec = ArrayToString($qspec);
        $dbid = $dbintf->AddQuery($_POST['queryname'],$qspec);
        $redirect_url_ref = substr($_SERVER['PHP_SELF'],1).'?savq=' . $dbid;
      }
    }
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.$redirect_url);
	}
	
  $queries = $dbintf->GetQueries();
  foreach ($queries as & $q_ref)
  {
    $q_ref['qspec_arr'] = StringToArray($q_ref['qspec']);
  }
  
	StatInit($statcfg,$search,$search_use);

  $logarr = array
      ("level"=>"view"
      ,"calllist_search"=>$search_use
      ,"calllist_config"=>array()
      );
  $cfgToLog = array('gran','type','out');
  foreach ($statcfg as $key=>$value)
  {
    if ( in_array($key,$cfgToLog) )
    {
      $logarr[$key] = $value;
    }
  }
	LogAction("View statistics", $logarr);

	if ($statcfg['type']=='ch')
	{
		$statres = $dbintf->GetLicNotRecStats($statcfg,'StatApply',$search_use);
	} else if ($statcfg['type']=='pc')
	{
		$statres = $dbintf->GetMaxSimCallsStats($statcfg,'StatApply',$search_use);
	} else	{
		// for images, do not generate yet,
		// this is done when the image is requested
		if (str_ensure_defined($statcfg['out'])=='t')
		{
			$statres = $dbintf->GetCallStats($statcfg,'StatApply',$search_use);
		}
	}
	
	$statcfg['max_entries'] = 5000;
	$statcfg['max_fraction'] = 1.01;
  StatPostProcess($statcfg,$statres);
	
	//FillStatMissing($statcfg,$statres);

	$data .= GeneralJSData();
	$data .= 'var LicNotRec = ' . ($dbintf->MayViewLicNotRec()?1:0) . ';
  ';

	$colkeys = array("playlink","flags","startdate","length","waittime","direction"
	,"category","notes","notes2","notes3","notes4","notes5"
	,"data1", "data2", "data3", "data4", "data5"
	, "rname", "remote", "remote2", "cname", "connected", "lname", "local", "local2","linenr"
	,"checksum","rem","tenant");

	$data .= 'var showcols = {';
	foreach ($colkeys as $colkey)
	{
		$data .= $colkey.': ' . int_ensure_defined($configs['col_'.$colkey]).',';
	}
	$data .= 'xyend:0};' . "\r\n";

  $recorders = $dbintf->GetRecorders();
  $data .= 'var recorders = [';
  $first = true;
  foreach ($recorders as $r)
  {
    if ($first) $first = false;
    else $data .= ', ';
    $data .= '{ id: '. $r['id']
    . ', name : "' . JSQuote($r['name']) . '" ';
    $data .= '}' . "\r\n";

  }
  $data .= '];' . "\r\n";
  
  $data .= "var NotesLabels = [];\n";
  for ($i=2;$i<=5;$i++)
  {
    $key = 'NotesLabel' . $i;
    $data .= "NotesLabels[$i] = \"" . JSQuote( str_ensure_defined($configs[$key]) ) . "\";\n";
  }
  
  $data .= "var DataLabels = [];\n";
  for($i=1;$i<=5;$i++)
  {
    $key = 'DataLabel' . $i;
	  $data .= "DataLabels[$i] = \"" . JSQuote( str_ensure_defined($configs[$key]) ) . "\";\n";
  }
  
	$data .= 'var categoryList =' . "\r\n";
	$data .= '[	{label:"'.JSQuote($lng->Get('Main.None')).'",value:"0"}' . "\r\n";
	for ($i=1;$i<=10;$i++)
	{
		// JSQuote($lng->Get('Cols.category')).' '.($i+1)
		$lbl = str_ensure_defined($configs['CatLabel'.$i]);
		//if ($lbl=='') $lbl = $lng->Get('Cols.category') . ' ' . $i;
		$data .= ', {label: "'.JSQuote($lbl).'",value:'.$i.'}';
	}

	$data .= '];' . "\r\n";
	
	$template_content = file_get_contents('../apresa/templ/stats.htm');

	$inside = '';
	$data .= 'var stat_type="'.JsQuote(str_ensure_defined($statcfg['type'])).'";';
	$data .= 'var stat_gran="'.JsQuote($statcfg['gran']).'";';
	$data .= 'var stat_out="'.JsQuote($statcfg['out']).'";';
	$data .= 'var stat_part="'.JsQuote($statcfg['part']).'";';
	$data .= 'var searchobj = {';
	$first = true;
	
	foreach ($search as $searchcol=>$searchvalue)
	{
		if ($first==false)
		{
			$data .= ',';
			}
		$first = false;
		$data .= $searchcol . ':"'.JSQuote($searchvalue).'"';
	}
	$data .= '};';
  
  $data .= 'savq = [';
  $first = true;
  foreach ($queries as $q)
  {
    if ($first) $first = false;
    else $data .= ', ';
    $data .= '{ id: '. $q['id']
    . ', name : "' . JSQuote($q['name']) . '" '
    . ', qspec: {';
    $first2 = true;
    foreach ($q['qspec_arr'] as $param=>$value)
    {
      if ($first2) $first2 = false;
      else $data .= ', ';
      $data .= $param . ':"' . $value . '"';
    }
    $data .= '} }' . "\r\n";

  }
  $data .= '];' . "\r\n";
  
  $defcolors = GetDefaultCategoryColors();
  $catColors = array();
  for ($i=1;$i<=10;$i++)
  {
    if (!isset($configs['CatColor'.$i]))
    {
      $configs['CatColor' . $i] = $defcolors[$i-1];
    }
    $catColors[] = $configs['CatColor' . $i];
  }
  $data .= 'var catColors = ' . json_encode($catColors) . ";\r\n";
  
	switch ($statcfg['out'])
	{
		case 't':
		  $inside = CreateExportLinks($statcfg);
			if($statcfg['type']=='ch')
			{
				$inside .= CreateEmptyLink($statcfg);
			}
			$inside .= CreateStatTable($statcfg,$statres);
			break;
		case 'lc': case 'bc': case 'pc':
			if($statcfg['type']=='ch')
			{
				$inside = CreateEmptyLink($statcfg);
				$inside .= '<br/>';
			}
			$inside .= CreateStatImageRef($statcfg,$search);
			break;
		default:
			$inside = $lng->Get('Stats.Intro');
			break;
	}

  $accessAnyTranscripts = ($dbintf->anyaccpms & PM_VIEW_TRANSCRIPT)!=0
     || ($dbintf->actuinfo['permissions'] & PM_VIEW_TRANSCRIPT) != 0;
  
	$data .= 'var anypm_tra = ' . ($accessAnyTranscripts?'1':'0') . ";\r\n";
    
	// ready with database
	$dbintf->close();
	
	// template replacements:
	$rpl['msg'] = message($msg);
	$rpl['nav'] = '';
	$rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
	$rpl['FOOTER'] = '';
	$rpl['inside'] = $inside;
	$rpl['data'] = $data;
	$rpl['stattitle'] = GetStatTitle($statcfg);
	$rpl['genlist_css'] = file_get_contents('../apresa/templ/genlist.css');
	$rpl['search_outside_js'] = file_get_contents('../apresa/templ/search_outside.js');
	$rpl['searchblk'] = file_get_contents('../apresa/templ/list_searchblk.htm');
	$rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
	$rpl['header'] = GetHeader();
	$template_content = do_replace_tags($template_content);
	echo $template_content;
}

function int_ensure_defined_null(&$var)
{
  if (isset($var)) return $var;
  else return null;
}

function OutputStatTableRow($statcfg,$key,$values,&$statres,$type)
{
	global $configs;
	if ($statcfg['type']=='ld')
	{
		if ($type==1) $t = '<tr><td class="dt"><%Stats.Total%>';
		else $t = '<tr><td class="dt">' . FormatKey($statcfg,$key);
		$min = $statres['meta']['skmin'];
		$max = $statres['meta']['skmax'];
		for ($day = $min ; $day <= $max+1 ; $day ++)
		{
			//mktime(
			$daydata = array();
			if (isset($values[$day]))
			{
				$daydata = $values[$day];
			}
			for ($x=0;$x<5;$x++)
			{
				$tp = 0;
				if ($x==1 || $x==2) $tp = 1;
				if ($x==3 || $x==4) $tp = 2;
				
				$t .= '<td class="number">';
				if (isset($daydata[$x])==false) continue;
				if ($tp==0)
				{
					$t .= int_ensure_defined($daydata[$x]);
				}
				if ($tp==1)
				{
					$t .= formatDuration( int_ensure_defined($daydata[$x]) );
				}
				if ($tp==2)
				{
					$t .= date($configs['timef'],$daydata[5]+$daydata[$x]);
				}
			}
		}
	} else if ($statcfg['type']=='pc')	//peak calls.
	{
		$t = '';
		$t .= '<tr><td class="dt">' .FormatKey($statcfg,$key);
		// TODO: check this suspicious code
		// is $values an array?
		if ($values == '' || is_array($values))
		{
			$t .= '<td class="number">0';
		}
		else
		{
			$t .= '<td class="number">' .$values;	//No formatting necessary.
		}
	} else
	{
		$t = '';
		$t .= '<tr><td class="dt">' . HtmlQuote(FormatKey($statcfg,$key));
		if (!isset($statcfg['onlytot']))
		{
			$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[0]));
			$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[1]));
			$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[2]));
		}
		$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[3]));
		if ($statcfg['showtotcols'])
		{
			if (!isset($statcfg['onlytot']))
			{
				$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[8]));
				$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[9]));
				$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[10]));
			}
			$t .= '<td class="number">' .FormatValue($statcfg,int_ensure_defined_null($values[11]));

			/*
			// DEBUG: aantal gesprekken
			if (!isset($statcfg['onlytot']))
			{
				$t .= '<td class="number">' . $values[4];
				$t .= '<td class="number">' . $values[5];
				$t .= '<td class="number">' . $values[6];
			}
			$t .= '<td class="number">' . $values[7];
			*/
			
		}
	}
	$t .= "\r\n";
	return $t;
}

function CreateStatImageRef($statcfg,$search)
{
	global $configs;
	if(int_ensure_defined($configs['LegacyGraph'])==1){
		$url = 'statsimglegacy.php?type='.$statcfg['type'].'&amp;gran='.$statcfg['gran'].'&amp;out='.$statcfg['out'];		
	}else{
		$url = 'statsimg.php?type='.$statcfg['type'].'&amp;gran='.$statcfg['gran'].'&amp;out='.$statcfg['out'];		
	}
	
	if (isset($statcfg['part']))
	{
		$url .= '&amp;part=' . $statcfg['part'];
	}
	foreach ($search as $searchcol=>$searchvalue)
	{
		$url .= '&amp;' . urlencode($searchcol) . '=' . urlencode($searchvalue);
	}
  
	if(int_ensure_defined($configs['LegacyGraph'])==1){
		if($statcfg['out']=="pc"){
			$t = '<img frameborder="0" height=240 width=600 src="'.$url.'" alt="[<%Web.Statistics%>]" ></img>';
		}else{
			$t = '<img frameborder="0" height=450 width=600 src="'.$url.'" alt="[<%Web.Statistics%>]" ></img>';
		}
	}else{		
		$t = '<iframe frameborder="0" height=820 width=1050 src="'.$url.'" alt="[<%Web.Statistics%>]" ></iframe>';
	}
	

	//$t = '';
	//$t .= '<!--[if IE]>';
	//$t .= '<embed src="http://127.0.0.1:8080/stats-test.svg" width="100" height="100" type="image/svg+xml" codebase="http://www.adobe.com/svg/viewer/install/"></embed>';
	//$t = '<iframe src="stats-test.svg" width="300" height="100"></iframe>';
	//$t .= '<![endif]-->';
	//$t = '<![if !IE]>';
	//$t .= '<object data="'.$url.'">You need a browser that can display SVG to display this image.</object>';
	//$t .= '<![endif]>';
	return $t;
}

function CreateStatTable($statcfg,$statres)
{
	global $configs,$lng;
	$unit = GetStatUnit($statcfg);

	//return '<pre>'.var_export( $statres , true).'</pre>';
	$t = '';
	$t .= '<table class="stat">';
	if ($statcfg['type']=='ld')
	{
		$t .= '<tr><td class="stathdr">';
		if(!isset($statres['meta'])) $statres['meta'] = [];
		$min = int_ensure_defined($statres['meta']['skmin']);
		$max = int_ensure_defined($statres['meta']['skmax']);
		for ($day = $min ; $day <= $max ; $day ++)
		{
			$t .= '<td class="stathdr" colspan="5">';
			$t .= gmdate($configs['datef'],$day * (24*60*60));
		}
		$t .= '<td class="stathdr" colspan="5">'.'<%Stats.Total%>';
		$t .= '<tr><td class="stathdr">'.GetStatKeyHeader($statcfg);
		for ($day = $min ; $day <= $max+1 ; $day ++)
		{
			foreach (GetLocalDetailsSubHeaders() as $hdr)
			{
				$t .= '<td class="stathdr">'.$hdr;
			}
		}
		$t .= "\r\n";
	} else
	{
		if (($statcfg['type']=='du' || $statcfg['type']=='wt')  && $statcfg['gran']!='x')
		{
			$t .= '<tr><td class="stathdr">'
			.	'<td class="stathdr" colspan="4">'.$lng->Get('Stats.averaged')
			.	'<td class="stathdr" colspan="4">'.$lng->Get('Stats.Total')
			;
		}
		$t .= '<tr><td class="stathdr">'.GetStatKeyHeader($statcfg);
		if (!isset($statcfg['onlytot']))
		{
			$t .= '<td class="stathdr"><%Web.Incoming%>';
			$t .= '<td class="stathdr"><%Web.Outgoing%>';
			$t .= '<td class="stathdr"><%Web.Internal%>';
		}
		$t .= '<td class="stathdr">'.GetTotalHeader($statcfg);
		if ($statcfg['showtotcols'])
		{
			if (!isset($statcfg['onlytot']))
			{
				$t .= '<td class="stathdr"><%Web.Incoming%>';
				$t .= '<td class="stathdr"><%Web.Outgoing%>';
				$t .= '<td class="stathdr"><%Web.Internal%>';
			}
			$t .= '<td class="stathdr">'.GetTotalHeader($statcfg);
		}
		$t .= '</tr>';
	}
	
	$totvalues = array();
	$totvalues[0] = 0;
	$totvalues[1] = 0;
	$totvalues[2] = 0;
	$totvalues[3] = 0;
	$prevkey = null;
	switch ($statcfg['type'])
  {
    case 'ln': case 'rn': case 'ld': case 'un':
      $fill = false;
      break;
    default:
     	$fill = true;
  }
	if ($statcfg['type']=='ld')
	{
		if (isset($statres['data']))
		{
			foreach ($statres['data'] as $key=>$values)
			{
				$t .= OutputStatTableRow($statcfg,$key,$values,$statres,0);
			}
		}
		$t .= OutputStatTableRow($statcfg,'tot',int_ensure_defined($statres['tot']),$statres,1);
	} else
	{
		foreach ($statres as $key=>$values)
		{
      // some keys are not int so dont: $key = (int) $key;
			if ($fill)
			{
				if ($prevkey!=null)
				{
					if ($statcfg['sortdir']=='down')
					{
						$rg1 = $key+1;
						$rg2 = $prevkey-1;
					} else
					{
						$rg1 = $prevkey+1;
						$rg2 = $key-1;
					}
					for ($k2=$rg1;$k2<=$rg2;$k2++)
					{
						if ($statcfg['type']=='pc')	//Peak calls.
							$t .= OutputStatTableRow($statcfg,$k2,array(0,0,0),$statres,0);
						else
							$t .= OutputStatTableRow($statcfg,$k2,array(),$statres,0);
					}
				}
				$prevkey = $key;
			}
			$t .= OutputStatTableRow($statcfg,$key,$values,$statres,0);
			if ($statcfg['type']!='pc')	//Peak calls.
			{
				foreach ($values as $ix=>$value)
				{
					add_to($totvalues[$ix],$value);
				}
			}
		}
		StatTotalsPostProcess($statcfg,$totvalues);

		if ($statcfg['type']!='pc')	//Peak calls
		{
			$t .= '<tr><td><%Stats.Total%>';
			if (!isset($statcfg['onlytot']))
			{
				$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[0]);
				$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[1]);
				$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[2]);
			}
			$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[3]);
		}
		
		if ($statcfg['showtotcols'])
		{
			if (!isset($statcfg['onlytot']))
			{
				$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[8]);
				$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[9]);
				$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[10]);
			}
			$t .= '<td class="number">' .FormatValue($statcfg,$totvalues[11]);
		}
	}
	$t .= '</table>';

	return $t;
}

function CreateExportLinks($statcfg)
{
  $t = '<input type="button" value="<%Stats.ExportCSV%>" id="ExportBtn">';

  if(HasExcelExport())
  {
    $t .= '<input type="button" value="<%Stats.ExportExcel%>" id="ExportExcelBtn">';
  }
  return $t;
}

function CreateEmptyLink($statcfg)
{
  $t = '<input type="button" value="<%Web.Delete%>" id="EmptyBtn">';
  return $t;
}

?>