<?php
require_once('general.php');
require_once('statgen.php');
require_once('utility.php');

HandleStatsCsv($dbintf);

function CsvLocalDetailRow(&$ref_csvRow, $key, &$ref_values, &$ref_statres, $type)
{
	global $configs, $lng;
	$min = $ref_statres['meta']['skmin'];
	$max = $ref_statres['meta']['skmax'];
	if ($type==0) $ref_csvRow->add($key);
	else if ($type==1) $ref_csvRow->add($lng->Get('Stats.Total'));
	
	for ($day = $min ; $day <= $max+1 ; $day ++)
	{
		$daydata = array();
		if (isset($ref_values[$day]))
		{
			$daydata = $ref_values[$day];
		}
		for ($x=0;$x<5;$x++)
		{
			$tp = 0;
			if ($x==1 || $x==2) $tp = 1;
			if ($x==3 || $x==4) $tp = 2;
			
			$t = '';
			if (isset($daydata[$x])==false)
			{
			} else
			{
				if ($tp==0)
				{
					$t .= int_ensure_defined($daydata[$x]);
				}
				if ($tp==1)
				{
					$t .= formatDuration( int_ensure_defined($daydata[$x]) );
				}
				if ($tp==2)
				{
					$t .= date($configs['timef'],$daydata[5]+$daydata[$x]);
				}
			}
			$ref_csvRow->add($t);
		}
		
	}
	$ref_csvRow->output();
}
			
function HandleStatsCsv($dbintf)
{
	global $lng, $rooturl;
	
	if (int_ensure_defined($configs['StatsAccess'])>0)
	{
		if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
		{
			echo 'Permission denied';
			exit;
		}
	}
	
	$statcfg = array();
	$statcfg['gran'] = 'w';
	$statcfg['out'] = 'csv';

  StatInit($statcfg,$search,$search_use);

  if($statcfg['out'] == 'csv')
  {
    $outfile = new CsvFile();
  }
  else if($statcfg['out'] == 'xlsx')
  {
    $outfile = new XLSXFile();
  }
  else
  {
    header('Location: '.$rooturl . 'stats.php');
    exit;
  }

  $logarr = array
      ("level"=>"view"
      ,"calllist_search"=>$search_use
      ,"calllist_config"=>array()
      );
  $cfgToLog = array('gran','type','out');
  foreach ($statcfg as $key=>$value)
  {
    if ( in_array($key,$cfgToLog) )
    {
      $logarr[$key] = $value;
    }
  }
	LogAction("Download statistics csv", $logarr);  
    
  if ($statcfg['type']=='ch')
  {
		$statres = $dbintf->GetLicNotRecStats($statcfg,'StatApply',$search_use);
	} else if ($statcfg['type']=='pc')
	{
		$statres = $dbintf->GetMaxSimCallsStats($statcfg,'StatApply',$search_use);
	} else
	{
		$statres = $dbintf->GetCallStats($statcfg,'StatApply',$search_use);
	}
	// ready with database
	$dbintf->close();

	$statcfg['max_entries'] = 5000;
	$statcfg['max_fraction'] = 1.01;
  StatPostProcess($statcfg,$statres);

  $outfile->Init(GetStatTitle($statcfg));

	$totvalues = array();
	$totvalues[0] = 0;
	$totvalues[1] = 0;
	$totvalues[2] = 0;
	$totvalues[3] = 0;
  $unit = GetStatUnit($statcfg);

	if ($statcfg['type']=='ld')
	{
    $csvRow = $outfile->CreateRow();
		$min = $statres['meta']['skmin'];
		$max = $statres['meta']['skmax'];
		$csvRow->add('');
		for ($day = $min ; $day <= $max ; $day ++)
		{
			$csvRow->add( gmdate('Y-m-d',$day * (24*60*60)) );
			for ($x=0;$x<4;$x++)
			{
				$csvRow->add('');
			}
		}
		$csvRow->add($lng->Get('Stats.Total'));
		$csvRow->output();

		$csvRow->add(GetStatKeyHeader($statcfg));
		for ($day = $min ; $day <= $max+1 ; $day ++)
		{
			foreach (GetLocalDetailsSubHeaders() as $hdr)
			{
				$csvRow->add($hdr);
			}
		}
		$csvRow->output();
		if (isset($statres['data']))
		{
			foreach ($statres['data'] as $key=>$values)
			{
				CsvLocalDetailRow($csvRow,$key,$values,$statres,0);
			}
		}
		CsvLocalDetailRow($csvRow,$key,$statres['tot'],$statres,1);
	} else
	{
		$csvRow = $outfile->CreateRow();
		if ($statcfg['type']=='du' && $statcfg['gran']!='x')
		{
			$csvRow->add( '' );
			$csvRow->add( $lng->Get('Stats.averaged') );
			$csvRow->add( '' );
			$csvRow->add( '' );
			$csvRow->add( '' );
			$csvRow->add( $lng->Get('Stats.Total') );
			$csvRow->add( '' );
			$csvRow->add( '' );
			$csvRow->add( '' );
			$csvRow->output();
		}
		$csvRow->add( GetStatKeyHeader($statcfg) );
		if ($statcfg['type'] != 'pc')
		{
			if (!isset($statcfg['onlytot']))
			{			
				$csvRow->add( $lng->Get('Web.Incoming') );
				$csvRow->add( $lng->Get('Web.Outgoing') );
				$csvRow->add( $lng->Get('Web.Internal') );
			}
			$csvRow->add( GetTotalHeader($statcfg) );
		}
		else
		{
			$csvRow->add("Max Simultaneous Calls");
		}
		if ($statcfg['showtotcols'])
		{
			if (!isset($statcfg['onlytot']))
			{
				$csvRow->add( $lng->Get('Web.Incoming') );
				$csvRow->add( $lng->Get('Web.Outgoing') );
				$csvRow->add( $lng->Get('Web.Internal') );
			}
			$csvRow->add( GetTotalHeader($statcfg) );
		}
		$csvRow->output();
		
		switch ($statcfg['type'])
		{
			case 'ln': case 'rn': case 'un':
				$fill = false;
				break;
			default:
				$fill = true;
		}
		foreach ($statres as $key=>$values)
		{
			if ($fill)
			{
				if (isset($prevkey))
				{
					for ($k2=$prevkey+1;$k2<$key;$k2++)
					{
						OutputStatCSVRow($statcfg,$outfile,$k2,array());
					}
				}
				$prevkey = $key;
			}
			OutputStatCSVRow($statcfg,$outfile,$key,$values);
			if ($statcfg['type']!='pc')
			{
				foreach ($values as $ix=>$value)
				{
					$totvalues[$ix] = int_ensure_defined($totvalues[$ix]) + $value;
				}
			}
		}

		StatTotalsPostProcess($statcfg,$totvalues);

		if ($statcfg['type'] != 'pc')	//Peak calls.
		{
			$csvRow = $outfile->CreateRow();
			$csvRow->add( $lng->Get('Stats.Total') );
			if (!isset($statcfg['onlytot']))
			{
				$csvRow->add( FormatValue($statcfg,$totvalues[0]) );
				$csvRow->add( FormatValue($statcfg,$totvalues[1]) );
				$csvRow->add( FormatValue($statcfg,$totvalues[2]) );
			}
			$csvRow->add( FormatValue($statcfg,$totvalues[3]) );
			if ($statcfg['showtotcols'])
			{
				if (!isset($statcfg['onlytot']))
				{
					$csvRow->add( FormatValue($statcfg,$totvalues[8+0]) );
					$csvRow->add( FormatValue($statcfg,$totvalues[8+1]) );
					$csvRow->add( FormatValue($statcfg,$totvalues[8+2]) );
				}
				$csvRow->add( FormatValue($statcfg,$totvalues[8+3]) );
			}
			$csvRow->output();
		}		
  }
  
  $outfile->Finish();
}

function OutputStatCSVRow($statcfg,$outfile,$key,$values)
{
	$csvRow = $outfile->CreateRow();
	$csvRow->add( FormatKey($statcfg,$key) );
	if ($statcfg['type'] != 'pc')
	{
		if (!isset($statcfg['onlytot']))
		{
			$csvRow->add( FormatValue($statcfg,$values[0]) );
			$csvRow->add( FormatValue($statcfg,$values[1]) );
			$csvRow->add( FormatValue($statcfg,$values[2]) );
		}
		$csvRow->add( FormatValue($statcfg,$values[3]) );
	}
	else
	{
		$csvRow->add(FormatValue($statcfg,$values));
	}
	if ($statcfg['showtotcols'])
	{
		if (!isset($statcfg['onlytot']))
		{
			$csvRow->add( FormatValue($statcfg,$values[8+0]) );
			$csvRow->add( FormatValue($statcfg,$values[8+1]) );
			$csvRow->add( FormatValue($statcfg,$values[8+2]) );
		}
		$csvRow->add( FormatValue($statcfg,$values[8+3]) );
	}
	$csvRow->output();
}
