<?php
require_once 'general.php';
require_once 'statgen.php';

function GetTextWidth($t)
{
  	$deffont = 'p/lib/mtChart/Fonts/DejaVuSansCondensed.ttf';
  	$deffontsize = 8;
    $bbox = imageftbbox($deffontsize,0,$deffont,$t);
    return $bbox[2] - $bbox[0];
}
function GetTextHeight($t)
{
  	$deffont = 'p/lib/mtChart/Fonts/DejaVuSansCondensed.ttf';
  	$deffontsize = 8;
    $bbox = imageftbbox($deffontsize,0,$deffont,$t);
    return $bbox[3] - $bbox[1];
}

	global $rpl,$configs,$msg,$lng;
	
	if (int_ensure_defined($configs['StatsAccess'])>0)
	{
		if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
		{
			echo 'Permission denied';
			exit;
		}
	}

	$statcfg = array();
	$statcfg['gran'] = 'w';

  StatInit($statcfg,$search,$search_use);

	if ($statcfg['type']=='ch')
	{
		$statres = $dbintf->GetLicNotRecStats($statcfg,'StatApply',$search_use);
	} else 	{
		$statres = $dbintf->GetCallStats($statcfg,'StatApply',$search_use);
	}
	// ready with database
	$dbintf->close();

	StatPostProcess($statcfg,$statres);

	//ini_set( "mbstring.internal_encoding", "UTF-8" );
	//echo ini_get( "mbstring.internal_encoding" );
	//exit;

	// vo: value offset
	$vo = 0;
	if ($statcfg['type']=='du' || $statcfg['type'] == 'wt')
	{
		if ($statcfg['part']==2)
		{
			$vo = 8;
		}
	}
	

	if ($statcfg['out']=='pc') // pie chart is substantially different
	{
  	$chart_width = 900;
  	$chart_height = 750;

    $data = array();
    $labels = array();
  	foreach ($statres as $key=>$values)
  	{
  		$val = int_ensure_defined($values[$vo+0])
				+ int_ensure_defined($values[$vo+1])
				+ int_ensure_defined($values[$vo+2])
				;
  		$data[$key] = $val;
  		$labels[$key] = FormatKey($statcfg,$key);
  	}
  	if (count($labels)>0)
  	{
		// create Labels for graph
		$listLabels="";
		foreach ($labels as $label)
		{
			if($listLabels!=""){
				$listLabels.=",";
			}
			$listLabels.="'".JSQuote($label)."'";
		}	

		// add total data
		$listPieChart="[";	
		foreach ($data as $score_ref)
		{
			if($listPieChart!="["){
				$listPieChart.=",";
			}
			$listPieChart.=$score_ref;
			//$chart->addPoint($score_ref,'d'.$ix);
			//$chart->addSerie('d'.$ix);
			//$chart->setSerieName($legends[$ix],'d'.$ix);
		
		}
		$listPieChart.="]";
		
  	}

  } else
  {
  	$chart_width = 900;
  	$chart_height = 750;

		$unit_type = 'num';
		if (($statcfg['type']=='du' || $statcfg['type']=='wt') && $statcfg['gran']!='x')
		{
			//$chart->setYAxisFormat('duration');
			$unit_type = 'time';
		}
		
    $include_null = 
			! (($statcfg['type']=='du' || $statcfg['type'] == 'wt') && $statcfg['gran']!='x' && $statcfg['part']!=2);
		$onlytot = isset($statcfg['onlytot']);
  	$incoming = array();
  	$outgoing = array();
  	$internal = array();
  	$total = array();
  	$labels = array();
  	$prevkey = null;
  	// for height calculation
  	$useboth = $statcfg['out']=='bc';
  	foreach ($statres as $key=>$values)
  	{
  		if ($prevkey!=null)
  		{
				// Filling gaps happens in this block
				if ($statcfg['sortdir']=='down')
				{
					$rg1 = $key+1;
					$rg2 = $prevkey-1;
				} else
				{
					$rg1 = $prevkey+1;
					$rg2 = $key-1;
				}
  			if ($include_null)
  			{
					// if no data means zero
					for ($k2=$rg1;$k2<=$rg2;$k2++)
					{
						$incoming[$k2] = 0;
						$outgoing[$k2] = 0;
						$internal[$k2] = 0;
						$total[$k2] = 0;
					}
    	  } else {
					// null causes skips in charts (good!)
					for ($k2=$rg1;$k2<=$rg2;$k2++)
					{
						$incoming[$k2] = null;
						$outgoing[$k2] = null;
						$internal[$k2] = null;
						$total[$k2] = null;
					}
				}
  		}
  		$prevkey = $key;
  		if ($include_null)
  		{
			// In that case null is 0, and not absent.
			$incoming[$key] = int_ensure_defined($values[$vo+0]);
			$outgoing[$key] = int_ensure_defined($values[$vo+1]);
			$internal[$key] = int_ensure_defined($values[$vo+2]);
			$total[$key]    = int_ensure_defined($values[$vo+3]);
  		} else {
			$incoming[] = $values[$vo+0];
			$outgoing[] = $values[$vo+1];
			$internal[] = $values[$vo+2];
			$total   [] = $values[$vo+3];
		}

		    if ($onlytot){
				$val = $values[$vo+3];
			} else	{
				if ($useboth)
				{
					$val = (int)$values[$vo+0] + (int)$values[$vo+1] + (int)$values[$vo+2];
				} else {
					$val = max( (int)$values[$vo+0] , (int)$values[$vo+1] , (int)$values[$vo+2], (int)$values[$vo+3] );
				}
			}

  		if (isset($keymin)==false || $key<$keymin)
  		{
  			$keymin = $key;
  		}
  		if (isset($keymax)==false || $key>$keymax)
  		{
  			$keymax = $key;
  		}
  		if (isset($valmin)==false || $val<$valmin)
  		{
  			$valmin = $val;
  		}
  		if (isset($valmax)==false || $val>$valmax)
  		{
  			$valmax = $val;
  		}
  	}

  	$xpoints = int_ensure_defined($keymax) - int_ensure_defined($keymin) + 1;
		if ($statcfg['sortdir']=='down')
		{
			$lastx = 100000;
		} else
		{
			$lastx = -1000;
		}
  	$prevkey = null;
    $area_width = $chart_width-30-70;

    $label_height = GetTextHeight('X');
    $label_max = 2;
  	//$chart->drawTextBox(0,0,100,10,$max_label_width );
  	foreach ($statres as $key=>$values)
  	{
  		if ($prevkey!=null)
  		{
				if ($statcfg['sortdir']=='down')
				{
					for ($k2=$prevkey-1;$k2>$key;$k2--)
					{
						LabelAdd($labels,$lastx,$label_max,$k2,$keymin,$label_height,$statcfg,$area_width,$xpoints);
					}
				} else
				{
					for ($k2=$prevkey+1;$k2<$key;$k2++)
					{
						LabelAdd($labels,$lastx,$label_max,$k2,$keymin,$label_height,$statcfg,$area_width,$xpoints);
					}
				}
  		}
  		$prevkey = $key;

      LabelAdd($labels,$lastx,$label_max,$key,$keymin,$label_height,$statcfg,$area_width,$xpoints);
  	}
		//var_dump( $labels );


  	// first data
  	//$chart->addPoint(array(3,11,8,4,6,4,2),'d1');
  	//$chart->addPoint(array(4,10,5,3,5,3,1),'d2');
  	//var_dump($labels);

	

  	//if ($include_null==false)
  	//{
  	//  $chart->addPoint($incoming_x,'d1x');
  	//  $chart->addPoint($outgoing_x,'d2x');
    //}

  	// chart always uses 5 levels
  	// for calc. value for one block
		$scale_oneblk = ceil((int_ensure_defined($valmax))/10);
		//echo $scale_oneblk; exit;
		
		if ($unit_type=='num')
		{
			$nice_values = array
			(   1,      2,      3,  4,  5,  6, 7, 8
			,  10, 15, 20, 25, 30, 40, 50, 75 );
			$nice_factor = 10;
			$nice_back = 8;
		} else if ($unit_type=='time')
		{
			$nice_values = array
			(    1,        2,         3,   4,     5
			,   10,   15, 20,        30,     45 
			,   60,   90,120,  150, 180, 240,   300,  450
			// 1:00,1:30,2:00,2:30,3:00,4:00,   5:00, 7:30
			//10:00,15:00,20:00,30:00,45:00 (not included)
			);
			$nice_factor = 60;
			$nice_back = 13;
		}
		$factor = 1;
		$ix = 0;
		for ($i=0;$i<100;$i++)
		{
			$val = $nice_values[ $ix ] * $factor;
			if ($val>=$scale_oneblk)
			{
				$scale_oneblk = $val;
				break;
			}
			$ix ++;
			if ($ix >= count($nice_values))
			{
				$ix -= $nice_back;
				$factor *= $nice_factor;
			}
		}
		//echo $scale_oneblk;
		//exit;
  	$scale_max = $scale_oneblk * 10;
	$labels_max = 0;
	$ticks = "";
	for($x = 0; $x <= 20; $x++)
	{		
		if($ticks!=""){
			$ticks.=",";
		}
		$ticks.=$scale_oneblk*($x);		

		if($valmax<($scale_oneblk*$x)){
			$scale_max=$scale_oneblk*($x);
			$labels_max=$x;	
			break;
		}
	}
		
	// create Labels for graph
	$listLabels="";
	foreach ($labels as $label)
	{
		if($listLabels!=""){
			$listLabels.=",";
		}
		$listLabels.="'".JSQuote($label)."'";
	}
	
	// add incoming data
	$listIncoming="[";	
	foreach ($incoming as $score_ref)
	{
		
		if($listIncoming!="["){
			$listIncoming.=",";
		}
		$listIncoming.="'".$score_ref."'";
			//$chart->addPoint($score_ref,'d'.$ix);
			//$chart->addSerie('d'.$ix);
			//$chart->setSerieName($legends[$ix],'d'.$ix);
		
	}
	$listIncoming.="]";
	
	// add outgoing data
	$listOutgoing="[";	
	foreach ($outgoing as $score_ref)
	{
		if($listOutgoing!="["){
			$listOutgoing.=",";
		}
		$listOutgoing.="'".$score_ref."'";
			//$chart->addPoint($score_ref,'d'.$ix);
			//$chart->addSerie('d'.$ix);
			//$chart->setSerieName($legends[$ix],'d'.$ix);
		
	}
	$listOutgoing.="]";
	
	
	$listInternal="[";
	foreach ($internal as $score_ref)
	{
		if($listInternal!="["){
			$listInternal.=",";
		}
		$listInternal.="'".$score_ref."'";
			//$chart->addPoint($score_ref,'d'.$ix);
			//$chart->addSerie('d'.$ix);
			//$chart->setSerieName($legends[$ix],'d'.$ix);
		
	}
	$listInternal.="]";
	
	$listTotal="[";
	foreach ($total as $score_ref)
	{
		if($listTotal!="["){
			$listTotal.=",";
		}
		$listTotal.="'".$score_ref."'";
			//$chart->addPoint($score_ref,'d'.$ix);
			//$chart->addSerie('d'.$ix);
			//$chart->setSerieName($legends[$ix],'d'.$ix);
		
	}
	$listTotal.="]";

    /*if (count($labels)>0)
    {
    	// draw graph
    	if ($statcfg['out']=='bc') // bar chart
    	{
    		$chart->drawStackedBarGraph();
    	} else if ($statcfg['out']=='lc'){ // line chart
    		$chart->setShadowProperties(1,1,0,0,0,30,0);
    		$usecubic = false; //true;
    		$dofill = false;

    		//if ($include_null)
    		//{
          if ($usecubic)
      		{
      			$chart->drawCubicCurve();
      		} else {
      			$chart->drawLineGraph();
      		}
      		$chart->clearShadow();
      		if ($dofill)
      		{
      			if ($usecubic)
      			{
      				$chart->drawFilledCubicCurve(0.1,30);
      			} else {
      				$chart->drawFilledLineGraph(30);
      			}
      		}
      		if ($xpoints<50)
      		{
      			$chart->drawPlotGraph(3,2,255,255,255);
      		}
      	//} else
      	//{
          //$chart->drawXYGraph('d1','d1x');
      		//$chart->clearShadow();
          //$chart->drawXYPlotGraph('d1','d1x',0,3,2);
        //}
    	}
			if (!$onlytot)
			{
    		$chart->drawLegend($chart_width-107,10);
   		}
  	}*/
  }


	//$chart->Stroke();

function LabelAdd(&$labels,&$lastx,&$label_max,$key,$keymin,$label_height,$statcfg,$area_width,$xpoints)
{
			$label_content = FormatKey($statcfg,$key);
			$label_width = GetTextWidth( $label_content );
			$x = $area_width * ($key-$keymin)/$xpoints - $label_height/2;
			if ( ($statcfg['sortdir']=='down' && $x - $lastx < -10)
			|| ($statcfg['sortdir']!='down' && $x - $lastx > 10))
			{
				$lastx = $x + $label_height;
				$labels[$key] = $label_content;
				$label_max = max($label_max,$label_width);
			}	else {
				$labels[$key] = '';
			}
}

?>
<script>
	function formatDuration($seconds)
	{
	  $seconds = Math.floor($seconds / 1);
	  $min = Math.floor($seconds / 60);
	  $seconds -= $min * 60;
	  $hour = Math.floor($min / 60);
	  $min -= $hour * 60;
	  
	  if($hour<10){
		  $hour='0'+$hour;
	  }
	  if($min<10){
		  $min='0'+$min;
	  }
	  if($seconds<10){
		  $seconds='0'+$seconds;
	  }
	  return $hour + ':' + $min + ':' +$seconds;
	}
</script>

<html>
  <head>
  <a id="myAnchor"></a>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <script type="text/javascript" src="/p/lib/Chartist/chartist.min.js"></script>
	<script type="text/javascript" src="/p/lib/Chartist/chartist-plugin-tooltip.js"></script>
	<script type="text/javascript" src="/p/lib/Chartist/chartist-plugin-axistitle.js"></script>
	<script type="text/javascript" src="/p/lib/Chartist/chartist-plugin-legend.js"></script>
	<link rel="stylesheet" href="/p/lib/Chartist/chartist.min.css">
	<link rel="stylesheet" href="/p/lib/Chartist/chartist-plugin-tooltip.css">
	<link rel="stylesheet" href="/p/lib/Chartist/chartist-plugin-legend.css">
	<link rel="stylesheet" href="/p/lib/Chartist/chartist-extra-colors.css">
  </head>
	<div class="ct-chart ct-golden-section"></div>
	<style>
	
		.ct-axis-title{
			fill:rgba(0,0,0,1) !important;
			font-family: arial;
			font-size: 14px;
		}
				
		.ct-legend{
			font-family: arial;
			font-size: 14px;
		}
		
		.ct-label{
			fill:rgba(0,0,0,1) !important;
			color:rgba(0,0,0,1) !important;
		}

		.chartist-tooltip{
			fill:				rgba(192, 192, 192, 1) !important;	
			color:				rgba(  0,   0,   0, 1) !important;
			background:			rgba(192, 192, 192, 1) !important;
			border-top-color:	rgba(192, 192, 192, 1) !important;
			z-index:			 999 !important;
		}
		
		.chartist-tooltip:before{
			border-top-color:rgba(192, 192, 192, 1); !important;
		}
		
		.ct-vertical.ct-label {
			padding: 5px !important;
		}
						
		.ct-chart {
			fill:rgba(0,0,0,1) !important;
			color:rgba(0,0,0,1) !important;
            position: relative;
		    bottom: -25px;
		    width: 90% !important;
		    height: 90% !important;
		}
		
		.ct-chart-line{
			height: 100%;
		}
		
		.ct-point{
			stroke-width: 7px;
		}
		
		.ct-grid-background{
			fill: 	rgba(255, 255, 255, 1) !important;
		}
		
		.ct-legend{
			<?php
			if($statcfg['out']=='pc'){
				echo "text-align: left;";
			}else{
				echo "text-align: right;";
			}
			?>
			top: -10px;
			
		}
		
	</style>
	<script>
		
	var data = {<?php
				echo "labels: [ ".$listLabels."],";
				?>
		series: <?php
				if($statcfg['out']=='lc'||$statcfg['out']=='bc'){
					echo "[";
					if ($statcfg['type']=='ch'){
						echo $listTotal.",";
					}else if($statcfg['out']=='bc'){								
						echo $listIncoming.",";
						echo $listOutgoing.",";
						echo $listInternal;						
					}else{
									
						echo $listIncoming.",";
						echo $listOutgoing.",";
						echo $listInternal.",";
						echo $listTotal;		
					}
					echo "]";
				}else{
					echo $listPieChart;
				}
				?>
	};
	
	<?php
	if($statcfg['out']=='lc'||$statcfg['out']=='bc'){
	?>
		var responsiveOptions = [{
			labelOffset: 0
			}];
		
		var options = {
		  width: '100%',
		  height: '100%',
		  seriesBarDistance: 2,
		  showLine: true,
		  stackBars: true,
		  showGridBackground: true,
		  showLabel: true,	
		  fullWidth: true,		  
		  
		  axisY: {
			type: Chartist.FixedScaleAxis, 
			offset: 50,
			onlyInteger: true,
			low: 0,
			high: <?php echo($scale_max) ?>,
			divisor: <?php echo($labels_max) ?>,
			ticks: [<?php echo($ticks) ?>],			
			<?php
			if($unit_type == 'time'){
				echo "labelInterpolationFnc: function(value) {return formatDuration(value);},";
			}
			?>
		  },
		  axisX: {
			offset: 70
		  },
		  plugins: [
				Chartist.plugins.ctAxisTitle({
					axisX: {
						showLabel: false,
						//axisTitle: 'Time (mins)',
						axisClass: 'ct-axis-title',
						offset: {
							x: 0,
							y: 40
						},
						textAnchor: 'middle'
					},
					axisY: {
						showLabel: true,
						axisTitle: <?php echo '" '.JSQuote(GetStatUnit($statcfg)).' "' ?>,
						axisClass: 'ct-axis-title',
						offset: {
							x: 0,
							y: 15
						},
						textAnchor: 'middle',
						flipTitle: true
					}
				}),
				Chartist.plugins.legend({
					legendNames: [<?php 
										if ($statcfg['type']=='ch'){
											echo('"'.JSQuote($lng->Get('Stats.Total')).'"');
										}else if($statcfg['out']=='bc'){								
											echo('"'.JSQuote($lng->Get('Web.Incoming')).'","');
											echo(JSQuote($lng->Get('Web.Outgoing')).'","');
											echo(JSQuote($lng->Get('Web.Internal')).'"');					
										}else{
											echo('"'.JSQuote($lng->Get('Web.Incoming')).'","');
											echo(JSQuote($lng->Get('Web.Outgoing')).'","');
											echo(JSQuote($lng->Get('Web.Internal')).'","');					
											echo(JSQuote($lng->Get('Stats.Total')).'"');					
										}
										?>],
				}),
				Chartist.plugins.tooltip({
					<?php
					if($unit_type == 'time'){
						echo "transformTooltipTextFnc: function(value) {return formatDuration(value);}";
					}
					?>
				})
				]
		}
		
	<?php 
	}else{	
	?>		
		var options = {
		  plugins: [
			Chartist.plugins.tooltip(),
			Chartist.plugins.legend()			
		  ]  
		};
		
		var responsiveOptions = [
			['screen and (min-width: 640px)', {			
				labelOffset: 15,
				chartPadding: 10,
				labelDirection: 'explode',
				labelInterpolationFnc: function(value) {
				return value;
			}}],
			['screen and (min-width: 1024px)', {
				labelOffset: 150,
				chartPadding: 100
			}]
		];		
	
	<?php
	}
	?>
	
	var anchor = document.getElementById('myAnchor');
	if('writingMode' in anchor.style){
		document.write("<style type='text/css'>.ct-horizontal.ct-label {text-align: left !important;font-size: 12px !important;writing-mode: vertical-lr;font-family: 'Arial', Arial, sans-serif;}</style>");
	}else{
		document.write("<style type='text/css'>.ct-horizontal.ct-label {text-align: left !important;font-size: 12px !important;-webkit-transform:rotate(90deg);-moz-transform:rotate(90deg);-o-transform: rotate(90deg);-ms-transform:rotate(90deg);transform-origin: left top 0;height: 70px!important;width: 70px!important;font-family: 'Arial', Arial, sans-serif;}</style>");
	}		

	// Create a new line chart object where as first parameter we pass in a selector
	// that is resolving to our chart container element. The Second parameter
	// is the actual data object. As a third parameter we pass in our custom options.
	<?php
	if ($statcfg['out']=='lc'){
		echo "var chart = new Chartist.Line('.ct-chart', data, options, responsiveOptions);";
	}else if($statcfg['out']=='bc'){
		echo "var chart = new Chartist.Bar('.ct-chart', data, options, responsiveOptions);";
	}else{
		echo "var chart = new Chartist.Pie('.ct-chart', data, options, responsiveOptions);";
	}
	
	if($statcfg['out']=='bc'){
	echo("
	var test = -1;
	chart.on('draw', function(data) {
	  if(data.type === 'label' && data.axis.units.pos === 'x') {
		  if(test==-1){
			  test=data.width;
		  }
		data.element.attr({
		  x: (data.x-5 + test / 2)
		});
	  }
	  if(data.type === 'bar') {
		data.element.attr({
		  style: 'stroke-width: '+(450 / data.series.length)+'px;'
		});
	  }
	});");
	}
	
	
	?>
	</script>
</html>