<?php
require_once 'general.php';
require_once 'statgen.php';
require_once 'p/lib/mtChart/mtChart.php';

HandleStatsImg($dbintf);

function GetTextWidth($t)
{
  	$deffont = 'p/lib/mtChart/Fonts/DejaVuSansCondensed.ttf';
  	$deffontsize = 8;
    $bbox = imageftbbox($deffontsize,0,$deffont,$t);
    return $bbox[2] - $bbox[0];
}
function GetTextHeight($t)
{
  	$deffont = 'p/lib/mtChart/Fonts/DejaVuSansCondensed.ttf';
  	$deffontsize = 8;
    $bbox = imageftbbox($deffontsize,0,$deffont,$t);
    return $bbox[3] - $bbox[1];
}

function HandleStatsImg($dbintf)
{
	global $rpl,$configs,$msg,$lng;
	
	if (int_ensure_defined($configs['StatsAccess'])>0)
	{
		if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
		{
			echo 'Permission denied';
			exit;
		}
	}

	$statcfg = array();
	$statcfg['gran'] = 'w';

	StatInit($statcfg,$search,$search_use);

	if ($statcfg['type']=='ch')
	{
		$statres = $dbintf->GetLicNotRecStats($statcfg,'StatApply',$search_use);
	} else 
	{
		$statres = $dbintf->GetCallStats($statcfg,'StatApply',$search_use);
	}
	// ready with database
	$dbintf->close();

	StatPostProcess($statcfg,$statres);

	//ini_set( "mbstring.internal_encoding", "UTF-8" );
	//echo ini_get( "mbstring.internal_encoding" );
	//exit;

	// vo: value offset
	$vo = 0;
	if ($statcfg['type']=='du' || $statcfg['type'] == 'wt')
	{
		if ($statcfg['part']==2)
		{
			$vo = 8;
		}
	}
	

	if ($statcfg['out']=='pc') // pie chart is substantially different
	{
		$chart_width = 610;
		$chart_height = 240;
		$chart = new mtChart($chart_width,$chart_height);

		// background
		$chart->drawFilledRoundedRectangle(7,7,$chart_width-7,$chart_height-7
		,10,240,240,240);
		$chart->drawRoundedRectangle(5,5,$chart_width-5,$chart_height-5
		,11,230,230,230);

		$data = array();
		$labels = array();
		foreach ($statres as $key=>$values)
		{
			$val = int_ensure_defined($values[$vo+0])
					+ int_ensure_defined($values[$vo+1])
					+ int_ensure_defined($values[$vo+2])
					;
			$data[$key] = $val;
			$labels[$key] = FormatKey($statcfg,$key);
		}
		if (count($labels)>0)
		{
			$chart->addPoint($data,'d1');
			$chart->addSerie('d1');
			$chart->addPoint($labels,'d0');
			$chart->setAbsciseLabelSerie('d0');
			$chart->drawPieGraph(230,110,100,PIE_LABELS);
			$chart->drawPieLegend($chart_width-150,10);
		}

		} else	{
		$chart_width = 600;
		$chart_height = 450;
		$chart = new mtChart($chart_width,$chart_height);
		// background
		$chart->drawFilledRoundedRectangle(7,7,$chart_width-7,$chart_height-7
		,10,240,240,240);
		$chart->drawRoundedRectangle(5,5,$chart_width-5,$chart_height-5
		,11,230,230,230);

			$unit_type = 'num';
			if (($statcfg['type']=='du' || $statcfg['type']=='wt') && $statcfg['gran']!='x')
			{
				$chart->setYAxisFormat('duration');
				$unit_type = 'time';
			}
			
		$include_null = 
				! (($statcfg['type']=='du' || $statcfg['type'] == 'wt') && $statcfg['gran']!='x' && $statcfg['part']!=2);
			$onlytot = isset($statcfg['onlytot']);
		$incoming = array();
		$outgoing = array();
		$internal = array();
		$total = array();
		$labels = array();
		$prevkey = null;
		// for height calculation
		$useboth = $statcfg['out']=='bc';
		foreach ($statres as $key=>$values)
		{
			if ($prevkey!=null)
			{
					// Filling gaps happens in this block
					if ($statcfg['sortdir']=='down')
					{
						$rg1 = $key+1;
						$rg2 = $prevkey-1;
					} else
					{
						$rg1 = $prevkey+1;
						$rg2 = $key-1;
					}
				if ($include_null)
				{
						// if no data means zero
						for ($k2=$rg1;$k2<=$rg2;$k2++)
						{
							$incoming[$k2] = 0;
							$outgoing[$k2] = 0;
							$internal[$k2] = 0;
							$total[$k2] = 0;
						}
			  } else {
						// null causes skips in charts (good!)
						for ($k2=$rg1;$k2<=$rg2;$k2++)
						{
							$incoming[$k2] = null;
							$outgoing[$k2] = null;
							$internal[$k2] = null;
							$total[$k2] = null;
						}
					}
			}
			$prevkey = $key;
			if ($include_null)
			{
					// In that case null is 0, and not absent.
			  $incoming[$key] = int_ensure_defined($values[$vo+0]);
			  $outgoing[$key] = int_ensure_defined($values[$vo+1]);
			  $internal[$key] = int_ensure_defined($values[$vo+2]);
			  $total[$key]    = int_ensure_defined($values[$vo+3]);
			} else {
			$incoming[] = $values[$vo+0];
			$outgoing[] = $values[$vo+1];
			$internal[] = $values[$vo+2];
			$total   [] = $values[$vo+3];
		  }
		  if ($onlytot)
		  {
					$val = $values[$vo+3];
				} else
				{
				if ($useboth)
				{
					$val = (int)$values[$vo+0] + (int)$values[$vo+1] + (int)$values[$vo+2];
				} else {
					$val = max( (int)$values[$vo+0] , (int)$values[$vo+1] , (int)$values[$vo+2] );
				}
			}
			if (isset($keymin)==false || $key<$keymin)
			{
				$keymin = $key;
			}
			if (isset($keymax)==false || $key>$keymax)
			{
				$keymax = $key;
			}
			if (isset($valmin)==false || $val<$valmin)
			{
				$valmin = $val;
			}
			if (isset($valmax)==false || $val>$valmax)
			{
				$valmax = $val;
			}
		}

		$xpoints = int_ensure_defined($keymax) - int_ensure_defined($keymin) + 1;
			if ($statcfg['sortdir']=='down')
			{
				$lastx = 100000;
			} else
			{
				$lastx = -1000;
			}
		$prevkey = null;
		$area_width = $chart_width-30-70;

		$label_height = GetTextHeight('X');
		$label_max = 0;
		//$chart->drawTextBox(0,0,100,10,$max_label_width );
		foreach ($statres as $key=>$values)
		{
			if ($prevkey!=null)
			{
					if ($statcfg['sortdir']=='down')
					{
						for ($k2=$prevkey-1;$k2>$key;$k2--)
						{
							LabelAdd($labels,$lastx,$label_max,$k2,$keymin,$label_height,$statcfg,$area_width,$xpoints);
						}
					} else
					{
						for ($k2=$prevkey+1;$k2<$key;$k2++)
						{
							LabelAdd($labels,$lastx,$label_max,$k2,$keymin,$label_height,$statcfg,$area_width,$xpoints);
						}
					}
			}
			$prevkey = $key;

		  LabelAdd($labels,$lastx,$label_max,$key,$keymin,$label_height,$statcfg,$area_width,$xpoints);
		}
			//var_dump( $labels );


		// first data
		//$chart->addPoint(array(3,11,8,4,6,4,2),'d1');
		//$chart->addPoint(array(4,10,5,3,5,3,1),'d2');
		//var_dump($labels);
		if (count($labels)>0)
		{
				if ($onlytot)
				{
				$chart->addPoint($total,'d1');
				} else
				{
				$chart->addPoint($incoming,'d1');
				$chart->addPoint($outgoing,'d2');
				$chart->addPoint($internal,'d3');
				//$chart->addPoint($total,'d4');
			}
			$chart->addPoint($labels,'d0');
				//$chart->addSerie('d4');
			$chart->addSerie('d1');
			$chart->addSerie('d2');
			$chart->addSerie('d3');
			if (!$onlytot){	
				$chart->setSerieName($lng->Get('Web.Incoming'),'d1');
				$chart->setSerieName($lng->Get('Web.Outgoing'),'d2');
				$chart->setSerieName($lng->Get('Web.Internal'),'d3');
				//$chart->setSerieName($lng->Get('Stats.Total'),'d4');
			}
			$chart->setAbsciseLabelSerie('d0');
	   }

		//if ($include_null==false)
		//{
		//  $chart->addPoint($incoming_x,'d1x');
		//  $chart->addPoint($outgoing_x,'d2x');
		//}

		$chart->setGraphArea(70,58,$chart_width-30,$chart_height - 28 - $label_max);

		// chart always uses 5 levels
		// for calc. value for one block
		$scale_oneblk = ceil((int_ensure_defined($valmax))/5);
		//echo $scale_oneblk; exit;
			
		if ($unit_type=='num')
		{
			$nice_values = array
			(   1,      2,      3,  4,  5,  6, 7, 8
			,  10, 15, 20, 25, 30, 40, 50, 75 );
			$nice_factor = 10;
			$nice_back = 8;
		} else if ($unit_type=='time')
		{
			$nice_values = array
			(    1,        2,         3,   4,     5
			,   10,   15, 20,        30,     45 
			,   60,   90,120,  150, 180, 240,   300,  450
			// 1:00,1:30,2:00,2:30,3:00,4:00,   5:00, 7:30
			//10:00,15:00,20:00,30:00,45:00 (not included)
			);
			$nice_factor = 60;
			$nice_back = 13;
		}
		$factor = 1;
		$ix = 0;
		for ($i=0;$i<100;$i++)
		{
			$val = $nice_values[ $ix ] * $factor;
			if ($val>=$scale_oneblk)
			{
				$scale_oneblk = $val;
				break;
			}
			$ix ++;
			if ($ix >= count($nice_values))
			{
				$ix -= $nice_back;
				$factor *= $nice_factor;
			}
		}
			//echo $scale_oneblk;
			//exit;
		$scale_max = $scale_oneblk * 5;

		$chart->setYAxisName(GetStatUnit($statcfg));
		$chart->setFixedScale(0,$scale_max);
		//$chart->setFixedScale(0,$scale_max,5,2,30,1);
		$chart->drawGraphArea(250,250,255,false);
		// could use rotate 90 also
		//if ($include_null)
		//{
		if (count($labels)>0)
		{
			$chart->drawScale(SCALE_NORMAL,150,150,150,true,90,1,true);
		}
		//} else {
		//  $chart->drawXYScale('d1','d1x',150,150,150,true,0,1,true);
		//}
		$chart->drawGrid(4,true,200,200,200,50);

		// when using line graph:
		// - drawPlotGraph for dots, only when not too much
		// when using stacked bar: calculate top value

		if (count($labels)>0)
		{
			// draw graph
			if ($statcfg['out']=='bc') // bar chart
			{
				$chart->drawStackedBarGraph();
			} else if ($statcfg['out']=='lc'){ // line chart
				$chart->setShadowProperties(1,1,0,0,0,30,0);
				$usecubic = false; //true;
				$dofill = false;

				//if ($include_null)
				//{
			if ($usecubic){
					$chart->drawCubicCurve();
				} else {
					$chart->drawLineGraph();
				}
				$chart->clearShadow();
				if ($dofill)
				{
					if ($usecubic)
					{
						$chart->drawFilledCubicCurve(0.1,30);
					} else {
						$chart->drawFilledLineGraph(30);
					}
				}
				if ($xpoints<50)
				{
					$chart->drawPlotGraph(3,2,255,255,255);
				}
			//} else
			//{
			  //$chart->drawXYGraph('d1','d1x');
				//$chart->clearShadow();
			  //$chart->drawXYPlotGraph('d1','d1x',0,3,2);
			//}
			}
			if (!$onlytot){
				$chart->drawLegend($chart_width-107,10);
			}
		}
	}
	$chart->Stroke();
}

function LabelAdd(&$labels,&$lastx,&$label_max,$key,$keymin,$label_height,$statcfg,$area_width,$xpoints)
{
			$label_content = FormatKey($statcfg,$key);
			$label_width = GetTextWidth( $label_content );
			$x = $area_width * ($key-$keymin)/$xpoints - $label_height/2;
			if ( ($statcfg['sortdir']=='down' && $x - $lastx < -10)
			|| ($statcfg['sortdir']!='down' && $x - $lastx > 10))
			{
				$lastx = $x + $label_height;
				$labels[$key] = $label_content;
				$label_max = max($label_max,$label_width);
			}	else {
				$labels[$key] = '';
			}
}

?>