<?php

require_once('general.php');

HandlePage($dbintf);

function GetSerialNumber()
{
	return file_get_contents('../apresa/conf/serial');
}

function HandlePage($dbintf)
{
  global $rpl,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_SYSALARM|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }
	OneTimeCheck();
	
  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='ignore')
    {
      if (($dbintf->actuinfo['permissions']&(PM_CONFIG))==0)
      {
        echo 'Permission denied';
        exit;
      }
      $list = $dbintf->GetConfigValue('HealthIgnoreList');
      if ($list=='') $list = '';
      else $list .= ',';
      $list .= $_POST['hid'];
      $dbintf->SetConfigsPart(array('HealthIgnoreList'=>$list),'s');
	    header('Location: '.$rooturl.'sysinfo.php');
			exit;
    }
    if ($act=='check')
    {
      if (($dbintf->actuinfo['permissions']&(PM_CONFIG))==0)
      {
        echo 'Permission denied';
        exit;
      }
      $list = $dbintf->GetConfigValue('HealthIgnoreList');
      $parts = explode(',',$list);
      $newlist = array();
      foreach ($parts as $part)
      {
        if ($part!=$_POST['hid'])
        {
          $newlist[] = $part;
        }
      }
      $list = implode(',',$newlist);
      $dbintf->SetConfigsPart(array('HealthIgnoreList'=>$list),'s');
	    header('Location: '.$rooturl.'sysinfo.php');
			exit;
    }
		if ($act=='clear')
		{
			msg_signal_service($msg,'sgnork ct ' . $_POST['cid']);
			$_SESSION['msg'] = $msg;
			header('Location: '.$rooturl.'sysinfo.php');
			exit;
		}
    if ($act=='simerr')
    {
			$value = int_ensure_defined( $_POST['value'] );
			$dbintf->SetConfigsPart(array('SimulateError'=>$value),'s');
	    $_SESSION['msg'] = $msg;
	    header('Location: '.$rooturl.'sysinfo.php');
			exit;
		}
    if ($act=='resetalarm')
    {
			$configs_crec = $dbintf->LoadConfigsPart('crec');
			$newconfigs = array();
			$newconfigs['PrevCardList'] = $configs_crec['CardList'];
			$CardList_Arr = explode(',',$configs_crec['CardList']);
			foreach ($CardList_Arr as $Card)
			{
				$ch = 0;
				if (isset($configs_crec[$Card . '_Channels']))
				{
					$ch = (int) $configs_crec[$Card . '_Channels'];
				}
				$newconfigs['Prev_' . $Card . '_Channels'] = '' . $ch;
				$present = 1;
				if (isset($configs_crec[$Card . '_Present']))
				{
					$ch = (int) $configs_crec[$Card . '_Present'];
				}
				$newconfigs['Prev_' . $Card . '_Present'] = '' . $ch;
			}
			if ($dbintf->nodePassive==false)
			{
				$dbintf->SetConfigsPart($newconfigs,'crec');
			}

			DeleteFn('/var/apresa/data/reccheck.dat');
			DeleteFn('/var/apresa/data/err_crec.dat');
			DeleteFn('/var/apresa/data/err_rectool.dat');
			DeleteFn('/var/apresa/data/err_aprem.dat');
			
			$dbintf->DeleteConfigsWithPrefix('LastLicOverflow');
	    $_SESSION['msg'] = $msg;
	    header('Location: '.$rooturl.'sysinfo.php');
			exit;
		}
	}

	$serialnum = (int) GetSerialNumber();

	msg_signal_service($msg,'sysinfo');

  $configs = $dbintf->LoadConfigs();

	// find out about Synway cards
	$cardlist = str_ensure_defined($configs['CardList']);
	//echo $cardlist;
	if ($cardlist=='')
	{
		$cardlist = array();
	} else
	{
		$cardlist = explode(',',$cardlist);
	}
  
  LogAction("View system information");

  // ready with database
  $dbintf->close();

	$uname_arr = array();
	$uname = 'Unknown';
	if (!defined('DEMO'))
	{
		exec('uname -r',$uname_arr);
		$uname = $uname_arr[0];
	}

	$healthinfo = file_get_contents(DATA_PATH . '/health.htm');

	$crec_installed = false;
	if (!defined('DEMO'))
	{
		$lsmodlines = array();
		exec('lsmod',$lsmodlines);
		foreach ($lsmodlines as $lsmodline)
		{
			$parts = preg_split('/[\s]+/',$lsmodline,-1,PREG_SPLIT_NO_EMPTY);
			if ($parts[0]=='shdpci')
			{
				$crec_installed = true;
			}
		}
	}
	$cdrv_dates = [];
	if ($crec_installed)
	{
		$cdrv_version = str_ensure_defined( $configs['CardDriverVersion'] );
	} else
	{
		$cdrv_version = "Driver not installed";
	}
	$cdrv_dates = findCdrvDateTimes();

	// Find out Linux distribution
	$issuenet = @file_get_contents('/etc/issue.net');
	$distname2 = 'Unknown';
	if (!defined('DEMO'))
	{
    $distname = 'unknown';
    if (strpos($issuenet,'Ubuntu')!==false)
    {
      $distname = 'Ubuntu';
    }
    if (strpos($issuenet,'Debian')!==false)
    {
      $distname = 'Debian';
    }
		$distname2 = trim( $issuenet );
	}

	// Find out MAC address
  $networkInterfaces = GetNetwInterfaces();
	$macs = array();
  foreach ($networkInterfaces as $networkInterface)
  {
    $macs[$networkInterface] = GetMacAddr($networkInterface);
  }
  
	// Find out installed hard disks
	$hddat = file_get_contents(DATA_PATH . '/procpartitions.dat');
	$disks = array();
	$hddat = explode("\n",$hddat);
	//echo '<pre>';
	$line_nr = 0;
	foreach($hddat as $line)
	{
		$line_nr ++;
		if ($line_nr<=2) continue;
		//echo $line . "\n";
		$parts = preg_split('/[\s]+/',$line,-1,PREG_SPLIT_NO_EMPTY);
		if (count($parts)==4)
		{
			$name = $parts[3];
			//echo $name . "\n";
			if (strlen($name)==3 && substr($name,0,2)=='sd')
			{
				$size = (int) $parts[2];
				$size = (int) ($size / (1024*1024));
				//echo "HD of size " . $size . " Gb\n";
				$disks[] = array( "name"=>$name, "size"=>$size );
			}
		}
		//var_dump($parts);
	}

	// Find out about RAID
	$procmdstat = file_get_contents(DATA_PATH . '/procmdstat.dat');
	$mdlines = array();
	$mdlines = explode("\n",$procmdstat);
	$raid = '';
	foreach($mdlines as $line)
	{
		$parts = preg_split('/[\s]+/',$line,-1,PREG_SPLIT_NO_EMPTY);
		if (count($parts)<2) continue;
		if (substr($parts[0],0,2)=='md')
		{
			$raid = strtoupper( $parts[3] );
		}
		//var_dump($parts);
	}

	//Find out about hardware RAID
	$prochwraid = file_get_contents(DATA_PATH . '/prochwraid.dat');
	$mdlines = array();
	$mdlines = explode("\n",$prochwraid);
	$hwraid = '';
	$found=false;
	foreach($mdlines as $line)
	{
		if(substr($line,0,5)=='DG/VD')
		{
			$found=true;
			continue;
		}
		if(!$found) continue;
		if(substr($line,0,5)!='-----')
		{
			$parts = preg_split('/[\s]+/',$line,-1,PREG_SPLIT_NO_EMPTY);
			$hwraid = $parts[1];
			break;
		}
	}

	$telsysVersion = getInstalledDebVersion('telsys');
  if ($telsysVersion=='') $telsysVersion = 'Not installed';

  $ed137Version = getInstalledDebVersion('apresa-ed137');
  if ($ed137Version=='') $ed137Version = 'Not installed';

	$features = array();
	if (int_ensure_defined($configs['calleval'])!=0)
	{
		$features[] = 'Agent Evaluation';
	}

  $data = 'var curv = "' . APRESA_VERSION . '";';
  $data .= 'var serialnum = "' . JSQuote($serialnum) . '";';
  /*
	// not relevant:
	if (defined('EMAILQ'))
  {
  	$distname .= ' (+Postfix)';
  }
	*/
  $data .= 'var distname = "' . JSQuote($distname) . '";';
	$data .= 'var distname2 = "' . JSQuote($distname2) . '";';
  $data .= 'var chcnt = ' . int_ensure_defined($configs['ChCnt']) . ';';
  $data .= 'var g729chcnt = ' . int_ensure_defined($configs['G729ChCnt']) . ';';
  $data .= 'var rtachcnt = ' . int_ensure_defined($configs['RtaChCnt']) . ';';
  $data .= 'var dstchcnt = ' . int_ensure_defined( $configs['DstChCnt'] ) . ';';
  $data .= 'var anachcnt = ' . int_ensure_defined( $configs['AnalogChCnt'] ) . ';';
  $data .= 'var prichcnt = ' . int_ensure_defined( $configs['PriChCnt'] ) . ';';
  $data .= 'var mobchcnt = ' . int_ensure_defined( $configs['MobileChCnt'] ) . ';';
  $data .= 'var ed137chcnt = ' . int_ensure_defined( $configs['ED137ChCnt'] ) . ';';
  $data .= 'var raid = "' . JSQuote($raid) . '";';
  $data .= 'var hwraid = "' . JSQuote($hwraid) . '";';
  $data .= 'var servertime = "' . date('Y-m-d H:i:s') . '";';
  $data .= 'var features = "' . implode(', ',$features) . '";' . "\r\n";
  $data .= 'var companyname = "' . JSQuote( str_ensure_defined( $configs['CompanyName'] )) . '";';
  $data .= 'var uname = "' . JSQuote($uname) . '";';
	$data .= 'var cdrv_version = "' . JSQuote( $cdrv_version ) . '";' . "\r\n";
	$data .= 'var cdrv_dates = ' . json_encode($cdrv_dates) . ';' . "\r\n";
	$data .= 'var simerr = '.int_ensure_defined( $configs['SimulateError'] ) . ';' . "\r\n";
  $data .= 'var telsysVersion = "' . JSQuote($telsysVersion) . "\";\r\n";
  $data .= 'var ed137Version = "' . JSQuote($ed137Version) . "\";\r\n";
  $data .= 'var phpVersion = "' . JSQuote(phpversion()) . "\";\r\n";

  $data .= 'var macs = {';
  $first = true;
  // use ordering of $networkInterfaces,
  // which should be good
  foreach ($networkInterfaces as $networkInterface)
  {
    $eth = $networkInterface;
    $mac = $macs[$networkInterface];
		if (!$first) $data .= ',';
		else $first = false;
		$data .= '"' . JSQuote($eth) . '" : "' . JSQuote($mac) . '"';
  }
  $data .= '};' . "\r\n";

  $data .= 'var disks = [';
  $first = true;
  foreach ($disks as $disk)
  {
		if (!$first) $data .= ',';
		else $first = false;
		$data .= '{ name:"' . JSQuote($disk['name']) . '"';
		$data .= ', size:' . JSQuote($disk['size']) . '';
		$data .= '}';
	}
	$data .= '];';

	$data .= "var boardlist=[\n";
	$first = true;
	foreach($cardlist as $cardid)
	{
		if (!$first) $data .= ',';
		$first = false;

		$synmodel = $configs[$cardid . '_Model'];
		$model = -1;
		if (substr($synmodel,0,3)=='DST')
		{
			$model = 12;
		}
		if (substr($synmodel,0,3)=='ATP')
		{
			$model = 3;
		}
		if (substr($synmodel,0,3)=='DTP')
		{
			$model = 7;
		}

		$data .= "{Id: \"" . JSQuote($cardid) . "\"";
		$data .= ",Present: " . (int) $configs[$cardid . '_Present'];
		$data .= ",SN: \"" . JSQuote($configs[$cardid . '_SN']) . "\"";
		$data .= ",StartCh: " . (int)$configs[$cardid . '_StartCh'];
		$data .= ",Channels: " . (int)$configs[$cardid . '_Channels'];
		$data .= ",MaxChannels: " . (int)$configs[$cardid . '_MaxChannels'];
		$data .= ",Model: \"" . JSQuote($configs[$cardid . '_Model']) . "\"";
		$data .= ",CtType: " . $model;
		$data .= ",PBX_Manu: \"" . JSQuote(str_ensure_defined($configs[$cardid . '_PBX_Manu'])) . "\"";
		$data .= ",PBX_Model: \"" . JSQuote(str_ensure_defined($configs[$cardid . '_PBX_Model'])) . "\"";
		$data .= "}\n";
	}
	$data .= "];\n";



  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/sysinfo.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['healthinfo'] = $healthinfo;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function findCdrvDateTimes()
{
	$files = glob('/var/CtiLinux*/README.txt');
	$dateTimeList = [];
	foreach ($files as $file) 
	{
			$timestamp = filemtime($file);
			$dateTimeList[] = date('Y-m-d', $timestamp);
	}
	return $dateTimeList;
}


// utility function
function getInstalledDebVersion($packname)
{
  $version = '';
  $dpkg_output = array();
  exec('dpkg-query -W ' . escapeshellarg($packname) , $dpkg_output);
  if (count($dpkg_output)==1)
  {
    $parts = explode("\t",$dpkg_output[0]);
    if (count($parts)==2 && $parts[0]==$packname)
    {
      $version = $parts[1];
    }
  }
  return $version;
}


?>
