<?php

require_once('general.php');
require_once('health.php');
require_once('update-gen.php');

// old type of key, not used anymore
// key exist of 3 times 4 digits
// product code is used for verification
// returns FALSE if invalid
// or otherwise the number of channels
// maybe remove at some time
function CheckLicenseKey($key,$prodcode)
{
	if (strlen($key)!=14) return false;
	if ($key[ 4]!='-') return false;
	if ($key[ 9]!='-') return false;
  $p1 = (int) (substr($key,0,4).substr($key,5,4));
  $p2 = (int) (substr($key,10,4));
  $channels = $p1 % 4957;
  $verify = ($p2 + $p1) % 2011;
  if ($verify != $prodcode) return false;
  return $channels;
}
function SumDigits($code)
{
	$sum = 0;
	$len = strlen($code);
	for ($i=0;$i<$len;$i++)
	{
		$sum += (int)($code[$i]-'0');
	}
	return $sum;
}
function SumOnlyDigits($code)
{
	$sum = 0;
	$len = strlen($code);
	for ($i=0;$i<$len;$i++)
	{
		$ch = $code[$i];
		if ($ch>='0' && $ch<='9')
		{
			$sum += (int)($ch-'0');
		}
	}
	return $sum;
}

// xxxx-xxxx-xxxx-xxxx
function CheckLicenseKeySerial($key,$prodcode,$serial)
{
	if (substr($key,0,2)!=$prodcode) return false;
  for ($i=0;$i<4;$i++)
  {
    if (ctype_digit(substr($key,$i*5,4))==false) return false;
  }
	if ($key[ 4]!='-') return false;
	if ($key[ 9]!='-') return false;
	if ($key[14]!='-') return false;
	if (strlen($key)!=19) return false;
	$exceptc = substr($key,0,3)
		.substr($key,5,4).substr($key,10,4)
		.substr($key,15,4);
	$c = (int) substr($key,3,1);
  $p1 = (int) (substr($key,5,4).substr($key,10,4));
  $p2 = (int) (substr($key,15,4));
  if (SumDigits($exceptc)%10!=$c) return false;
  $channels = $p1 % 4957;
  $verify = ($p2 + $p1 + $serial*7) % 2011;
  if ($verify != $prodcode) return false;
  return $channels;
}

function GetSerialNumber()
{
	return (int) file_get_contents('../apresa/conf/serial');
}

function IsEncryptedKey($cfgkey)
{
	if ($cfgkey=='SMTPpwd'
	|| $cfgkey=='ApiAuthE'
	|| (strpos($cfgkey,'LdapPwd') !== false)
	|| $cfgkey=='CSTAPwdE'
	|| $cfgkey=='CSTATelPwdE'
	|| $cfgkey=='SamwinPwd'
	|| $cfgkey=='MiccPwd'
	|| $cfgkey=='MitelSecret'
  || $cfgkey=='ShoreTelDb_Pwd'
  || $cfgkey=='Scribe_Pwd'
  || $cfgkey=='CjApiPwd'
	|| $cfgkey=='TeamsBotPwd'
	|| $cfgkey=='SforceLink_Pwd'
	|| $cfgkey=='SNMPv3Password'
	)
	{
		return true;
	}
	return false;
}

HandlePage();

function CheckRestart($part,$active_cnt)
{
  global $msg,$lng,$dbintf;

  $compnames = array( 'o' => 'Recording component'
    , 's' => 'System'
    , 'n' => 'Network'
    , 'cj' => 'Cisco JTAPI'
    );
  $compnames_lng = array( 'o' => $lng->Get('System.TheRecComp')
    , 's' => $lng->Get('System.TheSys')
    , 'n' => $lng->Get('System.TheNetwComp')
    , 'cj' => 'Cisco JTAPI'
    );

  $restart = false;
  if (str_ensure_defined($_POST['restart_'.$part])=='1')
  {
    if ($active_cnt>0 && $_POST['restart_force_'.$part]==false)
    {
      $msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceRestart'));
    } else
    {
			$ok = false;
			if ($part=='n' || $part=='s')
			{
				// in case of network restart, we should NOT wait for a reply
				$signal_ret = signal_service($part.'r');
        if ($signal_ret=='')
        {
					$ok = true;
				} else
				{
        	$msg[] = new Msg(MSG_ERR,'Socket error ('.$signal_ret.')');
				}
			} else
			{
      	if (msg_signal_service($msg,$part.'r'))
      	{
					$ok = true;
				}
				if ($part=='o')
				{
					clusterConfigNotify(true);
				}
			}
      if ($ok)
      {
        $restart = true;
        $t = $lng->Get('System.RestartComponentBusy');
        $t = str_replace('%1',$compnames_lng[$part],$t);
        $t = ucfirst($t);
        $msg[] = new Msg(MSG_INF,$t);
      } else {
        $msg[] = new Msg(MSG_ERR,$compnames[$part].' restart failed');
      }
    }
  }
  if ($restart==false)
  {
    if ($_POST['changed_'.$part])
    {
      // not restarting, but changed
      $msg[] = new Msg(MSG_WRN,$lng->Get('System.ChangesAfterRestart'));
      $_SESSION['changed_'.$part] = 1;
    }
  }
}


function CheckRestartOrReconfigO($active_cnt)
{
  global $msg,$lng,$dbintf;
	
	$needrestart = str_ensure_defined($_POST['needrestart_o'])=='1';
	$needreconfig = str_ensure_defined($_POST['needreconfig_o'])=='1';
  $restart = str_ensure_defined($_POST['restart_o'])=='1';
  if($restart)
  {
    if ($active_cnt>0 && $_POST['restart_force_o']==false)
    {
      $msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceRestart'));
			$restart = false;
    } else
    {
			if (msg_signal_service($msg, 'or'))
			{
				$restart = true;
        $t = $lng->Get('System.RestartComponentBusy');
        $t = str_replace('%1',$lng->Get('System.TheRecComp'),$t);
        $t = ucfirst($t);
        $msg[] = new Msg(MSG_INF,$t);
			}
			else
			{
				$msg[] = new Msg(MSG_ERR,$lng->Get('System.TheRecComp').' restart failed');
			}
			
			if($dbintf->GetConfigValue('ED137Service'))
			{
				if (msg_signal_service($msg, 'ar'))
				{
					$restart = true;
	        $t = $lng->Get('System.RestartComponentBusy');
	        $t = str_replace('%1','ED137',$t);
	        $t = ucfirst($t);
	        $msg[] = new Msg(MSG_INF,$t);
				}
				else
				{
					$msg[] = new Msg(MSG_ERR, 'ED137 restart failed');
				}
			}
		}
  }
  if ($restart==false)
  {
    if($needreconfig)
		{
			EnginesReconfig($msg,$dbintf);
		}
		if ($needrestart)
    {
      // not restarting, but changed
      $msg[] = new Msg(MSG_WRN,$lng->Get('System.ChangesAfterRestart'));
      $_SESSION['changed_o'] = 1;
    }
  }
	
	if($needrestart || $needreconfig)
	{
		clusterConfigNotify($needrestart);
	}
}


function HandlePage()
{
  global $rpl,$configs,$msg,$lng,$rooturl;
	global $dbintf;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }
	
	OneTimeCheck();

	$updatePeriod = GetUpdatePeriod();
	
  $active_cnt = $dbintf->GetActiveCallsCount();
	
  // must be all network settings
	$cfgkeys = array('EmAdmin','EmAdmin2','EmailAddrLoud','DHCP','IPaddr','IPmask'
  ,'ManualNetwConf'
  ,'IPgate','DNSaddr','IPname'
  ,'StatusMsg'
  ,'EmailConnectType'
  ,'SMTPhost','SMTPfrom','SMTPusr','SMTPpwd'
  ,'SMTPport','SMTPenc'
  ,'EmailTemplateNewPwdSubject'
  ,'EmailTemplateNewPwdBody'
	,'EmailTemplateVeriCodeSubject'
  ,'EmailTemplateVeriCodeBody'
	,'EmailTemplateEmailRecSubject'
  ,'EmailTemplateEmailRecBody'
  ,'NTPhost','NTPhost_2','NTPhost_3','NTPhost_4'
  // not yet: ,'NTPport','WebPort'
	,'WebSPort'
	,'StatusMsgTime'
  ,'WebMaxCon','Network2','n2_DHCP','n2_IPaddr','n2_IPmask'
	,'n2_IPgate','n2_DNSaddr'
	,'LdapHost','UsersDomain','LdapDomain','LdapUser','LdapPwd','LdapSyncInt','LdapTel1','LdapTel2','LdapTel3','LdapUseUPN'
  ,'SNMPConfig', 'RemoteSNMP', 'SNMPv2Enable', 'SNMPCommunity', 'SNMPAccess'
  ,'SNMPTrap', 'SNMPTrapCommunity', 'SNMPv3Enable', 'SNMPv3Username', 'SNMPv3Password', 'SNMPv3EngineID' ,'SNMPv3Trap'
  ,'SNMPv3AuthProt', 'SNMPv3EncryptProt', 'SNMPGeneralErr'
	,'EnableMitel', 'MitelAddress', 'MitelToken', 'MitelSecret', 'MitelSuper'
  ,'Azure'
  );
  // subset of network settings that relate to email
  // that require an email reconf
  $cfgkeys_email = array('SMTPhost','SMTPfrom','SMTPusr','SMTPpwd'
  ,'SMTPport','SMTPenc','IPname','EmailConnectType','EmAdmin','EmAdmin2');
	$cfgkeys_snmp = array('SNMPConfig', 'RemoteSNMP', 'SNMPv2Enable', 'SNMPCommunity', 'SNMPAccess', 
  'SNMPTrap', 'SNMPTrapCommunity', 'SNMPv3Enable', 'SNMPv3Username', 'SNMPv3Password',
  'SNMPv3AuthProt', 'SNMPv3EncryptProt', 'SNMPv3Trap');
  // all Oreka settings
  $cfgkeys_o = array('SIPpbx','FilterViaPbx','VoIPnetw','VoIPnetwChk','SipPorts'
  // 'SIPgate','SIPdir'
	, 'VoipEngine' , 'OrkDbLink'
  , 'FakeErspan'
  , 'AleDisk'
  , 'SipNameAsID' , 'DetectAastra', 'LocalIpRanges', 'RemoteIpRanges', 'MacLocal'
	, 'CalcChecksum', 'FullSipId', 'H323', 'TdmLogApi', 'Megaco', 'Unistim', 'ProtMGCP'
	, 'UnistimLocalIdType', 'NotRawRTP', 'AlcatelStopList'
	, 'AvayaH323', 'AvayaSip', 'AvayaSipStoreTrigger', 'DMCCRecordTrigger', 'RecCheck'
	, 'PrefixesToRemove','PostfixesToRemove','IdBetweenBrackets','PickupCodes'
  , 'VoipAmp', 'apresanet', 'LocalNums'
	, 'SipNec', 'SipRecNec', 'SipLogonStarDash'
	, 'SipLogonDetect', 'SipLogonCode', 'SipLogoffCode'
	, 'NoNotifyLicLimit', 'SipDetermIp'
	, 'StartRecOnConnect' , 'ORestartTime', 'AvayaLocalId', 'AvIpoConn'
	, 'srWeekdays'
  , 'srSundayStart1', 'srSundayStop1', 'srSundayStart2', 'srSundayStop2'
  , 'srMondayStart1', 'srMondayStop1', 'srMondayStart2', 'srMondayStop2'
  , 'srTuesdayStart1', 'srTuesdayStop1', 'srTuesdayStart2', 'srTuesdayStop2'
  , 'srWednesdayStart1', 'srWednesdayStop1', 'srWednesdayStart2', 'srWednesdayStop2'
  , 'srThursdayStart1', 'srThursdayStop1', 'srThursdayStart2', 'srThursdayStop2'
  , 'srFridayStart1', 'srFridayStop1', 'srFridayStart2', 'srFridayStop2'
  , 'srSaturdayStart1', 'srSaturdayStop1', 'srSaturdayStart2', 'srSaturdayStop2'
  , 'SipDataField1', 'SipDataTarget1'
  , 'SipDataField2', 'SipDataTarget2'
  , 'SipDataField3', 'SipDataTarget3'
  , 'SipDataField4', 'SipDataTarget4'
  , 'SipDataField5', 'SipDataTarget5'
  , 'SipDataField6', 'SipDataTarget6'
  , 'SipTenantField'
	, 'KeepCmdSipField', 'KeepCmdSipValue'
	, 'SplitTransfer', 'NoPAsserted', 'PAssertedReceiver', 'ReferTransfer'
  , 'SipRPIdCaller', 'SipRPIdReceiver', 'SipUseRequestUri'
	, 'samwin', 'samwinuid', 'InnovaPhoneAr', 'UnpreferredSipIds'
  , 'CiscoArZeroPfOut'
  // these are replaced by a table 'CjServer', 'CjApiUsr', 'CjApiPwd'
  , 'CjOriCalledConnected'
	, 'Xpert','XpertMasterTurret','XpertLocalId','XpertConnected', 'MiNet'
	, 'XpertSipRec', 'XpertSipRecCallerId'/*, 'XpertSipRecConnected'*/
	, 'XpertSipRecNotes1', 'XpertSipRecNotes2', 'XpertSipRecNotes3', 'XpertSipRecNotes4', 'XpertSipRecNotes5'
	, 'XpertSipRecData1', 'XpertSipRecData2', 'XpertSipRecData3', 'XpertSipRecData4', 'XpertSipRecData5'
	, 'CSTAServer','CSTAServerPort','CSTAType','CSTAUser','CSTAPwdE','CSTAApresaNr','CSTABlacklist','CSTAActive','CSTATlink'
	, 'CSTAUseAgentID','CSTAPassiveMode','CSTATelPwdE','CSTALocalIP','CSTAMultiControllable','CSTAConnectedColumn'
	, 'CSTAConfNum','CSTAMediaServer','CSTAClearConf','OutCallsFollowSIP','DMCCTriggerPurpose', 'DMCCRecordStereo'
	, 'CSTAOigServer', 'CSTAPbx'
	, 'SilenceBeep', 'NoBeepTimeJump', 'PfRing', 'AudioMultiCall','SipFilterNoRecOnDmd','MaxSilenceTime'
	, 'CSTASilentMon','CSTARCGNum', 'CSTARecOnDmd'
  , 'SipRemoteNameUsage'
	, 'MissedCalls','ChLimCalls','DialCodeFilter', 'UnfilteredStats'
	, 'EnableTunnel', 'TunnelPort', 'TunnelEncryptionPwd', 'TunnelDataSeparation', 'TunnelOnlyKnown', 'TunnelOnlyEncrypted', 'TunnelAlarmTableDisconnect'
  , 'TunnelAdvancedAlarm', 'TunnelDisconErr', 'TunnelAnalogNative', 'TunnelTLS', 'TunnelTLSPort'
  , 'SipInviteFar', 'SplitDuration', 'UseSipTags', 'CallLeg'
	, 'ToshibaSMDR', 'ToshibaSMDRPort', 'ToshibaIps'
  , 'ShoreTelDb', 'ShoreTelDb_Host', 'ShoreTelDb_Port', 'ShoreTelDb_Mode'
  , 'ShoreTelDb_Usr', 'ShoreTelDb_Pwd'
  , 'ShoreTelDb_DbName', 'ShoreTelDb_DbName2'
  , 'CollectLogs', 'CollectLogsKeep', 'NatMapping'
	, 'SIPRECAllTransport', 'BlockUnwantedRtp', 'RtpTcp'
	, 'Speakerbus', 'SpeakerbusPort'
	, 'SforceLink'
	, 'SforceLink_AuthDomain' , 'SforceLink_Usr', 'SforceLink_Pwd'
	, 'SforceLink_TaskAdd', 'SforceLink_CallType', 'SforceLink_BaseUrl'
  , 'BroadworksSipRec', 'BroadworksSipRecData1', 'BroadworksSipRecData2', 'BroadworksSipRecData3', 'BroadworksSipRecData4', 'BroadworksSipRecData5'
  , 'BroadworksSipRecNotes1', 'BroadworksSipRecNotes2', 'BroadworksSipRecNotes3', 'BroadworksSipRecNotes4', 'BroadworksSipRecNotes5', 'BroadworksSipRecIgnoreSOD'
  , 'BroadworksSipRecTenantAssignment'
	, 'MiccSync','MiccServer','MiccDb','MiccUsr','MiccPwd','MiccInterval'
  , 'OracleSipRec', 'OracleSipRecRequestUri', 'OracleSipRecRealm', 'OracleSipRecDirHeader', 'OracleSipRecDirIn', 'OracleSipRecDirOut' 
  , 'OracleSipRecHeader1', 'OracleSipRecHeaderTarget1', 'OracleSipRecHeader2', 'OracleSipRecHeaderTarget2', 'OracleSipRecHeader3', 'OracleSipRecHeaderTarget3'
  , 'OracleSipRecHeader4', 'OracleSipRecHeaderTarget4', 'OracleSipRecHeader5', 'OracleSipRecHeaderTarget5', 'OracleSipRecHeader6', 'OracleSipRecHeaderTarget6'
  , 'OracleSipRecHeader7', 'OracleSipRecHeaderTarget7', 'OracleSipRecHeader8', 'OracleSipRecHeaderTarget8', 'OracleSipRecHeader9', 'OracleSipRecHeaderTarget9'
  , 'OracleSipRecHeader10', 'OracleSipRecHeaderTarget10'
  , 'OracleSipRecTenantAssignment', 'OracleSipRecTenantAssignmentHeader'
  , 'ReportPortsRawRtp', 'InvertPortsRawRtp'
  , 'B3CpaasSiprec', 'B3CpaasSiprecTenant'
  , 'RawRtpInsertSilenceOnPacketResumption'
  );
  // scribe settings
  $cfgkeys_scribe = array
  ( 'Scribe_Type', 'Scribe_Server', 'Scribe_Usr', 'Scribe_Pwd', 'Scribe_Target'
  , 'Scribe_TranslationTarget'
  );
  // all system settings
  $cfgkeys_s = array('OutgPrefix'
  ,'HdDaysKeep','ScreenRecDaysKeep','TraDaysKeep'
  ,'KeepDelListed','KeepAgEvListed'
	,'LoadDelBackup','SecureDelete','UseCallsArchive','DelBckDelMain'
  ,'DTMF1','DTMFact1'
  ,'DTMF2','DTMFact2'
  ,'DTMF3','DTMFact3'
  ,'DTMF4','DTMFact4'
	,'DTMF5','DTMFact5'
  ,'DTMF6','DTMFact6'
  ,'DTMF7','DTMFact7'
  ,'DTMF8','DTMFact8'
	,'DTMF9','DTMFact9'
  ,'Https'
	,'RemoteShell','ApiAuthE'
	,'InactivityAlarm','iaStart1','iaStop1','iaStart2','iaStop2'
	,'iaPeriodSystem','iaPeriodSystemApresa','iaPeriodChannel','iaPeriodOtherRec','iaMaxCallLength','iaWeekdays','iaPeakCalls','iaPeriodUser','iaConfigPeriodUser'
	,'UsrFilterLocal','FailVoipStopTelsys','MaskLastRemoteDigits'
	,'ManualAccess','MultiTenancy','TenantQuickAssign','DupNamesAllowed','UniquePhones','OneGroupPerUser'
  ,'TenantPhonesOnlyEnabled'
  ,'ALPIps'
	,'SamwinInt','SamwinServer','SamwinDb','SamwinUsr','SamwinPwd','SamwinInterval'
  ,'ClientCon'
  ,'EmailRecs','EmailRecsDst','EmailAttach'
	,'TeamsBotCheck','TeamsBotServer','TeamsBotPwd', 'ED137ChCnt'
  );
	$cfgkeys_crec = array('LineNameInFileName','NoWriteIni','DoCrecCheck','TdmLogDaysKeep');
  // all web settings
  $cfgkeys_web = array('SystemName'
  ,'WebMaxCnt','WebMaxIdle','WebMaxTime','Audit','AuditDb','AuditView','AuditIntf','AuditDaysKeep'
  ,'EditProfile','PlayPmEmbedded'
	,'MinPwdLength','StrongPwdAuth','MustChangePwd','RenewPwdDays','TempDisabledTime','PwdHistory'
	,'RecycleBin', 'PwdRecover','NotEditPwdInProfile','StatsAccess','ActiveCallsAccess','LoginVerification'
  ,'ExtLogon','AccessUrl','SsoOneAction','TenantReassign','TenantContactList'
	, 'LoginPageMsg', 'EnableSCIM', 'AlePlayUnlockUser'
	);
  for ($i=1;$i<=10;$i++)
  {
		$cfgkeys_web[] = 'CatLabel'.$i;
    $cfgkeys_web[] = 'CatColor'.$i;
	}

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='alp-restart')
    {
      msg_signal_service($msg,"alprestart");
    }
    if ($act=='add-ldap')
    {
			if(isset($_POST['ldaphost']))
			{
				$ldaphost = $_POST['ldaphost'];
				if($ldaphost !='')
				{
					$configs_n = $dbintf->LoadConfigsPart('n');
					$i = 1; $newkey=false; $keyexists=false;
					while(!$newkey && !$keyexists)
					{
						if($i==1)
						{
							if(isset($configs_n['LdapHost']))
							{
								if($configs_n['LdapHost'] == $ldaphost) $keyexists=true;	//LdapHost must be unique!
								$i++;
							}
							else $newkey=true;
						}
						else
						{
							if(isset($configs_n['LdapHost'.$i]))
							{
								if($configs_n['LdapHost'.$i] == $ldaphost) $keyexists=true;	//LdapHost must be unique!
								$i++;
							}
							else $newkey = true;
						}
					}
					if(!$keyexists)
					{
						if($i==1) $key = ''; else $key = $i;
						$cfgs_n = array();
						$cfgs_n['LdapHost'.$key] = $ldaphost;
						if(isset($_POST['usersdomain'])) $cfgs_n['UsersDomain'.$key] = $_POST['usersdomain'];
						else $cfgs_n['UsersDomain'.$key] = '';
						if(isset($_POST['ldapdomain'])) $cfgs_n['LdapDomain'.$key] = $_POST['ldapdomain'];
						else $cfgs_n['LdapDomain'.$key] = '';
						if(isset($_POST['ldapuser'])) $cfgs_n['LdapUser'.$key] = $_POST['ldapuser'];
						else $cfgs_n['LdapUser'.$key] = '';
						if(isset($_POST['ldappwd'])) $cfgs_n['LdapPwd'.$key] = encrypt($_POST['ldappwd']);
						else $cfgs_n['LdapPwd'.$key] = encrypt('');
						$dbintf->SetConfigsPart($cfgs_n,'n');
					}
				}
			}
 		}
		if($act=='edit-ldap')
		{
			if(isset($_POST['key']))
			{
				$key = $_POST['key'];
				if($key=='0') $key='';
        $cfgs_n = array();
        if(isset($_POST['ldaphost'])) $cfgs_n['LdapHost'.$key] = $_POST['ldaphost'];
        else $cfgs_n['LdapHost'.$key] = '';
        if(isset($_POST['usersdomain'])) $cfgs_n['UsersDomain'.$key] = $_POST['usersdomain'];
        else $cfgs_n['UsersDomain'.$key] = '';
        if(isset($_POST['ldapdomain'])) $cfgs_n['LdapDomain'.$key] = $_POST['ldapdomain'];
        else $cfgs_n['LdapDomain'.$key] = '';
        if(isset($_POST['ldapuser'])) $cfgs_n['LdapUser'.$key] = $_POST['ldapuser'];
        else $cfgs_n['LdapUser'.$key] = '';
        if(isset($_POST['ldappwd'])) $cfgs_n['LdapPwd'.$key] = encrypt($_POST['ldappwd']);
        $dbintf->SetConfigsPart($cfgs_n,'n');
			}
		}
		if($act=='del-ldap')
		{
			if(isset($_POST['key']))
			{
				$key = $_POST['key'];
				if($key=='0') $key='';
				$dbintf->DeleteFromConfigs('LdapHost'.$key);
				$dbintf->DeleteFromConfigs('UsersDomain'.$key);
				$dbintf->DeleteFromConfigs('LdapDomain'.$key);
				$dbintf->DeleteFromConfigs('LdapUser'.$key);
				$dbintf->DeleteFromConfigs('LdapPwd'.$key);
			}
		}
    if ($act=='change-settings')
    {
			LogAction('Change system setting');
			// special case
			if (isset($_POST['UnofficialUpdates']))
			{
				$uu = (int) $_POST['UnofficialUpdates'];
				msg_signal_service($msg,"unoffupd $uu");
			}
      // selectively copy from POST data
			$email_change = false;
			$snmp_change = false;
      $configs_n = array();
      $configs_s = array();
      $configs_o = array();
      $configs_web = array();
      $configs_crec = array();
      $configs_scribe = array();
      foreach ($cfgkeys as $cfgkey)
      {
        if($cfgkey == 'SNMPv3EngineID') continue;

        if (isset($_POST[$cfgkey]))
        {
					$configs_n[$cfgkey] = $_POST[$cfgkey];
					if (IsEncryptedKey($cfgkey))
					{
            $configs_n[$cfgkey] = encrypt($configs_n[$cfgkey]);
          }
          if (in_array($cfgkey,$cfgkeys_email))
          {
						$email_change = true;
					}
					if (in_array($cfgkey, $cfgkeys_snmp))
					{
						$snmp_change = true;
					}
        }
      }
      // NOTE: this seems faulty
      // EmailConnectType is a string that can be:
      // { relay , direct , none } or empty
      if (isset($configs_n['EmailConnectType']) && 
       ($configs_n['EmailConnectType']==1 || $configs_n['EmailConnectType']==2) )
      {
        $configs_n['SMTPhost'] = '';
      }
      foreach ($cfgkeys_s as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_s[$cfgkey] = $_POST[$cfgkey];
					if (IsEncryptedKey($cfgkey))
					{
            $configs_s[$cfgkey] = encrypt($configs_s[$cfgkey]);
          }
					if ($cfgkey=='ApiAuthE')
					{
						$configs_s['ApiAuth'] = '';
					}
        }
      }
      foreach ($cfgkeys_o as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_o[$cfgkey] = $_POST[$cfgkey];
					if($cfgkey == 'TunnelEncryptionPwd')
					{
						$configs_o[$cfgkey] = bin2hex(passwordEncrypt('TheTnPwdKey', $configs_o[$cfgkey], 'nofb'));
          } else
					if (IsEncryptedKey($cfgkey))
					{
            $configs_o[$cfgkey] = encrypt($configs_o[$cfgkey]);
          }
					if ($cfgkey=='CSTAPwdE')
					{
						$configs_o['CSTAPwd'] = '';
					}
					if($cfgkey=='CSTAType' && $configs_o['CSTAType']>0)
					{
						$configs_o['SipDetermIp'] = "1";	//On.
						$configs_o['NoPAsserted'] = "1";	//Off. Reversed on the htm page!
						$configs_o['PAssertedReceiver'] = "0";	//Off.
					}
          if ($cfgkey=='UnfilteredStats')
          {
            $value = $configs_o[$cfgkey];
            if ($value==0)
            {
              $configs_web['LiveCalls'] = '0';
            } else
            {
              $configs_web['LiveCalls'] = '1';
            }
          }
        }
      }
      foreach ($cfgkeys_crec as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_crec[$cfgkey] = $_POST[$cfgkey];
        }
      }
      foreach ($cfgkeys_scribe as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_scribe[$cfgkey] = $_POST[$cfgkey];
					if (IsEncryptedKey($cfgkey))
					{
            $configs_scribe[$cfgkey] = encrypt($configs_scribe[$cfgkey]);
          }
        }
      }
      foreach ($cfgkeys_web as $cfgkey)
      {
        if (isset($_POST[$cfgkey]))
        {
          $configs_web[$cfgkey] = $_POST[$cfgkey];
					if($cfgkey=='LoginVerification' && $configs_web[$cfgkey]==1)
					{
						$_SESSION['LoginVerificationEnabled']=1;
					}
        }
      }
			if ($dbintf->nodePassive)
			{
				// If this message is to return,
				// we then have to check if the configs contain
				// any machine setting.
				
				//$msg[] = new Msg(MSG_ERR,'Most settings can only be changed on the primary node');
				// redirect
				//$_SESSION['msg'] = $msg;
				//header('Location: '.$rooturl.'systemopt.php');
				//exit;
			}
			
			
			if (isset($_POST['RemoteShellPwd']))
			{
				if (int_ensure_defined($dbintf->GetConfigValue('RemoteShellPwdSet'))==0)
				{
					$pwd = $_POST['RemoteShellPwd'];
					msg_signal_service($msg,'vidipwd '.$pwd);
					$configs_s['RemoteShellPwdSet'] = '1';
				} else
				{
					// should never happen
					echo "pwd. already set";
					exit;
				}
			}
      
      if (isset($configs_s['UseCallsArchive']) && $configs_s['UseCallsArchive']==0
      && $dbintf->GetConfigValue('UseCallsArchive')==1 )
      {
        $dbintf->ClearCallsArchive();
      }
      
      $restart = str_ensure_defined($_POST['restart'])=='1';
      // possibly new license key set
      $licdone = false;
      if ($_POST['LicKey']!='')
      {
        $lickey = trim( $_POST['LicKey'] );
				$fullkey = $lickey;
        $configs_s['LicKey'] = $lickey;
        $channels = CheckLicenseKey($lickey,30);
        if ($channels!==false)
        {
					// valid key
					$configs_o['ChCnt'] = $channels;
					// delete the additional ones
					// NOTE: this seems to be an extra protected against
					// this special key that is not bound to a serial number.
					$dbintf->ClearLicKeys();
					$licdone = true;
				}
				if ($licdone==false)
				{
					// check if not already in database
					if ($dbintf->UsedLicKey($lickey))
					{
	          $msg[] = new Msg(MSG_ERR,'License key is already loaded.');
	          $licdone = true;
					}
				}
				if ($licdone==false)
				{
        	$serial = GetSerialNumber();
        	$channels = CheckLicenseKeySerial($lickey,31,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
	          $configs_o['ChCnt'] = $dbintf->GetConfigValue('ChCnt') + $channels;
						$licdone = true;
					}
				}
				if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,33,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
	          $configs_o['G729ChCnt'] = $dbintf->GetConfigValue('G729ChCnt') + $channels;
						$licdone = true;
					}
        }
				if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,35,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
	          $configs_crec['DstChCnt'] = $dbintf->GetConfigValue('DstChCnt') + $channels;
						$licdone = true;
					}
        }
				if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,39,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
	          $configs_crec['AnalogChCnt'] = $dbintf->GetConfigValue('AnalogChCnt') + $channels;
						$licdone = true;
					}
        }
				if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,43,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
	          $configs_crec['PriChCnt'] = $dbintf->GetConfigValue('PriChCnt') + $channels;
						$licdone = true;
					}
        }
				if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,45,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
						$licdone = true;
					}
        }
				if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,47,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
						$licdone = true;
					}
        }
        if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,49,$serial);
        	if ($channels!==false)
        	{
						$dbintf->AddLicKey($lickey);
						$licdone = true;
					}
        }
				if ($licdone==false)
				{
        	$channels = CheckLicenseKeySerial($lickey,37,$serial);
        	if ($channels!==false)
        	{
						// it is a feature
						// channel number denotes the feature
						if ($channels==1)
						{
							$dbintf->AddLicKey($lickey);
	          	$configs_s['calleval'] = '1';
							$licdone = true;
						}
					}
        }
				if ($licdone==false)
				{
					// we have keys with more info
					// so take first part
					$partkey = substr($lickey,0,19);
					$channels = CheckLicenseKeySerial($partkey,37,$serial);
					if ($channels==2 || $channels==3)
					{
						// read service end from key
						$keyEnd = substr($lickey,20);
						$parts = explode('-',$keyEnd);
						if (count($parts)!=2)
						{
							$msg[] = new Msg(MSG_ERR,'Key is not in expected format');
						} else
						{
							$checksum = (SumOnlyDigits(substr($lickey,0,20+strlen($parts[0]))) + 44) % 100;
							if ((int) $checksum != (int) $parts[1])
							{
								//$msg[] = new Msg(MSG_ERR,'Key checksum is invalid');
							} else
							{
								$serviceEnd = (int) $parts[0];
								$allConfigs = $dbintf->LoadConfigs();
								$sysdescr = ComposeSysDescr($allConfigs);
								$configs_s['ServiceSysDescr'] = $sysdescr;
								if ($updatePeriod->updatesUntil >= $serviceEnd)
								{
									$msg[] = new Msg(MSG_WRN,'Existing service period is longer ' . $updatePeriod->updatesUntil);
									$licdone = true;
								} else
								{
									$dbintf->AddLicKey($lickey);
									$configs_s['ServiceEnd'] = $serviceEnd;
									$licdone = true;
								}
							}
						}
					}
				}
				if ($licdone==false)
				{
					// check if this is an unbound channel license key
					$onlineprods = array(32,34,36,38,40,44,46,48,50);
					foreach ($onlineprods as $prodcode)
					{
						$channels = CheckLicenseKeySerial($lickey,$prodcode,0);
						if ($channels!==false)
						{
							$msg[] = new Msg(MSG_WRN,'This key must be activated online first');
							$licdone = true;
						}
					}
				}
				if ($licdone==false)
				{
					$channels = CheckLicenseKeySerial($lickey,42,0);
					if ($channels!==false)
					{
						$msg[] = new Msg(MSG_WRN,'This is not a channel license key, but a system license key.');
						$licdone = true;
					}
				}
				if ($licdone==false)
				{
	        // if none matches, then invalid
	        $msg[] = new Msg(MSG_ERR,'License key is invalid.');
				}
      }

      $dbintf->SetConfigsPart($configs_n,'n');
      $dbintf->SetConfigsPart($configs_s,'s');
      $dbintf->SetConfigsPart($configs_o,'o');
      $dbintf->SetConfigsPart($configs_web,'web');
      $dbintf->SetConfigsPart($configs_crec,'crec');
      $dbintf->SetConfigsPart($configs_scribe,'scribe');
			
			if(isset($_POST['TunnelIDs']))
			{
				$tunnelIDs = explode(',', $_POST['TunnelIDs']);
				$tunnelHasPwds = explode(',', $_POST['TunnelHasPwds']);
				$tunnelPwds = explode(',', $_POST['TunnelPwds']);
				$tunnelTenants = explode(',', $_POST['TunnelTenants']);
				$tunnelNames = explode(',', $_POST['TunnelNames']);
				
				foreach($tunnelIDs as $ix => $id)
				{
					if(strlen($id) == 12)
					{
						$vtap = array();
						$vtap['vtap_id'] = strtoupper($id);
						if($tunnelHasPwds[$ix] == '1' && $tunnelPwds[$ix] != '')
						{
							$vtap['password'] = bin2hex(passwordEncrypt('TheTnPwdKey', $tunnelPwds[$ix], 'nofb'));
						}
						else if($tunnelHasPwds[$ix] == '0')
						{
							$vtap['password'] = '';
						}
						
						if($tunnelTenants[$ix] != '0')
						{
							$vtap['tenantid'] = $tunnelTenants[$ix];
						}
						else
						{
							$vtap['tenantid'] = NULL;
						}

						$vtap['name'] = $tunnelNames[$ix];

						$dbintf->UpdateOrCreateVTap($vtap);
					}
				}
			}
			
			if(isset($_POST['TunnelDeletions']))
			{
				$tunnelDeleteConfigs = explode(',', $_POST['TunnelDeletions']);
				foreach($tunnelDeleteConfigs as $id)
				{
						$dbintf->DeleteVTap($id);
				}
			}

      if (isset($_POST['AzureApps']))
      {
        //var_dump( $_POST['ExtIdps'] );
        $existingList = $dbintf->GetAzureApps();
        $newdefList = json_decode( $_POST['AzureApps'] , true);
        $copyCols = array( 'name'
        , 'appid' , 'appsecret' , 'mstenant'
        , 'importphones_bphones'
        , 'importphones_upn'
        , 'importphones_mobile'
        , 'importphones_name'
        );
        foreach ($existingList as $existing)
        {
          // do we find this existing in the new list?
          $found = false;
          foreach ($newdefList as $key => $newdef)
          {
            // we match on ID
            if ($newdef['id']==$existing['id'])
            {
              $found = true;
              // edit
              $obj = array();
              foreach ($copyCols as $col)
              {
                if (array_key_exists($col,$newdef)==false) continue;
                $obj[$col] = $newdef[$col];
                if ($col=='appsecret')
                {
                  $obj[$col] = encrypt( $obj[$col] );
                }
              }
              $dbintf->EditAzureApp($existing['id'],$obj);
              unset( $newdefList[$key] );
              break;
            }
          }
          if ($found==false)
          {
            // not found, so delete
            $dbintf->DeleteAzureApp($existing['id']);
          }
        }
        // existing accounts are deleted from newdefList during editing
        // what is left in newdefList are only new IdPs
        foreach ($newdefList as $newdef)
        {
          // add
          $obj = array();
          foreach ($copyCols as $col)
          {
            if (array_key_exists($col,$newdef)==false) continue;
            $obj[$col] = $newdef[$col];
            if ($col=='appsecret')
            {
              $obj[$col] = encrypt( $obj[$col] );
            }
          }
          $newid = $dbintf->AddAzureApp($obj);
        }
      }
      
      if (isset($_POST['ExtIdps']))
      {
        //var_dump( $_POST['ExtIdps'] );
        $existingList = $dbintf->GetExtIdPs();
        $newdefList = json_decode( $_POST['ExtIdps'] , true);
        $copyCols = array( 'name', 'tech', 'entityid', 'cert'
        , 'signonurl' , 'extlogout' , 'signoffurl'
        , 'azureapp'
        );
        foreach ($existingList as $existing)
        {
          // do we find this existing in the new list?
          $found = false;
          foreach ($newdefList as $key => $newdef)
          {
            // we match on ID
            if ($newdef['id']==$existing['id'])
            {
              $found = true;
              // edit
              $obj = array();
              foreach ($copyCols as $col)
              {
                if (array_key_exists($col,$newdef)==false) continue;
                $obj[$col] = $newdef[$col];
                if ($col=='azureapp' && $obj[$col]=='null')
                {
                  $obj[$col] = null;
                }
              }
              if ($obj['cert']===NULL)
              {
                $dbintf->DeleteCertificateUse( 'Saml_' . $existing['id'] );
              } else
              {
                $dbintf->SetCertificateUse( 'Saml_' . $existing['id'] , (int) $obj['cert'] );
              }
              // check if azure app ref is valid
              if (isset($obj['azureapp']))
              {
                $app = $dbintf->GetAzureApp( $obj['azureapp'] );
                if ($app===false)
                {
                  // reference invalid, so set to null
                  // this could happen when an azure app is deleted above
                  $obj['azureapp'] = null;
                }
              }
              $dbintf->EditExtIdP($existing['id'],$obj);
              unset( $newdefList[$key] );
              break;
            }
          }
          if ($found==false)
          {
            // not found, so delete
            $dbintf->DeleteExtIdP($existing['id']);
            $dbintf->DeleteCertificateUse( 'Saml_' . $existing['id'] );
          }
        }
        // existing accounts are deleted from newdefList during editing
        // what is left in newdefList are only new IdPs
        foreach ($newdefList as $newdef)
        {
          // add
          $obj = array();
          foreach ($copyCols as $col)
          {
            $obj[$col] = $newdef[$col];
            if ($col=='azureapp' && $obj[$col]=='null')
            {
              $obj[$col] = null;
            }
          }
          // check if azure app ref is valid
          if (isset($obj['azureapp']))
          {
            $app = $dbintf->GetAzureApp( $obj['azureapp'] );
            if ($app===false)
            {
              // reference invalid, so set to null
              // this could happen when an azure app is deleted above
              $obj['azureapp'] = null;
            }
          }
          $newid = $dbintf->AddExtIdP($obj);
          if ($obj['cert']!==NULL)
          {
            $dbintf->SetCertificateUse( 'Saml_' . $newid , (int) $obj['cert'] );
          }          
        }
      }
      
      if (isset($_POST['CjAccounts']))
      {
        // Cisco JTAPI accounts
        // There requires special handling
        $existingList = $dbintf->GetCjAccounts();
        $newdefList = json_decode( $_POST['CjAccounts'] , true);
        //var_dump( $existingList );
        //var_dump( $newdefList );
        //exit;
        foreach ($existingList as $existing)
        {
          // do we find this existing in the new list?
          $found = false;
          foreach ($newdefList as $key => $newdef)
          {
            // we match on ID
            if ($newdef['id']==$existing['id'])
            {
              $found = true;
              // edit
              $obj = array();
              $obj['server'] = $newdef['server'];
              $obj['usr'] = $newdef['usr'];
              if (isset($newdef['pwd']))
              {
                $obj['pwd'] = encrypt( $newdef['pwd'] );
              }
              $dbintf->EditCjAccount($existing['id'],$obj);
              unset( $newdefList[$key] );
              break;
            }
          }
          if ($found==false)
          {
            // not found, so delete
            $dbintf->DeleteCjAccount($existing['id']);
          }
        }
        // existing accounts are deleted from newdefList during editing
        // what is left in newdefList are only new Cj accounts
        foreach ($newdefList as $newdef)
        {
          // add
          $obj = array();
          $obj['server'] = $newdef['server'];
          $obj['usr'] = $newdef['usr'];
          $obj['pwd'] = encrypt( $newdef['pwd'] );
          $dbintf->AddCjAccount($obj);
        }
      }

			if(isset($_POST['SamlCert']))
      {
				$certid = (int) $_POST['SamlCert'];
				if($certid > 0)
				{
					$set = $dbintf->SetCertificateUse('Saml', $certid);
				}
				else
				{
					$dbintf->DeleteCertificateUse('Saml');
				}
			}
			
			if(isset($_POST['HttpsServerCert']))
			{
				$certid = (int) $_POST['HttpsServerCert'];
				if($certid > 0)
				{
					$set = $dbintf->SetCertificateUse('Https', $certid);
				}
				else
				{
					$dbintf->DeleteCertificateUse('Https');
				}
				
				if($set)
				{
					$set = msg_signal_service($msg, 'xcertmake');
				}
			}

      if(isset($_POST['TunnelTLSCert']))
      {
        $certid = (int) $_POST['TunnelTLSCert'];
        if($certid > 0)
				{
					$set = $dbintf->SetCertificateUse('TunnelTLS', $certid);
				}
				else
				{
					$dbintf->DeleteCertificateUse('TunnelTLS');
				}

        if($set)
				{
					$set = msg_signal_service($msg, 'tunneltlscert');
				}
      }
      
      if (isset($_POST['TenantPhonesOnlyEnabled']))
      {
        EnginesSettingsCalcApply(false,false);
      }
				
      $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));

      msg_signal_service($msg,'ns');
      msg_signal_service($msg,'ss');
      msg_signal_service($msg,'os');
      msg_signal_service($msg,'as');
      msg_signal_service($msg,'cjs');
			clusterSystemConfigNotify();
			clusterNetworkConfigNotify();

      if (defined('EMAILQ') && $email_change)
      {
				msg_signal_service($msg,'emailconf '.decrypt($dbintf->GetConfigValue('SMTPpwd')));
			}
			
			if($snmp_change && $dbintf->GetConfigValue('SNMPConfig'))
			{
				msg_signal_service($msg,'snmpconf');
			}
      if(isset($_POST['SNMPGeneralErr']))
      {
        msg_signal_service($msg,'sysinfo');
      }

      if ($_POST['LicKey']!='')
      {
				msg_signal_service($msg,'xlicchk');
				
				$moblic = ( ((int) $dbintf->GetConfigValue('MobileChCnt'))!=0)
					? '1' : '0';
				if ($moblic != $dbintf->GetConfigValue('MobileDevConf'))
				{
					$dbintf->SetConfigsPart(array('MobileDevConf'=>$moblic),'web');
				}
				
				ServiceSysChangeChk();
			}

      CheckRestart('n',$active_cnt);
      CheckRestart('s',$active_cnt);
      CheckRestartOrReconfigO($active_cnt);
      CheckRestart('cj',$active_cnt);

      if (int_ensure_defined($_POST['SendTestMail'])=='1')
      {
        $configs_n = $dbintf->LoadConfigsPart('n');
        SendTestMail($configs_n);
      }
    }
		else if($act == 'mitel-import')
		{
			msg_signal_service($msg, 'mitelimport');
			//DoMitelImport();
		}
		$tab = '0';
		if (isset($_POST['tab']))
		{
			$tab = (int)$_POST['tab'];
		}
		$adv = '0';
		if (isset($_POST['adv']))
		{
			$adv = (int)$_POST['adv'];
		}

		// redirect
		$_SESSION['msg'] = $msg;
		header('Location: '.$rooturl.'systemopt.php?tab='.$tab.'&adv='.$adv);
		exit;
  }

  //var_dump($configs);
  //exit;
	LogAction("Viewed System settings.",array("level"=>"view"));
  
  $data = '';

  $webConfigs = $configs;
  $configs = $dbintf->LoadConfigs();
  // copy for derived things such as 'datef'
  foreach($webConfigs as $key=>$value)
  {
    $configs[ $key ] = $value;
  }
	$configs['ChCnt'] = int_ensure_defined( $configs['ChCnt'] );
	$configs['G729ChCnt'] = int_ensure_defined( $configs['G729ChCnt'] );
	$configs['DstChCnt'] = int_ensure_defined( $configs['DstChCnt'] );
	$configs['AnalogChCnt'] = int_ensure_defined( $configs['AnalogChCnt'] );
	$configs['PriChCnt'] = int_ensure_defined( $configs['PriChCnt'] );
	$configs['MobileChCnt'] = int_ensure_defined( $configs['MobileChCnt'] );
	$configs['RtaChCnt'] = int_ensure_defined( $configs['RtaChCnt'] );
  $configs['ED137ChCnt'] = int_ensure_defined( $configs["ED137ChCnt"] );
	$configs['UnofficialUpdates'] = file_exists('/var/apresa/conf/unofficial_updates')?"1":"0";
	// set defaults to prevent useless prompts
  if(!isset($configs['CollectLogsKeep'])) $configs['CollectLogsKeep'] = 5;
	if(!isset($configs['LdapSyncInt'])) $configs['LdapSyncInt'] = 15;
	if(!isset($configs['ManualAccess'])) $configs['ManualAccess'] = 'all';
  if(!isset($configs['ActiveCallsAccess'])) $configs['ActiveCallsAccess'] = 'users';
	if(!isset($configs['LdapTel1'])) $configs['LdapTel1'] = 'Telephone number (general)';
	if(!isset($configs['LdapTel2'])) $configs['LdapTel2'] = '-';
	if(!isset($configs['LdapTel3'])) $configs['LdapTel3'] = '-';
  if(!isset($configs['EmailConnectType'])) $configs['EmailConnectType'] = 'relay';
  if(!isset($configs['AuditIntf'])) $configs['AuditIntf'] = 'files';
  if(!isset($configs['Scribe_Target'])) $configs['Scribe_Target'] = 'transcript';
	if(!isset($configs['DMCCTriggerPurpose'])) $configs['DMCCTriggerPurpose'] = 'only';
  if(!isset($configs['SsoOneAction'])) $configs['SsoOneAction'] = 'askusr';
  // the defaults should be the same as in engine
	if(!isset($configs['XpertLocalId'])) $configs['XpertLocalId'] = 'line';
  if(!isset($configs['SplitDuration'])) $configs['SplitDuration'] = '' . (24 * 60 * 60);
	if(!isset($configs['CSTAConnectedColumn'])) $configs['CSTAConnectedColumn'] = 1;
  if(!isset($configs['ShoreTelDb_Port'])) $configs['ShoreTelDb_Port'] = '4308';
  if(!isset($configs['ShoreTelDb_DbName'])) $configs['ShoreTelDb_DbName'] = 'Shorewarestatus';
  if(!isset($configs['SipRPIdReceiver'])) $configs['SipRPIdReceiver'] = 1;
  if(!isset($configs['SipUseRequestUri'])) $configs['SipUseRequestUri'] = 1;
	if(!isset($configs['SpeakerbusPort'])) $configs['SpeakerbusPort'] = 5700;
  if(!isset($configs['TunnelAdvancedAlarm'])) $configs['TunnelAdvancedAlarm'] = 1;
  if(!isset($configs['TunnelDisconErr'])) $configs['TunnelDisconErr'] = 1;
	if(!isset($configs['ProtMGCP'])) $configs['ProtMGCP'] = 1;
	//if(!isset($configs['SforceLink_Env'])) $configs['SforceLink_Env'] = 'production';
	if(!isset($configs['ShoreTelDb_Mode'])) $configs['ShoreTelDb_Mode'] = 'internal';
  if(!isset($configs['EmailAttach'])) $configs['EmailAttach'] = 'attach';
  if(!isset($configs['CSTAPassiveMode'])) $configs['CSTAPassiveMode'] = 2;

  // category colors
  $defcolors = GetDefaultCategoryColors();
  $catColors = array();
  for ($i=1;$i<=10;$i++)
  {
    if (!isset($configs['CatColor'.$i]))
    {
      $configs['CatColor' . $i] = $defcolors[$i-1];
    }
    $catColors[] = $configs['CatColor' . $i];
  }
  $data .= 'var catColors = ' . json_encode($catColors) . ";\r\n";
  
  
	$serial = GetSerialNumber();

	$sysdescr = ComposeSysDescr($configs);

	$tab = '0';
	if (isset($_GET['tab']))
	{
		$tab = (int)$_GET['tab'];
	}
	$adv = '0';
	if (isset($_GET['adv']))
	{
		$adv = (int)$_GET['adv'];
	}
	
  $data .= "var configs = []; \r\n";
  $data .= "var serial = '$serial';\r\n";
	$data .= "var sysdescr = \"" . JSQuote($sysdescr) . "\";\r\n";
  $data .= "var active_cnt = $active_cnt; \r\n";
  $data .= "var crec = ".int_ensure_defined( $configs['crec'] )."; \r\n";
  $data .= "var toset_tab = $tab;\r\n";
	$data .= "var toset_adv = $adv;\r\n";
	$data .= "var updatesUntil = \"" . JSQuote($updatePeriod->updatesUntilStr) . "\";\r\n";
  $data .= "var changed = []; \r\n";
  foreach (array('o','s','n','cj') as $part)
  {
    $onoff = 0;
    $data .= "changed['".$part."'] = ".int_ensure_defined($_SESSION['changed_'.$part])."; \r\n";
    unset($_SESSION['changed_'.$part]);
  }
	$data .= "var RemoteShellPwdSet = ".int_ensure_defined($configs['RemoteShellPwdSet']).";\r\n";

  $cfgkeys_out = array_merge($cfgkeys,$cfgkeys_s,$cfgkeys_o,$cfgkeys_crec,$cfgkeys_web,$cfgkeys_scribe);
  $cfgkeys_out[] = 'ChCnt';
  // no longer: $cfgkeys_out[] = 'G729ChCnt';
  $cfgkeys_out[] = 'DstChCnt';
  $cfgkeys_out[] = 'AnalogChCnt';
  $cfgkeys_out[] = 'PriChCnt';
  $cfgkeys_out[] = 'MobileChCnt';
	$cfgkeys_out[] = 'RtaChCnt';
	$cfgkeys_out[] = 'UnofficialUpdates';
	
	foreach($configs as $param=>$value)	//Add all the other LDAP servers and the parameters!
	{
		$pos = strpos($param, "LdapHost");
		if(($pos !== false) && (strlen($param) > strlen("LdapHost")))
		{
			$cfgkeys_out[] = $param;
			$num = substr($param,strlen("LdapHost"));
			$cfgkeys_out[] = 'UsersDomain'.$num;
			$cfgkeys_out[] = 'LdapDomain'.$num;
			$cfgkeys_out[] = 'LdapUser'.$num;
			$cfgkeys_out[] = 'LdapPwd'.$num;
			continue;
		}
	}

	SetHealthConfigDefaults( $configs );
	
	// other defaults
	if (isset($configs['WebSPort'])==false)
	{
		$configs['WebSPort'] = '443';
	}
	if (isset($configs['SMTPport'])==false)
	{
		$configs['SMTPport'] = '25';
	}
	if (isset($configs['TunnelPort'])==false)
	{
		$configs['TunnelPort'] = '2016';
	}
  if(isset($configs['TunnelTLSPort'])==false)
  {
    $configs['TunnelTLSPort'] = '2017';
  }
	if(isset($configs['TunnelDataSeparation'])==false)
	{
		$configs['TunnelDataSeparation'] = 1;
	}
	if (isset($configs['ToshibaSMDRPort']) == false)
	{
		$configs['ToshibaSMDRPort'] = '1109';
	}
	
	//Check CSTA Link Status. It's in /var/apresa/data/csta_status!
	$configs['CSTAType'] = int_ensure_defined($configs['CSTAType']);
	if($configs['CSTAType'] > 0)	//CSTA in use!
	{
    $fvalue = '';
		if(file_exists('../apresa/data/csta_status'))
		{
      $lines = file('../apresa/data/csta_status');
      foreach ($lines as $line)
      {
        $status = explode("=", $line);
        if(count($status) != 2) continue; // invalid
        $errDesc = "";
        if($status[1] != 0)
        {
          $extError = explode(";", $status[1]);
          if(count($extError) == 2)
          {
            $status[1] = $extError[0];
            $errDesc = $extError[1];
          }
        }
        switch($status[1])
        {
        case 0:
          $errDescription = "OK";
        break;
        case 1:
          $errDescription = "Port unknown or incorrect!";
        break;
        case 2:
          $errDescription = "Server address invalid!";
        break;
        case 3:
          $errDescription = "Connection failed!";
        break;
        case 4:
          $errDescription = 'Login rejected-permanent';
        break;
        case 5:
          $errDescription = 'Login rejected-transient';
        break;
        case 6:
          $errDescription = 'Restarting connection because lack of response from CSTA server';
        break;
        case 20:
          $errDescription = "Program closed";
        break;
        case 100:
          $errDescription = "Initializing";
        break;
        case 101:
          $errDescription = "Authentication error!";
        break;
        case 102:
          $errDescription = "Monitor failed!";
        break;
        case 103:
          $errDescription = "SSC failed! ".$errDesc;
        break;
        case 104:
          $errDescription = "Recorder login failed! ".$errDesc;
        break;
        case 105:
          $errDescription = "Recorder registration failed! ".$errDesc;
        break;
        default:
          $errDescription = "Unknown error " . $status[1];
        break;
        }
        if ($fvalue!='') $fvalue .= ', ';
        $fvalue .= $errDescription;
      }
    }
    $data .= "var CSTALinkStatus = \"".JSQuote(str_ensure_defined($fvalue))."\";\r\n";
	}
	
	$machineCfgKeys = array();
  foreach ($cfgkeys_out as $cfgkey)
  {
		if ($dbintf->IsMachineCfgKey($cfgkey,'?'))
		{
			$machineCfgKeys[$cfgkey] = 1;
		}
		// special case: backward compatible
		if ($cfgkey=='ApiAuthE' && isset($configs[$cfgkey])==false)
		{
			// copy from ApiAuth
			$configs[$cfgkey] = encrypt(str_ensure_defined($configs['ApiAuth']));
		}
		if ($cfgkey=='ApiAuth') break;
		// same for CSTAPwd
		if ($cfgkey=='CSTAPwdE' && isset($configs[$cfgkey])==false)
		{
			// copy from CSTAPwd
			$configs[$cfgkey] = encrypt(str_ensure_defined($configs['CSTAPwd']));
		}
		if ($cfgkey=='CSTAPwd') break;
		
		if (IsEncryptedKey($cfgkey)==false)
		{
			if($cfgkey != 'TunnelEncryptionPwd')
			{
				$data .= "configs[\"".$cfgkey."\"] = \"".JSQuote(str_ensure_defined($configs[$cfgkey]))."\";\r\n";
			}
			else
			{
				$pwd = passwordDecrypt('TheTnPwdKey', hex2bin(str_ensure_defined($configs[$cfgkey])), 'nofb');
				$data .= "configs[\"Has_".$cfgkey."\"] = ".(int)(strlen($pwd)>0).";\r\n";
			}
    } else
    {
      $pwd = decrypt(str_ensure_defined($configs[$cfgkey]));
      $data .= "configs[\"Has_".$cfgkey."\"] = ".(int)(strlen($pwd)>0).";\r\n";
    }
  }
	foreach ($cfgkeys_crec as $key)
	{
    if ($dbintf->IsMachineCfgKey($key,'crec'))
    {
      $machineCfgKeys[$key] = 1;
    }
	}
	
  $cjaccounts = $dbintf->GetCjAccounts();
  foreach ($cjaccounts as &$cjacc_ref)
  {
    if ($cjacc_ref['pwd']!='')
    {
      unset( $cjacc_ref['pwd'] );
      $cjacc_ref['HasPwd'] = 1;
    } else
    {
      $cjacc_ref['HasPwd'] = 0;
    }
  }
  $data .= 'var cjaccounts = ' . json_encode($cjaccounts) . ';' . "\r\n";

  $AzureApps = $dbintf->GetAzureApps();
  foreach ($AzureApps as $key => $az)
  {
    $secret = decrypt( $az['appsecret'] );
    unset($AzureApps[$key]['appsecret']);
    $AzureApps[$key]['has_appsecret'] = strlen($secret)>0;
    // debug: $AzureApps[$key]['debug_appsecret'] = $secret;
  }
  $data .= 'var AzureApps = ' . json_encode($AzureApps) . ';' . "\r\n";
  
  $ExtIdPs = $dbintf->GetExtIdPs();
  $data .= 'var ExtIdPs = ' . json_encode($ExtIdPs) . ';' . "\r\n";
  
	$id = $dbintf->GetCertificateFor('Https');
	if($id === false) $id = -1;
  $data .= "configs['HttpsServerCert'] = ". (int) $id . ";\r\n"; 

	$id = $dbintf->GetCertificateFor('Saml');
	if($id === false) $id = -1;
  $data .= "configs['SamlCert'] = ". (int) $id . ";\r\n";

  $id = $dbintf->GetCertificateFor('TunnelTLS');
	if($id === false) $id = -1;
  $data .= "configs['TunnelTLSCert'] = ". (int) $id . ";\r\n"; 
		
	$vtaps = $dbintf->GetVTaps();
	
	$data .= "var TunnelPwds = [";
	$first = true;
	
	foreach($vtaps as $vtap)
	{
		if(str_ensure_defined($vtap['vtap_id']) == "") continue;
		
		if($first == false) $data .= ',';
		else $first = false;
		
		$output = array();
		
		$output['id'] = $vtap['vtap_id'];
		
		if(str_ensure_defined($vtap['password']) != "")
		{
			$dpwd = passwordDecrypt('TheTnPwdKey',hex2bin($vtap['password']),'nofb');
			$output['hasPwd'] = (int)(strlen($dpwd)>0);
		}
		else
		{
			$output['hasPwd'] = 0;
		}
		
		$output['pwd'] = "";
		$output['Tenant'] = int_ensure_defined($vtap['tenantid']);
		$output['name'] = str_ensure_defined($vtap['name']);
		
		$data .= json_encode($output);
	}
	$data .= "];\r\n";
	
	$data .= "var MachineCfgKeys = "
	. json_encode($machineCfgKeys) . ";\r\n";

	$groups = $dbintf->GetNonTenantGroupList();

	$data .= "var grps = [];\r\n";
	foreach($groups as $group)
	{
		$data .= "grps[" . $group['accid'] . "] = " . '"' . JSQuote($group['name']) . '"' . ";\r\n";
	}
	
	$tenants = $dbintf->GetTenantList();
	$data .= "var tenants = [];\r\n";
	
	foreach($tenants as $tenant)
	{
		$data .= "tenants[" . $tenant['tenantid'] . "] = " . '"' . JSQuote($tenant['name']) . '"' . ";\r\n";
	}
	
	$certificates = $dbintf->GetCertificatesWithPrivateKey();
	
	$certdata = "var certificates = [\r\n";
	$certdata .= "{ id: -1, name: " . '"' . $lng->Get('Main.None') . '"' . "},";
	
	$certmap = "var certmap = {\r\n";
	$certmap .= "0:-1,";
	
	$ix = 1;
	foreach($certificates as $cert)
	{
		$certdata .= "\r\n{ id: " . $cert['id']  . ", name: " . '"' . JSQuote($cert['name']) . " (" .  JSQuote($cert['subject']) . ")"  . '"' . "},";
		$certmap .= "\r\n" . $ix . ":" . $cert['id'] . ",";
		$ix++;
	}
	
	$certdata .= "\r\n];\r\n";
	$certmap .= "\r\n};\r\n";

	$certmap .= "var map_HttpsServerCert = certmap;\r\n";
	$certmap .= "var map_SamlCert = certmap;\r\n";
  $certmap .= "var map_TunnelTLSCert = certmap;\r\n";
	
	$data .= $certdata;
	$data .= $certmap;

	$certificates = $dbintf->GetCertificates();
	
	$certdata = "var allcertificates = [\r\n";
	$certdata .= "{ id: -1, name: " . '"' . $lng->Get('Main.None') . '"' . "},";

	$certmap = "var allcertmap = {\r\n";
	$certmap .= "0:-1,";
	
	$ix = 1;
	foreach($certificates as $cert)
	{
		$certdata .= "\r\n{ id: " . $cert['id']  . ", name: " . '"' . JSQuote($cert['name']) . " (" .  JSQuote($cert['subject']) . ")"  . '"' . "},";
		$certmap .= "\r\n" . $ix . ":" . $cert['id'] . ",";
		$ix++;
	}
	
	$certdata .= "\r\n];\r\n";
	$certmap .= "\r\n};\r\n";
	
	
	$data .= $certdata;
	$data .= $certmap;
	
	$hascertold = @file_exists('/etc/lighttpd/conf-enabled/server-cert.conf')?'1':'0';
	$hascert = (count($certificates) > 0 || $hascertold) ? 1 : 0;
	$data .= "var hascert = $hascert;\r\n";
	

	
  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();
  $data .= "var ip = '" . $_SERVER['SERVER_ADDR'] . "';";

  $template_content = file_get_contents('../apresa/templ/systemopt.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
	$rpl['SN'] = $serial;
	$rpl['sysdescr'] = $sysdescr;
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

?>