<?php

require_once('general.php');

HandlePage($dbintf);

function GetSerialNumber()
{
	return file_get_contents('../apresa/conf/serial');
}

function HandlePage($dbintf)
{
  global $rpl,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

  $active_cnt = $dbintf->GetActiveCallsCount();

	$serialnum = (int) GetSerialNumber();

	$crec_installed = false;
	if (!defined('DEMO'))
	{
		$lsmodlines = array();
		exec('lsmod',$lsmodlines);
		foreach ($lsmodlines as $lsmodline)
		{
			$parts = preg_split('/[\s]+/',$lsmodline,-1,PREG_SPLIT_NO_EMPTY);
			if ($parts[0]=='shdpci')
			{
				$crec_installed = true;
			}
		}
		$cfg_crec = $dbintf->GetConfigValue('crec');
		if ($cfg_crec!=1 && $crec_installed)
		{
			$newcfg = array();
			$newcfg['crec'] = '1';
			$dbintf->SetConfigsPart($newcfg,'s');
			$newcfg = array();
			$newcfg['col_linenr'] = '1';
			$dbintf->SetConfigsPart($newcfg,'web');
			$msg[] = new Msg(MSG_INF,'Card recording enabled. Restart the recording component to activate.');
		}
	}

	if (isset($_GET['drivertry']))
	{
		if ($crec_installed)
    {
			$msg[] = new Msg(MSG_INF,$lng->Get('System.DriverOK'));
		} else
		{
			$msg[] = new Msg(MSG_ERR,$lng->Get('System.DriverFail'));
		}
	}

	$zonesroot = '/usr/share/zoneinfo/'; 
	
  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='settime')
    {
			LogAction('Set time');
			$time = $_POST['time'];
			$h = (int) substr($time,0,2);
			$m = (int) substr($time,3,2);
			msg_signal_service($msg,'xtime '.sprintf('%02d',$h).sprintf('%02d',$m));
	    $_SESSION['msg'] = $msg;
	    header('Location: '.$rooturl.'systools.php');
			exit;
		}
    if ($act=='setdate')
    {
			LogAction('Set date');
			$date = $_POST['date'];
			$y = (int) substr($date,0,4);
			$mo = (int) substr($date,5,2);
			$d = (int) substr($date,8,2);
			$h = (int) substr($date,11,2);
			$m = (int) substr($date,14,2);
			$cmd = 'xtime '.sprintf('%04d',$y).'-'.sprintf('%02d',$mo).'-'.sprintf('%02d',$d)
				.' '.sprintf('%02d',$h).sprintf('%02d',$m);
			msg_signal_service($msg,$cmd);
	    $_SESSION['msg'] = $msg;
	    header('Location: '.$rooturl.'systools.php');
			exit;
		}
		if ($act=='settz')
		{
			LogAction('Set time zone');
			$geo = $_POST['geo'];
			$city = $_POST['city'];
			$tz = $geo . '/' . $city;
			$fn = $zonesroot.$tz;
			if (is_file($fn)==false)
			{
        $msg[] = new Msg(MSG_ERR,'Time zone does not exist');
			} else
			{
				$cmd = 'settimezone '.$tz;
				signal_service($cmd);
			}
	    $_SESSION['msg'] = $msg;
	    header('Location: '.$rooturl.'systools.php?tzretry=1');
			exit;
		}
    if ($act=='installcarddriver')
    {
			LogAction('Install card driver');
      if (msg_signal_service($msg,'xdriver'))
      {
        // we cannot know here yet
      } else {
        $msg[] = new Msg(MSG_ERR,'Driver failed to install');
      }
	    // redirect
	    $_SESSION['msg'] = $msg;
	    header('Location: '.$rooturl.'systools.php?drivertry=1');
	    exit;
		}
		if ($active_cnt>0 && $act!='trace' && $_POST['restart_force']==false)
    {
      $msg[] = new Msg(MSG_ERR,$lng->Get('System.CallsActive').' '.$lng->Get('System.RepeatToForceAction'));
    } else
    {
      if ($act=='sys_restart')
      {
			  LogAction('System restart');
				$signal_ret = signal_service('sr');
        if ($signal_ret=='')
        {
          // Don't say, because it will be shown AFTER the reboot
          /*
          $t = $lng->Get('System.RestartComponentBusy');
          $t = str_replace('%1',$lng->Get('System.TheSys'),$t);
          $t = ucfirst($t);
          $msg[] = new Msg(MSG_INF,$t);
          */
        } else {
          $msg[] = new Msg(MSG_ERR,'System restart failed');
        }
      }
      if ($act=='netw_restart')
      {
			  LogAction('Network restart');
				$signal_ret = signal_service('nr');
        if ($signal_ret=='')
        {
          $t = $lng->Get('System.RestartComponentBusy');
          $t = str_replace('%1',$lng->Get('System.TheNetwComp'),$t);
          $t = ucfirst($t);
          $msg[] = new Msg(MSG_INF,$t);
        } else {
          $msg[] = new Msg(MSG_ERR,'Network restart failed ('.$signal_ret.')');
        }
      }
      if ($act=='rec_restart' || $act=='rec_restartC')
      {
			  LogAction('Recording component restart');
				$cmd = 'or';
				if ($act=='rec_restartC') $cmd = 'oR';
        if (msg_signal_service($msg,$cmd))
        {
          $t = $lng->Get('System.RestartComponentBusy');
          $t = str_replace('%1',$lng->Get('System.TheRecComp'),$t);
          $t = ucfirst($t);
          $msg[] = new Msg(MSG_INF,$t);
        } else {
          $msg[] = new Msg(MSG_ERR,'Recording component restart failed');
        }
				clusterConfigNotify(true);
      }
      if ($act=='sys_end')
      {
			  LogAction('System halt');
	  		$dbintf->DeleteSession(session_id());
	  		end_of_session();

				$signal_ret = signal_service('se');
        if ($signal_ret=='')
        {
          // Don't say, because it will be shown AFTER the shutdown
          //$msg[] = new Msg(MSG_INF,$lng->Get('System.ShutdownSysBusy'));
        } else {
          $msg[] = new Msg(MSG_ERR,'System shutdown failed');
        }
      }
      if ($act=='trace')
      {
        $trace = (int) $_POST['trace'];
			  LogAction('Trace on/off: '.$trace);
				$configs = $dbintf->LoadConfigs();
        $eth_port = (int) $configs['VoIPnetw'];
				$boundless = int_ensure_defined($_POST['boundless']);
        if (msg_signal_service($msg,"xtrace $trace $eth_port $boundless"))
        {
					// If succeeded, also save in DB
					$dbintf->SetConfigsPart(array('NetwTrace'=>$trace),'s');
				}
			}
    }
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'systools.php');
    exit;
  }

  $configs = $dbintf->LoadConfigs();
	LogAction("Viewed System tools.",array("level"=>"view"));
  // ready with database
  $dbintf->close();

	$curtz = '';
	$curtz_geo = '';
	$curtz_city = '';
	
	$data = 'var zones = {};';
	if (!defined('DEMO') && is_dir($zonesroot))
	{
		// load time zone list
		// For GEOs
		// use fixed list, because ...
		$main_geos = array(
			'Africa', 'America', 'Antarctica', 'Arctic', 'Asia',
			'Atlantic', 'Australia', 'Europe', 'Indian', 'Pacific',
			'US', 'Etc'
		);
		$zoneinfo = array();

		$curtz = trim(file_get_contents('/etc/timezone'));
		$parts = explode('/',$curtz);
		$curtz_geo = $parts[0];
		$curtz_city = $parts[1];
		
		foreach ($main_geos as $geo)
		{
			if (is_dir($zonesroot.$geo)==false) continue;
			//echo $geo . "\n";
			$data .= "zones['".$geo."'] = [";
			$firstcity = true;
			
			$cities = array();
			$items = scandir($zonesroot.$geo.'/');
			foreach ($items as $item)
			{
				$fn = $zonesroot.$geo.'/'.$item;
				if ($item=='.' || $item=='..') continue;
				if (is_dir($fn))
				{
					$subitems = scandir($fn);
					foreach ($subitems as $subitem)
					{
						$subfn = $fn . '/' . $subitem;
						if ($subitem=='.' || $subitem=='..') continue;
						if (is_file($subfn)==false) continue;
						$fullsubitem = $item . '/' . $subitem;
						if ($firstcity) $firstcity = false;
						else $data .= ',';
						$data .= '"'.JSQuote($fullsubitem).'"';
					}
					continue;
				}
				if (is_file($fn)==false) continue;
				
				//echo $geo.'/'.$item . "\n";
				if ($firstcity) $firstcity = false;
				else $data .= ',';
				$data .= '"'.JSQuote($item).'"';
			} // cities loop
			$data .= "];\n";
		} // geo loop
	} // not demo, zones info there
	
	$data .= 'var curtz = "' . JSQuote($curtz) . '";'
		. "\n";
	$data .= 'var curtz_geo = "' . JSQuote($curtz_geo) . '";'
		. "\n";
	$data .= 'var curtz_city = "' . JSQuote($curtz_city) . '";'
		. "\n";

	if (int_ensure_defined($_GET['tzretry']))
	{
		header('Refresh: 10; url='.$rooturl.'systools.php');
		$data .= 'var servertime = "' . date('Y-m-d H:i:s') . ' ... ... ...";';
	} else
	{
		$data .= 'var servertime = "' . date('Y-m-d H:i:s') . '";';
	}
	
  $audit = (int_ensure_defined($configs['Audit'])!=0)
    || (int_ensure_defined($configs['AuditDb'])!=0);
  
  $data .= "var active_cnt = $active_cnt; \r\n";
  $data .= 'var curv = "' . APRESA_VERSION . '";';
  $data .= 'var serialnum = "' . $serialnum . '";';
  $data .= 'var crec_installed = ' . ($crec_installed?"true":"false") . ';';
  $data .= 'var audit = ' . ($audit?1:0) . ';';

  $data .= 'var NetwTrace = '.int_ensure_defined($configs['NetwTrace']).';'."\r\n";

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/systools.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
