<?php
require_once 'utility.php';
require_once 'actions.php';
require_once 'cedb.php';

function GetDefTenantStatsObj()
{
	return array
		( 'sz' => 0
		, 'cnt' => 0
		);
}

function TnStatsCB(&$ref_cfg,&$ref_result,$row)
{
	$bytes = GetCallStorage($row);
	$ref_cfg['cnt']++;
	if ($ref_cfg['cnt'] % 1000 == 0)
	{
		//lg('done '.$ref_cfg['cnt']);
	}
	//lg('CALL id:'.$row['id'].' sz:'.round($bytes/1024).' KB');
	$ref_tenants = &$ref_cfg['tenants'];
	if (isset($ref_tenants[ $row['tenantid'] ])==false)
	{
		// new tenant object to store statistics
		$ref_tenants[ $row['tenantid'] ] = GetDefTenantStatsObj();
	}
	$ref_tenant = & $ref_tenants[ $row['tenantid'] ];
	$newsz = $ref_tenant['sz'] + $bytes;
	$ref_tenant['sz'] += $bytes;
	$ref_tenant['cnt'] += 1;
	return true;
}

function TenantsStorageReset()
{
	global $dbintf;
	$configs_tn_new = array();
	$tenants = $dbintf->GetTenantList();
	foreach ($tenants as $tenant)
	{
		$prefix = 'TN' . $tenant['id'] . '_';
		$configs_tn_new[$prefix . 'DiskUsage'] = '0';
		$configs_tn_new[$prefix . 'RecCnt'] = '0';
	}
	$dbintf->SetConfigsPart($configs_tn_new, 'tn');
}

// function not actively used
// it is called by RedoTnStats from specialtask
// but that function has no interface
function TenantsCalcStorage($storeInDb)
{
	global $dbintf;
  if (LockTenantAction()==false)
  {
    addToSay(MSG_ERR,'A tenant action is still busy');
    return;
  }
  try
  {
    $activity = "<%Tenancy.RecalcStats%> (<%Backup.LocalDisk%>)";
    lg('Tenants calc. storage usage');
    WriteTenantMsg(MSG_INF,"$activity ...");
    $configs_tn = $dbintf->LoadConfigsPart('tn');
    $anyWithLimit = false;
    $tenants = $dbintf->GetTenantList();
    foreach ($tenants as $tenant)
    {
      $prefix = 'TN' . $tenant['id'] . '_';
      $maxsz = int_ensure_defined($configs_tn[$prefix . 'MaxDiskUsage']);
      if ($maxsz>0)
      {
        $anyWithLimit = true;
      }
    }
    $cfg = array();
    $cfg['tenants'] = array();
    $MB = 1024 * 1024;
    $tenants = $dbintf->GetTenantList();
    foreach ($tenants as $tenant)
    {
      $prefix = 'TN' . $tenant['id'] . '_';
      $maxsz = int_ensure_defined($configs_tn[$prefix . 'MaxDiskUsage']);
      $cfg['tenants'][ $tenant['id'] ] = GetDefTenantStatsObj();
      if ($maxsz>0)
      {
        $cfg['tenants'][ $tenant['id'] ]['maxsz'] = $maxsz * $MB;
        $cfg['tenants'][ $tenant['id'] ]['maxsz_mb'] = $maxsz;
      }
      //lg('Tenant ' . $tenant['name'] . ' max: '. $maxsz . ' MB');
    }
    $now = time();
    // limiting the number of fields, speeds things up enormuously
    $cfg['cols'] = array( 'tenantid', 'id', 'directory', 'filename', 'flags', 'screenfn' );
    $cfg['tenancy'] = true;
    $cfg['isarchived'] = true;
    $cfg['cnt'] = 0;
    $dbintf->CallWalker( $cfg, 'TnStatsCB' );
    
    $anyDifference = false;
    $configs_tn_new = array();
    foreach ($tenants as $tenant)
    {
      $tn = $cfg['tenants'][ $tenant['id'] ];
      $line = 'TN'.$tenant['id'] . ': ' . $tenant['name'] . ' max:';
      if (isset($tn['maxsz'])==false)
      {
        $line .= ' unlimited';
      } else
      {
        $line .= ' ' . $tn['maxsz_mb'] . ' MB';
      }
      $line .= ' uses: ' . $tn['sz'] . ' = ' . showmb($tn['sz'],1);
      $line .= ' (' . $tn['cnt'] . ' x)';
      $prefix = 'TN' . $tenant['id'] . '_';
      if ($tn['cnt'] != int_ensure_defined($configs_tn[ $prefix . 'RecCnt' ])) $anyDifference = true;
      if ($tn['sz'] != int_ensure_defined($configs_tn[ $prefix . 'DiskUsage' ])) $anyDifference = true;
      $line .= ' in db: ' . int_ensure_defined($configs_tn[ $prefix . 'DiskUsage' ]) . ' (' . int_ensure_defined($configs_tn[ $prefix . 'RecCnt' ]) . " x)";
      lg($line);
      // to store in DB
      $configs_tn_new[$prefix . 'DiskUsage'] = $tn['sz'];
      $configs_tn_new[$prefix . 'RecCnt'] = $tn['cnt'];
      // not needed: $configs_tn_new[$prefix . 'DiskUsageCheckTime'] = $now;		
    }
    if ($anyDifference) lg('There were one or more differences');
    else lg('No differences found during recalculation (OK)');
    if ($storeInDb)
    {
      lg('Store results in DB');
      $dbintf->SetConfigsPart($configs_tn_new, 'tn');
      addToSayRaw(MSG_INF,"<%CE.Done%>: $activity");
    }
    
    // do we have data about all calls?
    if ($cfg['tenancy']==false)
    {
      $tn = $cfg['tenants'][NULL];
      $line = 'Without tenant';
      $line .= ' uses: ' . showmb($tn['sz'],1);
      $line .= ' (' . $tn['cnt'] . 'x)';
      lg($line);
    }
  } catch(Exception $e)
  {
    lg('TenantsCalcStorage failed: '.$e->getMessage());
    addToSayRaw(MSG_ERR,"<%Main.Error%>. $activity: ".HtmlQuote($e->getMessage()) );
  }

  RemoveTenantMsg();
  UnlockTenantAction();  
}

function TnBckStatsCB(&$ref_cfg,&$ref_result,$row)
{
  if (count(GetCallFiles($row,$ref_cfg['basepath']))==0)
  {
    // no recording stored at all
    return true;
  }
  $bytes = GetCallStorageEx($row,$ref_cfg['basepath']);
  // if no files are on the backup disk anymore,
  // do we still count it?
  // yes, to keep count consistent
  // so not: if ($bytes==0) return true;

	//lg('CALL id:'.$row['id'].' sz:'.round($bytes/1024).' KB , tn:' . $row['tenantid'] );
	$ref_tenants = &$ref_cfg['tenants'];
	if (isset($ref_tenants[ $row['tenantid'] ])==false)
	{
		// new tenant object to store statistics
		$ref_tenants[ $row['tenantid'] ] = GetDefTenantStatsObj();
	}
	$ref_tenant = & $ref_tenants[ $row['tenantid'] ];
	$newsz = $ref_tenant['sz'] + $bytes;
	$ref_tenant['sz'] += $bytes;
	$ref_tenant['cnt'] += 1;
  return true;
}

// used after CallsArchiveImport
function RecalcTnBckStats($storeInDb,$basepath)
{
	global $dbintf;
  if (LockTenantAction()==false)
  {
    addToSay(MSG_ERR,'A tenant action is still busy');
    return;
  }
  try
  {
    $activity = "<%Tenancy.RecalcStats%> (<%System.Backup%>)";  
    lg('Tenants recalc. backup storage usage ' . $basepath);
    WriteTenantMsg(MSG_INF,"$activity ...");
    $configs_tn = $dbintf->LoadConfigsPart('tn');
    $tenants = $dbintf->GetTenantList();
    $cfg = array();
    $cfg['tenants'] = array();
    foreach ($tenants as $tenant)
    {
      $cfg['tenants'][ $tenant['id'] ] = GetDefTenantStatsObj();
    }
    $MB = 1024 * 1024;
    $now = time();
    // limiting the number of fields, speeds things up enormuously
    $cfg['cols'] = array( 'tenantid', 'id', 'directory', 'filename', 'flags', 'screenfn' );
    $cfg['tenancy'] = true;
    $cfg['isarchived'] = true;
    $cfg['archive'] = true;
    $cfg['basepath'] = $basepath;
    $cfg['cnt'] = 0;
    $dbintf->CallWalker( $cfg, 'TnBckStatsCB' );

    $anyDifference = false;
    $configs_tn_new = array();
    foreach ($tenants as $tenant)
    {
      $tn = $cfg['tenants'][ $tenant['id'] ];
      $line = 'TN' . $tenant['id'] . ': ' . $tenant['name'];
      $line .= ' uses backup : ' . $tn['sz'] . ' = ' . showmb($tn['sz'],1);
      $line .= ' (' . $tn['cnt'] . 'x)';
      $prefix = 'TN' . $tenant['id'] . '_';
      if ($tn['cnt'] != int_ensure_defined($configs_tn[ $prefix . 'Backup' . 'RecCnt' ])) $anyDifference = true;
      if ($tn['sz'] != int_ensure_defined($configs_tn[ $prefix . 'Backup' . 'DiskUsage' ])) $anyDifference = true;
      $line .= ' in db: ' . int_ensure_defined($configs_tn[ $prefix . 'Backup' . 'DiskUsage' ]) . ' (' . int_ensure_defined($configs_tn[ $prefix . 'Backup' . 'RecCnt' ]) . " x)";
      lg($line);
      // to store in DB
      $configs_tn_new[$prefix . 'Backup' . 'DiskUsage'] = $tn['sz'];
      $configs_tn_new[$prefix . 'Backup' . 'RecCnt'] = $tn['cnt'];
      // not needed: $configs_tn_new[$prefix . 'DiskUsageCheckTime'] = $now;		
    }
    if ($anyDifference) lg('There were one or more differences');
    else lg('No differences found during recalculation (OK)');
    //var_dump( $configs_tn_new );
    if ($storeInDb)
    {
      lg('Store results in DB');
      $dbintf->SetConfigsPart($configs_tn_new, 'tn');
      addToSayRaw(MSG_INF,"<%CE.Done%>: $activity");
    }
  } catch(Exception $e)
  {
    lg('RecalcTnBckStats failed: '.$e->getMessage());
    addToSayRaw(MSG_ERR,"<%Main.Error%>. $activity: ".HtmlQuote($e->getMessage()) );
  }

  RemoveTenantMsg();
  UnlockTenantAction();  
}



// similar to UpdateTnDiskUsage
// but then for backup storage
function UpdateTnBackupDiskUsage($tenantid, $sizechange, $cntchange)
{
	global $dbintf;
	$f = function () use ($tenantid, $sizechange, $cntchange)
	{
		return UpdateTnBackupDiskUsageT($tenantid, $sizechange, $cntchange);
	};
	return $dbintf->TransactionRetry( $f );
}

function UpdateTnBackupDiskUsageT($tenantid, $sizechange, $cntchange)
{
	global $dbintf;
	$dbintf->StartTransaction();
	// verbose: lg("Adding $sizechange to backup for tn ".$tenantid.' cnt:'.$cntchange);
	$prfx = 'TN' . $tenantid . '_';
	$dukey  = $prfx . 'Backup' . 'DiskUsage';
	$rckey  = $prfx . 'Backup' . 'RecCnt';
	$val    = (int) $dbintf->GetConfigValue($dukey);
	$RecCnt = (int) $dbintf->GetConfigValue($rckey);
	$RecCnt += $cntchange;
	$val += $sizechange;
	$dbintf->AddToConfig($rckey,$cntchange,'tn');
	$dbintf->AddToConfig($dukey,$sizechange,'tn');
	$dbintf->CommitTransaction();
	if ( ($RecCnt % 100) == 0 )
	{
		$groupinfo = $dbintf->GetGroupInfo($tenantid);
		lg("Tenant " . $groupinfo['name'] . " backup disk usage: " . showkb($val)	. ' cnt: ' . $RecCnt );
	}
}



// Updates incrementally disk usage and count statistics of tenants
// If a disk usage limit is set, it applies this limit.
// $sizechange = extra bytes to add (or subtract)
// $cntchange = extra recordings that are added (usually will be +1 or -1)
function UpdateTnDiskUsage($tenantid, $sizechange, $cntchange)
{
	global $dbintf;
	$f = function () use ($tenantid, $sizechange, $cntchange)
	{
		return UpdateTnDiskUsageT($tenantid, $sizechange, $cntchange);
	};
	return $dbintf->TransactionRetry( $f );
}

function UpdateTnDiskUsageT($tenantid, $sizechange, $cntchange)
{
	global $dbintf;
	$dbintf->StartTransaction();
	// verbose: lg("Adding $sizechange to tn ".$tenantid.' cnt:'.$cntchange);
	$prfx = 'TN' . $tenantid . '_';
	$dukey  = $prfx . 'DiskUsage';
	$maxkey = $prfx . 'MaxDiskUsage';
	$rckey  = $prfx . 'RecCnt';
	$val    = (int) $dbintf->GetConfigValue($dukey);
	$maxval = (int) $dbintf->GetConfigValue($maxkey);
	$RecCnt = (int) $dbintf->GetConfigValue($rckey);
	$RecCnt += $cntchange;
	$maxval *= 1024 * 1024;
	$val += $sizechange;
	$toset = array();
	if ($maxval!=0 && $val > $maxval)
	{
		lg("TN reached limit, deleting to free space");
		$KeepDelListed = (int) $dbintf->GetConfigValue('KeepDelListed');
    $KeepAgEvListed = (int) $dbintf->GetConfigValue('KeepAgEvListed');
    $DeleteMode = 0;
    if ($KeepDelListed!=0) $DeleteMode = 1;
    else
    {
      if ($KeepAgEvListed) $DeleteMode = 3;
      else $DeleteMode = 2;
    }
		$i = 0;
		while ($val > $maxval)
		{
			require_once 'actions.php';
			// safety break
			$i ++;
			if ($i>100) break;
			// get oldest recordings
			$calls = $dbintf->GetOlderRecordings(FALSE, 10, $DeleteMode, $tenantid);
			foreach ($calls as $call)
			{
				$callStorage = GetCallStorage($call);
				$val -= $callStorage;
				$sizechange -= $callStorage;
				AutoDeleteCall($call,$KeepDelListed,$KeepAgEvListed);
        if ($call['isarchived']!=0)
        {
          $RecCnt --;
          $cntchange --;
        }
				// check if ready
				if ($val <= $maxval) break;
			}
		}
	}
	// old style had issues with concurrency:
	// $toset[$rckey] = $RecCnt;
	// $toset[$dukey] = $val;
	// $dbintf->SetConfigsPart( $toset , 'tn' );	
	// end block old style
	$dbintf->AddToConfig($rckey,$cntchange,'tn');
	$dbintf->AddToConfig($dukey,$sizechange,'tn');
	$dbintf->CommitTransaction();
	
	// verbose: lg("New disk usage: " . showkb($val)	. ' (' . $RecCnt . 'x)');
	
	if ( ($RecCnt % 100) == 0 )
	{
		$groupinfo = $dbintf->GetGroupInfo($tenantid);
		lg("Tenant " . $groupinfo['name'] . " disk usage: " . showkb($val)	. ' cnt: ' . $RecCnt );
	}
}

function CalcTenant($row)
{
	global $dbintf;
  $TenantPhonesOnlyEnabled = (int) $dbintf->GetCachedConfigValue('TenantPhonesOnlyEnabled');
	$accids = $dbintf->GetUsersOfCall($row,$TenantPhonesOnlyEnabled!=0);
	//echo 'usrcnt: ' . count($accids) . ' ';
	foreach($accids as $accid)
	{
		$userinfo = $dbintf->GetUserInfoOnAccId($accid);
		if ($userinfo['tenantid']!==null)
		{
			//echo 'user ' . $userinfo['name'] . ' TN' . "\r\n";
			return $userinfo['tenantid'];
		} else
		{
			//echo 'user ' . $userinfo['name'] . ' not TN' . "\r\n";
		}
	}
	return NULL;
}


function DeleteTenantData($groupid)
{
	global $dbintf;
  if (DeleteTenantDataDb($dbintf,$groupid,false,array()))
  {
    EnginesSettingsCalcApply(true);
    return true;
  }
  lg("DeleteTenantData failed");
  return false;
}

function DeleteCallFromBackup($info)
{
	global $dbintf;
	$filename = $info['filename'];
	DeleteFn(GetRecordingPath($info) . $info['filename']);
	if (HasScreenRecording($info))
	{
		DeleteFn(GetRecordingPath($info) . GetScreenFileName($info));
	}
	$recording_id = $info['id'];
	$dbintf->DeleteRecording($recording_id);
}


function DeleteTenantDataDb($dbintf,$groupid,$inbackup,$options)
{
	require_once 'actions.php'; // for DeleteGroup
	$ok = true;
  // user should retry, not redoing transaction
	$dbintf->StartTransaction();
	if ($ok)
	{
		// this must be done first
		// because below changes group membership
		$dbintf->DeleteTenantUsers($groupid);
		// delete subgroups
		$dbintf->DeleteTenantSubGroups($groupid);
		// groups changed, recalc.
		// to allow DeleteGroup to see it has no subgroups
		$dbintf->DetermineAllGroups(true);
	}
	if ($ok)
	{
		if (!DeleteGroup($dbintf,$groupid))
    {
      $ok = false;
      lg('Delete group failed');
    }
	}
	if ($ok)
	{
		$dbintf->UnassignVTapTenant($groupid);
		// delete all tenant calls
    $cfg = array();
    if ($inbackup)
    {
      $cfg['basepath'] = $options['BackupDest'];
    } 
    // first delete files
    $dbintf->PerformOnTenantCalls($groupid,'DeleteTheCallFiles',$cfg);
    // then delete database records
    $dbintf->DeleteTenantCalls($groupid);
    $dbintf->DeleteTenantCallsArchive($groupid);
		// unassign any remaining calls
    // normally should not be any, except just created
		// also those who are active
		$dbintf->UnassignTenantCalls($groupid);
		$tn_prefix = 'TN' . $groupid . '_';
		$dbintf->DeleteConfigsWithPrefix($tn_prefix);
	}
	if ($ok)
	{
		$dbintf->CommitTransaction();
	} else
	{
		$dbintf->CancelTransaction();
	}
  return $ok;
}

// helper function for ExportTenant
function GetDbEncoding()
{
  // determine current psql encoding
  // since not easy to change (utf8 might not even be installed)
  $retval = 0;
  $dbenc = '';
  $dummy_output = null;
  exec('psql -P pager=off -l | grep LATIN1',$dummy_output,$retval);
  if ($retval==0)
  {
    $dbenc = 'LATIN1';
  }
  exec('psql -P pager=off -l | grep UTF8',$dummy_output,$retval);
  if ($retval==0)
  {
    $dbenc = 'UTF8';
  }
  return $dbenc;
}

// helper function for CopyTenantCall
function TryTnCallCopy(&$ref_cfg,$row,$filename)
{
  $directory = $row['directory'];
  
  $src_local = AUDIO_PATH . '/' . $directory . '/' . $filename;
  $src_backup = $ref_cfg['BackupDest'] . '/' . $directory . '/' . $filename;
  $dstdir = $ref_cfg['dstdir'] . '/' . $directory;
  $dst = $dstdir . '/' . $filename;

  // does the file exist on local or backup storage?
  // we could have stored this info somewhere,
  // but this would be complicated,
  // and this check should be fast
  if (file_exists($src_local))
  {
    $src = $src_local;
  } else 
  if (file_exists($src_backup))
  {
    $src = $src_backup;
  } else
  {
    $srcMissingExpected = (($row['flags']&1)!=0);
    if ($row['isarchived']==0) $srcMissingExpected = true;
    if ($srcMissingExpected==false)
    {
      lg('Source file missing for recording '.$filename);
      $ref_cfg['failcnt']++;
    }
    $ref_cfg['sourceMissing']++;
    // but continue with the rest
    return true;
  }
  if (file_exists($dstdir)==false)
  {
    mkdir($dstdir,fileperms($ref_cfg['BackupDest']),true);
  }
  
  $ok = false;
  // Application Level Encryption
  $thisOneEncrypted = ($row['flags']&16)!=0;
  if ($thisOneEncrypted)
  {
    // decrypt while copying
    $cmdToExec = 'apresa_crypt -d -i '.escapeshellarg($src).' -o '.escapeshellarg($dst);
    $retValue = 999;
    $dummyOutput = array();
    exec($cmdToExec,$dummyOutput,$retValue);
    if ($retValue!=0)
    {
      $ok = false;
      lg('Decryption error (code: '.$retValue.') while trying to decrypt ' . $src);
      if ($retValue=='41') onerror('Decryption error: Playback of encrypted recordings is currently not possible');
    } else $ok = true;
  }
  else
  {
    // plain copy
    //lg('Copy '.$src.' to '.$dst);
    $ok = @copy($src,$dst);
  }
  if ($ok==false)
  {
    lg('Copy '.$src.' to '.$dst.' failed');
    $ref_cfg['copyFailed']++;
    $ref_cfg['failcnt']++;
  } else
  {
    $ref_cfg['okcnt']++;
  }
  return true;
}

// helper function for ExportTenant
function CopyTenantCall(&$ref_cfg, &$ref_result, $row)
{
  //lg("CopyTenantCall " . $row['filename']);
  
  if (!TryTnCallCopy($ref_cfg,$row,$row['filename'])) return false;

  if (HasScreenRecording($row))
  {
    if (!TryTnCallCopy($ref_cfg,$row,GetScreenFileName($row))) return false;
  }
  
  return true;
}

function WriteCsvDataToHandle($handle, $data)
{
  foreach ($data as &$ref_item)
  {
    $ref_item = CsvQuote($ref_item);
  }
  $t = implode(',',$data) . "\n";
  //echo $t;
  fwrite($handle,$t);
}

// helper function for ExportTenant
function WriteTenantCsvHeader($handle)
{
  global $lng;
  // write marker that this is UTF-8
  fwrite($handle,"\xEF\xBB\xBF");
  $data = array
  ( $lng->Get('Cols.startdate')
  , $lng->Get('Cols.callerID')
  , $lng->Get('Cols.receiverID')
  , $lng->Get('Cols.direction')
  , $lng->Get('Cols.direction')
  , $lng->Get('Cols.category')
  , $lng->Get('Cols.notes')
  , $lng->Get('Cols.notes') . ' (2)'
  , $lng->Get('Web.Identifier')
  , $lng->Get('Web.Directory')
  , $lng->Get('Web.Filename')
  );
  WriteCsvDataToHandle($handle,$data);
}

// helper function for ExportTenant
function WriteTenantCsvCall(&$ref_cfg, &$ref_result, $row)
{
  global $lng;
  $data = array();

  $datestr = date($ref_cfg['datetimef'],$row['startdate']);
  /*
  $startms = $row['startms'];
  if ($startms!=NULL && (int_ensure_defined($configs['timeformat'])==1) )
  {
    $datestr .= '.' . str_pad($startms,3,'0',STR_PAD_LEFT);
  }
  */
  $data[] = $datestr;
  
  $direction = (int) $row['direction'];
  if ($direction==0) // incoming
  {
    $caller   = $row['remote'];
    $receiver = $row['local'];
  } else
  {
    $caller   = $row['local'];
    $receiver = $row['remote'];
  }
  $data[] = $caller;
  $data[] = $receiver;

  $data[] = $row['direction'];
  if ($direction==0) $strDirection = $lng->Get('Web.Incoming');
  else if ($direction==1) $strDirection = $lng->Get('Web.Outgoing');
  else if ($direction==2) $strDirection = $lng->Get('Web.Internal');
  else $strDirection = 'External';
  $data[] = $strDirection;

  $data[] = $row['category'];
  $data[] = $row['notes'];
  $data[] = $row['notes2'];
  
  $data[] = $row['remoteid'];
  $data[] = $row['directory'];
  $data[] = $row['filename'];
  
  WriteCsvDataToHandle($ref_cfg['handle'],$data);
  return true;
}

function PrepareTnExpDatabase()
{
  // delete old database in case it exists from failed previous round
  lg("Delete database apresa_tnexp");
  exec('psql apresa -c "DROP DATABASE apresa_tnexp;"');
  lg("Create database apresa_tnexp");
  exec('psql apresa -c "CREATE DATABASE apresa_tnexp;"');
  lg("Create Calls table");
  // copy schema of Calls table (without data) to tnexp database 
  exec('pg_dump apresa -s -t Calls | psql apresa_tnexp');
}

function GetTnCallInfoFromBackup($tenantid,$db_tnexp,$options)
{
    global $dbintf;
    if ($dbintf->GetConfigValue('UseCallsArchive')!=0)
    {
      $added = $dbintf->copyTnCallInfo($tenantid, $db_tnexp, true);
      lg('Found ' . $added . ' extra tenant calls in backup archive');
      return;
    }
  
    $dbenc = GetDbEncoding();
    lg('Database encoding: ' . $dbenc);
    
    lg("Delete database apresa_restore");
    exec('psql apresa -c "DROP DATABASE apresa_restore;"');
    @mkdir('/recordings/tmp');
    // check database files on the backup disk
    // files in the root of the backup directory
    lg('Scanning ' . $options['BackupDest']);
    $rootfiles = scandir($options['BackupDest']);
    $tohandlecnt = 0;
    $handlingix = 0;
    foreach ($rootfiles as $rootfile)
    {
      if (startsWith($rootfile,"apresadb")
        && endsWith($rootfile,".sql.gz") )
      {
        $tohandlecnt++;
      }
    }
    foreach ($rootfiles as $rootfile)
    {
      if (startsWith($rootfile,"apresadb")
        && endsWith($rootfile,".sql.gz") )
      {
        lg('Importing ' . $rootfile);
        $handlingix++;
        $tnmessage = 'Exporting tenant: Loading tenant call info from backup ' . $rootfile
          . ' (' . $handlingix . ' of ' . $tohandlecnt . ')';
        WriteTenantMsg(MSG_INF,$tnmessage);

        $dbsrcfile = $options['BackupDest'] . '/' . $rootfile;
        $dbfile = AUDIO_PATH . '/tmp/' . $rootfile;
        
        if (@copy($dbsrcfile , $dbfile)==false)
        {
          onerror('Could not copy database file from ' . $dbsrcfile);
        }        

        // extract SQL
        $sqlfile = AUDIO_PATH . '/tmp/' . 'restoring.sql';
        exec('gunzip -c ' . escapeshellarg($dbfile) . ' > ' . escapeshellarg($sqlfile));
        // correct SQL for encoding (if we know it)
        if ($dbenc!='')
        {
          $cmd = 'sed -i "s/SET client_encoding = \'.*\'/SET client_encoding = \''.$dbenc.'\'/" ' . escapeshellarg($sqlfile);
          exec($cmd);
        }
        
        lg("Create database apresa_restore");
        exec('psql apresa -c "CREATE DATABASE apresa_restore;"');

        lg("Import database");
        exec('psql apresa_restore < '.escapeshellarg($sqlfile));
        
        $db_restore = new DBInterface(CMD_WEB_RELPATH . DATA_PATH, 'apresa_restore');
        $added = $db_restore->copyTnCallInfo($tenantid, $db_tnexp, false);
        lg('Found ' . $added . ' extra tenant calls in backup file');
        $db_restore->close();
        
        lg("Delete database apresa_restore");
        exec('psql apresa -c "DROP DATABASE apresa_restore;"');

        DeleteFn($dbfile);
        DeleteFn($sqlfile);
        
      }
    }  
}

function CopyTenantCalls($dstdir,$db_tnexp,$options)
{
    // - Copy tenant calls
    $cfg = array();
    $cfg['cols'] = array( 'directory', 'filename', 'flags', 'isarchived' );
    $cfg['cnt'] = 0;
    $cfg['dstdir'] = $dstdir;
    $cfg['failcnt'] = 0;
    $cfg['okcnt'] = 0;
    $cfg['sourceMissing'] = 0;
    $cfg['copyFailed'] = 0;
    $cfg['BackupDest'] = $options['BackupDest'];
    $db_tnexp->CallWalker( $cfg, 'CopyTenantCall' );
    $extramsg = 'Copied ' . $cfg['okcnt'] . ' recordings for tenant, ' . $cfg['failcnt'] . ' failed.';
    lg($extramsg);
    return $extramsg;
}

function CsvExportTenantCallInfo($tenantid,$dstdir,$db_tnexp)
{
    global $configs;
    // - Create CSV export of tenant call info
    
    $csvTmpDir = AUDIO_PATH . '/TNtmp';
    @mkdir($csvTmpDir);
    if (file_exists($csvTmpDir)==false) onerror('could not create ' . $csvTmpDir);
    
    $csvFn = 'TN_' . $tenantid . '_recordings.csv';
    $csvTmpPath = $csvTmpDir . '/' . $csvFn;
    $csvH = fopen($csvTmpPath,'w');
    if ($csvH===false) onerror("could not open " . $csvTmpPath);
    
    $cfg = array();
    $cfg['handle'] = $csvH;
    $cfg['datetimef'] = $configs['datetimef'];
    $cfg['cols'] = array( 'remoteid', 'directory', 'filename', 'flags'
    , 'local', 'remote', 'connected', 'direction'
    // , 'startms', 'durms'
    , 'startdate', 'duration'
    , 'category', 'notes', 'notes2'
    );
    WriteTenantCsvHeader($csvH);
    $db_tnexp->CallWalker( $cfg, 'WriteTenantCsvCall' );
    
    fclose($csvH);
    
    $csvFinalPath = $dstdir . '/' . $csvFn;
    if (copy($csvTmpPath,$csvFinalPath)==false) onerror('Could not copy tenant CSV file');
    
    DeleteFn($csvTmpPath);
    rmdir($csvTmpDir);
}

function UnlockTenantAction()
{
  $lockfn = '/var/apresa/data/TenantAction.lock';
  unlink($lockfn);
}

function IsTenantActionBusy()
{
  $lockfn = '/var/apresa/data/TenantAction.lock';
  return file_exists($lockfn);
}

function LockTenantAction()
{
  $lockfn = '/var/apresa/data/TenantAction.lock';
  if (file_exists($lockfn))
  {
    return false;
  }
  touch($lockfn);
  return true;
}

// New faster way to delete, using CallsArchive
function DeleteTenantFromMountedArchive($tenantid,$options)
{
  global $dbintf;
  
  // Use CallsArchive table (fast!)
  $cfg = array();
  $cfg['basepath'] = $options['BackupDest'];
  $dbintf->PerformOnTenantCallsArchive($tenantid,'DeleteTheCallFiles',$cfg);
  
  return true;
}

function DeleteTenantFromMountedBackup($tenantid,$options)
{
    $dbenc = GetDbEncoding();
    lg('Database encoding: ' . $dbenc);
    $ok = true;
    
    lg("Delete database apresa_restore");
    exec('psql apresa -c "DROP DATABASE apresa_restore;"');
    @mkdir('/recordings/tmp');
    // check database files on the backup disk
    // files in the root of the backup directory
    lg('Scanning ' . $options['BackupDest']);
    $rootfiles = scandir($options['BackupDest']);
    $tohandlecnt = 0;
    $handlingix = 0;
    foreach ($rootfiles as $rootfile)
    {
      if (startsWith($rootfile,"apresadb")
        && endsWith($rootfile,".sql.gz") )
      {
        $tohandlecnt++;
      }
    }
    foreach ($rootfiles as $rootfile)
    {
      if (startsWith($rootfile,"apresadb")
        && endsWith($rootfile,".sql.gz") )
      {
        lg('Importing ' . $rootfile);
        $handlingix++;
        $tnmessage = 'Deleting tenant data from backup ' . $rootfile
          . ' (' . $handlingix . ' of ' . $tohandlecnt . ')';
        WriteTenantMsg(MSG_INF,$tnmessage);

        $dbsrcfile = $options['BackupDest'] . '/' . $rootfile;
        $dbfile = AUDIO_PATH . '/tmp/' . $rootfile;
        
        if (@copy($dbsrcfile , $dbfile)==false)
        {
          onerror('Could not copy database file from ' . $dbsrcfile);
        }        

        // extract SQL
        $sqlfile = AUDIO_PATH . '/tmp/' . 'restoring.sql';
        exec('gunzip -c ' . escapeshellarg($dbfile) . ' > ' . escapeshellarg($sqlfile));
        // correct SQL for encoding (if we know it)
        if ($dbenc!='')
        {
          $cmd = 'sed -i "s/SET client_encoding = \'.*\'/SET client_encoding = \''.$dbenc.'\'/" ' . escapeshellarg($sqlfile);
          exec($cmd);
        }
        
        lg("Create database apresa_restore");
        exec('psql apresa -c "CREATE DATABASE apresa_restore;"');

        lg("Import database");
        exec('psql apresa_restore < '.escapeshellarg($sqlfile));
        
        lg("Delete records from database");
        // delete records of tenant in locally loaded (restored) database
        // also delete recording files of tenant from backup
        $db_restore = new DBInterface(CMD_WEB_RELPATH . DATA_PATH, 'apresa_restore');
        $db_restore->SetAdmin();
        DeleteTenantDataDb($db_restore,$tenantid,true,$options);
        $db_restore->close();
        
        lg("Export database back to backup location");
        $expdbfile = AUDIO_PATH."/tmp/apresa_tn.sql.gz";
        system("pg_dump apresa_restore | gzip > ".$expdbfile);
        
        if (file_exists($expdbfile)==false || filesize($expdbfile)<2*1024)
        {
          onerror('Replacement backup file is empty or too small');
        }
        
        // copy back to backup location
        // keep one OLD version
        $oldbackupfn = $options['BackupDest'] . '/OLD_' . $rootfile;
        @unlink( $oldbackupfn );
        rename( $dbsrcfile , $oldbackupfn );
        // overwrite existing
        if (@copy( $expdbfile, $dbsrcfile )==false)
        {
          onerror('Could not copy adjusted database file to ' . $dbsrcfile);
        }
        // delete tmp export file
        unlink($expdbfile);
        
        lg("Delete database apresa_restore");
        exec('psql apresa -c "DROP DATABASE apresa_restore;"');

        unlink($dbfile);
        unlink($sqlfile);
        
      }
    }  
    
    return $ok;
}

function DeleteTenantFromBackup($tenantid)
{
	global $dbintf, $configs;
  $configs_b = $dbintf->LoadConfigsPart('b');
  
  lg("Delete tenant data from backup");
  
  WriteTenantMsg(MSG_INF,'Deleting tenant data from backup: Connect to backup');
  $ok = false;

  $options = InitBackupOptions($configs_b);
  if (isset($options['error']))
  {
    RemoveTenantMsg();
    lg('Error initializing backup options: ' . $options['error'] );
    addToSay(MSG_ERR,'Error initializing backup options: ' . $options['error'] );
    return false;
  }
  
  $unmount_required = false;  
  try
  {  
    // we need access to the backup
    if ($options['Mounting'])
    {
      signal_required('bm');
      $unmount_required = true;
    }

    if ($dbintf->GetConfigValue('UseCallsArchive')!=0)
    {
      $ok = DeleteTenantFromMountedArchive($tenantid,$options);
    } else
    {
      // legacy mode (slow!)
      $ok = DeleteTenantFromMountedBackup($tenantid,$options);
    }
    
  } catch(Exception $e)
  {
    RemoveTenantMsg();
    lg('DeleteTenantFromBackup failed: '.$e->getMessage());
    addToSay(MSG_ERR,'Deleting tenant data from backup failed: '.$e->getMessage());
  }
  
  if ($unmount_required)
  {
    try
    {  
      signal_required('bu');
    } catch(Exception $e)
    {
      lg('DeleteTenantFromBackup failed (disconnect): '.$e->getMessage());
      addToSayRaw(MSG_ERR,'Deleting tenant data from backup failed (disconnect): '.$e->getMessage());
    }
  }
  
  return $ok;
}

// tenant to tenant call checked call back function
function T2tCb(&$ref_cfg,&$ref_result,$row)
{
  global $dbintf;
	$ref_cfg['cnt']++;
  $now = time();
  
  if ($row['tenantid']===null)
  {
    return true;
  }
  $currentTenant = $row['tenantid'];
  $ref_cfg['tc'] ++;
  
  if ($now - $ref_cfg['reporttime'] >= 1)
  {
    $ref_cfg['reporttime'] = $now;
    lg('Recordings seen: ' . $ref_cfg['cnt']
    . ' found: ' . $ref_cfg['twoTenantsHadNoDup']
    );
  }
  
  if (false && $now - $ref_cfg['starttime'] > 15)
  {
    // debug timeout
    lg('TIMEOUT');
    return false;
  }
  
  $OptCache = $ref_cfg['OptCache'];
  $OnlyEnabled = (int) $OptCache['TenantPhonesOnlyEnabled'];
  
  $users = $dbintf->GetUsersOfCall($row,$OnlyEnabled);
  $tenants = array();
  $seenCurrentTenant = false;
  foreach ($users as $useraccid)
  {
    $userinfo = $dbintf->GetUserInfoOnAccId( $useraccid );
    if ($OnlyEnabled!=0)
    {
      if ($userinfo['enabled']==false) continue;
    }
    if ($userinfo['tenantid']===null) continue;
    $tenantid = $userinfo['tenantid'];
    if (in_array($tenantid,$tenants)) continue;
    if ($tenantid == $currentTenant)
    {
      $seenCurrentTenant = true;
      continue;
    }
    $tenants[] = $tenantid;
  }
  
  if ($seenCurrentTenant==false)
  {
    $ref_cfg['notCurrentTenant']++;
    return true;
  }
  
  if (count($tenants)>=2)
  {
    $ref_cfg['moreThanTwoTenants']++;
    return true;
  }
  
  if (count($tenants)==0)
  {
    $ref_cfg['oneTenantOk']++;
    return true;
  }
  
  if (count($tenants)==1)
  {
    $ref_cfg['twoTenants']++;

    // this is the main thing
    $otherTenant = $tenants[0];
    $info = $dbintf->GetCallInfo( $row['id'] );
    
    // check if we have a dup assigned to the other tenant
    $timerange = 2;
    $begin = $info['startdate'] - $timerange;
    $end = $info['startdate'] + $timerange;
    $search = array();
    $search['fd'] = $begin;
    $search['ld'] = $end;
    $search['tenantid'] = $otherTenant;
    $cfg = array();
    $cfg['allrecords'] = true;
    $cfg['nousrflr'] = true;
    $sk = '';
    $calls = $dbintf->GetCallList($sk,'',$search,$cfg);

    $callCnt = $calls['cnt'];
    unset($calls['cnt']);
    
    $hadDup = false;
    $toReport = false;
    $reportCalls = false;
    
    if ($callCnt>=1)
    {
      $hadDup = true;
      $matches = false;
      foreach ($calls as $call)
      {
        // we also found a recording assigned to the other tenant
        if ( ($info['local']==$call['local']
        || $info['local']==$call['remote'])
        &&  ($info['remote']==$call['local']
        || $info['remote']==$call['remote']) )
        {
          $matches = true;
        }
      }
      if ($matches==false)
      {
        $ref_cfg['twoTenantsHadDupMismatch'] ++;
        $toReport = true;
        $reportCalls = true;
        lg('Call between two tenants with a possible duplicate but local/remote mismatch:');
      } else
      {
        $ref_cfg['twoTenantsHadDup'] ++;
      }
    } else
    {
      $ref_cfg['twoTenantsHadNoDup'] ++;
      $toReport = true;
      lg('Call between two tenants lacking a duplicate:');
    }
    
    if ($toReport)
    {
      // report details
      
      $TnThis  = $dbintf->GetGroupInfo($currentTenant)['name'];
      $TnOther = $dbintf->GetGroupInfo($otherTenant)['name'];
    
      lg('Recording assigned to tenant: ' . $TnThis);
      lg('Also involving tenant: ' . $TnOther);
      //lg('Id: ' . $info['remoteid'] );
      lg('Date & time: ' . date('Y-m-d H:i:s',$info['startdate']) );
      lg('Local/Remote: ' . $info['local'] . ' - ' . $info['remote'] );
      if ($reportCalls)
      {
        foreach ($calls as $call)
        {
          lg('Other Date & time: ' . date('Y-m-d H:i:s',$call['startdate']) );
          lg('Other Local/Remote: ' . $call['local'] . ' - ' . $call['remote'] );
        }
      }
    }
    
  }

  return true;
}

// called from special task
function CallsBetweenTenants($param)
{
	global $dbintf, $configs;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  $dbintf->SetAdmin();
  LoadBasicSettings();
  
  lg('Calls between tenants: ' . $param);
  $repair = false;
  if ($param=='check') {
    $repair = false;
  } else if ($param=='repair') {
    $repair = true;
    lg('Not implemented');
    return;
  } else {
    lg('Use option check or repair');
    return;
  }
  
  $CfgToLoad = array('TenantPhonesOnlyEnabled');
  
  $OptCache = array();
  foreach ($CfgToLoad as $key)
  {
    $OptCache[$key] = $dbintf->GetConfigValue($key);
  }
  
  $total = $dbintf->GetCallCount();
  lg('Total number of call records: ' . $total);
  
  $cfg = array();
  $cfg['repair'] = $repair;
  $cfg['total'] = $total;
  $cfg['OptCache'] = $OptCache;
	$cfg['cols'] = array('id'
		,'localcontact'
		,'remotecontact'
		,'linenr'
		,'local2','remote2'
		,'directory','filename','flags'
    ,'tenantid'
		);
  $cfg['cnt'] = 0;
  $cfg['starttime'] = time();
  $cfg['reporttime'] = time();
  $cfg['tc'] = 0;
  $cfg['oneTenantOk'] = 0;
  $cfg['notCurrentTenant'] = 0;
  $cfg['moreThanTwoTenants'] = 0;
  $cfg['twoTenants'] = 0;
  $cfg['twoTenantsHadDup'] = 0;
  $cfg['twoTenantsHadDupMismatch'] = 0;
  $cfg['twoTenantsHadNoDup'] = 0;

  $dbintf->CallWalker( $cfg, 'T2tCb' );
  
  lg('Finished');
  lg('- Recordings seen: ' . $cfg['cnt']);
  lg('- Recordings that were already assigned to a tenant: ' . $cfg['tc']);
  lg('  - that no longer match with this tenant (skipped): ' . $cfg['notCurrentTenant']);
  lg('  - that match with more than 2 tenants (skipped): ' . $cfg['moreThanTwoTenants']);
  lg('  - that match with only one tenant (already ok): ' . $cfg['oneTenantOk']);
  lg('  - that match with 2 tenants: ' . $cfg['twoTenants']);
  lg('    - that already had a duplicate assigned to other tenant: ' . $cfg['twoTenantsHadDup']);
  lg('    - that maybe already had a duplicate assigned to other tenant (local / remote mismatch): ' . $cfg['twoTenantsHadDupMismatch']);
  lg('    - that lacked a duplicate assigned to other tenant: ' . $cfg['twoTenantsHadNoDup']);
}

// called from special task
function DeleteTenantTask($param,$param2)
{
	global $dbintf, $configs;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  $dbintf->SetAdmin();
  LoadBasicSettings();

  $DelFromBackup = ($param=='1');
  $tenantid = (int) $param2;
  lg("Delete tenant with ID ".$tenantid);
  $ok = true;
  
  $tenantGroup = $dbintf->GetGroupInfo($tenantid);
  if ($tenantGroup==false)
  {
    lg("Group not found");
    return;
  }
  if ($tenantGroup['is_tenant']==0)
  {
    lg("Group is not a tenant");
    return;
  }
  if (LockTenantAction()==false)
  {
    addToSay(MSG_ERR,'Delete tenant cancelled: A tenant action is still busy');
    return;
  }
  lg("Deleting tenant data: ".$tenantGroup['name']);
  
  if ($DelFromBackup)
  {
    if (!DeleteTenantFromBackup($tenantid)) $ok = false;
  }

  if ($ok)
  {
    // delete from regular database
    if (!DeleteTenantData($tenantid))
    {
      $ok = false;
      addToSay(MSG_ERR,'Deleting tenant data from main storage failed');
    }
  }

  RemoveTenantMsg();
  if ($ok)
  {
    addToSay(MSG_INF,"Deletion of tenant data of " . $tenantGroup['name']. " has completed");
  }
  
  UnlockTenantAction();
  
}

function ExportTenantAuditLog($tenantid,$dstdir){
	global $dbintf;
	
	$result=array();
	$path="../".DATA_PATH . "/audit/";
	
	$cedb = new CEDB($dbintf);
  // Note: returns list of usernames
  // actually has nothing to do with call evaluation (CE)
	$tenants = $cedb->getTenants($tenantid);
	
	foreach($tenants as $tenant){
    // skip users with empty username
    if ($tenant=='') continue;
		$file="/log_".$tenant.".txt";
		if(file_exists($path.$file)){
			if(!copy($path.$file,$dstdir.$file)){
				//fail
			}else{
				//success
			}
		}else{
			//log does not exist
		}
	}

}

// called from special task
function ExportTenant($param)
{
	global $dbintf, $configs;
	$dbintf = new DBInterface(CMD_WEB_RELPATH . DATA_PATH);
  LoadBasicSettings();
  $configs_b = $dbintf->LoadConfigsPart('b');
  $tenantid = (int) $param;
	
  lg("Exporting tenant with ID ".$tenantid);
  $tenantGroup = $dbintf->GetGroupInfo($tenantid);
  if ($tenantGroup==false)
  {
    lg("Group not found");
    return;
  }
  if ($tenantGroup['is_tenant']==0)
  {
    lg("Group is not a tenant");
    return;
  }
  if (LockTenantAction()==false)
  {
    addToSay(MSG_ERR,'Tenant export cancelled: A tenant action is still busy');
    return;
  }
  lg("Exporting tenant: ".$tenantGroup['name']);
  WriteTenantMsg(MSG_INF,'Exporting tenant: Connect to backup');
  
  $options = InitBackupOptions($configs_b);
  if (isset($options['error']))
  {
    RemoveTenantMsg();
    lg('Error initializing backup options: ' . $options['error'] );
    addToSay(MSG_ERR,'Error initializing backup options: ' . $options['error'] );
    UnlockTenantAction();
    return false;
  }
  
  $unmount_required = false;  
  try
  {  
    // we need access to the backup
    if ($options['Mounting'])
    {
      signal_required('bm');
      $unmount_required = true;
    }

    $expsubdir = 'TN_' . $tenantid;

    WriteTenantMsg(MSG_INF,'Exporting tenant: Preparing tenant export database');
    PrepareTnExpDatabase();

    // connect to database
    $db_tnexp = new DBInterface(CMD_WEB_RELPATH . DATA_PATH, 'apresa_tnexp');

    WriteTenantMsg(MSG_INF,'Exporting tenant: Loading tenant call info from main database');
    // copy call info from main database
    $added = $dbintf->copyTnCallInfo($tenantid, $db_tnexp, false);
    lg('Found ' . $added . ' tenant calls in main database');

    WriteTenantMsg(MSG_INF,'Exporting tenant: Loading tenant call info from backup');
    GetTnCallInfoFromBackup($tenantid,$db_tnexp,$options);
    
    $dstdir = $options['BackupDest'] . '/' . $expsubdir;
    lg('Export to ' . $dstdir);
    // create directory for tenant export
    @mkdir($dstdir);
		
		ExportTenantAuditLog($tenantid,$dstdir);

    WriteTenantMsg(MSG_INF,'Exporting tenant: Copy tenant recordings');
    $extramsg = CopyTenantCalls($dstdir,$db_tnexp,$options);

    WriteTenantMsg(MSG_INF,'Exporting tenant: Create CSV call info file');
    CsvExportTenantCallInfo($tenantid,$dstdir,$db_tnexp);
    
    RemoveTenantMsg();
    addToSay(MSG_INF,"Export of tenant " . $tenantGroup['name']
      . " completed to backup directory " . $expsubdir . '. '
      . $extramsg);
    
  } catch(Exception $e)
  {
    RemoveTenantMsg();
    lg('ExportTenant failed: '.$e->getMessage());
    addToSay(MSG_ERR,'Tenant export failed: '.$e->getMessage());
  }
  
  if ($unmount_required)
  {
    try
    {  
      signal_required('bu');
    } catch(Exception $e)
    {
      lg('ExportTenant error during backup disconnect: '.$e->getMessage());
      addToSayRaw(MSG_ERR,'Tenant export error during backup disconnect: '.$e->getMessage());
    }
  }
  UnlockTenantAction();
}

class TenantRecExporter
{
  var $ref_frqTask;
  var $path;
  var $keyPrefix;
  var $enabled;
  var $tenant;
  
  function __construct($tenant,&$ref_frqTask)
  {
    global $configs_tn;
    $this->tenant = $tenant;
    $this->keyPrefix = 'TN' . $tenant['id'] . '_Exp';
    $this->enabled = $this->GetIntCfg('Enabled');
    $this->path = str_ensure_defined( $configs_tn[$this->keyPrefix . 'BckPath'] );
    $this->ref_frqTask = & $ref_frqTask;
  }

  function GetIntCfg($key)
  {
    global $configs_tn;
    return int_ensure_defined( $configs_tn[$this->keyPrefix . $key] );
  }

  function SetCfg($key,$value)
  {
    global $dbintf;
    $dbintf->SetConfigsPart( array($this->keyPrefix . $key => $value) , 'tn' );
  }
	
	function AddErrMsg( $t )
	{
		$this->ref_frqTask->AddErrMsg( $t );
	}
  
  function DetermineNextRun($now,$repeat,$BckTime,$BckDow)
  {
    $now_arr = localtime($now,true);
    $hours = floor( $BckTime / 60 );
    $minutes = $BckTime - $hours * 60;
    $t = 0;
    if ($repeat==1)
    {
      // weekly
      $diffDay = $BckDow - $now_arr['tm_wday'];
      $t = mktime($hours,$minutes,0
      ,$now_arr['tm_mon']+1,$now_arr['tm_mday']+$diffDay,$now_arr['tm_year']+1900);
      if ($t<$now)
      {
        // move one week further
        $t = mktime($hours,$minutes,0
        ,$now_arr['tm_mon']+1,$now_arr['tm_mday']+$diffDay+7,$now_arr['tm_year']+1900);
      }
    }
    else if ($repeat==2)
    {
      // daily
      $t = mktime($hours,$minutes,0
      ,$now_arr['tm_mon']+1,$now_arr['tm_mday'],$now_arr['tm_year']+1900);
      if ($t<$now)
      {
        // move a day further
        $t = mktime($hours,$minutes,0
        ,$now_arr['tm_mon']+1,$now_arr['tm_mday']+1,$now_arr['tm_year']+1900);
      }
    }
    else if ($repeat==3)
    {
      // hourly
      $t = mktime($now_arr['tm_hour'],$minutes,0
      ,$now_arr['tm_mon']+1,$now_arr['tm_mday'],$now_arr['tm_year']+1900);
      if ($t<$now)
      {
        // move an hour further
        $t = mktime($now_arr['tm_hour']+1,$minutes,0
        ,$now_arr['tm_mon']+1,$now_arr['tm_mday'],$now_arr['tm_year']+1900);
      }
    }
    return $t;
  }
  
  function IsExportPathOnRoot()
  {
    // lg($this->path);
    $path = $this->path;
    while (true)
    {
      $cmd = 'df ' . escapeshellarg($path) . ' 2>/dev/null';
      $output = array();
      $retStatus = 0;
      @exec($cmd,$output,$retStatus);
      if ($retStatus==1)
      {
        // lg("df on $path failed");
        $upPath = dirname($path);
        if ($path==$upPath) return false; // should never happen
        $path = $upPath;
        continue;
      }
      if ($retStatus==0)
      {
        // lg("df on $path succeeded");
        if (count($output)==2)
        {
          $line2 = $output[1];
          $parts = preg_split('/\s+/',$line2);
          if (count($parts)>=6)
          {
            $rootFs = $parts[5];
            if ($rootFs=='/')
            {
              // the directory is on root
              return true;
            } else {
              // lg($this->path . ' is mounted on ' . $rootFs );
              return false;
            }
          }
        }
        // if strange output, assume not on root
        return false;
      }
      // if a strange error, assume not on root
      return false;
    }
    // unreachable code probably
    return false;
  }
  
  // should return true if exported
  function Export()
  {
    global $dbintf, $configs;
    
    if ($this->path=='') return false;
    if ($this->enabled==0) return false;

    $IdHandled = $this->GetIntCfg('IdHandled');
    
    // check if tenant needs to be exported now
    // $lastDone = $this->GetIntCfg('LastDone');
    // last done can be 0 if it has not yet been done
    
    // read scheduling settings
    $BckRepeat = $this->GetIntCfg('BckRepeat');
    $BckTime   = $this->GetIntCfg('BckTime');
    $BckDow    = $this->GetIntCfg('BckDow');
    // determine current time of day
    $now = time();
    // do we know when to do the next run?
    $nextRun = $this->GetIntCfg('NextRun');
    if ($nextRun==0)
    {
      $nextRun = $this->DetermineNextRun($now,$BckRepeat,$BckTime,$BckDow);
      lg('ExpRecs Tenant ' . $this->tenant['name'] . ' Next run: ' . date('Y-m-d H:i:s',$nextRun) );
      $this->SetCfg('NextRun',$nextRun);
    }
    // no next run?
    if ($nextRun==0) return false;
    
    if ($now<$nextRun)
    {
      // not yet time for the next run
      return false;
    }
    
    // check if properly mounted
    if ($this->IsExportPathOnRoot())
    {
      $this->AddErrMsg('ExpRecs Tenant ' . $this->tenant['name'] . ' export path ' . $this->path . ' is on the main partition (ERROR)' );
      return false;
    }

    // we have determined we are going to perform it for this tenant
    // determine the next run
    // add 1 second to avoid scheduling for this same second
    $nextRun = $this->DetermineNextRun($now+1,$BckRepeat,$BckTime,$BckDow);
    $this->SetCfg('NextRun',$nextRun);

    lg('ExpRecs Tenant ' . $this->tenant['id'] . ': ' . $this->tenant['name'] 
    . ' IdHandled: ' . $IdHandled
    . ' Next run: ' . date('Y-m-d H:i:s',$nextRun)
    );
    
    $cfg = array();
    $cfg['tenant'] = $this->tenant['id'];
    $BackupDest = $this->path;
    $doneCount = 0;
    
		$to_stop = false;
		try
		{
		
			$chunck_size = 30;
			// Doing in chunck, not all at once
			// because otherwise maybe too large a list for memory
			while ($to_stop==false && $this->ref_frqTask->errflag==false)
			{
				// Get list of recordings to be exported...
				$testtime1 = microtime(true);
        $IdLatest = $dbintf->GetIdOfLatestCall();
        $calls_pre = $dbintf->GetToHandleList($IdHandled,$chunck_size,$cfg);
				$testtime2 = microtime(true);
				$db_time = (int) (($testtime2-$testtime1)*1000);
				if ($db_time>500)
				{
					lg( 'Get export list query took '.$db_time. ' ms' );
				}
        if (count($calls_pre)==0)
        {
          // we found nothing to export
          if ($IdLatest > $IdHandled)
          {
            // but when filtering, it might still be possible to update our pointer,
            // and move it forward a bit, which improves speed of next query
            $IdHandled = $IdLatest;
            $this->SetCfg('IdHandled',$IdHandled);
          }
          break;
        }
        $calls = array();
				foreach ($calls_pre as $call)
				{
          // no additional filtering currently
          $calls[] = $call;
				}
				$cnt_calls = count($calls);
				if ($cnt_calls==0)
				{
					// we are ready, or nothing to do
					break;			
				}
				lg('Calls to export: ' . $cnt_calls);

        // no mounting needed currently
        
				foreach ($calls as $call)
				{
					$dirfn = $call['directory'] . '/' . $call['filename'];
					$src = AUDIO_PATH . '/' . $dirfn;
					$einfo = array();
					$dstfn = $call['filename']; // no custom filename
					$einfo['dstfn'] = $dstfn;
					$dst = $BackupDest . '/' . $dstfn;
					if (file_exists($src)==false)
					{
						lg('Recording file ' . $src . ' does not exist!');
						continue;
					}
					if (copy($src,$dst)===false)
					{
						// already checked that source exists,
						// so this should have worked.
						$this->ref_frqTask->AddErrMsg('Copy failure of '.$src.' to '.$dst);
						// do not continue
						break;
					} 
					// verbose: lg('Copied '.$src);
          $doneCount ++;
          $ExpScrRec = true;
          // No ExpNotScrRec
					if ($ExpScrRec && HasScreenRecording($call))
					{
						$dirfn = $call['directory'] . '/' . GetScreenFileName($call);
						$src = AUDIO_PATH   . '/' . $dirfn;
						$screen_dstfn = GetScreenFileName($call);
            // No ExpCustomFN
						$einfo['scrdstfn'] = $screen_dstfn;
						$dst = $BackupDest . '/' . $screen_dstfn;
						if (file_exists($src)==false)
						{
							lg('Screen recording file ' . $src . ' is missing');
						} else
						{
							if (copy($src,$dst)===false)
							{
								lg('Copy failure (screen) of '.$src);
							} else // copy was OK
							{
								// verbose: lg('Copied '.$src);
							}
						}
					} // if has screen recording
          // always create XML
					if (true)
					{
						// now create XML
						if ($this->ref_frqTask->CreateRecInfoXml($BackupDest,$call,$configs,$einfo)==false)
						{
							$this->ref_frqTask->AddErrMsg('Failed to write XML');
							// do not continue
							break;
						} else
						{
							// too verbose lg('Written XML');
						}
					}
					$IdHandled = $call['id'];
				}
        $this->SetCfg('IdHandled',$IdHandled);
			} // end of while loop
		} catch(Exception $e)
		{
			$this->ref_frqTask->AddErrMsg("Exception: ".$e->getMessage());
		}
		// the TRY-CAST ensures code below is done    
    lg('Export completed (count: ' . $doneCount . ')' );
    return true;
  }
  
}

// called from frqtask
function ExportTenantRecordings(& $ref_frqTask)
{
  global $dbintf, $configs_tn;
  // verbose: lg('ExportTenantRecordings');
  $anydone = false;
  $configs_tn = $dbintf->LoadConfigsPart('tn');
  $tenants = $dbintf->GetTenantList();
	$anyErrFlag = false;
	$errMsgs = array();
  foreach ($tenants as $tenant)
  {
    $exporter = new TenantRecExporter($tenant,$ref_frqTask);
		$result = $exporter->Export();
    if ($result)
    {
      $anydone = true;
    }
		// check how well it went
		// Inform health system about the current state
		$toSet = null;
		$tnId = $tenant['id'];
		$tnName = $tenant['name'];
		$logPrefix = $tnName . ' (id=' . $tnId . ') ';
		$prefix = 'TN' . $tnId . '_';
		if ($ref_frqTask->errflag)
		{
			// Something went wrong
			// log it
			$toSet = array( $prefix . 'ExpHealth' => 0
			, $prefix . 'ExpHStatus' => $ref_frqTask->errmsg
			);
		} else if ($result)
		{
			// OK and something done.
			// If nothing is done, this does not negate previous errors.
			$toSet = array( $prefix . 'ExpHealth' => 1
			, $prefix . 'ExpHStatus' => 'Succeeded at ' . date('Y-m-d H:i',time())
			);
		}
		if ($toSet!==null)
		{
			$dbintf->SetConfigsPart($toSet,'tn');
		}		
		// reset for next round
		// but remember
		if ($ref_frqTask->errflag)
		{
			$anyErrFlag = true;
			if ($ref_frqTask->errmsg!='')
			{
				$errMsgs[] = $logPrefix . $ref_frqTask->errmsg;
			}
		}
		$ref_frqTask->errflag = false;
		$ref_frqTask->errmsg = '';
  }
	// restore what was reset
	if ($anyErrFlag) $ref_frqTask->errflag = true;
	foreach ($errMsgs as $errMsg)
	{
		$ref_frqTask->AddErrMsg( $errMsg );
	}
  return $anydone;
}

// this function is for recordings that might already have an assignment
// so first unassign is needed
function ReassignRecs($recording_ids, $tenantid)
{
  global $dbintf;
  if ($tenantid==0) $tenantid = NULL;

  lg('ReassignRecs');
	
	$DetermineAgent = $dbintf->GetConfigValue('DetermineAgent');
  
  $needToCheckBackup = false;
  $unmount = false;
  
  foreach( $recording_ids as $recording_id)
  {
    $call = $dbintf->GetCallInfo( $recording_id );
    if ($call===false) continue; // should not happen
    $call = $dbintf->GetCallArchiveInfo( $recording_id );
    if ($call===false) continue; // could happen
    if ($call['tenantid']!=$tenantid)
    {
      $needToCheckBackup = true;
    }
  }
  
  if ($needToCheckBackup)
  {
    $mount = true;
    $backup_basepath = '/mnt/backup';
    $BckTargetType = $dbintf->GetConfigValue('BckTargetType');
    $BckPath = $dbintf->GetConfigValue('BckPath');
    if ($BckTargetType==1 || $BckTargetType==2)
    {
      $backup_basepath = $BckPath;
      $mount = false;
    }
    // mount the backup if needed
    if ($mount)
    {
      lg('ReassignRecs. Mounting backup');
      $err = signal_helper('bm');
      if ($err!='')
      {
        return 'Error accessing backup: ' . $err;
      }
      $unmount = true;
    }
  }
  
  foreach( $recording_ids as $recording_id)
  {
    $call = $dbintf->GetCallInfo( $recording_id );
    if ($call===false) continue; // should not happen
    if ($call['tenantid']!=$tenantid)
    {
      $size = GetCallStorage($call);
      // verbose: lg('Size in main = ' . $size );
      if ($call['tenantid']!=NULL && $call['isarchived']!=0)
      {
        // there was an existing tenant assignment,
        // which needs to be undone
        UpdateTnDiskUsage($call['tenantid'],-$size,-1);
        LogAction('Unassign call', array('call_id'=>$recording_id) );
      }
      $dbintf->SetCallInfo( $recording_id, array('tenantid' => $tenantid) );
      // tenantid can be NULL, then we are unassigning
      if ($tenantid!=NULL && $call['isarchived']!=0)
      {
        UpdateTnDiskUsage($tenantid,$size,1);
        LogAction('Assign call', array('call_id'=>$recording_id) );
      }
			$call['tenantid'] = $tenantid;
			if ($DetermineAgent !== '0')
			{
				OnOtherTenant( $call );
			}
    }
    // now for the backup
    $call = $dbintf->GetCallArchiveInfo( $recording_id );
    if ($call===false) continue; // could happen
    // verbose: lg('Call found in CallsArchive with tenant = ' . $call['tenantid'] );
    if ($call['tenantid']!=$tenantid)
    {
      // it is not the same tenant
      $size = GetCallStorageEx($call,$backup_basepath);
      // verbose: lg('Size in backup = ' . $size );
      if ($call['tenantid']!=NULL && $call['isarchived']!=0)
      {
        // there was an existing tenant assignment,
        // which needs to be undone
        UpdateTnBackupDiskUsage($call['tenantid'],-$size,-1);
      }
      // tenantid can be NULL, then we are unassigning
      if ($tenantid!=NULL && $call['isarchived']!=0)
      {
        UpdateTnBackupDiskUsage($tenantid,$size,1);
      }      
      $dbintf->SetCallArchiveInfo( $recording_id, array('tenantid' => $tenantid) );
    }
  }
  
  if ($unmount)
  {
		// it is important that we unmount again
		$err = signal_helper('bu');
		if ($err!='')
		{
			return 'Error closing access to backup: ' . $err;
		}
  }
  
  return ''; // no error
}

function GetAgentOfCall(&$ref_data)
{
	global $dbintf;
	// determine agent
  $OnlyEnabled = false;
	$accids = $dbintf->GetUsersOfCall($ref_data,$OnlyEnabled);
	
	// is the recording assigned to a tenant?
	// then the user should match
	if ($ref_data['tenantid']!=null)
	{
		foreach($accids as $accid)
		{
			$userinfo = $dbintf->GetUserInfoOnAccId($accid);
			// must be the same tenant
			if ($userinfo['tenantid'] == $ref_data['tenantid'])
			{
				return $accid;
			}
		}
		return null;
	}
	
	if (count($accids)==0) return null;
	// assign first
	return $accids[0];	
}

function OnOtherTenant(&$ref_data)
{
	global $dbintf;
	$agent = GetAgentOfCall($ref_data);
	if ($agent !== $ref_data['agent'])
	{
		$ref_data['agent'] = $agent;
		$dbintf->SetCallInfo( $ref_data['id'], array('agent' => $agent) );
	}
}

function RemoveTenantMsg()
{
  DeleteFn('/var/apresa/data/tenantmsg');
}

function WriteTenantMsg($msgtype,$msg)
{
	file_put_contents('/var/apresa/data/tenantmsg',$msgtype . $msg . "\n");
}

?>