<?php

require_once('general.php');
require_once('tenancy.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$msg,$lng;

  // need to be full admin
	if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN|PM_T3_ADMIN))==0)
  {
    echo 'Permission denied';
    exit;
  }

	$act = str_ensure_defined($_POST['act']);
  if ($act!='')
  {
		if ($act=='assign-recs')
		{
			LogAction('Assign recordings to tenants');
			// for old recordings
			// can take a *long* time
			msg_signal_service($msg,'TnAssignRecs');
			sleep(1);
		}
    if ($act=='statsmain')
    {
      msg_signal_service($msg,'RedoTnStats 1');
			usleep(500*1000);
    }
    if ($act=='statsbackup')
    {
      msg_signal_service($msg,'RedoTnBackupStats 1');
			usleep(500*1000);
    }
    if ($act=='del-tenant')
    {
      $groupid = (int) $_POST['del-id'];
			$groupinfo = $dbintf->GetGroupInfo($groupid);
			if ($groupinfo === false)
			{
				echo 'Group does not exist';
				exit;
			} 
			if ($groupinfo['is_tenant']==0)
			{
				echo 'Not a tenant';
				exit;
			}
			if ( ($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN|PM_T3_ADMIN)) == 0)
			{
				echo 'Permission denied';
				exit;
			}
			if ($_POST['del-tenant-data']!='1')
			{
				echo 'missing confirmation';
				exit;
			} 
      $DelFromBackup = ($_POST['del-from-backup']=='1')?1:0;
			LogAction( 'Delete all tenant data', array('name'=>$groupinfo['name'],'backup'=>($DelFromBackup?'Y':'N')) );
			msg_signal_service($msg,'TnDelete '.$DelFromBackup.' '.$groupinfo['id']);
			sleep(1);
    }
		if ($act=='export')
		{
      $groupid = (int) $_POST['groupid'];
			$groupinfo = $dbintf->GetGroupInfo($groupid);
			if ($groupinfo === false)
			{
				echo 'Group does not exist';
				exit;
			} 
      LogAction('Export tenant data', array('tenantid'=>$groupid) );
			msg_signal_service($msg,'TnExport '.$groupid);
			sleep(1);
    }
		// redirect
		$_SESSION['msg'] = $msg;
		header('Location: '.'tenants.php');
  }

	$tenant_list = $dbintf->GetTenantList();
	$first_rootgroup_accid = 0;
	$group_list = $dbintf->GetGroupList();
	foreach ($group_list as $group)
	{
		if ($group['super']==0)
		{
			$first_rootgroup_accid = $group['accid'];
			break;
		}
	}
	
	$configs_tn = $dbintf->LoadConfigsPart('tn');

	$tenant_cfg_keys = array('RecMinDur'
	, 'HdDaysKeep' , 'MaxDiskUsage'
	, 'RecOnDmdAvail', 'SilOnDemandAvail'
	, 'DiskUsage', 'DiskUsageCheckTime'
	, 'RecCnt'
	);
	
	$data = '';
	
  $data = 'var users = [' . "\r\n";
  $first = true;
	foreach ($tenant_list as $tenant)
	{
		if (!$first) $data .= ',';
		$first = false;
		$obj = array();
		$groupid = $tenant['id'];
		$obj['id'] = $tenant['id'];
		$obj['name'] = $tenant['name'];
		
		foreach ($tenant_cfg_keys as $key)
		{
			$lookupkey = 'TN'.$groupid.'_'.$key;
			if (isset($configs_tn[$lookupkey]))
			{
				$obj[$key] = $configs_tn[$lookupkey];
			}
		}
		$data .= json_encode($obj,JSON_FORCE_OBJECT) . "\r\n";
	}
	$data .= '];' . "\r\n";
	$data .= 'var firstroot = ' . (int) $first_rootgroup_accid . ";\r\n";
	
  $data .= GeneralJSData();

	if (@file_exists('/var/apresa/data/tenantmsg'))
	{
		$lines = file('/var/apresa/data/tenantmsg');
		foreach($lines as $line)
		{
			$text = trim(substr($line,1));
			if (strlen($text)>1 && $text[0]=='~')
			{
				$text = $lng->Get(substr($text,1));
			}
			$msg[] = new Msg((int)$line[0],$text);
		}
	}

	LogAction('View tenants',array("level"=>"view"));

  // ready with database
  $dbintf->close();

  $template_content = file_get_contents('../apresa/templ/tenants.htm');
	
  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}


function AssignRecs()
{
	
	exit;
}

?>