<?php

require_once('general.php');

HandlePage($dbintf);

function HandleAct($dbintf)
{
  global $msg, $lng;
  
  $act = $_POST['act'];
  $tenant = $dbintf->GetGroupInfo($dbintf->actuinfo['tenantid']);

  $reconfig = false;
  if($act == 'newKey')
  {
    $dbintf->AddCallEncryptionKey([
      'accid' => $tenant['accid'],
      'pubkey' => $_POST['pubKey'],
      'privkey' => $_POST['privKey'],
      'salt' => $_POST['salt'],
      'iv' => $_POST['iv'],
      "inuse" => 1,
    ]);

    $reconfig = true;
    $msg[] = new Msg(MSG_INF, $lng->Get('Web.CallEncryptEnabled'));
  }
  else if($act == 'enable')
  {
    $dbintf->UpdateCallEncryptionKey($tenant['accid'], ["inuse" => 1]);
    $reconfig = true;
    $msg[] = new Msg(MSG_INF,  $lng->Get('Web.CallEncryptEnabled'));
  }
  else if($act == 'disable')
  {
    $dbintf->UpdateCallEncryptionKey($tenant['accid'], ["inuse" => 0]);
    $reconfig = true;
    $msg[] = new Msg(MSG_INF,  $lng->Get('Web.CallEncryptDisabled'));
  }
  else if($act == 'newPrivKeyPwd')
  {
    $dbintf->UpdateCallEncryptionKey($tenant['accid'], [
      'privkey' => $_POST['privKey'],
      'salt' => $_POST['salt'],
      'iv' => $_POST['iv'],
      'inuse' => $_POST['enable']
    ]);

    $msg[] = new Msg(MSG_INF,  $lng->Get('Web.CallEncryptPasswordChanged'));
  }
  else if($act == 'delete')
  {
    $dbintf->UpdateCallEncryptionKey($tenant['accid'], [
      'deleted' => 1,
      'inuse' => 0,
    ]);

    $reconfig = true;
    $msg[] = new Msg(MSG_INF,  $lng->Get('Web.CallEncryptPasswordReset'));
  }

  if($reconfig)
  {
    msg_signal_service($msg,'os');
    msg_signal_service($msg,'sgnork reconfig');
  }

  $_SESSION['msg'] = $msg;
  header('Location: tncallencryption.php');
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if(!$dbintf->GetConfigValue('MultiTenancy'))
  {
    echo 'Multi-tenancy disabled';
    exit;
  }

  if (($dbintf->actuinfo['permissions']&PM_TENANT_ADMIN_ENCRYPT)==0)
  {
    echo 'Permission denied';
    exit;
  }

  if($dbintf->actuinfo['tenantid'] === null)
  {
    echo 'Not a tenant administrator';
    exit;
  }

  if(isset($_POST['act']))
  {
    HandleAct($dbintf);
  }

  $tenant = $dbintf->GetGroupInfo($dbintf->actuinfo['tenantid']);
  $key = $dbintf->GetCallEncryptionKey($tenant['accid']);

  if($key === false)
  {
    $enabled = false;
    $haskey = false;
  }
  else
  {
    $enabled = $key['inuse'] == '1' ? true : false;
    $haskey = true;
  }

	
	LogAction("Viewed tenant call encryption setup",array("level"=>"view"));
	
  $data = '';
  $data .= 'var enabled = ' . ($enabled?"1":"0") . ";\r\n";
  $data .= 'var haskey = ' . ($haskey?"1":"0") . ";\r\n";
  
  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/tncallencryption.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;

  // Check for internet explorer
  $ua = htmlentities($_SERVER['HTTP_USER_AGENT'], ENT_QUOTES, 'UTF-8');
  if (preg_match('~MSIE|Internet Explorer~i', $ua) || (strpos($ua, 'Trident/7.0') !== false && strpos($ua, 'rv:11.0') !== false)) 
  {
    // To prevent causing a syntax error that would break the entire page
    $rpl['callencryption_js'] = "var call_encryption_available = false\r\n";
  }
  else
  {
    $rpl['callencryption_js'] = file_get_contents('../apresa/templ/callencryption.js');
  }

  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
