<?php

require_once('general.php');
require_once 'smbgen.php';

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_TENANT_ADMIN_EXP)==0)
  {
    echo 'Permission denied';
    exit;
  }

  if($dbintf->actuinfo["tenantid"]==NULL)
  {
    // configuration error
    // tenant admin, but no tenantid
    // no access
    $files = array();
    // and tell user about error
    $msg[] = new Msg(MSG_ERR,'Tenant admin but not a member of a tenant');
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl);
    exit;
  }
  
  $tenantid = $dbintf->actuinfo["tenantid"];
  $tenant = $dbintf->GetGroupInfo($tenantid);
  if ($tenant===false)
  {
    echo "Invalid tenant reference"; // should never happen
    exit;
  }
  
  $keyPrefix = 'TN' . $tenantid . '_';
  
  if ($_POST['act']=='change')
  {
    $keys = array( 'ExpEnabled','ExpBckRepeat','ExpBckTime','ExpBckDow' );
    $newCfgs = array();
    foreach ($keys as $key)
    {
      if (isset($_POST[$key]))
      {
        $newCfgs[ $keyPrefix . $key ] = $_POST[$key];
      }
    }
    $newCfgs[$keyPrefix . 'ExpNextRun'] = 0;
    $dbintf->SetConfigsPart($newCfgs,'tn');
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'tnexp.php');
    exit;
  }
  
  $tnconfigs = $dbintf->GetConfigsWithPrefix($keyPrefix);
  if (str_ensure_defined($tnconfigs['ExpBckPath'])=='')
  {
    $msg[] = new Msg(MSG_ERR,'Export destination is not configured');
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl);
    exit;
  }
  
  if (!isset($tnconfigs['ExpBckRepeat']))
  {
    // defaults
    $tnconfigs['ExpBckRepeat'] = 2;
    $tnconfigs['ExpBckTime'] = 3*60;
    $tnconfigs['ExpBckDow'] = 1;
  }
  
  /*
  // Leaks information,
  // because IdHandled might point to a call,
  // that is not owned by the tenant.
  // And it is incorrect too for the same reason.
  $lastExp = '';
  if (isset($tnconfigs['ExpIdHandled']))
  {
    $callid = $tnconfigs['ExpIdHandled'];
    $call = $dbintf->GetCallInfo($callid);
    $lastExp = $call['startdate'];
    $lastExp = date($configs['datetimef'],$lastExp);
  }
  */
  LogAction('View backup settings',array('level'=>'view'));
  
  // ready with database
  $dbintf->close();

  $data = GeneralJSData();
  
  $data .= 'var ExpEnabled       =  ' . int_ensure_defined($tnconfigs['ExpEnabled'  ]) .     ";\r\n";
  $data .= 'var ExpBckRepeat     =  ' . (int) $tnconfigs['ExpBckRepeat'] .     ";\r\n";
  $data .= 'var ExpBckDow        =  ' . (int) $tnconfigs['ExpBckDow'   ] .     ";\r\n";
  $data .= 'var ExpBckTime       =  ' . (int) $tnconfigs['ExpBckTime'  ] .     ";\r\n";
  
  // not: $data .= 'var lastExp     = "' . JSQuote($lastExp)        . "\";\r\n";
  $data .= 'var tenant_name = "' . JsQuote($tenant['name']) . '";' . "\r\n";
  
  $template_content = file_get_contents('../apresa/templ/tnexp.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
