<?php

require_once('general.php');

HandlePage($dbintf);

function GetTransferAuditDescr( $id )
{
  global $dbintf;
  $logarr = array();
  $transferlist = $dbintf->GetTransferTargets();
  $acc_list = $dbintf->GetAccessorsList();
  foreach ($transferlist as $tobj)
  {
    if ($tobj['id']==$id)
    {
      $logarr = array('descr'=>$tobj['description']);
      $accid = $tobj['accid'];
      if ($accid!=0)
      {
        $type = 0;
        foreach ($acc_list as $acc)
        {
          if ($accid == $acc['accid'])
          {
            $type = $acc['type'];
          }
        }
        if ($type==0)
        {
          $uinfo = $dbintf->GetUserInfoOnAccid($accid);
          $logarr['user'] = $uinfo['name'];
          $logarr['tenantid'] = $uinfo['tenantid'];
        } else if ($type==1)
        {
          $ginfo = $dbintf->GetGroupInfoOnAccid($accid);
          $logarr['group'] = $ginfo['name'];
          $logarr['tenantid'] = $ginfo['tenantid'];
        }
      }
    }
  }
  return $logarr;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$rooturl,$lng;

  if (($dbintf->actuinfo['permissions']&(PM_CONFIG|PM_T2_ADMIN) )==0)
  {
    echo 'Permission denied';
    exit;
  }
  $act = $_POST['act'];
  if ($act!='')
  {
    $changed = false;
		$datafields = array( 'description' , 'ip'
			, 'enabled' , 'accid', 'minage' 
      , 'expacalls' , 'acceptact' , 'importrecconf'
			, 'sendbefore' , 'sendafter'
      );
		$transfer = array();
		if ($act=='add' || $act=='edit')
		{
      $changed = true;
			foreach ($datafields as $key)
			{
				if (isset($_POST[$key]))
				{
					$transfer[$key] = $_POST[$key];
				}
			}
      
      if (isset($_POST['timeframe']))
      {
        $timeframe = (int) $_POST['timeframe'];
        $resetId = $dbintf->GetCallBefore($timeframe);
        if ($resetId===false) $resetId = 0;
        $transfer['lastid'] = $resetId;
        $transfer['triedid'] = 0;
      }
		}
		if ($act=='add')
		{
			if ($dbintf->AddTransferTarget($tid,$transfer)==false)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			} else
      {
        LogAction("Add transfer target",GetTransferAuditDescr($tid) );
      }
		}
		if ($act=='edit')
		{
			$id = (int) $_POST['id'];
			if (int_ensure_defined($_POST['restart'])==1)
			{
				$transfer['lastid'] = 0;
				$transfer['triedid'] = 0;
				$transfer['lasttry'] = NULL;
				$transfer['status'] = NULL;
			}
      LogAction('Edit transfer target', GetTransferAuditDescr($id) );
			if ($dbintf->EditTransferTarget($id,$transfer)==false)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
			}
		}
		
		if ($act=='del')
		{
      $changed = true;
			$ids = explode(',',$_POST['del-ids']);
      foreach ($ids as $id)
      {
        LogAction("Delete transfer target", GetTransferAuditDescr($id) );
        if ($dbintf->DelTransferTarget($id)==false)
        {
          $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
        }
      }
		}
    
    // Something has changed.
    // So determine of we need to run spin-client or not
    $OldSpinClient = (int) $dbintf->GetConfigValue('SpinClient');
    $SpinClient = false;
    $transferlist = $dbintf->GetTransferTargets();
    foreach ($transferlist as $transfer)
    {
      if ($transfer['enabled']==0) continue;
      // check the spin options
      if ($transfer['expacalls']!=0) $SpinClient = true;
      if ($transfer['acceptact']!=0) $SpinClient = true;
      if ($transfer['importrecconf']!=0) $SpinClient = true;
    }
    $SpinClient = $SpinClient?1:0;
    if ($SpinClient != $OldSpinClient)
    {
      $dbintf->SetConfigsPart( array('SpinClient'=>(''.$SpinClient) ) , 's');
      msg_signal_service($msg,'spin apply');
    } else if ( int_ensure_defined($_POST['restartSpin']) == 1) // restart
    {
      msg_signal_service($msg,'spin stop client');
    }
    
    // redirect
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'transfer.php');
    exit;
  }

	$data = '';
	
	$pubkey = @file_get_contents(DATA_PATH . '/connector.pub');
	
	$data .= 'var pubkey = "' . JsQuote($pubkey) . '";' . "\n";
	
	$transferlist = $dbintf->GetTransferTargets();

  $spincount = 0;
	foreach ($transferlist as $transfer)
	{
      if ($transfer['enabled']==0) continue;
      if ($transfer['expacalls']!=0
      || $transfer['acceptact']!=0
      || $transfer['importrecconf']!=0) $spincount ++;
  }
  if ($spincount >= 2)
  {
    $msg[] = new Msg(MSG_ERR,"Exporting active calls and importing settings is available for max. one server");
  }
  
	$data .= 'var transferlist = [';
	$first = true;
	foreach ($transferlist as $transfer)
	{
		$lastid = $transfer['lastid'];
		$dlu = 0;
		if ($lastid!=0)
		{
			//echo 'X'.$lastid;
			$call = $dbintf->GetCallInfo($lastid);
			if ($call!==false)
			{
				$dlu = $call['startdate'];
			}
		}
		if ($dlu==0) $dlu = '';
		else $dlu = date($configs['datetimef'],$dlu);
	
		if ($first) $first = false;
		else $data .= ',';
		$data .= '{ id: "' . $transfer['id'] . '"';
		$data .= ', description: "' . JsQuote($transfer['description']) . '"';
		$data .= ', errmsg: "' . JsQuote($transfer['errmsg']) . '"';
		$data .= ', enabled: "' . (int)$transfer['enabled'] . '"';
    $data .= ', minage: ' . (int)$transfer['minage'];
		$data .= ', ip: "' . JsQuote($transfer['ip']) . '"';
		$data .= ', accid: "' . JsQuote($transfer['accid']) . '"';
		$data .= ', status: "' . JsQuote($transfer['status']) . '"';
		$data .= ', dlu: "' . JsQuote($dlu) . '"';
		$data .= ', expacalls: ' . (int)$transfer['expacalls'];
    $data .= ', acceptact: ' . (int)$transfer['acceptact'];
    $data .= ', importrecconf: ' . (int)$transfer['importrecconf'];
		$data .= ', sendbefore: "' . JsQuote($transfer['sendbefore']) . '"';
		$data .= ', sendafter: "' . JsQuote($transfer['sendafter']) . '"';
		$data .= "}\n";
	}
	$data .= "];\n";

  $acc_list = $dbintf->GetAccessorsList(); // full list
  $data .= "var accs=[];\r\n";
  foreach ($acc_list as $acc)
  {
    $data .= "accs[" . $acc['accid'] . "]= " .
        '{name:"' . JSQuote($acc['name']) . '"' .
        ",type:" . $acc['type'] .
        "};\r\n";
  }
	
	LogAction("Viewed transfer targets.",array("level"=>"view"));

  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/transfer.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>