<?php

require_once('utility.php');

function GetServiceUpdateMargin()
{
	return 30;
}

function GetServiceUpdateLength($channels)
{
	$y = 0;
	if ($channels==2) $y = 1;
	else if ($channels==3) $y = 3;
	if ($y==0) return 0;
	return $y * 365 + GetServiceUpdateMargin();
}

function GetUpdateDefaultLength()
{
	return 395;
}

function GetUpdatePeriod()
{
	global $dbintf,$configs;
	
	$ret = (object) array();

	$SecondsPerDay = 60*60*24;
	$nowDay = (int) (time() / ($SecondsPerDay));
	//echo '<BR>' . date($configs['datef'],$nowDay*$SecondsPerDay);
	
	$licStartDay = (int) $dbintf->GetConfigValue('LicStartDay');
	//echo '<BR>' . $licStartDay;
	//echo '<BR>' . date($configs['datef'],$licStartDay*$SecondsPerDay);
	$serviceEnd = 0;
	$dbServiceEnd   = (int) $dbintf->GetConfigValue('ServiceEnd');
	if ($licStartDay==0)
	{
		// system license never activated
		// Allow updates?
		$serviceEnd = 0;
		if ($dbServiceEnd==0)
		{
			$serviceEnd = $nowDay+2;
			$dbintf->SetConfigsPart(array('ServiceEnd'=>''.$serviceEnd),'s');
		}
	} else
	{
		// this has effect only when no database ServiceEnd is defined
		$serviceEnd = $licStartDay + GetUpdateDefaultLength();
	}
	
	// service end in database takes precedence
	if ($dbServiceEnd != 0)
	{
		$serviceEnd = $dbServiceEnd;
	}
	
	// trial mode may always update within the trial period
	$trial = (int) $dbintf->GetConfigValue('LicTrial');
	if ($trial!=0)
	{
		$serviceEnd = $nowDay + (int) $dbintf->GetConfigValue('LicTrialDaysLeft');
	}
	
	$ret->updatesUntil = $serviceEnd;
	$ret->updatesUntilStr = date($configs['datef'],$ret->updatesUntil*$SecondsPerDay);
	$ret->nowDay = $nowDay;
	$ret->updating = ($ret->nowDay <= $ret->updatesUntil);
	
	return $ret;
}

function ComposeSysDescr($configs)
{
	$chtypes = array( "ChCnt", "G729ChCnt", "DstChCnt", "AnalogChCnt", "PriChCnt", "MobileChCnt", "RtaChCnt", "ED137ChCnt" );
	$chlets  = array( "V"    , "G"        , "D"       , "A"          , "P"       , "M"          , "R"       ,  "E" );
	// software channel configuration
	$sw = array();
	foreach ($chtypes as $ix => $chtype)
	{
		if (isset($configs[$chtype]) && $configs[$chtype]!=0)
		{
			$sw[] = $chlets[$ix] . $configs[$chtype];
		}
	}
	if (int_ensure_defined($configs['calleval'])!=0)
	{
		$sw[] = 'AE';
	}
	$t = 'sw:' . implode(',',$sw);
	// hardware configuration
	$hw = array();
	$CardList = str_ensure_defined($configs['CardList']);
	$CardList_Arr = explode(',',$CardList);
	foreach($CardList_Arr as $cardid)
	{
		if ($cardid=='') continue;
		//$sn = substr($cardid,3);
		$model = $configs[$cardid . '_Model'];
		$typemodel = substr($model,0,3);
		$channels = $configs[$cardid . '_Channels'];
		$hw[] = $typemodel . $channels;
	}
	$t .= ';hw:' . implode(',',$hw);
	$t .= ';';
	return $t;
}

function StoreCurrentSysDescr()
{
	global $dbintf;
	$allConfigs = $dbintf->LoadConfigs();
	$sysdescr = ComposeSysDescr($allConfigs);
	$dbintf->SetConfigsPart( array('ServiceSysDescr'=>$sysdescr) , 's' );
}

function ServiceSysChangeChk()
{
	global $dbintf, $msg, $lng;
	$allConfigs = $dbintf->LoadConfigs();
	$oldSys = str_ensure_defined($allConfigs['ServiceSysDescr']);
	$curSys = ComposeSysDescr($allConfigs);
	if ($oldSys!=$curSys && $oldSys!='' && isset($allConfigs['ServiceEnd']) )
	{
		$t = $lng->Get('Licensing.SysChanged') . ' ';
		//		$oldSys . ' <> ' . $curSys;
		$lnk = 'http://www.vidicode.com/apresaserviceupd'
			. '?sn=' . GlobGetSerialNumber()
			. '&descr=' . $curSys;
		$t .= '<a href="' . $lnk . '" target="_new" onclick="return RegSysChange();" >'
			. $lng->Get('Licensing.SysChangeRegister') . '</a>';
		$t .= '&nbsp;&nbsp;&nbsp;<a href="" onclick="RegSysChangeSync();return false;">[x]</a>';
		$msg[] = new Msg(MSG_INF,$t);
	}
}

?>
