<?php

require_once('general.php');
require_once('emailing.php');
require_once('webclient_settings.php');

HandleUser($dbintf);

function GetGroupName($group_list,$row)
{
  foreach($group_list as $group)
  {
    if ($group['accid']==$row)
    {
      return $group['name'];
    }
  }
  return '???';
}

function ContactIdPhoneFilter($var)
{
	global $phonemap;
	return isset($phonemap[ $var['contactid'] ]);
}

function HandleUser($dbintf)
{
  global $rpl,$rooturl,$msg,$phonemap,$lng,$configs, $configs_s;
	
	$configs = array_merge( $configs, $dbintf->LoadConfigsPart('o') );

	$limited_users = false;
  if (($dbintf->actuinfo['permissions']
	&(PM_CONFIG|PM_SUBADMIN|PM_USERS|PM_T2_ADMIN|PM_T3_ADMIN))==0
	)
  {
		if ( ($dbintf->anyaccpms|PM_USERS)!=0)
		{
			$limited_users = true;
		} else
		{
			echo 'Permission denied';
			exit;
		}
  }

	$subadmin = false;
	$grpfixed = -1;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0
	&& ($dbintf->actuinfo['permissions']&PM_SUBADMIN)!=0
	)
	{
		$subadmin = true;
		$arr = $dbintf->GetGroupsOfWhichMember( $dbintf->actuinfo['accid'] );
		if (count($arr)>0)
		{
			$grpfixed = $arr[0];
		}
		$phonelist = $dbintf->GetUserPhones( $dbintf->actuinfo['accid'] );
		foreach ($phonelist as $phone)
		{
			$phonemap[ $phone ] = true;
		}
	}

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='edit-useracc')
    {
      $isok = true;
			$anyerr = false;
      $istenant = false;
      $oldtenant = -1;
      $phonechange = false;
      $groupchange = false;
      $userid = $_POST['id'];
      $usrdata['usr'] = $_POST['usr'];
      $usrdata['name'] = $_POST['name'];
			$fields  = array( 'enabled'
			, 'email', 'rod', 'logonmethod', 'maxcallage'
			, 'mphones', 'playtimelim', 'customlocalid', 'freeseat', 'recondmd', 'delondmd', 'silondmd', 'iaperiod');
			
			foreach ($fields as $field)
			{
				if (isset($_POST[$field]))
				{
					$usrdata[$field] = $_POST[$field];
				}
			}
      if (isset($_POST['pwd']))
      {
				$minpwdlength = int_ensure_defined($configs['MinPwdLength']);
				$mustchangepwd = int_ensure_defined($configs['MustChangePwd']);
				if ($_POST['pwd']=="X1xxxxxxxxxx")
				{
					$usrdata['pwd'] = generateStrongPassword($minpwdlength, 'lud');
				} else { $usrdata['pwd'] = $_POST['pwd']; }

				if ($_POST['sendemail'] == 1)
				{
					// Send the password to the user, using the customizable template
          $key = 'EmailTemplate' . 'NewPwd';
          $subject = $dbintf->GetConfigValue($key . 'Subject');
          $body    = $dbintf->GetConfigValue($key . 'Body');
          // defaults
          if ($subject=='') $subject = $lng->Get('Profile.NewPwd');
          if ($body=='')
          {
            $body = "\r\n";
            $body .= $lng->Get('Main.Name') . ': <NAME>' . "\r\n";
            $body .= $lng->Get('Main.Username') . ': <USR>' . "\r\n";
            $body .= $lng->Get('Profile.NewPwd') . ': <PWD>' . "\r\n";
            $body .= "\r\n";
          }
          // replace template tags
          $body = str_replace('<NAME>',$usrdata['name'],$body);
          $body = str_replace('<USR>' ,$usrdata['usr'],$body);
          $body = str_replace('<PWD>' ,$usrdata['pwd'],$body);
          // send as email
					$dat = array();
					$dat['To'] = $usrdata['email'];
					$dat['Subject'] = $subject;
					$dat['Body'] = $body;
					EmailingFromWebIntf($dat);
				}
				$usrdata['rawpwd'] = $usrdata['pwd'];
				unset($usrdata['pwd']);
				if ($mustchangepwd) $usrdata['changepwd'] = 1; else $usrdata['changepwd'] = 0;
      }
			if (isset($_POST['grp1']))
			{
				$grpaccid = $_POST['grp1'];
			}
      /*if (isset($_POST['permissions']))
      {
        $usrdata['permissions'] = $_POST['permissions'];
      } */
      if ($userid!=-1)
      {
				$theuser = $dbintf->GetUserInfo($userid);
				if ($subadmin && ($theuser['manager']!=$dbintf->actuinfo['id']) )
				{
					echo 'Permission denied';
					exit;
				}
        if ( (int)$dbintf->GetConfigValue('DupNamesAllowed') == 0
				&& $dbintf->NameInUseExcept($usrdata['name'],$theuser['accid']))
        {
          $msg[] = new Msg(MSG_ERR,'Name is already in use');
          $isok = false;
        }
				if ($isok)
				{
					if ($usrdata['enabled'] && $dbintf->UsrExistsExcept($usrdata['usr'],$theuser['accid']))
					{
						$msg[] = new Msg(MSG_ERR,'Username is already in use');
						$isok = false;
					}
				}
				if ($isok)
				{
					if (int_ensure_defined($theuser['tenantid'])!=0)
					{
						$tndata = $dbintf->GetTenantMandates($theuser['tenantid']);
						$usrdata = array_merge( $usrdata , $tndata );
            $istenant = true;
					}
				}
				if ($isok)
				{
          $merged = array_merge($theuser,$usrdata);
          LogAction('Edit user', array('id'=>$userid,'name'=>$merged['name'],'tenantid'=>$theuser['tenantid']) );
					if ($dbintf->EditUserAccount($userid,$usrdata)==false)
					{
						$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr).' (basic)');
						$isok = false;
					}
        }
      } else {
        if ( (int)$dbintf->GetConfigValue('DupNamesAllowed') == 0
				&& $dbintf->NameInUse($usrdata['name']))
        {
          $msg[] = new Msg(MSG_ERR,'Name is already in use');
          $isok = false;
        }
        if ($usrdata['enabled'] && $dbintf->UsrExists($usrdata['usr']))
        {
          $msg[] = new Msg(MSG_ERR,'Username is already in use');
          $isok = false;
        }
        if ($isok)
        {
          // userid is filled in by function
          $isok = $dbintf->AddUserAccount($userid,$usrdata,$grpaccid);
          if ($isok==false)
          {
            $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr).' (add)');
          } else
          {
            $uinfo = $dbintf->GetUserInfo($userid);
            LogAction('Add user', array('id'=>$userid,'name'=>$uinfo['name'],'tenantid'=>$uinfo['tenantid']) );
          }
        }
      }
			if (!$isok) $anyerr = true;
      if ($isok)
      {
        $userinfo = $dbintf->GetUserInfo($userid);

				// we might have received access
				// to the new user account
				$dbintf->RecalcPermissions();
				
        if (isset($_POST['phones']))
        {
          $phonechange = true;
          $phones_list = explode(';',$_POST['phones']);
          $phones = array();
          foreach ($phones_list as $phone_item)
          {
						$phone = '';
            $obj = array();
            if ($phone_item=='') continue;
						if (substr($phone_item,0,2)=="~~")
            {
							if ($subadmin) continue;
							$ipaddr = substr($phone_item,2);
              $obj['contactid'] = $dbintf->GetOrCreateIpAddr( $ipaddr );
						} else if ($phone_item[0]=="~")
            {
							if ($subadmin) continue;
              $newcid = substr($phone_item,1);
              $res = $dbintf->GetOrCreateCallerID($newcid,'',1);
              $obj['contactid'] = $res["contactid"];
            } else {
							$tmpres = $dbintf->GetContactInfo($phone_item);
							if ($tmpres===false)
							{
								continue;
							} else
							{
								$obj['contactid'] = $phone_item;
							}
            }
						if ( (int) $dbintf->GetCachedConfigValue('UniquePhones') != 0 )
						{
							$tmpres = $dbintf->GetContactInfo( $obj['contactid'] );
							$phone = $tmpres['t'];
							$other_accid = $dbintf->PhoneInUseExcept( $obj['contactid'] ,  $userinfo['accid'] );
							if ($other_accid !== false)
							{
								$anyerr = true;
								$other_user = $dbintf->GetUserInfoOnAccId($other_accid);
								if ($other_user===false)
								{
									$other_des = '{deleted}';
								} else
								{
									$other_des = $other_user['usr'];
									if ($other_des=='')
									{
										$other_des = $other_user['name'];
									}
								}
								$msg[] = new Msg(MSG_ERR,'The phone ' . $phone . ' is already attached to user ' . $other_des );
							}
						}
            $phones[] = $obj;
          }
          $isok = $dbintf->SetUserPhones($userinfo['accid'],$phones);
          if ($isok==false)
          {
            $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr).' (phones)');
						$anyerr = true;
          }
        }
        if (isset($_POST['accpm']) && !$subadmin)
        {
          $accpm_list = explode(';',$_POST['accpm']);
          $accpm = array();
          foreach ($accpm_list as $accpm_item)
          {
            $obj = array();
            if ($accpm_item=='') continue;
            $splitted = explode(',',$accpm_item);
            $obj['callaccid'] = (int) $splitted[0];
            $obj['pm'] = (int) $splitted[1];
            $obj['applytype'] = 0;
            $accpm[] = $obj;
          }
          $isok = $dbintf->SetAccAccPms($userinfo['accid'],$accpm);
          if ($isok==false)
          {
            $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr).' (permissions)');
						$anyerr = true;
          }
        }
				if (isset($_POST['recpm']) && !$subadmin)
        {
          $recpm_list = explode(';',$_POST['recpm']);
          $recpm = array();
          foreach ($recpm_list as $recpm_item)
          {
            $obj = array();
            if ($recpm_item=='') continue;
            $splitted = explode(',',$recpm_item);
            $obj['recorderid'] = (int) $splitted[0];
            $obj['epermissions'] = (int) $splitted[1];
            $recpm[] = $obj;
          }
          $isok = $dbintf->SetUserRecorderPms($userinfo['accid'],$recpm);
          if ($isok==false)
          {
            $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr).' (permissions)');
						$anyerr = true;
          }
        }				
        if (isset($_POST['grp1']))
        {
          $grpaccid = $_POST['grp1'];
          //$oldgroups = $dbintf->GetGroupsOfWhichMember($userinfo['accid']);
          $usergroups = $dbintf->GetGroupsOfWhichMember($userinfo['accid']);
          $groupchange = true;
          if($istenant)
          {
            $oldtenant = $userinfo['tenantid'];
          }
          $usergroups[0] = $grpaccid;
          if ($grpaccid==0)
          {
            array_shift($usergroups);
          }
          if ($grpfixed!=-1)
          {
						$usergroups = array($grpfixed);
					}
          $isok = $dbintf->SetGroupsOfWhichMember($userinfo['accid'],$usergroups);
          if ($isok==false)
          {
            $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr).' (membership)');
						$anyerr = true;
          }
        }
        if(isset($_POST['webclientsettings']))
        {
          $webclientsettings = $_POST['webclientsettings'];
          WebClientUpdateSettingsUser($webclientsettings, $userinfo['accid']);
        }
        
        $reconfig = str_ensure_defined($_POST['needreconfig'])=='1';
        
        EnginesSettingsCalcApply($reconfig);

        $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));
      }
      
			
			// use $_SESSION for messaging
			// redirect
			$_SESSION['msg'] = $msg;
			if ($anyerr)
			{
				if ($userid!=-1) header('Location: '.$rooturl.'user.php?id='.$userid);
				else header('Location: '.$rooturl.'user.php');
			} else
			{
				header('Location: '.$rooturl.'users.php');
			}
			exit;
    }
  }

  $in_edit = false;
  if (isset($_GET['accid']))
	{
    $theuser = $dbintf->GetUserInfoOnAccId((int) $_GET['accid']);
		if ($theuser===false)
		{
      $msg[] = new Msg(MSG_ERR,'User account does not exist.');
    	$_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'users.php');
			exit;
		}
		$userid = $theuser['id'];
	}
  if (isset($_GET['id']))
  {
    $userid = $_GET['id'];
	}
	if (isset($userid))
	{
    $in_edit = true;
	  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
    {
	    if ($dbintf->IsUserAdmin($userid))
	    {
        $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
       	$_SESSION['msg'] = $msg;
       	header('Location: '.$rooturl.'users.php');
	    	exit;
			}
		}
    $theuser = $dbintf->GetUserInfo($userid);
		if ($theuser===false)
		{
      $msg[] = new Msg(MSG_ERR,'User account does not exist.');
    	$_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'users.php');
			exit;
		}
    if ($subadmin && ($theuser['manager']!=$dbintf->actuinfo['id']) )
    {
      $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
    	$_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'users.php');
    	exit;
		}
    if ($dbintf->MayEditUserAccount($theuser['id'],$theuser['accid'])==false)
    {
      $msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
    	$_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'users.php');
    	exit;
		}
		
		/*if ($subusers)
		{
			if ($dbintf->IsSubUser($theuser['accid'])==false)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'users.php');
				exit;
			}
		}*/

    $accpms = $dbintf->GetAccAccPms(array($theuser['accid']));
    $usergroups = $dbintf->GetGroupsOfWhichMember($theuser['accid']);
    $userphones = $dbintf->GetUserPhones($theuser['accid']);
		$recorderpms = $dbintf->GetUserRecorderPms($theuser['accid']);

		/*
		// moved to dynamic request
    $inh_accpms = $dbintf->GetAccAccPms($usergroups);
    $supergroups = $dbintf->GetSuperGroups($usergroups);
    $spr_accpms = $dbintf->GetAccAccPms($supergroups);
    foreach($spr_accpms as $accacc)
    {
      if ($accacc['applytype']!=1) continue;
      $inh_accpms[] = $accacc;
		}
		*/
  } else {
    $theuser['id'] = -1;
    // set defaults
    $theuser['permissions'] = 0;
    $theuser['enabled'] = 1;
		$theuser['playtimelim'] = 0;
		$theuser['customlocalid'] = 0;
		$theuser['freeseat'] = 0;
		$theuser['recondmd'] = 0;
		$theuser['delondmd'] = 0;
		$theuser['silondmd'] = 0;
		$theuser['maxcallage'] = -1;
    $theuser['iaperiod'] = -1;
		$recorderpms = array();
  }

  $line_list = $dbintf->GetLineList();

	// caller id loading is too much, so moved to async.

  $group_list = $dbintf->GetGroupList(); // full list
  $acc_list = $dbintf->GetAccessorsList(); // full list
	$recorder_list = $dbintf->GetRecorders(); // full list

  $data = 'var theuser='
  . '{id:'.$theuser['id']
  . ',accid:'.int_ensure_defined($theuser['accid'])
  . ',usr:"'.JSQuote(str_ensure_defined($theuser['usr'])).'"'
  . ',enabled:'.$theuser['enabled']
  . ',playtimelim:'.$theuser['playtimelim']
	. ',recondmd:'.int_ensure_defined($theuser['recondmd'])
	. ',delondmd:'.int_ensure_defined($theuser['delondmd'])
	. ',silondmd:'.int_ensure_defined($theuser['silondmd'])
	. ',customlocalid:'.int_ensure_defined($theuser['customlocalid'])
	. ',freeseat:'.int_ensure_defined($theuser['freeseat'])
  . ',name:"'.JSQuote(str_ensure_defined($theuser['name'])).'"'
  . ',email:"'.JSQuote(str_ensure_defined($theuser['email'])).'"'
  . ',rod:'.int_ensure_defined($theuser['rod'])
	. ',logonmethod:'.int_ensure_defined($theuser['logonmethod'])
  . ',mphones:"'.JSQuote(str_ensure_defined($theuser['mphones'])).'"'
  . ',maxcallage:"'.int_ensure_defined($theuser['maxcallage']).'"'
  . ',iaperiod:"'.int_ensure_defined($theuser['iaperiod']).'"'
  . "};\r\n";
	$data .= 'var can_ldap = '
		. (extension_loaded('ldap')?'1':'0')
		. ";\r\n";
  if ($in_edit)
  {
    $data .= 'var accpms=[';
    $first = true;
    foreach ($accpms as $row)
    {
      if ($first==false) $data .= ',';
      $data .= '{id:'.$row['id']
      . ',accid:'.$row['accid']
      . ',callaccid:'.$row['callaccid']
      . ',pm:'.$row['epermissions']
      . "}\r\n";
      $first = false;
    }
    $data .= "];\r\n";

		// inh. permissions moved to dynamic request
		// because it changes because of group selection

    $data .= 'var memberof=\'';
    $first = true;
    foreach ($usergroups as $row)
    {
      if ($first==false) $data .= ', ';
      $data .= GetGroupName($group_list,$row);
      $first = false;
    }
    $data .= "';\r\n";
    $data .= 'var usergroups=[';
    $first = true;
    foreach ($usergroups as $row)
    {
      if ($first==false) $data .= ',';
      $data .= '{accid:'.$row.'}';
      $first = false;
    }
    $data .= "];\r\n";
    $data .= 'var phones=[';
    $first = true;
    foreach ($userphones as $userphone)
    {
      if ($first==false) $data .= ',';
			$ctdat = $dbintf->GetContactInfo($userphone);
			$data .= '{contactid:'.$userphone;
			$data .= ',cname:"'.JSQuote($ctdat['name']).'"';
			$data .= ',value:"'.JSQuote($ctdat['value']).'"';
			$data .= ',callerid:"'.JSQuote($ctdat['callerid']).'"';
			$data .= ',ctype:'.$ctdat['ctype'];
			if (isset($ctdat['linenr'])) $data .= ',linenr:'.$ctdat['linenr'];
			$data .= '}'."\r\n";
      $first = false;
    }
    $data .= "];\r\n";
  } else {
    $data .= "var usergroups=[];\r\n";
    $data .= "var phones=[];\r\n";
    $data .= "var memberof=''\r\n";
    $data .= "var accpms=[];\r\n";
    //$data .= "var inh_accpms=[];\r\n";
  }
	$data .= "var recorderpms = " . json_encode($recorderpms) . ";\r\n";
	$recorders_js = array();
	foreach ($recorder_list as $recorder)
	{
		$recobj = new stdClass();
		$recobj->id = $recorder['id'];
		$recobj->name = $recorder['name'];
		$recorders_js[] = $recobj;
	}
	$data .= "var recorders = " . json_encode($recorders_js) . ";\r\n";
	// recordermap is created based on this in JS dynamically

	//echo '<pre>';
	//echo $data;
	//exit;

  // callerids (and lines), move to async, because too much load
	
	// -2: seen two
	// -1: seen none
	$tenantid = -1;

	$accid_ordering = array();
  $data .= "var accs=[];\r\n";
  foreach ($acc_list as $acc)
  {
		if ($limited_users)
		{
			if ( ($in_edit && $acc['accid']==$usergroups[0])
			|| ($acc['accid']==$dbintf->actuinfo['accid']) )
			{
				;
			} else
			{
				// remove users from list, to which account has no access
				//if (($dbintf->GetAccPm($acc['accid'])&PM_USERS)==0)
				if (($dbintf->GetAccPm($acc['accid']))==0)
				{
					continue;
				}
			}
			if ($acc['type']==1) // group
			{
				if ($tenantid === -2)
				{
					// seen two different
				} else if ($tenantid === -1)
				{
					// seen none yet
					$groupinfo = $dbintf->GetGroupInfoOnAccId($acc['accid']);
					$tenantid = $groupinfo['tenantid'];
				} else
				{
					$groupinfo = $dbintf->GetGroupInfoOnAccId($acc['accid']);
					$other_tenantid = $groupinfo['tenantid'];
					if ($tenantid != $other_tenantid)
					{
						$tenantid = -2;
					}
				}
			}
		}
    $data .= "accs[" . $acc['accid'] . "]= " .
        '{name:"' . JSQuote($acc['name']) . '"' .
        ",type:" . $acc['type'] .
        "};\r\n";
		$accid_ordering[] = (int) $acc['accid'];
  }
	$data .= "var accid_ordering = ".json_encode($accid_ordering).";\r\n";
	if ($in_edit)
	{
		if (int_ensure_defined($theuser['tenantid'])!=0)
		{
			$tenantid = $theuser['tenantid'];
		}
	}
	if ($tenantid<0) $tenantid = 0;
	
	if ($tenantid != 0)
	{
		// load tenant settings
		$tenant_cfg_keys = array('RecOnDmdAvail','SilOnDemandAvail');
		$obj = array();
		$tn_prefix = 'TN' . $tenantid . '_';
		foreach ($tenant_cfg_keys as $cfgkey)
		{
			$key = $tn_prefix . $cfgkey;
			$obj[ $cfgkey ] = $dbintf->GetConfigValue( $key );
		}
		$data .= 'var tenant_cfg = ' . json_encode( $obj, JSON_FORCE_OBJECT ) . ";\r\n";
    $data .= 'var tenant_id = ' . $tenantid . ";\r\n";
	} else
	{
		$data .= "var tenant_cfg = {};\r\n";
	}

  //Get the password information!
  $minpwdlength = int_ensure_defined($configs['MinPwdLength']);
  $strongpwdauth	= int_ensure_defined($configs['StrongPwdAuth']);

	if(($dbintf->actuinfo['permissions']&PM_CONFIG)!=0)
	{
		$delondmdtype = int_ensure_defined($configs['DelOnDmdType']);
		$data .= "var delondmdtype=" . $delondmdtype . ";\r\n";
	}else
	{
		$data .= "var delondmdtype = 0;\r\n";
	}

  $data .= "var iaConfigPeriodUser=" . (int_ensure_defined($configs_s['iaConfigPeriodUser']) ? 1 : 0) . ";\r\n";
	
	LogAction("Viewed user",array("level"=>"view","id"=>str_ensure_defined($_GET['id']),'name'=>$theuser['name'],'tenantid'=>$tenantid));
	
  $webclientsettings_dialog = WebClientSettingsUser($theuser['accid']);
  
	// ready with database
	$dbintf->close();
	
	$recondmdtype = int_ensure_defined($configs['RecOnDmdType']);
	$silondmdtype = int_ensure_defined($configs['SilOnDemand']);
	$sipfiltertype = int_ensure_defined($configs['SipFilterType']);
	$data .= "var grpfixed=" . $grpfixed . ";\r\n";
  $data .= "var minpwdlength=" . $minpwdlength . ";\r\n";
	$data .= "var strongpwdauth=" . $strongpwdauth . ";\r\n";
	$data .= "var recondmdtype=" . $recondmdtype . ";\r\n";
	$data .= "var silondmdtype=" . $silondmdtype .";\r\n";
	$data .= "var sipfiltertype=" . $sipfiltertype .";\r\n";
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/user.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['fr_dialog_contact'] = file_get_contents('../apresa/templ/fr_dialog_contact.htm');
  $rpl['fr_pm_set'] = file_get_contents('../apresa/templ/fr_pm_set.htm');
  $rpl['jsusergroup'] = file_get_contents('../apresa/templ/usergroup.js');
  $rpl['header'] = GetHeader();
  $rpl['webclient_settings_dialog'] = $webclientsettings_dialog;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}


?>
