<?php

require_once('general.php');

HandleUser($dbintf);

function GetGroupName($group_list,$row)
{
  foreach($group_list as $group)
  {
    if ($group['accid']==$row)
    {
      return $group['name'];
    }
  }
  return '???';
}

function ContactIdPhoneFilter($var)
{
	global $phonemap;
	return isset($phonemap[ $var['contactid'] ]);
}

function HandleUser($dbintf)
{
  global $rpl,$rooturl,$msg,$phonemap;

	$limited_users = false;
  if (($dbintf->actuinfo['permissions']
	&(PM_CONFIG|PM_SUBADMIN|PM_T2_ADMIN|PM_T3_ADMIN|PM_USERS))==0
	)
  {
		if ( ($dbintf->anyaccpms|PM_USERS)!=0)
		{
			$limited_users = true;
		} else
		{
			echo 'Permission denied';
			exit;
		}
  }

	$subadmin = false;
	$grpfixed = -1;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0
	&& ($dbintf->actuinfo['permissions']&PM_SUBADMIN)!=0
	)
	{
		$subadmin = true;
		$arr = $dbintf->GetGroupsOfWhichMember( $dbintf->actuinfo['accid'] );
		if (count($arr)>0)
		{
			$grpfixed = $arr[0];
		}
		$phonelist = $dbintf->GetUserPhones( $dbintf->actuinfo['accid'] );
		foreach ($phonelist as $phone)
		{
			$phonemap[ $phone ] = true;
		}
	}

  if (isset($_GET['accid']))
	{
    $theuser = $dbintf->GetUserInfoOnAccId((int) $_GET['accid']);
		if ($theuser===false)
		{
      $msg[] = new Msg(MSG_ERR,'User account does not exist.');
    	$_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'users.php');
			exit;
		}
		$userid = $theuser['id'];
	}
  if (isset($_GET['id']))
  {
    $userid = $_GET['id'];
	}
	if (isset($userid)==false)
	{
    $msg[] = new Msg(MSG_ERR,'No user id specified');
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl.'users.php');
		exit;
	}

	if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
	{
		if ($dbintf->IsUserAdmin($userid))
		{
			$msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
			$_SESSION['msg'] = $msg;
			header('Location: '.$rooturl.'users.php');
			exit;
		}
	}
	$theuser = $dbintf->GetUserInfo($userid);
	if ($theuser===false)
	{
		$msg[] = new Msg(MSG_ERR,'User account does not exist.');
		$_SESSION['msg'] = $msg;
		header('Location: '.$rooturl.'users.php');
		exit;
	}
	if ($subadmin && ($theuser['manager']!=$dbintf->actuinfo['id']) )
	{
		$msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
		$_SESSION['msg'] = $msg;
		header('Location: '.$rooturl.'users.php');
		exit;
	}
	if ($dbintf->MayEditUserAccount($theuser['id'],$theuser['accid'])==false)
	{
		$msg[] = new Msg(MSG_ERR,GetErrDescr('pm-denied'));
		$_SESSION['msg'] = $msg;
		header('Location: '.$rooturl.'users.php');
		exit;
	}
		
  $data = 'var theuser='
  . '{id:'.$theuser['id']
  . ',accid:'.(int)$theuser['accid']
  . ',usr:"'.JSQuote(str_ensure_defined($theuser['usr'])).'"'
  . ',enabled:'.$theuser['enabled']
  . ',name:"'.JSQuote(str_ensure_defined($theuser['name'])).'"'
  . "};\r\n";

  $acc_list = $dbintf->GetAccessorsList(); // full list
	
  $data .= "var accs=[];\r\n";
  foreach ($acc_list as $acc)
  {
		if ($limited_users)
		{
			if ( ($in_edit && $acc['accid']==$usergroups[0])
			|| ($acc['accid']==$dbintf->actuinfo['accid']) )
			{
				;
			} else
			{
				// remove users from list, to which account has no access
				//if (($dbintf->GetAccPm($acc['accid'])&PM_USERS)==0)
				if (($dbintf->GetAccPm($acc['accid']))==0)
				{
					continue;
				}
			}
		}
		
    $data .= "accs[" . $acc['accid'] . "]= " .
        '{name:"' . JSQuote($acc['name']) . '"' .
        ",type:" . $acc['type'] .
        "};\r\n";
  }

	// Get access list
	$db2 = new DBInterface('');
	$db2->cloneInit( $dbintf );
	$db2->SetCurrentUserId( $theuser['id'] );
	$data .= 'var access_list = [';
	$ix = 0;
	$first = true;
	if ($db2->actuinfo['permissions']!=0)
	{
		$ix++;
		$data .= '{"id":'.$ix
		. ',"callaccid":0'
		. ',"pm":'.$db2->actuinfo['permissions']
		. "}\r\n";
		$first = false;
	}
	foreach ($db2->accpms	as $accid=>$pm)
	{
		if (isset($dbintf->allgroups[$accid]))
		{
			continue;
		}
		$ix ++;
		if ($first==false) $data .= ',';
		$first = false;
		$data .= '{"id":'.$ix
		. ',"callaccid":'.$accid
		. ',"pm":'.$pm
		. "}\r\n";
	}
	$data .= '];' . "\r\n";	
	// end of access list
	
	LogAction("View user permissions",array("level"=>"view","id"=>$userid,'name'=>$theuser['name'],'tenantid'=>$theuser['tenantid'] ));
	
  // ready with database
  $dbintf->close();
	
  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/user_pm.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['fr_dialog_contact'] = file_get_contents('../apresa/templ/fr_dialog_contact.htm');
  $rpl['fr_pm_set'] = file_get_contents('../apresa/templ/fr_pm_set.htm');
  $rpl['jsusergroup'] = file_get_contents('../apresa/templ/usergroup.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}


?>
