<?php

require_once('general.php');

HandleUsers($dbintf);

function HandleUsers($dbintf)
{
  if (($dbintf->actuinfo['permissions']
		&(PM_CONFIG|PM_SUBADMIN|PM_USERS|PM_T2_ADMIN|PM_T3_ADMIN))==0
	&& ($dbintf->anyaccpms&PM_USERS)==0
		)
  {
    echo 'Permission denied';
    exit;
  }

  global $rpl,$msg,$lng,$configs_s;

	$subadmin = false;
  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0
	&& ($dbintf->actuinfo['permissions']&PM_SUBADMIN)!=0
	)
	{
		$subadmin = true;
	}

	// block not available for subadmin
	$act = str_ensure_defined($_POST['act']);
	if ($subadmin==false)
	{

	  if (str_ensure_defined($_GET['act'])=='export')
	  {
      LogAction('Export user list');
      
      if($_GET['type'] == 'xlsx')
      {
        $file = new XLSXFile();
      }
      else
      {
        $file = new CsvFile();
      }
      
      $file->Init("users");
      $row = $file->CreateRow();

	    $user_list = $dbintf->GetEditableUserList();
	    $group_list = $dbintf->GetGroupList();
	    $groups = array();
	    foreach ($group_list as $group)
	    {
	      $groups[ $group['accid'] ] = $group['name'];
      }
      
      $row->add('DB-ID');
      $row->add($lng->Get('Main.Name'));
	    $row->add($lng->Get('Main.Enabled'));
	    $row->add($lng->Get('Main.Username'));
	    $row->add($lng->Get('Main.Password'));
	    $row->add($lng->Get('Web.Telephones'));
	    $row->add($lng->Get('PM.MemberOf'));
	    $row->add($lng->Get('Main.Email'));
			$row->add($lng->Get('PM.ManagedPhones'));
			$row->add($lng->Get('Options.LogonMethod'));
	    $row->add($lng->Get('Options.RecOnDemand'));
	    $row->add($lng->Get('Options.DelOnDmd'));
	    $row->add($lng->Get('Options.SilenceOnDemand'));
	    $row->add($lng->Get('Options.CustomLocalId'));
	    $row->add($lng->Get('Options.FreeSeatAccount'));
	    $row->add($lng->Get('Options.StoreOnDemand'));
	    $row->add($lng->Get('LDAP.Usr'));
      $row->add($lng->Get('Web.WebClientSettings'));
      $row->output();

	    foreach ($user_list as $row)
	    {
	      $usergroups = $dbintf->GetGroupsOfWhichMember($row['accid']);
	      $userphones = $dbintf->GetUserPhones($row['accid']);

	      $phones = '';
	      $first2 = true;
	      foreach ($userphones as $phone)
	      {
	        if ($first2==false) $phones .= ', ';
	        $first2 = false;
	        $ctdat = $dbintf->GetContactInfo($phone);
					if ($ctdat['ctype']==2)
					{
						$phones .= 'IP#'.$ctdat['value'];
	        } else if ($ctdat['ctype']==1)
	        {
	        	$phones .= 'LINE#'.$ctdat['linenr'];
					} else
					{
	        	$phones .= $ctdat['callerid'];
					}
	      }
	      $groupst = '';
	      $first2 = true;
	      foreach ($usergroups as $usergroup)
	      {
	        if ($first2==false) $groupst .= ', ';
	        $first2 = false;
	        $groupst .= $groups[ $usergroup ];
        }
        $frow = $file->CreateRow();

	      $frow->add($row['id']);
	      $frow->add($row['name']);
	      $frow->add($row['enabled']);
	      $frow->add($row['usr']);
        $frow->add('');
        $frow->add($phones);
	      $frow->add($groupst);
	      $frow->add($row['email']);
				$frow->add($row['mphones']);
				$frow->add($row['logonmethod']);
				$frow->add($row['recondmd']);
				$frow->add($row['delondmd']);
				$frow->add($row['silondmd']);
				$frow->add($row['customlocalid']);
				$frow->add($row['freeseat']);
				$frow->add($row['rod']);
				$frow->add($row['ldapuser']);
				$frow->add($row['webclientsettings']);
	      $frow->output();
      }

      $file->Finish();
	    exit;
	  }

	} // end restricted area

  if ($act!='')
  {
    if ($act=='del-useracc')
    {
      $ids = explode(',',$_POST['del-ids']);
      foreach ($ids as $id)
      {
        $userinfo = $dbintf->GetUserInfo($id);
        if($userinfo === false) continue;

        $tenantid = -1;
        if(isset($userinfo['tenantid']))
        {
          $tenantid = $userinfo['tenantid'];
        }
        LogAction('Delete user',array('id'=>$id,'name'=>$userinfo['name'],'tenantid'=>$tenantid) );
        if ($dbintf->DeleteUserAccount($id)==false)
        {
          $msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
        }
      }
			
      EnginesSettingsCalcApply();
      
      // redirect
    	$_SESSION['msg'] = $msg;
    	header('Location: users.php');
    }
  }

	if ($subadmin)
	{
  	$user_list = $dbintf->GetManagedUserList();
	} else
	{
  	$user_list = $dbintf->GetEditableUserList();
	}

  $group_list = $dbintf->GetGroupList();
  $groups = array();
  foreach ($group_list as $group)
  {
    $groups[ $group['accid'] ] = $group['name'];
  }

  $usersdata = 'var users = [';
  $first = true;
  foreach ($user_list as $row)
  {
    if ($first==false) $usersdata .= ',';

    $usergroups = $dbintf->GetGroupsOfWhichMember($row['accid']);

    $userphones = $dbintf->GetUserPhones($row['accid']);
    $phones = count($userphones);
    $groupst = '';
    $first2 = true;
    foreach ($usergroups as $usergroup)
    {
      if ($first2==false) $groupst .= ', ';
      $first2 = false;
      $groupst .= $groups[ $usergroup ];
    }

    $usersdata .= '{id:'.$row['id']
    . ',usr:"'.JSQuote($row['usr']).'"'
    . ',enabled:'.$row['enabled']
    . ',name:"'.JSQuote($row['name']).'"'
    . ',email:"'.JSQuote($row['email']).'"'
    . ',phones:"'.JSQuote($phones).'"'
    . ',groups:"'.JSQuote($groupst).'"'
    . ',manager:'.int_ensure_defined($row['manager'])
    . "}\r\n";
    $first = false;
  }
  $usersdata .= "];\r\n";
  if ($subadmin)
  {
		$usersdata .= 'var thisuser = { id:'.$dbintf->actuinfo['id'].' ,name:"'.JSQuote($dbintf->actuinfo['name']).'"}';
	}
  $usersdata .= GeneralJSData();

	LogAction("View users.",array("level"=>"view"));

  // ready with database
  $dbintf->close();

  $template_content = file_get_contents('../apresa/templ/users.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $usersdata;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function CsvCell($t)
{
  return '"'.str_replace('"','""',$t).'"';
}

?>
