<?php

require_once('signaling.php');


function addToSayRaw($msgtype,$msg)
{
  lg('add to say: '.$msg);
	file_put_contents('/var/apresa/data/to_say',$msgtype . $msg . "\n", FILE_APPEND);
}

function addToSay($msgtype,$msg)
{
	addToSayRaw($msgtype,HtmlQuote($msg));
}

function addToSayUniq($msgtype,$msg)
{
	// only add if new
	$ori = @file_get_contents('/var/apresa/data/to_say');
	if (strpos($ori,HtmlQuote($msg))!==FALSE) return;
	addToSay($msgtype,$msg);
}

function addToSayUser($msgtype,$msg,$accid)
{
  $msg_raw = HtmlQuote($msg);
  lg('Add to say user ' . $accid . ': ' . $msg_raw);
  file_put_contents('/var/apresa/data/to_say_' . $accid, $msgtype . $msg_raw . "\n", FILE_APPEND);
}

// info: call info loaded from database
function HasScreenRecording($info)
{
	return ($info['flags']&2)!=0;
}

function GetRecordingPath($info)
{
  return AUDIO_PATH.'/'.$info['directory'].'/';
}

function GetScreenFileName($info)
{
	if (isset($info['screenfn'])==false || $info['screenfn']=='')
	{
		return 'screen' . change_filename_extension($info['filename'],'.wmv');
	} else
	{
		return $info['screenfn'];
	}
}

// returns without dot
function get_filename_extension($fn)
{
	$info = pathinfo($fn);
	return $info['extension'];
}

// needs . in $ext
function change_filename_extension($fn,$ext)
{
	$info = pathinfo($fn);
	return $info['filename'] . $ext;
}

// replaces GetExportFileName
function GetDownloadFileName($orifn,$info,$dbread=false)
{
	global $configs;
	return GetCustomFileName(str_ensure_defined($configs['RecExportFileName']),$orifn,$info,$dbread);
}

function GetCustomFileName($cfgFn,$orifn,$info,$dbread=false)
{
	global $configs, $dbintf, $lng;

	$orifn_pi = pathinfo($orifn);

	if ($cfgFn=='')
	{
		// OLD/def.: return $info['remoteid'] . '.' . $orifn_pi['extension'];
		// removed because a custom filename might be used,
		// that also should be used in export.
		return $orifn;
	}

	if (isset($info['remoteid'])==false && $dbread)
	{
		$info = array_merge($info, $dbintf->GetCallInfo($info['id']) );
	}
	
	if ($dbread)
	{
		$L = $dbintf->GetContactName($info['localcontact']);
		$R = $dbintf->GetContactName($info['remotecontact']);
		$C = $dbintf->GetContactName($info['connectedcontact']);
	} else
	{
		$L = $info['lname'];
		$R = $info['rname'];
		$C = $info['cname'];
	}

	$dir = $info['direction'];
	$dirtext = '';
	if ($dir == 0)	$dirtext = $lng->Get('Web.Incoming');
	else if ($dir == 1) $dirtext = $lng->Get('Web.Outgoing');
	else if ($dir == 2) $dirtext = $lng->Get('Web.Internal');
	
	if ($dir==0)
	{
		// for incoming calls,
		// the local side is the receiver.
		$callerNum    = $info['remote'];
		$receiverNum  = $info['local'];
		$callerName   = $R;
		$receiverName = $L;
	} else
	{
		// for outgoing/internal/external calls,
		// the local side is the caller
		$callerNum    = $info['local'];
		$receiverNum  = $info['remote'];
		$callerName   = $L;
		$receiverName = $R;
	}

	$cat = $info['category'];
	if ($cat==0)
	{
		$cattext = $lng->Get('Main.None');
	} else
	{
		$cattext = $configs['CatLabel'. $cat];
		if ($cattext == '')
		{
			$cattext = $lng->Get('Cols.category') . ' ' . $cat;
		}
	}
	
	$tenantName = '';
	if (strpos($cfgFn,'%T')!==false)
	{
		// There is a tag referencing the tenant,
		// so we need to lookup the tenant.
		// Also lookup if dbread is false,
		// because otherwise we would have to lookup elsewhere,
		// which is a bit costly,
		// while we do not know yet if it is needed.
		if ($info['tenantid']!=null)
		{
			$tnGroup = $dbintf->GetGroupInfo( $info['tenantid'] );
			if ($tnGroup!==false)
			{
				$tenantName = $tnGroup['name'];
			}
		}
	}

	$fn = $cfgFn;
	$date = date($configs['datef'],$info['startdate']);
	$date = str_replace('/','',$date);
	$date = str_replace('-','',$date);
	$time = date($configs['timef'],$info['startdate']);
	$time = str_replace(':','',$time);
	$time = str_replace(' ','',$time);

	$fn = str_replace('%Y',date('Y',$info['startdate']),$fn);
	$fn = str_replace('%M',date('m',$info['startdate']),$fn);
	$fn = str_replace('%D',date('d',$info['startdate']),$fn);
	$fn = str_replace('%h',date('H',$info['startdate']),$fn);
	$fn = str_replace('%m',date('i',$info['startdate']),$fn);
	$fn = str_replace('%s',date('s',$info['startdate']),$fn);
	$fn = str_replace('%x',$info['duration'],$fn);
	
	$fn = str_replace('%i',$info['remoteid'],$fn);
	$fn = str_replace('%d',$date,$fn);
	$fn = str_replace('%t',$time,$fn);
	$fn = str_replace('%L',$L,$fn);
	$fn = str_replace('%l',$info['local'],$fn);
	$fn = str_replace('%R',$R,$fn);
	$fn = str_replace('%r',$info['remote'],$fn);
	$fn = str_replace('%C',$C,$fn);
	$fn = str_replace('%c',$info['connected'],$fn);
	$fn = str_replace('%F',$callerName,$fn);
	$fn = str_replace('%f',$callerNum,$fn);
	$fn = str_replace('%E',$receiverName,$fn);
	$fn = str_replace('%e',$receiverNum,$fn);
	$fn = str_replace('%T',$tenantName,$fn);
	$fn = str_replace('%b',$info['linenr'],$fn);
	$fn = str_replace('%>',$dirtext,$fn);
	$fn = str_replace('%A',$cattext,$fn);
	$fn = str_replace('%a',$cat,$fn);
  $fn = str_replace('%n1',str_ensure_defined($info['notes']),$fn);
  $fn = str_replace('%n2',str_ensure_defined($info['notes2']),$fn);
  $fn = str_replace('%n3',str_ensure_defined($info['notes3']),$fn);
  $fn = str_replace('%n4',str_ensure_defined($info['notes4']),$fn);
  $fn = str_replace('%n5',str_ensure_defined($info['notes5']),$fn);
  $fn = str_replace('%z1',str_ensure_defined($info['data1']),$fn);
  $fn = str_replace('%z2',str_ensure_defined($info['data2']),$fn);
  $fn = str_replace('%z3',str_ensure_defined($info['data3']),$fn);
  $fn = str_replace('%z4',str_ensure_defined($info['data4']),$fn);
  $fn = str_replace('%z5',str_ensure_defined($info['data5']),$fn);
	$fn .= '.' . $orifn_pi['extension'];

	// remove invalid parts of filename
	$fn = strtr($fn,' /\\:*?"<>|#'."\t\r\n",'___________'."___");

	//echo $fn;
	//exit;
	
	return $fn;
}

function IsTelNumber($tel)
{
	$len = strlen($tel);
	$digits = 0;
	for ($i=0;$i<$len;$i++)
	{
		$ch = $tel[$i];
		if ($ch>='0' && $ch<='9')
		{
			$digits++;
			continue;
		}
		if ($ch=='+'
		||  $ch=='('
		||  $ch==')'
		||  $ch==' '
		) continue;
		// invalid telephone number
		return false;
	}
	return $digits>0;
}

// 0. use part before @
// 1. use full
// 2. use full minus last dot block
// 3. use part before @ if telephone number, otherwise full
function GetSipIdToUse($full,$FullSipId)
{
	if ($FullSipId==1) return $full;
  $arr = explode('@',$full);
  if (count($arr)!=2)
  {
		return $full;
	}
  if ($FullSipId==3)
  {
    if (IsTelNumber($arr[0])) return $arr[0];
    else return $full;
  }
	if ($FullSipId==0) return $arr[0];
	$hostarr = explode('.',$arr[1]);
	if (count($hostarr)>1)
	{
		unset( $hostarr[ count($hostarr)-1 ] );
		$arr[1] = implode('.',$hostarr);
	}
	return $arr[0] . '@' . $arr[1];
}

// for ID@host, returns ID
function IdSimplify($id)
{
  $arr = explode('@',$id);
  if (count($arr)==2)
  {
    // the left part
    return $arr[0];
  }
  // otherwise return all
  return $id;
}

function EmptyNull($a)
{
  if ($a==NULL) return '';
  else return $a;
}
function ToInt($v)
{
  if (isset($v)==false) return 0;
  return (int) $v;
}

function ensure_defined_null(&$var)
{
  if(isset($var)) return $var;
  else return null;
}

function ensure_defined(&$var,$def)
{
  if (isset($var)) return $var;
  else return $def;
}
function int_ensure_defined(&$var)
{
  if (isset($var)) return (int) $var;
  else return 0;
}
function str_ensure_defined(&$var)
{
  if (isset($var)) return $var;
  else return '';
}
function add_to(&$var,$toadd)
{
  if (isset($var)) $var += $toadd;
  else $var = $toadd;
}

function HtmlQuote($t)
{
  if(!isset($t)) return '';
  $t = str_replace("&",'&amp;',$t);
  $t = str_replace("<",'&lt;',$t);
  $t = str_replace(">",'&gt;',$t);
  return $t;
}

// Javascript quote inside double quotes "AAA"
// Note: json_encode fails for non UTF-8,
// which might be a problem.
function JSQuote($t)
{
	$x = json_encode(strval($t));
  if (json_last_error()!=JSON_ERROR_NONE)
  {
    return "";
  }
	// remove quotes because we already have those
	return substr($x,1,strlen($x)-2);
}

function IsValidUtf8($text)
{
  return mb_check_encoding($text,'UTF-8');
}

function FixInvalidCharsInString( $data )
{
	if (is_string($data))
	{
		if (mb_check_encoding($data,'UTF-8')==false)
		{
			return iconv('windows-1252','UTF-8',$data);
		}
	}
	return $data;
}

// detects non UTF-8 characters,
// and replaces based on other charset assumption
// use this to prevent a database error on insertion
function FixInvalidChars( & $ref_data )
{
  foreach ($ref_data as & $ref_value)
  {
    if (is_string($ref_value))
    {
      if (mb_check_encoding($ref_value,'UTF-8')==false)
      {
        $ref_value = iconv('windows-1252','UTF-8',$ref_value);
      }
    }
  }
}

function GetFileSize($fn)
{
	if (FileExists($fn)==false) return 0;
	return filesize($fn);
}

function showkb($bytes,$prec=0)
{
	return round( $bytes / (1024) , $prec) . ' KB';
}

function showmb($bytes,$prec=0)
{
	return round( $bytes / (1024*1024) , $prec) . ' MB';
}

function GetCallFiles($call,$basepath)
{
	$files = array();
  $dirfn = $call['directory'] . '/' . $call['filename'];
  $recfn = $basepath;
  $recfn .= '/' . $dirfn;
  if (FileExists($recfn))
  {
    $files[] = $recfn;
  }
	if (HasScreenRecording($call))
	{
		$dirfn = $call['directory'] . '/' . GetScreenFileName($call);
    $recfn = $basepath;
    $recfn .= '/' . $dirfn;
    if (FileExists($recfn))
    {
      $files[] = $recfn;
    }
	}
  return $files;
}

function GetCallStorageEx($call,$basepath)
{
	$sz = 0;
  $files = GetCallFiles($call,$basepath);
  foreach ($files as $recfn)
  {
    $sz += GetFileSize($recfn);
  }
	return $sz;
}

function GetCallStorage($call)
{
  return GetCallStorageEx($call,AUDIO_PATH);
}

function startsWith($a,$b)
{
	$len = strlen($b);
	return (substr($a,0,$len)===$b);
}

function endsWith($haystack, $needle)
{
  $len = strlen($needle);
  return (substr($haystack, - $len) === $needle);
}

// returns filename of file loaded from backup,
// or otherwise returns empty string
function LoadFromBackup($info,$filename,& $errmsg)
{
  global $dbintf;
	// determine options how to access the backup
	$mount = true;
	$BckTargetType = $dbintf->GetConfigValue('BckTargetType');
	$BckPath = $dbintf->GetConfigValue('BckPath');
	if ($BckTargetType==1 || $BckTargetType==2)
	{
		$mount = false;
	}
	// mount the backup if needed
	if ($mount)
	{
		$err = signal_helper('bm BPtmp');
		if ($err!='')
		{
			$errmsg = 'Error accessing backup: ' . $err;
			return '';
		}
		// determine filename in the backup that we need
		$bck_fn = '/mnt/drive_BPtmp/'.$info['directory'].'/'.$filename;
	} else
	{
		$bck_fn = $BckPath.'/'.$info['directory'].'/'.$filename;
	}
	$good = true;
	if (file_exists($bck_fn)===false)
	{
		$good = false;
		$errmsg = 'File not found in backup';
		// no return allowed (need bu!)
	} else
	{
		// copy to local
		// we store it in temp. directory
		$tmp_fn = tempnam(sys_get_temp_dir(), 'apresa') . '.' . get_filename_extension($bck_fn);
    if (copy($bck_fn,$tmp_fn)===false)
    {
			$errmsg = 'Failed to copy file from backup';
			$good = false;
		}
	}
	// cleanup
	if ($mount)
	{
		// it is important that we unmount again
		$err = signal_helper('bu BPtmp');
		if ($err!='')
		{
			$errmsg = $err;
			return '';
		}
	}
	if ($good) return $tmp_fn;
	else return '';
}

function signal_helper($msg)
{
  $reply = 1;
	$cmd_timeout = 20;
  $err = signal_service($msg,$reply,$cmd_timeout);
  if ($err!='')
  {
    return 'Socket error: '.$err;
  }
  $msg_firstpart = explode(' ',$msg);
  $msg_firstpart = $msg_firstpart[0];

	$where = $msg_firstpart;
	// more user friendly
  if ($where)
  {
		$where = 'mounting network directory';
	}
  if ($reply=='OK')
  {
    // OK
  } else if ($reply[0]=='E')
  {
		return $where . ' failed: '.$reply;
  } else
  {
    return $where . ' failed, unexpected reply: '.$reply.' LEN: '.strlen($reply);
  }
	return ''; // OK
}

function calcChecksum($program,$file)
{
  $cmd = $program . ' -b ' . escapeshellarg($file);
  $cmdret = 0;
  $cmdout = array();
  exec($cmd,$cmdout,$cmdret);
  if ($cmdret==0 && count($cmdout)==1)
  {
    $parts = explode(' ',$cmdout[0]);
    if (count($parts)>1)
    {
      return $parts[0];
    }
  }
  return '';
}

function clusterGenConfigNotify($key,$part)
{
			global $dbintf;
			// check if we must update the configuration version for clustering
			if ($dbintf->clustering && $dbintf->nodePassive==false)
			{
				// we are the primary node (active)
				$NewV = (int) $dbintf->GetConfigValue($key) + 1;
				$newconfigs = array();
				$newconfigs[$key] = '' . $NewV;
				$dbintf->SetConfigsPart($newconfigs,$part);
			}
}

function EnginesReconfig(&$msg,$dbintf)
{
  // save db (database) config to engine configuration files
  msg_signal_service($msg,'os');
  // signal to engine that configuration has changed
  msg_signal_service($msg,'sgnork reconfig');
  if ($dbintf->GetConfigValue('CardList','crec')!='')
  {
    msg_signal_service($msg,'sgncrc reconfig');
  }

  msg_signal_service($msg, 'as');

  if($dbintf->GetConfigValue('ED137Service'))
  {
    msg_signal_service($msg,'sgned137 reconfig');
  }
  
  // signal to other party in cluster that reconfig is needed
  clusterConfigNotify(false);    
}

function clusterBackupConfigNotify()
{
	clusterGenConfigNotify('SaveB','b');
}

function clusterSystemConfigNotify()
{
	clusterGenConfigNotify('SaveS','s');
}

function clusterNetworkConfigNotify()
{
	clusterGenConfigNotify('SaveN','n');
}

// $restart: 
// true: we have restarted the voip engine
// false: we have reconfigured the voip engine (while it was running)
// $fresh:
// true: create new xml, $restart should be true
function clusterConfigNotify($restart,$fresh=false)
{
			global $dbintf;
			// check if we must update the configuration version for clustering
			if ($dbintf->clustering && $dbintf->nodePassive==false)
			{
				// we are the primary node (active)
				$NewV = max( (int) $dbintf->GetConfigValue('ConfRestartO')
				, (int) $dbintf->GetConfigValue('ReconfigO') ) + 1;
				if ($restart)
				{
					// we have restarted at pri
					// also restart at other nodes
					$newconfigs = array();
          if ($fresh)
          {
            $newconfigs['ConfFreshO'] = '' . $NewV;
          }
					// first save the restart v
					$newconfigs['ConfRestartO'] = '' . $NewV;
					// because the reconfigure will trigger the action
					$newconfigs['ReconfigO'   ] = '' . $NewV;
					$dbintf->SetConfigsPart($newconfigs,'o');
				} else
				{
					// we have only reconfigured at PRI
					$newconfigs = array();
					$newconfigs['ReconfigO'   ] = '' . $NewV;
					$dbintf->SetConfigsPart($newconfigs,'o');
				}
				// These new settings should be detected at the secondary
				// by apresa-remote, and applied there.
			}
}

// serving byte ranges
// this yields better streaming playback		
// it is needed for WMP seeking
function ServerFilePart($filename)
{
	$size = filesize($filename);
	$ServeRanges = true;
	if ($ServeRanges)
	{
		// check if we can open
		$filehandle = fopen($filename,'rb');
		if ($filehandle===false)
		{
			header_remove('Content-Type');
			header_remove('Content-Disposition');
			header('Content-Type: text/plain');
			echo "Could not open file. ".$filename;
			exit;
		}

		header('Accept-Ranges: bytes');
		// parse bytes=000-999
    if(isset($_SERVER['HTTP_RANGE']))
    {
  		list($unit,$ranges) = explode('=',str_ensure_defined($_SERVER['HTTP_RANGE']),2);
  		$ranges = explode(',',$ranges,2);
  		$range = $ranges[0];
  		// parse 000-999
  		list($start,$end) = explode('-', $range, 2);
  		// normalize start/end
  		if (empty($start))
  		{
  			$start = 0;
  		} else
  		{
  			$start = abs(intval($start));
  		}
  		if (empty($end))
  		{
  			$end = $size - 1;
  		} else
  		{
  			$end = abs(intval($end));
  		}
  		$end = min($size-1,$end);
  		if ($start>$end) $start = 0;

  		// after normalization, is the range we are going to server partial?
  		if ($start!=0 || $end!=$size-1)
  		{
  			header('HTTP/1.1 206 Partial Content');
  			header('Content-Range: bytes '.$start.'-'.$end.'/'.$size);
  		}
  		header('Content-Length: '.($end-$start+1));
    }
    else
    {
      $start = 0;
      $end = $size-1;
      header('Content-Length: '. $size);
    }

		// write out the requested portion of the file
		fseek($filehandle,$start);
		$pos = $start;
		set_time_limit(0);
		while (!feof($filehandle))
		{
			$toread = $end - $pos + 1;
			if ($toread>8192) $toread = 8192;
			if ($toread<=0) break;
			$content = fread($filehandle,$toread);
			if ($content===false)
			{
				break;
			}
			$pos += strlen($content);
			print($content);
			flush();
			ob_flush();
		}

		fclose($filehandle);
	} else
	{
		header('Content-Length: '.$size);
		readfile($filename);
	}
	// might need to do extra things
	// so not: exit;
}

// Login related functions
// these are also needed for general

function LdapLogin($username,$password,$ldap_host)
{
	global $dbintf, $msg;
	lg('Trying LDAP login '.$username);
	
	if (extension_loaded('ldap')==false)
	{
		$msg[] = new Msg(MSG_ERR,"LDAP extension not loaded");
		return false;
	} 

	// Load from settings
	$configs_n = $dbintf->LoadConfigsPart('n');
	if ($ldap_host=='')
	{
		$key = '';
		$ldap_host = $dbintf->GetConfigValue('LdapHost');
	} else
	{
		foreach($configs_n as $param=>$value)	//Get the correct Ldap server!
		{
			$pos = strpos($param, "LdapHost");
			if(($pos !== false) && ($value == $ldap_host))
			{
				$key = substr($param, 8);
			}
		}
	}
	$domain_usr_prefix = $dbintf->GetConfigValue('UsersDomain'.$key);

	if ($ldap_host=='')
	{
		$msg[] = new Msg(MSG_ERR,"LDAP configuration error");
		return false;
	}
	if ($password=='')
	{
		$msg[] = new Msg(MSG_ERR,"Please input a password");
		return false;
	}
	
	$usr = $username;
	$pos = strpos($usr, "@");		//With a @-sign in the name it's a UniversalPrincipleName. Do not prefix!
	if ($domain_usr_prefix!='' && $pos === false)
	{
		$usr = $domain_usr_prefix . '\\' . $usr;
	}
	
	$lc = @ldap_connect($ldap_host);
	if (!$lc)
	{
		$msg[] = new Msg(MSG_ERR,"Could not connect to authentication server (code: ".ldap_errno($lc).")");
		lg('LDAP connect error: '.ldap_errno($lc).' '.ldap_error($lc));
		return false;
	}
  
  // set LDAP to protocol version 3
  // maybe needed for UTF8 with AD
  // needed for Synology
  @ldap_set_option($lc, LDAP_OPT_PROTOCOL_VERSION, 3);

	$bd = @ldap_bind($lc,$usr,$password);
	if (!$bd)
	{
		$msg[] = new Msg(MSG_ERR,"LDAP authentication error (code: ".ldap_errno($lc).")");
		lg('LPAP bind error: '.ldap_errno($lc).' '.ldap_error($lc));
		return false;
	} 
	
	ldap_unbind($lc);
	$lc = null;
	
	return true;
}

function CachedLdapLogin($username, $password, $userinfo)
{
	global $dbintf;
	$currenttime = time();
	// Apresa Client checks each 10 seconds, or each 20 seconds with CC,
  // so 30 seconds has a 10 second margin,
	// the 10*60 means each 10 min. a recheck is forced
	if (DBInterface::VerifyPwd($password,$userinfo['ldappwd'])
	&& $userinfo['ldapcacheuse'] > $currenttime - 30
	&& $userinfo['ldapvalidated'] > $currenttime - 10*60
	)
	{
		$dbintf->EditUserAccountLC($userinfo['id']
		, array('ldapcacheuse'=>time() )
		);
		return true;
	}
	if (LdapLogin($username, $password, $userinfo['ldaphost']))
	{
		$dbintf->EditUserAccountLC($userinfo['id']
		, array('ldapvalidated'=>$currenttime
			,'ldapcacheuse'=>$currenttime
			,'ldappwd'=>DBInterface::CreatePwdHash($password) )
		);
		
		return true;
	}
	return false;
}

function GetErrDescr($errcode)
{
  global $lng;
  // not translate
  if ($errcode=='db') return 'Database error.';
  // not translate
  if ($errcode=='lock-out') return 'There must remain at least one enabled administrator account.';
  // not translate
  if ($errcode=='pm-denied') return 'Permission denied';
  if ($errcode=='not-found') return 'Did not find record in database';
  if ($errcode=='login-failed') return $lng->Get('Web.LoginFailed');
  // demo
	if ($errcode=='demo-editadmin') return 'It is not possible to edit the administrator account in this demo.';
  if ($errcode=='demo-protecteduser') return 'It is not possible to edit this specific user account in this demo.';
  if ($errcode=='demo-delcall') return 'It is not possible to delete calls in this demo.';
  if ($errcode=='demo-protectedgroup') return 'It is not possible to edit this group in this demo.';
	if ($errcode=='compact-users') return 'The maximum number of users in the Compact Edition is reached.';
	if ($errcode=='phone-in-use') return 'The phone is already attached to another user';
  return $errcode;
}

// returns true if succesful
function GenTryLogin($dbintf, $username, $password, $pcname, &$uid)
{
	global $lng, $msg, $CLIENT;

	$freeseat = false;
	$MaxPwdFailures = 5;
	
  $uid = -1;
	$userinfo = $dbintf->GetUserInfoOnUsername($username);
  if ($userinfo && ($userinfo['freeseat']!=0 && $dbintf->IsUserAdmin($userinfo['id'])==false))
	{
		if (isset($CLIENT)==false)
		{		
			$msg[] = new Msg(MSG_ERR,'This free-seating account is only for use with Apresa Client');
			return false;
		} else
		{
			$freeseat = true;
		}
	}
	$login_ok = false;
	if ($userinfo===false)
	{
		// account does not exist
		$msg[] = new Msg(MSG_ERR,GetErrDescr('login-failed'));
	} else
	{
		// check LDAP password setting is enabled for this user.
		$logonmethod = (int) $userinfo['logonmethod'];
		if ($logonmethod==1)
		{
			if ($userinfo['enabled']==0)
			{
				$msg[] = new Msg(MSG_ERR,GetErrDescr('login-failed'));
				// disabled account
			} else
			{
				$login_ok = CachedLdapLogin($username
						, $password
						, $userinfo );
				if ($login_ok)
				{
					$uid = $userinfo['id'];
				}
			}
		} else if ($logonmethod==0)
		{
			$login_ok = $dbintf->TryLoginEx($username,$password,$uid,$pwdnok);
			if (!$login_ok)
			{
				if ($dbintf->lasterr == 'temporarily disabled')
				{
					$msg[] = new Msg(MSG_ERR, $lng->Get('Profile.AccountDisabled'));
				}
				else
				{
					if (!$pwdnok)
					{
						$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
					}
				}
				if ($pwdnok)
				{
					$ret = $dbintf->WrongPassword($username, 1, $MaxPwdFailures);			//1->increase the number of wrong passwords!
					$_SESSION['UserName'] = $username;
					if ($ret >= $MaxPwdFailures)
					{
						$msg[] = new Msg(MSG_ERR, $lng->Get('Profile.AccountDisabled'));
					}
					else
					{
						$msg[] = new Msg(MSG_ERR,GetErrDescr($dbintf->lasterr));
					}
				}
				if ($dbintf->lasterr == 'unknown user')
				{
					$_SESSION['UserName'] = '';
				}
			}
			else $dbintf->WrongPassword($username, 0, $MaxPwdFailures);		//0->reset number of wrong passwords!
		} else if ($logonmethod==2)
    {
      // SAML / Azure
      $msg[] = new Msg(MSG_ERR,'Local logon is disabled for this account. Log on using external identity provider instead.');
    }
	}
	if (!$login_ok)
	{
		sleep(1);
	}
	if ($login_ok && $freeseat)
	{
		if ($pcname=='')
		{
			// no PC name specified, update ApresaClient
			return false;
		}
		$pcname = strtoupper($pcname);
		// store in DB (to apply filtering)
		$dbintf->pcname = $pcname;
		//lg('PC name: '.$dbintf->pcname);
	}
	return $login_ok;
}

// improved check if file exists
function FileExists($fn)
{
  clearstatcache();
  if (file_exists($fn)) return true;
  // sometimes file_exists returns false for SMB shares,
  // although the file is actually there
  // then the check with fopen works
  $h = @fopen($fn,"r");
  if ($h===false) return false;
  fclose($h);
  return true;
}

// networkInterface : can be eth0 , np0s25
function GetMacAddr($networkInterface)
{
  return trim( file_get_contents( "/sys/class/net/$networkInterface/address" ) );
}

// returns network interface
// 0. primary
// 1. secondary
// 2... any further
function GetNetwInterfaces()
{
  if (COM_TYPE=='Win') return array();
  
  $primary = '';
  $secondary = '';
  
  $fn = "/var/apresa/conf/ethchoices";
  if (file_exists($fn))
  {
    $lines = file($fn,FILE_IGNORE_NEW_LINES);
    if (count($lines)>=1) $primary   = $lines[0];
    if (count($lines)>=2) $secondary = $lines[1];
  }
  
  // For the situation when above config file does not exist
  $sysNets = array();
  exec("ls /sys/class/net",$sysNets);
  foreach ($sysNets as $sysNet)
  {
    $sysNet = trim($sysNet);
    if ($sysNet=='lo') continue;
    if ($sysNet=='') continue;
    if ($sysNet==$primary || $sysNet==$secondary)
    {
      ; // do nothing
    } else if ($primary=='')
    {
      $primary = $sysNet;
    } else if ($secondary=='')
    {
      $secondary = $sysNet;
    }
  }

  $result = array();
  if (strpos($primary,'/')!==false) return $result;
  if (strpos($secondary,'/')!==false) return $result;
  if ($primary=='') return $result;
  $result[0] = $primary;
  if ($secondary!='') $result[1] = $secondary;

  foreach ($sysNets as $sysNet)
  {
    $sysNet = trim($sysNet);
    if ($sysNet=='lo') continue;
    if ($sysNet=='') continue;
    if ($sysNet==$primary || $sysNet==$secondary)
    {
      ; // do nothing
    } else
    {
      $result[] = $sysNet;
    }
  }
  
  return $result;
}
  
function DeleteFn($fn)
{
  if (file_exists('/var/apresa/conf/opt_secure_delete'))
  {
    if (FileExists($fn))
    {
      $cmd = 'shred -u ' . escapeshellarg($fn);
      if (startsWith($fn,'/recordings')
        || startsWith($fn,'/mnt/backup'))
      {
        // although verbose, it might be important as evidence
        lg('shredding '.$fn);
      }
      exec($cmd);
      // check if gone
      if (FileExists($fn))
      {
        lg('failed to shred, try through handler');
        // this could happen when we dont have write access
        // use handler
        $no_msg = null;
        msg_signal_service($no_msg,'shred '.$fn);
      }
      // check if gone
      // if secure delete doesnt work this is a serious error
      if (FileExists($fn))
      {
        lg('shred failed');
        throw new Exception("Delete failed (shred)");
      }
      return true;
    } else
    {
      return @unlink( $fn );
    }
  } else
  {
    // next line is workaround for file access problem on SMB drives
    FileExists($fn);
    return @unlink( $fn );
  }
  return true;
}

function IsEnoughSpaceAvail($path, $requiredSpaceLeft)
{
	$spaceFree = disk_free_space($path);
	// if function fails, assume we have enough space
	if ($spaceFree === false) return true;
	// if we have the required space available
	return $spaceFree >= $requiredSpaceLeft;
}

function IsEnoughSpaceAvailOnDevShm( $sizeAdding )
{
	$OneMeg = (1024*1024);
	return IsEnoughSpaceAvail("/dev/shm", $OneMeg * 64 + $sizeAdding);
}

function FormatPublicKey($key)
{
  $parts = explode("\n", $key);
  if(sizeof($parts) != 3) return $key;

  $tot = [];
  $tot[] = $parts[0];
  $tot = array_merge($tot, str_split($parts[1], 64));
  $tot[] = $parts[2];
  return implode("\n", $tot);
}

// major version number
function GetDebianVersion()
{
  $issuenet = @file_get_contents('/etc/issue.net');
  if (strpos($issuenet,'Debian')===false) return 0;
  $parts = explode(' ',$issuenet);
  if (count($parts)==0) return $parts[0];
  $lastword = array_pop( $parts );
  return (int) $lastword;
}

class CsvRow implements ArrayAccess, Countable
{
	var $data = array();
  
  function add($t)
	{
		$this->data[] = $t;
	}
  
  function quote($t)
	{
		if ($t=='') return $t;
		// duplicate " inside quotes
		$t = str_replace('"','""',$t);
		return '"'.$t.'"';
	}
  
  function get()
	{
		$first = true;
		$t = '';
		foreach($this->data as $elem)
		{
			if ($first) $first = false;
			else $t .= ',';
			$t .= $this->quote($elem);
		}
		$t .= "\r\n";
		return $t;
	}
  
  function flush()
	{
		$this->data = array();
  }
  
	function output()
	{
		echo $this->get();
		$this->flush();
  }
  
  function parse($t)
  {
    $len = strlen($t);
    $part = '';
    $inside = false;
    for($i=0;$i<$len;$i++)
    {
      $ch = $t[$i];
      if ($inside)
      {
        if ($ch=='"')
        {
          if ($i+1<$len && $t[$i+1]=='"')
          {
            $part .= '"';
            $i ++;
            continue;
          }
          $inside = false;
          continue;
        }
      } else
      {
        if ($ch==',')
        {
          $this->data[] = $part;
          $part = '';
          continue;
        }
        if ($ch=='"')
        {
          if ($part=='')
          {
            $inside = true;
            continue;
          }
        }
      }
      $part .= $ch;
      if ($inside==false)
      {
        $part = ltrim($part);
      }
    }
    $this->data[] = $part;
  }

  #[\ReturnTypeWillChange]
  function offsetExists($col)
  {
    return isset($this->data[$col]);
  }

  #[\ReturnTypeWillChange]
  function offsetGet($col)
  {
    return isset($this->data[$col]) ? $this->data[$col] : null;
  }

  #[\ReturnTypeWillChange]
  function offsetSet($col, $value)
  {
    if($col < count($this->data))
    {
      $this->data[$col] = $value;
    }
    else
    {
      $this->data[] = $value;
    }
  }

  #[\ReturnTypeWillChange]
  function offsetUnset($col)
  {
    unset($this->data[$col]);
  }

  #[\ReturnTypeWillChange]
  function count()
  {
    return count($this->data);
  }
}

class CsvFile implements Iterator
{
  var $rows = [];
  var $itIx = 0;
  var $csvText;

  function CreateRow()
  {
    return new CsvRow();
  }

  function Init($filename)
  {
    header('Content-type: text/csv');
    header('Content-Disposition: attachment; filename="' . $filename . ".csv" . '"');

    // UTF-8 BOM
	  echo "\xEF\xBB\xBF";
  }

  function Read($filename)
  {
    $csv = file_get_contents($filename);
    $this->ReadFromString($csv);
  }

  function ReadFromString($csv)
  {
    $this->csvText = $csv;
    $lines = explode("\r\n", $this->csvText);

    foreach($lines as $line)
    {
      $csvRow = new CsvRow();
      $csvRow->parse($line);
      $this->rows[] = $csvRow;
    }
  }

  function Finish()
  {

  }

  #[\ReturnTypeWillChange]
  function rewind()
  {
    $this->itIx = 0;
  }

  #[\ReturnTypeWillChange]
  function current()
  {
    return $this->rows[$this->itIx];
  }

  #[\ReturnTypeWillChange]
  function key()
  {
    return $this->itIx;
  }

  #[\ReturnTypeWillChange]
  function valid()
  {
    return $this->itIx < count($this->rows);
  }

  #[\ReturnTypeWillChange]
  function next()
  {
    $this->itIx++;
  }

  function asCSV()
  {
    return $this->csvText;
  }
}

class XLSXRow implements ArrayAccess, Countable
{
  var $data = array();
  var $sheet = null;
  var $row = 0;

  function __construct($sheet, $row)
  {
    $this->sheet = $sheet;
    $this->row = $row;
  }

	function add($t)
	{
		$this->data[] = $t;
  }

  function output()
	{
    $colctr = 1;
    foreach($this->data as $column)
    {
      $this->sheet->setCellValueByColumnAndRow($colctr, $this->row, $column);
      $colctr++;
    }
  }

  #[\ReturnTypeWillChange]
  function offsetExists($col)
  {
    return $this->sheet->cellExistsByColumnAndRow($col+1, $this->row);
  }

  #[\ReturnTypeWillChange]
  function offsetGet($col) 
  {
    if($this->sheet->cellExistsByColumnAndRow($col+1, $this->row))
    { 
      $val = $this->sheet->getCellByColumnAndRow($col+1, $this->row)->getValue();
      return $val ? $val : '';
    }
    return null;
  }

  #[\ReturnTypeWillChange]
  function offsetSet($col, $value)
  {
    $this->sheet->setCellValueByColumnAndRow($col+1, $this->row, $value);
  }

  #[\ReturnTypeWillChange]
  function offsetUnset($col)
  {
    $this->sheet->setCellValueByColumnAndRow($col+1, $this->row, null);
  }

  #[\ReturnTypeWillChange]
  function count()
  {
    $cnt = 0;
    $rowIt = $this->sheet->getRowIterator();
    $rowIt->seek($this->row);
    $row = $rowIt->current();

    foreach($row->getCellIterator() as $cell)
    {
      if($cell->getValue() !== null && trim($cell->getValue()) !== '')
      {
        $cnt++;
      }
    }

    return $cnt;
  }
}

class XLSXFile implements Iterator
{
  var $spreadsheet = null;
  var $row = 1;
  var $filename;

  function Init($filename)
  {
    if(!extension_loaded("xml"))
    {
      global $msg, $rooturl;
      $msg[] = new Msg(MSG_ERR, "php-xml package is not installed");
      $_SESSION['msg'] = $msg;
      header('Location: ' . $rooturl);
      exit;
    }

    require_once '../apresa/vendor/autoload.php';

    $this->filename = $filename;
    $this->spreadsheet = new PhpOffice\PhpSpreadsheet\Spreadsheet();
  }

  function Read($filename)
  {
    require_once '../apresa/vendor/autoload.php';
    $reader = new \PhpOffice\PhpSpreadsheet\Reader\Xlsx();
    $this->spreadsheet = $reader->load($filename);

    if($this->spreadsheet->getSheetCount() == 0)
    {
      $this->spreadsheet->createSheet(0);
      $this->spreadsheet->setActiveSheetIndex(0);
    }
  }

  function CreateRow()
  {
    return new XLSXRow($this->spreadsheet->getActiveSheet(), $this->row++);
  }

  function Finish()
  {
    require_once '../apresa/vendor/autoload.php';

    foreach($this->spreadsheet->getActiveSheet()->getColumnIterator() as $column)
    {
      $this->spreadsheet->getActiveSheet()->getColumnDimension($column->getColumnIndex())->setAutoSize(true);
    }

    $this->spreadsheet->getActiveSheet()->calculateColumnWidths();

    header('Content-type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
    header('Content-Disposition: attachment; filename="' . $this->filename . ".xlsx" . '"');

    $writer = new PhpOffice\PhpSpreadsheet\Writer\Xlsx($this->spreadsheet);
    $writer->save('php://output');
  }

  #[\ReturnTypeWillChange]
  function rewind()
  {
    $this->row = 1;
  }

  #[\ReturnTypeWillChange]
  function current()
  {
    return new XLSXRow($this->spreadsheet->getActiveSheet(), $this->row);
  }

  #[\ReturnTypeWillChange]
  function key()
  {
    return $this->row;
  }

  #[\ReturnTypeWillChange]
  function valid()
  {
    return $this->row <= (int) $this->spreadsheet->getActiveSheet()->getHighestRow();
  }

  #[\ReturnTypeWillChange]
  function next()
  {
    $this->row++;
  }

  function asCSV()
  {
    $writer = new \PhpOffice\PhpSpreadsheet\Writer\Csv($this->spreadsheet);
    $stream = fopen('php://memory','r+');
    $writer->save($stream);
    rewind($stream);
    $csv = stream_get_contents($stream);
    return $csv;
  }
}

?>