<?php

require_once('general.php');
require_once 'utility.php';
require_once 'callhandler.php';

HandleMain($dbintf);

function HandleMain($dbintf)
{
  global $rpl,$configs,$msg;

	$id = (int) $_GET['id'];
	
	LogAction("View a screen recording",array("level"=>"view","call_id"=>$id));
  
  $callinfo = $dbintf->GetCallInfo($id);
  if ($callinfo === false)
  {
    echo 'Could not get call info';
    exit;
  }
  
  $isZip = false;
  $parts = pathinfo($callinfo['screenfn']);
  if ($parts['extension']=='zip') $isZip = true;
  
  if ($isZip)
  {
    $handler = new CallHandler();
    $handler->errorEcho = false;
    $handler->ids = array( $id );
    $handler->download = false;
    $handler->screenrec = true;
    $handler->embed = true;
    $handler->countMonitors = true;
    $handler->Perform();
    if ($handler->good==false)
    {
      echo 'Error: ' . $handler->errmsg;
      exit;
    }
    $videoFileExtension = $handler->videoFileExtension;
  } else
  {
    $videoFileExtension = $parts['extension'];
  }
  
  $template_content = file_get_contents('../apresa/templ/viewscr.htm');

  $data = '';
	$data .= 'var dbid = "' . JSQuote($id) . '";' . "\r\n";
	$data .= 'var screenfn = "' . JSQuote($callinfo['screenfn']) . '";' . "\r\n";
  $data .= 'var isZip = ' . (int) $isZip . ';' . "\r\n";
  if ($isZip)
  {
    $data .= 'var monitorCount = ' . (int) $handler->monitorCount . ';' . "\r\n";
  } else
  {
    $data .= 'var monitorCount = 1;' . "\r\n";
  }
  $data .= 'var videoFileExtension = "' . JSQuote($videoFileExtension) . '"' . "\r\n";
  $data .= GeneralJSData();
	
  // template replacements:
  $rpl['data'] = $data;
  $rpl['genlist_css'] = file_get_contents('../apresa/templ/genlist.css');
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>