<?php

require_once('general.php');

HandlePage($dbintf);

function CheckPort($val, $def)
{
  $val = int_ensure_defined($val);

  if($val < 1 || $val > 65535)
  {
    return $def;
  }

  return $val;
}

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

  $maxRules = 15;
  $keys = array( 'VoipServer'
		, 'TelsysLateOffer', 'TelsysNoDups'
	 , 'TelsysReg', 'TelsysNatAddr'
	 , 'TelsysCodecAlaw', 'TelsysCodecUlaw'
   , 'TelsysCodecOpus', 'TelsysCodecG722', 'TelsysCodecG729'
   , 'TelsysCodeciLBC', 'TelsysCodecAMR', 'TelsysCodecAMRWB'
   , 'TelsysProtUDP', 'TelsysPortUDP'
   , 'TelsysProtTCP', 'TelsysPortTCP'
   , 'TelsysProtTLS', 'TelsysPortTLS', 'TelsysRecMethodTLS', 'TelsysServerCert', 'TelsysClientCert'
   , 'TelsysCheckCertTLS', 'TelsysRequireClientCert'
   , 'TelsysMinRtpPort', 'TelsysMaxRtpPort', 'TelsysSRTP', 'TelsysSAVP', 'TelsysSAVPRequire', 'TelsysMaxDur', 'TelsysMaxSimCalls'
   , 'TelsysRtpInactivity', 'TelsysRtpTimeout'
   , 'TelsysMaintenance'
	);
  $sipRegKeys = array('Usr','Pwd');
  $sipLineKeys = array( 'Ip', 'Reg','Usr','Pwd','Domain','Local','Interval','LIp','LPort', 'Prot' );
  $ruleKeys = array( 'Cnd', 'NumSrc', 'NumDst', 'Act', 'TT', 'ForwDst', 'ForwProt', 'MenuTimeout'
		, 'DetermDst', 'InLoop', 'DstPrefix', 'DstAPrefix', 'DstNum', 'SrcConv','UseUsername', 'NotifDst'
    , 'SetPAsserted'
    );
	$sipRecKeys = array('SipRec', 'SipRecDetermineDirection', 'SipRecUsr', 'SipRecReg', 'SipRecIP', 'SipRecPwd', 'SipRecDomain', 'SipRecLocal', 'SipRecInterval');
  for ($i=0;$i<13;$i++)
  {
    $ruleKeys[] = 'Dial' . $i;
  }
  foreach ($keys as $key)
  {
    $allkeys[] = $key;
  }
  for ($i=1;$i<=2;$i++)
  {
    foreach ($sipLineKeys as $key)
    {
      $fullkey = 'TelsysSip' . $i . $key;
      $allkeys[] = $fullkey;
    }
  }
  for ($i=1;$i<=2;$i++)
  {
    foreach ($sipRegKeys as $key)
    {
      $fullkey = 'TelsysReg' . $i . $key;
      $allkeys[] = $fullkey;
    }
  }
  for ($i=1;$i<=$maxRules;$i++)
  {
    foreach ($ruleKeys as $key)
    {
      $fullkey = 'TelsysR' . $i . $key;
      $allkeys[] = $fullkey;
    }
  }
	$allkeys = array_merge($allkeys, $sipRecKeys);
	
	if (isset($_SESSION['LicState']) && $_SESSION['LicState']==0)
	{
    $newConfigs = array();
		$newConfigs['VoipServer'] = '0';
    $dbintf->SetConfigsPart($newConfigs,'t');
    msg_signal_service($msg,'telsys apply');
    msg_signal_service($msg,'telsys restart');
		
		$msg[] = new Msg(MSG_INF,'The VoIP Service is only accessable, '
			. 'when it has a system license.');
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl);
	}

  $act = $_POST['act'];
  if ($act!='')
  {
    //var_dump($_POST);
    if ($act=='restart')
		{
			LogAction('Restart telephony service');

      msg_signal_service($msg,'telsys restart');
      
      // redirect
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'voippbx.php');
      exit;
		}

    if($act=='maintenance') 
    {
      LogAction('VoIP Service maintenance mode: ' . (($_POST['TelsysMaintenance']) == "1" ? 'Enabled' : 'Disabled'));

      $dbintf->SetConfigsPart([
        "TelsysMaintenance" => $_POST["TelsysMaintenance"] ?? "0"
      ], 't');

      msg_signal_service($msg,'telsys reload');

      // redirect
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'voippbx.php');
      exit;
    }
	
    if ($act=='save')
    {
			LogAction('Change telephony settings');
      
      $newConfigs = array();
      foreach ($allkeys as $key)
      {
        if (isset($_POST[$key]))
        {
          //echo $key . ' := ' . $_POST[$key] . "\r\n";
          if (stristr($key,'pwd')===false)
          {
            $newConfigs[ $key ] = $_POST[$key];
          } else
          {
            $newConfigs[ $key ] = encrypt($_POST[$key]);
          }
        }
      }

      // Fix potentially erroneous settings
      if(int_ensure_defined($newConfigs['TelsysProtUDP']) == 0 && int_ensure_defined($newConfigs['TelsysProtTCP']) == 0 && int_ensure_defined($newConfigs['TelsysProtTLS']) == 0)
      {
        $newConfigs['TelsysProtUDP'] = 1;
      }

      $newConfigs['TelsysPortUDP'] = CheckPort($newConfigs['TelsysPortUDP'], 5060);
      $newConfigs['TelsysPortTCP'] = CheckPort($newConfigs['TelsysPortTCP'], 5060);
      $newConfigs['TelsysPortTLS'] = CheckPort($newConfigs['TelsysPortTLS'], 5061);
      $newConfigs['TelsysMinRtpPort'] = CheckPort($newConfigs['TelsysMinRtpPort'], 16384);
      $newConfigs['TelsysMinRtpPort'] = CheckPort($newConfigs['TelsysMinRtpPort'], 32768);

      if(isset($newConfigs["TelsysMaxSimCalls"]))
      {
        $newConfigs["TelsysMaxSimCalls"] = intval($newConfigs["TelsysMaxSimCalls"]);
        if($newConfigs["TelsysMaxSimCalls"] == 0)
        {
          $newConfigs["TelsysMaxSimCalls"] = "";
        }
      }

      if($newConfigs["TelsysMaxDur"])
      {
        $newConfigs["TelsysMaxDur"] = intval($newConfigs["TelsysMaxDur"]);
        if($newConfigs["TelsysMaxDur"] == 0)
        {
          $newConfigs["TelsysMaxDur"] = "";
        }
      }

      if($newConfigs["TelsysRtpTimeout"])
      {
        $newConfigs["TelsysRtpTimeout"] = intval($newConfigs["TelsysRtpTimeout"]);
        if($newConfigs["TelsysRtpTimeout"] == 0)
        {
          $newConfigs["TelsysMaxDur"] = "10";
        }
      }
      

      // If settings were manually modified, do not set new ones still at default
      if($dbintf->GetConfigValue("TelsysNatAddr") === false && $newConfigs['TelsysNatAddr'] === "")
      {
        unset($newConfigs['TelsysNatAddr']);
      }

      if($dbintf->GetConfigValue("TelsysMinRtpPort") === false && $newConfigs['TelsysMinRtpPort'] === "16384")
      {
        unset($newConfigs['TelsysMinRtpPort']);
      }

      if($dbintf->GetConfigValue('TelsysMaxRtpPort') === false && $newConfigs['TelsysMaxRtpPort'] === "32768")
      {
        unset($newConfigs['TelsysMaxRtpPort']);
      }
			
			if(isset($_POST['TelsysServerCert']))
			{
				$certid = (int) $_POST['TelsysServerCert'];
				if($certid === -1)
				{
					$dbintf->DeleteCertificateUse('Telsys');
				}
				else
				{
					$dbintf->SetCertificateUse('Telsys', $certid);
				}
      }
      
      if(isset($_POST['TelsysClientCert']))
      {
        $certid = (int) $_POST['TelsysClientCert'];
        if($certid === -1)
        {
          $dbintf->DeleteCertificateUse('TelsysClient');
        }
        else
        {
          $dbintf->SetCertificateUse('TelsysClient', $certid);
        }
      }
			
      $dbintf->SetConfigsPart($newConfigs,'t');			
      $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));
      msg_signal_service($msg,'telsys apply');
			EnginesReconfig($msg,$dbintf);
      
      // redirect
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'voippbx.php');
      exit;
    }
  }
  
	if (!defined('DEMO') && COM_TYPE!='Win')
	{
		if (file_exists('/usr/bin/yate')==false)
		{
      if (file_exists('/usr/sbin/asterisk'))
      {
        $_SESSION['msg'] = $msg;
        header('Location: '.$rooturl.'voippbx2.php');
        exit;
      }
			$msg[] = new Msg(MSG_ERR,$lng->Get('This module is not installed'));
		}
	}
	
  $data = '';

	msg_signal_service($msg,'telsys status');	
	$lastCalls = array();
	if (!defined('DEMO') && COM_TYPE!='Win')
	{
		$lastCalls = file(DATA_PATH . '/telsysLast.dat');
	}
	$data .= "var lastCalls = \r\n[ ";
	$first = true;
	foreach ($lastCalls as $telsysCall)
	{
		$parts = explode("\t",$telsysCall);
		if (count($parts)<3) continue;
		if ($parts[0]!='[APRESA]') continue;
		array_shift($parts);
		if (!$first) $data .= ', ';
		else $first = false;
		$data .= "{";
		$first2 = true;
		foreach ($parts as $part)
		{
			$kv = explode(':',$part);
			if (count($kv)!=2) continue;
			$key = $kv[0];
			$value = trim($kv[1]);
			if ($key=='Ti')
			{
				$value = date($configs['datetimef'],$value);
			}
			//echo $key;
			if (!$first2) $data .= ', ';
			else $first2 = false;
			$data .= "\"$key\": \"$value\"";
		}
		$data .= "}" . "\r\n";
	}
	$data .= "]" . "\r\n";
	//echo '<PRE>'.$data;
  //exit;
  
  $configs_t = $dbintf->LoadConfigsPart('t');
  $configs_t["TelsysProtUDP"] = int_ensure_defined($configs_t["TelsysProtUDP"]);
  $configs_t["TelsysProtTCP"] = int_ensure_defined($configs_t["TelsysProtTCP"]);
  $configs_t["TelsysProtTLS"] = int_ensure_defined($configs_t["TelsysProtTLS"]);

  if($configs_t["TelsysProtUDP"] == 0 && $configs_t["TelsysProtTCP"] == 0 && $configs_t["TelsysProtTLS"] == 0)
  {
    $configs_t["TelsysProtUDP"] = 1;
  }

  if($configs_t["TelsysProtTLS"])
  {
    $defaultRegProt = 'tls';
  }
  else if($configs_t["TelsysProtUDP"])
  {
    $defaultRegProt = 'udp';
  }
  else 
  {
    $defaultRegProt = 'tcp';
  }

  $configs_t['TelsysSip1Prot'] = isset($configs_t['TelsysSip1Prot']) ? $configs_t['TelsysSip1Prot'] : $defaultRegProt;
  $configs_t['TelsysSip2Prot'] = isset($configs_t['TelsysSip2Prot']) ? $configs_t['TelsysSip2Prot'] : $defaultRegProt;
  $configs_t['TelsysRtpTimeout'] = isset($configs_t['TelsysRtpTimeout']) ? $configs_t['TelsysRtpTimeout'] : 10;

  $writeConfigs = array();

  foreach ($allkeys as $key)
  {
		if(stripos($key, "UseUsername")>0 && !isset($configs_t[$key]))
		{
			$writeConfigs[$key] = "1";	//Use username for caller is default enabled!
		}
		else if( ($key == 'TelsysCodecAlaw' || $key == 'TelsysCodecUlaw') && !isset($configs_t[$key]) )
		{
			$writeConfigs[$key] = "1";
    }
		else $writeConfigs[$key] = str_ensure_defined( $configs_t[$key] );
  }

	$certid = $dbintf->GetCertificateFor('Telsys');
  $writeConfigs['TelsysServerCert'] = $certid ? $certid : -1;
  
  $clientCertId = $dbintf->GetCertificateFor('TelsysClient');
  $writeConfigs['TelsysClientCert'] = $clientCertId ? $clientCertId : -1;
  
  $data .= "var configs = [];\r\n";
  foreach($writeConfigs as $key=>$value)
  {
    if (stristr($key,'pwd')===false)
    {
      // not a password
      $data .= 'configs["' . JsQuote($key) . '"] = "' . JsQuote($value) . '";' . "\r\n";
    } else
    {
      $pwd = decrypt(str_ensure_defined($value));
      // debug: print password dont do it: echo $key . '=' . $pwd . "\r\n";
      $data .= "configs[\"Has_".$key."\"] = ".(int)(strlen($pwd)>0).";\r\n";
    }
  }
	
	$certificates = $dbintf->GetCertificatesWithPrivateKey();
	
	$certdata = "var certificates = [\r\n";
	$certdata .= "{ id: -1, name: " . '"' . $lng->Get('Main.None') . '"' . "},";
	
	$certmap = "var map_TelsysServerCert = {\r\n";
	$certmap .= "0:-1,";
	
	$ix = 1;
	foreach($certificates as $cert)
	{
		$certdata .= "\r\n{ id: " . $cert['id']  . ", name: " . '"' . JSQuote($cert['name']) . " (" .  JSQuote($cert['subject']) . ")"  . '"' . "},";
		$certmap .= "\r\n" . $ix . ":" . $cert['id'] . ",";
		$ix++;
  }
  
	$certdata .= "\r\n]\r\n";
  $certmap .= "\r\n}\r\n";
  $certmap .= "var map_TelsysClientCert = map_TelsysServerCert;\r\n";
	
	$data .= $certdata;
	$data .= $certmap;
  
	LogAction("View VoIP Service (telephony)",array("level"=>"view"));
  
  // ready with database
  $dbintf->close();

  $data .= 'var maxRules = ' . $maxRules . ";\r\n";

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/voippbx.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();

  $inMaintenance = $configs_t['TelsysMaintenance'] == "1";
  if($inMaintenance) {
    $rpl["MAINTENANCEACT"] = $lng->Get('PBX.disableMaintenanceMode');
    $rpl["MAINTENANCEDESCR"] = $lng->Get('PBX.maintenanceModeDescr');
  }
  else {
    $rpl["MAINTENANCEACT"] = $lng->Get('PBX.enableMaintenanceMode');
    $rpl["MAINTENANCEDESCR"] = '';
  }

  $template_content = do_replace_tags($template_content);
  echo $template_content;  
}
