<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }

	if (isset($_SESSION['LicState']) && $_SESSION['LicState']==0)
	{
    $newConfigs = array();
		$newConfigs['VoipServer'] = '0';
    $dbintf->SetConfigsPart($newConfigs,'t');
    msg_signal_service($msg,'telsys apply');
    msg_signal_service($msg,'telsys restart');
		
		$msg[] = new Msg(MSG_INF,'The VoIP Service is only accessable, '
			. 'when it has a system license.');
    $_SESSION['msg'] = $msg;
    header('Location: '.$rooturl);
	}
  
  $prefix = 'Aste_';
  $cfgPart = 'aste';
  $keys = array();
  $keys[] = 'PublicIp';
  $keys[] = 'StunIp';
  $outCount = 1;
  for ($ix=1; $ix <= $outCount; $ix++)
  {
    $pre = 'OutReg' . $ix . '_';
    $keys[] = $pre . 'Server';
    $keys[] = $pre . 'Id';
    $keys[] = $pre . 'Pwd';
  }
  $inCount = 1;
  for ($ix=1; $ix <= $inCount; $ix++)
  {
    $pre = 'InReg' . $ix . '_';
    $keys[] = $pre . 'Id';
    $keys[] = $pre . 'Pwd';
  }
  $keys[] = 'MainAct';

  $act = $_POST['act'];
  if ($act!='')
  {
    if ($act=='restart')
    {
			LogAction('Restart VoIP service 2 (telephony)');

      msg_signal_service($msg,'aste restart');
      
      // redirect
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'voippbx2.php');
      exit;
    }
    
    if ($act=='save')
    {
      LogAction('Change settings for VoIP service 2 (telephony)');
      
      $newConfigs = array();
      foreach ($keys as $key)
      {
        $cfgKey = $prefix . $key;
        if (isset($_POST[$key]))
        {
          // debug echo $key . ' := ' . $_POST[$key] . "\n";
          if (stristr($key,'_pwd')===false)
          {
            $newConfigs[ $cfgKey ] = $_POST[$key];
          } else
          {
            $newConfigs[ $cfgKey ] = encrypt($_POST[$key]);
          }
        }
      }
      $dbintf->SetConfigsPart($newConfigs,$cfgPart);			

      $msg[] = new Msg(MSG_INF,$lng->Get('Options.ConfigSaved'));
      msg_signal_service($msg,'aste apply');
      
      // redirect
      $_SESSION['msg'] = $msg;
      header('Location: '.$rooturl.'voippbx2.php');
      exit;
    }
    
  }
  
  $data = '';
	if (!defined('DEMO') && COM_TYPE!='Win')
	{
		if (file_exists('/usr/sbin/asterisk')==false)
		{
			$msg[] = new Msg(MSG_ERR,$lng->Get('This module is not installed'));
      // not installed
      // maybe redirect to install page
      // or load install template htm
		}
	}
  
  $configs_aste = $dbintf->LoadConfigsPart($cfgPart);
  
  $defaultCfgs = array
  ( 'MainAct' => 'reject'
  );
  foreach ($defaultCfgs as $key=>$value)
  {
    $cfgKey = $prefix . $key;
    if (isset($configs_aste[$cfgKey])==false)
    {
      $configs_aste[$cfgKey] = $value;
    }
  }
  
  $arr = array();
  foreach ($keys as $key)
  {
    $value = '';
    $cfgKey = $prefix . $key;
    if (isset($configs_aste[$cfgKey])) $value = $configs_aste[$cfgKey];
    if (stristr($key,'_pwd'))
    {
      $key = 'Has_' . $key;
      $pwd = decrypt(str_ensure_defined($value));
      $value = (int)(strlen($pwd)>0);
    }
    $arr[ $key ] = $value;
  }

  // debug output what we have got for configuration
  foreach ($keys as $key)
  {
    $value = '';
    $cfgKey = $prefix . $key;
    if (isset($configs_aste[$cfgKey])) $value = $configs_aste[$cfgKey];
    if (stristr($key,'_pwd'))
    {
      $value = $value . ' =... ' . decrypt(str_ensure_defined($value));
    }
    // debug: echo "<br>$key = $value";
  }
  
  
  $data .= 'var configs = ' . json_encode($arr) . ';';
	
	LogAction("View VoIP Service 2 (telephony)",array("level"=>"view"));
  
  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/voippbx2.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;  
}
