<?php

function LogInUidUsr($uid,$username)
{
          global $rooturl, $dbintf, $msg, $lng;
          
	        lg('Login username ' . $username . ' from '.$_SERVER['REMOTE_ADDR']);
          
          // get more info about user
          $cologons = 0;
          $cologonGroup = null;
          $uinfo = $dbintf->GetUserInfo( $uid );
          $groups = $dbintf->GetGroupsOfWhichMember( $uinfo['accid'] );
          foreach ($groups as $groupAccid)
          {
            $ginfo = $dbintf->GetGroupInfoOnAccid( $groupAccid );
            if ($ginfo['cologons']>0)
            {
              $cologons = $ginfo['cologons'];
              $cologonGroup = $ginfo;
            }
          }
          
          if ($cologons>0 || int_ensure_defined( $_SESSION['LogonsDone'] )!=0 )
          {
            $getaccess = false;
            $failure = false;
            // do we have already other logged on users?
            $LogonsDone = int_ensure_defined( $_SESSION['LogonsDone'] );
            for ($i=1;$i<=$LogonsDone;$i++)
            {
              if ( $uid == $_SESSION['user' . $i] )
              {
                $msg[] = new Msg(MSG_ERR,str_replace('{0}',$username,$lng->Get('Cologon.UserLoggedIn')));
                $failure = true;
              }
            }
            if ($failure==false && $LogonsDone>0)
            {
              // check if part of same group
              if ($_SESSION['CologonGroup'] != $cologonGroup['accid'])
              {
                $msg[] = new Msg(MSG_ERR,str_replace('{0}',$username,$lng->Get('Cologon.UserOtherGroup')));
                $failure = true;
              }
            }
            if ($failure==false)
            {
              $LogonsDone ++;
              $_SESSION['user' . $LogonsDone] = $uid;
              $_SESSION['user' . $LogonsDone . '_usr' ] = $username;
              $_SESSION['LogonsDone'] = $LogonsDone;
              $_SESSION['CologonGroup'] = $cologonGroup['accid'];
              $_SESSION['LogonsNeeded'] = $cologons + 1;
              if ($LogonsDone == $cologons + 1)
              {
                $_SESSION['Cologon'] = 1;
                $usernames = '';
                for ($i=1;$i<=$LogonsDone;$i++)
                {
                  if ($i!=1) $usernames .= ' + ';
                  $usernames .= $_SESSION['user' . $i . '_usr'];
                }
                $_SESSION['CologonUsers'] = $usernames;
                $getaccess = true;
                // logon with the permissions of the first user that logged in
                $uid = $_SESSION['user1'];
                $username = $_SESSION['user1_usr'];
              }
            }
            
            if ($getaccess==false)
            {
              // redirect for second logon
              $_SESSION['msg'] = $msg;
              header('Location: '.$rooturl);
              exit;
            }
          }
          
					session_regenerate_id();
	        $_SESSION['uid'] = $uid;
	        $_SESSION['first_access'] = time();
	        $_SESSION['last_access'] = time();
          unset($_SESSION['token']);
	        // add to DB
	        $data = array();
	        $data['sessionid'] = session_id();
	        $data['userid'] = $uid;
	        $data['firstacc'] = $_SESSION['first_access'];
	        $data['lastacc' ] = $_SESSION['last_access' ];
					if ($dbintf->readonly==false)
					{
						$dbintf->InsertSession($data);
						
						if (str_ensure_defined($configs['LastUserLogin'])!=$username)
						{
							$dbintf->SetUserLastNewLogin( $uid , time() );
							$dbintf->SetConfigsPart(array('LastUserLogin'=>$username),'web');
						}
					}

					$dbintf->SetCurrentUserId($_SESSION['uid']);
					if ($dbintf->actuinfo['permissions']&PM_CONFIG)
					{
						UpdateSystemInfoCfg();
					}
					LogAction('Log in');

	        // redirect to remove username/password from browser history
					if ($dbintf->actuinfo['permissions']&PM_WEBCLIENT)
					{
						// If user has webclient permission, immediately redirect to webclient
            // as the landing page
						header('Location: '.$rooturl.'webclient.php');
					}
					else
					{
						header('Location: '.$rooturl);
					}
	        exit;
}

function CologonLoginPageMsg()
{
  global $msg, $lng;
  if (isset($_SESSION['LogonsDone']))
  {
    $txt = '';
    $LogonsDone = $_SESSION['LogonsDone'];
    for ($i=1;$i<=$LogonsDone;$i++)
    {
      $txt .= str_replace('{0}',$_SESSION['user' . $i . '_usr' ],$lng->Get('Cologon.UserLoggedIn')) . ' ';
    }
    $txt .= str_replace('{0}',$_SESSION['LogonsNeeded'],$lng->Get('Cologon.UserCologonCnt'));
    $msg[] = new Msg(MSG_INF,$txt);
  }
}

function end_of_session()
{
  session_unset();
  if (ini_get("session.use_cookies")) {
      $params = session_get_cookie_params();
      setcookie(session_name(), '', time() - 42000,
          $params["path"], $params["domain"],
          $params["secure"], $params["httponly"]
      );
  }
  @session_destroy();
}


function do_apply($a)
{
  global $rpl, $lng;
  if (isset($rpl[$a]))
  {
    return $rpl[$a];
  } else {
		if ($a[0]=='~')
		{
	    return JSQuote($lng->Get(substr($a,1)));
	  } else
		{
	    // look-up in language
	    return $lng->Get($a);
	  }
  }
}

function do_apply2($a)
{
  $t = do_apply($a);
  return $t;
}

function message($messages)
{
  $t = '';
  foreach ($messages as $message)
  {
    $cls = '';
    if ($message->type==0) $cls = 'msginfo';
    if ($message->type==1) $cls = 'msgerr';
    if ($message->type==2) $cls = 'msgerr';
    $t .= '<div class="'.$cls.'">'.$message->text.'</div>';
  }
  return $t;
}

function do_replace_tags($t)
{
  // search for <% followed by a block ()
  // (?U) means non greedy
  // \S means any character that is not whitespace
  // + one or more of it
  // ended by % >
  $t = preg_replace_callback('/<%((?U)\S+)%>/',function($m) {return do_apply($m[1]);},$t);
	// do a second time, because included file might contain language texts too
  $t = preg_replace_callback('/<%((?U)\S+)%>/',function($m) {return do_apply($m[1]);},$t);
  return $t;
}

function WebBasicInit()
{
  global $dbintf, $rooturl;
  BasicConstants();
  InitDB();
  LoadBasicSettings();
  // copied next line from general.php
  $rooturl = (isset($_SERVER['HTTPS'])?'https':'http').'://'.$_SERVER['HTTP_HOST'].rtrim(dirname($_SERVER['PHP_SELF']),'/\\').'/';
}

