<?php

require_once 'general.php';
require_once 'utility.php';
require_once 'webclient_settings.php';

HandleActive($dbintf);

function HandleActive($dbintf)
{
  global $rpl,$configs,$actuinfo,$msg,$lng,$uid;
	if(!(($actuinfo['permissions']&PM_WEBCLIENT) >0))
	{
		echo 'Permission Denied';
		return;
	}
	
	$calldata = 'var categoryList =' . "\r\n";
	$calldata .= '[	{label:"'.JSQuote($lng->Get('Main.None')).'",value:"0"}' . "\r\n";
	for ($i=1;$i<=10;$i++)
	{
		$lbl = str_ensure_defined($configs['CatLabel'.$i]);
		$calldata .= ', {label: "'.JSQuote($lbl).'",value:'.$i.'}';
	}
	
	$calldata .= '];' . "\r\n";
	
  $defcolors = GetDefaultCategoryColors();
  $catColors = array();
  for ($i=1;$i<=10;$i++)
  {
    if (!isset($configs['CatColor'.$i]))
    {
      $configs['CatColor' . $i] = $defcolors[$i-1];
    }
    $catColors[] = $configs['CatColor' . $i];
  }
  $calldata .= 'var catColors = ' . json_encode($catColors) . ";\r\n";  
	
	$calldata .= 'var StoreOnDemandDelay = ' . (int) $dbintf->GetConfigValue('StoreOnDemandDelay') . ";\r\n";
  
  $webclientsettings_dialog = WebClientSettingsUser($dbintf->actuinfo['accid']);
  
  
  $dbintf->close();
	
  $calldata .= GeneralJSData();

	$template_content = file_get_contents('../apresa/templ/webclient.htm');
	
  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['search'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $calldata;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
	$rpl['genlist_css'] = file_get_contents('../apresa/templ/genlist.css');
  $rpl['webclient_settings_dialog'] = $webclientsettings_dialog;
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}

function CallListIdsStr($calls,$phone_list)
{
	$arr = array();
	foreach ($calls as $call)
	{
		$callextra = StringToArray($call['callextra']);
		$t = $call['id'] . '(';
		$isremote = false;
		if (in_array($call['remotecontact'],$phone_list))
		{
			$isremote = true;
		}
		if ($isremote==false)
		{
			$t .= $call['remote'];
		} else
		{
			$t .= $call['local'];
		}
		$t .= ',' . (int)$callextra['silencing'];
		$t .= ')';
		$arr[] = $t;
	}
	return implode(',',$arr);
}

?>

