<?php

// Webclient settings
define('WC_NOTES', 1);
define('WC_NOTES2', 2);
define('WC_CATEGORIES', 4);
define('WC_SILENCE', 8);
define('WC_STARTSTOP', 16);
define('WC_DELETE', 32);
define('WC_STORE', 64);
define('WC_SHOWSETTINGS', 128);
define('WC_APPLY_SUBGROUP', 256);
define('WC_ALLOW_OVERRIDE_USER', 512);
define('WC_ALLOW_OVERRIDE_GROUP', 1024);

function WebClientPermissions()
{
  $pms = '';
  $pms .= "var WC_NOTES=" . WC_NOTES . ";\r\n";
  $pms .= "var WC_NOTES2=" . WC_NOTES2 . ";\r\n";
  $pms .= "var WC_CATEGORIES=" . WC_CATEGORIES . ";\r\n";
  $pms .= "var WC_SILENCE=" . WC_SILENCE . ";\r\n";
  $pms .= "var WC_STARTSTOP=" . WC_STARTSTOP . ";\r\n";
  $pms .= "var WC_DELETE=" . WC_DELETE . ";\r\n";
  $pms .= "var WC_STORE=" . WC_STORE . ";\r\n";
  $pms .= "var WC_SHOWSETTINGS=" . WC_SHOWSETTINGS . ";\r\n";
  $pms .= "var WC_APPLY_SUBGROUP=" . WC_APPLY_SUBGROUP . ";\r\n";
  $pms .= "var WC_ALLOW_OVERRIDE_USER=" . WC_ALLOW_OVERRIDE_USER . ";\r\n";
  $pms .= "var WC_ALLOW_OVERRIDE_GROUP=" . WC_ALLOW_OVERRIDE_GROUP . ";\r\n";

  return $pms;
}

function WebClientUpdateSettingsGroup($webclientsettings, $accid)
{
  global $dbintf;         
  if($webclientsettings === "null")
  {
    $dbintf->DeleteWebClientSettings($accid);
  }
  else
  {
    $dbintf->UpdateWebClientSettings($accid, $webclientsettings);
  }
}

function WebClientUpdateSettingsUser($webclientsettings, $accid)
{
  global $dbintf;
  if($webclientsettings === "null")
    $webclientsettings = null;
  $dbintf->SetWebClientSettingsUser($accid, $webclientsettings);
}

function WebClientSettingsGetOwnGroup($accid)
{
  if($accid == -1) return false;

  global $dbintf;
  return $dbintf->GetWebClientSettings($accid);
}

function WebClientSettingsGetSuperGroup($accid)
{
  if($accid == -1) return false;

  global $dbintf;
  $supergroups = $dbintf->GetSuperGroups(array($accid));

  $webclientsupersettings = false;

  foreach($supergroups as $supergroup)
  {
    $webclientThisSuper = $dbintf->GetWebClientSettings($supergroup);

    if($webclientThisSuper !== false && $webclientThisSuper & WC_APPLY_SUBGROUP)
    {
      $webclientsupersettings = $webclientThisSuper;
      break;
    }
  }

  return $webclientsupersettings;
}

function WebclientSettingsCombine($set1, $set2)
{
  if($set1 === false && $set2 === false) return false;
  return $set1 | $set2;
}

function WebClientSettingsGetMemberGroups($accid)
{
  global $dbintf;
  $settings = false;
  $groups = $dbintf->GetGroupsOfWhichMember($accid);

  foreach($groups as $group)
  {
    $group_settings = WebClientSettingsGetOwnGroup($group);
    $super_settings = WebClientSettingsGetSuperGroup($group);

    if((($super_settings & WC_ALLOW_OVERRIDE_GROUP) && $group_settings !== false) || $super_settings === false)
    {
      $use_settings = $group_settings;
    }
    else 
    {
      $use_settings = $super_settings;  
    }

    $settings = WebclientSettingsCombine($use_settings, $settings);
  }

  return $settings;
}

function WebClientSettingsGetUser($accid)
{  
  global $dbintf;
  return $dbintf->GetWebClientSettingsUser($accid);
}

function WebClientSettingsGroup($accid)
{
  global $rpl;
  $rpl['wc_settings_defines'] = WebClientPermissions();

  $webclient_settings = WebClientSettingsGetOwnGroup($accid);
  $webclient_super_settings = WebClientSettingsGetSuperGroup($accid);

  if($webclient_settings === false && $webclient_super_settings === false)
  {
    $webclient_settings = WC_NOTES | WC_NOTES2 | WC_CATEGORIES | WC_ALLOW_OVERRIDE_USER;
  }

  $rpl['wc_own_settings'] = $webclient_settings === false ? "null" : $webclient_settings;
  $rpl['wc_inherited_settings'] = $webclient_super_settings === false ? "null" : $webclient_super_settings;
  $rpl['wc_is_user_page'] = "false";
  $template_content = file_get_contents('../apresa/templ/webclient_settings.htm');
  $template_content = do_replace_tags($template_content);

  return $template_content;
}

function WebClientSettingsUser($accid)
{
  global $rpl;

  $rpl['wc_settings_defines'] = WebClientPermissions();
  $webclient_settings = WebClientSettingsGetUser($accid);
  $webclient_super_settings = WebClientSettingsGetMemberGroups($accid);

  if($webclient_settings === false && $webclient_super_settings === false)
  {
    $webclient_settings = WC_NOTES | WC_NOTES2 | WC_CATEGORIES;
  }

  $rpl['wc_own_settings'] = $webclient_settings === false ? "null" : $webclient_settings;
  $rpl['wc_inherited_settings'] = $webclient_super_settings === false ? "null" : $webclient_super_settings;
  $rpl['wc_is_user_page'] = "true";
  $template_content = file_get_contents('../apresa/templ/webclient_settings.htm');
  $template_content = do_replace_tags($template_content);

  return $template_content;
}

?>