<?php

require_once('general.php');

HandlePage($dbintf);

function HandlePage($dbintf)
{
  global $rpl,$configs,$msg,$lng,$rooturl;

  if (($dbintf->actuinfo['permissions']&PM_CONFIG)==0)
  {
    echo 'Permission denied';
    exit;
  }
 
	if (!defined('DEMO') && COM_TYPE!='Win')
	{
		//echo $_POST['act']; exit;
		if (isset($_POST['act']))
		{
			if ($_POST['act']=='ALE')
			{
				$newConfigs = array();
				$ALE = ($_POST['enabled']==1);
				$newConfigs['ALE'] = $ALE?"1":"0";
				$dbintf->SetConfigsPart($newConfigs,'o');
				// also store like this,
				// to make easily available
				$newConfigs = array();
				$newConfigs['ALEweb'] = $ALE?"1":"0";
				$dbintf->SetConfigsPart($newConfigs,'web');
				
				$newkey = false;
				if ($ALE)
				{
					LogAction('Enable call content encryption');
					// if there is no key, then generate a new one
					// if key in database (configs), then don't do it
					if (file_exists('/var/apresa/data/rec.ekey')==false
					&& $dbintf->GetConfigValue('PlayPkey')=='')
					{
						if (msg_signal_service($msg,'crypt start'))
						{
							$newkey = true;
						}
					}

					// pwd should always be set when new key is generated
					// but might also be set at another time
					// when the password is changed.
					if (isset($_POST['pwd']))
					{
						LogAction('Set call content encryption pass phrase');
						$passPhrase = encrypt($_POST['pwd']);
						file_put_contents('/dev/shm/apresa/web/tmp_pwd',$passPhrase);
						$oldPlay = $dbintf->GetConfigValue('PlayPkey');
						if (msg_signal_service($msg,'crypt prep'))
						{
							$newPlay = $dbintf->GetConfigValue('PlayPkey');
							if ($newPlay=='')
							{
								$msg[] = new Msg(MSG_ERR,'Error: Empty');
							} else if ($newPlay==$oldPlay)
							{
								$msg[] = new Msg(MSG_ERR,'Error: Nothing changed.');
							} else
							{
								$msg[] = new Msg(MSG_INF,'<%Main.OK%>');
							}
						} else
						{
							$msg[] = new Msg(MSG_ERR,'Failed to apply pass phrase');
						}
						DeleteFn('/dev/shm/apresa/web/tmp_pwd');
					}
					
				} else
				{
					LogAction('Disable call content encryption');
				}
				
        EnginesReconfig($msg,$dbintf);
				
				if ( int_ensure_defined($newConfigs['ALEweb']  )
					!= int_ensure_defined($configs['ALEweb']     )
				)
				{
					$msg[] = new Msg(MSG_INF,'Restart the recording component, to let changes take effect.');
				}
			
				// redirect
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'websecure.php');
				exit;
			}
			if ($_POST['act']=='playlock')
			{
				// delete global playback key
				unlink('/dev/shm/apresa/play.ekey');
				// delete ALE session playback key if present
				if (isset($_SESSION['PlayKeyId']))
				{
					$playKeyFn = '/dev/shm/apresa/web/play_'.$_SESSION['PlayKeyId'].'.ekey';
					DeleteFn($playKeyFn);
					$dbintf->RemoveTmpFile($playKeyFn);
				}
				// redirect
				$_SESSION['msg'] = $msg;
				header('Location: '.$rooturl.'websecure.php');
				exit;
			}
		}
		
	}

	$ALE = $dbintf->GetConfigValue('ALE')==1;
	$cryptPlayGlobal = file_exists('/dev/shm/apresa/play.ekey');
	$cryptPlay = file_exists('/dev/shm/apresa/play.ekey')
	|| (isset($_SESSION['PlayKeyId'])
	    && file_exists('/dev/shm/apresa/web/play_'.$_SESSION['PlayKeyId'].'.ekey') );
	

	if (int_ensure_defined($configs['ALEweb'])
	&& $dbintf->GetConfigValue('PlayPkey')!=''
	&& file_exists('/var/apresa/data/rec.ekey')==false)
	{
		$msgtext = '<%Crypt.RecLocked%>';
		$msgtext .= ' <a href="cryptunlock.php?rec"><%Crypt.RecUnlock%></a>';
		$msg[] = new Msg(MSG_WRN,$msgtext);
	}
	
	$hasKey = false;
	if ($dbintf->GetConfigValue('PlayPkey')!=''
	&& $dbintf->GetConfigValue('RecPkey')!='')
	{
		$hasKey = true;
	}
	
	LogAction("Viewed Web Secure.",array("level"=>"view"));
	
	$data = '';
	$data .= 'var ALE = ' . ($ALE?"1":"0") . ";\r\n";
	$data .= 'var cryptPlay = ' . ($cryptPlay?"1":"0") . ";\r\n";
	$data .= 'var cryptPlayGlobal = ' . ($cryptPlayGlobal?"1":"0") . ";\r\n";
	$data .= 'var hasKey = ' . ($hasKey?"1":"0") . ";\r\n";

  // ready with database
  $dbintf->close();

  $data .= GeneralJSData();

  $template_content = file_get_contents('../apresa/templ/websecure.htm');

  // template replacements:
  $rpl['msg'] = message($msg);
  $rpl['nav'] = '';
  $rpl['MAINFORM'] = '<form id="mainform" method="POST"></form>';
  $rpl['FOOTER'] = '';
  $rpl['data'] = $data;
  $rpl['JSGEN'] = file_get_contents('../apresa/templ/general.js');
  $rpl['header'] = GetHeader();
  $template_content = do_replace_tags($template_content);
  echo $template_content;
}



?>
